<?php
/* --------------------------------------------------------------
  gm_trusted_shop_id.php 2014-04-07 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2013 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------


  based on:
  (c) 2000-2001 The Exchange Project
  (c) 2002-2003 osCommerce coding standards (a typical file) www.oscommerce.com
  (c) 2003      nextcommerce (start.php,1.5 2004/03/17); www.nextcommerce.org
  (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: start.php 1235 2005-09-21 19:11:43Z mz $)

  Released under the GNU General Public License
  -------------------------------------------------------------- */

require('includes/application_top.php');

$service = new GMTSService();
$certs = $service->retrieveCertificates();

if(!empty($certs)) {
	mysql_query('
		UPDATE content_manager
		SET content_status = "1"
		WHERE content_group = "15"
	');
}

if(!empty($_POST)) {
	if(isset($_POST['del_id']) && $_SESSION['coo_page_token']->is_valid($_POST['page_token'])) {
		$service->deleteCertificate($_POST['del_id']);
		$_SESSION['ts_flash'] = 'Zertifikat gelöscht';
	}

	if(isset($_POST['cred_id']) && $_SESSION['coo_page_token']->is_valid($_POST['page_token'])) {
		$service->changeCredentials($_POST['cred_id'], $_POST['user'], $_POST['password']);
		$_SESSION['ts_flash'] = 'Zugangsdaten gespeichert';
	}

	if(isset($_POST['check_all_certs']) && $_SESSION['coo_page_token']->is_valid($_POST['page_token'])) {
		$service->checkAllCertificates();
		$service->reloadProtectionItems();
		$_SESSION['ts_flash'] = 'Zertifikate geprüft';
	}

	if(isset($_POST['application_number']) && $_SESSION['coo_page_token']->is_valid($_POST['page_token'])) {
		$state = $service->getRequestState($_POST['application_number']);
		if($state === false) {
			$_SESSION['ts_flash'] = 'Statusabruf fehlgeschlagen';
		}
		else if($state < 0) {
			$_SESSION['ts_flash'] = $service->errorText($state);
		}
		else {
			$_SESSION['ts_flash'] = 'Status abgerufen.';
		}
	}

	if(isset($_POST['save_rating_cfg']) && $_SESSION['coo_page_token']->is_valid($_POST['page_token'])) {
		gm_set_conf('GM_TS_RATING_ENABLED', isset($_POST['activate_rating']) ? '1' : '0');
		gm_set_conf('GM_TS_RATING_COSUCCESS', isset($_POST['rating_cosuccess']) ? '1' : '0');
		gm_set_conf('GM_TS_RATING_EMAIL', isset($_POST['rating_email']) ? '1' : '0');
	}

	if(isset($_POST['save_badge_cfg']) && $_SESSION['coo_page_token']->is_valid($_POST['page_token'])) {
		gm_set_conf('GM_TS_BADGE_ENABLED', isset($_POST['badge_enabled']) ? '1' : '0');
		gm_set_conf('GM_TS_BADGE_YOFFSET', (int)$_POST['badge_yoffset']);
		gm_set_conf('GM_TS_BADGE_VARIANT', in_array($_POST['badge_variant'], array('default', 'text', 'small', 'reviews')) ? $_POST['badge_variant'] : 'default');
	}
	
	if(isset($_POST['seal_cfg']) && $_SESSION['coo_page_token']->is_valid($_POST['page_token'])) {
		gm_set_conf('GM_TS_SEAL_ENABLED', isset($_POST['enable_seal']) ? '1' : '0');
		gm_set_conf('GM_TS_RICHSNIPPETS_ENABLED', isset($_POST['enable_richsnippets']) ? '1' : '0');
		gm_set_conf('GM_TS_VIDEOBOX_ENABLED', isset($_POST['enable_videobox']) ? '1' : '0');

		if(isset($_POST['enable_videobox'])) {
			// make sure video box is enabled
			$boxes_id = false;
			$boxes_id_result = xtc_db_query("SELECT boxes_id FROM gm_boxes WHERE box_name = 'gm_trusted_shops_video' AND template_name = 'EyeCandy'");
			while($boxes_id_row = xtc_db_fetch_array($boxes_id_result)) {
				$boxes_id = $boxes_id_row['boxes_id'];
			}
			if($boxes_id == false) {
				// get position of widget box
				$widget_box_result = xtc_db_query("SELECT * FROM gm_boxes WHERE box_name = 'gm_trusted_shops_widget' AND template_name = 'EyeCandy'");
				$widget_box_pos = false;
				while($widget_box_row = xtc_db_fetch_array($widget_box_result)) {
					$widget_box_pos = str_replace('gm_box_pos_', '', $widget_box_row['position']);
				}
				// insert new entry for video box
				xtc_db_query("INSERT INTO gm_boxes SET template_name = 'EyeCandy', box_name = 'gm_trusted_shops_video', position = 'gm_box_pos_".($widget_box_pos+1)."', box_status = 1");
				$boxes_id = xtc_db_insert_id();
			}
			// make sure video box is active
			xtc_db_query("UPDATE gm_boxes SET box_status = 1 WHERE box_name = 'gm_trusted_shops_video'");
		}
	}

	xtc_redirect(HTTP_SERVER.DIR_WS_ADMIN.basename(__FILE__));
}

$app_query = xtc_db_query("SELECT tsp.*, orders.customers_name, orders.date_purchased FROM ts_protection tsp, orders
		WHERE tsp.orders_id = orders.orders_id
		AND orders.date_purchased > DATE_SUB(NOW(), INTERVAL 31 DAY)
		ORDER BY orders.date_purchased DESC");
$applications = array();
while($app_row = xtc_db_fetch_array($app_query)) {
	$applications[] = $app_row;
}

$seal_enabled = gm_get_conf('GM_TS_SEAL_ENABLED') == 1;
$richsnippets_enabled = gm_get_conf('GM_TS_RICHSNIPPETS_ENABLED') == 1;
$videobox_enabled = gm_get_conf('GM_TS_VIDEOBOX_ENABLED') == 1;
$rating_enabled = gm_get_conf('GM_TS_RATING_ENABLED') == 1;
$rating_cosuccess = gm_get_conf('GM_TS_RATING_COSUCCESS') == 1;
$rating_email = gm_get_conf('GM_TS_RATING_EMAIL') == 1;
$badge_enabled = gm_get_conf('GM_TS_BADGE_ENABLED') == 1;
$badge_yoffset = (int)gm_get_conf('GM_TS_BADGE_YOFFSET');
$badge_variant = gm_get_conf('GM_TS_BADGE_VARIANT');
if(empty($badge_variant)) {
	$badge_variant = 'default';
}

if(isset($_SESSION['ts_flash'])) {
	$flash = $_SESSION['ts_flash'];
	unset($_SESSION['ts_flash']);
}
else {
	$flash = '';
}

$cronjob_url = HTTP_SERVER.DIR_WS_CATALOG.'trusted_shops_cron.php?key='.$service->getKey();

ob_start();
?>
<!doctype html>
<html <?php echo HTML_PARAMS; ?>>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $_SESSION['language_charset']; ?>">
		<title><?php echo TITLE; ?></title>
		<link rel="stylesheet" type="text/css" href="<?php echo DIR_WS_ADMIN; ?>includes/stylesheet.css">
		<style type="text/css">
			input[type="checkbox"] { vertical-align: middle; }
			.padded { padding: 1ex 1em; }
			form.padded { display: block; }
			.warning { color: #CC0000; font-weight: bold; }
			.tsmain {
				background: #f7f7f7;
				border: 1px solid #CCCCCC;
				font: 0.8em sans-serif;
				padding: 1ex;
			}

			.tsinfo .showhidecontent {
				margin-bottom: 1em;
			}

			.showhide {
				float: right;
				border: 1px solid #BBBBBB;
				background: #FFFF99;
				padding: .5ex;
				border-radius: .3ex;
				cursor: pointer;
			}

			.subHeading {
				background-color: #585858;
				padding: .3ex 0.5ex;
				margin: .5ex 0;
				color: #ffffff;
				font-size: 1.1em;
				font-weight: bold;
			}

			#message {
				color: red;
				font-weight: bold;
			}

			p.flash {
				border: 1px solid #CC0000;
				background: #fffacd;
				padding: 1ex 1em;
				font-weight: bold;
			}

			input.invalid {
				border-color: #CC0000;
			}

			.add_ts_id {
				background: #dddddd;
				margin: auto;
				padding: 1ex 1em;
				width: 80%;
				text-align: center;
			}

			table.tsids,
			table.applications {
				margin: 1em auto;
				width: 90%;
			}

			table.tsids thead,
			table.applications thead {
				background: #888888;
				color: #ffffff;
			}

			table.tsids th,
			table.tsids td,
			table.applications th,
			table.applications td {
				padding: .3ex .5ex;
			}

			table.tsids tbody,
			table.applications tbody {
				background: #dddddd;
			}

			.creds label {
				display: inline-block;
				width: 8em;
				margin-left: 2em;
			}

			.tsbadge label { display: inline-block; width: 15em; }
		</style>
		<script type="text/javascript" src="gm/javascript/LoadUrl.js"></script>
	</head>
	<body topmargin="0" leftmargin="0" bgcolor="#FFFFFF">

		<?php require(DIR_WS_INCLUDES . 'header.php'); ?>

		<script language="JavaScript" type="text/javascript">
		$(document).ready(function(){
			var coo_load_url = new LoadUrl();
			coo_load_url.load_url('load_content');
		});
		</script>

		<table border="0" width="100%" cellspacing="2" cellpadding="2">
			<tr>
				<td class="columnLeft2" width="<?php echo BOX_WIDTH; ?>" valign="top">
					<?php require(DIR_WS_INCLUDES . 'column_left.php'); ?>
				</td>
				<td class="boxCenter" width="100%" valign="top">
					<div class="pageHeading" style="background-image:url(images/gm_icons/gambio.png)">##HEADING_TITLE</div>

					<div class="tsmain">
						<div class="tsinfo">
							<div class="showhide">##SHOWHIDEINFO</div>
							<div class="showhidecontent">
								<div class="subHeading">##HEADING_INFO</div>

								<!-- Trusted Shops Info -->
								<div id="url_loader">
									<img id="loading" src="../images/loading.gif" />
									##TEXT_CONTENT_LOADING
								</div>
								<div class="load_url">http://news.gambio.de/trustedshops/trusted_shops_info.php?language=<?php echo $_SESSION['language_code']; ?></div>
								<!-- END Trusted Shops Info -->

							</div>
						</div>
						<div class="tscfg">
							<div class="subHeading">##HEADING_CONFIGURATION</div>
							<?php if(!empty($flash)): ?>
							<p class="flash">
								<?php echo $flash ?>
							</p>
							<?php endif ?>
							<div class="add_ts_id">
								<form action="" method="post" class="pseudoform">
									<label for="new_id">##ADD_TS_ID</label>
									<input type="text" name="new_id" id="new_id" size="40" maxlength="33">
									<input type="submit" value="##CHECK_ADD" id="add_id">
									<span id="message"></span>
								</form>
							</div>

							<?php if(empty($certs)): ?>
							<p><em>##NO_TS_YET</em></p>
							<?php else: ?>
							<table class="tsids">
								<thead>
									<tr>
										<th>##TH_TS_ID</th>
										<th>##TH_TYPE</th>
										<th>##TH_URL</th>
										<th>##TH_LANGUAGE</th>
										<th>##TH_STATE</th>
										<th>##TH_FOR_RATING</th>
										<th>&nbsp;</th>
									</tr>
								</thead>
								<tbody>
									<?php foreach($certs as $cert): ?>
									<tr>
										<td><?php echo $cert['tsid'] ?></td>
										<td><?php echo $cert['type'] ?></td>
										<td><?php echo $cert['url'] ?></td>
										<td><?php echo $cert['language'] ?></td>
										<td><?php echo $cert['state'] ?></td>
										<td><?php echo $cert['rating_ok'] == true ? YES : NO ?></td>
										<td>
											<form action="" method="POST">
												<input type="hidden" name="del_id" value="<?php echo $cert['tsid'] ?>">
												<input type="submit" value="##TS_DELETE">
												<?php  echo xtc_draw_hidden_field('page_token', $_SESSION['coo_page_token']->generate_token()); ?>
											</form>
										</td>
									</tr>
									<?php if($cert['type'] == 'EXCELLENCE'): ?>
									<tr>
										<td colspan="7">
											<form action="" method="POST" class="creds">
												<input type="hidden" name="cred_id" value="<?php echo $cert['tsid'] ?>">
												<label for="user_<?php echo $cert['tsid'] ?>">##TS_USERNAME</label>
												<input type="text" name="user" value="<?php echo $cert['user'] ?>" id="user_<?php echo $cert['tsid'] ?>" size="25" maxlength="200">
												<?php if($cert['login_ok'] != true): ?>
												<span class="warning">##TS_LOGIN_INVALID</span>
												<?php endif ?>
												<br>
												<label for="password_<?php echo $cert['tsid'] ?>">##TS_PASSWORD</label>
												<input type="text" name="password" value="<?php echo $cert['password'] ?>" id="password_<?php echo $cert['tsid'] ?>" size="25" maxlength="200">
												<input type="submit" value="##TS_CHECKSAVE">
												<?php  echo xtc_draw_hidden_field('page_token', $_SESSION['coo_page_token']->generate_token()); ?>
											</form>
										</td>
									</tr>
									<?php endif ?>
									<?php endforeach ?>
								</tbody>
							</table>
							<form action="" method="post" class="padded">
								<input type="hidden" name="check_all_certs" value="1">
								<input type="submit" value="##TS_CHECKALLIDS">
								<?php  echo xtc_draw_hidden_field('page_token', $_SESSION['coo_page_token']->generate_token()); ?>
							</form>

							<p>
								##TS_CRONJOB_URL<a href="<?php echo $cronjob_url ?>"><?php echo $cronjob_url ?></a>
							</p>
							<?php endif // empty($certs) ?>
						</div>

						<?php if(!empty($applications)): ?>
						<div class="tscfg">
							<div class="subHeading">##TS_BP_APPLICATIONS</div>
							<table class="applications">
								<thead>
									<tr>
										<th>##TH_ORDER</th>
										<th>##TH_DATE</th>
										<th>##TH_CUSTOMER</th>
										<th>##TH_APPNO</th>
										<th>##TH_GUARANTEENO</th>
									</tr>
								</thead>
								<tbody>
									<?php foreach($applications as $app): ?>
									<tr>
										<td><?php echo $app['orders_id'] ?></td>
										<td><?php echo $app['date_purchased'] ?></td>
										<td><?php echo $app['customers_name'] ?></td>
										<td><?php echo $app['application_number'] ?></td>
										<td>
											<?php if($app['result'] == '' || $app['result'] == '0'): ?>
											<?php if($app['result'] == '0'): ?>
											##TS_PROCESSING
											<?php endif ?>
											<form action="" method="post">
												<input type="hidden" name="application_number" value="<?php echo $app['application_number'] ?>">
												<input type="submit" value="##TS_CHECKUPDATE">
												<?php  echo xtc_draw_hidden_field('page_token', $_SESSION['coo_page_token']->generate_token()); ?>
											</form>
											<?php else: ?>
											<?php echo $app['result'] ?>
											<?php endif ?>
										</td>
									</tr>
									<?php endforeach ?>
								</tbody>
							</table>
						</div>
						<?php endif; // !empty($applications) ?>

						<div class="tscfg tsintegration">
							<div class="subHeading">##TS_HEADING_INTEGRATION</div>
							<form action="" method="post" class="padded">
								<input type="hidden" name="seal_cfg" value="1">
								<input type="checkbox" name="enable_seal" value="1" id="enable_seal" <?php echo $seal_enabled ? 'checked="checked"' : '' ?>>
								<label for="enable_seal">##TS_ENABLE_SEAL</label>
								<br>
								<input type="checkbox" name="enable_videobox" value="1" id="enable_videobox" <?php echo $videobox_enabled ? 'checked="checked"' : '' ?>>
								<label for="enable_videobox">##TS_ENABLE_VIDEOBOX</label>
								<br>
								<input type="checkbox" name="enable_richsnippets" value="1" id="enable_richsnippets" <?php echo $richsnippets_enabled ? 'checked="checked"' : '' ?>>
								<label for="enable_richsnippets">##TS_ENABLE_RICH_SNIPPETS</label>
								<input type="submit" value="##TS_SAVE" class="button">
								<?php  echo xtc_draw_hidden_field('page_token', $_SESSION['coo_page_token']->generate_token()); ?>
							</form>
						</div>

						<div class="tscfg tsbadge">
							<div class="subHeading">##TS_HEADING_TRUSTBADGE</div>
							<form action="" method="post" class="padded">
								<input type="hidden" name="save_badge_cfg" value="1">
								<label for="activate_badge">##TS_ENABLE_BADGE</label>
								<input type="checkbox" id="activate_badge" name="badge_enabled" value="1" <?php echo $badge_enabled ? 'checked="checked"' : ''?>>
								<label for="activate_badge">##TS_YES_ACTIVATE</label>
								<br>
								<label for="badge_yoffset">##TS_BADGE_YOFFSET</label>
								<input type="text" size="4" maxlength="4" name="badge_yoffset" value="<?php echo $badge_yoffset ?>">px
								<br>
								<label for="badge_variant">##TS_BADGE_VARIANT</label>
								<select id="badge_variant" name="badge_variant">
									<option value="default" <?php echo $badge_variant == 'default' ? 'selected="selected"' : '' ?>>##TS_BADGE_VARIANT_DEFAULT</option>
									<option value="text" <?php echo $badge_variant == 'text' ? 'selected="selected"' : '' ?>>##TS_BADGE_VARIANT_TEXT</option>
									<option value="small" <?php echo $badge_variant == 'small' ? 'selected="selected"' : '' ?>>##TS_BADGE_VARIANT_SMALL</option>
									<option value="reviews" <?php echo $badge_variant == 'reviews' ? 'selected="selected"' : '' ?>>##TS_BADGE_VARIANT_REVIEWS</option>
								</select>
								<br>
								<input class="button" type="submit" value="##TS_SAVE">
								<?php  echo xtc_draw_hidden_field('page_token', $_SESSION['coo_page_token']->generate_token()); ?>
							</form>
						</div>


						<div class="tscfg">
							<div class="subHeading">##TS_HEADING_RATING</div>
							<form action="" method="post" class="padded">
								<input type="hidden" name="save_rating_cfg" value="1">
								<input type="checkbox" id="activate_rating" name="activate_rating" value="1" <?php echo $rating_enabled ? 'checked="checked"' : ''?>>
								<label for="activate_rating">##TS_ENABLE_MODULE</label>
								<br>
								<input type="checkbox" id="rating_cosuccess" name="rating_cosuccess" value="1" <?php echo $rating_cosuccess ? 'checked="checked"' : ''?>>
								<label for="rating_cosuccess">##TS_SHOW_RATING_COSUCCESS</label>
								<br>
								<input type="checkbox" id="rating_email" name="rating_email" value="1" <?php echo $rating_email ? 'checked="checked"' : ''?>>
								<label for="rating_email">##TS_SHOW_RATING_EMAIL</label>
								<br>
								<input class="button" type="submit" value="##TS_SAVE">
								<?php  echo xtc_draw_hidden_field('page_token', $_SESSION['coo_page_token']->generate_token()); ?>
							</form>
						</div>
					</div>

				</td>
			</tr>
		</table>
		<script>
			$(function() {
				var error_txt = {
					'TS_INVALID_ID': '##TS_INVALID_ID',
					'TS_DOUBLE_ID': '##TS_DOUBLE_ID',
					'TS_LOGIN_INVALID': '##TS_LOGIN_INVALID'
				};
				$(".showhide").click(function(e) {
					var content = $(this).next(".showhidecontent");
					content.toggle('fast');
				});

				<?php if(!empty($certs)): ?>
				$(".tsinfo .showhidecontent").hide();
				<?php endif ?>

				$("form.pseudoform").submit(function(e) {
					return false;
				});

				$("#add_id").click(function(e) {
					var new_id = $("input[name=new_id]", $(this).closest("form")).val();
					var rpdata = {
						'new_id': new_id
					};
					$.ajax({
						type: "POST",
						url: "request_port.php?module=TrustedShopsAdmin&cmd=new_id",
						data: rpdata,
						dataType: 'json'
					}).done(function(result){
						if(result.error) {
							//$('#message').html(error_txt[result.error]);
							alert(error_txt[result.error]);
						}
						if(result.reload == true) {
							location.reload();
						}
					});
				});

				$("form.creds").submit(function(e) {
					var the_form = $(this);
					var user_input = $('input[name="user"]', this);
					var password_input = $('input[name="password"]', this);
					var tsid = $('input[name="cred_id"]', this).val();
					var user = user_input.val();
					var password = password_input.val();
					var rpdata = {
						'tsid': tsid,
						'user': user,
						'password': password
					};
					var valid = false;
					$.ajax({
						type: "POST",
						url: "request_port.php?module=TrustedShopsAdmin&cmd=check_login",
						data: rpdata,
						dataType: 'json',
						async: false
					}).done(function(result) {
						console.log(result);
						if(result.valid == true) {
							valid = true;
						}
						else {
							alert(error_txt['TS_LOGIN_INVALID']);
							user_input.addClass('invalid');
							password_input.addClass('invalid');
							valid = false;
						}
					});
					return valid;
				});
			});
		</script>
		<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
	</body>
</html>
<?php
echo $service->replaceTextPlaceholders(ob_get_clean());
require(DIR_WS_INCLUDES . 'application_bottom.php');