<?php
/* --------------------------------------------------------------
   iloxx.php 2014-02-11_1452 mabr
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2012 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(ot_cod_fee.php,v 1.02 2003/02/24); www.oscommerce.com
   (C) 2001 - 2003 TheMedia, Dipl.-Ing Thomas Plänkers ; http://www.themedia.at & http://www.oscommerce.at
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: ot_cod_fee.php 1003 2005-07-10 18:58:52Z mz $)

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

require('includes/application_top.php');
defined('GM_HTTP_SERVER') or define('GM_HTTP_SERVER', HTTP_SERVER);
define('PAGE_URL', GM_HTTP_SERVER.DIR_WS_ADMIN.basename(__FILE__));

$messages_ns = 'messages_'.basename(__FILE__);
if(!isset($_SESSION[$messages_ns])) {
	$_SESSION[$messages_ns] = array();
}

$iloxx = new GMIloxx();

if($_SERVER['REQUEST_METHOD'] == "POST") {
	$_SESSION['coo_page_token']->is_valid($_POST['page_token']);
	switch($_POST['cmd']) {
		case 'save_cfg':
			$iloxx->userid = xtc_db_input($_POST['userid']);
			$iloxx->usertoken = xtc_db_input($_POST['usertoken']);
			$iloxx->oslabelacquired = xtc_db_input($_POST['os_label_acquired']);
			$iloxx->ostracking = xtc_db_input($_POST['os_tracking']);
			$iloxx->use_weight_options = xtc_db_input($_POST['use_weight_options']);
			$iloxx->default_ship_service = xtc_db_input($_POST['default_ship_service']);
			$iloxx->default_ship_service_cod = xtc_db_input($_POST['default_ship_service_cod']);
			$_SESSION[$messages_ns][] = $iloxx->get_text('configuration_saved');
			break;
		case 'get_transaction_list':
			$pdfdata = $iloxx->getDailyTransactionList($_POST['gdtl_date'], $_POST['gdtl_type']);
			if($pdfdata !== false) {
				header('Content-Type: application/pdf');
				header('Content-Disposition: attachment;filename=tagesabschluss_'.$_POST['gdtl_date'].'.pdf');
				echo $pdfdata;
			}
			break;
		default:
			die('What do you think you are doing, Dave?');
	}
	xtc_redirect(PAGE_URL);
}

$t_page_token = $_SESSION['coo_page_token']->generate_token();

$messages = $_SESSION[$messages_ns];
$_SESSION[$messages_ns] = array();

$orders_status = xtc_get_orders_status();

ob_start();
?>
<!DOCTYPE html>
<html <?php echo HTML_PARAMS; ?>>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $_SESSION['language_charset']; ?>">
		<title><?php echo TITLE; ?></title>
		<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
		<link rel="stylesheet" type="text/css" href="includes/stylesheet_iloxx.css">
	</head>
	<body>
		<!-- header //-->
		<?php require(DIR_WS_INCLUDES . 'header.php'); ?>
		<!-- header_eof //-->

		<!-- body //-->
		<table border="0" width="100%" cellspacing="2" cellpadding="2">
			<tr>
				<td class="columnLeft2" width="<?php echo BOX_WIDTH; ?>" valign="top">
					<!-- left_navigation //-->
					<?php require(DIR_WS_INCLUDES . 'column_left.php'); ?>
					<!-- left_navigation_eof //-->
				</td>

				<!-- body_text //-->

				<td class="boxCenter" width="100%" valign="top">
					<table border="0" width="100%" cellspacing="0" cellpadding="0" class="credits">
						<tr>
							<td>
								<table border="0" width="100%" cellspacing="0" cellpadding="0">
									<tr>
										<td class="pageHeading" style="padding-left: 0px">MyDPD Business / iloxx</td>
										<td width="80" rowspan="2">&nbsp;</td>
									</tr>
									<tr>
										<td class="main" valign="top">&nbsp;</td>
									</tr>
								</table>
							</td>
						</tr>
						<tr>
							<td class="main">
								<?php foreach($messages as $msg): ?>
									<p class="message"><?php echo $msg ?></p>
								<?php endforeach; ?>

								<form class="bluegray" action="<?php echo PAGE_URL ?>" method="post">
									<input type="hidden" name="page_token" value="<?php echo $t_page_token ?>">
									<input type="hidden" name="cmd" value="save_cfg">
									<fieldset class="">
										<legend>##configuration</legend>
										<dl class="adminform">
											<dt><label for="userid">##user_id</label></dt>
											<dd>
												<input id="userid" name="userid" type="text" value="<?php echo $iloxx->userid ?>">
											</dd>
											<dt><label for="usertoken">##user_token</label></dt>
											<dd>
												<input id="usertoken" name="usertoken" type="text" value="<?php echo $iloxx->usertoken ?>">
											</dd>
											<dt><label for="os_label_acquired">##os_label_acquired</label></dt>
											<dd>
												<select name="os_label_acquired" size="1">
													<?php foreach($orders_status as $os): ?>
													<option value="<?php echo $os['id'] ?>"<?php echo $os['id'] == $iloxx->oslabelacquired ? ' selected="selected"' : '' ?>>
														<?php echo $os['text'] ?>
													</option>
													<?php endforeach ?>
												</select>
											</dd>
											<dt><label for="os_tracking">##os_tracking</label></dt>
											<dd>
												<select name="os_tracking" size="1">
													<?php foreach($orders_status as $os): ?>
													<option value="<?php echo $os['id'] ?>"<?php echo $os['id'] == $iloxx->ostracking ? ' selected="selected"' : '' ?>>
														<?php echo $os['text'] ?>
													</option>
													<?php endforeach ?>
												</select>
											</dd>
											<dt>
												<label for="use_weight_options">##use_weight_options</label>
											</dt>
											<dd>
												<input name="use_weight_options" id="use_weight_options"
													value="1" type="checkbox" <?php echo ($iloxx->use_weight_options == true) ? 'checked="checked"' : '' ?>>
											</dd>
											<dt>
												<label for="default_ship_service">##default_ship_service</label>
											</dt>
											<dd>
												<select name="default_ship_service">
													<?php foreach($iloxx->getShipServices() as $key => $name): ?>
														<option value="<?php echo $key ?>" <?php echo $iloxx->default_ship_service == $key ? 'selected="selected"' : '' ?>><?php echo $name ?></option>
													<?php endforeach ?>
												</select>
											</dd>
											<dt>
												<label for="default_ship_service_cod">##default_ship_service_cod</label>
											</dt>
											<dd>
												<select name="default_ship_service_cod">
													<?php foreach($iloxx->getShipServices() as $key => $name): ?>
														<option value="<?php echo $key ?>" <?php echo $iloxx->default_ship_service_cod == $key ? 'selected="selected"' : '' ?>><?php echo $name ?></option>
													<?php endforeach ?>
												</select>
											</dd>
										</dl>
										<div class="buttons">
											<input type="submit" value="##save" class="button">
										</div>
									</fieldset>
								</form>

								<form class="bluegray" action="<?php echo PAGE_URL ?>" method="post">
									<input type="hidden" name="page_token" value="<?php echo $t_page_token ?>">
									<input type="hidden" name="cmd" value="get_transaction_list">
									<fieldset class="">
										<legend>##day_end_list</legend>
										<dl class="adminform">
											<dt><label for="gdtl_date">##date</label></dt>
											<dd>
												<input type="text" name="gdtl_date" value="<?php echo date('Y-m-d') ?>">
											</dd>
											<dt><label for="gdtl_type">##gdtl_type</label></dt>
											<dd>
												<select name="gdtl_type">
													<option value="DPD">DPD</option>
													<option value="Grosspaket">Gro&szlig;paket</option>
												</select>
											</dd>
										</dl>
										<div class="buttons">
											<input type="submit" value="##retrieve" class="button">
										</div>
									</fieldset>
								</form>

								<p class="partnerinfo">
									##partnerinfo <a class="plink" target="_new" href="http://www.iloxx.de/net/Kooperationen/gambio.aspx">##here</a>.
								</p>

							</td><!--  main  -->
						</tr>
					</table>
				</td>

				<!-- body_text_eof //-->

			</tr>
		</table>
		<!-- body_eof //-->

		<!-- footer //-->
		<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
		<!-- footer_eof //-->
	</body>
</html>
<?php
echo $iloxx->replaceTextPlaceholders(ob_get_clean());
require(DIR_WS_INCLUDES . 'application_bottom.php');
