<?php
/* --------------------------------------------------------------
	orders_paypallink.php 2.5_2014-08-11_1722 mabr
	Gambio GmbH
	http://www.gambio.de
	Copyright (c) 2014 Gambio GmbH
	Released under the GNU General Public License (Version 2)
	[http://www.gnu.org/licenses/gpl-2.0.html]
	--------------------------------------------------------------
*/

function getOrderTotal($orders_id) {
	$query = "SELECT value FROM orders_total WHERE orders_id = :orders_id AND class = 'ot_total'";
	$query = strtr($query, array(':orders_id' => (int)$orders_id));
	$total = 0.0;
	$result = xtc_db_query($query);
	while($row = xtc_db_fetch_array($result)) {
		$total = $row['value'];
	}
	return $total;
}

if(strtolower(gm_get_conf('PAYPAL_VALID_API')) != 'true' || strtolower(MODULE_PAYMENT_PAYPALNG_STATUS) != 'true')
{
	return;
}

ob_start();
defined('GM_HTTP_SERVER') or define('GM_HTTP_SERVER', HTTP_SERVER);
defined('PAGE_URL') or define('PAGE_URL', GM_HTTP_SERVER.DIR_WS_ADMIN.'orders.php?'.http_build_query($_GET));

if(isset($_SESSION['coo_page_token']))
{
	$t_pplink_page_token = $_SESSION['coo_page_token']->generate_token();
}
else
{
	$t_pplink_page_token = '';
}

$paypal = new GMPayPal();
$paypal_config = $paypal->getConfigArray();
if(!is_array($_SESSION['orders_paypallink_messages'])) {
	$_SESSION['orders_paypallink_messages'] = array();
}

if($_SERVER['REQUEST_METHOD'] == 'POST') {
	$action_taken = false;
	if(isset($_POST['make_pplink'])) {
		isset($_SESSION['coo_page_token']) && $_SESSION['coo_page_token']->is_valid($_POST['pplink_page_token']);
		$action_taken = true;
		$amount = (double)$_POST['amount'];
		$paycode = md5(uniqid());
		$orders_id = (int)$_POST['orders_id'];
		$paypal->setPaycode($orders_id, $paycode, $amount);
		if(isset($_POST['send_email'])) {
			$paylink = HTTP_SERVER.DIR_WS_CATALOG."paypal_payment.php?paycode=".$paycode;
			$smarty->assign('language', $_SESSION['language']);
			$smarty->caching = false;
			$smarty->template_dir = DIR_FS_CATALOG.'templates';
			$smarty->compile_dir = DIR_FS_CATALOG.'templates_c';
			$smarty->config_dir = DIR_FS_CATALOG.'lang';
			$smarty->assign('tpl_path', 'templates/'.CURRENT_TEMPLATE.'/');
			$smarty->assign('logo_path', HTTP_SERVER.DIR_WS_CATALOG.'templates/'.CURRENT_TEMPLATE.'/img/');
			$smarty->assign('NAME', $order->customer['name']);
			$smarty->assign('ORDER_NR', $orders_id);
			$smarty->assign('PAY_LINK', $paylink);

			if(defined('EMAIL_SIGNATURE')) {
				$smarty->assign('EMAIL_SIGNATURE_HTML', nl2br(EMAIL_SIGNATURE));
				$smarty->assign('EMAIL_SIGNATURE_TEXT', EMAIL_SIGNATURE);
			}
			
			$html_mail = fetch_email_template($smarty, 'send_paylink', 'html', 'admin/');
			$txt_mail = fetch_email_template($smarty, 'send_paylink', 'txt', 'admin/');
			$subject = $paypal->get_text('paylink_mail_subject').' '.$oID;

			xtc_php_mail(
				EMAIL_BILLING_ADDRESS, // From address
				EMAIL_BILLING_NAME,  // From name
				$order->customer['email_address'], // To address
				$order->customer['name'], // To name
				'', // forwarding to
				EMAIL_BILLING_REPLY_ADDRESS, // Reply-To address
				EMAIL_BILLING_REPLY_ADDRESS_NAME, // Reply-To name
				'', '', // path to attachment, more attachments
				$subject,
				$html_mail, $txt_mail);

		}
		$_SESSION['orders_paypallink_messages'][] = $paypal->get_text('paycode_generated');
	}
	if(isset($_POST['delete_pplink'])) {
		$action_taken = true;
		$paypal->deletePaycode((int)$_POST['orders_id']);
		$_SESSION['orders_paypallink_messages'][] = $paypal->get_text('paycode_deleted');
	}

	if($action_taken) {
		xtc_redirect(GM_HTTP_SERVER.$_SERVER['REQUEST_URI']);
	}
}

$paypallink_messages = $_SESSION['orders_paypallink_messages'];
$_SESSION['orders_paypallink_messages'] = array();


$pcdata = $paypal->getPaycode((int)$_GET['oID']);
if($pcdata !== false) {
	$paylink = HTTP_SERVER.DIR_WS_CATALOG."paypal_payment.php?paycode=".$pcdata['paycode'];
}


?>
<style>
p.message { margin: 1ex auto; border: 1px solid red; background: #ffa; padding: 1ex 1em; }
table.paylink input[type="checkbox"] { vertical-align: middle; }
input.paylink_url { width: 99%; }
</style>
<table border="0" width="100%" cellspacing="0" cellpadding="0" class="pdf_menu">
	<tr>
		<td width="120" class="dataTableHeadingContent" style="border-right: 0px;">
			##heading_paypal_link
		</td>
	</tr>
</table>
<table border="0" width="100%" cellspacing="0" cellpadding="2" class="gm_border dataTableRow paylink">
	<tr>
		<td width="80" class="main" valign="top">
			<?php if(!empty($paypallink_messages)): ?>
				<?php foreach($paypallink_messages as $msg): ?>
					<p class="message"><?php echo $msg ?></p>
				<?php endforeach ?>
			<?php endif ?>

			<?php if($pcdata == false): ?>
				##create_paylink:<br>
				<form action="<?php echo PAGE_URL ?>" method="POST">
					<input type="hidden" name="pplink_page_token" value="<?php echo $t_pplink_page_token ?>">
					<input type="hidden" name="orders_id" value="<?php echo (int)$_GET['oID'] ?>">
					##amount <input type="text" name="amount" value="<?php echo number_format(getOrderTotal((int)$_GET['oID']), 2, '.', '') ?>" size="7">
					<?php echo $order->info['currency'] ?>
					<br>
					<label for="send_paylink">##send_by_email</label>
					<input type="checkbox" id="send_paylink" name="send_email" value="1">
					<br>
					<input type="submit" name="make_pplink" value="##create_paylink_now" class="button">
				</form>
			<?php else: ?>
				##paylink (##amount <?php echo number_format($pcdata['amount'], 2, '.', '').' '.$order->info['currency'] ?>):
				<input type="text" readonly="readonly" value="<?php echo $paylink ?>" class="paylink_url">
				<!-- <a target="_blank" href="<?php echo $paylink?>"><?php echo $paylink?></a> -->
				<form action="<?php echo PAGE_URL ?>" method="POST">
					<input type="hidden" name="pplink_page_token" value="<?php echo $t_pplink_page_token ?>">
					<input type="hidden" name="orders_id" value="<?php echo (int)$_GET['oID'] ?>">
					<input type="submit" name="delete_pplink" value="##delete_paylink_now" class="button">
				</form>
			<?php endif ?>
			<pre><?php //print_r($order); ?></pre>
		</td>
	</tr>
</table>
<?php
echo $paypal->replaceLanguagePlaceholders(ob_get_clean());
