<?php
/* --------------------------------------------------------------
	orders_paypalng.php 2.5_2014-08-11_1722 mabr
	Gambio GmbH
	http://www.gambio.de
	Copyright (c) 2013 Gambio GmbH
	Released under the GNU General Public License (Version 2)
	[http://www.gnu.org/licenses/gpl-2.0.html]
	--------------------------------------------------------------
*/

if(strpos($order->info['payment_method'], 'paypalng') !== false || GMPayPal::orderHasTransactions((int)$_GET['oID'])) {
	if(isset($_SESSION['coo_page_token']))
	{
		$t_pp_page_token = $_SESSION['coo_page_token']->generate_token();
	}
	else
	{
		$t_pp_page_token = '';
	}
	require_once DIR_FS_CATALOG.'inc/htmlspecialchars_wrapper.inc.php';
	defined('PAGE_URL') or define('PAGE_URL', GM_HTTP_SERVER.DIR_WS_ADMIN.'orders.php?'.http_build_query($_GET));

	$paypal = new GMPayPal();

	$paypal_config = $paypal->getConfigArray();
	if(!is_array($_SESSION['orders_paypalng_messages'])) {
		$_SESSION['orders_paypalng_messages'] = array();
	}

	if($_SERVER['REQUEST_METHOD'] == 'POST') {
		isset($_SESSION['coo_page_token']) && $_SESSION['coo_page_token']->is_valid($_POST['pp_page_token']);
		$action_taken = false;
		if(isset($_POST['get_transaction_details'])) {
			$action_taken = true;
			$txn_id = $_POST['txn_id'];
			try {
				$ta_details = $paypal->getTransactionDetails($txn_id, true);
				//$_SESSION['orders_paypalng_messages'][] = '<pre>'.print_r($ta_details, true).'</pre>';
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('txn_details_updated');
			}
			catch(Exception $e) {
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('get_transaction_details_error') .': '. $e->getMessage();
			}
		}

		if(isset($_POST['capture_payment'])) {
			$action_taken = true;
			$txn_id = $_POST['txn_id'];
			$amount = $_POST['capture_amount'];
			$currency = $_POST['currency_code'];
			try {
				$paypal->capturePayment((int)$_GET['oID'], $txn_id, $amount, $currency);
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('payment_captured');
				$ta_details = $paypal->getTransactionDetails($txn_id, true);
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('txn_details_updated');
			}
			catch(Exception $e) {
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('capture_error') .': '. $e->getMessage();
			}
		}

		if(isset($_POST['authorize_payment'])) {
			$action_taken = true;
			$txn_id = $_POST['txn_id'];
			$amount = $_POST['capture_amount'];
			$currency = $_POST['currency_code'];
			try {
				$paypal->authorizePayment((int)$_GET['oID'], $txn_id, $amount, $currency);
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('payment_authorized');
				$ta_details = $paypal->getTransactionDetails($txn_id, true);
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('txn_details_updated');
			}
			catch(Exception $e) {
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('authorize_error') .': '. $e->getMessage();
			}
		}

		if(isset($_POST['void_authorization'])) {
			$action_taken = true;
			$txn_id = $_POST['txn_id'];
			try {
				$paypal->voidAuthorization($txn_id);
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('authorization_voided');	
				$ta_details = $paypal->getTransactionDetails($txn_id, true);
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('txn_details_updated');
			}
			catch(Exception $e) {
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('void_authorization_error') .': '. $e->getMessage();
			}
		}

		if(isset($_POST['reverse_transaction'])) {
			$action_taken = true;
			$txn_id = $_POST['txn_id'];
			try {
				$paypal->reverseTransaction($txn_id);
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('transaction_reversed');	
				$ta_details = $paypal->getTransactionDetails($txn_id, true);
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('txn_details_updated');
			}
			catch(Exception $e) {
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('reverse_transaction_error') .': '. $e->getMessage();
			}
		}

		if(isset($_POST['full_refund'])) {
			$action_taken = true;
			$orders_id = (int)$_POST['orders_id'];
			$txn_id = $_POST['txn_id'];
			$memo = $_POST['refund_memo'];
			try {
				$paypal->refund($orders_id, $txn_id, $memo);
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('refund_successful');	
				$ta_details = $paypal->getTransactionDetails($txn_id, true);
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('txn_details_updated');
			}
			catch(Exception $e) {
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('refund_error') .': '. $e->getMessage();
			}
		}

		if(isset($_POST['partial_refund'])) {
			$action_taken = true;
			$txn_id = $_POST['txn_id'];
			$orders_id = (int)$_POST['orders_id'];
			$memo = $_POST['refund_memo'];
			$amount = $_POST['refund_amount'];
			$currency_code = $_POST['currency_code'];
			try {
				$paypal->refund($orders_id, $txn_id, $memo, 'Partial', $amount, $currency_code);
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('refund_successful');	
				$ta_details = $paypal->getTransactionDetails($txn_id, true);
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('txn_details_updated');
			}
			catch(Exception $e) {
				$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('refund_error') .': '. $e->getMessage();
			}
		}

		if($action_taken) {
			xtc_redirect(GM_HTTP_SERVER.$_SERVER['REQUEST_URI']);
		}
	}

	$paypalng_messages = $_SESSION['orders_paypalng_messages'];
	$_SESSION['orders_paypalng_messages'] = array();

	try {
		$ecdetails = $paypal->getExpressCheckoutDetails((int)$_GET['oID']);
	}
	catch(GMPayPalNoDataException $e) {
		$ecdetails = false;
	}
	catch(GMPayPalTokenExpiredException $e)
	{
		$_SESSION['orders_paypalng_messages'][] = $paypal->get_text('error_token_expired');
		$ecdetails = false;
	}
	try
	{
		$pp_orderdata = $paypal->getOrderData((int)$_GET['oID']);
	}
	catch(GMPayPalNoDataException $e)
	{
		$pp_orderdata = false;
	}
	$transactions = $paypal->getTransactions((int)$_GET['oID']);
	$refunds = $paypal->getRefunds((int)$_GET['oID']);
	$num_auths = $paypal->getNumberOfAuthorizations((int)$_GET['oID']);
	$max_auths_exceeded = $num_auths >= $paypal_config['order_max_auth'];
	$num_captures = $paypal->getNumberOfCaptures((int)$_GET['oID']);
	$max_captures_exceeded = $num_captures >= $paypal_config['order_max_captures'];

	ob_start();
	?>
	<style>
	table.ecdetails { width: 99%; margin: auto; }
	table.ecdetails td { vertical-align: top; }
	table.ecdetails th { background: #ccc; }
	table.ecdetails dl { position: relative; overflow: auto; }
	table.ecdetails dt, table.ecdetails dd { float: left; margin: 0;}
	table.ecdetails dt { clear: left; width: 8em; margin-right: 1ex; }
	table.pporder { width: 99%; }
	table.pporder tr.subtotal td { border-top: 1px solid #888; }
	table.pporder tr.total td { border-top: 1px solid #222; }
	table.pptransactions { width: 99; margin: auto; }
	table.pptransactions th, table.pptransactions td { padding: .3ex .3ex; vertical-align: top; }
	table.pptransactions th { background: #ddd; }
	table.pptransactions td { background: #eee; }
	table.pptransactions tr.ipn_data > td { padding-left: 1.5em; }
	table.ipn { border: 1px solid #aaa; width: 99%;}
	p.intable_heading { background: #ccc; font-weight: bold; margin: 1px 0; }
	td.right { text-align: right; }
	div.rawdata pre { display: none; }
	div.rdbutton { background: #ddd; border-radius: 3px; padding: .2ex .5ex; display: inline-block; cursor: pointer; }
	.rdblock { display: none; }
	p.message { margin: 1ex auto; border: 1px solid red; background: #ffa; padding: 1ex 1em; }
	div.paypal_refund { float: left; background: #ccc; margin: 3px 2px; padding: 2px; width: 40%; }
	div.paypal_refund textarea { display: block; width: 99%; }
	div.slide_trigger { cursor: pointer; font-weight: bold; }
	div.slide_part { display: none; }
	input.amount { width: 5em; }
	div.paypal_refunds { margin: 3px 2px; padding: 2px; }
	div.paypal_refunds table.refunds_list th { background: #ddd; }
	div.paypal_refunds table.refunds_list td { background: #eee; }
	table.refunds_list { width: 100%; }
	</style>
	<table border="0" width="100%" cellspacing="0" cellpadding="0" class="pdf_menu">
		<tr>
			<td width="120" class="dataTableHeadingContent" style="border-right: 0px;">
				##heading_paypal
			</td>
		</tr>
	</table>
	<table border="0" width="100%" cellspacing="0" cellpadding="2" class="gm_border dataTableRow">
		<tr>
			<td width="80" class="main" valign="top">
				<?php if(!empty($paypalng_messages)): ?>
					<?php foreach($paypalng_messages as $msg): ?>
						<p class="message"><?php echo $msg ?></p>
					<?php endforeach ?>
				<?php endif ?>	
				<table class="ecdetails">
					<?php if($ecdetails !== false): ?>
						<tr>
							<th><strong>##basic_data</strong></th>
							<th><strong>##customer</strong></th>
							<th><strong>##delivery_address</strong></th>
							<th><strong>##order_cart</strong></th>
						</tr>
						<tr class="rdtrigger">
							<td>
								<dl>
									<?php if($pp_orderdata !== false): ?>
										<dt>Token</dt>
										<dd><?php echo $pp_orderdata['token'] ?></dd>
									<?php endif ?>
									<dt>##timestamp</dt>
									<dd>
										<?php echo $ts = $ecdetails['checkoutdetails']->Timestamp ?><br>
										(<?php echo date('Y-m-d H:i:s T', strtotime($ts)) ?>)
									</dd>
									<dt>CorrelationID</dt>
									<dd><?php echo $ecdetails['checkoutdetails']->CorrelationID ?></dd>
									<dt>Status (Ack)</dt>
									<dd><?php echo $ecdetails['checkoutdetails']->Ack ?></dd>
									<dt>Errors</dt>
									<dd>									
										<?php
										if(is_array($ecdetails['checkoutdetails']->Errors))
										{
										foreach($ecdetails['checkoutdetails']->Errors as $error)
										{
												echo $paypal->transcodeInbound((string)$error->ErrorCode .' - '. (string)$error->LongMessage) .'<br>';
											}
										}
										else
										{
											echo '##none';
										}
										?>
									</dd>
									<dt>CheckoutStatus</dt>
									<dd><?php echo $ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->CheckoutStatus ?></dd>
								</dl>
							</td>
							<td>
								<dl>
									<dt>E-Mail (PayPal)</dt>
									<dd><?php echo $ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->Payer ?></dd>
									<dt>PayerID</dt>
									<dd><?php echo $ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->PayerID ?></dd>
									<dt>PayerStatus</dt>
									<dd><?php echo $ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->PayerStatus ?></dd>
									<dt>##name</dt>
									<dd>
										<?php echo $paypal->transcodeInbound($ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->PayerName->FirstName .' '.
										$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->PayerName->MiddleName .' '.
										$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->PayerName->LastName .' '.
										$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->PayerName->Suffix);
										?>
									</dd>
									<dt>##country</dt>
									<dd><?php echo $ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->PayerCountry ?></dd>
									<dt>##address</dt>
									<dd>
										<?php echo $paypal->transcodeInbound($ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->Address->Name .'<br>'.
										$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->Address->Street1 .'<br>'.
										$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->Address->Street2 .'<br>'.
										$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->Address->PostalCode .' '.
										$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->Address->CityName .'<br>'.
										$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->Address->CountryName .'<br>'.
										'<em>'.$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->Address->AddressStatus .'</em><br>')
										?>
									</dd>
									<dt>##phone</dt>
									<dd><?php echo $ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PayerInfo->ContactPhone ?></dd>
										

								</dl>
							</td>
							<td>
								<?php echo $paypal->transcodeInbound($ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->ShipToAddress->Name .'<br>'.
								$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->ShipToAddress->Street1 .'<br>'.
								$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->ShipToAddress->Street2 .'<br>'.
								$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->ShipToAddress->PostalCode .' '.
								$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->ShipToAddress->CityName .'<br>'.
								$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->ShipToAddress->CountryName .'<br>'.
								'<em>'.$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->ShipToAddress->AddressStatus .'</em><br>')
								?>
							</td>
							<td>
								<?php
								$paymentdetailsitems = $ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->PaymentDetailsItem;
								if(!empty($paymentdetailsitems)):
									?>
									<table class="pporder">
										<tr><th>##quantity</th><th>##product_name</th><th>##product_price</th></tr>
										<?php foreach($paymentdetailsitems as $pdi): ?>
											<tr>
												<td><?php echo $pdi->Quantity ?></td>
												<td><?php echo $paypal->transcodeInbound($pdi->Name) ?></td>
												<td class="right"><?php echo $pdi->Amount->value .' '. $pdi->Amount->currencyID ?></td>
											</tr>
										<?php endforeach ?>
										<tr class="subtotal">
											<td>&nbsp;</td>
											<td>##subtotal</td>
											<td class="right"><?php echo $ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->ItemTotal->value .' '.
												$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->ItemTotal->currencyID ?></td>
										</tr>
										<tr>
											<td>&nbsp;</td>
											<td>##shipping_cost</td>
											<td class="right"><?php echo $ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->ShippingTotal->value .' '.
												$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->ShippingTotal->currencyID ?></td>
										</tr>
										<tr>
											<td>&nbsp;</td>
											<td>##handling_cost</td>
											<td class="right"><?php echo $ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->HandlingTotal->value .' '.
												$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->HandlingTotal->currencyID ?></td>
										</tr>
										<tr>
											<td>&nbsp;</td>
											<td>##taxes</td>
											<td class="right"><?php echo $ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->TaxTotal->value .' '.
												$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->TaxTotal->currencyID ?></td>
										</tr>
										<tr class="total">
											<td>&nbsp;</td>
											<td>##sum_total</td>
											<td class="right"><?php echo $ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->OrderTotal->value .' '.
												$ecdetails['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->OrderTotal->currencyID ?></td>
										</tr>
									</table>
								<?php else: ?>
									<p><em>##order_not_on_record</em></p>
								<?php endif ?>
							</td>
						</tr>
						<tr class="rdblock">
							<td colspan="4">
								<p class="intable_heading">##raw_data</p>
								<pre><?php echo htmlspecialchars_wrapper(print_r($ecdetails, true)) ?></pre>
							</td>
						</tr>
					<?php endif; // $ecdetails !== false ?>

					<?php if(!empty($transactions)): ?>
						<tr>
							<td colspan="4">
								<p class="intable_heading">##transactions</p>
								<table class="pptransactions">
									<tr>
										<th>##transaction_type</th>
										<th>##time</th>
										<th>##correlation_id</th>
										<th>##transaction_id</th>
										<th>##ack</th>
										<th>##type</th>
										<th>##time_of_payment</th>
										<th>##gross_amount</th>
										<th>##taxes</th>
										<th>##fees</th>
										<th>##settleamount</th>
										<th>##payment_status</th>
									</tr>
									<?php foreach($transactions as $ta): ?>
										<?php
											$pa_is_order = false;
											$pa_is_order = $ta['transaction'] == 'doexpresscheckoutpayment' ? strpos($ta['transaction_type'], 'Order') !== false : $pa_is_order;
										?>
										<tr class="rdtrigger">
											<td>##transaction_type_<?php echo $ta['transaction'] ?></td>
											<td><?php echo $ta['timestamp'] ?></td>
											<td><?php echo $ta['correlation_id'] ?></td>
											<td><?php echo $ta['transaction_id'] ?></td>
											<td><?php echo $ta['ack'] ?></td>
											<td><?php echo (!empty($ta['transaction_type']) ? $ta['transaction_type'].', '.$ta['payment_type'] : '') ?></td>
											<td><?php echo $ta['payment_date'] ?></td>
											<td><?php echo $ta['grossamount'] ?></td>
											<td><?php echo $ta['taxamount'] ?></td>
											<td><?php echo $ta['feeamount'] ?></td>
											<td><?php echo $ta['settleamount'] ?></td>
											<td><?php echo $ta['paymentstatus'] ?><?php echo (!empty($ta['pending_reason'])) ? ' ('.$ta['pending_reason'].')' : '' ?></td>
										</tr>
										<tr class="rdblock">
											<td colspan="12">
												<pre><?php echo htmlspecialchars_wrapper(print_r($ta, true)) ?></pre>
												<pre><?php echo htmlspecialchars_wrapper(print_r(unserialize($ta['raw_response']), true)) ?></pre>
											</td>
										</tr>
										<?php $ipns = $paypal->getNotificationsForTransaction($ta['transaction_id']); ?>
										<?php if(!empty($ipns)): ?>
										<tr class="ipn_data">
											<td colspan="12">
												<strong>##instant_payment_notifications</strong>
												<table class="ipn">
													<tr>
														<th>##time</th>
														<th>##gross_amount</th>
														<th>##type</th>
														<th>##payment_status</th>
													</tr>
													<?php foreach($ipns as $ipn): ?>
													<tr class="rdtrigger">
														<td><?php echo $ipn['received_time'] ?></td>
														<td><?php echo $ipn['mc_gross'] .' '. $ipn['mc_currency'] ?></td>
														<td><?php echo $ipn['txn_type'] .' '. $ipn['payment_type'] ?></td>
														<td><?php echo $ipn['payment_status'] . (empty($ipn['pending_reason']) ? '' : ' ('. $ipn['pending_reason'] .')') ?></td>
													</tr>
													<tr class="rdblock">
														<td>
															<pre><?php //echo htmlspecialchars_wrapper(print_r($ipn, true)) ?></pre>
															<pre><?php echo htmlspecialchars_wrapper(print_r(unserialize($ipn['ipn_raw']), true)) ?></pre>
														</td>
													</tr>
													<?php endforeach ?>
												</table>
											</td>
										</tr>
										<?php endif // !empty($ipns) ?>
										<tr class="paypal_ta_actions">
											<td colspan="12">
												<form action="<?php echo PAGE_URL ?>" method="POST">
													<input type="hidden" name="pp_page_token" value="<?php echo $t_pp_page_token ?>">
													<input type="hidden" name="txn_id" value="<?php echo $ta['transaction_id'] ?>">
													<input type="submit" value="##get_ta_details" name="get_transaction_details">
												</form>

												<?php // echo strtolower($ta['paymentstatus']) ?>
												<?php if(in_array(strtolower($ta['paymentstatus']), array('pending', 'in-progress'))): ?>
													<?php if(in_array(strtolower($ta['pending_reason']), array('authorization', 'order', 'other'/*, 'none'*/))): ?>
														<form action="<?php echo PAGE_URL ?>" method="POST">
															<input type="hidden" name="pp_page_token" value="<?php echo $t_pp_page_token ?>">
															<input type="hidden" name="txn_id" value="<?php echo $ta['transaction_id'] ?>">
															<?php list($grossamount_value, $grossamount_currency) = explode(' ', $ta['grossamount']) ?>
															<input type="hidden" name="currency_code" value="<?php echo $grossamount_currency // $order->info['currency'] ?>">
															<?php // <input type="hidden" name="capture_amount" value="<?php echo $grossamount_value ? >"> ?>
															<?php if(!$pa_is_order || !$max_captures_exceeded): ?>
																<input type="submit" value="##capture" name="capture_payment">
																<input type="text" class="amount" name="capture_amount" value="<?php echo $grossamount_value ?>"><?php echo $grossamount_currency ?>
															<?php endif ?>
															<input class="must_confirm" type="submit" value="##void_authorization" name="void_authorization">
														</form>
													<?php endif ?>
													<?php if($pa_is_order && !$max_auths_exceeded): ?>
														<form action="<?php echo PAGE_URL ?>" method="POST">
															<input type="hidden" name="pp_page_token" value="<?php echo $t_pp_page_token ?>">
															<input type="hidden" name="txn_id" value="<?php echo $ta['transaction_id'] ?>">
															<?php list($grossamount_value, $grossamount_currency) = explode(' ', $ta['grossamount']) ?>
															<input type="hidden" name="currency_code" value="<?php echo $grossamount_currency // $order->info['currency'] ?>">
															<?php // <input type="hidden" class="amount" name="capture_amount" value="<?php echo $grossamount_value ? >"> ?>
															<input type="submit" value="##authorize" name="authorize_payment">
															<input type="text" class="amount" name="capture_amount" value="<?php echo $grossamount_value ?>"><?php echo $grossamount_currency ?>
														</form>
													<?php endif ?>
												<?php endif; // pending|in-progress ?>

												<?php if(strtolower($ta['paymentstatus']) == 'completed'): ?>
													<form action="<?php echo PAGE_URL ?>" method="POST">
														<input type="hidden" name="pp_page_token" value="<?php echo $t_pp_page_token ?>">
														<input type="hidden" name="txn_id" value="<?php echo $ta['transaction_id'] ?>">
														<input class="must_confirm" type="submit" value="##reverse_transaction" name="reverse_transaction">
													</form>
												<?php endif ?>
												<br>
												<?php if(in_array(strtolower($ta['paymentstatus']), array('completed', 'partially-refunded'))): ?>
													<div class="paypal_refund">
														<div class="slide_trigger">##refund</div>
														<div class="slide_part">
															<form action="<?php echo PAGE_URL ?>" method="POST">
																<input type="hidden" name="pp_page_token" value="<?php echo $t_pp_page_token ?>">
																<?php list($grossamount_value, $grossamount_currency) = explode(' ', $ta['grossamount']) ?>
																<input type="hidden" name="txn_id" value="<?php echo $ta['transaction_id'] ?>">
																<input type="hidden" name="orders_id" value="<?php echo $_GET['oID'] ?>">
																<textarea class="refund_memo" name="refund_memo" placeholder="##refund_memo"></textarea>
																		<input class="must_confirm" type="submit" value="##full_refund" name="full_refund"><br>
																		<input class="must_confirm" type="submit" value="##partial_refund" name="partial_refund">
																<input type="text" name="refund_amount" size="6" value="<?php echo $grossamount_value ?>"><?php echo $grossamount_currency ?>
																<input type="hidden" name="currency_code" value="<?php echo $grossamount_currency // $order->info['currency'] ?>">
															</form>
														</div>
													</div>
												<?php endif; // completed|partially-refunded ?>

											</td>
										</tr>
									<?php endforeach // $transactions ?>
								</table>

							</td>
						</tr>
					<?php endif // !empty($transactions) ?>
					<?php if(!empty($refunds)): ?>
						<tr>
							<td colspan="4">
								<p class="intable_heading">##refunds</p>
								<div class="paypal_refunds">									
									<table class="refunds_list">
										<tr>
											<th>##time</th>
											<th>##refundtransactionid</th>
											<th>##refund_grossnet</th>
											<th>##totalrefunded</th>
											<th>##refundstatus</th>
										</tr>
										<?php foreach($refunds as $rf): ?>
										<tr>
											<td><?php echo $rf['timestamp'] ?></td>
											<td><?php echo $rf['refundtransactionid'] ?></td>
											<td><?php echo number_format($rf['grossrefundvalue'], 2, '.', '').' '.$rf['grossrefundcurrency'] ?> /
											<?php echo number_format($rf['netrefundvalue'], 2, '.', '').' '.$rf['netrefundcurrency'] ?></td>
											<td><?php echo number_format($rf['totalrefundedvalue'], 2, '.', '').' '.$rf['totalrefundedcurrency'] ?></td>
											<td><?php echo $rf['refundinfostatus'] . ($rf['refundinfopendingreason'] == 'none' ? '' : ' ('.$rf['refundinfopendingreason'].')') ?></td>
										<?php endforeach ?>
									</table>
								</div>
							</td>
						</tr>
					<?php endif ?>
				</table>

			</td>
		</tr>
	</table>
	<script>
	$(function() {
		$('.rdtrigger').dblclick(function(e) { $(this).next('.rdblock').toggle(); });

		$('body').delegate('.slide_trigger', 'click', function(e) {
			var slide_part = $('.slide_part', $(this).parent());
			slide_part.slideToggle();
		});

		$('body').delegate('.must_confirm', 'click', function(e) {
			var action_text = $(this).attr('value');
			var confirmed = confirm('##really_execute ' + action_text);
			if(!confirmed) {
				e.preventDefault();
			}
		});
	});
	</script>
	<?php
	$content = ob_get_clean();

	while(preg_match('/##(\w+)\b/', $content, $matches) == 1) {
		$replacement = $paypal->get_text($matches[1]);
		if(empty($replacement)) {
			$replacement = $matches[1];
		}
		$content = preg_replace('/##'.$matches[1].'/', $replacement.'$1', $content, 1);
	}
	echo $content;
}
