<?php
/* --------------------------------------------------------------
   paypal_logs.php 2.5_2014-08-11_1722 mabr
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2013 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

require_once 'includes/application_top.php';
define('PAGE_URL', HTTP_SERVER.DIR_WS_ADMIN.basename(__FILE__));

$messages_ns = 'messages_'.basename(__FILE__);
if(!isset($_SESSION[$messages_ns])) {
	$_SESSION[$messages_ns] = array();
}

if($_SERVER['REQUEST_METHOD'] == 'POST') {
	// do something
	$_SESSION[$messages_ns][] = 'done';

	xtc_redirect(PAGE_URL);
}

/* --------------- */

function getNumberOfIPNLogs() {
	$query = "SELECT COUNT(*) AS num_entries FROM paypal_ipn";
	$result = xtc_db_query($query);
	$row = xtc_db_fetch_array($result);
	$num_entries = $row['num_entries'];
	return $num_entries;
}

function getIPNLogs($entries_per_page, $page) {
	$page = max(1, $page);
	$offset = $entries_per_page * ($page - 1);
	$limit = $entries_per_page;
	$query = "SELECT * FROM paypal_ipn ORDER BY paypal_ipn_id DESC LIMIT $limit OFFSET $offset";
	$result = xtc_db_query($query);
	$ipns = array();
	while($row = xtc_db_fetch_array($result)) {
		$ipns[] = $row;
	}
	return $ipns;
}

function hsc($string) {
	if(function_exists('htmlspecialchars_wrapper')) {
		return htmlspecialchars_wrapper($string);
	}
	else {
		return htmlspecialchars($string);
	}
}

/* --------------- */


$entries_per_page = 25;
$total_entries = getNumberOfIPNLogs();
$total_pages = ceil($total_entries / $entries_per_page);
$page = isset($_GET['page']) ? (int)$_GET['page'] : $total_pages;

$ipn_logs = getIPNLogs($entries_per_page, $page);

$messages = $_SESSION[$messages_ns];
$_SESSION[$messages_ns] = array();

$paypal = new GMPayPal();
ob_start();
?>
<!doctype HTML>
<html <?php echo HTML_PARAMS; ?>>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $_SESSION['language_charset']; ?>">
		<title><?php echo TITLE; ?></title>
		<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
		<style>
			p.message {
				margin: .5ex auto;
				background: rgb(240, 230, 140);
				border: 1px solid rgb(255, 0, 0);
				padding: 1em;
			}

			dl.adminform {
				position: relative;
				overflow: auto;
			}

			dl.adminform dd, dl.adminform dt {
				float: left;
			}

			dl.adminform dt {
				clear: left;
				width: 15em;
			}

			input[type="submit"].btn_wide {
				width: auto;
			}

			table.ipn { width: 99%; vertical-align: top; }
			table.ipn th, table.ipn td { padding: .5ex; }
			table.ipn thead { background: #ddd; }
			table.ipn tbody { background: #eee; }
			table.ipn tbody tr:hover td { background: #eed; }
			.rdblock { display: none; }
		</style>
	</head>
	<body>
		<!-- header //-->
		<?php require DIR_WS_INCLUDES . 'header.php'; ?>
		<!-- header_eof //-->

		<!-- body //-->
		<table border="0" width="100%" cellspacing="2" cellpadding="2">
			<tr>
				<td class="columnLeft2" width="<?php echo BOX_WIDTH; ?>" valign="top">
					<table border="0" width="<?php echo BOX_WIDTH; ?>" cellspacing="1" cellpadding="1" class="columnLeft">

						<!-- left_navigation //-->
						<?php require(DIR_WS_INCLUDES . 'column_left.php'); ?>
						<!-- left_navigation_eof //-->

					</table>
				</td>

				<!-- body_text //-->

				<td class="boxCenter" width="100%" valign="top">
					<table border="0" width="100%" cellspacing="0" cellpadding="0" class="">
						<tr>
							<td>
								<table border="0" width="100%" cellspacing="0" cellpadding="0">
									<tr>
										<td class="pageHeading" style="padding-left: 0px">##PPTXT_LOGS_HEADING</td>
										<td width="80" rowspan="2">&nbsp;</td>
									</tr>
									<tr>
										<td class="main" valign="top">&nbsp;</td>
									</tr>
								</table>
							</td>
						</tr>
						<tr>
							<td class="main">
								<?php foreach($messages as $msg): ?>
								<p class="message"><?php echo $msg ?></p>
								<?php endforeach; ?>

								<h2>Instant Payment Notification</h2>

								<form action="<?php echo PAGE_URL ?>" method="GET">
									##page
									<select id="page_no" name="page" class="instant_submit">
										<?php for($p = $total_pages; $p >= 1; $p--): ?>
											<option value="<?php echo $p ?>" <?php echo ($p == $page) ? 'selected="selected"' : '' ?>>
												<?php echo $p ?>
											</option>
										<?php endfor ?>
									</select> / <?php echo $total_pages ?>
								</form>

								<table class="ipn">
									<thead>
										<tr>
											<th>&nbsp;<!-- paypal_ipn_id --></th>
											<th>##payment_date</th>
											<th>##txn_id</th>
											<th>##payment_type</th>
											<th>##payment_status</th>
											<th>##mc_gross</th>
											<th>##address</th>
										</tr>
									</thead>
									<tbody>
										<?php foreach($ipn_logs as $ipn): ?>
											<tr class="rdtrigger">
												<td><?php echo $ipn['paypal_ipn_id'] ?></td>
												<td><?php echo $ipn['payment_date'] .'<br>('. date('Y-m-d H:i:s T', strtotime($ipn['payment_date'])) .')' ?></td>
												<td><?php echo $ipn['txn_id'] ?></td>
												<td><?php echo $ipn['payment_type'] ?></td>
												<td><?php echo $ipn['payment_status'] ?></td>
												<td><?php echo $ipn['mc_gross'].' '.$ipn['mc_currency'] ?></td>
												<td><?php
													echo $ipn['address_name'] .'<br>'.
														$ipn['address_street'] .'<br>'.
														$ipn['address_zip'] .' '. $ipn['address_city'] .'<br>'.
														$ipn['address_country_code'] . (empty($ipn['address_state']) ? '' : ' ('.$ipn['address_state'] .')').'<br>'.
														$ipn['payer_email'].'<br>'.
														$ipn['payer_id'].', '.$ipn['payer_status'];
													?>
												</td>
											</tr>
											<tr class="rdblock">
												<td colspan="6">
													<pre><?php echo hsc(print_r(unserialize($ipn['ipn_raw']), true)) ?></pre>
												</td>
											</tr>
										<?php endforeach?>
									</tbody>
								</table>

							</td>
						</tr>
					</table>
				</td>

				<!-- body_text_eof //-->
				
			</tr>
		</table>
		<!-- body_eof //-->
		<script>
		$(function() {
			$('.rdtrigger').dblclick(function(e) { $(this).next('.rdblock').toggle(); });
			$('.instant_submit').change(function(e) { $(this).closest('form').submit(); });
		});
		</script>

		<!-- footer //-->
		<?php require DIR_WS_INCLUDES . 'footer.php'; ?>
		<!-- footer_eof //-->
	</body>
</html>
<?php
echo $paypal->replaceLanguagePlaceholders(ob_get_clean());;
require DIR_WS_INCLUDES . 'application_bottom.php';
