<?php
/* --------------------------------------------------------------
	checkout_paypal_prepare.php 2014-09-04 mabr
	Gambio GmbH
	http://www.gambio.de
	Copyright (c) 2013 Gambio GmbH
	Released under the GNU General Public License (Version 2)
	[http://www.gnu.org/licenses/gpl-2.0.html]
	--------------------------------------------------------------
*/

require 'includes/application_top.php';

$paypal = new GMPayPal();

header('Content-Type: text/plain');

if(isset($_GET['PayerID']) && isset($_GET['token'])) {
	$payer_id = $_GET['PayerID'];
	$token = $_GET['token'];
	$response = $paypal->getExpressCheckoutDetailsByToken($token);
	if($response === false) {
		xtc_db_close();
		die('paypal error');
	}

	$_SESSION['paypal_checkout_data'] = array(
		'payer_id' => $payer_id,
		'token' => $token,
		'gecd_response' => $response,
	);

	if(isset($_SESSION['customer_id']) == false || $_SESSION['customer_id'] == 0)
	{
		$pp_guest = new GMPayPalGuestAccountManager();
		$pp_guest->createAccount($response);
	}
	else {
		$paypal_shipping_address = $response->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->ShipToAddress;
		$address = array(
			'name' => $paypal->transcodeInbound((string)$paypal_shipping_address->Name),
			'street1' => $paypal->transcodeInbound((string)$paypal_shipping_address->Street1),
			'company' => $paypal->transcodeInbound((string)$paypal_shipping_address->Street2),
			'postalcode' => $paypal->transcodeInbound((string)$paypal_shipping_address->PostalCode),
			'cityname' => $paypal->transcodeInbound((string)$paypal_shipping_address->CityName),
			'stateorprovince' => $paypal->transcodeInbound((string)$paypal_shipping_address->StateOrProvince),
			'country' => $paypal->transcodeInbound((string)$paypal_shipping_address->Country),
		);
		$_SESSION['sendto'] = $paypal->findOrCreateAddressBookEntry($_SESSION['customer_id'], $address);
		$paypal_customer_address = $response->GetExpressCheckoutDetailsResponseDetails->PayerInfo->Address;
		$address = array(
			'name' => $paypal->transcodeInbound((string)$paypal_customer_address->Name),
			'street1' => $paypal->transcodeInbound((string)$paypal_customer_address->Street1),
			'company' => $paypal->transcodeInbound((string)$paypal_customer_address->Street2),
			'postalcode' => $paypal->transcodeInbound((string)$paypal_customer_address->PostalCode),
			'cityname' => $paypal->transcodeInbound((string)$paypal_customer_address->CityName),
			'stateorprovince' => $paypal->transcodeInbound((string)$paypal_customer_address->StateOrProvince),
			'country' => $paypal->transcodeInbound((string)$paypal_customer_address->Country),
		);
		$_SESSION['billto'] = $paypal->findOrCreateAddressBookEntry($_SESSION['customer_id'], $address);
	}
	$_SESSION['payment'] = 'paypalng';
	xtc_redirect(GM_HTTP_SERVER.DIR_WS_CATALOG.FILENAME_CHECKOUT_SHIPPING);
}

$token = $paypal->prepareExpressCheckout();
if($token === false) {
	# die('paypal: error');
	$_SESSION['ASYNC_MESSAGE'] = $paypal->get_text('paypal_temporarily_unavailable');
	xtc_redirect(GM_HTTP_SERVER.DIR_WS_CATALOG.FILENAME_DEFAULT.'?'.SID);
}
else {
	$redirect_url = $paypal->getRedirectURL('_express-checkout', $token);
	xtc_redirect($redirect_url);
}

echo $redirect_url;
