<?php
/* --------------------------------------------------------------
   main.js.php 2014-08-08 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

$t_language = 'german';
if(isset($_GET['language']) && file_exists('../lang/' . basename($_GET['language']) . '.inc.php')) $t_language = basename($_GET['language']);

require_once('../lang/' . $t_language . '.inc.php');

?>
function RequestHandler()
{
	var coo_this = this;
	var t_section_file_delete_info_array = {};

	this.send_ajax_request = function(p_url)
	{
		var t_url = p_url;

		if(t_url.search('\\?') == -1)
		{
			t_url += '?rand=' + (Math.round(Math.random() * 1000000));
		}
		else
		{
			t_url += '&rand=' + (Math.round(Math.random() * 1000000));
		}

		$.ajax(
		{	
			data:		$('#form_install').serialize(),
			url: 		t_url,
			type: 		'POST',
			async:		true,
			dataType:	'json',
			success:	function(p_response)
			{			
				if(p_response === null)
				{
					coo_this.show_error('<?php echo TEXT_ERROR_NO_RESPONSE; ?>', '', t_url);
					return;
				}
			
				if(p_response.login_succes != true)
				{
					window.location.href = 'index.php?content=login&language=<?php echo $t_language; ?>';
				}
				
				if(p_response.current_update != '')
				{
					$('#current_update').html(p_response.current_update);
				}
				
				$('#form_install').hide();
				$('#update_status').show();
				
				t_section_file_delete_info_array = coo_this.merge(t_section_file_delete_info_array, p_response.section_file_delete_info_array);
				$('#sql_errors').append(p_response.sql_errors);
				
				if(p_response.url.match(/(^|\s)((https?:\/\/)?[\w-]+(\.[\w-]+)+\.?(:\d+)?(\/\S*)?)/gi))
				{
					coo_this.send_ajax_request(p_response.url);
				}
				else
				{
					coo_this.finish(p_response.next_content);
				}
			},
			error:	function(p_jqXHR, p_exception_text)
			{
				if(p_exception_text == 'timeout')
				{
					coo_this.show_error('<?php echo TEXT_ERROR_TIMEOUT; ?>', '', t_url);
				}
				else if(p_jqXHR.status == 500)
				{
					coo_this.show_error('<?php echo TEXT_ERROR_500; ?>', '', t_url);
				}
				else if(p_exception_text == 'parsererror')
				{
					coo_this.show_error('<?php echo TEXT_ERROR_PARSERERROR; ?>', p_jqXHR.responseText, t_url);
				}		
				else
				{
					coo_this.show_error('<?php echo TEXT_ERROR_UNKNOWN; ?>', '', t_url);
				}
			}
		});
	}

	this.build_list = function()
	{
		var t_html_list = '';
			
		if(t_section_file_delete_info_array.length > 0)
		{
			t_html_list = '<ul>';		
	
			for(var t_language in t_section_file_delete_info_array)
			{
				t_html_list += '<li><?php echo TEXT_LANGUAGE; ?>: ' + t_language + '</li><ul>';
				for(t_section in t_section_file_delete_info_array[t_language])
				{
					t_html_list += '<li><?php echo TEXT_SECTION_NAME; ?>: ' + t_section + '</li><ul>';
					for(t_phrase_name in t_section_file_delete_info_array[t_language][t_section])
					{
						t_html_list += '<li><?php echo TEXT_PHRASE_NAME; ?>: ' + t_section_file_delete_info_array[t_language][t_section][t_phrase_name] + '</li>';
					}
					t_html_list += '</ul>';
				}
				t_html_list += '</ul>';
			}

			t_html_list += '</ul>';
		}
		
		return t_html_list;
	}
	
	this.merge = function(p_coo_object1, p_coo_object2)
	{
		var t_coo_merged_object = p_coo_object1;
		
		for(var t_key1 in p_coo_object2)
		{
			if(typeof(t_coo_merged_object[t_key1]) == 'undefined')
			{
				t_coo_merged_object[t_key1] = p_coo_object2[t_key1];
			}
			else
			{
				for(var t_key2 in p_coo_object2[t_key1])
				{
					if(typeof(t_coo_merged_object[t_key1][t_key2]) == 'undefined')
					{
						t_coo_merged_object[t_key1][t_key2] = p_coo_object2[t_key1][t_key2];
					}
					else
					{
						for(var t_key3 in p_coo_object2[t_key1][t_key2])
						{
							t_coo_merged_object[t_key1][t_key2][t_key3] = p_coo_object2[t_key1][t_key2][t_key3];
						}
					}
				}
			}
		}
		
		return t_coo_merged_object;
	}
	
	this.finish = function(p_content)
	{
		var t_html_list = coo_this.build_list();
		if(t_html_list != '')
		{
			$('#conflicts_report').append(t_html_list);
			$('#conflicts_report').show();
		}
		
		if($('#sql_errors').html() != '')
		{
			$('#update_status').hide();
			$('#installation_success').hide();
			$('#sql_errors_report').show();
			$('#result').show();
		}
		else if(p_content != '')
		{
			$('#main').append('<form id="temp_form" action="index.php?content=' + p_content + '&language=<?php echo $t_language; ?>" name="' + p_content + '" method="post" style="display:none;"><input type="hidden" name="email" value="' + $('#form_install input[name="email"]').val() + '" /><input type="hidden" name="password" value="' + $('#form_install input[name="password"]').val() + '" /></form>');

			$('#temp_form').submit();
		}
		else
		{
			$('#update_status').hide();
			$('#result').show();
		}
	}
	
	this.show_error = function(p_error_message, p_error, p_url)
	{
		var t_data = $('#form_install').serialize();
		t_data += encodeURIComponent('&error_message='+p_error);
		t_data += encodeURIComponent('&error_url='+p_url);
		$.ajax(
		{	
			data:		t_data,
			url: 		'request_port.php?action=error_log&language=<?php echo $t_language; ?>',
			type: 		'POST',
			async:		true,
			dataType:	'json',
			success:	function(p_response)
			{	
			},
			error:	function(p_jqXHR, p_exception_text)
			{
			}
		});
	
		$('#errors_container').html(p_error_message + p_error);
		
		$('#form_install').hide();
		$('#update_status').hide();
		$('#installation_success').hide();
		$('#sql_errors_report').hide();
		$('#errors_report').show();
		$('#result').show();
	}
}

function set_keep_path(p_coo_this)
{
	var t_section_path = '';
	if(p_coo_this.value == 1)
	{
		t_section_path = $(p_coo_this).closest('tbody.section_body').attr('id');
	}
	
	$(p_coo_this).closest('tbody.section_body').find('input[name^=keep_list]').val(t_section_path);
	
}

$(document).ready(function()
{
	$('input.bound_radio').each(function ()
	{
		set_keep_path(this);
	});
	
	$('#button_install').bind('click', function()
	{
		var t_url = 'request_port.php?action=get_first_update&language=<?php echo $t_language; ?>';
		var coo_request_handler = new RequestHandler();
		
		coo_request_handler.send_ajax_request(t_url);
		
		return false;
	});
	
	$('.button_reload').bind('click', function()
	{
		location.reload();
		return false;
	});
	
	$('input.bound_radio').bind('change', function()
	{
		var t_class_selector = '.' + this.className.replace(' ', '.');
		//$('input' + t_class_selector + '[value=' + this.value + ']').prop('checked', true);

        var t_this_value = this.value;
        $('input' + t_class_selector).filter(function()
		{
			var t_ret = $(this).val() == t_this_value ? true : false;
			return t_ret;
		}).prop('checked', true);

		set_keep_path(this);
	});

	$('.folder').live('click', function()
	{
		var t_dir = $(this).find('.absolute_dir').html();
		$(this).append('<input type="hidden" name="dir" value="' + t_dir + '" />');
		
		var t_url = 'request_port.php?language=<?php echo $t_language; ?>&action=';
		
		if($('#form_move').length > 0)
		{
			t_url += 'ftp&content=move';
			var t_data = $('#form_move').serialize();
		}
		else if($('#form_delete').length > 0)
		{
			t_url += 'ftp&content=delete';
			var t_data = $('#form_delete').serialize();
		}
		else if($('#form_chmod').length > 0)
		{
			t_url += 'ftp&content=chmod';
			var t_data = $('#form_chmod').serialize();
		}
		
		$.ajax(
		{	data:		t_data,
			url: 		t_url,
			type: 		'POST',
			async:		true,
			dataType:	'json',
			beforeSend:	function()
			{
				$('#ftp_content').addClass('progress_cursor');
				$('.folder').addClass('progress_cursor');
			},
			success:	function(p_response)
			{
				$('#ftp_content').html(p_response.html);
			},
			complete: function()
			{
				$('#ftp_content').removeClass('progress_cursor');
				$('.folder').removeClass('progress_cursor');
			}
		});
	});
});