<?php
/* --------------------------------------------------------------
   fetch_email_template.inc.php 2013-09-06 mb
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2013 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

function fetch_email_template($coo_smarty, $p_filename, $p_type = 'html', $p_folder = '', $p_languages_id = null, $p_language_directory = null)
{
	$c_languages_id = (int)$p_languages_id;
	if(empty($p_languages_id))
	{
		$c_languages_id = (int)$_SESSION['languages_id'];
	}
	
	$c_language_directory = basename((string)$p_language_directory);
	if(empty($c_language_directory) || !file_exists(DIR_FS_CATALOG . 'lang/' . $c_language_directory))
	{
		$c_language_directory = basename($_SESSION['language']);
	}
	
	$c_filename = basename($p_filename);
	
	$c_folder = '';
	if($p_folder === 'admin/') $c_folder = $p_folder;
	
	$c_type = 'html';
	if($p_type === 'txt') $c_type = $p_type;
	
	$t_filepath = DIR_FS_CATALOG . 'lang/' . $c_language_directory . '/mail_templates/' . $c_folder . $c_filename . '.' . $c_type;
	if(file_exists($t_filepath))
	{
		$t_output = $coo_smarty->fetch($t_filepath);
		return $t_output;
	}

	$t_filepath = DIR_FS_CATALOG . 'cache/view_' . $c_languages_id . '-' . basename($c_folder) . '-' . $c_filename . '-' . $c_type . '.html';
	if(file_exists($t_filepath))
	{
		$t_output = $coo_smarty->fetch($t_filepath);
		return $t_output;
	}
	
	$t_sql = "SELECT 
					html, 
					txt 
				FROM gm_emails 
				WHERE 
					languages_id = '" . $c_languages_id . "' AND
					folder = '" . xtc_db_input($p_folder) . "' AND
					filename = '" . xtc_db_input($p_filename) . "'";
	$t_result = xtc_db_query($t_sql);
	if(xtc_db_num_rows($t_result) == 1)
	{
		$t_result_array = xtc_db_fetch_array($t_result);
		if(isset($t_result_array[$c_type]))
		{
			$t_success = file_put_contents($t_filepath, $t_result_array[$c_type]);
			
			if(!empty($t_success))
			{
				$t_output = $coo_smarty->fetch($t_filepath);
				return $t_output;
			}					
		}				
	}
			
	return false;
}