<?php
/* --------------------------------------------------------------
   paypalng.php 2014-09-18 mabr
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/


defined('GM_HTTP_SERVER') or define('GM_HTTP_SERVER', HTTP_SERVER);

class paypalng_ORIGIN {
	var $code, $title, $description, $enabled;
	//var $form_action_url;
	var $paypal;
	var $tmpOrders = true;
	var $tmpStatus;

	public function __construct() {
		$this->paypal = new GMPayPal();
		$pp_config = $this->paypal->getConfigArray();
		$this->code = 'paypalng';
		$this->title = MODULE_PAYMENT_PAYPALNG_LOGO.' '.MODULE_PAYMENT_PAYPALNG_TEXT_TITLE;
		$t_config_button = '<a href="'.GM_HTTP_SERVER.DIR_WS_ADMIN.'paypal_config.php" class="button" style="margin: auto; ">'.$this->paypal->get_text('configure').'</a>';
		$this->description = MODULE_PAYMENT_PAYPALNG_TEXT_DESCRIPTION.'<br><br>'.$this->_checkRequirements().$t_config_button;
		$this->sort_order = MODULE_PAYMENT_PAYPALNG_SORT_ORDER;
		$this->enabled = ((MODULE_PAYMENT_PAYPALNG_STATUS == 'True') ? true : false);
		$this->info = MODULE_PAYMENT_PAYPALNG_TEXT_INFO;
		$this->tmpStatus = $pp_config['orders_status_id_tmp'];
		$this->order_status = $pp_config['orders_status_id'];

		if(is_object($GLOBALS['order'])) {
			$this->update_status();
		}

		if(!is_array($_SESSION['paypal'])) {
			$_SESSION['paypal'] = array();
		}
	}

	function _checkRequirements() {
		$out = MODULE_PAYMENT_PAYPALNG_SYSTEM_REQUIREMENTS.':<br>';
		if(defined('DIR_WS_ADMIN') && strpos($_SERVER['REQUEST_URI'], constant('DIR_WS_ADMIN')) !== false) {
			$has_curl = in_array('curl', get_loaded_extensions());
			$out .= "cURL: ". ($has_curl ? '<span style="color:green">'.MODULE_PAYMENT_PAYPALNG_OK.'</span>' : '<span style="color:red">'.MODULE_PAYMENT_PAYPALNG_MISSING.'</span><br>');
			$out .= '<br>';
			$has_soap = in_array('soap', get_loaded_extensions());
			$out .= "SOAP: ". ($has_soap ? '<span style="color:green">'.MODULE_PAYMENT_PAYPALNG_OK.'</span>' : '<span style="color:red">'.MODULE_PAYMENT_PAYPALNG_MISSING.'</span><br>');
		}
		return $out;
	}

	function update_status() {
		global $order;

		if (($this->enabled == true) && ((int) MODULE_PAYMENT_PAYPALNG_ZONE > 0)) {
			$check_flag = false;
			$check_query = xtc_db_query("select zone_id from ".TABLE_ZONES_TO_GEO_ZONES." where geo_zone_id = '".MODULE_PAYMENT_PAYPALNG_ZONE."' and zone_country_id = '".$order->billing['country']['id']."' order by zone_id");
			while ($check = xtc_db_fetch_array($check_query)) {
				if ($check['zone_id'] < 1) {
					$check_flag = true;
					break;
				}
				elseif ($check['zone_id'] == $order->billing['zone_id']) {
					$check_flag = true;
					break;
				}
			}

			if ($check_flag == false) {
				$this->enabled = false;
			}
		}
	}

	function javascript_validation() {
		return false;
	}

	function selection() {
		$pp_config = $this->paypal->getConfigArray();
		// rationale: PayPal must not be used for selfpickup because selfpickup voids seller protection
		if($pp_config['prevent_selfpickup'] === 'prevent' && strpos($_SESSION['shipping']['id'], 'selfpickup') !== false) {
			if($_SESSION['payment'] == $this->code && (isset($_GET['payment_error']) === false || $_GET['payment_error'] != $this->code)) {
				unset($_SESSION['payment']);
				$_SESSION['paypalng_error'] = MODULE_PAYMENT_PAYPALNG_TEXT_ERROR_SELFPICKUP;
				if(headers_sent() === false) {
					xtc_redirect(GM_HTTP_SERVER.DIR_WS_CATALOG.FILENAME_CHECKOUT_PAYMENT.'?payment_error='.$this->code.'&redirect_by=hdr');
				}
				else {
					$redirect_url = GM_HTTP_SERVER.DIR_WS_CATALOG.FILENAME_CHECKOUT_PAYMENT.'?payment_error='.$this->code.'&redirect_by=js';
				}
			}
			else
			{
				return false;
			}
		}
		$order = $GLOBALS['order'];
		$fields = array();
		if($this->paypal->stateOrProvinceRequired($order->delivery['country']['iso_code_2'])) {
			$state_code = $this->_findStateCode($order->delivery['country']['id'], $order->delivery['state']);
			$fields[] = array('title' => $this->paypal->get_text('select_state'), 'field' => $this->_stateSelector($order->delivery['country']['id'], $state_code));
		}
		if(empty($redirect_url) === false) {
			$js_redirect = '<script>document.location = "'.$redirect_url.'";</script>';
		}
		$selection = array(
			'id' => $this->code,
			'module' => $this->title,
			'description' => $this->info.$js_redirect,
			'fields' => $fields,
		);
		if($this->pp_config['sandbox_mode'] == true && $_SESSION['customers_status']['customers_status_id'] != 0) {
			// only show up for admins in Sandbox mode
			$selection = false;
		}
		return $selection;
	}

	function _stateSelector($country_id, $order_state_code = null) {
		$states = $this->_getStates($country_id);
		if(!empty($states)) {
			$output = '<select name="paypal_state">';
			foreach($states as $state_code => $state) {
				$selected = $order_state_code == $state_code ? 'selected="selected"' : '';
				$output .= '<option '.$selected.' value="'.$state_code.'">'.$state.'</option>';
			}
			$output .= '</select>';
		}
		else {
			$output = '<input type="text" name="paypal_state" value="'.$GLOBALS['order']->delivery['state'].'">';
		}
		return $output;
	}

	function _findStateCode($country_id, $ab_state) {
		$states = $this->_getStates($country_id);
		foreach($states as $state_code => $state_name) {
			if(strcasecmp($state_code, $ab_state) == 0 || strcasecmp($state_name, $ab_state) == 0) {
				return $state_code;
			}
		}
		return '';
	}

	function _getStates($country_id) {
		$states = array();
		$query = "SELECT `zone_code`, `zone_name` FROM `zones` WHERE `zone_country_id` = ".(int)$country_id." ORDER BY `zone_code`";
		$result = xtc_db_query($query);
		while($row = xtc_db_fetch_array($result)) {
			$states[$row['zone_code']] = $row['zone_name'];
		}
		return $states;
	}

	function pre_confirmation_check() {
		if(isset($_POST['paypal_state'])) {
			$ppstate = trim($_POST['paypal_state']);
			if(empty($ppstate)) {
				$_SESSION['paypalng_error'] = MODULE_PAYMENT_PAYPALNG_TEXT_ERROR_STATEORPROVINCEREQUIRED;
				xtc_redirect(GM_HTTP_SERVER.DIR_WS_CATALOG.FILENAME_CHECKOUT_PAYMENT.'?payment_error='.$this->code);
			}
			$states = $this->_getStates($GLOBALS['order']->delivery['country']['id']);
			if(!empty($states)) {
				$states_codes = array_keys($states);
				if(in_array($_POST['paypal_state'], $states_codes)) {
					$_SESSION['paypal_state'] = $_POST['paypal_state'];
				}
			}
			else {
				$_SESSION['paypal_state'] = $_POST['paypal_state'];
			}
		}
		return false;
	}

	function confirmation() {
		$confirmation = array(
			'title' => MODULE_PAYMENT_PAYPALNG_TEXT_DESCRIPTION,
		);
		return $confirmation;
	}

	function refresh() {
	}

	function process_button() {
		global $order;
		$pb = '';
		return $pb;
	}

	function payment_action() {
		$order = $GLOBALS['order'];
		$orders_id = $GLOBALS['insert_id'];
		if(empty($orders_id)) {
			// workaround for a rare PHP configuration
			$orders_id = $_SESSION['tmp_oID'];
		}
		$pp = new GMPayPal();
		if(isset($_SESSION['paypal_checkout_data'])) {
			// Express Checkout

			/* $_SESSION should contain data from initial call to getExpressCheckoutDetails:
				$_SESSION['paypal_checkout_data'] = array(
					'payer_id' => $payer_id,
					'token' => $token,
					'gecd_response' => $response,
				);
			*/
			if(empty($_SESSION['paypal_checkout_data']) || empty($_SESSION['paypal_checkout_data']['payer_id']) || empty($_SESSION['paypal_checkout_data']['token'])) {
				xtc_db_close();
				die('thou shalt not hack this site.');
			}
			$pp->savePayerId($orders_id, $_SESSION['paypal_checkout_data']['payer_id']);
			$pp->saveToken($orders_id, $_SESSION['paypal_checkout_data']['token']);
			$pp->savePaymentaction($orders_id);
			$pp->_log("order $orders_id - payment_action for express checkout, redirecting to checkout_process");
			xtc_redirect(GM_HTTP_SERVER.DIR_WS_CATALOG.FILENAME_CHECKOUT_PROCESS.'?'.SID);
		}
		else {
			// classic checkout, redirect to PayPal
			$token = $pp->prepareClassicCheckout($orders_id, $order);
			if($token === false) {
				$_SESSION['paypalng_error'] = $pp->get_text('got_no_token');
				xtc_redirect(GM_HTTP_SERVER.DIR_WS_CATALOG.FILENAME_CHECKOUT_PAYMENT.'?payment_error='.$this->code);
			}
			$_SESSION['paypal']['token'] = $token;
			$redirect_url = $pp->getRedirectURL('_express-checkout', $token, 'commit');
			$pp->_log("order $orders_id - payment_action for classic checkout, redirecting to $redirect_url");
			$user_agent = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : 'unidentified';
			$pp->_log("customer's browser: ".$user_agent);
			if(!headers_sent($filename, $linenum)) {
				xtc_redirect($redirect_url);
			}
			else {
				$pp->_log("ERROR initiating redirection, output started in $filename line $linenum!");
				xtc_db_close();
				die('redirection error');
			}
		}
	}

	function before_process() {
		return false;
	}

	function after_process() {
		$pp_config = $this->paypal->getConfigArray();
		$insert_id = $GLOBALS['insert_id'];
		if(empty($insert_id)) {
			$insert_id = $_SESSION['tmp_oID'];
		}

		$this->paypal->_log("after_process for $insert_id, _REQUEST:\n".print_r($_REQUEST, true));

		if(isset($_SESSION['paypal_checkout_data'])) {
			// Express Checkout
			$this->paypal->saveGetExpressCheckoutDetails($insert_id, $_SESSION['paypal_checkout_data']['gecd_response']);
		}
		else
		{
			# classic checkout
			$details = $this->paypal->getExpressCheckoutDetails($insert_id, true);
			if(isset($_GET['token']) && $_GET['token'] == $_SESSION['paypal']['token'] && isset($_GET['PayerID'])) {
				$this->paypal->_log('returned from PayPal for token '.$_SESSION['paypal']['token'].', received PayerID '.$_GET['PayerID']);
				$this->paypal->savePayerId($insert_id, $_GET['PayerID']);
			}
			else {
				if($details !== false && $details['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->CheckoutStatus == 'PaymentActionNotInitiated')
				{
					# something went wrong when user was redirected to PayPal, user probably reloaded the page -> retry redirection
					$redirect_url = $this->paypal->getRedirectURL('_express-checkout', $_SESSION['paypal']['token']);
					$this->paypal->_log("order $orders_id - after_process for classic checkout after unsuccessful redirection, redirecting again to $redirect_url");
					$user_agent = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : 'unidentified';
					$this->paypal->_log("customer's browser: ".$user_agent);

					if(!headers_sent($filename, $linenum))
					{
						xtc_redirect($redirect_url);
					}
				}
				else
				{
					$this->paypal->_log('ERROR: invalid call to after_process!');
					xtc_db_close();
					die('error processing PayPal payment');
				}
			}
		}

		$result = $this->paypal->doExpressCheckoutPayment($insert_id);

		$token = false;
		if(isset($_GET['token']) && $_GET['token'] == $_SESSION['paypal']['token']) {
			$token = $_GET['token'];
		}
		else if(!empty($_SESSION['paypal_checkout_data']['token'])) {
			$token = $_SESSION['paypal_checkout_data']['token'];
		}

		if($result['success'] == true) {
			$details = $this->paypal->getExpressCheckoutDetails($insert_id, true);
			$ppconfig = $this->paypal->getConfigArray();
			$payment_status = $result['doecresponse']->DoExpressCheckoutPaymentResponseDetails->PaymentInfo[0]->PaymentStatus;
			$this->paypal->_log('after_process payment status: '.$payment_status);
			$note_text = (string)$details['checkoutdetails']->GetExpressCheckoutDetailsResponseDetails->PaymentDetails[0]->NoteText;
			if(empty($note_text))
			{
				$comments = '';
			}
			else
			{
				$comments = $note_text . "\n";
			}
			if(strtolower($payment_status) == 'completed') {
				xtc_db_query("UPDATE ".TABLE_ORDERS." SET orders_status='".$ppconfig['orders_status_id']."' WHERE orders_id='".$insert_id."'");
				$t_osh_entry = array(
					'orders_id' => (int)$insert_id,
					'orders_status_id' => (int)$ppconfig['orders_status_id'],
					'date_added' => 'now()',
					'customer_notified' => '0',
					'comments' => $comments,
				);
				xtc_db_perform('orders_status_history', $t_osh_entry, 'insert');
			}
			else if(in_array(strtolower($payment_status), array('pending', 'created'))) {
				xtc_db_query("UPDATE ".TABLE_ORDERS." SET orders_status='".$ppconfig['orders_status_id_pending']."' WHERE orders_id='".$insert_id."'");
				$t_pending_reason = (string)$result['doecresponse']->DoExpressCheckoutPaymentResponseDetails->PaymentInfo[0]->PendingReason;
				$t_osh_entry = array(
					'orders_id' => (int)$insert_id,
					'orders_status_id' => (int)$ppconfig['orders_status_id_pending'],
					'date_added' => 'now()',
					'customer_notified' => '0',
					'comments' => $comments . $t_pending_reason,
				);
				xtc_db_perform('orders_status_history', $t_osh_entry, 'insert');
			}
			else {
				// leave in tmp status
			}

			if($result['doecresponse']->DoExpressCheckoutPaymentResponseDetails->RedirectRequired == true) {
				if($token === false)
				{
					$this->_paypal->log('ERROR: redirect required without token');
					xtc_db_close();
					die('FATAL: cannot redirect without token');
				}
				$redirect_url = $this->paypal->getRedirectURL('_complete-express-checkout', $token);
				$this->paypal->_log('redirect required (for GiroPay): '.$redirect_url);
				$_SESSION['paypal_redirect_url'] = $redirect_url;
				// actual redirection will be initiated in a CheckoutSuccessExtender; rationale: checkout_process needs to do some cleanup first
			}
			unset($_SESSION['paypal_checkout_data']);
			unset($_SESSION['paypal']['token']);
		}
		else {
			$error_code = (string)$result['doecresponse']->Errors[0]->ErrorCode;

			# Error 10486 => "buyer's payment fails due to a bad funding method (typically an invalid or maxed out credit card)"
			if($error_code == '10486')
			{
				$redirect_url = $this->paypal->getRedirectURL('_express-checkout', $token);
				$this->paypal->_log("order $orders_id - trying to recover from 10486 (bad funding), redirecting to $redirect_url");
				$user_agent = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : 'unidentified';
				$this->paypal->_log("customer's browser: ".$user_agent);

				if(!headers_sent($filename, $linenum)) {
					xtc_redirect($redirect_url);
				}
				else
				{
					echo '<a href="'.$redirect_url.'">click here</a>';
				}
			}
			$error_msg = (string)$result['doecresponse']->Errors[0]->ShortMessage .' - '. (string)$result['doecresponse']->Errors[0]->LongMessage;
			$this->paypal->_log("DoExpressCheckout ERROR: ".$error_msg);
			$_SESSION['paypalng_error'] = $error_msg;
			unset($_SESSION['paypal_checkout_data']);
			unset($_SESSION['paypal']['token']);
			xtc_redirect(GM_HTTP_SERVER.DIR_WS_CATALOG.FILENAME_CHECKOUT_PAYMENT.'?payment_error='.$this->code);
		}
	}

	function get_error() {
		if(isset($_SESSION['paypalng_error'])) {
			$error = array('error' => $_SESSION['paypalng_error']);
			unset($_SESSION['paypalng_error']);
			return $error;
		}
		return false;
	}

	function check() {
		if (!isset ($this->_check)) {
			$check_query = xtc_db_query("select configuration_value from ".TABLE_CONFIGURATION." where configuration_key = 'MODULE_PAYMENT_".  strtoupper($this->code) ."_STATUS'");
			$this->_check = xtc_db_num_rows($check_query);
		}
		return $this->_check;
	}

	function install() {
		$config = $this->_configuration();
		$sort_order = 0;
		foreach($config as $key => $data) {
			$install_query = "insert into ".TABLE_CONFIGURATION." ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) ".
					"values ('MODULE_PAYMENT_".strtoupper($this->code)."_".$key."', '".$data['configuration_value']."', '6', '".$sort_order."', '".addslashes($data['set_function'])."', '".addslashes($data['use_function'])."', now())";
			xtc_db_query($install_query);
			$sort_order++;
		}
	}

	function remove() {
		xtc_db_query("delete from ".TABLE_CONFIGURATION." where configuration_key in ('".implode("', '", $this->keys())."')");
		gm_set_conf('PAYPAL_VALID_API', 'FALSE');
	}

	function keys() {
		$ckeys = array_keys($this->_configuration());
		$keys = array();
		foreach($ckeys as $k) {
			$keys[] = 'MODULE_PAYMENT_'.strtoupper($this->code).'_'.$k;
		}
		return $keys;
	}

	function _configuration() {
		$config = array(
			'STATUS' => array(
				'configuration_value' => 'True',
				'set_function' => 'gm_cfg_select_option(array(\'True\', \'False\'), ',
			),
			'ALLOWED' => array(
				'configuration_value' => '',
			),
			'ZONE' => array(
				'configuration_value' => '0',
				'use_function' => 'xtc_get_zone_class_title',
				'set_function' => 'xtc_cfg_pull_down_zone_classes(',
			),
			'SORT_ORDER' => array(
				'configuration_value' => '0',
			),
		);

		return $config;
	}

}

MainFactory::load_origin_class('paypalng');