<?php
/*
 * Shopgate GmbH
 * http://www.shopgate.com
 * Copyright © 2012-2014 Shopgate GmbH
 * 
 * Released under the GNU General Public License (Version 2)
 * [http://www.gnu.org/licenses/gpl-2.0.html]
*/

if(function_exists("sgIsHomepage") == false){
	function sgIsHomepage() {
		$scriptName = explode('/', $_SERVER['SCRIPT_NAME']);
		$scriptName = end($scriptName);

		if ($scriptName != 'index.php') {
			return false;
		}
		if (!empty($_REQUEST)) {
			foreach ($_REQUEST as $key => $value) {
				if ($key != 'language') {
					return false;
				}
			}
		}
		return true;
	}
}

$shopgateMobileHeader = '';// compatibility to older versions
$shopgateJsHeader = '';

if(defined('MODULE_PAYMENT_INSTALLED') && strpos(MODULE_PAYMENT_INSTALLED, 'shopgate.php') !== false) {
##### GambioGX BOF #####
	include_once DIR_FS_CATALOG.'shopgate/shopgate_library/shopgate.php';
	include_once DIR_FS_CATALOG.'shopgate/gambiogx/shopgate_config.php';
##### GambioGX EOF #####

	try {
		$shopgateCurrentLanguage = isset($_SESSION['language_code']) ? strtolower($_SESSION['language_code']) : 'de';
##### GambioGX BOF #####
		$shopgateHeaderConfig = new ShopgateConfigGambioGx();
##### GambioGX EOF #####
		$shopgateHeaderConfig->loadByLanguage($shopgateCurrentLanguage);

		if($shopgateHeaderConfig->checkUseGlobalFor($shopgateCurrentLanguage)) {
			$shopgateRedirectThisLanguage = in_array($shopgateCurrentLanguage, $shopgateHeaderConfig->getRedirectLanguages());
		} else {
			$shopgateRedirectThisLanguage = true;
		}

		if ($shopgateRedirectThisLanguage) {
			// SEO modules fix (for Commerce:SEO and others): if session variable was set, SEO did a redirect and most likely cut off our GET parameter
			// => reconstruct here, then unset the session variable
			if(!empty($_SESSION['shopgate_redirect'])) {
				$_GET['shopgate_redirect'] = 1;
				unset($_SESSION['shopgate_redirect']);
			}

			// instantiate and set up redirect class
			$shopgateBuilder = new ShopgateBuilder($shopgateHeaderConfig);
			$shopgateRedirector = $shopgateBuilder->buildRedirect();

			##################
			# redirect logic #
			##################

			if(($product instanceof product) && $product->isProduct && !empty($product->pID)) {
				$shopgateJsHeader = $shopgateRedirector->buildScriptItem($product->pID);
			} elseif(!empty($current_category_id)) {
				$shopgateJsHeader = $shopgateRedirector->buildScriptCategory($current_category_id);
			} elseif(sgIsHomepage()) {
				$shopgateJsHeader = $shopgateRedirector->buildScriptShop();
			} else {
				$shopgateJsHeader = $shopgateRedirector->buildScriptDefault();
			}
		}
	} catch (ShopgateLibraryException $e) {	}
}
