<?php
/* --------------------------------------------------------------
   Countries.inc.php 2014-07-15 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

class Countries
{
	protected $countries_array;
	
	public function __construct($p_language_id, $p_load_data = true)
	{
		if($p_load_data)
		{
			$this->load_countries_array((int)$p_language_id);
		}
	}
	
	protected function load_countries_array($p_language_id)
	{
		$t_country_codes_array = array();
		
		$t_sql = '	SELECT
						countries_iso_code_2 AS code
					FROM
						countries';
		$t_result = xtc_db_query($t_sql);
		
		while($t_country = xtc_db_fetch_array($t_result))
		{
			$t_country_codes_array[] = $t_country['code'];
		}
		
		$this->load_country_names($t_country_codes_array, $p_language_id);
	}
	
	public function load_country_names(array $p_country_codes_array, $p_language_id)
	{
		$this->countries_array = array();
		$coo_text_manager = MainFactory::create_object('LanguageTextManager', array('countries', (int)$p_language_id));
		
		foreach($p_country_codes_array as $t_country_code)
		{
			$this->countries_array[$t_country_code] = $coo_text_manager->get_text($t_country_code);
		}
	}
	
	public function get_country_codes_string()
	{
		$t_country_codes = implode(';', $this->get_country_codes_array());
		return $t_country_codes;
	}
	
	public function get_country_codes_array()
	{
		return array_keys($this->countries_array);
	}
	
	public function get_countries_array()
	{
		return $this->countries_array;
	}

	public function set_countries_array(array $p_countries_array)
	{
		$this->countries_array = $p_countries_array;
	}

	public function __toString()
	{
		$t_output = '';
		foreach($this->countries_array as $t_country)
		{
			$t_output .= $t_country . ', ';
		}
		
		$t_output = substr($t_output, 0, -2);
		return $t_output;
	}
}