<?php
/* --------------------------------------------------------------
   AccountEditContentView.inc.php 2014-04-24 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(account_edit.php,v 1.63 2003/05/19); www.oscommerce.com
   (c) 2003	 nextcommerce (account_edit.php,v 1.14 2003/08/17); www.nextcommerce.org
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: account_edit.php 1314 2005-10-20 14:00:46Z mz $)

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

class AccountEditContentView extends ContentView
{
	protected $error_array = array();
	protected $customer_data_array = array();
	
	
	function __construct()
	{
		parent::__construct();
		
		$this->set_content_template('module/account_edit.html');
		$this->set_flat_assigns(true);
		$this->set_caching_enabled(false);
	}
	
	
	protected function set_validation_rules()
	{
		$this->validation_rules_array['customer_data_array']	= array('type' => 'array');
		$this->validation_rules_array['error_array']			= array('type' => 'array');
	}
	
	
	protected function set_deprecated_array()
	{
		$this->deprecated_array[1][] = 'csID';
		$this->deprecated_array[1][] = 'FORM_ACTION';
		$this->deprecated_array[1][] = 'FORM_END';
		$this->deprecated_array[1][] = 'BUTTON_BACK';
		$this->deprecated_array[1][] = 'BUTTON_SUBMIT';
		$this->deprecated_array[1][] = 'INPUT_MALE';
		$this->deprecated_array[1][] = 'INPUT_MALE_NAME';
		$this->deprecated_array[1][] = 'INPUT_MALE_VALUE';
		$this->deprecated_array[1][] = 'INPUT_FEMALE';
		$this->deprecated_array[1][] = 'INPUT_FEMALE_NAME';
		$this->deprecated_array[1][] = 'INPUT_FEMALE_VALUE';
		$this->deprecated_array[1][] = 'INPUT_VAT';
		$this->deprecated_array[1][] = 'INPUT_VAT_NAME';
		$this->deprecated_array[1][] = 'INPUT_FIRSTNAME';
		$this->deprecated_array[1][] = 'INPUT_FIRSTNAME_NAME';
		$this->deprecated_array[1][] = 'INPUT_LASTNAME';
		$this->deprecated_array[1][] = 'INPUT_LASTNAME_NAME';
		$this->deprecated_array[1][] = 'INPUT_DOB';
		$this->deprecated_array[1][] = 'INPUT_DOB_NAME';
		$this->deprecated_array[1][] = 'INPUT_EMAIL';
		$this->deprecated_array[1][] = 'INPUT_EMAIL_NAME';
		$this->deprecated_array[1][] = 'INPUT_TEL';
		$this->deprecated_array[1][] = 'INPUT_TEL_NAME';
		$this->deprecated_array[1][] = 'INPUT_FAX';
		$this->deprecated_array[1][] = 'INPUT_FAX_NAME';
		$this->deprecated_array[1][] = 'INPUT_EMAIL_NAME';
		$this->deprecated_array[1][] = 'form_data|gender|required_symbol';
		$this->deprecated_array[1][] = 'form_data|vat|required_symbol';
		$this->deprecated_array[1][] = 'form_data|firstname|required_symbol';
		$this->deprecated_array[1][] = 'form_data|lastname|required_symbol';
		$this->deprecated_array[1][] = 'form_data|birthdate|required_symbol';
		$this->deprecated_array[1][] = 'form_data|email|required_symbol';
		$this->deprecated_array[1][] = 'form_data|telephone|required_symbol';
		$this->deprecated_array[1][] = 'form_data|fax|required_symbol';
	}
	
	
	public function prepare_data()
	{
		$this->add_error_messages();
		$this->add_data();
	}
	
	
	protected function add_data()
	{
		$this->content_array['csID'] = $this->customer_data_array['customers_id'];
		
		if(is_array($this->content_array['form_data']) == false)
		{
			$this->content_array['form_data'] = array();
		}
		
		$this->add_form();
		$this->add_gender();
		$this->add_vat();
		$this->add_firstname();
		$this->add_lastname();
		$this->add_birthdate();
		$this->add_email();
		$this->add_telephone();
		$this->add_fax();
		$this->add_privacy();
	}
	
	
	protected function add_form()
	{
		$t_form_action = xtc_href_link(FILENAME_ACCOUNT_EDIT, '', 'SSL');
		$this->content_array['FORM_ID'] =  'account_edit';
		$this->content_array['FORM_METHOD'] =  'post';
		$this->content_array['FORM_ACTION_URL'] =  $t_form_action;

		$this->content_array['FORM_ACTION'] = xtc_draw_form(
												  'account_edit',
												  $t_form_action,
												  'post',
												  ''
											  ) . xtc_draw_hidden_field('action', 'process'
	  	);
		$this->content_array['FORM_END'] = '</form>';

		$this->content_array['BUTTON_BACK'] = '<a href="' . xtc_href_link(FILENAME_ACCOUNT, '', 'SSL') . '">' . xtc_image_button('button_back.gif', IMAGE_BUTTON_BACK) . '</a>';
		$this->content_array['BUTTON_BACK_LINK'] = xtc_href_link(FILENAME_ACCOUNT, '', 'SSL');
		$this->content_array['BUTTON_SUBMIT'] = xtc_image_submit('button_continue.gif', IMAGE_BUTTON_CONTINUE);
		
		$this->content_array['HIDDEN_FIELD_NAME'] = 'action';
		$this->content_array['HIDDEN_FIELD_VALUE'] = 'process';
	}
	
	
	protected function add_gender()
	{
		if(ACCOUNT_GENDER == 'true')
		{
			$this->content_array['gender'] = '1';
			
			$t_male = $this->customer_data_array['gender'] == 'm';
			$t_female = !$t_male;
			
			$this->content_array['INPUT_MALE'] = xtc_draw_radio_field(
													array(
														'name' => 'gender',
														'suffix' => MALE . '&nbsp;'
													),
													'm',
													$t_male
			);
			$this->content_array['INPUT_MALE_NAME'] = 'gender';
			$this->content_array['INPUT_MALE_VALUE'] = 'm';

			$t_field_text = '';
			if(xtc_not_null(ENTRY_GENDER_TEXT))
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_GENDER_TEXT . '</span>';
			}
			$this->content_array['INPUT_FEMALE'] = xtc_draw_radio_field(
													  array(
														  'name' => 'gender',
														  'suffix' => FEMALE . '&nbsp;',
														  'text' => $t_field_text
													  ),
													  'f',
													  $t_female
			);
			$this->content_array['INPUT_FEMALE_NAME'] = 'gender';
			$this->content_array['INPUT_FEMALE_VALUE'] = 'f';

			$this->content_array['form_data']['gender'] = array();
			$this->content_array['form_data']['gender']['m'] = array();
			$this->content_array['form_data']['gender']['f'] = array();
			$this->content_array['form_data']['gender']['name'] = 'gender';
			$this->content_array['form_data']['gender']['m']['value'] = 'm';
			$this->content_array['form_data']['gender']['f']['value'] = 'f';
			$this->content_array['form_data']['gender']['m']['checked'] = '0';
			$this->content_array['form_data']['gender']['f']['checked'] = '0';

			if($this->customer_data_array['gender'] == 'm')
			{
				$this->content_array['form_data']['gender']['m']['checked'] = '1';
			}
			if($this->customer_data_array['gender'] == 'f')
			{
				$this->content_array['form_data']['gender']['f']['checked'] = '1';
			}

			$this->content_array['form_data']['gender']['required'] = 1;
			$this->content_array['form_data']['gender']['required_symbol'] = ENTRY_GENDER_TEXT;
		}
	}
	
	
	protected function add_vat()
	{
		if(ACCOUNT_COMPANY_VAT_CHECK == 'true')
		{
			$this->content_array['vat'] = '1';
			$t_field_text = '';
			if(xtc_not_null(ENTRY_VAT_TEXT))
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_VAT_TEXT . '</span>';
			}
			$this->content_array['INPUT_VAT'] = xtc_draw_input_fieldNote(
												   array(
													   'name' => 'vat',
													   'text' => '&nbsp;' . $t_field_text
												   ),
												   htmlspecialchars_wrapper($this->customer_data_array['vat_id']),
												   '',
												   'text',
												   true,
												   'gm_mb_input inactive_input'
			);
			$this->content_array['INPUT_VAT_NAME'] = 'vat';
			$this->content_array['form_data']['vat'] = array();
			$this->content_array['form_data']['vat']['name'] = 'vat';
			$this->content_array['form_data']['vat']['value'] = htmlspecialchars_wrapper($this->customer_data_array['vat_id']);
			$this->content_array['form_data']['vat']['required'] = 0;
			$this->content_array['form_data']['vat']['required_symbol'] = ENTRY_VAT_TEXT;
		}
		else
		{
			$this->content_array['vat'] = '0';
		}
	}
	
	
	protected function add_firstname()
	{
		$t_field_text = '';
		if(xtc_not_null(ENTRY_FIRST_NAME_TEXT))
		{
			$t_field_text =  '<span class="inputRequirement">' . ENTRY_FIRST_NAME_TEXT . '</span>';
		}
		$this->content_array['INPUT_FIRSTNAME'] = xtc_draw_input_fieldNote(
													 array(
														 'name' => 'firstname',
														 'text' => '&nbsp;' . $t_field_text
													 ),
													 htmlspecialchars_wrapper($this->customer_data_array['firstname']),
													 '',
													 'text',
													 true,
													 'gm_mb_input inactive_input'
		);
		$this->content_array['INPUT_FIRSTNAME_NAME'] = 'firstname';
		$this->content_array['form_data']['firstname'] = array();
		$this->content_array['form_data']['firstname']['name'] = 'firstname';
		$this->content_array['form_data']['firstname']['value'] = htmlspecialchars_wrapper($this->customer_data_array['firstname']);
		$this->content_array['form_data']['firstname']['required'] = 0;
		$this->content_array['form_data']['firstname']['required_symbol'] = ENTRY_FIRST_NAME_TEXT;
		if((int)ENTRY_FIRST_NAME_MIN_LENGTH > 0)
		{
			$this->content_array['form_data']['firstname']['required'] = 1;
		}
	}
	
	
	protected function add_lastname()
	{
		$t_field_text = '';
		if(xtc_not_null(ENTRY_LAST_NAME_TEXT))
		{
			$t_field_text = '<span class="inputRequirement">' . ENTRY_LAST_NAME_TEXT . '</span>';
		}
		$this->content_array['INPUT_LASTNAME'] = xtc_draw_input_fieldNote(
													array(
														'name' => 'lastname',
													  	'text' => '&nbsp;' . $t_field_text
													),
													htmlspecialchars_wrapper($this->customer_data_array['lastname']),
													'',
													'text',
													true,
													'gm_mb_input inactive_input'
		);
		$this->content_array['INPUT_LASTNAME_NAME'] = 'lastname';
		$this->content_array['form_data']['lastname'] = array();
		$this->content_array['form_data']['lastname']['name'] = 'lastname';
		$this->content_array['form_data']['lastname']['value'] = htmlspecialchars_wrapper($this->customer_data_array['lastname']);
		$this->content_array['form_data']['lastname']['required'] = 0;
		$this->content_array['form_data']['lastname']['required_symbol'] = ENTRY_LAST_NAME_TEXT;
		if((int)ENTRY_LAST_NAME_MIN_LENGTH > 0)
		{
			$this->content_array['form_data']['lastname']['required'] = 1;
		}
	}
	
	
	protected function add_birthdate()
	{
		if(ACCOUNT_DOB == 'true')
		{
			$this->content_array['birthdate'] = '1';
			$t_field_text = '<span class="inputRequirement">' . str_replace('* ', '', ENTRY_DATE_OF_BIRTH_TEXT) . '</span>';
			if(xtc_not_null(ENTRY_DATE_OF_BIRTH_TEXT))
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_DATE_OF_BIRTH_TEXT . '</span>';
			}
			$this->content_array['INPUT_DOB'] = xtc_draw_input_fieldNote(
												   array(
													   'name' => 'dob',
													   'text' => '&nbsp;' . $t_field_text
												   ),
												   htmlspecialchars_wrapper($this->customer_data_array['dob']),
												   '',
												   'text',
												   true,
												   'gm_mb_input inactive_input'
			);
			$this->content_array['INPUT_DOB_NAME'] = 'dob';
			$this->content_array['form_data']['birthdate'] = array();
			$this->content_array['form_data']['birthdate']['name'] = 'dob';
			$this->content_array['form_data']['birthdate']['value'] = htmlspecialchars_wrapper($this->customer_data_array['dob']);
			$this->content_array['form_data']['birthdate']['required'] = 0;
			$this->content_array['form_data']['birthdate']['required_symbol'] = ENTRY_DATE_OF_BIRTH_TEXT;
			if((int)ENTRY_DOB_MIN_LENGTH > 0)
			{
				$this->content_array['form_data']['birthdate']['required'] = 1;
			}
		}
		else
		{
			$this->content_array['birthdate'] = '0';
		}
	}
	
	
	protected function add_email()
	{
		$t_field_text = '';
		if(xtc_not_null(ENTRY_EMAIL_ADDRESS_TEXT))
		{
			$t_field_text = '<span class="inputRequirement">' . ENTRY_EMAIL_ADDRESS_TEXT . '</span>';
		}
		$this->content_array['INPUT_EMAIL'] = xtc_draw_input_fieldNote(
												 array(
													 'name' => 'email_address',
													 'text' => '&nbsp;' . $t_field_text
												 ),
												 htmlspecialchars_wrapper($this->customer_data_array['email_address']),
												 '',
												 'text',
												 true,
												 'gm_mb_input inactive_input'
		);
		$this->content_array['INPUT_EMAIL_NAME'] = 'email_address';
		$this->content_array['form_data']['email'] = array();
		$this->content_array['form_data']['email']['name'] = 'email_address';
		$this->content_array['form_data']['email']['value'] = htmlspecialchars_wrapper($this->customer_data_array['email_address']);
		$this->content_array['form_data']['email']['required'] = 0;
		$this->content_array['form_data']['email']['required_symbol'] = ENTRY_EMAIL_ADDRESS_TEXT;
		if((int)ENTRY_EMAIL_ADDRESS_MIN_LENGTH > 0)
		{
			$this->content_array['form_data']['email']['required'] = 1;
		}
	}
	
	
	protected function add_telephone()
	{
		$this->content_array['telephone'] = '0';
		
		if(ACCOUNT_TELEPHONE == 'true')
		{
			$this->content_array['telephone'] = '1';
			
			$t_field_text = '';
			if(xtc_not_null(ENTRY_TELEPHONE_NUMBER_TEXT))
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_TELEPHONE_NUMBER_TEXT . '</span>';
			}
			$this->content_array['INPUT_TEL'] = xtc_draw_input_fieldNote(
													array(
														'name' => 'telephone',
														'text' => '&nbsp;' . $t_field_text
													),
													htmlspecialchars_wrapper($this->customer_data_array['telephone']),
													'',
													'text',
													true,
													'gm_mb_input inactive_input'
			);
			$this->content_array['INPUT_TEL_NAME'] = 'telephone';
			$this->content_array['form_data']['telephone'] = array();
			$this->content_array['form_data']['telephone']['name'] = 'telephone';
			$this->content_array['form_data']['telephone']['value'] = htmlspecialchars_wrapper($this->customer_data_array['telephone']);
			$this->content_array['form_data']['telephone']['required'] = 0;
			$this->content_array['form_data']['telephone']['required_symbol'] = ENTRY_TELEPHONE_NUMBER_TEXT;
			if((int)ENTRY_TELEPHONE_MIN_LENGTH > 0)
			{
				$this->content_array['form_data']['telephone']['required'] = 1;
			}
		}
	}
	
	
	protected function add_fax()
	{
		$this->content_array['fax'] = '0';
		
		if(ACCOUNT_FAX == '1')
		{
			$this->content_array['fax'] = '1';
			
			$t_field_text = '';
			if(xtc_not_null(ENTRY_FAX_NUMBER_TEXT))
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_FAX_NUMBER_TEXT . '</span>';
			}
			$this->content_array['INPUT_FAX'] = xtc_draw_input_fieldNote(
												   array(
													   'name' => 'fax',
													   'text' => '&nbsp;' . $t_field_text
												   ),
												   htmlspecialchars_wrapper($this->customer_data_array['fax']),
												   '',
												   'text',
												   true,
												   'gm_mb_input inactive_input'
			);
			$this->content_array['INPUT_FAX_NAME'] = 'fax';
			$this->content_array['form_data']['fax'] = array();
			$this->content_array['form_data']['fax']['name'] = 'fax';
			$this->content_array['form_data']['fax']['value'] = htmlspecialchars_wrapper($this->customer_data_array['fax']);
			$this->content_array['form_data']['fax']['required'] = 0;
			$this->content_array['form_data']['fax']['required_symbol'] = ENTRY_TELEPHONE_NUMBER_TEXT;
		}
	}
	
	
	protected function add_privacy()
	{
		$this->content_array['GM_PRIVACY_LINK'] = gm_get_privacy_link('GM_CHECK_PRIVACY_ACCOUNT_CONTACT');
	}

	
	protected function add_error_messages()
	{
		if(is_array($this->error_array) && empty($this->error_array) == false)
		{
			foreach($this->error_array as $t_error => $t_error_text)
			{
				$this->content_array[$t_error] = $t_error_text;
				$GLOBALS['messageStack']->add('account_edit', $t_error_text);
			}

			if($GLOBALS['messageStack']->size('account_edit') > 0)
			{
				$this->content_array['error'] = $GLOBALS['messageStack']->output('account_edit');
			}
		}
	}
}