<?php
/* --------------------------------------------------------------
   AccountHistoryInfoContentView.inc.php 2014-06-18 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(account_history_info.php,v 1.97 2003/05/19); www.oscommerce.com
   (c) 2003	 nextcommerce (account_history_info.php,v 1.17 2003/08/17); www.nextcommerce.org
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: account_history_info.php 1309 2005-10-17 08:01:11Z mz $)

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

// include needed functions
require_once (DIR_FS_INC . 'xtc_date_short.inc.php');
require_once (DIR_FS_INC . 'xtc_get_all_get_params.inc.php');
require_once (DIR_FS_INC . 'xtc_image_button.inc.php');
require_once (DIR_FS_INC . 'xtc_display_tax_value.inc.php');
require_once (DIR_FS_INC . 'xtc_format_price_order.inc.php');

require_once(DIR_WS_CLASSES . 'order.php');

class AccountHistoryInfoContentView extends ContentView
{
	function __construct()
	{
		parent::__construct();
		$this->set_content_template('module/account_history_info.html');
		$this->set_flat_assigns(true);
		$this->set_caching_enabled(false);
	}

	function get_html($p_order_id, $p_languages_id, $p_language, $p_customers_id)
	{
		$coo_lang_file_master = MainFactory::create_object('LanguageTextManager', array(), true);
		$t_html_output = '';

		$order = new order((int)$p_order_id);

		// Delivery Info
		if ($order->delivery != false) {
			$this->set_content_data('DELIVERY_LABEL', xtc_address_format($order->delivery['format_id'], $order->delivery, 1, ' ', '<br />'));
			if ($order->info['shipping_method']) { $this->set_content_data('SHIPPING_METHOD', $order->info['shipping_method']); }
		}

		$order_total = $order->getTotalData((int)$p_order_id);

		$this->set_content_data('order_data', $order->getOrderData((int)$p_order_id));
		$this->set_content_data('order_total', $order_total['data']);

		// Payment Method
		if ($order->info['payment_method'] != '' && $order->info['payment_method'] != 'no_payment') {
			switch($order->info['payment_method']) {
				case 'billsafe_3_invoice':
				case 'billsafe_3_installment':
					$bs = MainFactory::create_object('GMBillSafe', array($order->info['payment_method']));
					$pmethod = $bs->getPaymentInfo((int)$p_order_id);
					break;
				default:
					$coo_lang_file_master->init_from_lang_file('lang/' . $p_language . '/modules/payment/' . $order->info['payment_method'] . '.php');
					$pmethod = constant(MODULE_PAYMENT_.strtoupper($order->info['payment_method'])._TEXT_TITLE);
			}

			$this->set_content_data('PAYMENT_METHOD', $pmethod);
		}



		// Order History
		$statuses_query = xtc_db_query("select os.orders_status_name, osh.date_added, osh.comments, osh.customer_notified from ".TABLE_ORDERS_STATUS." os, ".TABLE_ORDERS_STATUS_HISTORY." osh where osh.orders_id = '".(int) $p_order_id."' and osh.orders_status_id = os.orders_status_id and os.language_id = '".(int) $p_languages_id."' order by osh.date_added");
		while ($statuses = xtc_db_fetch_array($statuses_query)) {

			if($statuses['customer_notified'] == '0') {
				$statuses['comments'] ='';
			}
				$history_block .= '<span class="strong">' .  xtc_date_short($statuses['date_added']) . ':</span> '. $statuses['orders_status_name'].' '. (empty ($statuses['comments']) ? ' ' : nl2br(htmlspecialchars_wrapper($statuses['comments']))).''."<br />";
		}

		$this->set_content_data('HISTORY_BLOCK', $history_block);

		// Download-Products
		if (DOWNLOAD_ENABLED == 'true')
		{
			$coo_downloads_view = MainFactory::create_object('DownloadsContentView');
			$t_downloads_html = $coo_downloads_view->get_html($p_order_id, $p_customers_id);
			$this->set_content_data('downloads_content', $t_downloads_html);
		}

		// Stuff
		$this->set_content_data('ORDER_NUMBER', (int)$p_order_id);
		$this->set_content_data('ORDER_DATE', xtc_date_long($order->info['date_purchased']));
		$this->set_content_data('ORDER_STATUS', $order->info['orders_status']);
		$this->set_content_data('BILLING_LABEL', xtc_address_format($order->billing['format_id'], $order->billing, 1, ' ', '<br />'));
		$this->set_content_data('PRODUCTS_EDIT', xtc_href_link(FILENAME_SHOPPING_CART, '', 'SSL'));
		$this->set_content_data('SHIPPING_ADDRESS_EDIT', xtc_href_link(FILENAME_CHECKOUT_SHIPPING_ADDRESS, '', 'SSL'));
		$this->set_content_data('BILLING_ADDRESS_EDIT', xtc_href_link(FILENAME_CHECKOUT_PAYMENT_ADDRESS, '', 'SSL'));
		$this->set_content_data('BUTTON_PRINT', '<a style="cursor:pointer" onclick="javascript:window.open(\''.xtc_href_link(FILENAME_PRINT_ORDER, 'oID='.(int)$p_order_id).'\', \'popup\', \'toolbar=0, width=640, height=600\')"><img src="'.'templates/'.CURRENT_TEMPLATE.'/buttons/'.$p_language.'/button_print.gif"/></a>');
		$this->set_content_data('BUTTON_PRINT_URL', xtc_href_link(FILENAME_PRINT_ORDER, 'oID='.(int)$p_order_id));

		if(gm_get_conf("SHOW_ACCOUNT_WITHDRAWAL_LINK") == "1")
		{
			$t_link = generate_withdrawal_link($order->info['orders_hash']);
			$this->set_content_data('WITHDRAWAL_LINK', $t_link);
		}

		$coo_language_text_manager = MainFactory::create_object('LanguageTextManager', array('withdrawal', $_SESSION['languages_id']));

		if($order->info['abandonment_download'] == 1)
		{
			$this->set_content_data('abandonment_download', $coo_language_text_manager->get_text('text_abandonment_download'));
		}
		if($order->info['abandonment_service'] == 1)
		{
			$this->set_content_data('abandonment_service', $coo_language_text_manager->get_text('text_abandonment_service'));
		}
		
		$t_withdrawal_content_id = gm_get_conf('GM_WITHDRAWAL_CONTENT_ID');

		$this->set_content_data('WITHDRAWAL_WEBFORM_ACTIVE', gm_get_conf('WITHDRAWAL_WEBFORM_ACTIVE'));
		$this->set_content_data('WITHDRAWAL_PDF_ACTIVE', gm_get_conf('WITHDRAWAL_PDF_ACTIVE'));
		$this->set_content_data('PDF_FORM_URL', xtc_href_link('request_port.php', 'module=ShopContent&amp;action=download&amp;coID=' . $t_withdrawal_content_id . '&amp;withdrawal_form=1'));
		
		$from_history = preg_match('/page=/i', xtc_get_all_get_params()); // referer from account_history yes/no
		$back_to = $from_history ? FILENAME_ACCOUNT_HISTORY : FILENAME_ACCOUNT; // if from account_history => return to account_history
		$this->set_content_data('BUTTON_BACK','<a href="' . xtc_href_link($back_to,xtc_get_all_get_params(array ('order_id')), 'SSL') . '">' . xtc_image_button('button_back.gif', IMAGE_BUTTON_BACK) . '</a>');
		$this->set_content_data('BUTTON_BACK_LINK', xtc_href_link($back_to,xtc_get_all_get_params(array ('order_id')), 'SSL'));

		$t_html_output = $this->build_html();

		return $t_html_output;
	}
}
