<?php
/* --------------------------------------------------------------
  AccountPasswordContentView.inc.php 2014-04-24 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2014 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------


  based on:
  (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
  (c) 2002-2003 osCommerce(account_password.php,v 1.1 2003/05/19); www.oscommerce.com
  (c) 2003	 nextcommerce (account_password.php,v 1.14 2003/08/17); www.nextcommerce.org
  (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: account_password.php 1218 2005-09-16 11:38:37Z mz $)

  Released under the GNU General Public License
  --------------------------------------------------------------------------------------- */

class AccountPasswordContentView extends ContentView
{
	protected $error_array = array();

	public function __construct()
	{
		parent::__construct();
		
		$this->set_content_template('module/account_password.html');
		$this->set_flat_assigns(true);
		$this->set_caching_enabled(false);
	}

	protected function set_validation_rules()
	{
		$this->validation_rules_array['error_array'] = array('type' => 'array');
	}
	
	protected function set_deprecated_array()
	{
		$this->deprecated_array[1][] = 'FORM_ACTION';
		$this->deprecated_array[1][] = 'HIDDEN_NAME';
		$this->deprecated_array[1][] = 'HIDDEN_VALUE';
		$this->deprecated_array[1][] = 'BUTTON_BACK';
		$this->deprecated_array[1][] = 'BUTTON_SUBMIT';
		$this->deprecated_array[1][] = 'FORM_END';
		$this->deprecated_array[1][] = 'INPUT_ACTUAL';
		$this->deprecated_array[1][] = 'form_data|password_current|required_symbol';
		$this->deprecated_array[1][] = 'INPUT_NEW';
		$this->deprecated_array[1][] = 'form_data|password_new|required_symbol';
		$this->deprecated_array[1][] = 'INPUT_CONFIRM';
		$this->deprecated_array[1][] = 'form_data|password_confirmation|required_symbol';
	}

	public function prepare_data()
	{
		$this->add_error_messages();
		
		$this->add_data();
	}
	
	protected function add_error_messages()
	{
		if(is_array($this->error_array) && empty($this->error_array) == false)
		{
			foreach($this->error_array AS $t_error => $t_error_text)
			{
				$this->content_array[$t_error] = $t_error_text;
				if($t_error == 'error_confirmation' || $t_error == 'error_password_not_matching')
				{
					$GLOBALS['messageStack']->add('account_password', $t_error_text);
				}
			}
		}
		
		if($GLOBALS['messageStack']->size('account_password') > 0)
		{
			$this->content_array['error'] = $GLOBALS['messageStack']->output('account_password');
		}
	}
	
	protected function add_data()
	{
		if(isset($this->content_array['form_data']) == false)
		{
			$this->content_array['form_data'] = array();
		}
		
		$this->add_form();
		$this->add_password_current();
		$this->add_password_new();
		$this->add_password_confirmation();
	}
	
	protected function add_form()
	{
		$this->content_array['FORM_ACTION'] = xtc_draw_form('account_password', xtc_href_link(FILENAME_ACCOUNT_PASSWORD, '', 'SSL'), 'post', '') . xtc_draw_hidden_field('action', 'process');
		$this->content_array['FORM_ID'] = 'account_password';
		$this->content_array['FORM_ACTION_URL'] = xtc_href_link(FILENAME_ACCOUNT_PASSWORD, '', 'SSL');
		$this->content_array['FORM_METHOD'] = 'post';
		$this->content_array['HIDDEN_NAME'] = 'action';
		$this->content_array['HIDDEN_VALUE'] = 'process';
		
		$this->content_array['form_data']['password_hidden_action'] = array();;
		$this->content_array['form_data']['password_hidden_action']['name'] = 'action';
		$this->content_array['form_data']['password_hidden_action']['value'] = 'process';

		$this->content_array['BUTTON_BACK'] = '<a href="' . xtc_href_link(FILENAME_ACCOUNT, '', 'SSL') . '">' . xtc_image_button('button_back.gif', IMAGE_BUTTON_BACK) . '</a>';
		$this->content_array['BUTTON_BACK_LINK'] = xtc_href_link(FILENAME_ACCOUNT, '', 'SSL');
		$this->content_array['BUTTON_SUBMIT'] = xtc_image_submit('button_continue.gif', IMAGE_BUTTON_CONTINUE);
		$this->content_array['FORM_END'] = '</form>';
	}
	
	protected function add_password_current()
	{
		$this->content_array['INPUT_ACTUAL'] = xtc_draw_password_fieldNote(array('name' => 'password_current', 'text' => '&nbsp;' . (xtc_not_null(ENTRY_PASSWORD_CURRENT_TEXT) ? '<span class="inputRequirement">' . ENTRY_PASSWORD_CURRENT_TEXT . '</span>' : '')));
		
		$this->content_array['form_data']['password_current'] = array();
		$this->content_array['form_data']['password_current']['name'] = 'password_current';
		$this->content_array['form_data']['password_current']['value'] = '';
		$this->content_array['form_data']['password_current']['required'] = 0;
		$this->content_array['form_data']['password_current']['required_symbol'] = ENTRY_PASSWORD_CURRENT_TEXT;
		if((int)ENTRY_PASSWORD_MIN_LENGTH > 0)
		{
			$this->content_array['form_data']['password_current']['required'] = 1;
		}
	}
	
	protected function add_password_new()
	{
		$this->content_array['INPUT_NEW'] = xtc_draw_password_fieldNote(array('name' => 'password_new', 'text' => '&nbsp;' . (xtc_not_null(ENTRY_PASSWORD_NEW_TEXT) ? '<span class="inputRequirement">' . ENTRY_PASSWORD_NEW_TEXT . '</span>' : '')));
		
		$this->content_array['form_data']['password_new'] = array();
		$this->content_array['form_data']['password_new']['name'] = 'password_new';
		$this->content_array['form_data']['password_new']['value'] = '';
		$this->content_array['form_data']['password_new']['required'] = 0;
		$this->content_array['form_data']['password_new']['required_symbol'] = ENTRY_PASSWORD_CURRENT_TEXT;
		if((int)ENTRY_PASSWORD_MIN_LENGTH > 0)
		{
			$this->content_array['form_data']['password_new']['required'] = 1;
		}
	}
	
	protected function add_password_confirmation()
	{
		$this->content_array['INPUT_CONFIRM'] = xtc_draw_password_fieldNote(array('name' => 'password_confirmation', 'text' => '&nbsp;' . (xtc_not_null(ENTRY_PASSWORD_CONFIRMATION_TEXT) ? '<span class="inputRequirement">' . ENTRY_PASSWORD_CONFIRMATION_TEXT . '</span>' : '')));
		
		$this->content_array['form_data']['password_confirmation'] = array();
		$this->content_array['form_data']['password_confirmation']['name'] = 'password_confirmation';
		$this->content_array['form_data']['password_confirmation']['value'] = '';
		$this->content_array['form_data']['password_confirmation']['required'] = 0;
		$this->content_array['form_data']['password_confirmation']['required_symbol'] = ENTRY_PASSWORD_CURRENT_TEXT;
		if((int)ENTRY_PASSWORD_MIN_LENGTH > 0)
		{
			$this->content_array['form_data']['password_confirmation']['required'] = 1;
		}
	}
}