<?php
/* --------------------------------------------------------------
   CreateAccountContentView.inc.php 2014-09-19 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(create_account.php,v 1.63 2003/05/28); www.oscommerce.com
   (c) 2003  nextcommerce (create_account.php,v 1.27 2003/08/24); www.nextcommerce.org
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: create_account.php 1311 2005-10-18 12:30:40Z mz $)

   Released under the GNU General Public License
   -----------------------------------------------------------------------------------------
   Third Party contribution:

   Credit Class/Gift Vouchers/Discount Coupons (Version 5.10)
   http://www.oscommerce.com/community/contributions,282
   Copyright (c) Strider | Strider@oscworks.com
   Copyright (c  Nick Stanko of UkiDev.com, nick@ukidev.com
   Copyright (c) Andre ambidex@gmx.net
   Copyright (c) 2001,2002 Ian C Wilson http://www.phesis.org

   Guest account idea by Ingo T. <xIngox@web.de>

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

// include needed functions
require_once(DIR_FS_INC . 'xtc_get_country_list.inc.php');

class CreateAccountContentView extends ContentView
{
	protected $error_array = array();
	protected $checkout_started = 0;
	protected $checkout_started_param = '';
	protected $guest_account = false;
	protected $customer_data_array = array();
	protected $process = false;


	public function __construct()
	{
		parent::__construct();
		
		$this->set_content_template('module/create_account.html');
		$this->set_flat_assigns(true);
	}
	
	
	protected function set_validation_rules()
	{
		$this->validation_rules_array['customer_data_array']	= array('type' => 'array');
		$this->validation_rules_array['error_array']			= array('type' => 'array');
		$this->validation_rules_array['checkout_started']		= array('type' => 'int');
		$this->validation_rules_array['guest_account']			= array('type' => 'bool');
		$this->validation_rules_array['process']				= array('type' => 'bool');
	}
	
	protected function set_deprecated_array()
	{
		$this->deprecated_array[1][] = 'FORM_ACTION';
		$this->deprecated_array[1][] = 'FORM_END';
		$this->deprecated_array[1][] = 'BUTTON_BACK';
		$this->deprecated_array[1][] = 'LINK_CLOSE';
		$this->deprecated_array[1][] = 'INPUT_MALE';
		$this->deprecated_array[1][] = 'INPUT_MALE_NAME';
		$this->deprecated_array[1][] = 'INPUT_MALE_VALUE';
		$this->deprecated_array[1][] = 'INPUT_FEMALE';
		$this->deprecated_array[1][] = 'INPUT_FEMALE_NAME';
		$this->deprecated_array[1][] = 'INPUT_FEMALE_VALUE';
		$this->deprecated_array[1][] = 'INPUT_FIRSTNAME';
		$this->deprecated_array[1][] = 'INPUT_FIRSTNAME_NAME';
		$this->deprecated_array[1][] = 'INPUT_LASTNAME';
		$this->deprecated_array[1][] = 'INPUT_LASTNAME_NAME';
		$this->deprecated_array[1][] = 'INPUT_DOB';
		$this->deprecated_array[1][] = 'INPUT_DOB_NAME';
		$this->deprecated_array[1][] = 'INPUT_EMAIL';
		$this->deprecated_array[1][] = 'INPUT_EMAIL_NAME';
		$this->deprecated_array[1][] = 'INPUT_EMAIL_CONFIRM';
		$this->deprecated_array[1][] = 'INPUT_EMAIL_CONFIRM_NAME';
		$this->deprecated_array[1][] = 'INPUT_COMPANY';
		$this->deprecated_array[1][] = 'INPUT_COMPANY_NAME';
		$this->deprecated_array[1][] = 'INPUT_VAT';
		$this->deprecated_array[1][] = 'INPUT_VAT_NAME';
		$this->deprecated_array[1][] = 'INPUT_STREET';
		$this->deprecated_array[1][] = 'INPUT_STREET_NAME';
		$this->deprecated_array[1][] = 'INPUT_SUBURB';
		$this->deprecated_array[1][] = 'INPUT_SUBURB_NAME';
		$this->deprecated_array[1][] = 'INPUT_CODE';
		$this->deprecated_array[1][] = 'INPUT_CODE_NAME';
		$this->deprecated_array[1][] = 'INPUT_CITY';
		$this->deprecated_array[1][] = 'INPUT_CITY_NAME';
		$this->deprecated_array[1][] = 'INPUT_STATE';
		$this->deprecated_array[1][] = 'SELECT_COUNTRY';
		$this->deprecated_array[1][] = 'INPUT_TEL';
		$this->deprecated_array[1][] = 'INPUT_TEL_NAME';
		$this->deprecated_array[1][] = 'INPUT_FAX';
		$this->deprecated_array[1][] = 'INPUT_FAX_NAME';
		$this->deprecated_array[1][] = 'INPUT_PASSWORD';
		$this->deprecated_array[1][] = 'INPUT_PASSWORD_NAME';
		$this->deprecated_array[1][] = 'INPUT_CONFIRMATION';
		$this->deprecated_array[1][] = 'INPUT_CONFIRMATION_NAME';
		$this->deprecated_array[1][] = 'form_data|gender|required_symbol';
		$this->deprecated_array[1][] = 'form_data|firstname|required_symbol';
		$this->deprecated_array[1][] = 'form_data|lastname|required_symbol';
		$this->deprecated_array[1][] = 'form_data|birthdate|required_symbol';
		$this->deprecated_array[1][] = 'form_data|email|required_symbol';
		$this->deprecated_array[1][] = 'form_data|email_confirm|required_symbol';
		$this->deprecated_array[1][] = 'form_data|company|required_symbol';
		$this->deprecated_array[1][] = 'form_data|vat|required_symbol';
		$this->deprecated_array[1][] = 'form_data|street_address|required_symbol';
		$this->deprecated_array[1][] = 'form_data|suburb|required_symbol';
		$this->deprecated_array[1][] = 'form_data|postcode|required_symbol';
		$this->deprecated_array[1][] = 'form_data|city|required_symbol';
		$this->deprecated_array[1][] = 'form_data|state|required_symbol';
		$this->deprecated_array[1][] = 'form_data|country|required_symbol';
		$this->deprecated_array[1][] = 'form_data|telephone|required_symbol';
		$this->deprecated_array[1][] = 'form_data|fax|required_symbol';
		$this->deprecated_array[1][] = 'form_data|password|required_symbol';
	}

	
	public function prepare_data()
	{
		$this->add_error_messages();
		$this->set_checkout_started_param();
		$this->add_data();
	}

	
	protected function add_data()
	{
		if(is_array($this->content_array['form_data']) == false)
		{
			$this->content_array['form_data'] = array();
		}
		
		$this->add_form();
		$this->add_gender();
		$this->add_firstname();
		$this->add_lastname();
		$this->add_birthdate();
		$this->add_email();
		$this->add_email_confirm();
		$this->add_company();
		$this->add_vat();
		$this->add_street_address();
		$this->add_suburb();
		$this->add_postcode();
		$this->add_city();
		$this->add_state();
		$this->add_country();
		$this->add_telephone();
		$this->add_fax();
		$this->add_password();
		$this->add_privacy();
	}


	protected function add_error_messages()
	{
		if(is_array($this->error_array) && empty($this->error_array) == false)
		{
			foreach($this->error_array AS $t_error => $t_error_text)
			{
				$this->content_array[$t_error] = $t_error_text;
				$GLOBALS['messageStack']->add('create_account', $t_error_text);
			}

			if($GLOBALS['messageStack']->size('create_account') > 0)
			{
				$this->content_array['error'] = $GLOBALS['messageStack']->output('create_account');
			}
		}
	}


	protected function set_checkout_started_param()
	{
		if($this->checkout_started == 1)
		{
			$this->checkout_started_param = 'checkout_started=1';
		}
	}
	

	protected function add_form()
	{
		$t_form_action = xtc_href_link(FILENAME_CREATE_ACCOUNT, $this->checkout_started_param, 'SSL');
		if($this->guest_account)
		{
			$t_form_action = xtc_href_link(FILENAME_CREATE_GUEST_ACCOUNT, $this->checkout_started_param, 'SSL');
		}
		
		$this->content_array['FORM_ID'] = 'create_account';
		$this->content_array['FORM_METHOD'] = 'post';
		$this->content_array['FORM_ACTION_URL'] = $t_form_action;
		
		$this->content_array['FORM_ACTION'] = xtc_draw_form(
											   'create_account',
											   $t_form_action,
											   'post',
											   ''
										   ) . xtc_draw_hidden_field('action', 'process'
		);

		$this->content_array['FORM_END'] = '</form>';

		$this->content_array['CHECKOUT_STARTED'] = $this->checkout_started;


		$this->content_array['LIGHTBOX'] = gm_get_conf('GM_LIGHTBOX_CREATE_ACCOUNT');
		$this->content_array['BUTTON_BACK'] = '<a href="' . xtc_href_link(FILENAME_LOGIN, $this->checkout_started_param, 'SSL') . '"><img src="templates/' . CURRENT_TEMPLATE . '/buttons/' . $_SESSION['language'] . '/button_back.gif" alt="' . IMAGE_BUTTON_BACK . '" title="' . IMAGE_BUTTON_BACK . '" border="0" /></a>';
		$this->content_array['BUTTON_BACK_LINK'] = xtc_href_link(FILENAME_LOGIN, $this->checkout_started_param, 'SSL');
		$this->content_array['LINK_CLOSE'] = xtc_href_link(FILENAME_DEFAULT);

		$this->content_array['LIGHTBOX_CLOSE'] = xtc_href_link(FILENAME_LOGIN, '', 'NONSSL');
		
		$this->content_array['HIDDEN_FIELD_NAME'] = 'action';
		$this->content_array['HIDDEN_FIELD_VALUE'] = 'process';
	}


	protected function add_gender()
	{
		if(ACCOUNT_GENDER == 'true')
		{
			$this->content_array['gender'] = '1';
			
			$t_male = $this->customer_data_array['gender'] == 'm';
			$t_female = !$t_male;

			$this->content_array['INPUT_MALE'] = xtc_draw_radio_field(
													array(
														'name' => 'gender',
														'suffix' => MALE
													),
													'm',
													$t_male
			);
			$this->content_array['INPUT_MALE_NAME'] = 'gender';
			$this->content_array['INPUT_MALE_VALUE'] = 'm';

			$t_field_text = '';
			if(xtc_not_null(ENTRY_GENDER_TEXT))
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_GENDER_TEXT . '</span>';
			}
			$this->content_array['INPUT_FEMALE'] = xtc_draw_radio_field(
														array(
															'name' => 'gender',
															'suffix' => FEMALE,
															'text' => $t_field_text
														),
														'f',
														$t_female
			);
			$this->content_array['INPUT_FEMALE_NAME'] = 'gender';
			$this->content_array['INPUT_FEMALE_VALUE'] = 'f';

			$this->content_array['form_data']['gender'] = array();
			$this->content_array['form_data']['gender']['m'] = array();
			$this->content_array['form_data']['gender']['f'] = array();
			$this->content_array['form_data']['gender']['name'] = 'gender';
			$this->content_array['form_data']['gender']['m']['value'] = 'm';
			$this->content_array['form_data']['gender']['f']['value'] = 'f';
			$this->content_array['form_data']['gender']['m']['checked'] = '0';
			$this->content_array['form_data']['gender']['f']['checked'] = '0';

			if($this->customer_data_array['gender'] == 'm')
			{
				$this->content_array['form_data']['gender']['m']['checked'] = '1';
			}
			if($this->customer_data_array['gender'] == 'f')
			{
				$this->content_array['form_data']['gender']['f']['checked'] = '1';
			}

			$this->content_array['form_data']['gender']['required'] = 1;
			$this->content_array['form_data']['gender']['required_symbol'] = ENTRY_GENDER_TEXT;
		}
		else
		{
			$this->content_array['gender'] = '0';
		}
	}


	protected function add_firstname()
	{
		$t_field_text = '';
		if(xtc_not_null(ENTRY_FIRST_NAME_TEXT))
		{
			$t_field_text = '<span class="inputRequirement">' . ENTRY_FIRST_NAME_TEXT . '</span>';
		}
		$this->content_array['INPUT_FIRSTNAME'] =  xtc_draw_input_fieldNote(
														array(
															'name' => 'firstname',
															'text' => '&nbsp;' . $t_field_text
														),
														htmlspecialchars_wrapper($this->customer_data_array['firstname']),
														'',
														'text',
														true,
														'gm_mb_input inactive_input'
		);
		$this->content_array['INPUT_FIRSTNAME_NAME'] = 'firstname';
		$this->content_array['form_data']['firstname'] = array();
		$this->content_array['form_data']['firstname']['name'] = 'firstname';
		$this->content_array['form_data']['firstname']['value'] = htmlspecialchars_wrapper($this->customer_data_array['firstname']);
		$this->content_array['form_data']['firstname']['required'] = 0;
		$this->content_array['form_data']['firstname']['required_symbol'] = ENTRY_FIRST_NAME_TEXT;
		if((int)ENTRY_FIRST_NAME_MIN_LENGTH > 0)
		{
			$this->content_array['form_data']['firstname']['required'] = 1;
		}
	}


	protected function add_lastname()
	{
		$t_field_text = '';
		if(xtc_not_null(ENTRY_LAST_NAME_TEXT))
		{
			$t_field_text = '<span class="inputRequirement">' . ENTRY_LAST_NAME_TEXT . '</span>';
		}
		$this->content_array['INPUT_LASTNAME'] = xtc_draw_input_fieldNote(
													array(
														'name' => 'lastname',
														'text' => '&nbsp;' . $t_field_text
													),
													htmlspecialchars_wrapper($this->customer_data_array['lastname']),
													'',
													'text',
													true,
													'gm_mb_input inactive_input'
		);
		$this->content_array['INPUT_LASTNAME_NAME'] = 'lastname';
		$this->content_array['form_data']['lastname'] = array();
		$this->content_array['form_data']['lastname']['name'] = 'lastname';
		$this->content_array['form_data']['lastname']['value'] = htmlspecialchars_wrapper($this->customer_data_array['lastname']);
		$this->content_array['form_data']['lastname']['required'] = 0;
		$this->content_array['form_data']['lastname']['required_symbol'] = ENTRY_LAST_NAME_TEXT;
		if((int)ENTRY_LAST_NAME_MIN_LENGTH > 0)
		{
			$this->content_array['form_data']['lastname']['required'] = 1;
		}
	}
	
	
	protected function add_birthdate()
	{
		if(ACCOUNT_DOB == 'true')
		{
			$this->content_array['birthdate'] = '1';
			$t_field_text = '<span class="inputRequirement">' . str_replace('* ', '', ENTRY_DATE_OF_BIRTH_TEXT) . '</span>';
			if(ENTRY_DATE_OF_BIRTH_TEXT)
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_DATE_OF_BIRTH_TEXT . '</span>';
			}
			$this->content_array['INPUT_DOB'] = xtc_draw_input_fieldNote(
													array(
														'name' => 'dob',
														'text' => '&nbsp;' . $t_field_text
													),
													htmlspecialchars_wrapper($this->customer_data_array['dob']),
													'',
													'text',
													true,
													'gm_mb_input inactive_input'
			);
			$this->content_array['INPUT_DOB_NAME'] = 'dob';
			$this->content_array['form_data']['birthdate'] = array();
			$this->content_array['form_data']['birthdate']['name'] = 'dob';
			$this->content_array['form_data']['birthdate']['value'] = htmlspecialchars_wrapper($this->customer_data_array['dob']);
			$this->content_array['form_data']['birthdate']['required'] = 0;
			$this->content_array['form_data']['birthdate']['required_symbol'] = ENTRY_DATE_OF_BIRTH_TEXT;
			if((int)ENTRY_DOB_MIN_LENGTH > 0)
			{
				$this->content_array['form_data']['birthdate']['required'] = 1;
			}
		}
		else
		{
			$this->content_array['birthdate'] = '0';
		}
	}
	
	protected function add_email()
	{
		$t_field_text = '';
		if(xtc_not_null(ENTRY_EMAIL_ADDRESS_TEXT))
		{
			$t_field_text = '<span class="inputRequirement">' . ENTRY_EMAIL_ADDRESS_TEXT . '</span>';
		}
		$this->content_array['INPUT_EMAIL'] = xtc_draw_input_fieldNote(
													array(
														'name' => 'email_address',
														'text' => '&nbsp;' . $t_field_text
													),
													htmlspecialchars_wrapper($this->customer_data_array['email_address']),
													'',
													'text',
													true,
													'gm_mb_input inactive_input'
		);
		$this->content_array['INPUT_EMAIL_NAME'] = 'email_address';
		$this->content_array['form_data']['email'] = array();
		$this->content_array['form_data']['email']['name'] = 'email_address';
		$this->content_array['form_data']['email']['value'] = htmlspecialchars_wrapper($this->customer_data_array['email_address']);
		$this->content_array['form_data']['email']['required'] = 0;
		$this->content_array['form_data']['email']['required_symbol'] = ENTRY_EMAIL_ADDRESS_TEXT;
		if((int)ENTRY_EMAIL_ADDRESS_MIN_LENGTH > 0)
		{
			$this->content_array['form_data']['email']['required'] = 1;
		}
	}
	
	
	protected function add_email_confirm()
	{
		$t_field_text = '';
		if(xtc_not_null(ENTRY_EMAIL_ADDRESS_TEXT))
		{
			$t_field_text = '<span class="inputRequirement">' . ENTRY_EMAIL_ADDRESS_TEXT . '</span>';
		}
		$this->content_array['INPUT_EMAIL_CONFIRM'] = xtc_draw_input_fieldNote(
															array(
																'name' => 'email_address_confirm',
																'text' => '&nbsp;' . $t_field_text
															),
															htmlspecialchars_wrapper($this->customer_data_array['email_address_confirm']),
															'',
															'text',
															true,
															'gm_mb_input inactive_input'
		);
		$this->content_array['INPUT_EMAIL_CONFIRM_NAME'] = 'email_address_confirm';
		$this->content_array['form_data']['email_confirm'] = array();
		$this->content_array['form_data']['email_confirm']['name'] = 'email_address_confirm';
		$this->content_array['form_data']['email_confirm']['value'] = htmlspecialchars_wrapper($this->customer_data_array['email_address_confirm']);
		$this->content_array['form_data']['email_confirm']['required'] = 0;
		$this->content_array['form_data']['email_confirm']['required_symbol'] = ENTRY_EMAIL_ADDRESS_TEXT;
		if((int)ENTRY_EMAIL_ADDRESS_MIN_LENGTH > 0)
		{
			$this->content_array['form_data']['email_confirm']['required'] = 1;
		}
	}
	
	
	protected function add_company()
	{
		if(ACCOUNT_COMPANY == 'true')
		{
			$this->content_array['company'] = '1';
			$t_field_text = '';
			if(xtc_not_null(ENTRY_COMPANY_TEXT))
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_COMPANY_TEXT . '</span>';
			}
			$this->set_content_data('INPUT_COMPANY', xtc_draw_input_fieldNote(
													   array(
														   'name' => 'company',
														   'text' => '&nbsp;' . $t_field_text
													   ),
													   htmlspecialchars_wrapper($this->customer_data_array['company']),
													   '',
													   'text',
													   true,
													   'gm_mb_input inactive_input')
			);
			$this->content_array['INPUT_COMPANY_NAME'] = 'company';
			$this->content_array['form_data']['company'] = array();
			$this->content_array['form_data']['company']['name'] = 'company';
			$this->content_array['form_data']['company']['value'] = htmlspecialchars_wrapper($this->customer_data_array['company']);
			$this->content_array['form_data']['company']['required'] = 0;
			$this->content_array['form_data']['company']['required_symbol'] = ENTRY_COMPANY_TEXT;
		}
		else
		{
			$this->content_array['company'] = '0';
		}
	}
	
	
	protected function add_vat()
	{
		if(ACCOUNT_COMPANY_VAT_CHECK == 'true')
		{
			$this->content_array['vat'] = '1';
			$t_field_text = '';
			if(xtc_not_null(ENTRY_VAT_TEXT))
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_VAT_TEXT . '</span>';
			}
			$this->content_array['INPUT_VAT'] = xtc_draw_input_fieldNote(
												array(
													'name' => 'vat',
													'text' => '&nbsp;' . $t_field_text
												),
												htmlspecialchars_wrapper($this->customer_data_array['vat']),
												'',
												'text',
												true,
												'gm_mb_input inactive_input'
			);
			$this->content_array['INPUT_VAT_NAME'] = 'vat';
			$this->content_array['form_data']['vat'] = array();
			$this->content_array['form_data']['vat']['name'] = 'vat';
			$this->content_array['form_data']['vat']['value'] = htmlspecialchars_wrapper($this->customer_data_array['vat']);
			$this->content_array['form_data']['vat']['required'] = 0;
			$this->content_array['form_data']['vat']['required_symbol'] = ENTRY_VAT_TEXT;
		}
		else
		{
			$this->content_array['vat'] = '0';
		}
	}
	
	protected function add_street_address()
	{
		$t_field_text = '';
		if(xtc_not_null(ENTRY_STREET_ADDRESS_TEXT))
		{
			$t_field_text = '<span class="inputRequirement">' . ENTRY_STREET_ADDRESS_TEXT . '</span>';
		}
		$this->content_array['INPUT_STREET'] = xtc_draw_input_fieldNote(
													array(
														'name' => 'street_address',
														'text' => '&nbsp;' . $t_field_text
													),
													htmlspecialchars_wrapper($this->customer_data_array['street_address']),
													'',
													'text',
													true,
													'gm_mb_input inactive_input'
		);
		$this->content_array['INPUT_STREET_NAME'] = 'street_address';
		$this->content_array['form_data']['street_address'] = array();
		$this->content_array['form_data']['street_address']['name'] = 'street_address';
		$this->content_array['form_data']['street_address']['value'] = htmlspecialchars_wrapper($this->customer_data_array['street_address']);
		$this->content_array['form_data']['street_address']['required'] = 0;
		$this->content_array['form_data']['street_address']['required_symbol'] = ENTRY_STREET_ADDRESS_TEXT;
		if((int)ENTRY_STREET_ADDRESS_MIN_LENGTH > 0)
		{
			$this->content_array['form_data']['street_address']['required'] = 1;
		}
	}
	
	
	protected function add_suburb()
	{
		if(ACCOUNT_SUBURB == 'true')
		{
			$this->content_array['suburb'] = '1';
			$t_field_text = '';
			if(xtc_not_null(ENTRY_SUBURB_TEXT))
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_SUBURB_TEXT . '</span>';
			}
			$this->content_array['INPUT_SUBURB'] = xtc_draw_input_fieldNote(
														array(
															'name' => 'suburb',
															'text' => '&nbsp;' . $t_field_text
														),
														htmlspecialchars_wrapper($this->customer_data_array['suburb']),
														'',
														'text',
														true,
														'gm_mb_input inactive_input'
			);
			$this->content_array['INPUT_SUBURB_NAME'] = 'suburb';
			$this->content_array['form_data']['suburb'] = array();
			$this->content_array['form_data']['suburb']['name'] = 'suburb';
			$this->content_array['form_data']['suburb']['value'] = htmlspecialchars_wrapper($this->customer_data_array['suburb']);
			$this->content_array['form_data']['suburb']['required'] = 0;
			$this->content_array['form_data']['suburb']['required_symbol'] = ENTRY_STREET_ADDRESS_TEXT;
		}
		else
		{
			$this->content_array['suburb'] = '0';
		}
	}
	
	
	protected function add_postcode()
	{
		$t_field_text = '';
		if(xtc_not_null(ENTRY_POST_CODE_TEXT))
		{
			$t_field_text = '<span class="inputRequirement">' . ENTRY_POST_CODE_TEXT . '</span>';
		}
		$this->content_array['INPUT_CODE'] = xtc_draw_input_fieldNote(
												array(
													'name' => 'postcode',
													'text' => '&nbsp;' . $t_field_text
												),
												htmlspecialchars_wrapper($this->customer_data_array['postcode']),
												'',
												'text',
												true,
												'gm_mb_input inactive_input'
		);
		$this->content_array['INPUT_CODE_NAME'] = 'postcode';
		$this->content_array['form_data']['postcode'] = array();
		$this->content_array['form_data']['postcode']['name'] = 'postcode';
		$this->content_array['form_data']['postcode']['value'] = htmlspecialchars_wrapper($this->customer_data_array['postcode']);
		$this->content_array['form_data']['postcode']['required'] = 0;
		$this->content_array['form_data']['postcode']['required_symbol'] = ENTRY_POSTCODE_TEXT;
		if((int)ENTRY_POSTCODE_MIN_LENGTH > 0)
		{
			$this->content_array['form_data']['postcode']['required'] = 1;
		}
	}
	
	
	protected function add_city()
	{
		$t_field_text = '';
		if(xtc_not_null(ENTRY_CITY_TEXT))
		{
			$t_field_text = '<span class="inputRequirement">' . ENTRY_CITY_TEXT . '</span>';
		}
		$this->content_array['INPUT_CITY'] = xtc_draw_input_fieldNote(
												array(
													'name' => 'city',
													'text' => '&nbsp;' . $t_field_text
												),
												htmlspecialchars_wrapper($this->customer_data_array['city']),
												'',
												'text',
												true,
												'gm_mb_input inactive_input'
		);
		$this->content_array['INPUT_CITY_NAME'] = 'city';
		$this->content_array['form_data']['city'] = array();
		$this->content_array['form_data']['city']['name'] = 'city';
		$this->content_array['form_data']['city']['value'] = htmlspecialchars_wrapper($this->customer_data_array['city']);
		$this->content_array['form_data']['city']['required'] = 0;
		$this->content_array['form_data']['city']['required_symbol'] = ENTRY_CITY_TEXT;
		if((int)ENTRY_CITY_MIN_LENGTH > 0)
		{
			$this->content_array['form_data']['city']['required'] = 1;
		}
	}
	
	
	protected function add_state()
	{
		if(ACCOUNT_STATE == 'true')
		{
			$this->content_array['state'] = '1';

			$this->content_array['form_data']['state'] = array();
			$this->content_array['form_data']['state']['required'] = 0;
			$this->content_array['form_data']['state']['required_symbol'] = ENTRY_STATE_TEXT;
			if((int)ENTRY_STATE_MIN_LENGTH > 0)
			{
				$this->content_array['form_data']['state']['required'] = 1;
			}

			if($this->process == true)
			{
				if($this->customer_data_array['entry_state_has_zones'] == true)
				{
					$t_field_text = '';
					if(xtc_not_null(ENTRY_STATE_TEXT))
					{
						$t_field_text = '<span class="inputRequirement">' . ENTRY_STATE_TEXT . '</span>';
					}
					$state_input = xtc_draw_pull_down_menuNote(
										array(
											'name' => 'state',
											'text' => '&nbsp;' . $t_field_text
										),
										$this->customer_data_array['zones_array']
					);

					$this->content_array['form_data']['state']['name'] = 'state';
					$this->content_array['form_data']['state']['type'] = 'selection';
					$this->content_array['form_data']['state']['value'] = htmlspecialchars_wrapper($this->customer_data_array['state']);
					$this->content_array['zones_data'] = $this->customer_data_array['zones_array'];
				}
				else
				{
					$t_field_text = '';
					if(xtc_not_null(ENTRY_STATE_TEXT))
					{
						$t_field_text = '<span class="inputRequirement">' . ENTRY_STATE_TEXT . '</span>';
					}
					$state_input = xtc_draw_input_fieldNote(
										array(
											'name' => 'state',
											'text' => '&nbsp;' . $t_field_text
										),
										'',
										'',
										'text',
										true,
										'gm_mb_input inactive_input'
					);

					$this->content_array['form_data']['state']['name'] = 'state';
					$this->content_array['form_data']['state']['value'] = '';
					$this->content_array['form_data']['state']['type'] = 'input';
				}
			}
			else
			{
				$t_field_text = '';
				if(xtc_not_null(ENTRY_STATE_TEXT))
				{
					$t_field_text = '<span class="inputRequirement">' . ENTRY_STATE_TEXT . '</span>';
				}
				$state_input = xtc_draw_input_fieldNote(
									array(
										'name' => 'state',
										'text' => '&nbsp;' . $t_field_text
									),
									'',
									'',
									'text',
									true,
									'gm_mb_input inactive_input'
				);

				$this->content_array['form_data']['state']['name'] = 'state';
				$this->content_array['form_data']['state']['value'] = '';
				$this->content_array['form_data']['state']['type'] = 'input';
			}

			$this->content_array['INPUT_STATE'] = $state_input;
		}
		else
		{
			$this->content_array['state'] = '0';
		}
	}
	
	
	protected function add_country()
	{
		if(isset($this->customer_data_array['country']))
		{
			$t_selected = htmlspecialchars_wrapper($this->customer_data_array['country']);
		}
		else
		{
			$t_selected = htmlspecialchars_wrapper(STORE_COUNTRY);
		}

		$t_field_text = '';
		if(xtc_not_null(ENTRY_COUNTRY_TEXT))
		{
			$t_field_text = '<span class="inputRequirement">' . ENTRY_COUNTRY_TEXT . '</span>';
		}
		$this->content_array['SELECT_COUNTRY'] = xtc_get_country_list(
													array(
														'name' => 'country',
														'text' => '&nbsp;' . $t_field_text
													),
													$t_selected
		);
		$this->content_array['form_data']['country'] = array();
		$this->content_array['form_data']['country']['name'] = 'country';
		$this->content_array['form_data']['country']['value'] = $t_selected;
		$this->content_array['form_data']['country']['required'] = 1;
		$this->content_array['form_data']['country']['required_symbol'] = ENTRY_COUNTRY_TEXT;
		$this->content_array['countries_data'] = xtc_get_countriesList();
	}
	
	
	protected function add_telephone()
	{
		$this->content_array['telephone'] = '0';
		
		if(ACCOUNT_TELEPHONE == 'true')
		{
			$this->content_array['telephone'] = '1';
			
			$t_field_text = '';
			if(ENTRY_TELEPHONE_MIN_LENGTH != 0)
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_TELEPHONE_NUMBER_TEXT . '</span>';
			}
			$this->content_array['INPUT_TEL'] = xtc_draw_input_fieldNote(
													array(
														'name' => 'telephone',
														'text' => '&nbsp;' . $t_field_text
													),
													htmlspecialchars_wrapper($this->customer_data_array['telephone']),
													'',
													'text',
													true,
													'gm_mb_input inactive_input'
			);
			$this->content_array['INPUT_TEL_NAME'] = 'telephone';
			$this->content_array['form_data']['telephone'] = array();
			$this->content_array['form_data']['telephone']['name'] = 'telephone';
			$this->content_array['form_data']['telephone']['value'] = htmlspecialchars_wrapper($this->customer_data_array['telephone']);
			$this->content_array['form_data']['telephone']['required'] = 0;
			$this->content_array['form_data']['telephone']['required_symbol'] = ENTRY_TELEPHONE_NUMBER_TEXT;
			if((int)ENTRY_TELEPHONE_MIN_LENGTH > 0)
			{
				$this->content_array['form_data']['telephone']['required'] = 1;
			}
		}
	}
	
	
	protected function add_fax()
	{
		$this->content_array['fax'] = '0';

		if(ACCOUNT_FAX == 'true')
		{
			$this->content_array['fax'] = '1';
			
			$t_field_text = '';
			if(xtc_not_null(ENTRY_FAX_NUMBER_TEXT))
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_FAX_NUMBER_TEXT . '</span>';
			}
			$this->content_array['INPUT_FAX'] = xtc_draw_input_fieldNote(
													array(
														'name' => 'fax',
														'text' => '&nbsp;' . $t_field_text
													),
													htmlspecialchars_wrapper($this->customer_data_array['fax']),
													'',
													'text',
													true,
													'gm_mb_input inactive_input'
			);
			$this->content_array['INPUT_FAX_NAME'] = 'fax';
			$this->content_array['form_data']['fax'] = array();
			$this->content_array['form_data']['fax']['name'] = 'fax';
			$this->content_array['form_data']['fax']['value'] = htmlspecialchars_wrapper($this->customer_data_array['fax']);
			$this->content_array['form_data']['fax']['required'] = 0;
			$this->content_array['form_data']['fax']['required_symbol'] = ENTRY_TELEPHONE_NUMBER_TEXT;
		}
	}
	
	
	protected function add_password()
	{
		if($this->guest_account === false)
		{
			$t_field_text = '';
			if(xtc_not_null(ENTRY_PASSWORD_TEXT))
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_PASSWORD_TEXT . '</span>';
			}
			$this->content_array['INPUT_PASSWORD'] = xtc_draw_password_fieldNote(
														array(
															'name' => 'password',
															'text' => '&nbsp;' . $t_field_text
														),
														'',
														'',
														'gm_mb_input inactive_input'
			);
			$this->content_array['INPUT_PASSWORD_NAME'] = 'password';
			$this->content_array['form_data']['password'] = array();
			$this->content_array['form_data']['password']['name'] = 'password';
			$this->content_array['form_data']['password']['required'] = 1;
			$this->content_array['form_data']['password']['required_symbol'] = ENTRY_PASSWORD_TEXT;

			$t_field_text = '';
			if(xtc_not_null(ENTRY_PASSWORD_CONFIRMATION_TEXT))
			{
				$t_field_text = '<span class="inputRequirement">' . ENTRY_PASSWORD_CONFIRMATION_TEXT . '</span>';
			}
			$this->content_array['INPUT_CONFIRMATION'] = xtc_draw_password_fieldNote(
															array(
																'name' => 'confirmation',
																'text' => '&nbsp;' . $t_field_text
															),
															'',
															'',
															'gm_mb_input inactive_input'
			);
			$this->content_array['INPUT_CONFIRMATION_NAME'] = 'confirmation';
			$this->content_array['form_data']['confirmation']['name'] = 'confirmation';
		}
	}


	protected function add_privacy()
	{
		if(gm_get_conf('GM_SHOW_PRIVACY_REGISTRATION'))
		{
			$this->content_array['show_privacy'] = 1;
			$this->content_array['PRIVACY_LINK'] = gm_get_privacy_link('GM_SHOW_PRIVACY_REGISTRATION');
		}
	}
}