<?php
/* --------------------------------------------------------------
   DeleteGuestAccountsAjaxHandler.inc.php 2014-03-18 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

require_once(DIR_FS_CATALOG . 'gm/classes/JSON.php');

class DeleteGuestAccountsAjaxHandler extends AjaxHandler
{
	function get_permission_status($p_customers_id = NULL)
    {
		return true;
    }

	function proceed()
	{
		if($this->get_secure_token() != $this->v_data_array['GET']['token'])
		{
			return false;
		}
		
		$coo_logoff = MainFactory::create_object('LogoffContentControl');
		$coo_logoff->delete_unused_guest_accounts();
		$this->v_output_buffer = 'true';
		
		// add infobox message, if script is called from backend
		if(strpos(gm_get_env_info('SCRIPT_NAME'), DIR_WS_CATALOG . 'admin') !== false)
		{
			$coo_language = new language();
			$t_messages_array = array();
			$t_headline_array = array();
			$coo_infobox = MainFactory::create_object('AdminInfoboxControl');
			foreach($coo_language->catalog_languages AS $t_language_array)
			{
				$coo_text_mgr = MainFactory::create_object('LanguageTextManager', array('admin_info_boxes', $t_language_array['id']));
				$t_messages_array[$t_language_array['id']] = $coo_text_mgr->get_text('guest_accounts_deleted_message');
				$t_headline_array[$t_language_array['id']] = $coo_text_mgr->get_text('guest_accounts_deleted_heading');
			}

			$coo_infobox->add_message($t_messages_array, 'success', $t_headline_array, array(), '', 'removable', 'new', 'guest_accounts_deleted', 'intern', false, true);
		}		
		
		return true;
	}
	
	function get_secure_token()
	{
		$t_token = LogControl::get_secure_token();
		$t_token = md5($t_token);
		
		return $t_token;
	}
}
