<?php

/* --------------------------------------------------------------
  CheckoutAddressContentView.inc.php 2014-04-24 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2014 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------


  based on:
  (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
  (c) 2002-2003 osCommerce(checkout_shipping_address.php,v 1.14 2003/05/27); www.oscommerce.com
  (c) 2003	 nextcommerce (checkout_shipping_address.php,v 1.14 2003/08/17); www.nextcommerce.org
  (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: checkout_shipping_address.php 867 2005-04-21 18:35:29Z mz $)

  Released under the GNU General Public License
  --------------------------------------------------------------------------------------- */

// include needed functions
require_once(DIR_FS_INC . 'xtc_address_label.inc.php');
require_once(DIR_FS_INC . 'xtc_get_address_format_id.inc.php');
require_once(DIR_FS_INC . 'xtc_address_format.inc.php');

class CheckoutAddressContentView extends ContentView
{
	protected $address_book_id;
	protected $coo_order;
	protected $customer_id;
	protected $error_message;
	protected $language;
	protected $page_type;

	public function __construct()
	{
		parent::__construct();
		
		$this->set_flat_assigns(true);
		$this->set_caching_enabled(false);
	}

	protected function set_validation_rules()
	{
		$this->validation_rules_array['address_book_id']	= array('type' => 'int');
		$this->validation_rules_array['customer_id']		= array('type' => 'int');
		$this->validation_rules_array['error_message']		= array('type' => 'string');
		$this->validation_rules_array['language']			= array('type' => 'string');
		$this->validation_rules_array['page_type']			= array('type' => 'string');
		$this->validation_rules_array['coo_order']			= array('type' => 'object',
																	'object_type' => 'order');
	}
	
	public function get_html($p_process)
	{
		$t_html_output = '';
		$t_uninitialized_array = $this->get_uninitialized_variables(array('address_book_id',
																			'coo_order',
																			'customer_id',
																			'error_message',
																			'language',
																			'page_type'));
		if(empty($t_uninitialized_array))
		{			
			if($this->page_type == 'shipping')
			{
				$this->set_content_template('module/checkout_shipping_address.html');
				$t_filename_checkout_address = FILENAME_CHECKOUT_SHIPPING_ADDRESS;
				$t_filename_checkout = FILENAME_CHECKOUT_SHIPPING;
			}
			elseif($this->page_type == 'payment')
			{
				$this->set_content_template('module/checkout_payment_address.html');
				$t_filename_checkout_address = FILENAME_CHECKOUT_PAYMENT_ADDRESS;
				$t_filename_checkout = FILENAME_CHECKOUT_PAYMENT;
			}
			
			$t_addresses_count = xtc_count_customer_address_book_entries();
			
			$this->set_content_data('FORM_ACTION', xtc_draw_form('checkout_address', xtc_href_link($t_filename_checkout_address, '', 'SSL'), 'post', ''));
			
			$t_error_message = $this->error_message;
			if(empty($t_error_message) == false)
			{
				$this->set_content_data('error', $this->error_message);
			}

			if($p_process == false)
			{
				$this->set_content_data('ADDRESS_LABEL', xtc_address_label($this->customer_id, $this->address_book_id, true, ' ', '<br />'));

				if($t_addresses_count > 1)
				{
					$t_address_html = '<table class="checkout_addresses" border="0" width="100%" cellspacing="0" cellpadding="0">';
					$count_radio_buttons = 0;
					$t_unallowed_classes_array = array();
					$t_unallowed_classes_array[] = 'packstation';
					$t_unallowed_classes_array[] = 'postfiliale';
					
					$addresses_query = xtc_db_query("SELECT 
														address_class, 
														address_book_id, 
														entry_firstname AS firstname, 
														entry_lastname AS lastname, 
														entry_company AS company, 
														entry_street_address AS street_address, 
														entry_suburb AS suburb, 
														entry_city AS city, 
														entry_postcode AS postcode, 
														entry_state AS state, 
														entry_zone_id AS zone_id, 
														entry_country_id AS country_id
													FROM " . TABLE_ADDRESS_BOOK . " 
													WHERE customers_id = '" . $this->customer_id . "'");
					while($t_addresses_array = xtc_db_fetch_array($addresses_query))
					{
						if($this->page_type == 'payment' &&
								(in_array($t_addresses_array['address_class'], $t_unallowed_classes_array)
									|| preg_match('/.*(packstation|postfiliale).*/i', $t_addresses_array['street_address']) == 1
								)
						   	)
						{
							continue;
						}

						$t_format_id = xtc_get_address_format_id($t_addresses_array['country_id']);
						$t_address_html .= '<tr>
												<td>
													<table border="0" width="100%" cellspacing="0" cellpadding="0">
														<tr>
															<td><strong>' . $t_addresses_array['firstname'] . ' ' . $t_addresses_array['lastname'] . '</strong></td>
															<td align="right">' . xtc_draw_radio_field('address', $t_addresses_array['address_book_id'], ($t_addresses_array['address_book_id'] == $this->address_book_id)) . '</td>
														</tr>
														<tr>
															<td colspan="2">
																<table border="0" cellspacing="0" cellpadding="5">
																	<tr>
																		<td>' . xtc_address_format($t_format_id, $t_addresses_array, true, ' ', ', ') . '</td>
																	</tr>
																</table>
															</td>
														</tr>
													</table>
												</td>
											</tr>';

						$count_radio_buttons++;
					}

					$t_address_html .= '</table>';
					$this->set_content_data('BLOCK_ADDRESS', $t_address_html);
				}
			}
			else
			{
				$this->set_content_data('BUTTON_BACK', '<a href="' . xtc_href_link($t_filename_checkout_address, '', 'SSL') . '">' . xtc_image_button('button_back.gif', IMAGE_BUTTON_BACK) . '</a>');
			}

			if($t_addresses_count < MAX_ADDRESS_BOOK_ENTRIES)
			{
				$coo_checkout_new_address_control = MainFactory::create_object('CheckoutNewAddressContentControl');
				$coo_checkout_new_address_control->set_data('GET', $_GET);
				$coo_checkout_new_address_control->set_data('POST', $_POST);
				$coo_checkout_new_address_control->proceed();
				
				$t_checkout_new_address_html = $coo_checkout_new_address_control->get_response();
				
				$this->set_content_data('MODULE_new_address', $t_checkout_new_address_html);
			}

			$this->set_content_data('BUTTON_BACK', '<a href="javascript:history.back()"><img src="templates/' . CURRENT_TEMPLATE . '/buttons/' . $this->language . '/backgr.gif" /></a>');
			$this->set_content_data('BUTTON_CONTINUE', xtc_draw_hidden_field('action', 'submit') . xtc_image_submit('contgr.gif', IMAGE_BUTTON_CONTINUE));
			$this->set_content_data('BUTTON_BACK_LINK', xtc_href_link($t_filename_checkout, '', 'SSL'));
			$this->set_content_data('FORM_END', '</form>');
			$this->set_content_data('LIGHTBOX', gm_get_conf('GM_LIGHTBOX_CHECKOUT'));

			if(function_exists('gm_get_privacy_link'))
			{			
				$this->set_content_data('GM_PRIVACY_LINK', gm_get_privacy_link('GM_CHECK_PRIVACY_CHECKOUT_PAYMENT'));
			}
			
			$t_html_output = $this->build_html();
		}
		else
		{
			trigger_error("Variable(s) " . implode(', ', $t_uninitialized_array) . " do(es) not exist in class " . get_class($this) . " or is/are null", E_USER_ERROR);
		}
		
		return $t_html_output;
	}
}