<?php
/* --------------------------------------------------------------
   CheckoutPaymentContentView.inc.php 2014-08-19 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(checkout_payment.php,v 1.110 2003/03/14); www.oscommerce.com
   (c) 2003	 nextcommerce (checkout_payment.php,v 1.20 2003/08/17); www.nextcommerce.org
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: checkout_payment.php 1325 2005-10-30 10:23:32Z mz $)

   Released under the GNU General Public License
   -----------------------------------------------------------------------------------------
   Third Party contributions:
   agree_conditions_1.01        	Autor:	Thomas Plänkers (webmaster@oscommerce.at)

   Customers Status v3.x  (c) 2002-2003 Copyright Elari elari@free.fr | www.unlockgsm.com/dload-osc/ | CVS : http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/elari/?sortby=date#dirlist

   Credit Class/Gift Vouchers/Discount Coupons (Version 5.10)
   http://www.oscommerce.com/community/contributions,282
   Copyright (c) Strider | Strider@oscworks.com
   Copyright (c  Nick Stanko of UkiDev.com, nick@ukidev.com
   Copyright (c) Andre ambidex@gmx.net
   Copyright (c) 2001,2002 Ian C Wilson http://www.phesis.org

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

// include needed functions
require_once(DIR_FS_INC . 'xtc_address_label.inc.php');
require_once(DIR_FS_INC . 'xtc_get_address_format_id.inc.php');

// include needed classes
require_once(DIR_FS_CATALOG . 'gm/classes/GMJanolaw.php');

class CheckoutPaymentContentView extends ContentView
{
	protected $address_book_id;
	protected $comments;
	protected $coo_order;
	protected $coo_order_total;
	protected $coo_payment;
	protected $customer_id;
	protected $customers_status_id;
	protected $error_message;
	protected $language;
	protected $languages_id;
	protected $selected_payment_method;
	protected $style_edit_active;
	protected $cart_product_array;

	public function __construct()
	{
		parent::__construct();
		
		$this->set_content_template('module/checkout_payment.html');
		$this->set_flat_assigns(true);
	}

	protected function set_validation_rules()
	{
		$this->validation_rules_array['address_book_id'] = 				array('type' 	=> 'int');
		$this->validation_rules_array['customer_id'] = 					array('type' 	=> 'int');
		$this->validation_rules_array['customers_status_id'] = 			array('type' 	=> 'int');
		$this->validation_rules_array['languages_id'] = 				array('type' 	=> 'int');
		$this->validation_rules_array['language'] = 					array('type' 	=> 'string');
		$this->validation_rules_array['selected_payment_method'] = 		array('type' 	=> 'string');
		$this->validation_rules_array['comments'] = 					array('type' 	=> 'string');
		$this->validation_rules_array['error_message'] = 				array('type' 	=> 'string');
		$this->validation_rules_array['style_edit_active'] = 			array('type' 	=> 'bool',
																			  'strict'	=> true);
		$this->validation_rules_array['coo_order'] = 					array('type' 		=> 'object',
																			  'object_type'	=> 'order');
		$this->validation_rules_array['coo_payment'] = 					array('type'		=> 'object',
																			  'object_type'	=> 'payment');
		$this->validation_rules_array['coo_order_total'] = 				array('type'		=> 'object',
																			  'object_type'	=> 'order_total');
	}
	
	public function get_html()
	{
		$t_html_output = '';
		$t_uninitialized_array = $this->get_uninitialized_variables(array(	'address_book_id', 
																			'customer_id', 
																			'customers_status_id', 
																			'language', 
																			'languages_id', 
																			'style_edit_active',
																			'error_message',
																			'comments',
																			'coo_payment',
																			'coo_order',
																			'coo_order_total'));
		if(empty($t_uninitialized_array))
		{
			$t_link_back_button = xtc_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL');
			if ($this->coo_order->content_type == 'virtual' || ($this->coo_order->content_type == 'virtual_weight') || ($_SESSION['cart']->count_contents_virtual() == 0))
			{
				$t_link_back_button = xtc_href_link(FILENAME_SHOPPING_CART, '', 'SSL');
			}
			
			$this->set_content_data('error', $this->error_message);

			$this->set_content_data('FORM_ACTION', xtc_draw_form('checkout_payment', xtc_href_link(FILENAME_CHECKOUT_CONFIRMATION, '', 'SSL'), 'post'));
			$this->set_content_data('ADDRESS_LABEL', xtc_address_label($this->customer_id, $this->address_book_id, true, ' ', '<br />'));
			$this->set_content_data('BUTTON_ADDRESS', '<a href="' . xtc_href_link(FILENAME_CHECKOUT_PAYMENT_ADDRESS, '', 'SSL') . '">' . xtc_image_button('button_change_address.gif', IMAGE_BUTTON_CHANGE_ADDRESS) . '</a>');
			$this->set_content_data('BUTTON_BACK', '<a href="' . $t_link_back_button . '"><img src="templates/' . CURRENT_TEMPLATE . '/buttons/' . $this->language . '/backgr.gif" /></a>');
			$this->set_content_data('BUTTON_CONTINUE', xtc_image_submit('contgr.gif', IMAGE_BUTTON_CONTINUE));
			$this->set_content_data('BUTTON_BACK_URL', $t_link_back_button);
			$this->set_content_data('FORM_END', '</form>');

			if($this->coo_order->info['total'] <= 0)
			{
				$this->set_content_data('GV_COVER', 'true');
			}

			if(ACTIVATE_GIFT_SYSTEM == 'true')
			{
				$order_total_modules = $this->coo_order_total;
				$this->set_content_data('module_gift', $order_total_modules->credit_selection());
			}

			$this->set_content_data('COMMENTS', xtc_draw_textarea_field('comments', 'soft', '', '', $this->comments, 'class="comments_textarea"') . xtc_draw_hidden_field('comments_added', 'YES'));
			$this->set_content_data('COMMENTS_NAME', 'comments');
			$this->set_content_data('COMMENTS_WRAP', 'soft');
			$this->set_content_data('COMMENTS_VALUE', $this->comments);
			$this->set_content_data('COMMENTS_HIDDEN_NAME', 'comments_added');
			$this->set_content_data('COMMENTS_HIDDEN_VALUE', 'YES');

			//check if display conditions on checkout page is true
			if(gm_get_conf('GM_SHOW_CONDITIONS') == 1)
			{
				if(GROUP_CHECK == 'true')
				{
					$group_check = " AND group_ids LIKE '%c_" . $this->customers_status_id . "_group%' ";
				}

				$shop_content_query = xtc_db_query("SELECT
														content_title,
														content_heading,
														content_text,
														content_file
													FROM " . TABLE_CONTENT_MANAGER . "
													WHERE 
														content_group = '3' 
														" . $group_check . " AND
														languages_id = '" . $this->languages_id . "'");
				$shop_content_data = xtc_db_fetch_array($shop_content_query);

				if($shop_content_data['content_file'] != '')
				{
					$conditions = '<iframe SRC="' . GM_HTTP_SERVER . DIR_WS_CATALOG . 'media/content/' . $shop_content_data['content_file'] . '" width="100%" height="300">';
					$conditions .= '</iframe>';
					$this->set_content_data('AGB_IFRAME', 1);
					$this->set_content_data('AGB_IFRAME_URL', GM_HTTP_SERVER . DIR_WS_CATALOG . 'media/content/' . $shop_content_data['content_file']);
				}
				else
				{
					$conditions = '<textarea class="agb_textarea" name="conditions_text" readonly="readonly">' . trim(strip_tags($shop_content_data['content_text'])) . '</textarea>';
					$t_conditions_array = array();
					$t_conditions_array = array('CLASS' => 'agb_textarea', 'NAME' => 'conditions_text', 'TEXT' => strip_tags($shop_content_data['content_text']));
					$this->set_content_data('conditions_data', $t_conditions_array);
				}

				$this->set_content_data('AGB', $conditions);
				$main = new main();
				$this->set_content_data('AGB_LINK', $main->getContentLink(3, MORE_INFO));
			}

			if(gm_get_conf('GM_CHECK_CONDITIONS') == 1)
			{
				$this->set_content_data('CHECKBOX_AGB', '<input type="checkbox" value="conditions" name="conditions" />');
			}

			//check if display withdrawal on checkout page is true
			if(gm_get_conf('GM_SHOW_WITHDRAWAL') == 1)
			{
				if(GROUP_CHECK == 'true')
				{
					$group_check = " AND group_ids LIKE '%c_" . $this->customers_status_id . "_group%' ";
				}
				
				if((int)gm_get_conf('GM_WITHDRAWAL_CONTENT_ID') === 3889895)
				{
					$t_check_query = 'SELECT
											content_title,
											content_heading,
											content_text,
											content_file
										FROM 
											' . TABLE_CONTENT_MANAGER . '
										WHERE
											content_group = ' . (int)gm_get_conf('GM_WITHDRAWAL_CONTENT_ID') . '
										AND
											languages_id = ' . $this->languages_id . ' ' . $group_check
					;
					$t_check_result = xtc_db_query($t_check_query);
					$t_row = xtc_db_fetch_array($t_check_result);

					if($t_row['content_file'] == false)
					{
						$t_check = xtc_db_query('SELECT file_flag FROM cm_file_flags WHERE file_flag_name = "withdrawal"');
						$t_check = xtc_db_fetch_array($t_check);
						$t_withdrawal_file_flag = $t_check['file_flag'];
						$t_withdrawal_query = 'SELECT
												content_title,
												content_heading,
												content_text,
												content_file
											FROM 
												' . TABLE_CONTENT_MANAGER . '
											WHERE
												file_flag = ' . $t_withdrawal_file_flag . '
											AND
												content_status = 1
											AND
												languages_id = ' . $this->languages_id . ' ' . $group_check . '
											ORDER BY
												sort_order
					';
					}
					else
					{
						$t_withdrawal_query = $t_check_query;
					}
				}
				else
				{
					$t_withdrawal_query = 'SELECT
												content_title,
												content_heading,
												content_text,
												content_file
											FROM 
												' . TABLE_CONTENT_MANAGER . '
											WHERE
												content_group = ' . (int)gm_get_conf('GM_WITHDRAWAL_CONTENT_ID') . '
											AND
												languages_id = ' . $this->languages_id . ' ' . $group_check;
				}
				$t_withdrawal_result = xtc_db_query($t_withdrawal_query);

				$t_withdrawals_array = array();

				while($t_withdrawal_data = xtc_db_fetch_array($t_withdrawal_result))
				{
					if($t_withdrawal_data['content_file'] != '')
					{
						$t_withdrawal = array('data' => array('IFRAME_URL' => GM_HTTP_SERVER . DIR_WS_CATALOG . 'media/content/' . $t_withdrawal_data['content_file'],
															  'HEADING' => $t_withdrawal_data['content_heading']),
												'data_type' => 'iframe'
						);
					}
					else
					{
						$t_withdrawal = array('data' => array('CLASS' => 'withdrawal_textarea',
															  'NAME' => 'withdrawal_text',
															  'HEADING' => $t_withdrawal_data['content_heading'],
															  'TEXT' => strip_tags(str_replace('<br />', "\n", $t_withdrawal_data['content_text']))),
												'data_type' => 'content'
						);
					}
					$t_withdrawals_array[] = $t_withdrawal;
				}

				$this->set_content_data('SHOW_WITHDRAWAL', gm_get_conf('GM_SHOW_WITHDRAWAL'));
				$this->set_content_data('withdrawal_array', $t_withdrawals_array);
			}

			if(gm_get_conf('GM_CHECK_WITHDRAWAL') == 1)
			{
				$this->set_content_data('CHECKBOX_WITHDRAWAL', '<input type="checkbox" value="withdrawal" name="withdrawal" />');
			}

			$this->set_content_data('LIGHTBOX', gm_get_conf('GM_LIGHTBOX_CHECKOUT'));
			$this->set_content_data('LIGHTBOX_CLOSE', xtc_href_link(FILENAME_DEFAULT, '', 'NONSSL'));

			if($this->style_edit_active)
			{
				$this->set_content_data('STYLE_EDIT', 1);
			}
			else
			{
				$this->set_content_data('STYLE_EDIT', 0);
			}

			$coo_checkout_payment_modules_view = MainFactory::create_object('CheckoutPaymentModulesContentView');
			$coo_checkout_payment_modules_view->set_('coo_order', $this->coo_order);
			$coo_checkout_payment_modules_view->set_('coo_payment', $this->coo_payment);
			
			if($this->selected_payment_method !== null)
			{
				$coo_checkout_payment_modules_view->set_('selected_payment_method', $this->selected_payment_method);
			}
			
			$t_payment_block_html = $coo_checkout_payment_modules_view->get_html();
			$this->set_content_data('PAYMENT_BLOCK', $t_payment_block_html);
			
			$t_show_abandonment_download = false;
			$t_show_abandonment_service = false;

			for($i = 0, $n = sizeof($this->cart_product_array); $i < $n; $i++)
			{
				if($this->cart_product_array[$i]['product_type'] == '2')
				{
					$t_show_abandonment_download = true;
				}
				if($this->cart_product_array[$i]['product_type'] == '3')
				{
					$t_show_abandonment_service = true;
				}
			}
			if($t_show_abandonment_download)
			{
				$this->set_content_data('show_abandonment_download', 'true');
			}
			if($t_show_abandonment_service)
			{
				$this->set_content_data('show_abandonment_service', 'true');
			}
			
			// BEGIN AmazonAdvancedPayment
			if(empty($_SESSION['amazonadvpay_order_ref_id']) !== true)
			{
				$coo_aap = MainFactory::create_object('AmazonAdvancedPayment');
				$this->set_content_data('amazonadvpay_active', 1);
				$this->set_content_data('amazon_checkout_payment', '<div id="walletWidgetDiv"></div>');
			}
			// END AmazonAdvancedPayment

			$t_html_output = $this->build_html();
		}
		else
		{
			trigger_error("Variable(s) " . implode(', ', $t_uninitialized_array) . " do(es) not exist in class " . get_class($this) . " or is/are null", E_USER_ERROR);
		}
		
		return $t_html_output;
	}
}