<?php
/* --------------------------------------------------------------
  CheckoutShippingContentView.inc.php 2014-06-18 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2014 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------


  based on:
  (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
  (c) 2002-2003 osCommerce(checkout_shipping.php,v 1.15 2003/04/08); www.oscommerce.com
  (c) 2003	 nextcommerce (checkout_shipping.php,v 1.20 2003/08/20); www.nextcommerce.org
  (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: checkout_shipping.php 1037 2005-07-17 15:25:32Z gwinger $)

  Released under the GNU General Public License
  -----------------------------------------------------------------------------------------
  Third Party contribution:

  Credit Class/Gift Vouchers/Discount Coupons (Version 5.10)
  http://www.oscommerce.com/community/contributions,282
  Copyright (c) Strider | Strider@oscworks.com
  Copyright (c  Nick Stanko of UkiDev.com, nick@ukidev.com
  Copyright (c) Andre ambidex@gmx.net
  Copyright (c) 2001,2002 Ian C Wilson http://www.phesis.org

  Released under the GNU General Public License
  --------------------------------------------------------------------------------------- */

// include needed functions
require_once (DIR_FS_INC.'xtc_address_label.inc.php');
require_once (DIR_FS_INC.'xtc_count_shipping_modules.inc.php');

class CheckoutShippingContentView extends ContentView
{
	protected $free_shipping;
	protected $shipping_free_over;
	protected $quotes_array;
	protected $coo_xtc_price;
	protected $address_book_id;
	protected $customer_id;
	protected $language;
	protected $selected_shipping_method;
	protected $style_edit_active;

	public function __construct()
	{
		parent::__construct();

		$this->set_content_template('module/checkout_shipping.html');
		$this->set_flat_assigns(true);
	}

	protected function set_validation_rules()
	{
		$this->validation_rules_array['customer_id'] = 					array('type'		=> 'int');
		$this->validation_rules_array['shipping_free_over'] =			array('type'		=> 'double');
		$this->validation_rules_array['language'] = 					array('type'		=> 'string');
		$this->validation_rules_array['selected_shipping_method'] = 	array('type'		=> 'string');
		$this->validation_rules_array['quotes_array'] =					array('type'		=> 'array');
		$this->validation_rules_array['free_shipping'] =				array('type'		=> 'bool',
															   				  'strict'		=> true);
		$this->validation_rules_array['style_edit_active'] = 			array('type'		=> 'bool',
																			  'strict'		=> true);
		$this->validation_rules_array['coo_xtc_price'] =				array('type'		=> 'object',
															   				  'object_type'	=> 'xtcPrice');
	}

	protected function set_address_book_id($p_address_book_id)
	{
		if($p_address_book_id === false)
		{
			$this->address_book_id = false;
		}
		elseif(check_data_type($p_address_book_id, 'int'))
		{
			$this->address_book_id = (int)$p_address_book_id;
		}
	}

	public function get_html()
	{
		$t_html_output = '';
		$t_uninitialized_array = $this->get_uninitialized_variables(array('free_shipping',
																			'shipping_free_over',
																			'quotes_array',
																			'coo_xtc_price',
																			'address_book_id',
																			'language',
																			'style_edit_active'));
		if(empty($t_uninitialized_array))
		{
			// check if country of selected shipping address is not allowed
			$t_country_check_sql = "SELECT a.address_book_id
									FROM
										" . TABLE_ADDRESS_BOOK . " a,
										" . TABLE_COUNTRIES . " c
									WHERE
										a.address_book_id = '" . $this->address_book_id . "' AND
										a.entry_country_id = c.countries_id AND
										c.status = 1";
			$t_country_check_result = xtc_db_query($t_country_check_sql);
			if(xtc_db_num_rows($t_country_check_result) == 0)
			{
				$this->set_content_data('error', ERROR_INVALID_SHIPPING_COUNTRY);
			}

			$this->set_content_data('FORM_ACTION', xtc_draw_form('checkout_address', xtc_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL')) . xtc_draw_hidden_field('action', 'process'));
			$this->set_content_data('ADDRESS_LABEL', xtc_address_label($this->customer_id, $this->address_book_id, true, ' ', '<br />'));
			$this->set_content_data('BUTTON_ADDRESS', '<a href="' . xtc_href_link(FILENAME_CHECKOUT_SHIPPING_ADDRESS, '', 'SSL') . '">' . xtc_image_button('button_change_address.gif', IMAGE_BUTTON_CHANGE_ADDRESS) . '</a>');
			$this->set_content_data('BUTTON_BACK', '<a href="javascript:history.back()"><img src="templates/' . CURRENT_TEMPLATE . '/buttons/' . $this->language . '/backgr.gif" /></a>');
			$this->set_content_data('BUTTON_CONTINUE', xtc_image_submit('contgr.gif', IMAGE_BUTTON_CONTINUE));
			$this->set_content_data('FORM_END', '</form>');

			// BEGIN Postfinder
			if(file_exists(DIR_FS_CATALOG.'gm/classes/GMIntraship.php'))
			{
				$intraship = new GMIntraship();
				if($intraship->isPostfinderActive() && $intraship->isPackstationAddress($this->address_book_id) == false)
				{
					$this->set_content_data('url_pfinder', xtc_href_link('postfinder.php', 'ab='.$this->address_book_id, 'SSL').'&checkout_started=1');
				}
			}
			// END Postfinder

			$this->set_content_data('LIGHTBOX', gm_get_conf('GM_LIGHTBOX_CHECKOUT'));
			$this->set_content_data('LIGHTBOX_CLOSE', xtc_href_link(FILENAME_DEFAULT, '', 'NONSSL'));

			if($this->style_edit_active)
			{
				$this->set_content_data('STYLE_EDIT', 1);
			}
			else
			{
				$this->set_content_data('STYLE_EDIT', 0);
			}

			if(xtc_count_shipping_modules() > 1)
			{
				$this->set_content_data('GM_MORE_SHIPPING', 1);
			}

			$coo_checkout_shipping_modules_view = MainFactory::create_object('CheckoutShippingModulesContentView');
			$coo_checkout_shipping_modules_view->set_('free_shipping', $this->free_shipping);
			$coo_checkout_shipping_modules_view->set_('quotes_array', $this->quotes_array);
			$coo_checkout_shipping_modules_view->set_('shipping_free_over', $this->shipping_free_over);
			$coo_checkout_shipping_modules_view->set_('coo_xtc_price', $this->coo_xtc_price);
			if($this->selected_shipping_method !== null)
			{
				$coo_checkout_shipping_modules_view->set_('selected_shipping_method', $this->selected_shipping_method);
			}
			$t_shipping_block_html = $coo_checkout_shipping_modules_view->get_html();
			$this->set_content_data('SHIPPING_BLOCK', $t_shipping_block_html);

			if(sizeof($coo_checkout_shipping_modules_view->get_('quotes_array')) == 1 || $this->free_shipping)
			{
				$this->set_content_data('GM_FREE_SHIPPING_ACTIVATED', 1);
			}

			// BEGIN AmazonAdvancedPayment
			if(empty($_SESSION['amazonadvpay_order_ref_id']) !== true)
			{
				$this->set_content_data('amazon_checkout_address', '<div id="addressBookWidgetDiv"></div>');
			}
			// END AmazonAdvancedPayment

			$t_html_output = $this->build_html();
		}
		else
		{
			trigger_error("Variable(s) " . implode(', ', $t_uninitialized_array) . " do(es) not exist in class " . get_class($this) . " or is/are null", E_USER_ERROR);
		}

		return $t_html_output;
	}
}