<?php
/* --------------------------------------------------------------
  CheckoutShippingModulesContentView.inc.php 2014-05-15 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2014 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------


  based on:
  (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
  (c) 2002-2003 osCommerce(checkout_shipping.php,v 1.15 2003/04/08); www.oscommerce.com
  (c) 2003	 nextcommerce (checkout_shipping.php,v 1.20 2003/08/20); www.nextcommerce.org
  (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: checkout_shipping.php 1037 2005-07-17 15:25:32Z gwinger $)

  Released under the GNU General Public License
  -----------------------------------------------------------------------------------------
  Third Party contribution:

  Credit Class/Gift Vouchers/Discount Coupons (Version 5.10)
  http://www.oscommerce.com/community/contributions,282
  Copyright (c) Strider | Strider@oscworks.com
  Copyright (c  Nick Stanko of UkiDev.com, nick@ukidev.com
  Copyright (c) Andre ambidex@gmx.net
  Copyright (c) 2001,2002 Ian C Wilson http://www.phesis.org

  Released under the GNU General Public License
  --------------------------------------------------------------------------------------- */

// include needed functions
require_once (DIR_FS_INC.'xtc_count_shipping_modules.inc.php');

class CheckoutShippingModulesContentView extends ContentView
{
	protected $coo_xtc_price;
	protected $free_shipping;
	protected $shipping_free_over;
	protected $quotes_array;
	protected $selected_shipping_method;

	public function __construct()
	{
		parent::__construct();
		
		$this->set_content_template('module/checkout_shipping_block.html');
		$this->set_flat_assigns(true);
	}

	protected function set_validation_rules()
	{
		$this->validation_rules_array['shipping_free_over'] =			array('type'		=> 'double');
		$this->validation_rules_array['selected_shipping_method'] = 	array('type'		=> 'string');
		$this->validation_rules_array['quotes_array'] =					array('type'		=> 'array');
		$this->validation_rules_array['free_shipping'] =				array('type'		=> 'bool',
																			  'strict'		=> true);
		$this->validation_rules_array['coo_xtc_price'] =				array('type'		=> 'object',
																			  'object_type'	=> 'xtcPrice');
	}
	
	public function get_html()
	{
		$t_html_output = '';
		$t_uninitialized_array = $this->get_uninitialized_variables(array('free_shipping', 
																			'shipping_free_over', 
																			'quotes_array', 
																			'coo_xtc_price'));
		if(empty($t_uninitialized_array))
		{
			if(xtc_count_shipping_modules() > 0)
			{				
				$coo_xtc_price = $this->coo_xtc_price;
				$quotes = $this->quotes_array;
				
				$this->set_content_data('FREE_SHIPPING', $this->free_shipping);

				# free shipping or not...
				if($this->free_shipping == true)
				{
					$this->set_content_data('FREE_SHIPPING_TITLE', FREE_SHIPPING_TITLE);
					$this->set_content_data('FREE_SHIPPING_DESCRIPTION', sprintf(FREE_SHIPPING_DESCRIPTION, $coo_xtc_price->xtcFormat($this->shipping_free_over, true, 0, true))
																		. xtc_draw_hidden_field('shipping', 'free_free'));
					$this->set_content_data('FREE_SHIPPING_ICON', '');

					$t_gm_quotes = array();

					foreach($quotes AS $t_gm_key => $t_gm_value)
					{
						if($quotes[$t_gm_key]['id'] == 'selfpickup' || $quotes[$t_gm_key]['id'] == 'selfpickup_selfpickup')
						{
							$t_gm_quotes = array();
							$t_gm_quotes[] = array('id' => 'free_free',
															'module' => FREE_SHIPPING_TITLE,
															'methods' => array(array('id' => 'free_free',
																	'title' => sprintf(FREE_SHIPPING_DESCRIPTION, $coo_xtc_price->xtcFormat($this->shipping_free_over, true, 0, true)),
																	'cost' => 0,
																	'radio_buttons' => 0,
																	'checked' => 1,
																	'price' => $coo_xtc_price->xtcFormat(0, true),
																	'radio_field' => xtc_draw_radio_field('shipping', 'free_free', true))
																));
							$t_gm_quotes[] = $quotes[$t_gm_key];
							unset($t_gm_quotes[1]['methods'][0]['checked']);
							$t_gm_quotes[1]['id'] = 'selfpickup_selfpickup';
							$t_gm_quotes[1]['methods'][0]['id'] = 'selfpickup_selfpickup';
							$t_gm_quotes[1]['methods'][0]['radio_buttons'] = 1;
							$t_gm_quotes[1]['methods'][0]['price'] = $coo_xtc_price->xtcFormat(0, true);
							$t_gm_quotes[1]['methods'][0]['radio_field'] = xtc_draw_radio_field('shipping', 'selfpickup_selfpickup', false);
						}
					}

					if(!empty($t_gm_quotes))
					{
						$quotes = $t_gm_quotes;
						$this->set_content_data('module_content', $quotes);
					}
				}
				else
				{
					$radio_buttons = 0;
					$count_modules = count($quotes);
					
					#loop through installed shipping methods...
					foreach($quotes as $t_key => $t_method_array)
					{
						if(!isset($quotes[$t_key]['error']))
						{
							for($j = 0, $count_methods = sizeof($quotes[$t_key]['methods']); $j < $count_methods; $j++)
							{
								# set the radio button to be checked if it is the method chosen
								$quotes[$t_key]['methods'][$j]['radio_buttons'] = $radio_buttons;
								$checked = (($quotes[$t_key]['id'] . '_' . $quotes[$t_key]['methods'][$j]['id'] == $this->selected_shipping_method) ? true : false);

								if(($checked == true) || ($count_modules == 1 && $count_methods == 1))
								{
									$quotes[$t_key]['methods'][$j]['checked'] = 1;
								}

								if($_SESSION['customers_status']['customers_status_show_price_tax'] == 0)
								{
									$quotes[$t_key]['tax'] = 0;
								}

								if(($count_modules > 1) || ($count_methods > 1))
								{
									$quotes[$t_key]['methods'][$j]['price'] = $coo_xtc_price->xtcFormat(xtc_add_tax($quotes[$t_key]['methods'][$j]['cost'], $quotes[$t_key]['tax']), true, 0, true);
									$quotes[$t_key]['methods'][$j]['radio_field'] = xtc_draw_radio_field('shipping', $quotes[$t_key]['id'] . '_' . $quotes[$t_key]['methods'][$j]['id'], $checked);
								} 
								else
								{
									$quotes[$t_key]['methods'][$j]['price'] = $coo_xtc_price->xtcFormat(xtc_add_tax($quotes[$t_key]['methods'][$j]['cost'], $quotes[$t_key]['tax']), true, 0, true)
																			. xtc_draw_hidden_field('shipping', $quotes[$t_key]['id'] . '_' . $quotes[$t_key]['methods'][$j]['id']);
								}

								$radio_buttons++;
							}
						}
					}

					$this->set_content_data('module_content', $quotes);
				}
				
				// use setter to allow overloading
				$this->set_('quotes_array', $quotes);
			}

			$t_html_output = $this->build_html();
		}
		else
		{
			trigger_error("Variable(s) " . implode(', ', $t_uninitialized_array) . " do(es) not exist in class " . get_class($this) . " or is/are null", E_USER_ERROR);
		}
		
		return $t_html_output;
	}
}