<?php
/* --------------------------------------------------------------
   CheckoutSuccessContentView.inc.php 2014-04-24 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on: 
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(checkout_success.php,v 1.48 2003/02/17); www.oscommerce.com 
   (c) 2003	 nextcommerce (checkout_success.php,v 1.14 2003/08/17); www.nextcommerce.org
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: checkout_success.php 896 2005-04-27 19:22:59Z mz $)

   Released under the GNU General Public License
   -----------------------------------------------------------------------------------------
   Third Party contribution:

   Credit Class/Gift Vouchers/Discount Coupons (Version 5.10)
   http://www.oscommerce.com/community/contributions,282
   Copyright (c) Strider | Strider@oscworks.com
   Copyright (c  Nick Stanko of UkiDev.com, nick@ukidev.com
   Copyright (c) Andre ambidex@gmx.net
   Copyright (c) 2001,2002 Ian C Wilson http://www.phesis.org


   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

class CheckoutSuccessContentView extends ContentView
{
	protected $language;
	protected $order_id;
	protected $customer_id;
	protected $nc_checkout_success_info;
	
	public function __construct()
	{
		parent::__construct();
		
		$this->set_content_template('module/checkout_success.html');
		$this->set_flat_assigns(true);
		$this->set_caching_enabled(false);
	}

	protected function set_validation_rules()
	{
		$this->validation_rules_array['customer_id']	= array('type' => 'int');
		$this->validation_rules_array['order_id']		= array('type' => 'int');
		$this->validation_rules_array['language']		= array('type' => 'string');
	}
	
	public function get_html()
	{
		$this->set_content_data('FORM_ACTION', xtc_draw_form('order', xtc_href_link(FILENAME_CHECKOUT_SUCCESS, 'action=update', 'SSL')));

		$this->set_content_data('BUTTON_CONTINUE', xtc_image_submit('contgr.gif', IMAGE_BUTTON_CONTINUE));
		$this->set_content_data('BUTTON_PRINT', '<img src="'.'templates/'.CURRENT_TEMPLATE.'/buttons/'.$this->language.'/button_print.gif" style="cursor:hand" onclick="window.open(\''.xtc_href_link(FILENAME_PRINT_ORDER, 'oID='.$this->order_id).'\', \'popup\', \'toolbar=0, width=640, height=600\')" />');
		$this->set_content_data('BUTTON_PRINT_URL', xtc_href_link(FILENAME_PRINT_ORDER, 'oID='.$this->order_id));
		$this->set_content_data('FORM_END', '</form>');
		// GV Code Start
		$gv_query = xtc_db_query("select amount from ".TABLE_COUPON_GV_CUSTOMER." where customer_id='".$this->customer_id."'");
		if ($gv_result = xtc_db_fetch_array($gv_query))
		{
			if ($gv_result['amount'] > 0)
			{
				$this->set_content_data('GV_SEND_LINK', xtc_href_link(FILENAME_GV_SEND, '', 'SSL'));
			}
		}
		// GV Code End

		if($this->nc_checkout_success_info)
		{
			$this->set_content_data('NC_SUCCESS_INFO', $this->nc_checkout_success_info);
		}

		$this->set_content_data('LIGHTBOX', gm_get_conf('GM_LIGHTBOX_CHECKOUT'));
		$this->set_content_data('LIGHTBOX_CLOSE', xtc_href_link(FILENAME_DEFAULT, '', 'NONSSL'));
		
		if (DOWNLOAD_ENABLED == 'true')
		{
			$coo_downloads_content_view = MainFactory::create_object('DownloadsContentView');
			$t_downloads_html = $coo_downloads_content_view->get_html($this->order_id, $this->customer_id);
			$this->set_content_data('downloads_content', $t_downloads_html);
		}
		
		$t_html_output = $this->build_html();
		return $t_html_output;
	}
	
	protected function set_nc_checkout_success_info($p_nc_checkout_success_info)
	{
		if (is_null($p_nc_checkout_success_info))
		{
			return;
		}
		if(check_data_type($p_nc_checkout_success_info, 'string'))
		{
			$this->nc_checkout_success_info = $p_nc_checkout_success_info;
		}
	}
}