<?php
/* --------------------------------------------------------------
   DownloadsContentView.inc.php 2014-07-15 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on: 
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(downloads.php,v 1.2 2003/02/12); www.oscommerce.com 
   (c) 2003	 nextcommerce (downloads.php,v 1.6 2003/08/13); www.nextcommerce.org
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: downloads.php 896 2005-04-27 19:22:59Z mz $)

   Released under the GNU General Public License 
   ---------------------------------------------------------------------------------------*/

// include the needed functions
if (!function_exists('xtc_date_long')) {
	require_once (DIR_FS_INC.'xtc_date_long.inc.php');
}

if (!function_exists('xtc_date_short')) {
	require_once (DIR_FS_INC.'xtc_date_short.inc.php');
}


class DownloadsContentView extends ContentView
{
	 public function __construct()
	{
		parent::__construct();
		$this->set_content_template('module/downloads.html');
		$this->set_flat_assigns(true);
		$this->set_caching_enabled(false);
	}
	
	public function get_html($p_order_id, $p_customers_id)
	{
		$t_html_output = '';		
		
		if (!strstr(gm_get_env_info('PHP_SELF'), FILENAME_ACCOUNT_HISTORY_INFO)) {
			// Get last order id for checkout_success
			$orders_query = xtc_db_query("select orders_id, orders_status from ".TABLE_ORDERS." where customers_id = '".(int)$p_customers_id."' order by orders_id desc limit 1");
			$orders = xtc_db_fetch_array($orders_query);
			$last_order = $orders['orders_id'];
			$order_status = $orders['orders_status'];
		} else {
			$last_order = (int)$p_order_id;
			$orders_query = xtc_db_query("SELECT orders_status FROM ".TABLE_ORDERS." WHERE orders_id = '".$last_order."'");
			$orders = xtc_db_fetch_array($orders_query);
			$order_status = $orders['orders_status'];
		}

		$t_download_order_status_array = explode('|', DOWNLOAD_MIN_ORDERS_STATUS);

		if (!in_array($order_status, $t_download_order_status_array)) {
			$this->set_content_data('dl_prevented', 'true');
		}

		// Now get all downloadable products in that order
		$downloads_query = xtc_db_query("select date_format(o.date_purchased, '%Y-%m-%d') as date_purchased_day, opd.download_maxdays, op.products_name, opd.orders_products_download_id, opd.orders_products_filename, opd.download_count, opd.download_maxdays, o.abandonment_download, UNIX_TIMESTAMP(o.date_purchased) as date_purchased_unix from ".TABLE_ORDERS." o, ".TABLE_ORDERS_PRODUCTS." op, ".TABLE_ORDERS_PRODUCTS_DOWNLOAD." opd where o.customers_id = '".(int)$p_customers_id."' and o.orders_id = '".$last_order."' and o.orders_id = op.orders_id and op.orders_products_id = opd.orders_products_id and opd.orders_products_filename != ''");
		if (xtc_db_num_rows($downloads_query) > 0) {
			$jj = 0;
			//<!-- list of products -->
			while ($downloads = xtc_db_fetch_array($downloads_query)) {
				// MySQL 3.22 does not have INTERVAL
				list ($dt_year, $dt_month, $dt_day) = explode('-', $downloads['date_purchased_day']);
				$download_timestamp = mktime(23, 59, 59, $dt_month, $dt_day + $downloads['download_maxdays'], $dt_year);
				$download_expiry = date('Y-m-d H:i:s', $download_timestamp);
				$t_download_delay_message = $this->get_download_delay_message($downloads['date_purchased_unix'], $downloads['abandonment_download']);
				
				//<!-- left box -->
				// The link will appear only if:
				// - Download remaining count is > 0, AND
				// - The file is present in the DOWNLOAD directory, AND EITHER
				// - No expiry date is enforced (maxdays == 0), OR
				// - The expiry date is not reached
				if (($downloads['download_count'] > 0) && (file_exists(DIR_FS_DOWNLOAD.$downloads['orders_products_filename'])) && (($downloads['download_maxdays'] == 0) || ($download_timestamp > time())) && in_array($order_status, $t_download_order_status_array)) {
					$dl[$jj]['download_link'] = '<a href="'.xtc_href_link(FILENAME_DOWNLOAD, 'order='.$last_order.'&id='.$downloads['orders_products_download_id']).'">'.$downloads['products_name'].'</a>';
					$dl[$jj]['pic_link'] = xtc_href_link(FILENAME_DOWNLOAD, 'order='.$last_order.'&id='.$downloads['orders_products_download_id']);
					$dl[$jj]['delay_message'] = $t_download_delay_message;
				} else {
					$dl[$jj]['download_link'] = $downloads['products_name'];
				}
				//<!-- right box -->
				$dl[$jj]['date'] = xtc_date_long($download_expiry);
				$dl[$jj]['date_short'] = xtc_date_short($download_expiry);
				$dl[$jj]['count'] = $downloads['download_count'];
				$jj ++;
			}
		}
		$this->set_content_data('dl', $dl);
		
		$t_html_output = $this->build_html();

		return $t_html_output;
	}
	
	protected function get_download_delay_message($p_date_purchased, $p_withdrawal_right_abandoned = 0)
	{
		$t_output = '';

		if($p_withdrawal_right_abandoned == 1)
		{
			$t_download_abandonment_time = gm_get_conf('DOWNLOAD_DELAY_FOR_ABANDONMENT_OF_WITHDRAWL_RIGHT');
		}
		else
		{
			$t_download_abandonment_time = gm_get_conf('DOWNLOAD_DELAY_WITHOUT_ABANDONMENT_OF_WITHDRAWL_RIGHT');
		}

		$t_time_until_download_allowed = ($p_date_purchased + $t_download_abandonment_time) - time();

		if($t_time_until_download_allowed > 0) {
			/** @var $coo_download_delay DownloadDelay */
			$coo_download_delay = MainFactory::create_object('DownloadDelay');
			$coo_download_delay->convert_seconds_to_days($t_time_until_download_allowed);

			$t_days = $coo_download_delay->get_delay_days();
			$t_hours = $coo_download_delay->get_delay_hours();
			$t_minutes = $coo_download_delay->get_delay_minutes();
			$t_seconds = $coo_download_delay->get_delay_seconds();

			$coo_text_mgr = MainFactory::create_object('LanguageTextManager', array('withdrawal', $_SESSION['languages_id']) );
			/** @var $coo_text_time_left DownloadTimerStringOutput */
			$coo_text_time_left = MainFactory::create_object('DownloadTimerStringOutput', array(
				$t_days,
				$t_hours,
				$t_minutes,
				$t_seconds,
				$coo_text_mgr
			));

			$t_output = $coo_text_time_left->get_msg();
		}

		return $t_output;
	}
}