<?php
/* --------------------------------------------------------------
   ErrorMessageContentView.inc.php 2014-03-07 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------

   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: error_handler.php 949 2005-05-14 16:44:33Z hhgag $)

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

class ErrorMessageContentView extends ContentView
{
	protected $error;

	public function __construct()
	{
		parent::__construct();
		
		$this->set_content_template('module/error_message.html');
		$this->set_flat_assigns(true);
	}
	
	protected function set_validation_rules()
	{
		$this->validation_rules_array['error'] = array('type' => 'string');
	}
	
	protected function set_deprecated_array()
	{
		$this->deprecated_array[1][] = 'ERROR';
		$this->deprecated_array[1][] = 'BUTTON';
		$this->deprecated_array[1][] = 'INPUT_SEARCH';
		$this->deprecated_array[1][] = 'BUTTON_SUBMIT';
		$this->deprecated_array[1][] = 'LINK_ADVANCED';
	}

	public function prepare_data()
	{
		$t_feature_value_group_array = $_SESSION['coo_filter_manager']->get_feature_value_group_array();
		# transfer feature_value_groups to product finder
		$coo_finder = MainFactory::create_object('IndexFeatureProductFinder');
		foreach($t_feature_value_group_array as $t_feature_value_group)
		{
			$coo_finder->add_feature_value_group($t_feature_value_group);
		}
		$coo_filter_selection_content_view = MainFactory::create_object('FilterSelectionContentView');
		$coo_filter_selection_content_view->set_('feature_value_group_array', $t_feature_value_group_array);
		$coo_filter_selection_content_view->set_('language_id', $_SESSION['languages_id']);
		$t_filter_selection_html = $coo_filter_selection_content_view->get_html();
		$this->content_array['FILTER_SELECTION'] = $t_filter_selection_html;
		
		$this->content_array['ERROR'] = $this->error;
		$this->content_array['BUTTON'] = '<a href="javascript:history.back(1)">'. xtc_image_button('button_back.gif', IMAGE_BUTTON_CONTINUE).'</a>';

		// search field
		$this->content_array['FORM_ACTION'] = xtc_draw_form('new_find', xtc_href_link(FILENAME_ADVANCED_SEARCH_RESULT, '', 'NONSSL', false, true, true), 'get').xtc_hide_session_id();
		$this->content_array['INPUT_SEARCH'] = xtc_draw_input_field('keywords', '', 'size="30" maxlength="30"');
		$this->content_array['INPUT_SEARCH_NAME'] = 'keywords';
		$this->content_array['BUTTON_SUBMIT'] = xtc_image_submit('button_quick_find.gif');
		$this->content_array['LINK_ADVANCED'] = xtc_href_link(FILENAME_ADVANCED_SEARCH);
		$this->content_array['FORM_END'] = '</form>';
	}
}