<?php
/* --------------------------------------------------------------
	PaypalPaymentContentView.inc.php 2014-03-12_1546 mabr
	Gambio GmbH
	http://www.gambio.de
	Copyright (c) 2013 Gambio GmbH
	Released under the GNU General Public License (Version 2)
	[http://www.gnu.org/licenses/gpl-2.0.html]
	--------------------------------------------------------------
*/

class PaypalPaymentContentView extends ContentView {
	function PaypalPaymentContentView() {
		$this->set_content_template('module/paypal_payment.html');
	}

	function get_html() {
		$pp = new GMPayPal();

		if(isset($_GET['token']) && $_GET['token'] == $_SESSION['paypal']['token'] && isset($_GET['PayerID']) && isset($_SESSION['paypal_payment_orders_id'])) {
			$token = $_SESSION['paypal']['token'];
			$orders_id = $_SESSION['paypal_payment_orders_id'];
			$orderdata = array(
				'payer_id' => $_GET['PayerID'],
				'token' => $token,
			);
			$pp->_log("processing independent payment for order $orders_id");
			$result = $pp->doExpressCheckoutPayment($orders_id, $orderdata);
			if($result['success'] == true) {
				$pp->deletePaycode($orders_id);
				unset($_SESSION['paypal']['token']);
				unset($_SESSION['paypal_payment_orders_id']);
				$this->set_content_data('thankyou', true);
				$pp->_log("independent payment successfully received");
			}
			else {
				$this->set_content_data('error', $pp->get_text('paypalpayment_misc_error'));
				$pp->_log("independent payment FAIL");
			}
		}
		else if(isset($_GET['paycode'])) {
			if(($paycode = $pp->getPaycodeByCode($_GET['paycode'])) !== false) {
				$orders_id = $paycode['orders_id'];
				$amount = $paycode['amount'];
				$pp->_log("initiating independent payment for order $orders_id, amount ".($amount != null ? $amount : 'full'));
				$_SESSION['paypal_payment_orders_id'] = $orders_id;
				try {
					$token = $pp->prepareIndependentPayment($orders_id, $amount);
				}
				catch(GMPayPalNoTokenException $e) {
					$pp->_log("preparing payment FAILED");
					die($e->getMessage());
				}
				$_SESSION['paypal']['token'] = $token;
				$redirect_url = $pp->getRedirectURL('_express-checkout', $token);
				$pp->_log("independent payment for order $orders_id, redirecting to $redirect_url");
				xtc_redirect($redirect_url);
			}
			else {
				$this->set_content_data('error', $pp->get_text('invalid_paycode'));
			}
		}
		else {
			xtc_redirect(GM_HTTP_SERVER.DIR_WS_CATALOG);
		}

		$t_html_output = $this->build_html();		
		return $t_html_output;
	}
}