<?php
/* --------------------------------------------------------------
  TrustedShopsExcellenceContentView.inc.php 2014-02-12 gambio
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2014 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------


  based on:
  (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
  (c) 2002-2003 osCommerce(best_sellers.php,v 1.20 2003/02/10); www.oscommerce.com
  (c) 2003	 nextcommerce (best_sellers.php,v 1.10 2003/08/17); www.nextcommerce.org
  (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: best_sellers.php 1292 2005-10-07 16:10:55Z mz $)

  Released under the GNU General Public License
  -----------------------------------------------------------------------------------------
  Third Party contributions:
  Enable_Disable_Categories 1.3        	Autor: Mikel Williams | mikel@ladykatcostumes.com

  Released under the GNU General Public License
  --------------------------------------------------------------------------------------- */

class TrustedShopsExcellenceContentView extends ContentView
{
	function TrustedShopsExcellenceContentView()
	{
		parent::__construct();
		$this->set_content_template('module/ts_excellence.html');
		$this->set_flat_assigns(true);
	}

	function get_html($order)
	{
		$service = new GMTSService();
		$tsid = $service->findExcellenceID($_SESSION['language_code']);
		if($tsid !== false)
		{
			$trusted_amount = round($order->info['total'], 2);
			if(isset($_SESSION['ts_excellence']))
			{
				$this->set_content_data('has_protection', '1');
				unset($_SESSION['ts_excellence']['from_protection']);
			}
			$product = $service->findProtectionProduct($tsid, $trusted_amount, $order->info['currency']);
			if($product === false)
			{
				$t_html_output = '<!-- TS Buyer Protection Excellence product not found ' . $tsid . ' ' . $trusted_amount . ' ' . $order->info['currency'] . ' -->';
			}
			else
			{
				$this->set_content_data('TSID', $tsid);
				$this->set_content_data('total', round($order->info['total'], 2));
				$this->set_content_data('add_protection_action', GM_HTTP_SERVER.DIR_WS_CATALOG.'trusted_shops_protection.php');
				$this->set_content_data('add_protection_checked', isset($_SESSION['ts_excellence']['application_number']));
				$this->set_content_data('trusted_amount', number_format($trusted_amount, 2, ',', '') . ' ' . $order->info['currency']);
				$this->set_content_data('protected_amount', number_format($product['protectedamount'], 2, ',', '') . ' ' . $order->info['currency']);
				$this->set_content_data('protection_fee', number_format($product['grossfee'], 2, ',', '') . ' ' . $order->info['currency']);
				$this->set_content_data('incl_tax', $_SESSION['customers_status']['customers_status_show_price_tax'] == 1);
				//$this->set_content_data('foo', htmlspecialchars(print_r($order, true)));
				$foo = htmlspecialchars(print_r($product, true));
				$foo .= '<br>[tse]' . htmlspecialchars(print_r($_SESSION['ts_excellence'], true)) . '[/tse]';
				$this->set_content_data('foo', $foo);
				$t_html_output = $this->build_html();
				$t_html_output = strtr($t_html_output, array('{TSID}' => $tsid));
			}
		}
		else
		{
			$t_html_output = '<!-- TS Buyer Protection Excellence unavailable -->';
		}
		return $t_html_output;
	}

}
