<?php
/* --------------------------------------------------------------
  GxmlAttributes.inc.php 2012-06-01 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2012 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------
 */

class GxmlAttributes
{
	private $v_coo_gxml_helper;
	
	public function __construct() 
	{
		$this->v_coo_gxml_helper = MainFactory::create_object('GxmlHelper');
	}	

	function download_attributes($p_coo_request_xml)
	{
		// build response document
		$t_response_xml_content = $this->v_coo_gxml_helper->get_blank_xml();
		$coo_response_xml = simplexml_load_string($t_response_xml_content); 

		$coo_response_xml->addChild('request');
		$coo_response_xml->request->addChild('success', 1);
		
		$coo_gxml = MainFactory::create_object('GxmlLanguages');
		$coo_response_xml = $coo_gxml->add_languages_block($coo_response_xml);
		$coo_response_xml = $this->add_attributes_block($coo_response_xml);
		
		return $coo_response_xml;
	}
	
	function add_attributes_block($p_coo_xml)
	{
		$coo_output_xml = $p_coo_xml;
		$coo_output_xml->addChild('attributes');
		
		$t_sql = '
			SELECT po.language_id AS po_language_id, po.*, pov.*
			FROM
				products_options AS po 
					LEFT JOIN products_options_values_to_products_options AS pov2po USING (products_options_id)
					LEFT JOIN products_options_values AS pov ON (pov2po.products_options_values_id = pov.products_options_values_id AND po.language_id = pov.language_id)
			ORDER BY
				po.products_options_id,
				pov.products_options_values_id,
				po.language_id
		';
		$t_result = xtc_db_query($t_sql);
		
		$t_last_new_options_id = 0;
		$t_options_name_array = array();
		
		while(($t_row = xtc_db_fetch_array($t_result) ))
		{
			if($t_row['products_options_id'] != $t_last_new_options_id)
			{
				//add collected names from last loop
				foreach ($t_options_name_array as $t_key => $t_value)
				{
					$coo_child = $coo_attribute_child->addChild('name', $t_value);
					$coo_child->addAttribute('language_id', $t_key);
				}
				
				//products_options
				$coo_attribute_child = $coo_output_xml->attributes->addChild('attribute');
				$coo_attribute_child->addChild('attribute_id', $t_row['products_options_id']);
				
				$coo_values_child = $coo_attribute_child->addChild('values');
				
				$t_last_new_options_id = $t_row['products_options_id'];
				$t_options_name_array = array();
			}
			
			//collect option_names for later output in next loop
			$t_options_name_array[$t_row['po_language_id']] = $t_row['products_options_name'];
			
			$coo_child = $coo_values_child->addChild('value', $t_row['products_options_values_name']);
			$coo_child->addAttribute('id', $t_row['products_options_values_id']);
			$coo_child->addAttribute('language_id', $t_row['language_id']);
			$coo_child = NULL;
		}
		//add collected names from last loop
		foreach ($t_options_name_array as $t_key => $t_value)
		{
			$coo_child = $coo_attribute_child->addChild('name', $t_value);
			$coo_child->addAttribute('language_id', $t_key);
		}
		
		return $coo_output_xml;
	}
}

?>