<?php
/* --------------------------------------------------------------
  GxmlAuth.inc.php 2013-02-12 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2013 Gambio GmbH
  Released under the GNU General private License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------
 */

class GxmlAuth 
{
	private $v_coo_gxml_helper;
	private $v_session_lifetime;
	
	public function __construct() 
	{
		$this->v_coo_gxml_helper = MainFactory::create_object('GxmlHelper');
		$t_session_lifetime = 15 * 60; // 15 minutes
		$this->set_session_lifetime($t_session_lifetime);
		$this->clean_up_sessions_array();
	}
	
	public function login($p_coo_request_xml)
	{
		// extract login data from xml document
		$f_user	= (string)$p_coo_request_xml->login->user;
		$f_password	= (string)$p_coo_request_xml->login->password;
		if(isset($p_coo_request_xml->login->password['encryption']))
		{
			$f_encryption = (string)$p_coo_request_xml->login->password['encryption'];
		}		
		
		// check login data
		$t_result = mysql_query('
			SELECT customers_password
			FROM customers
			WHERE
				customers_email_address = "'. xtc_db_input($f_user) .'" AND
				customers_status = 0
		');
		$t_data = xtc_db_fetch_array($t_result);

		// login validation status
		$t_login_success = false;
		
		if(empty($f_user) || empty($f_password)) {
			$t_login_success = false;
		}
		elseif(isset($f_encryption) && strtolower($f_encryption) == 'md5' && $t_data['customers_password'] == $f_password) { // sent password is md5
			$t_login_success = true;
		}
		elseif($t_data['customers_password'] == md5($f_password)) { // sent password is plaintext
			$t_login_success = true;
		}
		
		// build response document
		$t_response_xml_content = $this->v_coo_gxml_helper->get_blank_xml();
		$coo_response_xml = simplexml_load_string($t_response_xml_content); 
		
		$coo_response_xml->addChild('request');
		if($t_login_success == false)
		{
			$coo_response_xml->request->addChild('success', 0);
			$coo_response_xml->request->addChild('errormessage', 'invalid login');
		}
		else
		{
			$coo_response_xml->request->addChild('success', 1);
			$coo_response_xml->addChild('login');
			$coo_response_xml->login->addChild('session_key', $this->create_session_key() );
		}
		
		return $coo_response_xml;
	}
	
	public function logout($p_coo_request_xml)
	{
		// extract session_key from xml document
		$f_session_key = (string)$p_coo_request_xml->general->session_key;
		
		$this->destroy_session($f_session_key);
		
		$t_response_xml_content = $this->v_coo_gxml_helper->get_blank_xml();
		$coo_response_xml = simplexml_load_string($t_response_xml_content); 
		
		$coo_response_xml->addChild('request');
		$coo_response_xml->request->addChild('success', 1);
		
		return $coo_response_xml;
	}
	
	public function build_invalid_session_response()
	{
		// build response document
		$t_response_xml_content = $this->v_coo_gxml_helper->get_blank_xml();
		$coo_response_xml = simplexml_load_string($t_response_xml_content); 
		
		$coo_response_xml->addChild('request');
		$coo_response_xml->request->addChild('success', 0);
		$coo_response_xml->request->addChild('errormessage', 'session_key is not valid');
		
		return $coo_response_xml;
	}
	
	private function set_session_lifetime($p_lifetime_in_seconds)
	{
		$this->v_session_lifetime = (int)$p_lifetime_in_seconds;
	}
	
	private function get_session_lifetime()
	{
		return $this->v_session_lifetime;
	}

	private function clean_up_sessions_array()
	{
		$t_sessions_array = $this->get_sessions_array();
		foreach($t_sessions_array AS $t_session_key => $t_session_time)
		{
			if($t_session_time + $this->get_session_lifetime() < time())
			{
				unset($t_sessions_array[$t_session_key]);
			}
		}
		
		$this->set_sessions_array($t_sessions_array);
	}
	
	private function create_session_key()
	{
		$t_sessions_array = $this->get_sessions_array();
		
		$t_session_key = md5(time() . rand());
		$t_sessions_array[$t_session_key] = time();
		
		$this->set_sessions_array($t_sessions_array);
		
		return $t_session_key;
	}
	
	private function update_session_key($p_session_key)
	{
		$c_session_key = (string)$p_session_key;	
		
		if(!empty($c_session_key))
		{
			$t_sessions_array = $this->get_sessions_array();
			if(isset($t_sessions_array[$c_session_key]))
			{
				$t_sessions_array[$c_session_key] = time();
				
				$this->set_sessions_array($t_sessions_array);
			}
		}
		
	}
	
	// not used yet
	private function destroy_session($p_session_key)
	{
		$c_session_key = (string)$p_session_key;	
		
		if(!empty($c_session_key))
		{
			$t_sessions_array = $this->get_sessions_array();
		
			if(isset($t_sessions_array[$c_session_key]))
			{
				unset($t_sessions_array[$c_session_key]);
				
				$this->set_sessions_array($t_sessions_array);
			}
		}		
	}
	
	public function validate_session_key($p_session_key)
	{
		$t_valid = false;
		
		$c_session_key = (string)$p_session_key;
		if(!empty($c_session_key))
		{
			$t_sessions_array = $this->get_sessions_array();
			if(isset($t_sessions_array[$c_session_key]))
			{
				$t_session_time = $t_sessions_array[$c_session_key];
				if($t_session_time + $this->get_session_lifetime() > time())
				{
					$t_valid = true;
					
					$this->update_session_key($c_session_key);					
				}
			}
		}
		
		return $t_valid;
	}
	
	private function get_cache_filepath()
	{
		return DIR_FS_CATALOG . 'cache/gxml_sessions-' . FileLog::get_secure_token();
	}
	
	private function set_sessions_array($p_sessions_array)
	{
		$t_sessions_data = serialize($p_sessions_array);
		
		if(!file_exists($this->get_cache_filepath()) || is_writable($this->get_cache_filepath()))
		{
			file_put_contents($this->get_cache_filepath(), $t_sessions_data);
		}
		else
		{
			trigger_error('cannot write cache data, because cache file is not writable: ' . $this->get_cache_filepath(), E_USER_ERROR);
		}
	}
	
	private function get_sessions_array()
	{
		$t_sessions_array = array();
		
		if(file_exists($this->get_cache_filepath()) && is_readable($this->get_cache_filepath()))
		{
			$t_sessions_data = file_get_contents($this->get_cache_filepath());
			$t_unserialize_data = unserialize($t_sessions_data);
			if(is_array($t_unserialize_data))
			{
				$t_sessions_array = $t_unserialize_data;
			}
		}
		
		return $t_sessions_array;
	}
}

?>