<?php
/* --------------------------------------------------------------
  GxmlCategories.inc.php 2014-01-31 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2014 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------
 */

class GxmlCategories extends GxmlMaster
{

	public function __construct() 
	{
		parent::__construct();
		$this->set_plural_name('categories');
		$this->set_singular_name('category');
		$this->build_mapper_array();
		$this->build_table_mapper_array();
	}
	
	protected function build_mapper_array()
	{
		$this->v_mapper_array = array();
		
		$this->v_mapper_array['category_id'] = 'categories_id';
		$this->v_mapper_array['parent_id'] = 'parent_id';
		$this->v_mapper_array['status'] = 'categories_status';
		$this->v_mapper_array['image'] = 'categories_image';
		$this->v_mapper_array['image_url'] = 'categories_image';
		$this->v_mapper_array['template'] = 'categories_template';
		$this->v_mapper_array['listing_template'] = 'listing_template';
		$this->v_mapper_array['sort_order'] = 'sort_order';
		$this->v_mapper_array['product_sorting'] = 'products_sorting';
		$this->v_mapper_array['product_sorting2'] = 'products_sorting2';
		$this->v_mapper_array['date_added'] = 'date_added';
		$this->v_mapper_array['last_modified'] = 'last_modified';
		$this->v_mapper_array['category_icon'] = 'categories_icon';
		$this->v_mapper_array['category_icon_url'] = 'categories_icon';
		$this->v_mapper_array['priority'] = 'gm_priority';
		$this->v_mapper_array['change_frequency'] = 'gm_changefreq';
		$this->v_mapper_array['show_attributes'] = 'gm_show_attributes';
		$this->v_mapper_array['show_graduated_prices'] = 'gm_show_graduated_prices';
		$this->v_mapper_array['show_quantity'] = 'gm_show_qty';
		$this->v_mapper_array['sitemap_entry'] = 'gm_sitemap_entry';
		$this->v_mapper_array['show_quantity_info'] = 'gm_show_qty_info';
		$this->v_mapper_array['show_sub_categories'] = 'show_sub_categories';
		$this->v_mapper_array['show_sub_categories_images'] = 'show_sub_categories_images';
		$this->v_mapper_array['show_sub_categories_names'] = 'show_sub_categories_names';
		$this->v_mapper_array['show_sub_products'] = 'show_sub_products';
		$this->v_mapper_array['view_mode_tiled'] = 'show_sub_products';
		
		$this->v_mapper_array['customer_group_permission'] = 'group_permission_';
				
		$this->v_mapper_array['name'] = 'categories_name';
		$this->v_mapper_array['heading_title'] = 'categories_heading_title';
		$this->v_mapper_array['description'] = 'categories_description';
		$this->v_mapper_array['meta_title'] = 'categories_meta_title';
		$this->v_mapper_array['meta_description'] = 'categories_meta_description';
		$this->v_mapper_array['meta_keywords'] = 'categories_meta_keywords';
		$this->v_mapper_array['image_alt_text'] = 'gm_alt_text';
		$this->v_mapper_array['url_keywords'] = 'gm_url_keywords';
	}
	
	protected function build_table_mapper_array()
	{
		$this->v_table_mapper_array = array();
		
		$this->v_table_mapper_array['category_id'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['parent_id'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['status'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['image'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['image_url'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['template'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['listing_template'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['sort_order'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['product_sorting'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['product_sorting2'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['date_added'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['last_modified'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['category_icon'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['category_icon_url'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['priority'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['change_frequency'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['show_attributes'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['show_graduated_prices'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['show_quantity'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['sitemap_entry'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['show_quantity_info'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['show_sub_categories'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['show_sub_categories_images'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['show_sub_categories_names'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['show_sub_products'] = TABLE_CATEGORIES;
		$this->v_table_mapper_array['view_mode_tiled'] = TABLE_CATEGORIES;
		
		$this->v_table_mapper_array['customer_group_permission'] = TABLE_CATEGORIES;
				
		$this->v_table_mapper_array['name'] = TABLE_CATEGORIES_DESCRIPTION;
		$this->v_table_mapper_array['heading_title'] = TABLE_CATEGORIES_DESCRIPTION;
		$this->v_table_mapper_array['description'] = TABLE_CATEGORIES_DESCRIPTION;
		$this->v_table_mapper_array['meta_title'] = TABLE_CATEGORIES_DESCRIPTION;
		$this->v_table_mapper_array['meta_description'] = TABLE_CATEGORIES_DESCRIPTION;
		$this->v_table_mapper_array['meta_keywords'] = TABLE_CATEGORIES_DESCRIPTION;
		$this->v_table_mapper_array['image_alt_text'] = TABLE_CATEGORIES_DESCRIPTION;
		$this->v_table_mapper_array['url_keywords'] = TABLE_CATEGORIES_DESCRIPTION;
                
		$this->v_language_dependent_mapper_array = array(TABLE_CATEGORIES_DESCRIPTION);
	}
	

	function download_categories($p_coo_request_xml)
	{
		$t_parameters_array = $this->build_sql_strings($p_coo_request_xml->parameters, array('limit', 'where'));
				
		$this->v_coo_response_xml->addChild('request');
		$this->v_coo_response_xml->request->addChild('success', 1);
				
		$this->add_blocks(array('languages'));
		
		$this->add_categories_block($t_parameters_array);

		return $this->v_coo_response_xml;
	}
	
	function add_categories_block($p_parameters_array = array())
	{
		$this->v_coo_response_xml->addChild('categories');
		
		$t_where_part = $this->build_where_part($p_parameters_array, true);
		$t_limitation = '';
		$t_category_ids_array = true;
		
		if(count($p_parameters_array) > 0)
		{
			$t_category_ids_array = array();
			
			$t_limit_part = ' GROUP BY ' . TABLE_CATEGORIES . '.categories_id' . $this->build_limit_part($p_parameters_array);
			
			$t_sql = "SELECT 
							" . TABLE_CATEGORIES . ".categories_id
						FROM 
							" . TABLE_CATEGORIES . ",
							" . TABLE_CATEGORIES_DESCRIPTION . "
						WHERE
							" . TABLE_CATEGORIES . ".categories_id = " . TABLE_CATEGORIES_DESCRIPTION . ".categories_id
							" . $t_where_part . "
						" . $t_limit_part;
			$t_result = xtc_db_query($t_sql);
			while($t_result_array = xtc_db_fetch_array($t_result))
			{
				$t_category_ids_array[] = $t_result_array['categories_id'];
			}
			
			$t_limit = 0;
			$t_offset = 0;
			if(isset($p_parameters_array['offset']) && !empty($p_parameters_array['offset']))
			{
				$t_offset = (int)$p_parameters_array['offset'];
			}

			if(isset($p_parameters_array['limit']) && !empty($p_parameters_array['limit']))
			{
				$t_limit = (int)$p_parameters_array['limit'];
				
				if(!empty($t_category_ids_array))
				{					
					$t_limitation .= ' AND ' . TABLE_CATEGORIES . '.categories_id IN (' . implode(',', $t_category_ids_array) . ') ';
				}
			}			
		}
		
		if(empty($t_category_ids_array) == false)
		{
			$t_sql = "SELECT 
							* 
						FROM 
							" . TABLE_CATEGORIES . ",
							" . TABLE_CATEGORIES_DESCRIPTION . "
						WHERE
							" . TABLE_CATEGORIES . ".categories_id = " . TABLE_CATEGORIES_DESCRIPTION . ".categories_id
							" . $t_where_part . "
							" . $t_limitation;
			$t_result = xtc_db_query($t_sql);

			$t_last_categories_id = 0;
			while($t_row = xtc_db_fetch_array($t_result))
			{
				if($t_last_categories_id != $t_row['categories_id'])
				{
					$coo_category_child = $this->v_coo_response_xml->categories->addChild('category');
				}

				$this->add($t_row, $coo_category_child);

				$t_last_categories_id = $t_row['categories_id'];
			}
		}
	}
	
	
	protected function delete_object(SimpleXMLElement $p_coo_xml)
	{
		$t_category_data_array = $this->build_data_array($p_coo_xml);
		$t_category_data_array = $this->convert_to_latin1($t_category_data_array);
		$t_categories_id = (string)$p_coo_xml->category_id;
		$t_delete_array = array();
		$t_success = true;
		
		// select all categories_ids
		if(empty($t_categories_id))
		{
			$t_sql = '
					SELECT categories_id
					FROM categories
					WHERE 
					';
			foreach($t_category_data_array['categories'] as $t_key => $t_value)
			{
				$t_sql .= $t_key . ' LIKE \'' . $t_value . '\' AND ';
			}
			$t_sql = substr($t_sql, 0, strlen($t_sql) - 5);
			
			$t_result = xtc_db_query($t_sql);
			if(xtc_db_num_rows($t_result));
			{
				while($t_row = xtc_db_fetch_array($t_result))
				{
					$t_delete_array[] = $t_row['categories_id'];
				}
			}
		}
		else
		{
			$t_delete_array[] = $t_categories_id;
		}
		
		// delete from categories and categories_description
		if (!empty($t_delete_array))
		{
			$t_sql = '
					DELETE c.*, cd.* 
					FROM 
						categories c, categories_description cd
					WHERE 
						c.categories_id IN (' . implode(', ', $t_delete_array) . ') AND 
						c.categories_id = cd.categories_id
					';
			$t_success &= $this->perform_db_action($t_sql);
			
			$t_sql = '
					DELETE FROM categories_filter
					WHERE 
						categories_id IN (' . implode(', ', $t_delete_array) . ')
					';
			$t_success &= $this->perform_db_action($t_sql);
		}
		
		// select all affected sub-categories
		$t_subcategories_array = array();
		if (!empty($t_delete_array))
		{
			$t_sql = '
					SELECT categories_id
					FROM categories
					WHERE parent_id IN (' . implode(', ', $t_delete_array) . ')
					';
			$t_result = $this->perform_db_action($t_sql);
			$t_success &= $t_result;
			if(xtc_db_num_rows($t_result))
			{
				while($t_row = xtc_db_fetch_array($t_result))
				{
					$t_subcategories_array[] = $t_row['categories_id'];
				}
			}
		}
		
		if (!empty($t_delete_array) && !empty($t_subcategories_array))
		{
			// set parent_id from all affected sub-categories to '0'
			$t_sql = '
					UPDATE categories
					SET parent_id = 0
					WHERE categories_id IN (' . implode(', ', $t_subcategories_array) . ')
					';
			$t_success &= $this->perform_db_action($t_sql);
		}
		
		// set parent_id from all products deleted categories and their sub-categories to '0'
		if (!empty($t_delete_array))
		{
			$t_sql = '
					UPDATE products_to_categories
					SET categories_id = 0
					WHERE 
						categories_id IN (' . implode(', ', $t_delete_array) . ')
					';
			$t_success &= $this->perform_db_action($t_sql);
		}
		
		return $t_success;
	}
	
	private function sort_categories_by_unknown_parents($p_cat_array_without_parent, &$p_sorted_category_array)
	{
		if(empty($p_cat_array_without_parent))
		{
			return;
		}
		
		$t_filtered_categories_array = $p_cat_array_without_parent;
		
		foreach($p_cat_array_without_parent as $t_pos => $t_category)
		{
			foreach($p_sorted_category_array as $t_possible_parent)
			{
				if(isset($t_category->external_parent_id) && 
					isset($t_possible_parent->external_category_id) && 
					(string)$t_category->external_parent_id == (string)$t_possible_parent->external_category_id)
				{
					$p_sorted_category_array[] = $t_category;
					unset($t_filtered_categories_array[$t_pos]);
				}
			}
		}
		$t_filtered_categories_array = array_values($t_filtered_categories_array);
		$this->sort_categories_by_unknown_parents($t_filtered_categories_array, $p_sorted_category_array);
		
	}

	function upload_categories($p_coo_request_xml)
	{
		$t_last_category_id = false;
		$t_response_array = array();
		$count_categories_child = 0;
		
		$t_categories_to_delete_array = $p_coo_request_xml->xpath("//category[@action='delete']"); 
		$t_sorted_category_array = $p_coo_request_xml->xpath("//category[(parent_id) and not (@action='delete')]");
		$t_cat_array_without_parent = $p_coo_request_xml->xpath("//category[not (parent_id) and (external_parent_id) and not (@action='delete')]");
		
		$this->sort_categories_by_unknown_parents($t_cat_array_without_parent, $t_sorted_category_array);
		
		$this->delete_xml_children_by_tag_name($p_coo_request_xml->parameters->categories, 'category');
		foreach ($t_sorted_category_array as $t_category)
		{
			$this->add_xml_child($p_coo_request_xml->parameters->categories, $t_category);
		}
		
		foreach ($t_categories_to_delete_array as $t_category)
		{
			$this->add_xml_child($p_coo_request_xml->parameters->categories, $t_category);
		}
		
		foreach ($p_coo_request_xml->parameters->categories->children() as $t_category_xml)
		{
			if($t_last_category_id !== false && !isset($t_category_xml->parent_id))
			{
				$t_category_xml->parent_id = $t_last_category_id;
			}
			
			$count_categories_child++;
			$t_last_category_id = $this->upload($t_category_xml, $t_response_array);
		}
		$t_output_xml = $this->build_response_xml($t_response_array);
		
		return $t_output_xml;
	}
	
	public function add_node($p_data_array, $p_table_column, $p_xml_name, $p_coo_xml)
	{
		switch($p_xml_name)
		{
			case 'name':
			case 'heading_title':
			case 'description':
			case 'meta_title':
			case 'meta_description':
			case 'meta_keywords':
			case 'image_alt_text':
			case 'url_keywords':
				if ($this->node_exists($p_coo_xml, $p_xml_name, array('language_id' => $p_data_array['language_id'], 'language_iso' => $this->v_language_array[$p_data_array['language_id']]['iso']), 'or') === false)
				{
					$p_coo_xml->addChild($p_xml_name);
					$p_coo_xml->{$p_xml_name}[count($p_coo_xml->{$p_xml_name}) - 1] = $this->wrap_value($p_data_array[$p_table_column]);
					$coo_child = $p_coo_xml->{$p_xml_name}[count($p_coo_xml->{$p_xml_name}) - 1];
					$coo_child['language_id'] = $p_data_array['language_id'];
					$coo_child['language_iso'] = $this->v_language_array[$p_data_array['language_id']]['iso'];
					
					if($p_xml_name == 'description' ||
						$p_xml_name == 'meta_keywords')
					{
						$coo_child['type'] = 2;
					}
				}
				
				break;
				
			case 'customer_group_permission':
				if($this->node_exists($p_coo_xml, $p_xml_name) === false)
				{
					foreach($p_data_array AS $t_column => $t_value)
					{
						if(strpos($t_column, 'group_permission_') !== false)
						{
							$p_coo_xml->addChild($p_xml_name);
							$p_coo_xml->{$p_xml_name}[count($p_coo_xml->{$p_xml_name}) - 1] = $t_value;
							$coo_child = $p_coo_xml->{$p_xml_name}[count($p_coo_xml->{$p_xml_name}) - 1];
							$coo_child['customer_group_id'] = str_replace('group_permission_', '', $t_column);
						}
					}
				}
				
				break;
				
			case 'icon':
				if($this->node_exists($p_coo_xml, $p_xml_name) === false)
				{
					$p_coo_xml->{$p_xml_name} = $this->wrap_value($p_data_array[$p_table_column]);
					$p_coo_xml->{$p_xml_name}['width'] = $p_data_array['categories_icon_w'];
					$p_coo_xml->{$p_xml_name}['height'] = $p_data_array['categories_icon_h'];
				}
				
				break;
				
			case 'icon_url':
				if($this->node_exists($p_coo_xml, $p_xml_name) === false)
				{
					$t_category_icon_url = '';
					if(empty($p_data_array[$p_table_column]) === false)
					{
						$t_category_icon_url = HTTP_SERVER . DIR_WS_CATALOG . DIR_WS_IMAGES . 'categories/icons/' . $p_data_array[$p_table_column];
					}
					$p_coo_xml->{$p_xml_name} = $this->wrap_value($t_category_icon_url);
				}
				
				break;
					
			case 'image_url':
				if($this->node_exists($p_coo_xml, $p_xml_name) === false)
				{
					$t_category_image_url = '';
					if(empty($p_data_array[$p_table_column]) === false)
					{
						$t_category_image_url = HTTP_SERVER . DIR_WS_CATALOG . DIR_WS_IMAGES . 'categories/' . $p_data_array[$p_table_column];
					}
					
					$p_coo_xml->{$p_xml_name} = $this->wrap_value($t_category_image_url);
				}
				
				break;
			
			case 'category_icon':
			case 'category_icon_url':
			case 'image':
			case 'listing_template':
			case 'template':
				if($this->node_exists($p_coo_xml, $p_xml_name) === false)
				{
					$p_coo_xml->{$p_xml_name} = $this->wrap_value($p_data_array[$p_table_column]);
				}
				break;
				
			default:
				if($this->node_exists($p_coo_xml, $p_xml_name) === false)
				{
					$p_coo_xml->{$p_xml_name} = $p_data_array[$p_table_column];
				}
				
				break;
		}
	}
	
}