<?php
/* --------------------------------------------------------------
  GxmlOrder.inc.php 2014-01-31 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2014 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------
 */

/**
 * Description of GxmlOrders
 *
 * @author wu
 */
class GxmlOrders extends GxmlMaster
{
	public function __construct() 
	{
		parent::__construct();
		$this->set_plural_name('orders');
		$this->set_singular_name('order');
		$this->build_mapper_array();
		$this->build_table_mapper_array();
	}
	
	protected function build_mapper_array()
	{
		$this->v_mapper_array = array();
		
		$this->v_mapper_array['order_id'] = 'orders_id';
		$this->v_mapper_array['order_status_id'] = 'orders_status';
		$this->v_mapper_array['currency'] = 'currency';
		$this->v_mapper_array['currency_value'] = 'currency_value';
		$this->v_mapper_array['account_type'] = 'account_type';
		$this->v_mapper_array['payment_class'] = 'payment_class';
		$this->v_mapper_array['shipping_method'] = 'shipping_method';
		$this->v_mapper_array['shipping_class'] = 'shipping_class';
		$this->v_mapper_array['customer_ip'] = 'customers_ip';
		$this->v_mapper_array['language'] = 'language';
		$this->v_mapper_array['afterbuy_success'] = 'afterbuy_success';
		$this->v_mapper_array['afterbuy_id'] = 'afterbuy_id';
		$this->v_mapper_array['referrer_id'] = 'refferers_id';
		$this->v_mapper_array['conversion_type'] = 'conversion_type';
		$this->v_mapper_array['confirmation_send_date'] = 'gm_order_send_date';
		$this->v_mapper_array['confirmation_sent'] = 'gm_send_order_status';
		$this->v_mapper_array['customer_id'] = 'customers_id';
		$this->v_mapper_array['customer_number'] = 'customers_cid';
		$this->v_mapper_array['customer_vat_id'] = 'customers_vat_id';
		$this->v_mapper_array['customer_status_id'] = 'customers_status';
		$this->v_mapper_array['customer_status_name'] = 'customers_status_name';
		$this->v_mapper_array['customer_status_image'] = 'customers_status_image';
		$this->v_mapper_array['customer_status_discount'] = 'customers_status_discount';
		$this->v_mapper_array['customer_name'] = 'customers_name';
		$this->v_mapper_array['customer_firstname'] = 'customers_firstname';
		$this->v_mapper_array['customer_lastname'] = 'customers_lastname';
		$this->v_mapper_array['customer_company'] = 'customers_company';
		$this->v_mapper_array['customer_street_address'] = 'customers_street_address';
		$this->v_mapper_array['customer_suburb'] = 'customers_suburb';
		$this->v_mapper_array['customer_city'] = 'customers_city';
		$this->v_mapper_array['customer_postcode'] = 'customers_postcode';
		$this->v_mapper_array['customer_state'] = 'customers_state';
		$this->v_mapper_array['customer_country'] = 'customers_country';
		$this->v_mapper_array['customer_telephone'] = 'customers_telephone';
		$this->v_mapper_array['customer_email_address'] = 'customers_email_address';
		$this->v_mapper_array['customer_address_format_id'] = 'customers_address_format_id';
		$this->v_mapper_array['delivery_name'] = 'delivery_name';
		$this->v_mapper_array['delivery_firstname'] = 'delivery_firstname';
		$this->v_mapper_array['delivery_lastname'] = 'delivery_lastname';
		$this->v_mapper_array['delivery_company'] = 'delivery_company';
		$this->v_mapper_array['delivery_street_address'] = 'delivery_street_address';
		$this->v_mapper_array['delivery_suburb'] = 'delivery_suburb';
		$this->v_mapper_array['delivery_city'] = 'delivery_city';
		$this->v_mapper_array['delivery_postcode'] = 'delivery_postcode';
		$this->v_mapper_array['delivery_state'] = 'delivery_state';
		$this->v_mapper_array['delivery_country'] = 'delivery_country';
		$this->v_mapper_array['delivery_country_iso_code'] = 'delivery_country_iso_code_2';
		$this->v_mapper_array['delivery_address_format_id'] = 'delivery_address_format_id';
		$this->v_mapper_array['billing_name'] = 'billing_name';
		$this->v_mapper_array['billing_firstname'] = 'billing_firstname';
		$this->v_mapper_array['billing_lastname'] = 'billing_lastname';
		$this->v_mapper_array['billing_company'] = 'billing_company';
		$this->v_mapper_array['billing_street_address'] = 'billing_street_address';
		$this->v_mapper_array['billing_suburb'] = 'billing_suburb';
		$this->v_mapper_array['billing_city'] = 'billing_city';
		$this->v_mapper_array['billing_postcode'] = 'billing_postcode';
		$this->v_mapper_array['billing_state'] = 'billing_state';
		$this->v_mapper_array['billing_country'] = 'billing_country';
		$this->v_mapper_array['billing_country_iso_code'] = 'billing_country_iso_code_2';
		$this->v_mapper_array['billing_address_format_id'] = 'billing_address_format_id';
		$this->v_mapper_array['payment_method'] = 'payment_method';
		$this->v_mapper_array['credit_card_type'] = 'cc_type';
		$this->v_mapper_array['credit_card_owner'] = 'cc_owner';
		$this->v_mapper_array['credit_card_number'] = 'cc_number';
		$this->v_mapper_array['credit_card_expires'] = 'cc_expires';
		$this->v_mapper_array['credit_card_start'] = 'cc_start';
		$this->v_mapper_array['credit_card_issue'] = 'cc_issue';
		$this->v_mapper_array['credit_card_cvv'] = 'cc_cvv';
		$this->v_mapper_array['comments'] = 'comments';
		$this->v_mapper_array['date_purchased'] = 'date_purchased';
		$this->v_mapper_array['cancel_date'] = 'gm_cancel_date';
		$this->v_mapper_array['last_modified'] = 'last_modified';
		$this->v_mapper_array['date_finished'] = 'orders_date_finished';
		$this->v_mapper_array['exported'] = 'exported';
		$this->v_mapper_array['products/product/order_product_id'] = 'o_products_id';
		$this->v_mapper_array['products/product/product_id'] = 'products_id';
		$this->v_mapper_array['products/product/model'] = 'products_model';
		$this->v_mapper_array['products/product/name'] = 'products_name';
		$this->v_mapper_array['products/product/price'] = 'products_price';
		$this->v_mapper_array['products/product/discount_made'] = 'products_discount_made';
		$this->v_mapper_array['products/product/shipping_time'] = 'products_shipping_time';
		$this->v_mapper_array['products/product/final_price'] = 'final_price';
		$this->v_mapper_array['products/product/tax_rate'] = 'products_tax';
		$this->v_mapper_array['products/product/quantity'] = 'products_quantity';
		$this->v_mapper_array['products/product/allow_tax'] = 'allow_tax';
		$this->v_mapper_array['products/product/quantity_unit_id'] = 'quantity_unit_id';
		$this->v_mapper_array['products/product/unit_name'] = 'unit_name';
		$this->v_mapper_array['products/product/attributes/attribute/order_product_attribute_id'] = 'orders_products_attributes_id';
		$this->v_mapper_array['products/product/attributes/attribute/name'] = 'products_options';
		$this->v_mapper_array['products/product/attributes/attribute/value'] = 'products_options_values';
		$this->v_mapper_array['products/product/attributes/attribute/price'] = 'options_values_price';
		$this->v_mapper_array['products/product/attributes/attribute/price_prefix'] = 'price_prefix';
 		$this->v_mapper_array['products/product/properties/property/order_product_property_id'] = 'orders_products_properties_id';
		$this->v_mapper_array['products/product/properties/property/product_combi_id'] = 'products_properties_combis_id';
		$this->v_mapper_array['products/product/properties/property/name'] = 'properties_name';
		$this->v_mapper_array['products/product/properties/property/value'] = 'values_name';
		$this->v_mapper_array['products/product/properties/property/price_type'] = 'properties_price_type';
		$this->v_mapper_array['products/product/properties/property/price'] = 'properties_price';
  		$this->v_mapper_array['products/product/gprint_elements/gprint_element/gprint_element_id'] = 'gm_gprint_orders_elements_id';
		$this->v_mapper_array['products/product/gprint_elements/gprint_element/name'] = 'name';
		$this->v_mapper_array['products/product/gprint_elements/gprint_element/value'] = 'elements_value';
		$this->v_mapper_array['products/product/gprint_elements/gprint_element/download_url'] = 'download_key';
 		$this->v_mapper_array['totals/total/order_total_id'] = 'orders_total_id';
		$this->v_mapper_array['totals/total/title'] = 'title';
		$this->v_mapper_array['totals/total/text'] = 'text';
		$this->v_mapper_array['totals/total/value'] = 'value';
		$this->v_mapper_array['totals/total/class'] = 'class';
		$this->v_mapper_array['totals/total/sort_order'] = 'sort_order';
		$this->v_mapper_array['status_history/status_history_entry/order_status_history_id'] = 'orders_status_history_id';
		$this->v_mapper_array['status_history/status_history_entry/order_status_id'] = 'orders_status_id';
		$this->v_mapper_array['status_history/status_history_entry/date_added'] = 'date_added';
		$this->v_mapper_array['status_history/status_history_entry/customer_notified'] = 'customer_notified';
		$this->v_mapper_array['status_history/status_history_entry/comments'] = 'comments';
		$this->v_mapper_array['status_history/order_status_id'] = 'orders_status_id';
		$this->v_mapper_array['status_history/date_added'] = 'date_added';
		$this->v_mapper_array['status_history/customer_notified'] = 'customer_notified';
		$this->v_mapper_array['status_history/comments'] = 'comments';
	}
	
	protected function build_table_mapper_array()
	{
		$this->v_table_mapper_array = array();	
		
		$this->v_table_mapper_array['order_id'] = TABLE_ORDERS;
		$this->v_table_mapper_array['order_status_id'] = TABLE_ORDERS;
		$this->v_table_mapper_array['currency'] = TABLE_ORDERS;
		$this->v_table_mapper_array['currency_value'] = TABLE_ORDERS;
		$this->v_table_mapper_array['account_type'] = TABLE_ORDERS;
		$this->v_table_mapper_array['payment_class'] = TABLE_ORDERS;
		$this->v_table_mapper_array['shipping_method'] = TABLE_ORDERS;
		$this->v_table_mapper_array['shipping_class'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_ip'] = TABLE_ORDERS;
		$this->v_table_mapper_array['language'] = TABLE_ORDERS;
		$this->v_table_mapper_array['afterbuy_success'] = TABLE_ORDERS;
		$this->v_table_mapper_array['afterbuy_id'] = TABLE_ORDERS;
		$this->v_table_mapper_array['referrer_id'] = TABLE_ORDERS;
		$this->v_table_mapper_array['conversion_type'] = TABLE_ORDERS;
		$this->v_table_mapper_array['confirmation_email_html'] = TABLE_ORDERS;
		$this->v_table_mapper_array['confirmation_email_txt'] = TABLE_ORDERS;
		$this->v_table_mapper_array['confirmation_send_date'] = TABLE_ORDERS;
		$this->v_table_mapper_array['confirmation_sent'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_id'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_number'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_vat_id'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_status_id'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_status_name'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_status_image'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_status_discount'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_name'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_firstname'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_lastname'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_company'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_street_address'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_suburb'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_city'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_postcode'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_state'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_country'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_telephone'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_email_address'] = TABLE_ORDERS;
		$this->v_table_mapper_array['customer_address_format_id'] = TABLE_ORDERS;
		$this->v_table_mapper_array['delivery_name'] = TABLE_ORDERS;
		$this->v_table_mapper_array['delivery_firstname'] = TABLE_ORDERS;
		$this->v_table_mapper_array['delivery_lastname'] = TABLE_ORDERS;
		$this->v_table_mapper_array['delivery_company'] = TABLE_ORDERS;
		$this->v_table_mapper_array['delivery_street_address'] = TABLE_ORDERS;
		$this->v_table_mapper_array['delivery_suburb'] = TABLE_ORDERS;
		$this->v_table_mapper_array['delivery_city'] = TABLE_ORDERS;
		$this->v_table_mapper_array['delivery_postcode'] = TABLE_ORDERS;
		$this->v_table_mapper_array['delivery_state'] = TABLE_ORDERS;
		$this->v_table_mapper_array['delivery_country'] = TABLE_ORDERS;
		$this->v_table_mapper_array['delivery_country_iso_code'] = TABLE_ORDERS;
		$this->v_table_mapper_array['delivery_address_format_id'] = TABLE_ORDERS;
		$this->v_table_mapper_array['billing_name'] = TABLE_ORDERS;
		$this->v_table_mapper_array['billing_firstname'] = TABLE_ORDERS;
		$this->v_table_mapper_array['billing_lastname'] = TABLE_ORDERS;
		$this->v_table_mapper_array['billing_company'] = TABLE_ORDERS;
		$this->v_table_mapper_array['billing_street_address'] = TABLE_ORDERS;
		$this->v_table_mapper_array['billing_suburb'] = TABLE_ORDERS;
		$this->v_table_mapper_array['billing_city'] = TABLE_ORDERS;
		$this->v_table_mapper_array['billing_postcode'] = TABLE_ORDERS;
		$this->v_table_mapper_array['billing_state'] = TABLE_ORDERS;
		$this->v_table_mapper_array['billing_country'] = TABLE_ORDERS;
		$this->v_table_mapper_array['billing_country_iso_code'] = TABLE_ORDERS;
		$this->v_table_mapper_array['billing_address_format_id'] = TABLE_ORDERS;
		$this->v_table_mapper_array['payment_method'] = TABLE_ORDERS;
		$this->v_table_mapper_array['credit_card_type'] = TABLE_ORDERS;
		$this->v_table_mapper_array['credit_card_owner'] = TABLE_ORDERS;
		$this->v_table_mapper_array['credit_card_number'] = TABLE_ORDERS;
		$this->v_table_mapper_array['credit_card_expires'] = TABLE_ORDERS;
		$this->v_table_mapper_array['credit_card_start'] = TABLE_ORDERS;
		$this->v_table_mapper_array['credit_card_issue'] = TABLE_ORDERS;
		$this->v_table_mapper_array['credit_card_cvv'] = TABLE_ORDERS;
		$this->v_table_mapper_array['comments'] = TABLE_ORDERS;
		$this->v_table_mapper_array['date_purchased'] = TABLE_ORDERS;
		$this->v_table_mapper_array['cancel_date'] = TABLE_ORDERS;
		$this->v_table_mapper_array['last_modified'] = TABLE_ORDERS;
		$this->v_table_mapper_array['date_finished'] = TABLE_ORDERS;
		$this->v_table_mapper_array['exported'] = TABLE_ORDERS;
		$this->v_table_mapper_array['products/product/order_product_id'] = TABLE_ORDERS_PRODUCTS;
		$this->v_table_mapper_array['products/product/product_id'] = TABLE_ORDERS_PRODUCTS;
		$this->v_table_mapper_array['products/product/model'] = TABLE_ORDERS_PRODUCTS;
		$this->v_table_mapper_array['products/product/name'] = TABLE_ORDERS_PRODUCTS;
		$this->v_table_mapper_array['products/product/price'] = TABLE_ORDERS_PRODUCTS;
		$this->v_table_mapper_array['products/product/discount_made'] = TABLE_ORDERS_PRODUCTS;
		$this->v_table_mapper_array['products/product/shipping_time'] = TABLE_ORDERS_PRODUCTS;
		$this->v_table_mapper_array['products/product/final_price'] = TABLE_ORDERS_PRODUCTS;
		$this->v_table_mapper_array['products/product/tax_rate'] = TABLE_ORDERS_PRODUCTS;
		$this->v_table_mapper_array['products/product/quantity'] = TABLE_ORDERS_PRODUCTS;
		$this->v_table_mapper_array['products/product/allow_tax'] = TABLE_ORDERS_PRODUCTS;
		$this->v_table_mapper_array['products/product/quantity_unit_id'] = 'orders_products_quantity_units';
		$this->v_table_mapper_array['products/product/unit_name'] = 'orders_products_quantity_units';
		$this->v_table_mapper_array['products/product/attributes/attribute/order_product_attribute_id'] = TABLE_ORDERS_PRODUCTS_ATTRIBUTES;
		$this->v_table_mapper_array['products/product/attributes/attribute/name'] = TABLE_ORDERS_PRODUCTS_ATTRIBUTES;
		$this->v_table_mapper_array['products/product/attributes/attribute/value'] = TABLE_ORDERS_PRODUCTS_ATTRIBUTES;
		$this->v_table_mapper_array['products/product/attributes/attribute/price'] = TABLE_ORDERS_PRODUCTS_ATTRIBUTES;
		$this->v_table_mapper_array['products/product/attributes/attribute/price_prefix'] = TABLE_ORDERS_PRODUCTS_ATTRIBUTES;
		$this->v_table_mapper_array['products/product/properties/property/order_product_property_id'] = 'orders_products_properties';
		$this->v_table_mapper_array['products/product/properties/property/product_combi_id'] = 'orders_products_properties';
		$this->v_table_mapper_array['products/product/properties/property/name'] = 'orders_products_properties';
		$this->v_table_mapper_array['products/product/properties/property/value'] = 'orders_products_properties';
		$this->v_table_mapper_array['products/product/properties/property/price_type'] = 'orders_products_properties';
		$this->v_table_mapper_array['products/product/properties/property/price'] = 'orders_products_properties';
		$this->v_table_mapper_array['products/product/gprint_elements/gprint_element/gprint_element_id'] = 'gm_gprint_orders_elements';
		$this->v_table_mapper_array['products/product/gprint_elements/gprint_element/name'] = 'gm_gprint_orders_elements';
		$this->v_table_mapper_array['products/product/gprint_elements/gprint_element/value'] = 'gm_gprint_orders_elements';
		$this->v_table_mapper_array['products/product/gprint_elements/gprint_element/download_url'] = 'gm_gprint_uploads';
		$this->v_table_mapper_array['totals/total/order_total_id'] = TABLE_ORDERS_TOTAL;
		$this->v_table_mapper_array['totals/total/title'] = TABLE_ORDERS_TOTAL;
		$this->v_table_mapper_array['totals/total/text'] = TABLE_ORDERS_TOTAL;
		$this->v_table_mapper_array['totals/total/value'] = TABLE_ORDERS_TOTAL;
		$this->v_table_mapper_array['totals/total/class'] = TABLE_ORDERS_TOTAL;
		$this->v_table_mapper_array['totals/total/sort_order'] = TABLE_ORDERS_TOTAL;
		$this->v_table_mapper_array['status_history/status_history_entry/order_status_history_id'] = TABLE_ORDERS_STATUS_HISTORY;
		$this->v_table_mapper_array['status_history/status_history_entry/order_status_id'] = TABLE_ORDERS_STATUS_HISTORY;
		$this->v_table_mapper_array['status_history/status_history_entry/date_added'] = TABLE_ORDERS_STATUS_HISTORY;
		$this->v_table_mapper_array['status_history/status_history_entry/customer_notified'] = TABLE_ORDERS_STATUS_HISTORY;
		$this->v_table_mapper_array['status_history/status_history_entry/comments'] = TABLE_ORDERS_STATUS_HISTORY;
		$this->v_table_mapper_array['status_history/order_status_id'] = TABLE_ORDERS_STATUS_HISTORY;
		$this->v_table_mapper_array['status_history/date_added'] = TABLE_ORDERS_STATUS_HISTORY;
		$this->v_table_mapper_array['status_history/customer_notified'] = TABLE_ORDERS_STATUS_HISTORY;
		$this->v_table_mapper_array['status_history/comments'] = TABLE_ORDERS_STATUS_HISTORY;
                
		$this->v_language_dependent_mapper_array = array();
	}
	
	protected function delete_object(SimpleXMLElement $p_coo_xml) {}
	
	function download_orders($p_coo_request_xml)
	{
		$t_parameters_array = $this->build_sql_strings($p_coo_request_xml->parameters, array('limit', 'where'));

		$this->v_coo_response_xml->addChild('request');
		$this->v_coo_response_xml->request->addChild('success', 1);
		
		$this->add_blocks(array('customer_groups', 'tax_classes'));
		
		$this->add_orders_block($t_parameters_array);
		
		return $this->v_coo_response_xml;
	}


	function add_orders_block($p_parameters_array = array())
	{
		$this->v_coo_response_xml->addChild('orders');
		
		//TODO: optional machen		
		$t_where_part = " WHERE exported = '0' " . $this->build_where_part($p_parameters_array, true);
		$t_limitation = '';
		$t_order_ids_array = true;
		
		if(count($p_parameters_array) > 0)
		{
			$t_order_ids_array = array();
			
			$t_limit_part = ' GROUP BY ' . TABLE_ORDERS . '.orders_id' . $this->build_limit_part($p_parameters_array);
			
			$t_sql = "SELECT
							" . TABLE_ORDERS . ".orders_id
						FROM " . TABLE_ORDERS . " 
							LEFT JOIN " . TABLE_ORDERS_TOTAL . " USING (orders_id)
							LEFT JOIN " . TABLE_ORDERS_STATUS_HISTORY . " USING (orders_id)
							LEFT JOIN " . TABLE_ORDERS_PRODUCTS . " USING (orders_id)
							LEFT JOIN orders_products_quantity_units USING (orders_products_id)
							LEFT JOIN " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . " USING (orders_products_id)
							LEFT JOIN orders_products_properties USING (orders_products_id)
							LEFT JOIN gm_gprint_orders_surfaces_groups USING (orders_products_id)
							LEFT JOIN gm_gprint_orders_surfaces USING (gm_gprint_orders_surfaces_groups_id)
							LEFT JOIN gm_gprint_orders_elements USING (gm_gprint_orders_surfaces_id)
							LEFT JOIN gm_gprint_uploads USING (gm_gprint_uploads_id)
						" . $t_where_part . "
						" . $t_limit_part;
			$t_result = xtc_db_query($t_sql);
			while($t_result_array = xtc_db_fetch_array($t_result))
			{
				$t_order_ids_array[] = $t_result_array['orders_id'];
			}
			
			$t_limit = 0;
			$t_offset = 0;
			if(isset($p_parameters_array['offset']) && !empty($p_parameters_array['offset']))
			{
				$t_offset = (int)$p_parameters_array['offset'];
			}

			if(isset($p_parameters_array['limit']) && !empty($p_parameters_array['limit']))
			{
				$t_limit = (int)$p_parameters_array['limit'];
				
				if(!empty($t_order_ids_array))
				{					
					if($t_where_part == '' )
					{
						$t_limitation = ' WHERE ' . TABLE_ORDERS . '.orders_id IN (' . implode(',', $t_order_ids_array) . ') ';
					}
					else
					{
						$t_limitation .= ' AND ' . TABLE_ORDERS . '.orders_id IN (' . implode(',', $t_order_ids_array) . ') ';
					}
				}
			}			
		}
		
		if(empty($t_order_ids_array) == false)
		{
			$t_sql = "SELECT
							" . TABLE_ORDERS_PRODUCTS . ".orders_products_id AS o_products_id,
							" . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . ".*,
							orders_products_quantity_units.*,
							gm_gprint_uploads.*,
							gm_gprint_orders_elements.*,
							orders_products_properties.*,
							" . TABLE_ORDERS_TOTAL . ".*,
							" . TABLE_ORDERS_STATUS_HISTORY . ".*,
							" . TABLE_ORDERS_PRODUCTS . ".*,
							" . TABLE_ORDERS . ".*
						FROM 
							" . TABLE_ORDERS . " 
							LEFT JOIN " . TABLE_ORDERS_TOTAL . " USING (orders_id)
							LEFT JOIN " . TABLE_ORDERS_STATUS_HISTORY . " USING (orders_id)
							LEFT JOIN " . TABLE_ORDERS_PRODUCTS . " USING (orders_id)
							LEFT JOIN orders_products_quantity_units USING (orders_products_id)
							LEFT JOIN " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . " USING (orders_products_id)
							LEFT JOIN orders_products_properties USING (orders_products_id)
							LEFT JOIN gm_gprint_orders_surfaces_groups USING (orders_products_id)
							LEFT JOIN gm_gprint_orders_surfaces USING (gm_gprint_orders_surfaces_groups_id)
							LEFT JOIN gm_gprint_orders_elements USING (gm_gprint_orders_surfaces_id)
							LEFT JOIN gm_gprint_uploads USING (gm_gprint_uploads_id)
						" . $t_where_part . "
							" . $t_limitation;

			$t_result = xtc_db_query($t_sql);

			$t_last_orders_id = 0;
			while($t_row = xtc_db_fetch_array($t_result))
			{
				if($t_last_orders_id != $t_row['orders_id'])
				{
					$coo_order_child = $this->v_coo_response_xml->orders->addChild('order');
				}

				$this->add($t_row, $coo_order_child);

				$t_last_orders_id = $t_row['orders_id'];
			}
		}
	}	
	
	
	function upload_order_status($p_coo_request_xml)
	{
		$t_response_array = array();
		
		foreach ($p_coo_request_xml->parameters->orders->children() as $t_order_xml)
		{
			if((isset($t_order_xml->exported) === false || isset($t_order_xml->order_status_id)) && isset($t_order_xml->status_history) === false) 
			{
				$t_response_array[] = array(
									$this->v_singular_name . '_id' => $t_order_xml->order_id,
									'success' => '0',
									'errormessage' => 'missing required \'status_history\'-block',
									'action_performed' => 'error'
								);
				continue;
			}
			elseif(isset($t_order_xml->order_status_id) === false && isset($t_order_xml->status_history))
			{
				$t_response_array[] = array(
									$this->v_singular_name . '_id' => $t_order_xml->order_id,
									'success' => '0',
									'errormessage' => 'missing required order_status_id',
									'action_performed' => 'error'
								);
				continue;
			}
			
			$this->upload($t_order_xml, $t_response_array);
		}
		
		$t_output_xml = $this->build_response_xml($t_response_array);
		
		return $t_output_xml;
	}
	
	
	public function add_node($p_data_array, $p_table_column, $p_xml_name, $p_coo_xml)
	{
		switch($p_xml_name)
		{
			case 'download_url':
				$t_xml_name = $p_xml_name;
				
				if($this->node_exists($p_coo_xml, $t_xml_name) === false)
				{
					$t_download_url = '';
					if(empty($p_data_array[$p_table_column]) === false)
					{
						$t_download_url = $this->wrap_value(HTTP_SERVER . DIR_WS_CATALOG . 'gm_gprint_download.php?key=' . $p_data_array[$p_table_column]);
					}
					$p_coo_xml->addChild($t_xml_name, $t_download_url);
				}
				break;

			case 'products/product/order_product_id':
			case 'products/product/product_id':
			case 'products/product/model':
			case 'products/product/name':
			case 'products/product/price':
			case 'products/product/discount_made':
			case 'products/product/shipping_time':
			case 'products/product/final_price':
			case 'products/product/tax_rate':
			case 'products/product/quantity':
			case 'products/product/allow_tax':
			case 'products/product/quantity_unit_id':
			case 'products/product/unit_name':

				$t_xml_name = str_replace('products/product/', '', $p_xml_name);
				
				if($this->node_exists($p_coo_xml, 'products') === false) {
					$coo_products = $p_coo_xml->addChild('products');
				} else {
					$coo_products = $p_coo_xml->products;
				}
				
				$coo_product = $this->node_value_exists($coo_products, 'product', 'order_product_id', $p_data_array['o_products_id']);
				if($coo_product === false)
				{
					$coo_product = $coo_products->addChild('product');
					$coo_product->order_product_id = $p_data_array['o_products_id'];
					$coo_product->product_id = $p_data_array['products_id'];
					$coo_product->model = $this->wrap_value($p_data_array['products_model']);
					$coo_product->name = $this->wrap_value($p_data_array['products_name']);
					$coo_product->price = $p_data_array['products_price'];
					$coo_product->discount_made = $p_data_array['products_discount_made'];
					$coo_product->shipping_time = $p_data_array['products_shipping_time'];
					$coo_product->final_price = $p_data_array['final_price'];
					$coo_product->tax_rate = $p_data_array['products_tax'];
					$coo_product->quantity = $p_data_array['products_quantity'];
					$coo_product->allow_tax = $p_data_array['allow_tax'];
					$coo_product->quantity_unit_id = $p_data_array['quantity_unit_id'];
					$coo_product->unit_name = $this->wrap_value($p_data_array['unit_name']);
				}
				break;

			case 'products/product/attributes/attribute/order_product_attribute_id':
			case 'products/product/attributes/attribute/name':
			case 'products/product/attributes/attribute/value':
			case 'products/product/attributes/attribute/price':
			case 'products/product/attributes/attribute/price_prefix':
				
				$coo_product = $this->node_value_exists($p_coo_xml->products, 'product', 'order_product_id', $p_data_array['o_products_id']);
				if($coo_product !== false)
				{
					if(empty($p_data_array['orders_products_attributes_id']) === false) {

						$t_xml_name = str_replace('products/product/attributes/attribute/', '', $p_xml_name);

						if($this->node_exists($coo_product, 'attributes') === false) {
							$coo_attributes = $coo_product->addChild('attributes');
						} else {
							$coo_attributes = $coo_product->attributes;
						}

						$coo_attribute = $this->node_value_exists($coo_attributes, 'attribute', 'order_product_attribute_id', $p_data_array['orders_products_attributes_id']);
						if($coo_attribute === false)
						{
							$coo_attribute = $coo_attributes->addChild('attribute');
							$coo_attribute->order_product_attribute_id = $p_data_array['orders_products_attributes_id'];
							$coo_attribute->name = $this->wrap_value($p_data_array['products_options']);
							$coo_attribute->value = $this->wrap_value($p_data_array['products_options_values']);
							$coo_attribute->price = $p_data_array['options_values_price'];
							$coo_attribute->price_prefix = $p_data_array['price_prefix'];
						}
					}
				}
				break;
				
			case 'products/product/gprint_elements/gprint_element/gprint_element_id':
			case 'products/product/gprint_elements/gprint_element/name':
			case 'products/product/gprint_elements/gprint_element/value':
			case 'products/product/gprint_elements/gprint_element/download_url':
				
				$coo_product = $this->node_value_exists($p_coo_xml->products, 'product', 'order_product_id', $p_data_array['o_products_id']);
				if($coo_product !== false)
				{
					if(empty($p_data_array['name']) === false) {

						$t_xml_name = str_replace('products/product/gprint_elements/gprint_element/', '', $p_xml_name);

						if($this->node_exists($coo_product, 'gprint_elements') === false) {
							$coo_gprint_elements = $coo_product->addChild('gprint_elements');
						} else {
							$coo_gprint_elements = $coo_product->gprint_elements;
						}

						$coo_gprint_element = $this->node_value_exists($coo_gprint_elements, 'gprint_element', 'gprint_element_id', $p_data_array['gm_gprint_orders_elements_id']);
						if($coo_gprint_element === false)
						{
							$coo_gprint_element = $coo_gprint_elements->addChild('gprint_element');
							$coo_gprint_element->gprint_element_id = $p_data_array['gm_gprint_orders_elements_id'];
							$coo_gprint_element->name = $this->wrap_value($p_data_array['name']);
							$coo_gprint_element->value = $this->wrap_value($p_data_array['elements_value']);
							$coo_gprint_element->download_url = $this->wrap_value($p_data_array['download_url']);
						}
					}
				}
				break;				
				
			case 'products/product/properties/property/order_product_property_id':
			case 'products/product/properties/property/product_combi_id':
			case 'products/product/properties/property/name':
			case 'products/product/properties/property/value':
			case 'products/product/properties/property/price_type':
			case 'products/product/properties/property/price':
				
				$coo_product = $this->node_value_exists($p_coo_xml->products, 'product', 'order_product_id', $p_data_array['o_products_id']);
				if($coo_product !== false)
				{
					if(empty($p_data_array['orders_products_properties_id']) === false) {

						$t_xml_name = str_replace('products/product/properties/property/', '', $p_xml_name);

						if($this->node_exists($coo_product, 'properties') === false) {
							$coo_properties = $coo_product->addChild('properties');
						} else {
							$coo_properties = $coo_product->properties;
						}

						$coo_property = $this->node_value_exists($coo_properties, 'property', 'order_product_property_id', $p_data_array['orders_products_properties_id']);
						if($coo_property === false)
						{
							$coo_property = $coo_properties->addChild('property');
							$coo_property->order_product_property_id = $p_data_array['orders_products_properties_id'];
							$coo_property->product_combi_id = $p_data_array['products_properties_combis_id'];
							$coo_property->name = $this->wrap_value($p_data_array['properties_name']);
							$coo_property->value = $this->wrap_value($p_data_array['values_name']);
							$coo_property->price_type = $p_data_array['properties_price_type'];
							$coo_property->price = $p_data_array['properties_price'];
						}
					}
				}
				break;
				
			case 'totals/total/order_total_id':
			case 'totals/total/title':
			case 'totals/total/text':
			case 'totals/total/value':
			case 'totals/total/class':
			case 'totals/total/sort_order':
				
				$t_xml_name = str_replace('totals/total/', '', $p_xml_name);
				
				if($this->node_exists($p_coo_xml, 'totals') === false) {
					$coo_totals = $p_coo_xml->addChild('totals');
				} else {
					$coo_totals = $p_coo_xml->totals;
				}

				if($this->node_value_exists($coo_totals, 'total', 'order_total_id', $p_data_array['orders_total_id']) === false)
				{
					$coo_total = $coo_totals->addChild('total');
					$coo_total->order_total_id = $p_data_array['orders_total_id'];
					$coo_total->title = $this->wrap_value($p_data_array['title']);
					$coo_total->text = $this->wrap_value($p_data_array['text']);
					$coo_total->value = $this->wrap_value($p_data_array['value']);
					$coo_total->class = $p_data_array['class'];
					$coo_total->sort_order = $p_data_array['sort_order'];
				}				
				break;

			case 'status_history/status_history_entry/order_status_history_id':
			case 'status_history/status_history_entry/order_status_id':
			case 'status_history/status_history_entry/date_added':
			case 'status_history/status_history_entry/customer_notified':
			case 'status_history/status_history_entry/comments':				
				
				$t_xml_name = str_replace('status_history/status_history_entry/', '', $p_xml_name);
				
				if($this->node_exists($p_coo_xml, 'status_history') === false) {
					$coo_history = $p_coo_xml->addChild('status_history');
				} else {
					$coo_history = $p_coo_xml->status_history;
				}

				if($this->node_value_exists($coo_history, 'status_history_entry', 'order_status_history_id', $p_data_array['orders_status_history_id']) === false)
				{
					$coo_total = $coo_history->addChild('status_history_entry');
					$coo_total->order_status_history_id = $p_data_array['orders_status_history_id'];
					$coo_total->order_status_id = $p_data_array['orders_status_id'];
					$coo_total->date_added = $p_data_array['date_added'];
					$coo_total->customer_notified = $p_data_array['customer_notified'];
					$coo_total->comments = $this->wrap_value($p_data_array['comments']);
				}								
				break;
			
			case 'status_history/order_status_id':
			case 'status_history/date_added':
			case 'status_history/customer_notified':
			case 'status_history/comments':				
				// skip (only needed for upload)
				break;
				
			case 'customer_status_name':
			case 'customer_status_image':
			case 'customer_name':
			case 'customer_firstname':
			case 'customer_lastname':
			case 'customer_company':
			case 'customer_street_address':
			case 'customer_suburb':
			case 'customer_city':
			case 'customer_state':
			case 'customer_country':
			case 'delivery_name':
			case 'delivery_firstname':
			case 'delivery_lastname':
			case 'delivery_company':
			case 'delivery_street_address':
			case 'delivery_suburb':
			case 'delivery_city':
			case 'delivery_state':
			case 'delivery_country':
			case 'billing_name':
			case 'billing_firstname':
			case 'billing_lastname':
			case 'billing_company':
			case 'billing_street_address':
			case 'billing_suburb':
			case 'billing_city':
			case 'billing_state':
			case 'billing_country':
			case 'credit_card_owner':
			case 'comments':
			case 'shipping_method':
				$t_xml_name = $p_xml_name;
				
				if($this->node_exists($p_coo_xml, $t_xml_name) === false)
				{
					$p_coo_xml->{$t_xml_name} = $this->wrap_value($p_data_array[$p_table_column]);
				}
				break;
			
			default:
				$t_xml_name = $p_xml_name;
				
				if($this->node_exists($p_coo_xml, $t_xml_name) === false)
				{
					$p_coo_xml->{$t_xml_name} = $p_data_array[$p_table_column];
				}
				break;
		}
	}	
}
