<?php
/* --------------------------------------------------------------
  GxmlProductCombis.inc.php 2014-01-31 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2014 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------
 */

class GxmlProductCombis extends GxmlMaster
{

	public function __construct() 
	{
		parent::__construct();
		$this->set_plural_name('product_combis');
		$this->set_singular_name('product_combi');
		$this->build_mapper_array();
		$this->build_table_mapper_array();
		$this->load_languages();
	}
	
	protected function build_mapper_array()
	{
		$this->v_mapper_array = array();
		$this->v_mapper_array['product_combi_id'] = 'products_properties_combis_id';
		$this->v_mapper_array['product_id'] = 'products_id';
		$this->v_mapper_array['sort_order'] = 'sort_order';
		$this->v_mapper_array['model'] = 'combi_model';
		$this->v_mapper_array['quantity'] = 'combi_quantity';
		$this->v_mapper_array['shipping_time_id'] = 'combi_shipping_status_id';
		$this->v_mapper_array['weight'] = 'combi_weight';
		$this->v_mapper_array['price'] = 'combi_price';
		$this->v_mapper_array['image'] = 'combi_image';
		$this->v_mapper_array['base_price_unit_id'] = 'products_vpe_id';
		$this->v_mapper_array['base_price_unit_value'] = 'vpe_value';
		$this->v_mapper_array['property_values'] = '';
	}
	
	protected function build_table_mapper_array()
	{
		$this->v_table_mapper_array = array();
		
		$this->v_table_mapper_array['product_combi_id'] = 'products_properties_combis';
		$this->v_table_mapper_array['product_id'] = 'products_properties_combis';
		$this->v_table_mapper_array['sort_order'] = 'products_properties_combis';
		$this->v_table_mapper_array['model'] = 'products_properties_combis';
		$this->v_table_mapper_array['quantity'] = 'products_properties_combis';
		$this->v_table_mapper_array['shipping_time_id'] = 'products_properties_combis';
		$this->v_table_mapper_array['weight'] = 'products_properties_combis';
		$this->v_table_mapper_array['price'] = 'products_properties_combis';
		$this->v_table_mapper_array['image'] = 'products_properties_combis';
		$this->v_table_mapper_array['base_price_unit_id'] = 'products_properties_combis';
		$this->v_table_mapper_array['base_price_unit_value'] = 'products_properties_combis';
		$this->v_table_mapper_array['property_values'] = 'products_properties_combis_values';
                
		$this->v_language_dependent_mapper_array = array();
	}
	
	function upload_product_combis($p_coo_request_xml, $p_product_id)
	{
		$t_response_array = array();
		
		foreach($p_coo_request_xml->{$this->v_plural_name}->children() as $t_combi_xml)
		{
			$t_combi_xml->addChild('product_id', $p_product_id);
			$t_attributes_array = $t_combi_xml->attributes();
			$t_is_delete = false;
			foreach ($t_attributes_array as $t_key => $t_value)
			{
				if ($t_key == 'action' && $t_value == 'delete')
				{
					$t_is_delete = true;
					break;
				}
			}
			if ($t_is_delete == true)
			{
				$this->delete_object($t_combi_xml);
				continue;
			}
			$this->upload($t_combi_xml, $t_response_array);
		}
		$t_output_xml = $this->build_response_xml($t_response_array);
		
		return $t_output_xml;
	}
	
	public function add_products_combis_block($p_parameters_array = array())
	{
		$t_product_child = $p_parameters_array['product_child'];
		$t_product_id = $p_parameters_array['product_id'];
		
		$t_combis_sql = 'SELECT * FROM products_properties_combis WHERE products_id = ' . $t_product_id;
		$t_combis_result = xtc_db_query($t_combis_sql);
				
		$t_combis_values_sql = 'SELECT pv.*, prv.properties_id FROM products_properties_combis_values pv, products_properties_combis p, properties_values prv WHERE p.products_properties_combis_id = pv.products_properties_combis_id AND pv.properties_values_id = prv.properties_values_id AND p.products_id = ' . $t_product_id;
		$t_combis_values_result = xtc_db_query($t_combis_values_sql);
		
		if ( xtc_db_num_rows( $t_combis_result ) > 0 )
		{
			$coo_combis_child = $t_product_child->addChild($this->v_plural_name);
			$t_values_array = array();
			while ($t_combis_values_row = xtc_db_fetch_array($t_combis_values_result))
			{
				if (!array_key_exists($t_combis_values_row['products_properties_combis_id'], $t_values_array) )
				{
					$t_values_array[$t_combis_values_row['products_properties_combis_id']] = array();
				}
				$t_values_array[$t_combis_values_row['products_properties_combis_id']][] = array('properties_id' => $t_combis_values_row['properties_id'], 'properties_values_id' => $t_combis_values_row['properties_values_id']);
			}
			
			while ($t_combi_row = xtc_db_fetch_array($t_combis_result))
			{
				$t_combi_values_array = array();
				if (array_key_exists($t_combi_row['products_properties_combis_id'], $t_values_array))
				{
					$t_combi_values_array = $t_values_array[$t_combi_row['products_properties_combis_id']];
				}
				$coo_combi_child = $coo_combis_child->addChild($this->v_singular_name);
				$this->add($t_combi_row, $coo_combi_child);
				
				$coo_combi_values_child = $coo_combi_child->addChild('property_values');
				foreach ($t_combi_values_array as $t_property_value_data)
				{
					$coo_combi_value_child = $coo_combi_values_child->addChild('property_value');
					$this->add_node($t_property_value_data, 'properties_id', 'property_id', $coo_combi_value_child);
					$this->add_node($t_property_value_data, 'properties_values_id', 'property_value_id', $coo_combi_value_child);
				}
			}			
		}
	}
	
	public function add_node($p_data_array, $p_table_column, $p_xml_name, $p_coo_xml)
	{
		switch($p_xml_name)
		{			
			case 'property_values/property_value/property_id':
			case 'property_values/property_value/property_value_id':
				$p_coo_xml->{substr($p_xml_name, strrpos($p_xml_name, '/') + 1)} = $p_data_array[$p_table_column];
				break;
			
			case 'model':
			case 'image':
				if($this->node_exists($p_coo_xml, $p_xml_name) === false)
				{
					$p_coo_xml->{$p_xml_name} = $this->wrap_value($p_data_array[$p_table_column]);
				}
				break;
				
			default:
				if($this->node_exists($p_coo_xml, $p_xml_name) === false)
				{
					$p_coo_xml->{$p_xml_name} = $p_data_array[$p_table_column];
				}
				break;
		}
	}
	
	protected function delete_object(SimpleXMLElement $p_coo_xml)
	{
		$t_combi_id = (string)$p_coo_xml->product_combi_id;
		
		if(!empty($t_combi_id))
		{
			$coo_combis_admin_control = MainFactory::create_object('PropertiesCombisAdminControl');
			$coo_combis_admin_control->delete_properties_combis(array($t_combi_id));
			
			return true;
		}
		
		return false;
	}
}
