<?php
/* --------------------------------------------------------------
  GxmlProducts.inc.php 2014-01-31 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2014 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------
 */

class GxmlProducts extends GxmlMaster
{
	public function __construct() 
	{
		parent::__construct();
		$this->set_plural_name('products');
		$this->set_singular_name('product');
		$this->build_mapper_array();
		$this->build_table_mapper_array();
	}
	
	protected function build_mapper_array()
	{
		$this->v_mapper_array = array();
		
		$this->v_mapper_array['product_id'] = 'products_id';
		$this->v_mapper_array['ean'] = 'products_ean';
		$this->v_mapper_array['quantity'] = 'products_quantity';
		$this->v_mapper_array['shipping_time_id'] = 'products_shippingtime';
		$this->v_mapper_array['model'] = 'products_model';
		$this->v_mapper_array['sort_order'] = 'products_sort';
		$this->v_mapper_array['image'] = 'products_image';
		$this->v_mapper_array['image_url'] = 'products_image';
		$this->v_mapper_array['price'] = 'products_price';
		$this->v_mapper_array['discount_allowed'] = 'products_discount_allowed';
		$this->v_mapper_array['date_added'] = 'products_date_added';
		$this->v_mapper_array['last_modified'] = 'products_last_modified';
		$this->v_mapper_array['date_available'] = 'products_date_available';
		$this->v_mapper_array['weight'] = 'products_weight';
		$this->v_mapper_array['status'] = 'products_status';
		$this->v_mapper_array['tax_class_id'] = 'products_tax_class_id';
		$this->v_mapper_array['tax_rate'] = 'tax_rate';
		$this->v_mapper_array['template'] = 'product_template';
		$this->v_mapper_array['attributes_template'] = 'options_template';
		$this->v_mapper_array['attributes_listing_template'] = 'gm_options_template';
		$this->v_mapper_array['products_ordered'] = 'products_ordered';
		$this->v_mapper_array['price_status'] = 'gm_price_status';
		$this->v_mapper_array['min_order'] = 'gm_min_order';
		$this->v_mapper_array['graduated_quantity'] = 'gm_graduated_qty';
		$this->v_mapper_array['startpage_sort'] = 'products_startpage_sort';
		$this->v_mapper_array['shipping_costs'] = 'nc_ultra_shipping_costs';
		$this->v_mapper_array['priority'] = 'gm_priority';
		$this->v_mapper_array['change_frequency'] = 'gm_changefreq';
		$this->v_mapper_array['fsk18'] = 'products_fsk18';
		
		$this->v_mapper_array['name'] = 'products_name';
		$this->v_mapper_array['description'] = 'products_description';
		$this->v_mapper_array['short_description'] = 'products_short_description';
		$this->v_mapper_array['keywords'] = 'products_keywords';
		$this->v_mapper_array['meta_title'] = 'products_meta_title';
		$this->v_mapper_array['meta_description'] = 'products_meta_description';
		$this->v_mapper_array['meta_keywords'] = 'products_meta_keywords';
		$this->v_mapper_array['url'] = 'products_url';
		$this->v_mapper_array['viewed'] = 'products_viewed';
		$this->v_mapper_array['image_alt_text'] = 'gm_alt_text';
		$this->v_mapper_array['url_keywords'] = 'gm_url_keywords';
		
		$this->v_mapper_array['quantity_unit_id'] = 'quantity_unit_id';
		$this->v_mapper_array['base_price_unit_id'] = 'products_vpe';
		$this->v_mapper_array['base_price_unit_status'] = 'products_vpe_status';
		$this->v_mapper_array['base_price_unit_value'] = 'products_vpe_value';
		
		$this->v_mapper_array['show_date_added'] = 'gm_show_date_added';
		$this->v_mapper_array['show_price_offer'] = 'gm_show_price_offer';
		$this->v_mapper_array['show_weight'] = 'gm_show_weight';
		$this->v_mapper_array['show_quantity_info'] = 'gm_show_qty_info';
		$this->v_mapper_array['show_image'] = 'gm_show_image';
		$this->v_mapper_array['show_on_startpage'] = 'products_startpage';
		$this->v_mapper_array['sitemap_entry'] = 'gm_sitemap_entry';
		
		$this->v_mapper_array['properties_dropdown_mode'] = 'properties_dropdown_mode';
		$this->v_mapper_array['properties_show_price'] = 'properties_show_price';
		$this->v_mapper_array['use_properties_combis_weight'] = 'use_properties_combis_weight';
		$this->v_mapper_array['use_properties_combis_quantity'] = 'use_properties_combis_quantity';
		$this->v_mapper_array['use_properties_combis_shipping_time'] = 'use_properties_combis_shipping_time';
		
		$this->v_mapper_array['customer_group_permission'] = 'group_permission_';
		$this->v_mapper_array['personal_offers'] = 'personal_offers_by_customers_status_';
				
		$this->v_mapper_array['special/special_id'] = 'specials_id';
		$this->v_mapper_array['special/quantity'] = 'specials_quantity';
		$this->v_mapper_array['special/price'] = 'specials_new_products_price';
		$this->v_mapper_array['special/date_added'] = 'specials_date_added';
		$this->v_mapper_array['special/last_modified'] = 'specials_last_modified';
		$this->v_mapper_array['special/expiring_date'] = 'expires_date';
		$this->v_mapper_array['special/date_status_change'] = 'date_status_change';
		$this->v_mapper_array['special/status'] = 'status';
		
		$this->v_mapper_array['categories/category/category_id'] = 'categories_id';
		
		$this->v_mapper_array['cross_selling_products/cross_selling_product/product_id'] = 'xsell_id';
		$this->v_mapper_array['cross_selling_products/cross_selling_product/sort_order'] = 'sort_order';
	}
	
	protected function build_table_mapper_array()
	{
		$this->v_table_mapper_array = array();
		
		$this->v_table_mapper_array['product_id'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['ean'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['quantity'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['shipping_time_id'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['model'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['sort_order'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['image'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['image_url'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['price'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['discount_allowed'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['date_added'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['last_modified'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['date_available'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['weight'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['status'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['tax_class_id'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['tax_rate'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['template'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['attributes_template'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['attributes_listing_template'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['products_ordered'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['price_status'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['min_order'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['graduated_quantity'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['startpage_sort'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['shipping_costs'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['priority'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['change_frequency'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['fsk18'] = TABLE_PRODUCTS;
		
		$this->v_table_mapper_array['name'] = TABLE_PRODUCTS_DESCRIPTION;
		$this->v_table_mapper_array['description'] = TABLE_PRODUCTS_DESCRIPTION;
		$this->v_table_mapper_array['short_description'] = TABLE_PRODUCTS_DESCRIPTION;
		$this->v_table_mapper_array['keywords'] = TABLE_PRODUCTS_DESCRIPTION;
		$this->v_table_mapper_array['meta_title'] = TABLE_PRODUCTS_DESCRIPTION;
		$this->v_table_mapper_array['meta_description'] = TABLE_PRODUCTS_DESCRIPTION;
		$this->v_table_mapper_array['meta_keywords'] = TABLE_PRODUCTS_DESCRIPTION;
		$this->v_table_mapper_array['url'] = TABLE_PRODUCTS_DESCRIPTION;
		$this->v_table_mapper_array['viewed'] = TABLE_PRODUCTS_DESCRIPTION;
		$this->v_table_mapper_array['image_alt_text'] = TABLE_PRODUCTS_DESCRIPTION;
		$this->v_table_mapper_array['url_keywords'] = TABLE_PRODUCTS_DESCRIPTION;
		
		$this->v_table_mapper_array['quantity_unit_id'] = 'products_quantity_unit';
		$this->v_table_mapper_array['base_price_unit_id'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['base_price_unit_status'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['base_price_unit_value'] = TABLE_PRODUCTS;
		
		$this->v_table_mapper_array['show_date_added'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['show_price_offer'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['show_weight'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['show_quantity_info'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['show_image'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['show_on_startpage'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['sitemap_entry'] = TABLE_PRODUCTS;
		
		$this->v_table_mapper_array['properties_dropdown_mode'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['properties_show_price'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['use_properties_combis_weight'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['use_properties_combis_quantity'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['use_properties_combis_shipping_time'] = TABLE_PRODUCTS;
		
		$this->v_table_mapper_array['customer_group_permission'] = TABLE_PRODUCTS;
		$this->v_table_mapper_array['personal_offers'] = TABLE_PERSONAL_OFFERS_BY;
		$this->v_table_mapper_array['personal_offer'] = TABLE_PERSONAL_OFFERS_BY;
		
		$this->v_table_mapper_array['special/special_id'] = TABLE_SPECIALS;
		$this->v_table_mapper_array['special/quantity'] = TABLE_SPECIALS;
		$this->v_table_mapper_array['special/price'] = TABLE_SPECIALS;
		$this->v_table_mapper_array['special/date_added'] = TABLE_SPECIALS;
		$this->v_table_mapper_array['special/last_modified'] = TABLE_SPECIALS;
		$this->v_table_mapper_array['special/expiring_date'] = TABLE_SPECIALS;
		$this->v_table_mapper_array['special/date_status_change'] = TABLE_SPECIALS;
		$this->v_table_mapper_array['special/status'] = TABLE_SPECIALS;
		
		$this->v_table_mapper_array['categories/category/category_id'] = TABLE_PRODUCTS_TO_CATEGORIES;
		
		$this->v_table_mapper_array['cross_selling_products/cross_selling_product/product_id'] = TABLE_PRODUCTS_XSELL;
		$this->v_table_mapper_array['cross_selling_products/cross_selling_product/sort_order'] = TABLE_PRODUCTS_XSELL;
                
		$this->v_language_dependent_mapper_array = array(TABLE_PRODUCTS_DESCRIPTION);
	}

	function download_products($p_coo_request_xml)
	{
		$t_parameters_array = $this->build_sql_strings($p_coo_request_xml->parameters, array('limit', 'where'));

		$this->v_coo_response_xml->addChild('request');
		$this->v_coo_response_xml->request->addChild('success', 1);
		
		$this->add_blocks(array('languages', 'customer_groups', 'shipping_times', 'tax_classes', 'base_price_units', 'quantity_units'));
		
		$this->add_products_block($t_parameters_array);
		
		return $this->v_coo_response_xml;
	}
	
	function upload_products($p_coo_request_xml)
	{
		$t_response_array = array();
		$t_combis_xml_array = array();
		$coo_product_combis = MainFactory::create_object('GxmlProductCombis');
		
		foreach($p_coo_request_xml->parameters->products->children() as $t_product_xml)
		{
			// update tax_class_id by given tax_rate
			$t_valid = $this->validate_tax($t_product_xml, $t_response_array);
			
			if($t_valid === true)
			{
				if(isset($t_product_xml->product_id) == false
					&& (isset($t_product_xml->categories) == false
					|| isset($t_product_xml->categories->category) == false))
				{
					$this->add_xml_child($t_product_xml, simplexml_load_string('<categories>
							<category>
								<category_id>0</category_id>
							</category>
						</categories>'), false);
				}
				$this->upload($t_product_xml, $t_response_array);
				$t_actual_product_id = !empty($t_response_array) && isset($t_response_array[count($t_response_array) - 1]['product_id']) ? $t_response_array[count($t_response_array) - 1]['product_id'] : false;
				if ($t_actual_product_id != false && isset($t_product_xml->product_combis))
				{
					$t_combis_xml_array[] = $coo_product_combis->upload_product_combis($t_product_xml, $t_actual_product_id);
				}
			}
		}
		
		$t_output_xml = $this->build_response_xml($t_response_array);
		
		foreach($t_combis_xml_array as $coo_product_combis_xml)
		{
			$t_product_combi_array = $coo_product_combis_xml->product_combis->children();
			
			if(isset($t_output_xml->product_combis) === false)
			{
				$coo_output_product_combis_xml = $t_output_xml->addChild('product_combis');
			}
			
			foreach($t_product_combi_array as $coo_product_combi_xml)
			{
				$this->add_xml_child($coo_output_product_combis_xml, $coo_product_combi_xml);
				$t_output_xml->request->success &= $coo_product_combi_xml->success;
			}
		}
		
		return $t_output_xml;
	}

	
	protected function delete_object(SimpleXMLElement $p_coo_xml)
	{
		$t_product_data_array = $this->build_data_array($p_coo_xml);
		$t_product_data_array = $this->convert_to_latin1($t_product_data_array);
		$t_products_id = (string)$p_coo_xml->product_id;
		$t_delete_array = array();
		$t_success = true;
		
		// select all products_ids
		if(empty($t_products_id))
		{
			$t_sql = '
					SELECT products_id
					FROM products
					WHERE
					';
			foreach($t_product_data_array['products'] as $t_key => $t_value)
			{
				$t_sql .= $t_key . ' LIKE \'' . $t_value . '\' AND ';
			}
			$t_sql = substr($t_sql, 0, strlen($t_sql) - 5);
			
			$t_result = xtc_db_query($t_sql);
			if(xtc_db_num_rows(($t_result)))
			{
				while($t_row = xtc_db_fetch_array($t_result))
				{
					$t_delete_array[] = $t_row['products_id'];
				}
			}
		}
		else
		{
			$t_delete_array[] = $t_products_id;
		}
		
		// delete all products data
		if(!empty($t_delete_array))
		{
			include_once(DIR_FS_ADMIN . 'includes/classes/categories.php');
			$coo_categories = new categories();
			foreach( $t_delete_array AS $t_products_id )
			{
				$coo_categories->remove_product( $t_products_id );
			}
			$t_success &= true;
		}
		
		return $t_success;
	}

	
	function build_personal_offers_parts_array()
	{
		$t_parts_array = array();
		$t_select_part = '';
		$t_join_part = '';
		
		$t_sql = "SELECT customers_status_id 
					FROM " . TABLE_CUSTOMERS_STATUS . " 
					WHERE customers_status_id > 0 
					GROUP BY customers_status_id 
					ORDER BY customers_status_id ASC";
		$t_result = xtc_db_query($t_sql);
		while($t_result_array = xtc_db_fetch_array($t_result))
		{
			$t_select_part .= ', p' . $t_result_array['customers_status_id'] . '.quantity AS personal_offers_quantity_' . $t_result_array['customers_status_id'] . ',
								p' . $t_result_array['customers_status_id'] . '.personal_offer AS personal_offers_price_' . $t_result_array['customers_status_id'];
			$t_join_part .= ' LEFT JOIN personal_offers_by_customers_status_' . $t_result_array['customers_status_id'] . ' AS p' . $t_result_array['customers_status_id'] . ' ON (p' . $t_result_array['customers_status_id'] . '.products_id = ' . TABLE_PRODUCTS . '.products_id) ';
		}
		
		$t_parts_array['select'] = $t_select_part;
		$t_parts_array['join'] = $t_join_part;
				
		return $t_parts_array;
	}
	
	function add_products_block($p_parameters_array = array())
	{
		$this->v_coo_response_xml->addChild('products');
		$t_product_ids_array = true;
		$t_products_to_categories = array();
		
		if(count($p_parameters_array) === 0)
		{
			$t_sql = "SELECT * FROM " . TABLE_PRODUCTS_TO_CATEGORIES;
			$t_products_to_categories_result = xtc_db_query($t_sql);

			while($t_row = xtc_db_fetch_array($t_products_to_categories_result))
			{
				if(isset($t_products_to_categories[$t_row['products_id']]) === false)
				{
					$t_products_to_categories[$t_row['products_id']] = array();
				}
				
				$t_products_to_categories[$t_row['products_id']][] = $t_row['categories_id'];
			}
		}
		
		$t_where_part = $this->build_where_part($p_parameters_array);
		$t_personal_offers_parts_array = $this->build_personal_offers_parts_array();
		$t_limitation = '';
		if(count($p_parameters_array) > 0)
		{
			$t_product_ids_array = array();
			$t_limit_part = ' GROUP BY ' . TABLE_PRODUCTS . '.products_id' . $this->build_limit_part($p_parameters_array);
			
			$t_sql = "SELECT " . TABLE_PRODUCTS . ".products_id
								FROM " . TABLE_PRODUCTS . "
								LEFT JOIN " . TABLE_SPECIALS . " ON (" . TABLE_SPECIALS . ".products_id = " . TABLE_PRODUCTS . ".products_id)
								" . $t_personal_offers_parts_array['join'] . "
								LEFT JOIN " . TABLE_PRODUCTS_DESCRIPTION . " ON (" . TABLE_PRODUCTS_DESCRIPTION . ".products_id = " . TABLE_PRODUCTS . ".products_id)
								LEFT JOIN products_quantity_unit ON (products_quantity_unit.products_id = " . TABLE_PRODUCTS . ".products_id)
								LEFT JOIN " . TABLE_PRODUCTS_TO_CATEGORIES . " ON (" . TABLE_PRODUCTS_TO_CATEGORIES . ".products_id = " . TABLE_PRODUCTS . ".products_id)
								" . $t_where_part . "
								" . $t_limit_part;
			$t_result = xtc_db_query($t_sql);
			while($t_result_array = xtc_db_fetch_array($t_result))
			{
				$t_product_ids_array[] = $t_result_array['products_id'];
			}
			
			$t_limit = 0;
			$t_offset = 0;
			if(isset($p_parameters_array['offset']) && !empty($p_parameters_array['offset']))
			{
				$t_offset = (int)$p_parameters_array['offset'];
			}

			if(isset($p_parameters_array['limit']) && !empty($p_parameters_array['limit']))
			{
				$t_limit = (int)$p_parameters_array['limit'];
				
				if(!empty($t_product_ids_array))
				{					
					if($t_where_part == '' )
					{
						$t_limitation = ' WHERE ' . TABLE_PRODUCTS . '.products_id IN (' . implode(',', $t_product_ids_array) . ') ';
					}
					else
					{
						$t_limitation .= ' AND ' . TABLE_PRODUCTS . '.products_id IN (' . implode(',', $t_product_ids_array) . ') ';
					}
				}
			}
			
			if(!empty($t_product_ids_array))
			{
				$t_sql = 'SELECT * FROM ' . TABLE_PRODUCTS_TO_CATEGORIES . ' WHERE products_id IN (' . implode(',', $t_product_ids_array) . ')';
				$t_products_to_categories_result = xtc_db_query($t_sql);

				while ($t_row = xtc_db_fetch_array($t_products_to_categories_result))
				{
					if(isset($t_products_to_categories[$t_row['products_id']]) === false)
					{
						$t_products_to_categories[$t_row['products_id']] = array();
					}
					
					$t_products_to_categories[$t_row['products_id']][] = $t_row['categories_id'];
				}
			}
		}

		if(empty($t_product_ids_array) == false)
		{
			$t_sql = "SELECT 
								" . TABLE_SPECIALS . ".*,
								" . TABLE_PRODUCTS_DESCRIPTION . ".*,
								" . TABLE_PRODUCTS . ".*,
								products_quantity_unit.quantity_unit_id
								" . $t_personal_offers_parts_array['select'] . "
							FROM " . TABLE_PRODUCTS . "
							LEFT JOIN " . TABLE_SPECIALS . " ON (" . TABLE_SPECIALS . ".products_id = " . TABLE_PRODUCTS . ".products_id)
							" . $t_personal_offers_parts_array['join'] . "
							LEFT JOIN " . TABLE_PRODUCTS_DESCRIPTION . " ON (" . TABLE_PRODUCTS_DESCRIPTION . ".products_id = " . TABLE_PRODUCTS . ".products_id)
							LEFT JOIN products_quantity_unit ON (products_quantity_unit.products_id = " . TABLE_PRODUCTS . ".products_id)
							LEFT JOIN " . TABLE_PRODUCTS_TO_CATEGORIES . " ON (" . TABLE_PRODUCTS_TO_CATEGORIES . ".products_id = " . TABLE_PRODUCTS . ".products_id)
							" . $t_where_part . "
							" . $t_limitation;
			$t_result = xtc_db_query($t_sql);

			$t_last_products_id = 0;

			$coo_gxml_property_values = MainFactory::create_object( 'GxmlProductCombis' );

			while ($t_row = xtc_db_fetch_array($t_result))
			{
				if ($t_last_products_id != $t_row['products_id'])
				{
					$coo_product_child = $this->v_coo_response_xml->products->addChild('product');
				}
				$t_categories_id_array = array(0);
				if(isset($t_products_to_categories[$t_row['products_id']]))
				{
					$t_categories_id_array = $t_products_to_categories[$t_row['products_id']];
				}

				$t_row['categories_id'] = $t_categories_id_array;
				$this->add($t_row, $coo_product_child);


				if ($t_last_products_id != $t_row['products_id'])
				{
					// add combis
					$coo_gxml_property_values->add_products_combis_block( array( 'product_child' => $coo_product_child, 'product_id' => $t_row['products_id'] ) );

					// add xselling
					$this->add_xselling_block($coo_product_child, $t_row['products_id']);
				}

				$t_last_products_id = $t_row['products_id'];
			}
		}
	}
	
	private function add_xselling_block($p_coo_product_xml, $p_products_id)
	{
		$t_products_id = (int)$p_products_id;
		$t_sql = "SELECT xsell_id, sort_order FROM " . TABLE_PRODUCTS_XSELL . " WHERE products_id = " . $t_products_id . " ORDER BY sort_order";
		$t_result = xtc_db_query($t_sql);
		
		if(xtc_db_num_rows($t_result) > 0)
		{
			$coo_xselling = $p_coo_product_xml->addChild('cross_selling_products');
			
			while($t_row = xtc_db_fetch_array($t_result))
			{
				$coo_xselling_product = $coo_xselling->addChild('cross_selling_product');
				
				$this->add_node($t_row, 'xsell_id', 'product_id', $coo_xselling_product);
				$this->add_node($t_row, 'sort_order', 'sort_order', $coo_xselling_product);
			}
		}
	}
	
	
	
	private function validate_tax($p_coo_product_xml, &$p_response_array)
	{
		$t_products_id = (string)$p_coo_product_xml->product_id;
		$t_match = false;
		
		if(isset($p_coo_product_xml->tax_class_id) && !in_array((int)$p_coo_product_xml->tax_class_id, array_keys($this->v_tax_array)))
		{
			$p_response_array[] = array(
									'external_' . $this->v_singular_name . '_id' => '',
									$this->v_singular_name . '_id' => $t_products_id,
									'success' => '0',
									'errormessage' => 'given tax_class_id does not exist',
									'action_performed' => 'error'
								);
			return false;
		}
		
		if(isset($p_coo_product_xml->tax_rate))
		{
			foreach($this->v_tax_array as $t_tax_class)
			{
				if((string)$p_coo_product_xml->tax_rate == $t_tax_class['tax_rate'])
				{
					if(isset($p_coo_product_xml->tax_class_id) && (int)$p_coo_product_xml->tax_class_id != $t_tax_class['tax_class_id'])
					{
						$p_response_array[] = array(
									'external_' . $this->v_singular_name . '_id' => '',
									$this->v_singular_name . '_id' => $t_products_id,
									'success' => '0',
									'errormessage' => 'tax_class_id and tax_rate are in conflict',
									'action_performed' => 'error'
								);
						return false;
					}
					
					$t_match = true;
					$p_coo_product_xml->tax_class_id = $t_tax_class['tax_class_id'];
				}
			}
			if(!$t_match)
			{
				$p_response_array[] = array(
									'external_' . $this->v_singular_name . '_id' => '',
									$this->v_singular_name . '_id' => $t_products_id,
									'success' => '0',
									'errormessage' => 'no matching tax_class_id for given tax_rate found',
									'action_performed' => 'error'
								);
				return false;
			}
			unset($p_coo_product_xml->tax_rate);
		}
		return true;
	}
	
	
	
	public function add_node($p_data_array, $p_table_column, $p_xml_name, $p_coo_xml)
	{
		switch($p_xml_name)
		{
			case 'tax_rate':
				if($this->node_exists($p_coo_xml, $p_xml_name) === false)
				{
					$p_coo_xml->{$p_xml_name} = $this->v_tax_array[$p_data_array['products_tax_class_id']]['tax_rate'];
				}
				break;
			
			case 'name':
			case 'description':
			case 'short_description':
			case 'keywords':
			case 'meta_title':
			case 'meta_description':
			case 'meta_keywords':
			case 'url':
			case 'viewed':
			case 'image_alt_text':
			case 'url_keywords':
				$t_xml_name = $p_xml_name;
				
				if($this->node_exists($p_coo_xml, $t_xml_name, array('language_id' => $p_data_array['language_id'], 'language_iso' => $this->v_language_array[$p_data_array['language_id']]['iso']), 'or') === false)
				{
					$p_coo_xml->addChild($p_xml_name);
					$p_coo_xml->{$p_xml_name}[count($p_coo_xml->{$p_xml_name}) - 1] = $this->wrap_value($p_data_array[$p_table_column]);
					$coo_child = $p_coo_xml->{$p_xml_name}[count($p_coo_xml->{$p_xml_name}) - 1];
					$coo_child['language_id'] = $p_data_array['language_id'];
					$coo_child['language_iso'] = $this->v_language_array[$p_data_array['language_id']]['iso'];
					
					if($t_xml_name == 'description' ||
						$t_xml_name == 'short_description')
					{
						$coo_child['type'] = 2;
					}
				}
				
				break;
				
			case 'customer_group_permission':
				if($this->node_exists($p_coo_xml, $p_xml_name) === false)
				{
					foreach($p_data_array AS $t_column => $t_value)
					{
						if(strpos($t_column, 'group_permission_') !== false)
						{
							$p_coo_xml->addChild($p_xml_name);
							$p_coo_xml->{$p_xml_name}[count($p_coo_xml->{$p_xml_name}) - 1] = $t_value;
							$coo_child = $p_coo_xml->{$p_xml_name}[count($p_coo_xml->{$p_xml_name}) - 1];
							$coo_child['customer_group_id'] = str_replace('group_permission_', '', $t_column);
						}
					}
				}
				
				break;
				
			case 'image':
				$t_xml_name = $p_xml_name;
				
				if($this->node_exists($p_coo_xml, $t_xml_name) === false)
				{
					$p_coo_xml->{$t_xml_name} = $this->wrap_value($p_data_array[$p_table_column]);
					$p_coo_xml->{$t_xml_name}['width'] = $p_data_array['products_image_w'];
					$p_coo_xml->{$t_xml_name}['height'] = $p_data_array['products_image_h'];
				}
				
				break;
				
			case 'image_url':
				$t_xml_name = $p_xml_name;
				
				if($this->node_exists($p_coo_xml, $t_xml_name) === false)
				{
					$t_category_icon_url = '';
					if(empty($p_data_array[$p_table_column]) === false)
					{
						$t_category_icon_url = $this->wrap_value(HTTP_SERVER . DIR_WS_CATALOG . DIR_WS_IMAGES . 'product_images/original_images/' . $p_data_array[$p_table_column]);
					}
					$p_coo_xml->{$t_xml_name} = $t_category_icon_url;
				}
				
				break;
				
			case 'personal_offers':
				$t_data_array = array();
					
				foreach($p_data_array AS $t_column => $t_value)
				{
					if(strpos($t_column, 'personal_offers_quantity_') !== false)
					{
						$t_customers_status_id = str_replace('personal_offers_quantity_', '', $t_column);

						$t_data_array[$t_customers_status_id][(string)$t_value] = (string)$p_data_array['personal_offers_price_' . $t_customers_status_id];
					}
				}

				if(!empty($t_data_array))
				{
					foreach($t_data_array AS $t_customers_status_id => $t_personal_offers_array)
					{
						foreach($t_personal_offers_array AS $t_quantity => $t_price)
						{
							$t_quantity_value = (double)$t_quantity;
							if(!empty($t_quantity_value))
							{
								if($this->node_exists($p_coo_xml, $p_xml_name) === false)
								{
									$coo_child = $p_coo_xml->addChild($p_xml_name);
								}
								else
								{
									$coo_child = $p_coo_xml->personal_offers;
								}

								if($this->node_value_exists($coo_child, 'personal_offer', 'quantity', $t_quantity, array('customer_group_id' => $t_customers_status_id)) === false)
								{
									$coo_personal_offer = $coo_child->addChild('personal_offer');
									$coo_personal_offer['customer_group_id'] = $t_customers_status_id;

									$coo_personal_offer->quantity = $t_quantity;
									$coo_personal_offer->price = $t_price;
								}
							}			
						}
					}
				}
				
				break;
				
			case 'special/special_id':
			case 'special/quantity':
			case 'special/price':
			case 'special/date_added':
			case 'special/last_modified':
			case 'special/expiring_date':
			case 'special/date_status_change':
			case 'special/status':
				$t_xml_name = str_replace('special/', '', $p_xml_name);
				
				if(!empty($p_data_array[$this->v_mapper_array['special/special_id']]))
				{
					if($this->node_exists($p_coo_xml, 'special') === false)
					{
						$coo_special = $p_coo_xml->addChild('special');
					}
					else
					{
						$coo_special = $p_coo_xml->special;
					}
					
					if($this->node_exists($coo_special, $t_xml_name) === false)
					{
						$coo_special->{$t_xml_name} = $p_data_array[$p_table_column];
					}
				}
				break;
				
			case 'categories/category/category_id':
				$t_xml_name = substr($p_xml_name, strrpos($p_xml_name, '/') + 1);
				
				if(!empty($p_data_array[$this->v_mapper_array['categories/category/category_id']]))
				{
					if($this->node_exists($p_coo_xml, 'categories') === false)
					{
						$coo_categories = $p_coo_xml->addChild('categories');
					}
					else
					{
						$coo_categories = $p_coo_xml->categories;
					}
					
					foreach ($p_data_array[$p_table_column] as $t_category_id)
					{
						if($this->node_value_exists($coo_categories, 'category', $t_xml_name, $t_category_id) === false)
						{
							$coo_category = $coo_categories->addChild('category');
							$coo_category->{$t_xml_name} = $t_category_id;
						}
					}
				}
				break;
			case 'cross_selling_products/cross_selling_product/product_id':
			case 'cross_selling_products/cross_selling_product/sort_order':
				break;
			
			case 'ean':
			case 'model':
			case 'template':
			case 'attributes_template':
			case 'attributes_listing_template':
				$t_xml_name = $p_xml_name;
				
				if($this->node_exists($p_coo_xml, $t_xml_name) === false)
				{
					$p_coo_xml->{$t_xml_name} = $this->wrap_value($p_data_array[$p_table_column]);
				}
				break;
				
			default:
				$t_xml_name = $p_xml_name;
				
				if($this->node_exists($p_coo_xml, $t_xml_name) === false)
				{
					$p_coo_xml->{$t_xml_name} = $p_data_array[$p_table_column];
				}
				break;
		}
	}
}
