<?php
/* --------------------------------------------------------------
   AdminLangEditAjaxHandler.inc.php 2014-03-07 gambio
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

require_once(DIR_FS_CATALOG . 'gm/inc/gm_get_language.inc.php');

class AdminLangEditAjaxHandler extends AjaxHandler
{
	function get_permission_status($p_customers_id=NULL)
	{
		if($_SESSION['customers_status']['customers_status_id'] === '0')
		{
			#admins only
			return true;
		}
		return false;
	}

	function proceed()
	{
		$t_needle = xtc_db_input($this->v_data_array['POST']['needle']);

		$t_languages_array = gm_get_language();
		
		switch($this->v_data_array['GET']['act'])
		{
			case 'search':
				$t_query ='SELECT 
								s.section_name,
								s.language_id,
								sp.language_section_phrase_id,
								sp.language_section_id,
								sp.phrase_name,
								sp.phrase_value
							FROM 
								language_sections s,
								language_section_phrases sp
							WHERE
								s.language_section_id = sp.language_section_id AND 
								(sp.phrase_value LIKE "%' . $t_needle . '%" OR sp.phrase_name LIKE "%' . $t_needle . '%")';

				$t_result = xtc_db_query($t_query);
				
				$t_output_html = '';

				if(xtc_db_num_rows($t_result) > 0)
				{
					while($t_row = xtc_db_fetch_array($t_result)) 
					{
						$t_output_html .= '<div style="padding:0px" class="gm_border dataTableRow">';
						$t_output_html .= '<div class="result_phrase_name">'. $t_row['phrase_name'] . ' (' . $t_languages_array[$t_row['language_id']]['name'] . ', section: ' . $t_row['section_name'] . '): </div>';
						$t_output_html .= '<div class="result_phrase_value" id="id'. $t_row['language_section_phrase_id'] . '">' . htmlentities_wrapper($t_row['phrase_value']) . '</div>';
						$t_output_html .= '</div>';
					}

				} 
				else 
				{
						$t_output_html .= '<div style="padding:5px" class="gm_border dataTableRow">';
						$t_output_html .= GM_MESSAGE_NO_RESULT;
						$t_output_html .= '</div>';
				}
				
				$this->v_output_buffer = $t_output_html;
				break;

			case 'save_content':
				$content 	= xtc_db_input(xtc_db_prepare_input($this->v_data_array['POST']['content']));
				$content_id = xtc_db_input(xtc_db_prepare_input(substr($this->v_data_array['POST']['content_id'], 2)));

				$t_sql = 'UPDATE language_section_phrases
							SET	phrase_value = "' . $content . '"
							WHERE language_section_phrase_id = "' . $content_id . '"';
				xtc_db_query($t_sql);
				break;

			default:
		}

		return true;
	}
}