<?php
/* --------------------------------------------------------------
  HeaderContentView.inc.php 2014-07-14 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2014 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------

  based on:
  (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
  (c) 2002-2003 osCommerce(header.php,v 1.40 2003/03/14); www.oscommerce.com
  (c) 2003	 nextcommerce (header.php,v 1.13 2003/08/17); www.nextcommerce.org
  (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: header.php 1140 2005-08-10 10:16:00Z mz $)

  Released under the GNU General Public License
  -----------------------------------------------------------------------------------------
  Third Party contribution:

  Credit Class/Gift Vouchers/Discount Coupons (Version 5.10)
  http://www.oscommerce.com/community/contributions,282
  Copyright (c) Strider | Strider@oscworks.com
  Copyright (c  Nick Stanko of UkiDev.com, nick@ukidev.com
  Copyright (c) Andre ambidex@gmx.net
  Copyright (c) 2001,2002 Ian C Wilson http://www.phesis.org

  Released under the GNU General Public License
  --------------------------------------------------------------------------------------- */

// include needed functions
require_once(DIR_FS_INC . 'xtc_output_warning.inc.php');
require_once(DIR_FS_INC . 'xtc_image.inc.php');
require_once(DIR_FS_INC . 'xtc_parse_input_field_data.inc.php');
require_once(DIR_FS_INC . 'xtc_draw_separator.inc.php');
require_once(DIR_FS_INC . 'xtc_banner_exists.inc.php');
require_once(DIR_FS_INC . 'xtc_display_banner.inc.php');
require_once(DIR_FS_INC . 'xtc_update_banner_display_count.inc.php');

class HeaderContentView extends ContentView
{
	protected $style_edit_mode;
	protected $script_name;
	protected $c_path;
	protected $coo_product;
	protected $languages_id;
	protected $extender_html;
	protected $coo_payment;

	public function __construct()
	{
		parent::__construct();

		$this->set_content_template('module/head.html');
	}

	public function prepare_data()
	{
		$this->content_array['HTML_PARAMS'] = HTML_PARAMS;

		$this->content_array['BASE_URL'] = GM_HTTP_SERVER . DIR_WS_CATALOG;

		$coo_logo_manager = MainFactory::create_object('GMLogoManager', array('gm_logo_favicon'));
		if($coo_logo_manager->logo_use == '1')
		{
			$this->content_array['FAVICON'] = $coo_logo_manager->logo_path . $coo_logo_manager->logo_file;
		}

		$t_css_params_array = array();

		if($this->style_edit_mode == 'edit' || $this->style_edit_mode == 'sos')
		{
			$t_css_params_array[] = 'renew_cache=1&amp;style_edit=1&amp;current_template=' . CURRENT_TEMPLATE;
		}
		elseif($this->style_edit_mode == 'stop')
		{
			$t_css_params_array[] = 'renew_cache=1&amp;stop_style_edit=1&amp;current_template=' . CURRENT_TEMPLATE;
		}
		else
		{
			$t_css_params_array[] = 'current_template=' . CURRENT_TEMPLATE;
		}

		$t_css_params_array[] = 'http_caching=' . HTTP_CACHING;
		$t_css_params_array[] = 'gzip=' . GZIP_COMPRESSION;
		$t_css_params_array[] = 'gzip_level=' . GZIP_LEVEL;
		$t_css_params_array[] = 'ob_gzhandler=' . PREFER_GZHANDLER;

		$this->content_array['CSS_PARAMS'] = implode('&amp;', $t_css_params_array);
		$this->content_array['STYLE_EDIT_MODE'] = $this->style_edit_mode;
		$this->content_array['additional_html_array'] = $this->get_additional_html_array();
	}

	public function get_warnings_html()
	{
		ob_start();

		// check if the 'install' directory exists, and warn of its existence
		if(WARN_INSTALL_EXISTENCE == 'true')
		{
			if(file_exists(dirname($_SERVER['SCRIPT_FILENAME']) . '/gambio_installer'))
			{
				xtc_output_warning(WARNING_INSTALL_DIRECTORY_EXISTS);
			}
		}

		// check if the configure.php file is writeable
		if(WARN_CONFIG_WRITEABLE == 'true')
		{
			if((file_exists(dirname($_SERVER['SCRIPT_FILENAME']) . '/includes/configure.php')) && (is_writeable(dirname($_SERVER['SCRIPT_FILENAME']) . '/includes/configure.php')))
			{
				xtc_output_warning(WARNING_CONFIG_FILE_WRITEABLE);
			}
		}

		// check if the session folder is writeable
		if(WARN_SESSION_DIRECTORY_NOT_WRITEABLE == 'true')
		{
			if(STORE_SESSIONS == '')
			{
				if(!is_dir(xtc_session_save_path()))
				{
					xtc_output_warning(WARNING_SESSION_DIRECTORY_NON_EXISTENT);
				}
				elseif(!is_writeable(xtc_session_save_path()))
				{
					xtc_output_warning(WARNING_SESSION_DIRECTORY_NOT_WRITEABLE);
				}
			}
		}

		// check session.auto_start is disabled
		if((function_exists('ini_get')) && (WARN_SESSION_AUTO_START == 'true'))
		{
			if(ini_get('session.auto_start') == '1')
			{
				xtc_output_warning(WARNING_SESSION_AUTO_START);
			}
		}

		if((WARN_DOWNLOAD_DIRECTORY_NOT_READABLE == 'true') && (DOWNLOAD_ENABLED == 'true'))
		{
			if(!is_dir(DIR_FS_DOWNLOAD))
			{
				xtc_output_warning(WARNING_DOWNLOAD_DIRECTORY_NON_EXISTENT);
			}
		}

		$t_html = ob_get_clean();

		return $t_html;
	}

	public function get_additional_html_array()
	{
		$t_html_array = array();
		$t_html_array['head'] = array();
		$t_html_array['head']['top'] = '';
		$t_html_array['head']['bottom'] = '';
		$t_html_array['body'] = array();
		$t_html_array['body']['params'] = '';
		$t_html_array['body']['top'] = '';

		$t_uninitialized_array = $this->get_uninitialized_variables(array('extender_html'));
		if(empty($t_uninitialized_array))
		{
			$t_html_array['head']['top'] .= $this->get_meta_tags_html();

			ob_start();

			// require theme based javascript
			if(MOBILE_ACTIVE != 'true')
			{
				require(DIR_FS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/javascript/general.js.php');
			}

			if(strpos($GLOBALS['PHP_SELF'], FILENAME_CHECKOUT_PAYMENT) !== false)
			{
				$coo_payment = $this->coo_payment;
				$coo_payment->javascript_validation();
			}

			$t_html_array['head']['bottom'] .= ob_get_clean();

			if(gm_get_env_info('TEMPLATE_VERSION') < FIRST_GX2_TEMPLATE_VERSION)
			{
				$t_html_array['head']['bottom'] .= $this->get_deprecated_html();
			}

			$t_html_array['head']['bottom'] .= $this->extender_html;

			if(strpos($GLOBALS['PHP_SELF'], FILENAME_POPUP_IMAGE) !== false)
			{
				$t_html_array['body']['params'] .= ' onload="resize();" ';
			}

			$t_html_array['body']['top'] .= $this->get_warnings_html();

			$this->get_modules_html($t_html_array);
		}
		else
		{
			trigger_error("Variable(s) " . implode(', ', $t_uninitialized_array) . " do(es) not exist in class " . get_class($this) . " or is/are null", E_USER_ERROR);
		}

		return $t_html_array;
	}

	public function get_deprecated_html()
	{
		ob_start();
		$t_html_output = '';

		if(strpos($GLOBALS['PHP_SELF'], FILENAME_CREATE_ACCOUNT) !== false
			|| strpos($GLOBALS['PHP_SELF'], FILENAME_CREATE_GUEST_ACCOUNT) !== false
			|| strpos($GLOBALS['PHP_SELF'], FILENAME_ACCOUNT_PASSWORD) !== false
			|| strpos($GLOBALS['PHP_SELF'], FILENAME_ACCOUNT_EDIT) !== false
			|| strpos($GLOBALS['PHP_SELF'], FILENAME_ADDRESS_BOOK_PROCESS) !== false
			|| strpos($GLOBALS['PHP_SELF'], FILENAME_CHECKOUT_SHIPPING_ADDRESS) !== false
			|| strpos($GLOBALS['PHP_SELF'], FILENAME_CHECKOUT_PAYMENT_ADDRESS) !== false
		)
		{
			include(DIR_FS_CATALOG . 'includes/form_check.js.php');
		}

		$t_html_output .= ob_get_clean();

		if(strpos($GLOBALS['PHP_SELF'], FILENAME_CHECKOUT_SHIPPING_ADDRESS) !== false
			|| strpos($GLOBALS['PHP_SELF'], FILENAME_CHECKOUT_PAYMENT_ADDRESS) !== false)
		{
			$t_html_output .= "\t\t" . '<script type="text/javascript"><!--
			function check_form_optional(form_name) {
					var form = form_name;

					var firstname = form.elements["firstname"].value;
					var lastname = form.elements["lastname"].value;
					var street_address = form.elements["street_address"].value;

					if (firstname == "" && lastname == "" && street_address == "") {
						return true;
					} else {
						return check_form(form_name);
					}
				}
			//--></script>' . "\n";
		}

		if(strpos($GLOBALS['PHP_SELF'], FILENAME_ADVANCED_SEARCH) !== false)
		{
			$t_html_output .= "\t\t" . '<script type="text/javascript" src="includes/general.js"></script>
			<script type="text/javascript"><!--
			function check_form() {
					var error_message = unescape("' . xtc_js_lang(JS_ERROR) . '");
					var error_found = false;
					var error_field;
					var keywords = document.getElementById("advanced_search").keywords.value;
					var pfrom = document.getElementById("advanced_search").pfrom.value;
					var pto = document.getElementById("advanced_search").pto.value;
					var pfrom_float;
					var pto_float;

					if ((keywords == "" || keywords.length < 1) && (pfrom == "" || pfrom.length < 1) && (pto == "" || pto.length < 1)) {
						error_message = error_message + unescape("' . xtc_js_lang(JS_AT_LEAST_ONE_INPUT) . '");
						error_field = document.getElementById("advanced_search").keywords;
						error_found = true;
					}

					if (pfrom.length > 0) {
						pfrom_float = parseFloat(pfrom);
						if (isNaN(pfrom_float)) {
							error_message = error_message + unescape("' . xtc_js_lang(JS_PRICE_FROM_MUST_BE_NUM) . '");
							error_field = document.getElementById("advanced_search").pfrom;
							error_found = true;
						}
					} else {
						pfrom_float = 0;
					}

					if (pto.length > 0) {
						pto_float = parseFloat(pto);
						if (isNaN(pto_float)) {
							error_message = error_message + unescape("' . xtc_js_lang(JS_PRICE_TO_MUST_BE_NUM) . '");
							error_field = document.getElementById("advanced_search").pto;
							error_found = true;
						}
					} else {
						pto_float = 0;
					}

					if ((pfrom.length > 0) && (pto.length > 0)) {
						if ((!isNaN(pfrom_float)) && (!isNaN(pto_float)) && (pto_float < pfrom_float)) {
							error_message = error_message + unescape("' . xtc_js_lang(JS_PRICE_TO_LESS_THAN_PRICE_FROM) . '");
							error_field = document.getElementById("advanced_search").pto;
							error_found = true;
						}
					}

					if (error_found == true) {
						alert(error_message);
						error_field.focus();
						return false;
					}
				}

				function popupWindow(url) {
					window.open(url, "popupWindow", "toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,copyhistory=no,width=450,height=280,screenX=150,screenY=150,top=150,left=150")
				}
			//--></script>' . "\n";
		}

		if(strpos($GLOBALS['PHP_SELF'], FILENAME_PRODUCT_REVIEWS_WRITE) !== false)
		{
			$t_html_output .= "\t\t" . '<script type="text/javascript"><!--
				function checkForm() {
					var error = 0;
					var error_message = unescape("' . xtc_js_lang(JS_ERROR) . '");

					var review = document.getElementById("product_reviews_write").review.value;

					if (review.length < ' . REVIEW_TEXT_MIN_LENGTH . ') {
						error_message = error_message + unescape("' . xtc_js_lang(sprintf(JS_REVIEW_TEXT, REVIEW_TEXT_MIN_LENGTH)) . '");
						error = 1;
					}

					if (!((document.getElementById("product_reviews_write").rating[0].checked) || (document.getElementById("product_reviews_write").rating[1].checked) || (document.getElementById("product_reviews_write").rating[2].checked) || (document.getElementById("product_reviews_write").rating[3].checked) || (document.getElementById("product_reviews_write").rating[4].checked))) {
						error_message = error_message + unescape("' . xtc_js_lang(JS_REVIEW_RATING) . '");
						error = 1;
					}

					if (error == 1) {
						alert(error_message);
						return false;
					} else {
						return true;
					}
				}
			//--></script>' . "\n";
		}

		if(strpos($GLOBALS['PHP_SELF'], FILENAME_POPUP_IMAGE) !== false)
		{
			$t_html_output .= "\t\t" . '<script type="text/javascript"><!--
				var i = 0;
				function resize() {
					if (navigator.appName == "Netscape")
						i = 40;
					if (document.images[0])
						window.resizeTo(document.images[0].width + 30, document.images[0].height + 60 - i);
					self.focus();
				}
			//--></script>' . "\n";
		}

		return $t_html_output;
	}

	public function get_modules_html(&$p_html_array)
	{
		$t_uninitialized_array = $this->get_uninitialized_variables(array('languages_id'));

		if(empty($t_uninitialized_array))
		{
			// econda tracking
			if(TRACKING_ECONDA_ACTIVE == 'true')
			{
				$p_html_array['body']['top'] .= "\n\t\t" . '<script type="text/javascript">
				<!--
				var emos_kdnr = "' . TRACKING_ECONDA_ID . '";
				//-->
				</script>' . "\n";
			}
			// econda tracking END
		}
		else
		{
			trigger_error("Variable(s) " . implode(', ', $t_uninitialized_array) . " do(es) not exist in class " . get_class($this) . " or is/are null", E_USER_ERROR);
		}

		return $p_html_array;
	}

	public function get_meta_tags_html()
	{
		$t_meta_tags_html = '';
		$t_uninitialized_array = $this->get_uninitialized_variables(array(	'c_path',
																			'coo_product',
																			'script_name'
																			));
		if(empty($t_uninitialized_array))
		{

			$coo_meta = MainFactory::create_object('GMMeta', array(false));
			$t_meta_tags_html = $coo_meta->get($this->c_path, $this->coo_product);

			if(strpos($this->script_name, 'create_account.php') !== false || strpos($this->script_name, 'create_guest_account.php') !== false)
			{
				$t_meta_tags_html .= "\t\t" . '<meta http-equiv="pragma" content="no-cache" />' . "\n";
			}
		}
		else
		{
			trigger_error("Variable(s) " . implode(', ', $t_uninitialized_array) . " do(es) not exist in class " . get_class($this) . " or is/are null", E_USER_ERROR);
		}

		return $t_meta_tags_html;
	}

	protected function set_validation_rules()
	{
		// GENERAL VALIDATION RULES
		$this->validation_rules_array['style_edit_mode']	= array('type' 			=> 'string',
																	'strict'		=> 'true');
		$this->validation_rules_array['script_name']		= array('type' 			=> 'string',
																	'strict' 		=> 'true');
		$this->validation_rules_array['c_path']				= array('type' 			=> 'string',
																	'strict' 		=> 'true');
		$this->validation_rules_array['coo_product']		= array('type' 			=> 'object',
																	'object_type' 	=> 'product');
		$this->validation_rules_array['languages_id']		= array('type'			=> 'int');
		$this->validation_rules_array['extender_html']		= array('type' 			=> 'string',
																	'strict' 		=> 'true');
		$this->validation_rules_array['coo_payment']		= array('type' 			=> 'object',
																	'object_type' 	=> 'payment');
	}
}
