<?php
/* --------------------------------------------------------------
   AlsoPurchasedContentView.inc.php 2014-02-28 gambio
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(also_purchased_products.php,v 1.21 2003/02/12); www.oscommerce.com
   (c) 2003	 nextcommerce (also_purchased_products.php,v 1.9 2003/08/17); www.nextcommerce.org
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: also_purchased_products.php 1243 2005-09-25 09:33:02Z mz $)

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

class AlsoPurchasedContentView extends ContentView
{
	protected $coo_product;
	protected $data_array;
	
	function __construct()
	{
		parent::__construct();
		
		$this->set_content_template('module/also_purchased.html');
		$this->set_flat_assigns(true);
	}
	
	protected function set_validation_rules()
	{
		$this->validation_rules_array['data_array']		= array('type'			=> 'array');
		$this->validation_rules_array['coo_product']	= array('type'			=> 'object',
															 	'object_type'	=> 'product');
	}
	
	protected function set_deprecated_array()
	{
		$this->deprecated_array[1][] = 'GM_THUMBNAIL_WIDTH';
	}
	
	function prepare_data()
	{
		$t_uninitialized_array = $this->get_uninitialized_variables(array('coo_product'));

		if(empty($t_uninitialized_array))
		{
			$this->get_data();
			if(count($this->data_array) >= MIN_DISPLAY_ALSO_PURCHASED && count($this->data_array) > 0)
			{
				$this->add_data();
			}
			else
			{
				$this->build_html = false;
			}
		}
		else
		{
			trigger_error("Variable(s) " . implode(', ', $t_uninitialized_array) . " do(es) not exist in class " . get_class($this) . " or is/are null", E_USER_ERROR);
		}
	}

	protected function get_data()
	{
		$this->data_array = $this->coo_product->getAlsoPurchased();
	}

	protected function add_data()
	{
		$this->content_array['TRUNCATE_PRODUCTS_NAME'] = gm_get_conf('TRUNCATE_PRODUCTS_NAME');
		$this->content_array['GM_THUMBNAIL_WIDTH'] = PRODUCT_IMAGE_THUMBNAIL_WIDTH + 10;
		$this->content_array['module_content'] = $this->data_array;
	}
}