<?php
/* --------------------------------------------------------------
   CategoryListingContentView.inc.php 2014-04-02 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


  based on:
  (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
  (c) 2002-2003 osCommerce(default.php,v 1.84 2003/05/07); www.oscommerce.com
  (c) 2003  nextcommerce (default.php,v 1.11 2003/08/22); www.nextcommerce.org
  (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: default.php 1292 2005-10-07 16:10:55Z mz $)

  Released under the GNU General Public License
  -----------------------------------------------------------------------------------------
  Third Party contributions:
  Enable_Disable_Categories 1.3        Autor: Mikel Williams | mikel@ladykatcostumes.com
  Customers Status v3.x  (c) 2002-2003 Copyright Elari elari@free.fr | www.unlockgsm.com/dload-osc/ | CVS : http://cvs.sourceforge.net/cgi-bin/viewcvs...by=date#dirlist

  Released under the GNU General Public License
  ---------------------------------------------------------------------------------------*/

// include needed functions


class CategoryListingContentView extends ContentView
{
	function __construct($p_template = 'default')
	{
		parent::__construct();
		$filepath = DIR_FS_CATALOG.'templates/'.CURRENT_TEMPLATE.'/module/categorie_listing/';
		$c_template = basename($p_template);

		// get default template
		$c_template = $this->get_default_template($filepath, $p_template);

		$this->set_content_template('module/categorie_listing/' . $c_template);
		$this->set_flat_assigns(true);
	}

	function get_html($p_current_category_id)
	{
		$c_current_category_id = (int)$p_current_category_id;

		if(GROUP_CHECK == 'true')
		{
			$group_check = "and c.group_permission_".$_SESSION['customers_status']['customers_status_id']."=1 ";
		}
		$category_query = "select
								cd.categories_description,
								cd.categories_name,
								cd.categories_heading_title,
								cd.gm_alt_text,
								c.show_sub_categories,
								c.show_sub_categories_images,
								c.show_sub_categories_names,
								c.show_sub_products,
								c.categories_template,
								c.view_mode_tiled,
								c.categories_image from ".TABLE_CATEGORIES." c, ".TABLE_CATEGORIES_DESCRIPTION." cd
							where c.categories_id = '".$c_current_category_id."'
								and cd.categories_id = '".$c_current_category_id."'
								".$group_check."
								and cd.language_id = '".(int) $_SESSION['languages_id']."'";

		$category_query = xtDBquery($category_query);
		$category = xtc_db_fetch_array($category_query, true);

		if($category['show_sub_products'] == 1 && $_SESSION['coo_filter_manager']->is_active() == false)
		{
			$_SESSION['coo_filter_manager']->reset();
			$_SESSION['coo_filter_manager']->set_categories_id($c_current_category_id);
			$_SESSION['coo_filter_manager']->set_price_range_start(0);
			$_SESSION['coo_filter_manager']->set_active(true);
		}
		
		$t_feature_value_group_array = $_SESSION['coo_filter_manager']->get_feature_value_group_array();
		# transfer feature_value_groups to product finder
		$coo_finder = MainFactory::create_object('IndexFeatureProductFinder');
		foreach($t_feature_value_group_array as $t_feature_value_group)
		{
			$coo_finder->add_feature_value_group($t_feature_value_group);
		}
		$coo_filter_selection_content_view = MainFactory::create_object('FilterSelectionContentView');
		$coo_filter_selection_content_view->set_('feature_value_group_array', $t_feature_value_group_array);
		$coo_filter_selection_content_view->set_('language_id', $_SESSION['languages_id']);
		$t_filter_selection_html = $coo_filter_selection_content_view->get_html();
		$this->set_content_data('FILTER_SELECTION', $t_filter_selection_html);

		if($category['show_sub_categories'] == 1 || MOBILE_ACTIVE == 'true')
		{
				if(GROUP_CHECK == 'true')
				{
					$group_check = "and c.group_permission_".$_SESSION['customers_status']['customers_status_id']."=1 ";
				}
				$categories_query = "select
											cd.categories_description,
											c.categories_id,
											cd.categories_name,
											cd.gm_alt_text,
											cd.categories_heading_title,
											c.categories_image,
											c.parent_id from ".TABLE_CATEGORIES." c, ".TABLE_CATEGORIES_DESCRIPTION." cd
										where c.categories_status = '1'
											and c.parent_id = '".$c_current_category_id."'
											and c.categories_id = cd.categories_id
											".$group_check."
											and cd.language_id = '".(int) $_SESSION['languages_id']."'
										order by sort_order, cd.categories_name";
			$categories_query = xtDBquery($categories_query);

			$coo_seo_boost = MainFactory::create_object('GMSEOBoost');

			$rows = 0;
			while($categories = xtc_db_fetch_array($categories_query, true))
			{
				$rows ++;

				$cPath_new = xtc_category_link($categories['categories_id'],$categories['categories_name']);

				$width = (int) (100 / MAX_DISPLAY_CATEGORIES_PER_ROW).'%';
				$image = '';
				if($categories['categories_image'] != '')
				{
					$image = DIR_WS_IMAGES.'categories/'.$categories['categories_image'];
				}

				if($coo_seo_boost->boost_categories)
				{
					$gm_category_link = $coo_seo_boost->get_boosted_category_url($categories['categories_id']);
				}
				else
				{
					$gm_category_link = xtc_href_link(FILENAME_DEFAULT, $cPath_new);
				}

				$categories_content[] = array (
												'CATEGORIES_NAME' => $categories['categories_name'],
												'CATEGORIES_ALT_TEXT' => $categories['gm_alt_text'],
												'CATEGORIES_HEADING_TITLE' => $categories['categories_heading_title'],
												'CATEGORIES_IMAGE' => $image,
												'CATEGORIES_LINK' => $gm_category_link,
												'CATEGORIES_DESCRIPTION' => $categories['categories_description']
											);

			}
			$new_products_category_id = $c_current_category_id;
			// BOF GM_MOD
			define('GM_CAT_COUNT', count($categories_content));

			if(count($categories_content) > 0)
			{
				if(MAX_DISPLAY_CATEGORIES_PER_ROW > count($categories_content))
				{
					$this->set_content_data('GM_LI_WIDTH', 100/count($categories_content) - 2);
				}
				else
				{
					$this->set_content_data('GM_LI_WIDTH', 100/MAX_DISPLAY_CATEGORIES_PER_ROW - 2);
				}
				//include (DIR_WS_MODULES.FILENAME_NEW_PRODUCTS);
				// EOF GM_MOD

				$image = '';
				if($category['categories_image'] != '')
				{
					$image = DIR_WS_IMAGES.'categories/'.$category['categories_image'];
				}
				$this->set_content_data('CATEGORIES_NAME', $category['categories_name']);
				$this->set_content_data('CATEGORIES_HEADING_TITLE', $category['categories_heading_title']);

				$this->set_content_data('CATEGORIES_IMAGE', $image);
				$this->set_content_data('CATEGORIES_ALT_TEXT', $category['gm_alt_text']);
				$this->set_content_data('CATEGORIES_DESCRIPTION', $category['categories_description']);

				$this->set_content_data('SHOW_SUB_CATEGORIES_IMAGES', $category['show_sub_categories_images']);
				$this->set_content_data('SHOW_SUB_CATEGORIES_NAMES', $category['show_sub_categories_names']);
				
				if(isset($t_filter_selection_array) && count($t_filter_selection_array) != 0)
				{
					$this->set_content_data('FILTER_SELECTION_ARRAY', $t_filter_selection_array);
				}
			}

			$this->set_content_data('module_content', $categories_content);
		}

		$t_html_output = $this->build_html();

		return $t_html_output;
	}
}
