<?php
/* --------------------------------------------------------------
   CrossSellingContentView.inc.php 2014-02-28 gambio
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------

(c) 2005 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: cross_selling.php 1243 2005-09-25 09:33:02Z mz $) 

   Released under the GNU General Public License
   -----------------------------------------------------------------------------------------
   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(also_purchased_products.php,v 1.21 2003/02/12); www.oscommerce.com
   (c) 2003	 nextcommerce (also_purchased_products.php,v 1.9 2003/08/17); www.nextcommerce.org
   ---------------------------------------------------------------------------------------*/

class CrossSellingContentView extends ContentView
{
	protected $coo_product;
	protected $type = 'cross_selling';
	
	public function __construct()
	{
		parent::__construct();
		
		$this->set_flat_assigns(true);
	}
	
	protected function set_validation_rules()
	{
		$this->validation_rules_array['type'] 			= array('type'			=> 'string');
		$this->validation_rules_array['coo_product']	= array('type'			=> 'object',
																'object_type'	=> 'product');
	}
	
	protected function set_deprecated_array()
	{
		$this->deprecated_array[1][] = 'GM_THUMBNAIL_WIDTH';
		$this->deprecated_array[1][] = 'thumbnail_heigth';
	}

	public function prepare_data()
	{
		$this->build_html = false;
		$t_uninitialized_array = $this->get_uninitialized_variables(array('coo_product',
																		  'type')
		);

		if(empty($t_uninitialized_array))
		{
			$t_data_array = $this->get_data();
			$this->add_data($t_data_array);
		}
		else
		{
			trigger_error("Variable(s) " . implode(', ', $t_uninitialized_array) . " do(es) not exist in class " . get_class($this) . " or is/are null", E_USER_ERROR);
		}
	}
	
	protected function get_data()
	{
		switch($this->type)
		{
			case 'cross_selling':
				$this->set_content_template('module/cross_selling.html');
				return $this->coo_product->getCrossSells();

			case 'reverse_cross_selling':
				$this->set_content_template('module/reverse_cross_selling.html');
				return $this->coo_product->getReverseCrossSells();
			
			default:
				return array();
		}
	}
	
	protected function add_data($p_data_array)
	{
		if(count($p_data_array) > 0)
		{
			$this->build_html = true;
			$this->set_content_data('GM_THUMBNAIL_WIDTH', PRODUCT_IMAGE_THUMBNAIL_WIDTH + 10);
			$this->set_content_data('thumbnail_heigth', PRODUCT_IMAGE_THUMBNAIL_HEIGHT + 40);
			$this->set_content_data('TRUNCATE_PRODUCTS_NAME', gm_get_conf('TRUNCATE_PRODUCTS_NAME'));
			$this->set_content_data('module_content', $p_data_array);
		}
	}
}