<?php
/* --------------------------------------------------------------
   NewsletterContentView.inc.php 2014-02-28 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce www.oscommerce.com
   (c) 2003	 nextcommerce www.nextcommerce.org
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: newsletter.php,v 1.0)

   XTC-NEWSLETTER_RECIPIENTS RC1 - Contribution for XT-Commerce http://www.xt-commerce.com
   by Matthias Hinsche http://www.gamesempire.de

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

class NewsletterContentView extends ContentView
{
	protected $form_send = false;
	protected $email_address = '';
	protected $info_message = '';
	
	public function __construct()
	{
		parent::__construct();
		$this->set_content_template('module/newsletter.html');
		$this->set_flat_assigns(true);
	}
	
	protected function set_validation_rules()
	{
		// SET VALIDATION RULES
		$this->validation_rules_array['form_send']		= array('type' => 'bool');
		$this->validation_rules_array['email_address']	= array('type' => 'string');
		$this->validation_rules_array['info_message']	= array('type' => 'string');
	}
	
	protected function set_deprecated_array()
	{
		$this->deprecated_array[1][] = 'VVIMG';
		$this->deprecated_array[1][] = 'text_newsletter';
		$this->deprecated_array[1][] = 'FORM_ACTION';
		$this->deprecated_array[1][] = 'INPUT_EMAIL';
		$this->deprecated_array[1][] = 'INPUT_CODE';
		$this->deprecated_array[1][] = 'CHECK_INP';
		$this->deprecated_array[1][] = 'CHECK_DEL';
		$this->deprecated_array[1][] = 'BUTTON_BACK';
		$this->deprecated_array[1][] = 'BUTTON_SUBMIT';
		$this->deprecated_array[1][] = 'FORM_END';
	}
	
	public function prepare_data()
	{
		$this->content_array['VVIMG'] = '<img src="'.xtc_href_link(FILENAME_DISPLAY_VVCODES).'" alt="Captcha" />';
		$this->content_array['VVIMG_URL'] = xtc_href_link(FILENAME_DISPLAY_VVCODES);
		$this->content_array['text_newsletter'] = TEXT_NEWSLETTER;
		$this->content_array['info_message'] = $this->info_message;
		$this->content_array['FORM_ACTION'] = xtc_draw_form('sign', xtc_href_link(FILENAME_NEWSLETTER, 'action=process', 'NONSSL', true, true, true));
		$this->content_array['FORM_ID'] = 'sign';
		$this->content_array['FORM_ACTION_URL'] = xtc_href_link(FILENAME_NEWSLETTER, 'action=process', 'NONSSL', true, true, true);
		$this->content_array['FORM_METHOD'] = 'post';
		$this->content_array['INPUT_EMAIL'] = xtc_draw_input_field('email', htmlentities_wrapper($this->email_address));
		$this->content_array['INPUT_EMAIL_NAME'] = 'email';
		$this->content_array['INPUT_EMAIL_VALUE'] = htmlentities_wrapper($this->email_address);
		$this->content_array['INPUT_CODE'] = xtc_draw_input_field('vvcode', '', 'size="6" maxlength="6"', 'text', false);
		$this->content_array['INPUT_CODE_NAME'] = 'vvcode';
		$this->content_array['CHECK_INP'] = xtc_draw_radio_field('check', 'inp');
		$this->content_array['CHECK_DEL'] = xtc_draw_radio_field('check', 'del');
		$this->content_array['INPUT_RADIO_NAME'] = 'check';
		$this->content_array['INPUT_SUBSCRIBE_VALUE'] = 'inp';
		$this->content_array['INPUT_UNSUBSCRIBE_VALUE'] = 'del';
		$this->content_array['BUTTON_BACK'] = '<a href="'.xtc_href_link(FILENAME_ACCOUNT, '', 'SSL').'">'.xtc_image_button('button_back.gif', IMAGE_BUTTON_BACK).'</a>';
		$this->content_array['BUTTON_BACK_LINK'] = xtc_href_link(FILENAME_ACCOUNT, '', 'SSL');
		$this->content_array['BUTTON_BACK_NL_LINK'] = xtc_href_link('newsletter.php', '', 'SSL');
		$this->content_array['BUTTON_SUBMIT'] = xtc_image_submit('button_send.gif', IMAGE_BUTTON_LOGIN);
		$this->content_array['FORM_END'] = '</form>';
		$this->content_array['form_send'] = $this->form_send;
		$this->content_array['GM_PRIVACY_LINK'] = gm_get_privacy_link('GM_CHECK_PRIVACY_ACCOUNT_NEWSLETTER');
	}
}