<?php
/* --------------------------------------------------------------
   GraduatedPricesContentView.inc.php 2014-09-14 gambio
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommercebased on original files from OSCommerce CVS 2.2 2002/08/28 02:14:35 www.oscommerce.com
   (c) 2003	 nextcommerce (graduated_prices.php,v 1.11 2003/08/17); www.nextcommerce.org
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: graduated_prices.php 1243 2005-09-25 09:33:02Z mz $)

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

class GraduatedPricesContentView extends ContentView
{
	protected $customers_status_graduated_prices = 0;
	protected $graduated_prices_array = array();
	protected $coo_product;
	
	function __construct()
	{
		parent::__construct();
		
		$this->set_content_template('module/graduated_price.html');
		$this->set_flat_assigns(true);
	}
	
	protected function set_validation_rules()
	{
		$this->validation_rules_array['customers_status_graduated_prices']	= array('type' => 'int');
		$this->validation_rules_array['graduated_prices_array']				= array('type' => 'array');
		$this->validation_rules_array['coo_product']						= array('type' => 'object',
																					'object_type' => 'product');
	}
	
	protected function set_deprecated_array()
	{
		$this->deprecated_array[1][] = 'GRADUATED_BOX_WIDTH';
	}

	function prepare_data()
	{
		$t_uninitialized_array = $this->get_uninitialized_variables(array('coo_product'));

		if(empty($t_uninitialized_array))
		{
			$this->get_data();
			$this->add_data();
		}
		else
		{
			trigger_error("Variable(s) " . implode(', ', $t_uninitialized_array) . " do(es) not exist in class " . get_class($this) . " or is/are null", E_USER_ERROR);
		}
	}
	
	protected function get_data()
	{
		$this->build_html = false;
		$this->graduated_prices_array = array();

		$this->graduated_prices_array = $this->coo_product->getGraduated();
		
		if(count($this->graduated_prices_array) > 1 && $this->customers_status_graduated_prices == 1)
		{
			$this->build_html = true;
		}
	}
	
	protected function add_data()
	{
		if($this->build_html == false)
		{
			return;
		}

		if(PRODUCT_IMAGE_INFO_WIDTH < (190 - 16))
		{
			$this->content_array['GRADUATED_BOX_WIDTH'] = 190+16;
		}
		else
		{
			$this->content_array['GRADUATED_BOX_WIDTH'] = PRODUCT_IMAGE_INFO_WIDTH+16+2;
		}

		$this->content_array['module_content'] = $this->graduated_prices_array;
	}
}