<?php
/* --------------------------------------------------------------
  AdvancedSearchContentView.inc.php 2014-02-27 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2014 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------


  based on:
  (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
  (c) 2002-2003 osCommerce(advanced_search.php,v 1.49 2003/02/13); www.oscommerce.com
  (c) 2003	 nextcommerce (advanced_search.php,v 1.13 2003/08/21); www.nextcommerce.org
  (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: advanced_search.php 988 2005-06-18 16:42:42Z mz $)

  Released under the GNU General Public License
  --------------------------------------------------------------------------------------- */

// include needed functions
require_once(DIR_FS_INC . 'xtc_get_categories.inc.php');
require_once(DIR_FS_INC . 'xtc_get_manufacturers.inc.php');
require_once(DIR_FS_INC . 'xtc_checkdate.inc.php');

class AdvancedSearchContentView extends ContentView
{
	function __construct()
	{
		parent::__construct();
		$this->set_content_template('module/advanced_search.html');
		$this->set_flat_assigns(true);
	}
	
	protected function set_deprecated_array()
	{
		$this->deprecated_array[1][] = 'FORM_ACTION';
		$this->deprecated_array[1][] = 'SESSION_ID';
		$this->deprecated_array[1][] = 'INPUT_KEYWORDS';
		$this->deprecated_array[1][] = 'HELP_LINK';
		$this->deprecated_array[1][] = 'HELP_URL';
		$this->deprecated_array[1][] = 'BUTTON_SUBMIT';
		$this->deprecated_array[1][] = 'SELECT_CATEGORIES';
		$this->deprecated_array[1][] = 'ENTRY_SUBCAT';
		$this->deprecated_array[1][] = 'SELECT_MANUFACTURERS';
		$this->deprecated_array[1][] = 'SELECT_PFROM';
		$this->deprecated_array[1][] = 'SELECT_PTO';
		$this->deprecated_array[1][] = 'FORM_END';
	}
	
	function prepare_data()
	{
		$this->content_array['FORM_ACTION'] = xtc_draw_form('advancedsearch', xtc_href_link(FILENAME_ADVANCED_SEARCH_RESULT, '', 'NONSSL', false, true, true), 'get', '') . xtc_hide_session_id();
		$this->content_array['FORM_ID'] = 'advancedsearch';
		$this->content_array['FORM_ACTION_URL'] = xtc_href_link(FILENAME_ADVANCED_SEARCH_RESULT, '', 'NONSSL', false, true, true);
		$this->content_array['FORM_METHOD'] = 'get';

		$this->content_array['SESSION_ID'] = xtc_session_id();

		$this->content_array['INPUT_KEYWORDS'] = xtc_draw_input_field('keywords', '', '', 'text', true, 'gm_class_input inactive_input');
		$this->content_array['INPUT_KEYWORDS_NAME'] = 'keywords';

		$this->content_array['HELP_LINK'] = 'javascript:popupWindow(\'' . xtc_href_link(FILENAME_POPUP_SEARCH_HELP) . '\')';
		$this->content_array['HELP_URL'] = xtc_href_link(FILENAME_POPUP_SEARCH_HELP);
		$this->content_array['BUTTON_SUBMIT'] = xtc_image_submit('button_search.gif', IMAGE_BUTTON_SEARCH);

		$t_categories_array = array();
		$t_categories_array = xtc_get_categories(array(array('id' => '', 'text' => TEXT_ALL_CATEGORIES)));
		$this->content_array['categories_data'] = $t_categories_array;
		$this->content_array['SELECT_CATEGORIES_NAME'] = 'categories_id';
		$this->content_array['SELECT_CATEGORIES'] = xtc_draw_pull_down_menu('categories_id', xtc_get_categories(array(array('id' => '', 'text' => TEXT_ALL_CATEGORIES))), '', '');

		$this->content_array['ENTRY_SUBCAT'] = xtc_draw_checkbox_field('inc_subcat', '1', true);
		$this->content_array['INPUT_SUBCAT_NAME'] = 'inc_subcat';
		$this->content_array['INPUT_SUBCAT_VALUE'] = '1';

		$t_manufacturers_array = array();
		$t_manufacturers_array = xtc_get_manufacturers(array(array('id' => '', 'text' => TEXT_ALL_MANUFACTURERS)));
		$this->content_array['manufacturers_data'] = $t_manufacturers_array;
		$this->content_array['SELECT_MANUFACTURERS_NAME'] = 'manufacturers_id';
		$this->content_array['SELECT_MANUFACTURERS'] = xtc_draw_pull_down_menu('manufacturers_id', xtc_get_manufacturers(array(array('id' => '', 'text' => TEXT_ALL_MANUFACTURERS))), '', '');

		$this->content_array['SELECT_PFROM'] = xtc_draw_input_field('pfrom', '', '', 'text', true, 'gm_class_input inactive_input');
		$this->content_array['SELECT_PFROM_NAME'] = 'pfrom';

		$this->content_array['SELECT_PTO'] = xtc_draw_input_field('pto', '', '', 'text', true, 'gm_class_input inactive_input');
		$this->content_array['SELECT_PTO_NAME'] = 'pto';

		$error = '';
		if(isset($_GET['errorno']))
		{
			if(($_GET['errorno'] & 1) == 1)
			{
				$error .= str_replace('\n', '<br />', JS_AT_LEAST_ONE_INPUT);
			}
			if(($_GET['errorno'] & 10) == 10)
			{
				$error .= str_replace('\n', '<br />', JS_INVALID_FROM_DATE);
			}
			if(($_GET['errorno'] & 100) == 100)
			{
				$error .= str_replace('\n', '<br />', JS_INVALID_TO_DATE);
			}
			if(($_GET['errorno'] & 1000) == 1000)
			{
				$error .= str_replace('\n', '<br />', JS_TO_DATE_LESS_THAN_FROM_DATE);
			}
			if(($_GET['errorno'] & 10000) == 10000)
			{
				$error .= str_replace('\n', '<br />', JS_PRICE_FROM_MUST_BE_NUM);
			}
			if(($_GET['errorno'] & 100000) == 100000)
			{
				$error .= str_replace('\n', '<br />', JS_PRICE_TO_MUST_BE_NUM);
			}
			if(($_GET['errorno'] & 1000000) == 1000000)
			{
				$error .= str_replace('\n', '<br />', JS_PRICE_TO_LESS_THAN_PRICE_FROM);
			}
			if(($_GET['errorno'] & 10000000) == 10000000)
			{
				$error .= str_replace('\n', '<br />', JS_INVALID_KEYWORDS);
			}
		}

		if(gm_get_conf('GM_OPENSEARCH_SEARCH') == 1)
		{
			$this->content_array['gm_opensearch_link_text'] = gm_get_content('GM_OPENSEARCH_LINK', $_SESSION['languages_id']);
			$this->content_array['gm_opensearch_link'] = xtc_href_link('export/opensearch_' . $_SESSION['languages_id'] . '.xml');
		}

		$this->content_array['error'] = $error;
		$this->content_array['FORM_END'] = '</form>';
	}
}