<?php
/* --------------------------------------------------------------
   CallbackServiceAjaxHandler.inc.php 2013-11-14 tb@gambio
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2013 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

require_once(DIR_FS_CATALOG . 'gm/classes/JSON.php');
		
require_once (DIR_FS_INC.'xtc_validate_email.inc.php');
require_once (DIR_FS_INC.'xtc_random_charcode.inc.php');
require_once (DIR_WS_CLASSES.'class.phpmailer.php');
require_once (DIR_FS_INC.'xtc_php_mail.inc.php');

class CallbackServiceAjaxHandler extends AjaxHandler
{
	function get_permission_status($p_customers_id=NULL)
	{
		return true;
	}

	function proceed()
	{
		$t_output_array = array();
		$t_enable_json_output = false;

		$t_action_request = $this->v_data_array['GET']['action'];

		$coo_captcha = $_SESSION['captcha_object'];

		switch($t_action_request)
		{
			case 'check':
				// name and telephone number exist?
				if(empty($this->v_data_array['GET']['name']) || empty($this->v_data_array['GET']['telephone'])){
					$this->v_output_buffer .= GM_CALLBACK_SERVICE_ERROR . '<br /><br />';
				}
				$this->v_data_array['GET']['recaptcha_response_field'] = urldecode($this->v_data_array['GET']['recaptcha_response_field']);
				$this->v_data_array['GET']['recaptcha_challenge_field'] = urldecode($this->v_data_array['GET']['recaptcha_challenge_field']);
				// vvcode check
				if(!$coo_captcha->is_valid($this->v_data_array['GET'], 'GM_CALLBACK_SERVICE_VVCODE', true)){
					$this->v_output_buffer .= GM_CALLBACK_SERVICE_WRONG_CODE . '<br /><br />';
				}

				$visual_verify_code = xtc_random_charcode(6);
				$_SESSION['vvcode'] = $visual_verify_code;
				break;
			case 'send':
				if(!empty($this->v_data_array['POST']['telephone']))
				{
					$message = str_replace('%u20AC', 'EUR', $this->v_data_array['POST']['message']);
					$message = gm_prepare_string($message);
					$text = GM_CALLBACK_SERVICE_MAIL_NAME . $this->v_data_array['POST']['name']
								. "\n". GM_CALLBACK_SERVICE_MAIL_EMAIL . $this->v_data_array['POST']['email']
								. "\n" . GM_CALLBACK_SERVICE_MAIL_TELEPHONE . $this->v_data_array['POST']['telephone']
								. "\n" . GM_CALLBACK_SERVICE_MAIL_TIME . $this->v_data_array['POST']['time']
								. "\n\n" . GM_CALLBACK_SERVICE_MAIL_MESSAGE . "\n" . $message;			

					if(!empty($this->v_data_array['POST']['email'])) $email = $this->v_data_array['POST']['email'];
					else $email = STORE_OWNER_EMAIL_ADDRESS;

					// send mail
					xtc_php_mail(CONTACT_US_EMAIL_ADDRESS, CONTACT_US_NAME, CONTACT_US_EMAIL_ADDRESS, CONTACT_US_NAME, '', $email, $this->v_data_array['POST']['name'], '', '', GM_CALLBACK_SERVICE_SUBJECT . $this->v_data_array['POST']['name'] . ', ' . $this->v_data_array['POST']['telephone'], nl2br(htmlentities_wrapper($text)), html_entity_decode_wrapper($text));	

					$this->v_output_buffer = GM_CALLBACK_SERVICE_SUCCESS;
				}
				break;
			default:
				print_r($_GET);
				trigger_error('t_action_request not found: '. htmlentities($t_action_request));
				return false;
		}

		if($t_enable_json_output)
		{
			$coo_json = new Services_JSON(SERVICES_JSON_LOOSE_TYPE);
			$t_output_json = $coo_json->encode($t_output_array);

			$this->v_output_buffer = $t_output_json;
		}
		
		return true;
	}
}