<?php
/* --------------------------------------------------------------
   ShoppingCartContentView.inc.php 2014-07-01 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2014 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(best_sellers.php,v 1.20 2003/02/10); www.oscommerce.com
   (c) 2003	 nextcommerce (best_sellers.php,v 1.10 2003/08/17); www.nextcommerce.org
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: best_sellers.php 1292 2005-10-07 16:10:55Z mz $)

   Released under the GNU General Public License
   -----------------------------------------------------------------------------------------
   Third Party contributions:
   Enable_Disable_Categories 1.3        	Autor: Mikel Williams | mikel@ladykatcostumes.com

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

// include needed functions
require_once (DIR_FS_INC.'xtc_array_to_string.inc.php');
require_once (DIR_FS_INC.'xtc_image_submit.inc.php');
require_once (DIR_FS_INC.'xtc_recalculate_price.inc.php');


class ShoppingCartContentView extends ContentView
{
	protected $paypal;

	function ShoppingCartContentView()
	{
		parent::__construct();
		$this->set_content_template('module/shopping_cart.html');
		$this->set_flat_assigns(true);
	}

	function get_html()
	{
		$t_show_klarna_widget = gm_get_conf('KLARNA_SHOW_CHECKOUT_PARTPAY') == true;
		if($t_show_klarna_widget)
		{
			$klarna = new GMKlarna();
			$klarna_widget = $klarna->getWidgetCode($_SESSION['cart']->show_total());
			$this->set_content_data('KLARNA_WIDGET', $klarna_widget);
		}
		else
		{
			$this->set_content_data('KLARNA_WIDGET', '');
		}

		$xtPrice = new xtcPrice($_SESSION['currency'], $_SESSION['customers_status']['customers_status_id']);

		$this->_add_paypal_button();
		$this->_add_amazonadvpay_button();

		if(gm_get_env_info('TEMPLATE_VERSION') < FIRST_GX2_TEMPLATE_VERSION || $_SESSION['cart']->count_contents() == 0)
		{
			$coo_gift_cart = MainFactory::create_object('GiftCartContentView');
			$t_view_html = $coo_gift_cart->get_html();
			$this->set_content_data('MODULE_gift_cart', $t_view_html);
		}

		if ($_SESSION['cart']->count_contents() > 0) {

			$this->set_content_data('FORM_ACTION', xtc_draw_form('cart_quantity', xtc_href_link(FILENAME_SHOPPING_CART, 'action=update_product', 'NONSSL', true, true, true)));
			$this->set_content_data('FORM_END', '</form>');
			$hidden_options = '';
			$_SESSION['any_out_of_stock'] = 0;

			$products = $_SESSION['cart']->get_products();

			for ($i = 0, $n = sizeof($products); $i < $n; $i ++) {
				/* bof gm weight*/
				$products[$i]['gm_weight'] = $products[$i]['weight'];
				/* eof gm weight */

				// Push all attributes information in an array
				if (isset ($products[$i]['attributes'])) {
					while (list ($option, $value) = each($products[$i]['attributes'])) {
						$hidden_options .= xtc_draw_hidden_field('id['.$products[$i]['id'].']['.$option.']', $value);
						$attributes = xtc_db_query("select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix,pa.attributes_stock,pa.products_attributes_id,pa.attributes_model,pa.weight_prefix,pa.options_values_weight
															  from ".TABLE_PRODUCTS_OPTIONS." popt, ".TABLE_PRODUCTS_OPTIONS_VALUES." poval, ".TABLE_PRODUCTS_ATTRIBUTES." pa
															  where pa.products_id = '".(int)$products[$i]['id']."'
															   and pa.options_id = '".(int)$option."'
															   and pa.options_id = popt.products_options_id
															   and pa.options_values_id = '".(int)$value."'
															   and pa.options_values_id = poval.products_options_values_id
															   and popt.language_id = '".(int) $_SESSION['languages_id']."'
															   and poval.language_id = '".(int) $_SESSION['languages_id']."'");
						$attributes_values = xtc_db_fetch_array($attributes);

						$products[$i][$option]['products_options_name'] = $attributes_values['products_options_name'];
						$products[$i][$option]['options_values_id'] = (int)$value;
						$products[$i][$option]['products_options_values_name'] = $attributes_values['products_options_values_name'];
						$products[$i][$option]['options_values_price'] = $attributes_values['options_values_price'];
						$products[$i][$option]['price_prefix'] = $attributes_values['price_prefix'];
						$products[$i][$option]['weight_prefix'] = $attributes_values['weight_prefix'];
						$products[$i][$option]['options_values_weight'] = $attributes_values['options_values_weight'];
						$products[$i][$option]['attributes_stock'] = $attributes_values['attributes_stock'];
						$products[$i][$option]['products_attributes_id'] = $attributes_values['products_attributes_id'];
						$products[$i][$option]['products_attributes_model'] = $attributes_values['products_attributes_model'];

						/* bof gm weight*/
						if($attributes_values['weight_prefix'] == '-') {
							$products[$i]['gm_weight'] -= $attributes_values['options_values_weight'];
						} else {
							$products[$i]['gm_weight'] += $products[$i][$option]['options_values_weight'];
						}
						/* eof gm weight*/
					}
				}
			}

			$this->set_content_data('HIDDEN_OPTIONS', $hidden_options);

			# order details
			$coo_order_details_cart = MainFactory::create_object('OrderDetailsCartContentView');
			$t_view_html = $coo_order_details_cart->get_html($products);
			$this->set_content_data('MODULE_order_details', $t_view_html);

			$_SESSION['allow_checkout'] = 'true';
			if (STOCK_CHECK == 'true') {
				if ($_SESSION['any_out_of_stock'] == 1) {
					if (STOCK_ALLOW_CHECKOUT == 'true') {
						// write permission in session
						$_SESSION['allow_checkout'] = 'true';
						$this->set_content_data('info_message', sprintf(OUT_OF_STOCK_CAN_CHECKOUT, STOCK_MARK_PRODUCT_OUT_OF_STOCK));
					} else {
						$_SESSION['allow_checkout'] = 'false';
						$this->set_content_data('info_message', sprintf(OUT_OF_STOCK_CANT_CHECKOUT, STOCK_MARK_PRODUCT_OUT_OF_STOCK));
					}
				} else {
					$_SESSION['allow_checkout'] = 'true';
				}
			}

			// minimum/maximum order value
			$checkout = true;
			if ((int) $_SESSION['cart']->show_total() < $_SESSION['customers_status']['customers_status_min_order'] ) {
				$_SESSION['allow_checkout'] = 'false';
				$more_to_buy = $_SESSION['customers_status']['customers_status_min_order'] - $_SESSION['cart']->show_total();
				$order_amount=$xtPrice->xtcFormat($more_to_buy, true);
				$min_order=$xtPrice->xtcFormat($_SESSION['customers_status']['customers_status_min_order'], true);
				$this->set_content_data('info_message_1', MINIMUM_ORDER_VALUE_NOT_REACHED_1);
				$this->set_content_data('info_message_2', MINIMUM_ORDER_VALUE_NOT_REACHED_2);
				$this->set_content_data('order_amount', $order_amount);
				$this->set_content_data('min_order', $min_order);
			}
			if  ($_SESSION['customers_status']['customers_status_max_order'] != 0) {
				if ($_SESSION['cart']->show_total() > $_SESSION['customers_status']['customers_status_max_order'] ) {
				$_SESSION['allow_checkout'] = 'false';
				$less_to_buy = $_SESSION['cart']->show_total() - $_SESSION['customers_status']['customers_status_max_order'];
				$max_order=$xtPrice->xtcFormat($_SESSION['customers_status']['customers_status_max_order'], true);
				$order_amount=$xtPrice->xtcFormat($less_to_buy, true);
				$this->set_content_data('info_message_1', MAXIMUM_ORDER_VALUE_REACHED_1);
				$this->set_content_data('info_message_2', MAXIMUM_ORDER_VALUE_REACHED_2);
				$this->set_content_data('order_amount', $order_amount);
				$this->set_content_data('min_order', $max_order);
				}
			}

			if(isset($_SESSION['info_message']))
			{
				$this->set_content_data('info_message', $_SESSION['info_message']);
				unset($_SESSION['info_message']);
			}

			$t_button_back_url = xtc_href_link(FILENAME_DEFAULT);
			if(!empty($_SESSION['gm_history'][count($_SESSION['gm_history'])-1]['CLOSE']))
			{
				$t_button_back_url = HTTP_SERVER . $_SESSION['gm_history'][count($_SESSION['gm_history'])-1]['CLOSE'];
			}

			$this->set_content_data('BUTTON_RELOAD', xtc_image_submit('button_update_cart.gif', IMAGE_BUTTON_UPDATE_CART, 'onclick="var gm_quantity_checker = new GMOrderQuantityChecker(); return gm_quantity_checker.check_cart();"'));
			$this->set_content_data('BUTTON_BACK', '<a href="' . $t_button_back_url . '"><img src="templates/' . CURRENT_TEMPLATE . '/buttons/' . $_SESSION['language'] . '/button_back.gif" alt="' . IMAGE_BUTTON_BACK . '" title="' . IMAGE_BUTTON_BACK . '" border="0" /></a>');
			$this->set_content_data('BUTTON_BACK_URL', $t_button_back_url);
			$this->set_content_data('BUTTON_CHECKOUT', '<a id="gm_checkout" onclick="var gm_quantity_checker = new GMOrderQuantityChecker(); return gm_quantity_checker.check_cart();" href="'.xtc_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL').'">'.xtc_image_button('button_checkout.gif', IMAGE_BUTTON_CHECKOUT).'</a>');
			$this->set_content_data('LINK_CLOSE', $t_button_back_url);

			$t_sql = '	SELECT
							content_title
						FROM
							content_manager
						WHERE
							content_group = ' . (int)SHIPPING_INFOS . '
							AND languages_id = ' . (int)$_SESSION['languages_id'];
			$t_result = xtc_db_query($t_sql);
			$t_shipping_and_payment_content_title = '';
			if($t_shipping_and_payment_content_title_array = xtc_db_fetch_array($t_result))
			{
				$t_shipping_and_payment_content_title = $t_shipping_and_payment_content_title_array['content_title'];

				$t_sef_parameter = '';
				if(SEARCH_ENGINE_FRIENDLY_URLS == 'true')
				{
					$t_sef_parameter .= '&content=' . xtc_cleanName($t_shipping_and_payment_content_title);
				}

				$t_content_url = xtc_href_link(FILENAME_POPUP_CONTENT, 'coID=' . (int)SHIPPING_INFOS . '&lightbox_mode=1' . $t_sef_parameter, 'SSL');

				$this->set_content_data('SHIPPING_AND_PAYMENT_INFO_LINK', $t_content_url);
				
				$coo_seo_boost = MainFactory::create_object('GMSEOBoost'); 

			if($coo_seo_boost->boost_content) 
			{ 
				$t_content_url = xtc_href_link($coo_seo_boost->get_boosted_content_url($coo_seo_boost->get_content_id_by_content_group((int)SHIPPING_INFOS), $_SESSION['languages_id'])); 
			} 
			else 
			{ 
				$t_content_url = xtc_href_link(FILENAME_CONTENT, 'coID=' . (int)SHIPPING_INFOS . $t_sef_parameter); 
			}
			
			$this->set_content_data('SHIPPING_AND_PAYMENT_INFO_LINK_MOBILE', $t_content_url);
			}

			$this->set_content_data('SHIPPING_AND_PAYMENT_CONTENT_TITLE', $t_shipping_and_payment_content_title);
			
			# BOF YOOCHOOSE
			$t_view_html = '';

			if(defined('YOOCHOOSE_ACTIVE') && YOOCHOOSE_ACTIVE)
			{
				$coo_also_interesting = MainFactory::create_object('YoochooseShoppingCartContentView');
				$t_view_html = $coo_also_interesting->get_html();
			}

			$this->set_content_data('MODULE_yoochoose_shopping_cart', $t_view_html);
			# EOF YOOCHOOSE
		}
		else
		{
			// empty cart
			$cart_empty = true;

			if(isset($_SESSION['info_message']))
			{
				$this->set_content_data('info_message', $_SESSION['info_message']);
				unset($_SESSION['info_message']);
			}

			$t_button_back_url = xtc_href_link(FILENAME_DEFAULT);
			if(!empty($_SESSION['gm_history'][count($_SESSION['gm_history'])-1]['CLOSE']))
			{
				$t_button_back_url = HTTP_SERVER . $_SESSION['gm_history'][count($_SESSION['gm_history'])-1]['CLOSE'];
			}

			$this->set_content_data('cart_empty', $cart_empty);

			$this->set_content_data('FORM_ACTION', xtc_draw_form('cart_quantity', xtc_href_link(FILENAME_SHOPPING_CART, 'action=update_product', 'NONSSL', true, true, true)));
			$this->set_content_data('FORM_END', '</form>');

			$this->set_content_data('BUTTON_BACK', '<a href="' . $t_button_back_url . '"><img src="templates/' . CURRENT_TEMPLATE . '/buttons/' . $_SESSION['language'] . '/button_back.gif" alt="' . IMAGE_BUTTON_BACK . '" title="' . IMAGE_BUTTON_BACK . '" border="0" /></a>');
			$this->set_content_data('BUTTON_BACK_URL', $t_button_back_url);
			$this->set_content_data('BUTTON_CONTINUE', '<a href="'.xtc_href_link(FILENAME_DEFAULT).'">'.xtc_image_button('button_continue.gif', IMAGE_BUTTON_CONTINUE).'</a>');
			$this->set_content_data('LINK_CLOSE', $t_button_back_url);
		}

		$this->set_content_data('LIGHTBOX', gm_get_conf('GM_LIGHTBOX_CART'));
		$this->set_content_data('LIGHTBOX_CLOSE', xtc_href_link(FILENAME_DEFAULT, '', 'NONSSL'));

		$this->set_content_data('PRODUCTS_DATA', $t_products_array);

		$t_html_output = $this->build_html();
		return $t_html_output;
	}

	protected function _add_paypal_button()
	{
		$this->paypal = new GMPayPal();
		$t_pp_config = $this->paypal->getConfigArray();
		$this->paypal->doQuickButtonRedirect();
		$use_paypal_checkout = $this->paypal->isExpressCheckoutActive();

		if($use_paypal_checkout)
		{
			$supported_languages = array('DE', 'EN', 'ES', 'FR', 'IT', 'NL');
			$lang_code = strtoupper($_SESSION['language_code']);

			if(!in_array($lang_code, $supported_languages))
			{
				$lang_code = 'EN';
			}

			$t_button_array = array(
							'url' => GM_HTTP_SERVER . DIR_WS_CATALOG . 'checkout_paypal_prepare.php',
							'img' => GM_HTTP_SERVER . DIR_WS_CATALOG . 'images/icons/paypal/'.$t_pp_config['button_style'].'Btn_' . $lang_code . '.png',
							);
			$this->_add_checkout_button($t_button_array);
		}
	}

	protected function _add_amazonadvpay_button()
	{
		unset($_SESSION['amazonadvpay_order_ref_id']);
		$coo_aap = MainFactory::create_object('AmazonAdvancedPayment');
		if($coo_aap->is_enabled())
		{
			$t_button_array = array(
				'script' => $coo_aap->get_button_element(),
			);
			$this->_add_checkout_button($t_button_array);
		}

	}


	protected function _add_checkout_button(array $p_button)
	{
		$t_content_array = $this->get_content_array();
		$t_cob_array = array();
		if(isset($t_content_array['checkout_buttons']))
		{
			$t_cob_array = $t_content_array['checkout_buttons'];
			$t_cob_array[] = $p_button;
		}
		else
		{
			$t_cob_array = array($p_button);
		}
		$this->set_content_data('checkout_buttons', $t_cob_array);
	}

}