<?php
/* --------------------------------------------------------------
  FeatureAdminEditCategoryExtenderComponent.inc.php 2014-09-21 gm
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2014 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------
 */

class FeatureAdminEditCategoryExtenderComponent extends FeatureAdminEditCategoryExtenderComponent_parent
{
	protected $position;
	
	function __construct()
	{
		parent::__construct();
		$this->position = 'right';
	}
	
	function proceed()
	{
		parent::proceed();
		
		$coo_feature_helper = MainFactory::create_object('FeatureFunctionHelper');
		$coo_control        = MainFactory::create_object('FeatureControl');
		$feature_array      = $coo_control->get_feature_array();
		
		$t_feature_mode = $coo_feature_helper->get_feature_mode($this->v_data_array['GET']['cID']);
		$t_feature_display_mode = $coo_feature_helper->get_feature_display_mode($this->v_data_array['GET']['cID']);
		
		$t_show_category_filter_checked = '';
		if($this->v_data_array['cInfo']->show_category_filter == '1')
		{
			$t_show_category_filter_checked = ' checked="checked"';
		}
		
		$t_feature_mode_standard_selected = '';
		$t_feature_mode_step_selected = ' selected="selected"';
		if($t_feature_mode == 0)
		{
			$t_feature_mode_standard_selected = ' selected="selected"';
			$t_feature_mode_step_selected = '';
		}
		
		$t_feature_display_mode_hide = '';
		$t_feature_display_mode_disable = ' selected="selected"';
		if($t_feature_display_mode == 0)
		{
			$t_feature_display_mode_hide = ' selected="selected"';
			$t_feature_display_mode_disable = '';
		}
		
		$this->v_output_buffer[$this->position]['Feature']['title'] = '';
		$this->v_output_buffer[$this->position]['Feature']['content'] = '
			<div style="line-height: 20px; margin-bottom: 10px;">
				<label for="show_category_filter" style="float: left;">' . TITLE_SHOW_CATEGORY_FILTER . '</label>
				<input type="checkbox" name="show_category_filter" id="show_category_filter" value="1"' . $t_show_category_filter_checked . '/>
			<div style="clear: left"></div></div>';
		
		if(empty($feature_array) == false)
		{
			$this->v_output_buffer[$this->position]['Feature']['content'] .=
			TITLE_FEATURES . ':<br/><br/>
			' . $coo_feature_helper->generate_feature_select() . '
			<input type="submit" name="insert_feature" value="' . BUTTON_ADD . '" class="button">
			<br/><br/>
			<table cellspacing="3" cellpadding="3">
				<tr>
					<td><label for="feature_mode">' . TEXT_FEATURE_MODE . ': </label></td>
					<td>
						<select id="feature_mode" name="feature_mode">
							<option value="0"' . $t_feature_mode_standard_selected . '>' . TEXT_FEATURE_MODE_STANDARD . '</option>
							<option value="1"' . $t_feature_mode_step_selected . '>' . TEXT_FEATURE_MODE_STEPS . '</option>
						</select>
					</td>
				</tr>

				<tr>
					<td><label for="feature_display_mode">' . TEXT_FEATURE_DISPLAY_MODE . ': </label></td>
					<td>
						<select id="feature_display_mode" name="feature_display_mode" type="checkbox">
							<option value="0"' . $t_feature_display_mode_hide . '>' . TEXT_FEATURE_DISPLAY_MODE_HIDE . '</option>
							<option value="1"' . $t_feature_display_mode_disable . '>' . TEXT_FEATURE_DISPLAY_MODE_DISABLE . '</option>
						</select>
					</td>
				</tr>
			</table>
			<br/><br/>
			<table width="100%" cellspacing="1" cellpadding="1" border="0">
			' . $coo_feature_helper->generate_feature_list($this->v_data_array['GET']['cID']) . '
			</table>';
		}
		else
		{
			$this->v_output_buffer[$this->position]['Feature']['content'] .= TEXT_FEATURE_CREATE . '<br/><br />';
		}
		$this->v_output_buffer[$this->position]['Feature']['content'] .= '<input type="submit" name="save_features" value="' . BUTTON_SAVE . '" class="button">';
	}
}