ALTER DATABASE DEFAULT CHARACTER SET 'utf8' DEFAULT COLLATE 'utf8_general_ci';

DROP TABLE IF EXISTS `address_book`;
CREATE TABLE `address_book` (
  `address_book_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `entry_gender` char(1) NOT NULL default '',
  `entry_company` varchar(255) default NULL,
  `entry_firstname` varchar(32) NOT NULL default '',
  `entry_lastname` varchar(32) NOT NULL default '',
  `entry_street_address` varchar(64) NOT NULL default '',
  `entry_suburb` varchar(32) default NULL,
  `entry_postcode` varchar(10) NOT NULL default '',
  `entry_city` varchar(32) NOT NULL default '',
  `entry_state` varchar(32) default NULL,
  `entry_country_id` int(11) NOT NULL default '0',
  `entry_zone_id` int(11) NOT NULL default '0',
  `address_date_added` datetime default '0000-00-00 00:00:00',
  `address_last_modified` datetime default '0000-00-00 00:00:00',
  `address_class` varchar(32) NOT NULL,
  PRIMARY KEY  (`address_book_id`),
  KEY `idx_address_book_customers_id` (`customers_id`),
  KEY `entry_country_id` (`entry_country_id`),
  KEY `entry_zone_id` (`entry_zone_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `address_format`;
CREATE TABLE `address_format` (
  `address_format_id` int(11) NOT NULL auto_increment,
  `address_format` varchar(128) NOT NULL default '',
  `address_summary` varchar(48) NOT NULL default '',
  PRIMARY KEY  (`address_format_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `admin_access`;
CREATE TABLE `admin_access` (
  `customers_id` varchar(32) NOT NULL default '0',
  `configuration` int(1) NOT NULL default '0',
  `modules` int(1) NOT NULL default '0',
  `countries` int(1) NOT NULL default '0',
  `currencies` int(1) NOT NULL default '0',
  `zones` int(1) NOT NULL default '0',
  `geo_zones` int(1) NOT NULL default '0',
  `tax_classes` int(1) NOT NULL default '0',
  `tax_rates` int(1) NOT NULL default '0',
  `accounting` int(1) NOT NULL default '0',
  `backup` int(1) NOT NULL default '0',
  `cache` int(1) NOT NULL default '0',
  `server_info` int(1) NOT NULL default '0',
  `whos_online` int(1) NOT NULL default '0',
  `languages` int(1) NOT NULL default '0',
  `define_language` int(1) NOT NULL default '0',
  `orders_status` int(1) NOT NULL default '0',
  `shipping_status` int(1) NOT NULL default '0',
  `module_export` int(1) NOT NULL default '0',
  `customers` int(1) NOT NULL default '0',
  `create_account` int(1) NOT NULL default '0',
  `customers_status` int(1) NOT NULL default '0',
  `orders` int(1) NOT NULL default '0',
  `campaigns` int(1) NOT NULL default '0',
  `print_packingslip` int(1) NOT NULL default '0',
  `print_order` int(1) NOT NULL default '0',
  `popup_memo` int(1) NOT NULL default '0',
  `coupon_admin` int(1) NOT NULL default '0',
  `listcategories` int(1) NOT NULL default '0',
  `gv_queue` int(1) NOT NULL default '0',
  `gv_mail` int(1) NOT NULL default '0',
  `gv_sent` int(1) NOT NULL default '0',
  `validproducts` int(1) NOT NULL default '0',
  `validcategories` int(1) NOT NULL default '0',
  `mail` int(1) NOT NULL default '0',
  `categories` int(1) NOT NULL default '0',
  `new_attributes` int(1) NOT NULL default '0',
  `products_attributes` int(1) NOT NULL default '0',
  `manufacturers` int(1) NOT NULL default '0',
  `reviews` int(1) NOT NULL default '0',
  `specials` int(1) NOT NULL default '0',
  `stats_products_expected` int(1) NOT NULL default '0',
  `stats_products_viewed` int(1) NOT NULL default '0',
  `stats_products_purchased` int(1) NOT NULL default '0',
  `stats_customers` int(1) NOT NULL default '0',
  `stats_sales_report` int(1) NOT NULL default '0',
  `stats_campaigns` int(1) NOT NULL default '0',
  `banner_manager` int(1) NOT NULL default '0',
  `banner_statistics` int(1) NOT NULL default '0',
  `module_newsletter` int(1) NOT NULL default '0',
  `start` int(1) NOT NULL default '0',
  `content_manager` int(1) NOT NULL default '0',
  `content_preview` int(1) NOT NULL default '0',
  `credits` int(1) NOT NULL default '0',
  `blacklist` int(1) NOT NULL default '0',
  `orders_edit` int(1) NOT NULL default '0',
  `popup_image` int(1) NOT NULL default '0',
  `csv_backend` int(1) NOT NULL default '0',
  `products_vpe` int(1) NOT NULL default '0',
  `cross_sell_groups` int(1) NOT NULL default '0',
  `econda` int(1) NOT NULL default '0',
  `listproducts` int(1) NOT NULL default '0',
  `gm_scroller` int(1) NOT NULL default '0',
  `gm_pdf` int(1) NOT NULL default '0',
  `gm_id_starts` int(1) NOT NULL default '0',
  `gm_pdf_order` int(1) NOT NULL default '0',
  `gm_pdf_action` int(1) NOT NULL default '0',
  `gm_emails` int(1) NOT NULL default '0',
  `gm_emails_preview` int(1) NOT NULL default '0',
  `gm_guestbook` int(1) NOT NULL default '0',
  `gm_counter` int(1) NOT NULL default '0',
  `gm_counter_action` int(1) NOT NULL default '0',
  `gm_meta` int(1) NOT NULL default '0',
  `gm_meta_action` int(1) NOT NULL default '0',
  `gm_analytics` int(1) NOT NULL default '0',
  `gm_bookmarks` int(1) NOT NULL default '0',
  `gm_bookmarks_action` int(1) NOT NULL default '0',
  `gm_logo` int(1) NOT NULL default '0',
  `gm_security` int(1) NOT NULL default '0',
  `gm_style_edit` int(1) NOT NULL default '0',
  `gm_send_order` int(1) NOT NULL default '0',
  `gm_order_menu` int(1) NOT NULL default '0',
  `gm_miscellaneous` int(1) NOT NULL default '0',
  `gm_lang_edit` int(1) NOT NULL default '0',
  `gm_sitemap` int(1) NOT NULL default '0',
  `gm_sitemap_creator` int(1) NOT NULL default '0',
  `gm_sql` int(1) NOT NULL default '0',
  `gm_offline` int(1) NOT NULL default '0',
  `gm_lightbox` int(1) NOT NULL default '0',
  `gm_seo_boost` int(1) NOT NULL default '0',
  `gm_trusted_shop_id` int(1) NOT NULL default '0',
  `gm_opensearch` int(1) NOT NULL default '0',
  `gm_opensearch_action` int(1) NOT NULL default '0',
  `gm_module_export` int(1) NOT NULL default '0',
  `gm_backup_files_zip` int(1) NOT NULL default '0',
  `gm_janolaw` int(1) NOT NULL default '0',
  `gm_module_part_export` int(1) NOT NULL default '0',
  `gm_product_export` int(1) NOT NULL default '0',
  `gm_gprint` int(1) NOT NULL default '0',
  `gm_gprint_download` int(1) NOT NULL default '0',
  `gm_gmotion` int(1) NOT NULL default '0',
  `xml_export` int(1) NOT NULL default '0',
  `gm_feature_control` int(1) NOT NULL default '0',
  `properties` int(1) NOT NULL default '0',
  `properties_combis` int(1) NOT NULL default '0',
  `request_port` int(1) NOT NULL default '0',
  `gm_slider` int(1) NOT NULL default '0',
  `template_configuration` int(1) NOT NULL default '0',
  `quantity_units` int(1) NOT NULL default '0',
  `show_logs` int(1) NOT NULL default '0',
  `robots_download` int(1) NOT NULL default '0',
  `clear_cache` int(1) NOT NULL default '0',
  `directory_scan` int(1) NOT NULL default '0',
  `yoochoose` int(1) NOT NULL default '0',
  `yatego` int(1) NOT NULL default '0',
  `gm_invoicing` int(1) NOT NULL default '0',
  `brickfox` int(1) NOT NULL default '0',
  `phpminiadmin` int(1) NOT NULL default '0',
  `minisql` int(1) NOT NULL default '0',
  `ekomi` int(1) NOT NULL default '0',
  `magnalister` int(1) NOT NULL default '0',
  `mobile` int(1) NOT NULL default '0',
  `shopgate` int(1) NOT NULL default '0',
  `mediafinanz` int(1) NOT NULL default '0',
  `lettr_de` int(1) NOT NULL default '0',
  `admin_javascript` int(1) NOT NULL default '0',
  `hermes_collection` int(1) NOT NULL default '0',
  `hermes_list` int(1) NOT NULL default '0',
  `hermes_info` int(1) NOT NULL default '0',
  `hermes_order` int(1) NOT NULL default '0',
  `hermes_config` int(1) NOT NULL default '0',
  `iloxx` int(1) NOT NULL default '0',
  `orders_iloxx` int(1) NOT NULL default '0',
  `affiliprint_module` int(1) NOT NULL DEFAULT '0',
  `csv` int(1) NOT NULL default '0',
  `paypal_config` int(1) NOT NULL default '0',
  `paypal_logs` int(1) NOT NULL default '0',
  `print_intraship_label` int(1) NOT NULL default '0',
  `intraship` int(1) NOT NULL default '0',
  `klarna_config` int(1) NOT NULL default '0',
  `protectedshops` int(1) NOT NULL default '0',
  `itrecht_config` int(1) NOT NULL default '0',
  `withdrawals` int(1) NOT NULL DEFAULT '0',
  `findologic_config` int(1) NOT NULL default '0',
  `amazonadvpay` int(1) NOT NULL DEFAULT '0',
  `payone_config` int(1) NOT NULL DEFAULT '0',
  `payone_logs` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY  (`customers_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `additional_fields`;
CREATE TABLE `additional_fields` (
  `additional_field_id` int(11) NOT NULL AUTO_INCREMENT,
  `field_key` varchar(255) NOT NULL,
  `item_type` enum('product') NOT NULL DEFAULT 'product',
  `multilingual` TINYINT UNSIGNED NOT NULL,
  PRIMARY KEY (`additional_field_id`),
  UNIQUE KEY `field_key` (`field_key`,`item_type`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `additional_field_descriptions`;
CREATE TABLE `additional_field_descriptions` (
  `additional_field_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL,
  `name` text NOT NULL,
  PRIMARY KEY (`additional_field_id`,`language_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `additional_field_values`;
CREATE TABLE `additional_field_values` (
  `additional_field_value_id` int(11) NOT NULL AUTO_INCREMENT,
  `additional_field_id` int(11) NOT NULL,
  `item_id` int(11) NOT NULL,
  PRIMARY KEY (`additional_field_value_id`),
  UNIQUE KEY `additional_field_id` (`additional_field_id`,`item_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `additional_field_value_descriptions`;
CREATE TABLE `additional_field_value_descriptions` (
  `additional_field_value_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL DEFAULT '0',
  `value` text NOT NULL,
  PRIMARY KEY (`additional_field_value_id`,`language_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `amzadvpay_authorizations`;
CREATE TABLE `amzadvpay_authorizations` (
  `amzadvpay_authorizations_id` int(11) NOT NULL AUTO_INCREMENT,
  `orders_id` int(11) NOT NULL,
  `order_reference_id` varchar(64) NOT NULL,
  `authorization_reference_id` varchar(64) NOT NULL,
  `state` varchar(20) NOT NULL,
  `last_update` datetime NOT NULL,
  `last_details` mediumtext NOT NULL,
  PRIMARY KEY (`amzadvpay_authorizations_id`),
  UNIQUE KEY `authorization_reference_id` (`authorization_reference_id`),
  KEY `orders_id` (`orders_id`),
  KEY `order_reference_id` (`order_reference_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `amzadvpay_captures`;
CREATE TABLE `amzadvpay_captures` (
  `amzadvpay_captures_id` int(11) NOT NULL AUTO_INCREMENT,
  `orders_id` int(11) NOT NULL,
  `order_reference_id` varchar(64) NOT NULL,
  `authorization_reference_id` varchar(64) NOT NULL,
  `capture_reference_id` varchar(64) NOT NULL,
  `state` varchar(20) NOT NULL,
  `last_update` datetime NOT NULL,
  `last_details` mediumtext NOT NULL,
  PRIMARY KEY (`amzadvpay_captures_id`),
  KEY `orders_id` (`orders_id`,`order_reference_id`,`authorization_reference_id`,`capture_reference_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `amzadvpay_orders`;
CREATE TABLE `amzadvpay_orders` (
  `amzadvpay_orders_id` int(11) NOT NULL AUTO_INCREMENT,
  `orders_id` int(11) NOT NULL,
  `order_reference_id` varchar(64) NOT NULL,
  `state` varchar(20) NOT NULL,
  `last_update` datetime NOT NULL,
  `last_details` mediumtext NOT NULL,
  PRIMARY KEY (`amzadvpay_orders_id`),
  UNIQUE KEY `orders_id_2` (`orders_id`),
  KEY `orders_id` (`orders_id`,`order_reference_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `amzadvpay_refunds`;
CREATE TABLE `amzadvpay_refunds` (
  `amzadvpay_refunds_id` int(11) NOT NULL AUTO_INCREMENT,
  `orders_id` int(11) NOT NULL,
  `order_reference_id` varchar(64) NOT NULL,
  `authorization_reference_id` varchar(64) NOT NULL,
  `capture_reference_id` varchar(64) NOT NULL,
  `refund_reference_id` varchar(64) NOT NULL,
  `state` varchar(20) NOT NULL,
  `last_update` datetime NOT NULL,
  `last_details` mediumtext NOT NULL,
  PRIMARY KEY (`amzadvpay_refunds_id`),
  UNIQUE KEY `refund_reference_id` (`refund_reference_id`),
  KEY `orders_id` (`orders_id`),
  KEY `authorization_reference_id` (`authorization_reference_id`),
  KEY `capture_reference_id` (`capture_reference_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `banktransfer`;
CREATE TABLE `banktransfer` (
  `orders_id` int(11) NOT NULL default '0',
  `banktransfer_owner` varchar(64) default NULL,
  `banktransfer_number` varchar(24) default NULL,
  `banktransfer_bankname` varchar(255) default NULL,
  `banktransfer_blz` varchar(8) default NULL,
  `banktransfer_status` int(11) default NULL,
  `banktransfer_prz` char(2) default NULL,
  `banktransfer_fax` char(2) default NULL,
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `banktransfer_blz`;
CREATE TABLE `banktransfer_blz` (
  `blz` int(10) NOT NULL default '0',
  `bankname` varchar(255) NOT NULL default '',
  `bic` varchar(11) NOT NULL default '',
  `prz` char(2) NOT NULL default '',
  PRIMARY KEY  (`blz`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `banners`;
CREATE TABLE `banners` (
  `banners_id` int(11) NOT NULL auto_increment,
  `banners_title` varchar(64) NOT NULL default '',
  `banners_url` varchar(255) NOT NULL default '',
  `banners_image` varchar(64) NOT NULL default '',
  `banners_group` varchar(10) NOT NULL default '',
  `banners_html_text` text,
  `expires_impressions` int(7) default '0',
  `expires_date` datetime default NULL,
  `date_scheduled` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_status_change` datetime default NULL,
  `status` int(1) NOT NULL default '1',
  PRIMARY KEY  (`banners_id`),
  KEY `status` (`status`,`banners_group`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `banners_history`;
CREATE TABLE `banners_history` (
  `banners_history_id` int(11) NOT NULL auto_increment,
  `banners_id` int(11) NOT NULL default '0',
  `banners_shown` int(5) NOT NULL default '0',
  `banners_clicked` int(5) NOT NULL default '0',
  `banners_history_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`banners_history_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `billsafe_directpayments`;
CREATE TABLE `billsafe_directpayments` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `orders_id` int(10) unsigned NOT NULL,
  `amount` decimal(15,4) NOT NULL,
  `date` date NOT NULL,
  PRIMARY KEY (`id`),
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `billsafe_paymentinfo`;
CREATE TABLE `billsafe_paymentinfo` (
  `orders_id` int(11) NOT NULL,
  `received` datetime NOT NULL,
  `transaction_id` varchar(255) NOT NULL,
  `recipient` varchar(100) NOT NULL,
  `bankCode` varchar(8) NOT NULL,
  `accountNumber` varchar(10) NOT NULL,
  `bankName` varchar(100) NOT NULL,
  `bic` varchar(11) NOT NULL,
  `iban` varchar(34) NOT NULL,
  `reference` varchar(50) NOT NULL,
  `amount` decimal(15,4) NOT NULL,
  `currencyCode` varchar(3) NOT NULL,
  `paymentPeriod` int(11) NOT NULL,
  `note` varchar(200) NOT NULL,
  `legalNote` text NOT NULL,
  PRIMARY KEY (`orders_id`),
  KEY `transaction_id` (`transaction_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `billsafe_products_shipped`;
CREATE TABLE `billsafe_products_shipped` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `orders_id` int(10) unsigned NOT NULL,
  `transaction_id` varchar(255) NOT NULL,
  `shipping_date` date NOT NULL,
  `parcel_service` varchar(255) NOT NULL,
  `parcel_company` varchar(255) NOT NULL DEFAULT '',
  `parcel_trackingid` varchar(255) NOT NULL,
  `article_number` varchar(255) NOT NULL,
  `article_name` varchar(255) NOT NULL,
  `article_type` varchar(20) NOT NULL,
  `article_quantity` int(5) NOT NULL,
  `article_grossprice` decimal(15,4) NOT NULL,
  `article_tax` decimal(4,2) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `campaigns`;
CREATE TABLE `campaigns` (
  `campaigns_id` int(11) NOT NULL auto_increment,
  `campaigns_name` varchar(32) NOT NULL default '',
  `campaigns_refID` varchar(64) default NULL,
  `campaigns_leads` int(11) NOT NULL default '0',
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  PRIMARY KEY  (`campaigns_id`),
  KEY `IDX_CAMPAIGNS_NAME` (`campaigns_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `campaigns_ip`;
CREATE TABLE `campaigns_ip` (
  `user_ip` varchar(15) NOT NULL default '',
  `time` datetime NOT NULL default '0000-00-00 00:00:00',
  `campaign` varchar(32) NOT NULL default ''
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `card_blacklist`;
CREATE TABLE `card_blacklist` (
  `blacklist_id` int(5) NOT NULL auto_increment,
  `blacklist_card_number` varchar(20) NOT NULL default '',
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  KEY `blacklist_id` (`blacklist_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `categories`;
CREATE TABLE `categories` (
  `categories_id` int(11) NOT NULL auto_increment,
  `categories_image` varchar(64) default NULL,
  `parent_id` int(11) NOT NULL default '0',
  `categories_status` tinyint(1) unsigned NOT NULL default '1',
  `categories_template` varchar(64) default NULL,
  `group_permission_0` tinyint(1) NOT NULL default '0',
  `group_permission_1` tinyint(1) NOT NULL default '0',
  `group_permission_2` tinyint(1) NOT NULL default '0',
  `group_permission_3` tinyint(1) NOT NULL default '0',
  `listing_template` varchar(64) default NULL,
  `sort_order` int(3) NOT NULL default '0',
  `products_sorting` varchar(32) default NULL,
  `products_sorting2` varchar(32) default NULL,
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  `categories_icon` varchar(255) NOT NULL,
  `categories_icon_w` int(11) NOT NULL,
  `categories_icon_h` int(11) NOT NULL,
  `group_ids` varchar(50) NOT NULL default '',
  `gm_show_attributes` int(1) unsigned NOT NULL default '0',
  `gm_show_graduated_prices` int(1) unsigned NOT NULL default '0',
  `gm_show_qty` int(1) unsigned NOT NULL default '1',
  `gm_priority` varchar(3) NOT NULL default '0.5',
  `gm_changefreq` varchar(255) NOT NULL default 'weekly',
  `gm_sitemap_entry` int(1) NOT NULL default '1',
  `gm_show_qty_info` int(1) unsigned NOT NULL default '0',
  `show_sub_categories` tinyint(1) NOT NULL default '1',
  `show_sub_categories_images` tinyint(1) NOT NULL default '1',
  `show_sub_categories_names` tinyint(1) NOT NULL default '1',
  `show_sub_products` tinyint(1) NOT NULL default '0',
  `view_mode_tiled` tinyint(1) NOT NULL default '0',
  `feature_mode` int(11) NOT NULL DEFAULT '0',
  `feature_display_mode` int(11) NOT NULL DEFAULT '0',
  `show_category_filter` tinyint(1) NOT NULL DEFAULT '0',
PRIMARY KEY  (`categories_id`),
  KEY `idx_categories_parent_id` (`parent_id`),
  KEY `categories_id` (`categories_id`,`parent_id`,`categories_status`,`sort_order`),
  KEY `parent_id` (`parent_id`,`categories_status`,`sort_order`),
  KEY `categories_status` (`categories_status`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `categories_description`;
CREATE TABLE `categories_description` (
  `categories_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `categories_name` varchar(255) NOT NULL,
  `categories_heading_title` varchar(255) NOT NULL default '',
  `categories_description` text NOT NULL,
  `categories_meta_title` text NOT NULL,
  `categories_meta_description` text NOT NULL,
  `categories_meta_keywords` text NOT NULL,
  `gm_alt_text` varchar(255) NOT NULL default '',
  `gm_url_keywords` varchar(255) NOT NULL,
  PRIMARY KEY  (`categories_id`,`language_id`),
  KEY `idx_categories_name` (`categories_name`),
  KEY `seo_boost_index` (`gm_url_keywords`,`categories_id`,`language_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `cm_file_flags`;
CREATE TABLE `cm_file_flags` (
  `file_flag` int(11) NOT NULL default '0',
  `file_flag_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`file_flag`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `configuration`;
CREATE TABLE `configuration` (
  `configuration_id` int(11) NOT NULL auto_increment,
  `configuration_key` varchar(64) NOT NULL default '',
  `configuration_value` text NOT NULL,
  `configuration_group_id` int(11) NOT NULL default '0',
  `sort_order` int(5) default NULL,
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `use_function` varchar(255) default NULL,
  `set_function` varchar(255) default NULL,
  PRIMARY KEY  (`configuration_id`),
  UNIQUE KEY `configuration_key` (`configuration_key`),
  KEY `idx_configuration_group_id` (`configuration_group_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `configuration_group`;
CREATE TABLE `configuration_group` (
  `configuration_group_id` int(11) NOT NULL auto_increment,
  `configuration_group_title` varchar(64) NOT NULL default '',
  `configuration_group_description` varchar(255) NOT NULL default '',
  `sort_order` int(5) default NULL,
  `visible` int(1) default '1',
  PRIMARY KEY  (`configuration_group_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `configuration_storage`;
CREATE TABLE `configuration_storage` (
  `key` varchar(255) NOT NULL,
  `value` varchar(255) DEFAULT NULL,
  `last_modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`key`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `content_manager`;
CREATE TABLE `content_manager` (
  `content_id` int(11) NOT NULL auto_increment,
  `categories_id` int(11) NOT NULL default '0',
  `parent_id` int(11) NOT NULL default '0',
  `group_ids` text,
  `languages_id` int(11) NOT NULL default '0',
  `content_title` text NOT NULL,
  `content_heading` text NOT NULL,
  `content_text` text NOT NULL,
  `sort_order` int(4) NOT NULL default '0',
  `file_flag` int(1) NOT NULL default '0',
  `content_file` varchar(64) NOT NULL default '',
  `download_file` varchar(64) NOT NULL default '',
  `content_status` int(1) NOT NULL default '0',
  `content_group` int(11) NOT NULL default '0',
  `content_delete` int(1) NOT NULL default '1',
  `gm_link` text NOT NULL,
  `gm_link_target` varchar(10) NOT NULL,
  `gm_priority` varchar(3) NOT NULL default '0.5',
  `gm_changefreq` varchar(255) NOT NULL default 'weekly',
  `gm_last_modified` datetime default NULL,
  `gm_sitemap_entry` int(1) NOT NULL default '1',
  `gm_url_keywords` varchar(255) NOT NULL,
  `contents_meta_title` text NOT NULL,
  `contents_meta_description` text NOT NULL,
  `contents_meta_keywords` text NOT NULL,
  `protected` varchar(64) NOT NULL,
  PRIMARY KEY  (`content_id`),
  KEY `languages_id` (`languages_id`,`file_flag`,`content_status`,`sort_order`),
  KEY `content_id` (`content_id`,`languages_id`),
  KEY `content_group` (`content_group`,`languages_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `counter`;
CREATE TABLE `counter` (
  `startdate` char(8) default NULL,
  `counter` int(12) default NULL
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `counter_history`;
CREATE TABLE `counter_history` (
  `month` char(8) default NULL,
  `counter` int(12) default NULL
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `countries`;
CREATE TABLE `countries` (
  `countries_id` int(11) NOT NULL auto_increment,
  `countries_name` varchar(64) NOT NULL default '',
  `countries_iso_code_2` char(2) NOT NULL default '',
  `countries_iso_code_3` char(3) NOT NULL default '',
  `address_format_id` int(11) NOT NULL default '0',
  `status` int(1) default '1',
  PRIMARY KEY  (`countries_id`),
  KEY `IDX_COUNTRIES_NAME` (`countries_name`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `coupons`;
CREATE TABLE `coupons` (
  `coupon_id` int(11) NOT NULL auto_increment,
  `coupon_type` char(1) NOT NULL default 'F',
  `coupon_code` varchar(32) NOT NULL default '',
  `coupon_amount` decimal(8,4) NOT NULL default '0.0000',
  `coupon_minimum_order` decimal(8,4) NOT NULL default '0.0000',
  `coupon_start_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `coupon_expire_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `uses_per_coupon` int(5) NOT NULL default '1',
  `uses_per_user` int(5) NOT NULL default '0',
  `restrict_to_products` varchar(255) default NULL,
  `restrict_to_categories` varchar(255) default NULL,
  `restrict_to_customers` text,
  `coupon_active` char(1) NOT NULL default 'Y',
  `date_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`coupon_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `coupons_description`;
CREATE TABLE `coupons_description` (
  `coupon_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '0',
  `coupon_name` varchar(32) NOT NULL default '',
  `coupon_description` text,
  PRIMARY KEY (`coupon_id`,`language_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `coupon_email_track`;
CREATE TABLE `coupon_email_track` (
  `unique_id` int(11) NOT NULL auto_increment,
  `coupon_id` int(11) NOT NULL default '0',
  `customer_id_sent` int(11) NOT NULL default '0',
  `sent_firstname` varchar(32) default NULL,
  `sent_lastname` varchar(32) default NULL,
  `emailed_to` varchar(32) default NULL,
  `date_sent` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`unique_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `coupon_gv_customer`;
CREATE TABLE `coupon_gv_customer` (
  `customer_id` int(5) NOT NULL default '0',
  `amount` decimal(8,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`customer_id`),
  KEY `customer_id` (`customer_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `coupon_gv_queue`;
CREATE TABLE `coupon_gv_queue` (
  `unique_id` int(5) NOT NULL auto_increment,
  `customer_id` int(5) NOT NULL default '0',
  `order_id` int(5) NOT NULL default '0',
  `amount` decimal(8,4) NOT NULL default '0.0000',
  `date_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `ipaddr` varchar(32) NOT NULL default '',
  `release_flag` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`unique_id`),
  KEY `uid` (`unique_id`,`customer_id`,`order_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `coupon_redeem_track`;
CREATE TABLE `coupon_redeem_track` (
  `unique_id` int(11) NOT NULL auto_increment,
  `coupon_id` int(11) NOT NULL default '0',
  `customer_id` int(11) NOT NULL default '0',
  `redeem_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `redeem_ip` varchar(32) NOT NULL default '',
  `order_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`unique_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `currencies`;
CREATE TABLE `currencies` (
  `currencies_id` int(11) NOT NULL auto_increment,
  `title` varchar(32) NOT NULL default '',
  `code` char(3) NOT NULL default '',
  `symbol_left` varchar(12) default NULL,
  `symbol_right` varchar(12) default NULL,
  `decimal_point` char(1) default NULL,
  `thousands_point` char(1) default NULL,
  `decimal_places` char(1) default NULL,
  `value` float(13,8) default NULL,
  `last_updated` datetime default NULL,
  PRIMARY KEY  (`currencies_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `customers`;
CREATE TABLE `customers` (
  `customers_id` int(11) NOT NULL auto_increment,
  `customers_cid` varchar(32) default NULL,
  `customers_vat_id` varchar(20) default NULL,
  `customers_vat_id_status` int(2) NOT NULL default '0',
  `customers_warning` varchar(32) default NULL,
  `customers_status` int(5) NOT NULL default '1',
  `customers_gender` char(1) NOT NULL default '',
  `customers_firstname` varchar(32) NOT NULL default '',
  `customers_lastname` varchar(32) NOT NULL default '',
  `customers_dob` datetime NOT NULL default '0000-00-00 00:00:00',
  `customers_email_address` varchar(96) NOT NULL default '',
  `customers_default_address_id` int(11) NOT NULL default '0',
  `customers_telephone` varchar(32) NOT NULL default '',
  `customers_fax` varchar(32) default NULL,
  `customers_password` varchar(40) NOT NULL default '',
  `customers_newsletter` char(1) default NULL,
  `customers_newsletter_mode` char(1) NOT NULL default '0',
  `member_flag` char(1) NOT NULL default '0',
  `delete_user` char(1) NOT NULL default '1',
  `account_type` int(1) NOT NULL default '0',
  `password_request_key` varchar(32) NOT NULL default '',
  `payment_unallowed` varchar(255) NOT NULL default '',
  `shipping_unallowed` varchar(255) NOT NULL default '',
  `refferers_id` int(5) NOT NULL default '0',
  `customers_date_added` datetime default '0000-00-00 00:00:00',
  `customers_last_modified` datetime default '0000-00-00 00:00:00',
  PRIMARY KEY  (`customers_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_basket`;
CREATE TABLE `customers_basket` (
  `customers_basket_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `customers_basket_quantity` decimal(15,4) NOT NULL default '0.0000',
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `customers_basket_date_added` varchar(8) default NULL,
  PRIMARY KEY  (`customers_basket_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_basket_attributes`;
CREATE TABLE `customers_basket_attributes` (
  `customers_basket_attributes_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `products_options_id` int(11) NOT NULL default '0',
  `products_options_value_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`customers_basket_attributes_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_info`;
CREATE TABLE `customers_info` (
  `customers_info_id` int(11) NOT NULL default '0',
  `customers_info_date_of_last_logon` datetime default NULL,
  `customers_info_number_of_logons` int(5) default NULL,
  `customers_info_date_account_created` datetime default NULL,
  `customers_info_date_account_last_modified` datetime default NULL,
  `global_product_notifications` int(1) default '0',
  PRIMARY KEY  (`customers_info_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_ip`;
CREATE TABLE `customers_ip` (
  `customers_ip_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `customers_ip` varchar(15) NOT NULL default '',
  `customers_ip_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `customers_host` varchar(255) NOT NULL default '',
  `customers_advertiser` varchar(30) default NULL,
  `customers_referer_url` varchar(255) default NULL,
  PRIMARY KEY  (`customers_ip_id`),
  KEY `customers_id` (`customers_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_logs_history`;
CREATE TABLE `customers_logs_history` (
  `customers_logs_history_id` int(10) unsigned NOT NULL auto_increment,
  `customers_id` int(10) unsigned NOT NULL,
  `confirmation_date` varchar(32) NOT NULL,
  `logfile` varchar(255) NOT NULL,
  PRIMARY KEY  (`customers_logs_history_id`),
  UNIQUE KEY `customers_id` (`customers_id`,`logfile`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_memo`;
CREATE TABLE `customers_memo` (
  `memo_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `memo_date` date NOT NULL default '0000-00-00',
  `memo_title` text NOT NULL,
  `memo_text` text NOT NULL,
  `poster_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`memo_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_status`;
CREATE TABLE `customers_status` (
  `customers_status_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `customers_status_name` varchar(32) NOT NULL default '',
  `customers_status_public` int(1) NOT NULL default '1',
  `customers_status_min_order` decimal(15,2) default NULL,
  `customers_status_max_order` decimal(15,2) default NULL,
  `customers_status_image` varchar(64) default NULL,
  `customers_status_discount` decimal(4,2) default '0.00',
  `customers_status_ot_discount_flag` char(1) NOT NULL default '0',
  `customers_status_ot_discount` decimal(4,2) default '0.00',
  `customers_status_graduated_prices` char(1) NOT NULL default '0',
  `customers_status_show_price` int(1) NOT NULL default '1',
  `customers_status_show_price_tax` int(1) NOT NULL default '1',
  `customers_status_add_tax_ot` int(1) NOT NULL default '0',
  `customers_status_payment_unallowed` varchar(255) NOT NULL default '',
  `customers_status_shipping_unallowed` varchar(255) NOT NULL default '',
  `customers_status_discount_attributes` int(1) NOT NULL default '0',
  `customers_fsk18` int(1) NOT NULL default '1',
  `customers_fsk18_display` int(1) NOT NULL default '1',
  `customers_status_write_reviews` int(1) NOT NULL default '1',
  `customers_status_read_reviews` int(1) NOT NULL default '1',
  PRIMARY KEY  (`customers_status_id`,`language_id`),
  KEY `idx_orders_status_name` (`customers_status_name`),
  KEY `language_id` (`language_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_status_history`;
CREATE TABLE `customers_status_history` (
  `customers_status_history_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `new_value` int(5) NOT NULL default '0',
  `old_value` int(5) default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `customer_notified` int(1) default '0',
  PRIMARY KEY  (`customers_status_history_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_wishlist`;
CREATE TABLE `customers_wishlist` (
  `customers_basket_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `customers_basket_quantity` decimal(15,4) NOT NULL default '0.0000',
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `customers_basket_date_added` varchar(8) default NULL,
  PRIMARY KEY  (`customers_basket_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_wishlist_attributes`;
CREATE TABLE `customers_wishlist_attributes` (
  `customers_basket_attributes_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `products_options_id` int(11) NOT NULL default '0',
  `products_options_value_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`customers_basket_attributes_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `database_version`;
CREATE TABLE `database_version` (
  `version` varchar(32) NOT NULL default ''
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `export_cronjobs`;
CREATE TABLE `export_cronjobs` (
  `cronjob_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `scheme_id` int(10) unsigned NOT NULL,
  `due_date` datetime NOT NULL,
  PRIMARY KEY (`cronjob_id`),
  KEY `scheme_id` (`scheme_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `export_schemes`;
CREATE TABLE `export_schemes` (
  `scheme_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `type_id` int(11) unsigned NOT NULL DEFAULT '2',
  `scheme_name` varchar(255) NOT NULL,
  `filename` varchar(45) NOT NULL,
  `field_separator` varchar(8) NOT NULL,
  `field_quotes` varchar(8) NOT NULL,
  `date_created` datetime NOT NULL,
  `date_modified` datetime NOT NULL,
  `date_last_export` datetime NOT NULL,
  `created_by` varchar(45) NOT NULL DEFAULT 'custom',
  `customers_status_id` int(11) unsigned NOT NULL,
  `currencies_id` int(11) unsigned NOT NULL,
  `languages_id` int(11) unsigned NOT NULL,
  `campaign_id` varchar(64) NOT NULL,
  `shipping_free_minimum` decimal(15,4) NOT NULL,
  `quantity_minimum` decimal(15,4) NOT NULL,
  `export_attributes` tinyint(1) NOT NULL,
  `export_properties` tinyint(1) NOT NULL,
  `export_features` tinyint(1) NOT NULL,
  `cronjob_allowed` tinyint(1) NOT NULL,
  `cronjob_days` varchar(32) NOT NULL DEFAULT 'Mon|Tue|Wed|Thu|Fri|Sat|Sun',
  `cronjob_hour` enum('0','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','21','22','23') NOT NULL DEFAULT '3',
  `cronjob_interval` enum('0','1','2','3','4','5','6','7','8','9','10','11','12') NOT NULL DEFAULT '0',
  PRIMARY KEY (`scheme_id`),
  UNIQUE KEY `scheme_type` (`type_id`, `scheme_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `export_scheme_categories`;
CREATE TABLE `export_scheme_categories` (
  `scheme_id` int(11) NOT NULL,
  `categories_id` int(11) NOT NULL,
  `selection_state` enum('self_all_sub','self_some_sub','self_no_sub','no_self_all_sub','no_self_some_sub','no_self_no_sub') NOT NULL DEFAULT 'no_self_no_sub',
  PRIMARY KEY (`scheme_id`,`categories_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `export_scheme_fields`;
CREATE TABLE `export_scheme_fields` (
  `field_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `scheme_id` int(11) unsigned NOT NULL,
  `field_name` varchar(255) NOT NULL,
  `field_content` varchar(255) NOT NULL,
  `field_content_default` varchar(255) NOT NULL,
  `created_by` varchar(45) NOT NULL DEFAULT 'custom',
  `sort_order` int(11) NOT NULL,
  PRIMARY KEY (`field_id`),
  KEY `fk_export_scheme_fields_export_schemes_idx` (`scheme_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `export_scheme_properties`;
CREATE TABLE `export_scheme_properties` (
  `scheme_id` int(11) unsigned NOT NULL,
  `properties_column` varchar(100) NOT NULL,
  `sort_order` int(11) NOT NULL,
  PRIMARY KEY (`scheme_id`,`properties_column`),
  KEY `scheme_id` (`scheme_id`,`sort_order`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `export_types`;
CREATE TABLE `export_types` (
  `type_id` int(11) unsigned NOT NULL,
  `language_id` int(11) unsigned NOT NULL,
  `name` varchar(64) NOT NULL,
  PRIMARY KEY (`type_id`,`language_id`),
  KEY `language_id` (`language_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `geo_zones`;
CREATE TABLE `geo_zones` (
  `geo_zone_id` int(11) NOT NULL auto_increment,
  `geo_zone_name` varchar(32) NOT NULL default '',
  `geo_zone_description` varchar(255) NOT NULL default '',
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`geo_zone_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_admin_boxes`;
CREATE TABLE `gm_admin_boxes` (
  `boxes_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL,
  `box_key` varchar(64) NOT NULL,
  `box_status` tinyint(4) NOT NULL,
  PRIMARY KEY  (`boxes_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_admin_favorites`;
CREATE TABLE `gm_admin_favorites` (
  `favorites_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL,
  `link_key` varchar(255) NOT NULL,
  `sort_order` int(11) NOT NULL,
  PRIMARY KEY  (`favorites_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_bookmarks`;
CREATE TABLE `gm_bookmarks` (
  `gm_bookmarks_id` int(11) NOT NULL auto_increment,
  `gm_bookmarks_name` varchar(255) default NULL,
  `gm_bookmarks_link` varchar(255) default NULL,
  `gm_bookmarks_image` varchar(255) default NULL,
  PRIMARY KEY  (`gm_bookmarks_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_boxes`;
CREATE TABLE `gm_boxes` (
  `boxes_id` int(11) NOT NULL auto_increment,
  `template_name` varchar(32) NOT NULL default '',
  `box_name` varchar(64) NOT NULL,
  `position` varchar(32) NOT NULL,
  `box_status` tinyint(1) NOT NULL,
  PRIMARY KEY  (`boxes_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_configuration`;
CREATE TABLE `gm_configuration` (
  `gm_configuration_id` int(11) NOT NULL auto_increment,
  `gm_key` varchar(255) NOT NULL default '',
  `gm_value` text NOT NULL,
  `gm_group_id` int(11) NOT NULL default '0',
  `gm_sort_order` int(5) NOT NULL default '0',
  PRIMARY KEY  (`gm_configuration_id`),
  UNIQUE KEY `gm_key` (`gm_key`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_contents`;
CREATE TABLE `gm_contents` (
  `gm_contents_id` int(10) unsigned NOT NULL auto_increment,
  `languages_id` int(10) unsigned NOT NULL default '0',
  `gm_key` varchar(255) NOT NULL default '',
  `gm_value` text NOT NULL,
  `gm_group_id` int(11) NOT NULL default '0',
  `gm_sort_order` int(5) NOT NULL default '0',
  PRIMARY KEY  (`gm_contents_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_counter_extern_search`;
CREATE TABLE `gm_counter_extern_search` (
  `gm_counter_extern_search_id` int(10) NOT NULL auto_increment,
  `gm_counter_extern_search_name` varchar(255) default NULL,
  `gm_counter_extern_search_engine` varchar(255) default NULL,
  `gm_counter_extern_search_hits` int(10) NOT NULL default '0',
  PRIMARY KEY  (`gm_counter_extern_search_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_counter_info`;
CREATE TABLE `gm_counter_info` (
  `gm_counter_info_id` int(10) NOT NULL auto_increment,
  `gm_counter_info_type_id` int(10) NOT NULL default '0',
  `gm_counter_info_hits` int(10) NOT NULL default '0',
  `gm_counter_info_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`gm_counter_info_id`),
  KEY `gm_counter_info_type_id` (`gm_counter_info_type_id`,`gm_counter_info_name`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_counter_info_type`;
CREATE TABLE `gm_counter_info_type` (
  `gm_counter_info_type_id` int(10) NOT NULL auto_increment,
  `gm_counter_info_type_name` varchar(255) default NULL,
  PRIMARY KEY  (`gm_counter_info_type_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_counter_intern_search`;
CREATE TABLE `gm_counter_intern_search` (
  `gm_counter_intern_search_id` int(10) NOT NULL auto_increment,
  `gm_counter_intern_search_name` varchar(255) default NULL,
  `gm_counter_intern_search_hits` int(10) NOT NULL default '0',
  PRIMARY KEY  (`gm_counter_intern_search_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_counter_ip`;
CREATE TABLE `gm_counter_ip` (
  `gm_ip_id` int(10) NOT NULL auto_increment,
  `gm_ip_value` varchar(255) default NULL,
  `gm_ip_date` datetime NOT NULL,
  PRIMARY KEY  (`gm_ip_id`),
  KEY `gm_ip_date` (`gm_ip_date`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_counter_page`;
CREATE TABLE `gm_counter_page` (
  `gm_counter_page_id` int(10) NOT NULL auto_increment,
  `gm_counter_page_name` varchar(255) default NULL,
  `gm_counter_page_type` varchar(255) default NULL,
  `gm_counter_page_date` datetime NOT NULL,
  PRIMARY KEY  (`gm_counter_page_id`),
  KEY `gm_counter_page_date` (`gm_counter_page_date`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_counter_page_history`;
CREATE TABLE `gm_counter_page_history` (
  `gm_counter_page_history_id` int(10) NOT NULL auto_increment,
  `gm_counter_page_history_name` varchar(255) default NULL,
  `gm_counter_page_history_type` varchar(255) default NULL,
  `gm_counter_page_history_hits` int(10) default NULL,
  `gm_counter_page_history_date` datetime NOT NULL,
  PRIMARY KEY  (`gm_counter_page_history_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_counter_visits`;
CREATE TABLE `gm_counter_visits` (
  `gm_counter_id` int(10) NOT NULL auto_increment,
  `gm_counter_visits_total` int(10) NOT NULL default '0',
  `gm_counter_date` datetime NOT NULL,
  PRIMARY KEY  (`gm_counter_id`),
  KEY `gm_counter_date` (`gm_counter_date`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_css_look`;
CREATE TABLE `gm_css_look` (
  `gm_css_look_id` int(11) unsigned NOT NULL auto_increment,
  `gm_css_ref_look_id` int(11) unsigned NOT NULL,
  `gm_css_look_name` varchar(30) NOT NULL DEFAULT 'default',
  PRIMARY KEY (`gm_css_look_id`)
) ENGINE = MyISAM;

DROP TABLE IF EXISTS `gm_css_style`;
CREATE TABLE `gm_css_style` (
  `gm_css_style_id` int(11) NOT NULL auto_increment,
  `template_name` varchar(32) NOT NULL default '',
  `style_name` varchar(255) NOT NULL default '',
  `editable` tinyint(4) NOT NULL default '1',
  `selectors_specificity` varchar(8) NOT NULL,
  `gm_css_look_id` int(11) unsigned NOT NULL default '1',
  PRIMARY KEY  (`gm_css_style_id`),
  KEY `name` (`style_name`),
  KEY `editable` (`editable`,`template_name`,`selectors_specificity`,`gm_css_style_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_css_style_content`;
CREATE TABLE `gm_css_style_content` (
  `gm_css_style_content_id` int(11) NOT NULL auto_increment,
  `gm_css_style_id` int(11) NOT NULL default '0',
  `style_attribute` varchar(32) NOT NULL default '',
  `style_value` text NOT NULL,
  `editable` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`gm_css_style_content_id`),
  KEY `gm_css_style_id` (`gm_css_style_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_css_style_fonts`;
CREATE TABLE `gm_css_style_fonts` (
  `gm_css_style_fonts_id` int(10) unsigned NOT NULL auto_increment,
  `font` varchar(255) NOT NULL,
  PRIMARY KEY  (`gm_css_style_fonts_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_css_style_history`;
CREATE TABLE IF NOT EXISTS `gm_css_style_history` (
  `gm_css_style_history_id` int(10) unsigned NOT NULL auto_increment,
  `gm_css_style_security_id` int(10) unsigned NOT NULL,
  `gm_css_style_id` int(10) unsigned NOT NULL,
  `gm_css_history_active` enum('true','false') NOT NULL default 'true',
  `date` datetime default NULL,
  PRIMARY KEY  (`gm_css_style_history_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_css_style_history_content`;
CREATE TABLE IF NOT EXISTS `gm_css_style_history_content` (
  `gm_css_style_history_content_id` int(10) unsigned NOT NULL auto_increment,
  `gm_css_style_history_id` int(10) unsigned NOT NULL,
  `style_attribute` varchar(32) default NULL,
  `style_value` text,
  PRIMARY KEY  (`gm_css_style_history_content_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_css_style_security`;
CREATE TABLE IF NOT EXISTS `gm_css_style_security` (
  `gm_css_style_security_id` int(10) unsigned NOT NULL auto_increment,
  `gm_css_style_security_token` varchar(64) default NULL,
  `gm_css_style_security_date` datetime default NULL,
  PRIMARY KEY  (`gm_css_style_security_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_emails`;
CREATE TABLE `gm_emails` (
  `gm_emails_id` int(10) unsigned NOT NULL auto_increment,
  `gm_email_id` int(10) unsigned NOT NULL default '0',
  `languages_id` int(10) unsigned NOT NULL default '0',
  `folder` varchar(64) NOT NULL default '',
  `filename` varchar(255) NOT NULL default '',
  `backup_original_html` MEDIUMTEXT NOT NULL,
  `backup_user_html` MEDIUMTEXT NOT NULL,
  `backup_original_txt` MEDIUMTEXT NOT NULL,
  `backup_user_txt` MEDIUMTEXT NOT NULL,
  `html` MEDIUMTEXT NOT NULL,
  `txt` MEDIUMTEXT NOT NULL,
  PRIMARY KEY  (`gm_emails_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_guestbook`;
CREATE TABLE `gm_guestbook` (
  `gm_guestbook_id` int(10) unsigned NOT NULL auto_increment,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `name` varchar(255) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `homepage` varchar(255) NOT NULL default '',
  `message` text NOT NULL,
  `ip` varchar(255) NOT NULL default '',
  `activated` int(1) NOT NULL default '0',
  PRIMARY KEY  (`gm_guestbook_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_guestbook_customers_status`;
CREATE TABLE `gm_guestbook_customers_status` (
  `gm_guestbook_customers_status_id` int(10) unsigned NOT NULL auto_increment,
  `customers_status_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`gm_guestbook_customers_status_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `language_sections`;
CREATE TABLE `language_sections` (
  `language_section_id` int(11) NOT NULL auto_increment,
  `language_id` int(11) NOT NULL,
  `section_name` varchar(255) NOT NULL,
  PRIMARY KEY  (`language_section_id`),
  UNIQUE KEY `language_section` (`language_id`, `section_name`),
  KEY `lang_files_id` (`language_section_id`,`section_name`),
  KEY `section_name` (`section_name`,`language_section_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `language_section_phrases`;
CREATE TABLE `language_section_phrases` (
  `language_section_phrase_id` int(11) NOT NULL auto_increment,
  `language_section_id` int(11) NOT NULL,
  `phrase_name` varchar(255) NOT NULL,
  `phrase_value` text NOT NULL,
  PRIMARY KEY  (`language_section_phrase_id`),
  UNIQUE KEY `language_section_phrase` (`language_section_id`, `phrase_name`),
  KEY `lang_files_id` (`language_section_id`),
  FULLTEXT KEY `phrase_value` (`phrase_value`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_login_history`;
CREATE TABLE `gm_login_history` (
  `gm_login_history_id` int(10) NOT NULL auto_increment,
  `gm_login_ip` varchar(15) NOT NULL default '',
  `gm_login_date` datetime NOT NULL,
  PRIMARY KEY  (`gm_login_history_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gmotion`;
CREATE TABLE `gm_gmotion` (
  `gm_gmotion_id` int(10) unsigned NOT NULL auto_increment,
  `products_id` int(10) unsigned NOT NULL,
  `image_nr` smallint(6) NOT NULL default '0',
  `position_from` varchar(32) NOT NULL,
  `position_to` varchar(32) NOT NULL,
  `zoom_from` decimal(3,1) NOT NULL,
  `zoom_to` decimal(3,1) NOT NULL,
  `duration` int(10) unsigned NOT NULL default '1',
  `sort_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`gm_gmotion_id`),
  UNIQUE KEY `products_id` (`products_id`,`image_nr`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gmotion_products`;
CREATE TABLE `gm_gmotion_products` (
  `gm_gmotion_products_id` int(10) unsigned NOT NULL auto_increment,
  `products_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`gm_gmotion_products_id`),
  UNIQUE KEY `products_id` (`products_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_prd_img_alt`;
CREATE TABLE `gm_prd_img_alt` (
  `img_alt_id` int(11) NOT NULL auto_increment,
  `image_id` int(11) NOT NULL default '0',
  `products_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL default '1',
  `gm_alt_text` varchar(255) default NULL,
  PRIMARY KEY  (`img_alt_id`),
  UNIQUE KEY `image_id` (`image_id`,`products_id`,`language_id`),
  KEY `image_id2` (`image_id`,`language_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_search_history`;
CREATE TABLE `gm_search_history` (
  `gm_search_history_id` int(10) NOT NULL auto_increment,
  `gm_search_ip` varchar(15) NOT NULL default '',
  `gm_search_date` datetime NOT NULL,
  PRIMARY KEY  (`gm_search_history_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `infobox_messages`;
CREATE TABLE IF NOT EXISTS `infobox_messages` (
  `infobox_messages_id` int(10) unsigned NOT NULL auto_increment,
  `source` varchar(255) NOT NULL,
  `identifier` varchar(255) NOT NULL,
  `status` enum('new','read','hidden','deleted') NOT NULL default 'new',
  `type` enum('info','warning','success') NOT NULL default 'info',
  `visibility` enum('alwayson','hideable','removable') NOT NULL default 'hideable',
  `button_link` varchar(255) NOT NULL,
  `customers_id` int(10) unsigned NOT NULL,
  `date_added` datetime NOT NULL,
  `date_modified` datetime NOT NULL,
  PRIMARY KEY  (`infobox_messages_id`),
  UNIQUE KEY `identifier` (`identifier`,`customers_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `ipayment_log`;
CREATE TABLE IF NOT EXISTS `ipayment_log` (
  `ipayment_log_id` int(11) NOT NULL AUTO_INCREMENT,
  `orders_id` int(11) NOT NULL,
  `action` varchar(255) NOT NULL,
  `trxuser_id` varchar(255) NOT NULL,
  `trx_currency` varchar(255) NOT NULL,
  `trx_amount` varchar(255) NOT NULL,
  `trx_typ` varchar(255) NOT NULL,
  `addr_name` varchar(255) NOT NULL,
  `addr_email` varchar(255) NOT NULL,
  `shopper_id` varchar(255) NOT NULL,
  `client_name` varchar(255) NOT NULL,
  `client_version` varchar(255) NOT NULL,
  `addr_street` varchar(255) NOT NULL,
  `addr_zip` varchar(255) NOT NULL,
  `addr_city` varchar(255) NOT NULL,
  `trx_paymenttyp` varchar(255) NOT NULL,
  `ret_transdate` varchar(255) NOT NULL,
  `ret_transtime` varchar(255) NOT NULL,
  `ret_errorcode` varchar(255) NOT NULL,
  `ret_fatalerror` varchar(255) NOT NULL,
  `ret_errormsg` varchar(255) NOT NULL,
  `ret_additionalmsg` varchar(255) NOT NULL,
  `ret_authcode` varchar(255) NOT NULL,
  `ret_ip` varchar(255) NOT NULL,
  `ret_booknr` varchar(255) NOT NULL,
  `ret_trx_number` varchar(255) NOT NULL,
  `ret_param_checksum` varchar(255) NOT NULL,
  `redirect_needed` varchar(255) NOT NULL,
  `trx_paymentmethod` varchar(255) NOT NULL,
  `trx_paymentdata_country` varchar(255) NOT NULL,
  `trx_remoteip_country` varchar(255) NOT NULL,
  `ret_status` varchar(255) NOT NULL,
  `trx_payauth_status` varchar(255) NOT NULL,
  `trx_issuer_avs_response` varchar(255) NOT NULL,
  `ret_url_checksum` varchar(255) NOT NULL,
  `addr_check_result` varchar(255) NOT NULL,
  `paydata` varchar(255) NOT NULL,
  PRIMARY KEY (`ipayment_log_id`),
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `infobox_messages_description`;
CREATE TABLE IF NOT EXISTS `infobox_messages_description` (
  `infobox_messages_id` int(10) unsigned NOT NULL,
  `languages_id` int(10) unsigned NOT NULL,
  `headline` varchar(255) NOT NULL,
  `message` text NOT NULL,
  `button_label` varchar(64) NOT NULL,
  PRIMARY KEY  (`infobox_messages_id`,`languages_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `languages`;
CREATE TABLE `languages` (
  `languages_id` int(11) NOT NULL auto_increment,
  `name` varchar(32) NOT NULL default '',
  `code` char(2) NOT NULL default '',
  `image` varchar(64) default NULL,
  `directory` varchar(32) default NULL,
  `sort_order` int(3) default NULL,
  `language_charset` text NOT NULL,
  `status` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`languages_id`),
  KEY `IDX_LANGUAGES_NAME` (`name`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `log_levels`;
CREATE TABLE IF NOT EXISTS `log_levels` (
  `log_level_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`log_level_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

DROP TABLE IF EXISTS `log_output_types`;
CREATE TABLE IF NOT EXISTS `log_output_types` (
  `log_output_type_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`log_output_type_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

DROP TABLE IF EXISTS `log_outputs`;
CREATE TABLE IF NOT EXISTS `log_outputs` (
  `log_output_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`log_output_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

DROP TABLE IF EXISTS `log_groups`;
CREATE TABLE IF NOT EXISTS `log_groups` (
  `log_group_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`log_group_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

DROP TABLE IF EXISTS `log_configuration`;
CREATE TABLE IF NOT EXISTS `log_configuration` (
  `log_group_id` int(11) NOT NULL,
  `log_level_id` int(11) NOT NULL,
  `log_output_type_id` int(11) NOT NULL,
  `log_output_id` int(11) NOT NULL,
  PRIMARY KEY (`log_group_id`, `log_level_id`,`log_output_type_id`,`log_output_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `manufacturers`;
CREATE TABLE `manufacturers` (
  `manufacturers_id` int(11) NOT NULL auto_increment,
  `manufacturers_name` varchar(64) NOT NULL,
  `manufacturers_image` varchar(64) default NULL,
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  PRIMARY KEY  (`manufacturers_id`),
  KEY `IDX_MANUFACTURERS_NAME` (`manufacturers_name`),
  KEY `manufacturers_id` (`manufacturers_id`,`manufacturers_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `manufacturers_info`;
CREATE TABLE `manufacturers_info` (
  `manufacturers_id` int(11) NOT NULL default '0',
  `languages_id` int(11) NOT NULL default '0',
  `manufacturers_meta_title` text NOT NULL,
  `manufacturers_meta_description` text NOT NULL,
  `manufacturers_meta_keywords` text NOT NULL,
  `manufacturers_url` varchar(255) NOT NULL default '',
  `url_clicked` int(5) NOT NULL default '0',
  `date_last_click` datetime default NULL,
  PRIMARY KEY  (`manufacturers_id`,`languages_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `media_content`;
CREATE TABLE `media_content` (
  `file_id` int(11) NOT NULL auto_increment,
  `old_filename` text NOT NULL,
  `new_filename` text NOT NULL,
  `file_comment` text NOT NULL,
  PRIMARY KEY  (`file_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `module_newsletter`;
CREATE TABLE `module_newsletter` (
  `newsletter_id` int(11) NOT NULL auto_increment,
  `title` text NOT NULL,
  `bc` text NOT NULL,
  `cc` text NOT NULL,
  `date` datetime default NULL,
  `status` int(1) NOT NULL default '0',
  `body` text NOT NULL,
  PRIMARY KEY  (`newsletter_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `module_newsletter_temp_1`;
CREATE TABLE `module_newsletter_temp_1` (
  `id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `customers_status` int(11) NOT NULL default '0',
  `customers_firstname` varchar(64) NOT NULL default '',
  `customers_lastname` varchar(64) NOT NULL default '',
  `customers_email_address` text NOT NULL,
  `mail_key` varchar(32) NOT NULL,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `comment` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `newsletters`;
CREATE TABLE `newsletters` (
  `newsletters_id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `content` text NOT NULL,
  `module` varchar(255) NOT NULL default '',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_sent` datetime default NULL,
  `status` int(1) default NULL,
  `locked` int(1) default '0',
  PRIMARY KEY  (`newsletters_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `newsletters_history`;
CREATE TABLE `newsletters_history` (
  `news_hist_id` int(11) NOT NULL default '0',
  `news_hist_cs` int(11) NOT NULL default '0',
  `news_hist_cs_date_sent` date default NULL,
  PRIMARY KEY  (`news_hist_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `newsletter_recipients`;
CREATE TABLE `newsletter_recipients` (
  `mail_id` int(11) NOT NULL auto_increment,
  `customers_email_address` varchar(96) NOT NULL default '',
  `customers_id` int(11) NOT NULL default '0',
  `customers_status` int(5) NOT NULL default '0',
  `customers_firstname` varchar(32) NOT NULL default '',
  `customers_lastname` varchar(32) NOT NULL default '',
  `mail_status` int(1) NOT NULL default '0',
  `mail_key` varchar(32) NOT NULL default '',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`mail_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders`;
CREATE TABLE `orders` (
  `orders_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `customers_cid` varchar(32) default NULL,
  `customers_vat_id` varchar(20) default NULL,
  `customers_status` int(11) default NULL,
  `customers_status_name` varchar(32) NOT NULL default '',
  `customers_status_image` varchar(64) default NULL,
  `customers_status_discount` decimal(4,2) default NULL,
  `customers_name` varchar(64) NOT NULL default '',
  `customers_firstname` varchar(64) NOT NULL default '',
  `customers_lastname` varchar(64) NOT NULL default '',
  `customers_gender` char(1) NOT NULL default '',
  `customers_company` varchar(255) default NULL,
  `customers_street_address` varchar(64) NOT NULL default '',
  `customers_suburb` varchar(32) default NULL,
  `customers_city` varchar(32) NOT NULL default '',
  `customers_postcode` varchar(10) NOT NULL default '',
  `customers_state` varchar(32) default NULL,
  `customers_country` varchar(32) NOT NULL default '',
  `customers_telephone` varchar(32) NOT NULL default '',
  `customers_email_address` varchar(96) NOT NULL default '',
  `customers_address_format_id` int(5) NOT NULL default '0',
  `delivery_name` varchar(64) NOT NULL default '',
  `delivery_firstname` varchar(64) NOT NULL default '',
  `delivery_lastname` varchar(64) NOT NULL default '',
  `delivery_gender` char(1) NOT NULL default '',
  `delivery_company` varchar(255) default NULL,
  `delivery_street_address` varchar(64) NOT NULL default '',
  `delivery_suburb` varchar(32) default NULL,
  `delivery_city` varchar(32) NOT NULL default '',
  `delivery_postcode` varchar(10) NOT NULL default '',
  `delivery_state` varchar(32) default NULL,
  `delivery_country` varchar(32) NOT NULL default '',
  `delivery_country_iso_code_2` char(2) NOT NULL default '',
  `delivery_address_format_id` int(5) NOT NULL default '0',
  `billing_name` varchar(64) NOT NULL default '',
  `billing_firstname` varchar(64) NOT NULL default '',
  `billing_lastname` varchar(64) NOT NULL default '',
  `billing_gender` char(1) NOT NULL default '',
  `billing_company` varchar(255) default NULL,
  `billing_street_address` varchar(64) NOT NULL default '',
  `billing_suburb` varchar(32) default NULL,
  `billing_city` varchar(32) NOT NULL default '',
  `billing_postcode` varchar(10) NOT NULL default '',
  `billing_state` varchar(32) default NULL,
  `billing_country` varchar(32) NOT NULL default '',
  `billing_country_iso_code_2` char(2) NOT NULL default '',
  `billing_address_format_id` int(5) NOT NULL default '0',
  `payment_method` varchar(32) NOT NULL default '',
  `cc_type` varchar(20) default NULL,
  `cc_owner` varchar(64) default NULL,
  `cc_number` varchar(64) default NULL,
  `cc_expires` varchar(4) default NULL,
  `cc_start` varchar(4) default NULL,
  `cc_issue` char(3) default NULL,
  `cc_cvv` varchar(4) default NULL,
  `comments` text default NULL,
  `last_modified` datetime default NULL,
  `date_purchased` datetime default NULL,
  `orders_status` int(5) NOT NULL default '0',
  `orders_date_finished` datetime default NULL,
  `currency` char(3) default NULL,
  `currency_value` decimal(14,6) default NULL,
  `account_type` int(1) NOT NULL default '0',
  `payment_class` varchar(32) NOT NULL default '',
  `shipping_method` varchar(32) NOT NULL default '',
  `shipping_class` varchar(32) NOT NULL default '',
  `customers_ip` varchar(32) NOT NULL default '',
  `language` varchar(32) NOT NULL default '',
  `afterbuy_success` int(1) NOT NULL default '0',
  `afterbuy_id` int(32) NOT NULL default '0',
  `refferers_id` varchar(32) NOT NULL default '',
  `conversion_type` int(1) NOT NULL default '0',
  `orders_ident_key` varchar(128) default NULL,
  `gm_orders_id` int(11) default NULL,
  `gm_packings_id` int(11) default NULL,
  `gm_orders_code` varchar(255) NOT NULL,
  `gm_packings_code` varchar(255) NOT NULL,
  `gm_order_html` MEDIUMTEXT,
  `gm_order_txt` MEDIUMTEXT NOT NULL,
  `gm_order_send_date` datetime NOT NULL,
  `gm_send_order_status` int(1) NOT NULL,
  `gm_cancel_date` datetime NOT NULL,
  `abandonment_download` tinyint(1) NOT NULL,
  `abandonment_service` tinyint(1) NOT NULL,
  `orders_hash` varchar(32) NOT NULL,
  `intraship_shipmentnumber` varchar(255) NOT NULL,
  `exported` TINYINT NOT NULL DEFAULT '0' COMMENT 'already exported to WaWi?',
  PRIMARY KEY  (`orders_id`),
  KEY `date_purchased` (`date_purchased`)
) ENGINE=MyISAM AUTO_INCREMENT=400210;

DROP TABLE IF EXISTS `orders_billsafe`;
CREATE TABLE `orders_billsafe` (
  `orders_id` int(10) unsigned NOT NULL,
  `transaction_id` varchar(255) NOT NULL,
  PRIMARY KEY (`orders_id`),
  KEY `transaction_id` (`transaction_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_hermes`;
CREATE TABLE `orders_hermes` (
  `orderno` varchar(255) NOT NULL,
  `order_type` enum('props','prips') NOT NULL DEFAULT 'props',
  `orders_id` int(11) NOT NULL,
  `receiver_firstname` varchar(25) DEFAULT NULL,
  `receiver_lastname` varchar(25) NOT NULL,
  `receiver_street` varchar(27) NOT NULL,
  `receiver_housenumber` varchar(5) DEFAULT NULL,
  `receiver_addressadd` varchar(25) DEFAULT NULL,
  `receiver_postcode` varchar(25) NOT NULL,
  `receiver_city` varchar(30) NOT NULL,
  `receiver_district` varchar(25) DEFAULT NULL,
  `receiver_countrycode` varchar(3) NOT NULL,
  `receiver_email` varchar(255) DEFAULT NULL,
  `receiver_telephonenumber` varchar(32) DEFAULT NULL,
  `receiver_telephoneprefix` varchar(25) DEFAULT NULL,
  `clientreferencenumber` varchar(255) DEFAULT NULL,
  `parcelclass` varchar(255) DEFAULT NULL,
  `amountcashondeliveryeurocent` int(11) NOT NULL,
  `state` enum('not_sent','sent','printed') NOT NULL DEFAULT 'not_sent',
  `shipping_id` varchar(255) DEFAULT NULL,
  `paket_shop_id` varchar(255) DEFAULT NULL,
  `hand_over_mode` varchar(255) DEFAULT NULL,
  `collection_desired_date` datetime DEFAULT NULL,
  PRIMARY KEY (`orderno`),
  KEY `order_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_intraship_labels`;
CREATE TABLE `orders_intraship_labels` (
  `orders_id` int(11) NOT NULL,
  `label_url` text NOT NULL,
  PRIMARY KEY (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_klarna`;
CREATE TABLE `orders_klarna` (
  `orders_id` int(10) unsigned NOT NULL,
  `rno` varchar(255) NOT NULL,
  `status` varchar(255) NOT NULL,
  `risk_status` varchar(255) NOT NULL,
  `inv_rno` varchar(255) NOT NULL,
  PRIMARY KEY (`orders_id`),
  KEY `rno` (`rno`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_klarna_creditpart`;
CREATE TABLE `orders_klarna_creditpart` (
  `ok_creditpart_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `orders_id` int(10) unsigned NOT NULL,
  `products_model` varchar(255) NOT NULL,
  `quantity` int(11) NOT NULL,
  `sent_time` datetime NOT NULL,
  PRIMARY KEY (`ok_creditpart_id`),
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_klarna_returnamount`;
CREATE TABLE `orders_klarna_returnamount` (
  `ok_returnamount_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `orders_id` int(10) unsigned NOT NULL,
  `amount` decimal(15,4) NOT NULL,
  `vat` decimal(15,4) NOT NULL,
  `description` varchar(255) NOT NULL,
  `sent_time` datetime NOT NULL,
  PRIMARY KEY (`ok_returnamount_id`),
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_products`;
CREATE TABLE `orders_products` (
  `orders_products_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `products_id` int(11) NOT NULL default '0',
  `products_model` varchar(64) default NULL,
  `products_name` varchar(255) NOT NULL default '',
  `products_price` decimal(15,4) NOT NULL default '0.0000',
  `products_discount_made` decimal(4,2) default NULL,
  `products_shipping_time` varchar(255) default NULL,
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `products_tax` decimal(7,4) NOT NULL default '0.0000',
  `products_quantity` decimal(15,4) NOT NULL default '0.0000',
  `allow_tax` int(1) NOT NULL default '0',
  `product_type` int(11) NOT NULL DEFAULT '1',
  `properties_combi_price` decimal(15,4) NOT NULL default '0.0000',
  `properties_combi_model` varchar(64) NOT NULL,
  `checkout_information` text,
  PRIMARY KEY (`orders_products_id`),
  KEY `orders_id` (`orders_id`),
  KEY `products_id` (`products_id`,`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_products_attributes`;
CREATE TABLE `orders_products_attributes` (
  `orders_products_attributes_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `orders_products_id` int(11) NOT NULL default '0',
  `products_options` varchar(255) NOT NULL default '',
  `products_options_values` varchar(255) NOT NULL default '',
  `options_values_price` decimal(15,4) NOT NULL default '0.0000',
  `price_prefix` char(1) NOT NULL default '',
  `options_id` int(11) NOT NULL default '0',
  `options_values_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`orders_products_attributes_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_products_download`;
CREATE TABLE `orders_products_download` (
  `orders_products_download_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `orders_products_id` int(11) NOT NULL default '0',
  `orders_products_filename` varchar(255) NOT NULL default '',
  `download_maxdays` int(2) NOT NULL default '0',
  `download_count` int(2) NOT NULL default '0',
  PRIMARY KEY  (`orders_products_download_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_recalculate`;
CREATE TABLE `orders_recalculate` (
  `orders_recalculate_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `n_price` decimal(15,4) NOT NULL default '0.0000',
  `b_price` decimal(15,4) NOT NULL default '0.0000',
  `tax` decimal(15,13) NOT NULL default '0.0000000000000',
  `tax_rate` decimal(7,4) NOT NULL default '0.0000',
  `class` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`orders_recalculate_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_status`;
CREATE TABLE `orders_status` (
  `orders_status_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `orders_status_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`orders_status_id`,`language_id`),
  KEY `idx_orders_status_name` (`orders_status_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_status_history`;
CREATE TABLE `orders_status_history` (
  `orders_status_history_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `orders_status_id` int(5) NOT NULL default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `customer_notified` int(1) default '0',
  `comments` text,
  PRIMARY KEY  (`orders_status_history_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_total`;
CREATE TABLE `orders_total` (
  `orders_total_id` int(10) unsigned NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `text` varchar(255) NOT NULL default '',
  `value` decimal(15,4) NOT NULL default '0.0000',
  `class` varchar(32) NOT NULL default '',
  `sort_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`orders_total_id`),
  KEY `idx_orders_total_orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payment_ipayment`;
CREATE TABLE `payment_ipayment` (
  `ip_BOOKNR` varchar(255) NOT NULL,
  `ip_INFO` text NOT NULL,
  `ip_ORDERID` int(11) NOT NULL,
  `ip_IS_CAPTURED` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`ip_BOOKNR`),
  KEY `ip_ORDERID` (`ip_ORDERID`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payment_ipayment_log`;
CREATE TABLE `payment_ipayment_log` (
  `ip_LOG_ID` int(10) unsigned NOT NULL auto_increment,
  `ip_LOG_MESSAGE` varchar(255) NOT NULL,
  `ip_LOG_INFO` text NOT NULL,
  `ip_LOG_DATE` datetime NOT NULL,
  PRIMARY KEY  (`ip_LOG_ID`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payment_qenta`;
CREATE TABLE `payment_qenta` (
  `q_TRID` varchar(255) NOT NULL default '',
  `q_DATE` datetime NOT NULL default '0000-00-00 00:00:00',
  `q_QTID` bigint(18) unsigned NOT NULL default '0',
  `q_ORDERDESC` varchar(255) NOT NULL default '',
  `q_STATUS` tinyint(1) NOT NULL default '0',
  `q_ORDERID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`q_TRID`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payone_ac_cache`;
CREATE TABLE `payone_ac_cache` (
  `address_hash` varchar(32) NOT NULL,
  `address_book_id` int(11) NOT NULL,
  `received` datetime NOT NULL,
  `secstatus` int(11) NOT NULL,
  `status` varchar(7) NOT NULL,
  `personstatus` varchar(4) NOT NULL,
  `street` varchar(255) NOT NULL,
  `streetname` varchar(255) NOT NULL,
  `streetnumber` varchar(255) NOT NULL,
  `zip` varchar(255) NOT NULL,
  `city` varchar(255) NOT NULL,
  `errorcode` varchar(255) NOT NULL,
  `errormessage` text NOT NULL,
  `customermessage` varchar(255) NOT NULL,
  PRIMARY KEY (`address_hash`),
  KEY `address_book_id` (`address_book_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payone_api_log`;
CREATE TABLE `payone_api_log` (
  `p1_api_log_id` int(11) NOT NULL AUTO_INCREMENT,
  `event_id` bigint(20) NOT NULL,
  `date_created` datetime NOT NULL,
  `log_count` int(11) NOT NULL,
  `log_level` int(11) NOT NULL,
  `message` mediumtext NOT NULL,
  `customers_id` int(11) NOT NULL,
  PRIMARY KEY (`p1_api_log_id`),
  KEY `event_id` (`event_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `payone_clearingdata`;
CREATE TABLE `payone_clearingdata` (
  `p1_clearingdata_id` int(11) NOT NULL AUTO_INCREMENT,
  `orders_id` int(10) unsigned NOT NULL,
  `bankaccountholder` varchar(255) NOT NULL,
  `bankcountry` varchar(2) NOT NULL,
  `bankaccount` varchar(32) NOT NULL,
  `bankcode` varchar(32) NOT NULL,
  `bankiban` varchar(32) NOT NULL,
  `bankbic` varchar(32) NOT NULL,
  `bankcity` varchar(64) NOT NULL,
  `bankname` varchar(128) NOT NULL,
  PRIMARY KEY (`p1_clearingdata_id`),
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payone_cr_cache`;
CREATE TABLE `payone_cr_cache` (
  `address_hash` varchar(32) NOT NULL,
  `address_book_id` int(11) NOT NULL,
  `scoretype` varchar(2) NOT NULL,
  `received` datetime NOT NULL,
  `secstatus` int(11) NOT NULL,
  `status` varchar(7) NOT NULL,
  `score` varchar(100) NOT NULL,
  `scorevalue` varchar(100) NOT NULL,
  `secscore` varchar(100) NOT NULL,
  `personstatus` varchar(4) NOT NULL,
  `firstname` varchar(255) NOT NULL,
  `lastname` varchar(255) NOT NULL,
  `street` varchar(255) NOT NULL,
  `streetname` varchar(255) NOT NULL,
  `streetnumber` varchar(255) NOT NULL,
  `zip` varchar(255) NOT NULL,
  `city` varchar(255) NOT NULL,
  `errorcode` varchar(255) NOT NULL,
  `errormessage` text NOT NULL,
  `customermessage` varchar(255) NOT NULL,
  PRIMARY KEY (`address_hash`),
  KEY `address_book_id` (`address_book_id`),
  KEY `scoretype` (`scoretype`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payone_transactions`;
CREATE TABLE `payone_transactions` (
  `payone_transactions_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `orders_id` int(10) unsigned NOT NULL,
  `status` varchar(255) NOT NULL,
  `txid` varchar(100) NOT NULL,
  `userid` varchar(100) NOT NULL,
  `created` datetime DEFAULT NULL,
  `last_modified` datetime DEFAULT NULL,
  PRIMARY KEY (`payone_transactions_id`),
  KEY `orders_id` (`orders_id`,`txid`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payone_transactions_log`;
CREATE TABLE `payone_transactions_log` (
  `p1_transactions_log_id` int(11) NOT NULL AUTO_INCREMENT,
  `event_id` bigint(20) NOT NULL,
  `date_created` datetime NOT NULL,
  `log_count` int(11) NOT NULL,
  `log_level` int(11) NOT NULL,
  `message` mediumtext NOT NULL,
  `customers_id` int(11) NOT NULL,
  PRIMARY KEY (`p1_transactions_log_id`),
  KEY `event_id` (`event_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payone_txstatus`;
CREATE TABLE `payone_txstatus` (
  `payone_txstatus_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `orders_id` int(11) NOT NULL,
  `received` datetime NOT NULL,
  PRIMARY KEY (`payone_txstatus_id`),
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payone_txstatus_data`;
CREATE TABLE `payone_txstatus_data` (
  `payone_txstatus_data_id` int(11) NOT NULL AUTO_INCREMENT,
  `payone_txstatus_id` int(11) NOT NULL,
  `key` varchar(255) NOT NULL,
  `value` varchar(255) NOT NULL,
  PRIMARY KEY (`payone_txstatus_data_id`),
  KEY `payone_txstatus_id` (`payone_txstatus_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `paypal_ipn`;
CREATE TABLE IF NOT EXISTS `paypal_ipn` (
  `paypal_ipn_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `received_time` datetime NOT NULL,
  `txn_id` varchar(255) NOT NULL,
  `address_city` varchar(255) DEFAULT NULL,
  `address_country` varchar(255) DEFAULT NULL,
  `address_country_code` varchar(255) DEFAULT NULL,
  `address_name` varchar(255) DEFAULT NULL,
  `address_state` varchar(255) DEFAULT NULL,
  `address_status` varchar(255) DEFAULT NULL,
  `address_street` varchar(255) DEFAULT NULL,
  `address_zip` varchar(255) DEFAULT NULL,
  `business` varchar(255) DEFAULT NULL,
  `custom` varchar(255) DEFAULT NULL,
  `first_name` varchar(255) DEFAULT NULL,
  `invoice` varchar(255) DEFAULT NULL,
  `item_name` varchar(255) DEFAULT NULL,
  `item_number` varchar(255) DEFAULT NULL,
  `last_name` varchar(255) DEFAULT NULL,
  `mc_currency` varchar(255) DEFAULT NULL,
  `mc_fee` varchar(255) DEFAULT NULL,
  `mc_gross1` varchar(255) DEFAULT NULL,
  `mc_gross` varchar(255) DEFAULT NULL,
  `mc_handling` varchar(255) DEFAULT NULL,
  `mc_shipping` varchar(255) DEFAULT NULL,
  `notify_version` varchar(255) DEFAULT NULL,
  `parent_txn_id` varchar(255) DEFAULT NULL,
  `payer_email` varchar(255) DEFAULT NULL,
  `payer_id` varchar(255) DEFAULT NULL,
  `payer_status` varchar(255) DEFAULT NULL,
  `payment_date` varchar(255) DEFAULT NULL,
  `payment_status` varchar(255) DEFAULT NULL,
  `payment_type` varchar(255) DEFAULT NULL,
  `pending_reason` varchar(255) NOT NULL,
  `quantity` varchar(255) DEFAULT NULL,
  `reason_code` varchar(255) DEFAULT NULL,
  `receipt_ID` varchar(255) DEFAULT NULL,
  `receiver_email` varchar(255) DEFAULT NULL,
  `receiver_id` varchar(255) DEFAULT NULL,
  `residence_country` varchar(255) DEFAULT NULL,
  `shipping` varchar(255) DEFAULT NULL,
  `tax` varchar(255) DEFAULT NULL,
  `test_ipn` varchar(255) DEFAULT NULL,
  `txn_type` varchar(255) DEFAULT NULL,
  `verify_sign` varchar(255) DEFAULT NULL,
  `ipn_raw` text,
  `date_test` datetime NOT NULL,
  PRIMARY KEY (`paypal_ipn_id`),
  KEY `txn_id` (`txn_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `paypal_checkoutdetails`;
CREATE TABLE IF NOT EXISTS `paypal_checkoutdetails` (
  `orders_id` int(11) NOT NULL,
  `retrievaltime` datetime NOT NULL,
  `checkoutdetails` text NOT NULL,
  PRIMARY KEY (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `paypal_transactions`;
CREATE TABLE IF NOT EXISTS `paypal_transactions` (
  `ecresponse_id` int(11) NOT NULL AUTO_INCREMENT,
  `orders_id` int(11) NOT NULL,
  `correlation_id` varchar(255) DEFAULT NULL,
  `ack` varchar(255) DEFAULT NULL,
  `timestamp` datetime DEFAULT NULL,
  `transaction` varchar(255) NOT NULL DEFAULT 'doexpresscheckoutpayment',
  `transaction_id` varchar(255) DEFAULT NULL,
  `parenttransaction_id` varchar(255) DEFAULT NULL,
  `transaction_type` varchar(255) DEFAULT NULL,
  `payment_type` varchar(255) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `grossamount` varchar(255) DEFAULT NULL,
  `feeamount` varchar(255) DEFAULT NULL,
  `settleamount` varchar(255) DEFAULT NULL,
  `taxamount` varchar(255) DEFAULT NULL,
  `exchange_rate` varchar(255) DEFAULT NULL,
  `paymentstatus` varchar(255) DEFAULT NULL,
  `payment_error` varchar(255) DEFAULT NULL,
  `expected_echeck_clear_date` varchar(255) DEFAULT NULL,
  `pending_reason` varchar(255) DEFAULT NULL,
  `reason_code` varchar(255) DEFAULT NULL,
  `hold_decision` varchar(255) DEFAULT NULL,
  `protection_eligibility` varchar(255) DEFAULT NULL,
  `protection_eligibility_type` varchar(255) DEFAULT NULL,
  `secure_merchant_account_id` varchar(255) DEFAULT NULL,
  `raw_response` text NOT NULL,
  `success_page_redirect_requested` tinyint(1) DEFAULT NULL,
  `errors` varchar(255) DEFAULT NULL,
  `version_build` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`ecresponse_id`),
  KEY `orders_id` (`orders_id`),
  KEY `transaction_id` (`transaction_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `paypal_refunds`;
CREATE TABLE IF NOT EXISTS `paypal_refunds` (
  `paypal_refunds_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `orders_id` int(10) unsigned NOT NULL,
  `refundtransactionid` varchar(32) NOT NULL,
  `netrefundvalue` decimal(10,4) NOT NULL,
  `netrefundcurrency` varchar(3) NOT NULL,
  `feerefundvalue` decimal(10,4) NOT NULL,
  `feerefundcurrency` varchar(3) NOT NULL,
  `grossrefundvalue` decimal(10,4) NOT NULL,
  `grossrefundcurrency` varchar(3) NOT NULL,
  `totalrefundedvalue` decimal(10,4) NOT NULL,
  `totalrefundedcurrency` varchar(3) NOT NULL,
  `refundinfostatus` varchar(255) NOT NULL,
  `refundinfopendingreason` varchar(255) NOT NULL,
  `receiptdata` varchar(255) NOT NULL,
  `msgsubid` varchar(255) NOT NULL,
  `timestamp` datetime NOT NULL,
  `ack` varchar(50) NOT NULL,
  `correlationid` varchar(50) NOT NULL,
  `errors` varchar(255) NOT NULL,
  `version` varchar(10) NOT NULL,
  `build` varchar(10) NOT NULL,
  PRIMARY KEY (`paypal_refunds_id`),
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_paypal`;
CREATE TABLE IF NOT EXISTS `orders_paypal` (
  `orders_id` int(10) unsigned NOT NULL,
  `correlation_id` varchar(255) DEFAULT NULL,
  `payer_id` varchar(255) DEFAULT NULL,
  `token` varchar(255) DEFAULT NULL,
  `paymentaction` varchar(20) DEFAULT NULL,
  PRIMARY KEY (`orders_id`),
  KEY `correlation_id` (`correlation_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `paypal_paylink`;
CREATE TABLE IF NOT EXISTS `paypal_paylink` (
  `orders_id` int(10) unsigned NOT NULL,
  `paycode` varchar(32) NOT NULL,
  `amount` decimal(15,4) DEFAULT NULL,
  PRIMARY KEY (`orders_id`),
  KEY `paycode` (`paycode`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_shopgate_order`;
CREATE TABLE `orders_shopgate_order` (
  `shopgate_order_id` int(11) NOT NULL AUTO_INCREMENT,
  `orders_id` int(11) NOT NULL,
  `shopgate_order_number` bigint(20) NOT NULL,
  `last_response` text NOT NULL,
  `modified` datetime DEFAULT NULL,
  `created` datetime DEFAULT NULL,
  PRIMARY KEY (`shopgate_order_id`),
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `personal_offers_by_customers_status_`;
CREATE TABLE `personal_offers_by_customers_status_` (
  `price_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `quantity` decimal(15,4) default NULL,
  `personal_offer` decimal(15,4) default NULL,
  PRIMARY KEY  (`price_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products`;
CREATE TABLE `products` (
  `products_id` int(11) NOT NULL auto_increment,
  `products_ean` varchar(128) default NULL,
  `products_quantity` decimal(15,4) NOT NULL default '0.0000',
  `products_shippingtime` int(4) NOT NULL default '0',
  `products_model` varchar(64) default NULL,
  `group_permission_0` tinyint(1) NOT NULL default '0',
  `group_permission_1` tinyint(1) NOT NULL default '0',
  `group_permission_2` tinyint(1) NOT NULL default '0',
  `group_permission_3` tinyint(1) NOT NULL default '0',
  `products_sort` int(4) NOT NULL default '0',
  `products_image` varchar(254) default NULL,
  `products_price` decimal(15,4) NOT NULL default '0.0000',
  `products_discount_allowed` decimal(5,2) NOT NULL default '0.00',
  `products_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `products_last_modified` datetime default NULL,
  `products_date_available` datetime default NULL,
  `products_weight` decimal(15,4) NOT NULL default '0.00',
  `products_status` tinyint(1) NOT NULL default '0',
  `products_tax_class_id` int(11) NOT NULL default '0',
  `product_template` varchar(64) default NULL,
  `options_template` varchar(64) default NULL,
  `manufacturers_id` int(11) default NULL,
  `products_ordered` decimal(15,4) NOT NULL default '0.0000',
  `products_fsk18` int(1) NOT NULL default '0',
  `products_vpe` int(11) NOT NULL default '0',
  `products_vpe_status` int(1) NOT NULL default '0',
  `products_vpe_value` decimal(15,4) NOT NULL default '0.0000',
  `products_startpage` int(1) NOT NULL default '0',
  `products_startpage_sort` int(4) NOT NULL default '0',
  `group_ids` varchar(5) NOT NULL default '',
  `nc_ultra_shipping_costs` decimal(15,4) NOT NULL default '0.00',
  `gm_show_date_added` int(1) unsigned NOT NULL default '0',
  `gm_show_price_offer` int(1) unsigned NOT NULL default '0',
  `gm_show_weight` int(1) NOT NULL,
  `gm_price_status` int(10) unsigned NOT NULL default '0',
  `gm_min_order` decimal(15,4) NOT NULL default '1.0000',
  `gm_graduated_qty` decimal(15,4) NOT NULL default '1.0000',
  `gm_options_template` varchar(64) default NULL,
  `gm_priority` varchar(3) NOT NULL default '0.5',
  `gm_changefreq` varchar(255) NOT NULL default 'weekly',
  `gm_show_qty_info` int(1) unsigned NOT NULL default '0',
  `gm_sitemap_entry` int(1) NOT NULL default '1',
  `products_image_w` int(11) NOT NULL,
  `products_image_h` int(11) NOT NULL,
  `gm_show_image` int(1) unsigned NOT NULL default '1',
  `properties_dropdown_mode` varchar(30) NOT NULL,
  `properties_show_price` varchar(10) NOT NULL,
  `use_properties_combis_weight` tinyint(1) NOT NULL,
  `use_properties_combis_quantity` tinyint(1) NOT NULL ,
  `use_properties_combis_shipping_time` tinyint(1) NOT NULL,
  `product_type` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY  (`products_id`),
  KEY `idx_products_date_added` (`products_date_added`),
  KEY `products_id` (`products_id`,`products_status`,`products_date_added`),
  KEY `products_status` (`products_status`,`products_id`,`products_date_added`),
  KEY `products_status_2` (`products_status`,`products_id`,`products_price`),
  KEY `products_status_3` (`products_status`,`products_ordered`,`products_id`),
  KEY `products_status_4` (`products_status`,`products_model`,`products_id`),
  KEY `products_id_2` (`products_id`,`products_startpage`,`products_status`,`products_startpage_sort`),
  KEY `products_date_available` (`products_date_available`,`products_id`),
  KEY `products_quantity` (`products_quantity`),
  KEY `products_sort` (`products_sort`),
  KEY `products_tax_class_id` (`products_tax_class_id`),
  KEY `manufacturers_id` (`manufacturers_id`),
  KEY `products_model` (`products_model`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_attributes`;
CREATE TABLE `products_attributes` (
  `products_attributes_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `options_id` int(11) NOT NULL default '0',
  `options_values_id` int(11) NOT NULL default '0',
  `options_values_price` decimal(15,4) NOT NULL default '0.0000',
  `price_prefix` char(1) NOT NULL default '',
  `attributes_model` varchar(64) default NULL,
  `attributes_stock` decimal(15,4) default NULL,
  `options_values_weight` decimal(15,4) NOT NULL default '0.0000',
  `weight_prefix` char(1) NOT NULL default '',
  `sortorder` int(11) default NULL,
  `products_vpe_id` int(11) UNSIGNED default '0' NOT NULL ,
  `gm_vpe_value` decimal(15,4 ) default '0.0000' NOT NULL ,
  `gm_ean` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`products_attributes_id`),
  KEY `products_id` (`products_id`,`options_id`,`options_values_id`,`sortorder`),
  KEY `options_values_id` (`options_values_id`),
  KEY `sortorder` (`sortorder`),
  FULLTEXT KEY `attributes_model` (`attributes_model`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_attributes_download`;
CREATE TABLE `products_attributes_download` (
  `products_attributes_id` int(11) NOT NULL default '0',
  `products_attributes_filename` varchar(255) NOT NULL default '',
  `products_attributes_maxdays` int(2) default '0',
  `products_attributes_maxcount` int(2) default '0',
  PRIMARY KEY  (`products_attributes_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_content`;
CREATE TABLE `products_content` (
  `content_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `group_ids` text,
  `content_name` varchar(32) NOT NULL default '',
  `content_file` varchar(64) NOT NULL default '',
  `content_link` text NOT NULL,
  `languages_id` int(11) NOT NULL default '0',
  `content_read` int(11) NOT NULL default '0',
  `file_comment` text NOT NULL,
  PRIMARY KEY  (`content_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_description`;
CREATE TABLE `products_description` (
  `products_id` int(11) NOT NULL auto_increment,
  `language_id` int(11) NOT NULL default '1',
  `products_name` varchar(255) NOT NULL default '',
  `products_description` text,
  `products_short_description` text,
  `products_keywords` varchar(255) default NULL,
  `products_meta_title` text NOT NULL,
  `products_meta_description` text NOT NULL,
  `products_meta_keywords` text NOT NULL,
  `products_url` varchar(255) default NULL,
  `products_viewed` int(5) default '0',
  `gm_alt_text` varchar(255) default NULL,
  `gm_url_keywords` varchar(255) NOT NULL,
  `checkout_information` text NOT NULL,
  PRIMARY KEY  (`products_id`,`language_id`),
  KEY `products_name` (`products_name`),
  KEY `language_id` (`language_id`,`products_keywords`),
  KEY `language_id_2` (`language_id`,`products_name`),
  KEY `seo_boost_index` (`gm_url_keywords`,`products_id`,`language_id`),
  FULLTEXT KEY `products_name_2` (`products_name`),
  FULLTEXT KEY `products_description` (`products_description`),
  FULLTEXT KEY `products_short_description` (`products_short_description`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_graduated_prices`;
CREATE TABLE `products_graduated_prices` (
  `products_id` int(11) NOT NULL default '0',
  `quantity` int(11) NOT NULL default '0',
  `unitprice` decimal(15,4) NOT NULL default '0.0000',
  KEY `products_id` (`products_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_hermesoptions`;
CREATE TABLE `products_hermesoptions` (
  `products_id` int(11) NOT NULL,
  `min_pclass` enum('XS','S','M','L','XL','XXL') NOT NULL,
  PRIMARY KEY (`products_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_images`;
CREATE TABLE `products_images` (
  `image_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `image_nr` smallint(6) NOT NULL default '0',
  `image_name` varchar(254) NOT NULL default '',
  `gm_show_image` int(1) unsigned NOT NULL default '1',
  PRIMARY KEY  (`image_id`),
  UNIQUE KEY `products_id` (`products_id`,`image_nr`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_notifications`;
CREATE TABLE `products_notifications` (
  `products_id` int(11) NOT NULL default '0',
  `customers_id` int(11) NOT NULL default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`products_id`,`customers_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_options`;
CREATE TABLE `products_options` (
  `products_options_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `products_options_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`products_options_id`,`language_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_options_values`;
CREATE TABLE `products_options_values` (
  `products_options_values_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `products_options_values_name` varchar(255) NOT NULL default '',
  `gm_filename` varchar(255) NOT NULL,
  PRIMARY KEY  (`products_options_values_id`,`language_id`),
  KEY `products_options_values_name` (`products_options_values_name`,`language_id`),
  FULLTEXT KEY `products_options_values_name_2` (`products_options_values_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_options_values_to_products_options`;
CREATE TABLE `products_options_values_to_products_options` (
  `products_options_values_to_products_options_id` int(11) NOT NULL auto_increment,
  `products_options_id` int(11) NOT NULL default '0',
  `products_options_values_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`products_options_values_to_products_options_id`),
  KEY `products_options_id` (`products_options_id`),
  KEY `products_options_values_id` (`products_options_values_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_to_categories`;
CREATE TABLE `products_to_categories` (
  `products_id` int(11) NOT NULL default '0',
  `categories_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`products_id`,`categories_id`),
  KEY `categories_id` (`categories_id`,`products_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `product_types`;
CREATE TABLE `product_types` (
 `product_type_id` int(11) NOT NULL AUTO_INCREMENT,
 PRIMARY KEY (`product_type_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `product_type_descriptions`;
CREATE TABLE `product_type_descriptions` (
 `product_type_id` int(11) NOT NULL,
 `language_id` int(11) NOT NULL,
 `name` varchar(255) NOT NULL,
 PRIMARY KEY (`product_type_id`,`language_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_vpe`;
CREATE TABLE `products_vpe` (
  `products_vpe_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '0',
  `products_vpe_name` varchar(32) NOT NULL default '',
  PRIMARY KEY (`products_vpe_id`,`language_id`),
  KEY `language_id` (`language_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_xsell`;
CREATE TABLE `products_xsell` (
  `ID` int(10) NOT NULL auto_increment,
  `products_id` int(10) unsigned NOT NULL default '1',
  `products_xsell_grp_name_id` int(10) unsigned NOT NULL default '1',
  `xsell_id` int(10) unsigned NOT NULL default '1',
  `sort_order` int(10) unsigned NOT NULL default '1',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `products_id` (`products_id`, `xsell_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_xsell_grp_name`;
CREATE TABLE `products_xsell_grp_name` (
  `products_xsell_grp_name_id` int(10) NOT NULL default '0',
  `xsell_sort_order` int(10) NOT NULL default '0',
  `language_id` smallint(6) NOT NULL default '0',
  `groupname` varchar(255) NOT NULL default ''
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_google_categories`;
CREATE TABLE `products_google_categories` (
  `products_google_categories_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) default NULL,
  `google_category` text,
  PRIMARY KEY  (`products_google_categories_id`),
  KEY `products_id` (`products_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_item_codes`;
CREATE TABLE `products_item_codes` (
  `products_id` int(11) NOT NULL,
  `code_isbn` varchar(128) default NULL,
  `code_upc` varchar(128) default NULL,
  `code_mpn` varchar(128) default NULL,
  `code_jan` varchar(128) default NULL,
  `google_export_condition` varchar(64) NOT NULL default 'neu',
  `google_export_availability_id` int(10) unsigned NOT NULL,
  `brand_name` varchar(128) NOT NULL,
  `identifier_exists` TINYINT(1) NOT NULL DEFAULT '1',
  `gender` ENUM( '', 'Herren', 'Damen', 'Unisex' ) NOT NULL DEFAULT '',
  `age_group` ENUM( '', 'Erwachsene', 'Kinder' ) NOT NULL DEFAULT '',
  `expiration_date` DATE NOT NULL,
  PRIMARY KEY  (`products_id`),
  KEY `google_export_condition` (`google_export_condition`),
  KEY `brand_name` (`brand_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `protectedshops`;
CREATE TABLE `protectedshops` (
  `ps_id` int(11) NOT NULL AUTO_INCREMENT,
  `document_name` varchar(255) NOT NULL,
  `document_date` datetime NOT NULL,
  `md5` varchar(32) NOT NULL,
  `document_type` varchar(32) NOT NULL,
  `content` mediumtext NOT NULL,
  PRIMARY KEY (`ps_id`),
  KEY `document_name` (`document_name`,`document_date`,`document_type`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `shipping_status_to_google_availability`;
CREATE TABLE `shipping_status_to_google_availability` (
  `shipping_status_id` int(10) unsigned NOT NULL,
  `google_export_availability_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`shipping_status_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `google_export_availability`;
CREATE TABLE `google_export_availability` (
  `google_export_availability_id` int(10) unsigned NOT NULL auto_increment,
  `availability` varchar(64) NOT NULL,
  PRIMARY KEY  (`google_export_availability_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `reviews`;
CREATE TABLE `reviews` (
  `reviews_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `customers_id` int(11) default NULL,
  `customers_name` varchar(64) NOT NULL default '',
  `reviews_rating` int(1) default NULL,
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  `reviews_read` int(5) NOT NULL default '0',
  PRIMARY KEY  (`reviews_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `reviews_description`;
CREATE TABLE `reviews_description` (
  `reviews_id` int(11) NOT NULL default '0',
  `languages_id` int(11) NOT NULL default '0',
  `reviews_text` text NOT NULL,
  PRIMARY KEY  (`reviews_id`,`languages_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `sessions`;
CREATE TABLE `sessions` (
  `sesskey` varchar(32) NOT NULL default '',
  `expiry` int(11) unsigned NOT NULL default '0',
  `value` text NOT NULL,
  PRIMARY KEY  (`sesskey`),
  KEY `sesskey` (`sesskey`,`expiry`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `shipping_and_payment_matrix`;
CREATE TABLE `shipping_and_payment_matrix` (
 `country_code` varchar(255) NOT NULL,
 `language_id` int(11) NOT NULL,
 `shipping_info` text NOT NULL,
 `payment_info` text NOT NULL,
 `shipping_time` text NOT NULL,
 PRIMARY KEY (`country_code`,`language_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `shipping_status`;
CREATE TABLE `shipping_status` (
  `shipping_status_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `shipping_status_name` varchar(32) NOT NULL default '',
  `shipping_status_image` varchar(32) NOT NULL default '',
  `number_of_days` INT(10) NOT NULL default '0',
  `shipping_quantity` DECIMAL(15,4) NULL DEFAULT NULL,
  `info_link_active` tinyint(4) NOT NULL DEFAULT '1',
  PRIMARY KEY  (`shipping_status_id`,`language_id`),
  KEY `idx_shipping_status_name` (`shipping_status_name`),
  KEY `language_id` (`language_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `specials`;
CREATE TABLE `specials` (
  `specials_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `specials_quantity` decimal(15,4) NOT NULL default '0.0000',
  `specials_new_products_price` decimal(15,4) NOT NULL default '0.0000',
  `specials_date_added` datetime default NULL,
  `specials_last_modified` datetime default NULL,
  `expires_date` datetime default NULL,
  `date_status_change` datetime default NULL,
  `status` int(1) NOT NULL default '1',
  PRIMARY KEY  (`specials_id`),
  UNIQUE KEY `products_id2` (`products_id`),
  KEY `products_id` (`products_id`,`status`,`specials_date_added`),
  KEY `status` (`status`,`expires_date`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `tax_class`;
CREATE TABLE `tax_class` (
  `tax_class_id` int(11) NOT NULL auto_increment,
  `tax_class_title` varchar(32) NOT NULL default '',
  `tax_class_description` varchar(255) NOT NULL default '',
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`tax_class_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `tax_rates`;
CREATE TABLE `tax_rates` (
  `tax_rates_id` int(11) NOT NULL auto_increment,
  `tax_zone_id` int(11) NOT NULL default '0',
  `tax_class_id` int(11) NOT NULL default '0',
  `tax_priority` int(5) default '1',
  `tax_rate` decimal(7,4) NOT NULL default '0.0000',
  `tax_description` varchar(255) NOT NULL default '',
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`tax_rates_id`),
  KEY `tax_zone_id` (`tax_zone_id`),
  KEY `tax_class_id` (`tax_class_id`,`tax_priority`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `whos_online`;
CREATE TABLE `whos_online` (
  `customer_id` int(11) default NULL,
  `full_name` varchar(64) NOT NULL default '',
  `session_id` varchar(128) NOT NULL default '',
  `ip_address` varchar(15) NOT NULL default '',
  `time_entry` varchar(14) NOT NULL default '',
  `time_last_click` varchar(14) NOT NULL default '',
  `last_page_url` varchar(255) NOT NULL default '',
  KEY `customer_id` (`customer_id`),
  KEY `session_id` (`session_id`),
  KEY `time_last_click` (`time_last_click`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `withdrawals`;
CREATE TABLE `withdrawals` (
 `withdrawal_id` int(11) NOT NULL AUTO_INCREMENT,
 `order_id` int(11) NOT NULL,
 `customer_id` int(11) NOT NULL,
 `customer_gender` varchar(16) NOT NULL,
 `customer_firstname` varchar(255) NOT NULL,
 `customer_lastname` varchar(255) NOT NULL,
 `customer_street_address` varchar(255) NOT NULL,
 `customer_postcode` varchar(255) NOT NULL,
 `customer_city` varchar(255) NOT NULL,
 `customer_country` varchar(255) NOT NULL,
 `customer_email` varchar(255) NOT NULL,
 `order_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
 `delivery_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
 `withdrawal_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
 `withdrawal_content` text NOT NULL,
 `date_created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
 `created_by_admin` tinyint(1) NOT NULL DEFAULT '0',
 PRIMARY KEY (`withdrawal_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `zones`;
CREATE TABLE `zones` (
  `zone_id` int(11) NOT NULL auto_increment,
  `zone_country_id` int(11) NOT NULL default '0',
  `zone_code` varchar(32) NOT NULL default '',
  `zone_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`zone_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `zones_to_geo_zones`;
CREATE TABLE `zones_to_geo_zones` (
  `association_id` int(11) NOT NULL auto_increment,
  `zone_country_id` int(11) NOT NULL default '0',
  `zone_id` int(11) default NULL,
  `geo_zone_id` int(11) default NULL,
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`association_id`),
  KEY `zone_id` (`zone_id`),
  KEY `geo_zone_id` (`geo_zone_id`, `zone_country_id`),
  KEY `zone_country_id` (`zone_country_id`,`zone_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `gm_gprint_cart_elements`;
CREATE TABLE `gm_gprint_cart_elements` (
  `gm_gprint_cart_elements_id` int(10) unsigned NOT NULL auto_increment,
  `gm_gprint_elements_id` int(10) unsigned default NULL,
  `products_id` tinytext,
  `customers_id` int(10) unsigned default NULL,
  `elements_value` text,
  `gm_gprint_uploads_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`gm_gprint_cart_elements_id`),
  UNIQUE KEY `gm_gprint_uploads_id` (`gm_gprint_uploads_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_elements`;
CREATE TABLE `gm_gprint_elements` (
  `gm_gprint_elements_id` int(10) unsigned NOT NULL auto_increment,
  `gm_gprint_elements_groups_id` int(10) unsigned NOT NULL,
  `gm_gprint_surfaces_id` int(10) unsigned NOT NULL,
  `position_x` int(10) NOT NULL default '0',
  `position_y` int(10) NOT NULL default '0',
  `height` int(10) unsigned NOT NULL default '0',
  `width` int(10) unsigned NOT NULL default '0',
  `z_index` int(10) NOT NULL default '0',
  `max_characters` int(10) NOT NULL default '0',
  `allowed_extensions` VARCHAR( 255 ) NOT NULL default '',
  `show_name` tinyint(1) unsigned NOT NULL default '0',
  `minimum_filesize` decimal(7,4) NOT NULL default '0.0000',
  `maximum_filesize` decimal(7,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`gm_gprint_elements_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_elements_groups`;
CREATE TABLE `gm_gprint_elements_groups` (
  `gm_gprint_elements_groups_id` int(10) unsigned NOT NULL auto_increment,
  `group_type` varchar(255) default NULL,
  `group_name` varchar(255) default NULL,
  PRIMARY KEY  (`gm_gprint_elements_groups_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_elements_values`;
CREATE TABLE `gm_gprint_elements_values` (
  `gm_gprint_elements_values_id` int(10) unsigned NOT NULL auto_increment,
  `languages_id` int(10) unsigned NOT NULL,
  `gm_gprint_elements_groups_id` int(10) unsigned NOT NULL,
  `name` varchar(255) default NULL,
  `elements_value` text,
  PRIMARY KEY  (`gm_gprint_elements_values_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_orders_elements`;
CREATE TABLE `gm_gprint_orders_elements` (
  `gm_gprint_orders_elements_id` int(10) unsigned NOT NULL auto_increment,
  `gm_gprint_orders_surfaces_id` int(10) unsigned NOT NULL,
  `position_x` int(10) NOT NULL default '0',
  `position_y` int(10) NOT NULL default '0',
  `height` int(10) unsigned NOT NULL default '0',
  `width` int(10) unsigned NOT NULL default '0',
  `z_index` int(10) NOT NULL default '0',
  `show_name` tinyint(1) unsigned NOT NULL default '0',
  `group_type` varchar(255) default NULL,
  `name` varchar(255) default NULL,
  `elements_value` text,
  `gm_gprint_uploads_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`gm_gprint_orders_elements_id`),
  KEY `gm_gprint_uploads_id` (`gm_gprint_uploads_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_orders_surfaces`;
CREATE TABLE `gm_gprint_orders_surfaces` (
  `gm_gprint_orders_surfaces_id` int(10) unsigned NOT NULL auto_increment,
  `gm_gprint_orders_surfaces_groups_id` int(10) unsigned NOT NULL,
  `name` varchar(255) default NULL,
  `width` int(10) unsigned NOT NULL,
  `height` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`gm_gprint_orders_surfaces_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_orders_surfaces_groups`;
CREATE TABLE `gm_gprint_orders_surfaces_groups` (
  `gm_gprint_orders_surfaces_groups_id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `orders_products_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`gm_gprint_orders_surfaces_groups_id`),
  UNIQUE KEY `orders_products_id` (`orders_products_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_surfaces`;
CREATE TABLE `gm_gprint_surfaces` (
  `gm_gprint_surfaces_id` int(10) unsigned NOT NULL auto_increment,
  `gm_gprint_surfaces_groups_id` int(10) unsigned NOT NULL,
  `width` int(10) unsigned NOT NULL,
  `height` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`gm_gprint_surfaces_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_surfaces_description`;
CREATE TABLE `gm_gprint_surfaces_description` (
  `gm_gprint_surfaces_id` int(10) unsigned NOT NULL,
  `languages_id` int(10) unsigned NOT NULL,
  `name` varchar(255) default NULL,
  PRIMARY KEY  (`gm_gprint_surfaces_id`,`languages_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_surfaces_groups`;
CREATE TABLE `gm_gprint_surfaces_groups` (
  `gm_gprint_surfaces_groups_id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  PRIMARY KEY  (`gm_gprint_surfaces_groups_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_surfaces_groups_to_products`;
CREATE TABLE `gm_gprint_surfaces_groups_to_products` (
  `gm_gprint_surfaces_groups_id` int(10) unsigned NOT NULL,
  `products_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`gm_gprint_surfaces_groups_id`,`products_id`),
  UNIQUE KEY `products_id` (`products_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_uploads`;
CREATE TABLE `gm_gprint_uploads` (
  `gm_gprint_uploads_id` int(11) NOT NULL auto_increment,
  `datetime` datetime NOT NULL,
  `customers_id` int(10) unsigned default NULL,
  `filename` varchar(255) NOT NULL,
  `encrypted_filename` varchar(255) NOT NULL,
  `download_key` varchar(32) NOT NULL,
  `ip_hash` varchar(32) NOT NULL,
  PRIMARY KEY  (`gm_gprint_uploads_id`),
  UNIQUE KEY `encrypted_filename` (`encrypted_filename`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_wishlist_elements`;
CREATE TABLE `gm_gprint_wishlist_elements` (
  `gm_gprint_wishlist_elements_id` int(10) unsigned NOT NULL auto_increment,
  `gm_gprint_elements_id` int(10) unsigned default NULL,
  `products_id` tinytext,
  `customers_id` int(10) unsigned default NULL,
  `elements_value` text,
  `gm_gprint_uploads_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`gm_gprint_wishlist_elements_id`),
  UNIQUE KEY `gm_gprint_uploads_id` (`gm_gprint_uploads_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_boxes_area`;
CREATE TABLE IF NOT EXISTS `gm_boxes_area` (
  `boxes_area_id` int(10) unsigned NOT NULL auto_increment,
  `boxes_id` int(11) NOT NULL,
  `area` varchar(32) NOT NULL,
  PRIMARY KEY  (`boxes_area_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_products_quantity_units` ;
CREATE TABLE `orders_products_quantity_units` (
`orders_products_id` INT NOT NULL ,
`quantity_unit_id` INT NOT NULL ,
`unit_name` VARCHAR( 45 ) NOT NULL ,
PRIMARY KEY ( `orders_products_id` )
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `quantity_unit` ;
CREATE  TABLE IF NOT EXISTS `quantity_unit` (
  `quantity_unit_id` INT NOT NULL AUTO_INCREMENT ,
  PRIMARY KEY (`quantity_unit_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `quantity_unit_description` ;
CREATE  TABLE IF NOT EXISTS `quantity_unit_description` (
  `quantity_unit_id` INT NOT NULL ,
  `language_id` INT NOT NULL ,
  `unit_name` VARCHAR(45) NOT NULL ,
  PRIMARY KEY (`quantity_unit_id`, `language_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_quantity_unit` ;
CREATE  TABLE IF NOT EXISTS `products_quantity_unit` (
  `products_id` INT NOT NULL ,
  `quantity_unit_id` INT NOT NULL ,
  PRIMARY KEY (`products_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `slider_set` ;
CREATE  TABLE IF NOT EXISTS `slider_set` (
  `slider_set_id` INT NOT NULL AUTO_INCREMENT ,
  `set_name` VARCHAR(255) NULL ,
  `slider_speed` INT NULL ,
  `width` int(10) unsigned NOT NULL default '760',
  `height` int(10) unsigned NOT NULL default '300',
  PRIMARY KEY (`slider_set_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `slider_image` ;
CREATE  TABLE IF NOT EXISTS `slider_image` (
  `slider_image_id` INT NOT NULL AUTO_INCREMENT ,
  `slider_set_id` INT NOT NULL ,
  `sort_order` INT NULL ,
  `image_file` VARCHAR(45) NULL ,
  `image_preview_file` VARCHAR(45) NULL ,
  `link_url` VARCHAR(255) NULL ,
  `link_window_target` VARCHAR(45) NULL ,
  PRIMARY KEY (`slider_image_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `slider_image_area`;
CREATE TABLE IF NOT EXISTS `slider_image_area` (
  `slider_image_area_id` int(11) NOT NULL auto_increment,
  `slider_image_id` int(11) NOT NULL,
  `shape` varchar(16) default NULL,
  `coords` varchar(255) default NULL,
  `title` varchar(255) default NULL,
  `link_url` varchar(255) default NULL,
  `link_target` varchar(16) default NULL,
  `flyover_content` TEXT default NULL,
  PRIMARY KEY  (`slider_image_area_id`),
  KEY `fk_slider_image_maparea_slider_image1` (`slider_image_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `category_slider_set` ;
CREATE  TABLE IF NOT EXISTS `category_slider_set` (
  `category_id` INT NOT NULL ,
  `category_slider_set_id` INT NOT NULL ,
  PRIMARY KEY (`category_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `slider_image_description` ;
CREATE  TABLE IF NOT EXISTS `slider_image_description` (
  `slider_image_id` INT NOT NULL ,
  `language_id` INT NOT NULL ,
  `image_title` VARCHAR(255) NULL ,
  `image_alt_text` VARCHAR(255) NULL ,
  PRIMARY KEY (`language_id`, `slider_image_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `content_slider_set` ;
CREATE  TABLE IF NOT EXISTS`content_slider_set` (
  `content_slider_set_id` INT NOT NULL AUTO_INCREMENT ,
  `slider_set_id` INT NOT NULL ,
  PRIMARY KEY (`content_slider_set_id`) ,
  INDEX `fk_content_slider_set_slider_set1` (`slider_set_id` ASC)
)
ENGINE = MyISAM;

DROP TABLE IF EXISTS `products_slider_set` ;
CREATE  TABLE IF NOT EXISTS`products_slider_set` (
  `products_slider_set_id` INT NOT NULL AUTO_INCREMENT ,
  `slider_set_id` INT NOT NULL ,
  PRIMARY KEY (`products_slider_set_id`) ,
  INDEX `fk_products_slider_set_slider_set1` (`slider_set_id` ASC)
)
ENGINE = MyISAM;

DROP TABLE IF EXISTS `orders_products_properties`;
CREATE TABLE IF NOT EXISTS `orders_products_properties` (
  `orders_products_properties_id` int(10) unsigned NOT NULL auto_increment,
  `orders_products_id` int(10) unsigned default NULL,
  `products_properties_combis_id` int(10) unsigned default NULL,
  `properties_name` varchar(255) NOT NULL,
  `values_name` varchar(255) NOT NULL,
  `properties_price_type` varchar(8) NOT NULL,
  `properties_price` decimal(16,4) NOT NULL,
  PRIMARY KEY  (`orders_products_properties_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_properties_admin_select`;
CREATE TABLE  `products_properties_admin_select` (
  `products_properties_admin_select_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL,
  `properties_id` int(11) NOT NULL,
  `properties_values_id` int(11) NOT NULL,
  PRIMARY KEY  (`products_properties_admin_select_id`),
  UNIQUE KEY `unique_value_assignment` (`products_id`,`properties_values_id`),
  KEY `products_id` (`products_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_properties_combis`;
CREATE TABLE `products_properties_combis` (
  `products_properties_combis_id` int(10) unsigned NOT NULL auto_increment,
  `products_id` int(10) unsigned NOT NULL,
  `sort_order` int(10) unsigned NOT NULL,
  `combi_model` varchar(64) NOT NULL,
  `combi_ean` VARCHAR(20) NOT NULL,
  `combi_quantity` decimal(15,4) NOT NULL default '0.0000',
  `combi_shipping_status_id` int(11) NOT NULL,
  `combi_weight` decimal(15,4) NOT NULL,
  `combi_price_type` ENUM( 'calc', 'fix' ) NOT NULL,
  `combi_price` decimal(15,4) NOT NULL,
  `combi_image` varchar(255) NOT NULL,
  `products_vpe_id` int(11) NOT NULL,
  `vpe_value` decimal(15,4) NOT NULL,
  PRIMARY KEY  (`products_properties_combis_id`),
  KEY `products_properties_combis_id` (`products_properties_combis_id`,`products_id`,`sort_order`),
  KEY `products_id` (`products_id`,`sort_order`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_properties_combis_defaults`;
CREATE TABLE `products_properties_combis_defaults` (
  `products_properties_combis_defaults_id` int(11) unsigned NOT NULL auto_increment,
  `products_id` int(10) unsigned NOT NULL,
  `combi_ean` VARCHAR(20) NOT NULL,
  `combi_quantity` decimal(15,4) NOT NULL default '0.0000',
  `combi_shipping_status_id` int(11) NOT NULL,
  `combi_weight` decimal(15,4) NOT NULL,
  `combi_price_type` ENUM( 'calc', 'fix' ) NOT NULL,
  `combi_price` decimal(15,4) NOT NULL,
  `products_vpe_id` int(11) NOT NULL,
  `vpe_value` decimal(15,4) NOT NULL,
  PRIMARY KEY  (`products_properties_combis_defaults_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_properties_combis_values`;
CREATE TABLE `products_properties_combis_values` (
  `products_properties_combis_values_id` int(10) unsigned NOT NULL auto_increment,
  `products_properties_combis_id` int(10) unsigned NOT NULL,
  `properties_values_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`products_properties_combis_values_id`),
  UNIQUE KEY `unique_value_assignment` (`products_properties_combis_id`,`properties_values_id`),
  KEY `products_properties_combis_values_id` (`products_properties_combis_values_id`,`products_properties_combis_id`,`properties_values_id`),
  KEY `products_properties_combis_id` (`products_properties_combis_id`,`properties_values_id`),
  KEY `properties_values_id` (`properties_values_id`,`products_properties_combis_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_properties_index`;
CREATE TABLE IF NOT EXISTS `products_properties_index` (
  `products_id` int(10) NOT NULL,
  `language_id` int(10) NOT NULL,
  `properties_id` int(10) NOT NULL,
  `products_properties_combis_id` int(10) default '0',
  `properties_values_id` int(10) default NULL,
  `properties_name` varchar(255) default NULL,
  `properties_admin_name` varchar(255) NOT NULL,
  `properties_sort_order` int(10) NOT NULL,
  `values_name` varchar(255) default NULL,
  `values_price` decimal(9,4) NOT NULL,
  `value_sort_order` int(10) default NULL,
  PRIMARY KEY (`products_properties_combis_id`,`language_id`,`properties_values_id`),
  KEY `products_id` (`products_id`,`language_id`,`properties_id`),
  KEY `products_id_2` (`products_id`,`language_id`,`properties_values_id`,`products_properties_combis_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `properties`;
CREATE TABLE `properties` (
  `properties_id` int(10) unsigned NOT NULL auto_increment,
  `sort_order` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`properties_id`),
  KEY `properties_id` (`properties_id`,`sort_order`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `properties_description`;
CREATE TABLE `properties_description` (
  `properties_description_id` int(10) unsigned NOT NULL auto_increment,
  `properties_id` int(10) unsigned NOT NULL,
  `language_id` int(10) unsigned NOT NULL,
  `properties_name` varchar(255) NOT NULL,
  `properties_admin_name` varchar(255) NOT NULL,
  PRIMARY KEY  (`properties_description_id`),
  KEY `properties_id` (`properties_id`,`language_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `properties_values`;
CREATE TABLE `properties_values` (
  `properties_values_id` int(10) unsigned NOT NULL auto_increment,
  `properties_id` int(10) unsigned NOT NULL,
  `sort_order` int(10) unsigned NOT NULL,
  `value_model` varchar(64) NOT NULL,
  `value_price` decimal(9,4) NOT NULL,
  PRIMARY KEY  (`properties_values_id`),
  KEY `properties_values_id` (`properties_values_id`,`properties_id`,`sort_order`),
  KEY `properties_id` (`properties_id`,`sort_order`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `properties_values_description`;
CREATE TABLE `properties_values_description` (
  `properties_values_description_id` int(10) unsigned NOT NULL auto_increment,
  `properties_values_id` int(10) unsigned NOT NULL,
  `language_id` int(10) unsigned NOT NULL,
  `values_name` varchar(255) NOT NULL,
  PRIMARY KEY  (`properties_values_description_id`),
  UNIQUE KEY `unique_description` (`properties_values_id`,`language_id`),
  KEY `properties_values_description_id` (`properties_values_description_id`,`properties_values_id`,`language_id`),
  KEY `properties_values_id` (`properties_values_id`,`language_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `categories_filter`;
CREATE TABLE IF NOT EXISTS `categories_filter` (
  `categories_id` int(11) NOT NULL,
  `feature_id` int(11) NOT NULL,
  `sort_order` int(11) default NULL,
  `selection_preview_mode` varchar(45) default NULL,
  `selection_template` varchar(45) default NULL,
  `value_conjunction` INT( 1  ) UNSIGNED NOT NULL DEFAULT '1',
  PRIMARY KEY  (`categories_id`,`feature_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `feature`;
CREATE TABLE IF NOT EXISTS `feature` (
  `feature_id` int(11) NOT NULL auto_increment,
  PRIMARY KEY  (`feature_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `feature_description`;
CREATE TABLE IF NOT EXISTS `feature_description` (
  `feature_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL,
  `feature_name` varchar(45) default NULL,
  `feature_admin_name` VARCHAR(45) NOT NULL,
  PRIMARY KEY  (`feature_id`,`language_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `feature_index`;
CREATE TABLE IF NOT EXISTS `feature_index` (
  `feature_set_id` int(11) unsigned NOT NULL,
  `date_created` datetime default NULL,
  `feature_value_index` text,
  PRIMARY KEY  (`feature_set_id`),
  FULLTEXT KEY `feature_value_index` (`feature_value_index`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `categories_index`;
CREATE TABLE IF NOT EXISTS `categories_index` (
  `products_id` int(11) NOT NULL,
  `categories_index` text NOT NULL,
  PRIMARY KEY (`products_id`),
  FULLTEXT KEY `categories_index` (`categories_index`)
) ENGINE = MyISAM ;

DROP TABLE IF EXISTS `feature_value`;
CREATE TABLE IF NOT EXISTS `feature_value` (
  `feature_value_id` int(11) NOT NULL auto_increment,
  `feature_id` int(11) default NULL,
  `sort_order` int(11) default NULL,
  PRIMARY KEY  (`feature_value_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `feature_value_description`;
CREATE TABLE IF NOT EXISTS `feature_value_description` (
  `feature_value_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL,
  `feature_value_text` varchar(45) default NULL,
  PRIMARY KEY  (`feature_value_id`,`language_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `feature_set`;
CREATE TABLE IF NOT EXISTS `feature_set` (
  `feature_set_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`feature_set_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `feature_set_to_products`;
CREATE TABLE IF NOT EXISTS `feature_set_to_products` (
`feature_set_id` int(11) UNSIGNED NOT NULL,
`products_id` int(11) UNSIGNED NOT NULL,
  KEY `products_id` (`products_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `feature_set_values`;
CREATE TABLE IF NOT EXISTS `feature_set_values` (
  `feature_set_id` int(11) unsigned NOT NULL,
  `feature_value_id` int(11) unsigned NOT NULL,
  PRIMARY KEY (`feature_set_id`,`feature_value_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `brickfox_export`;
CREATE TABLE `brickfox_export` (
  `brickfox_export_id` int(11) NOT NULL auto_increment,
  `type` varchar(50) NOT NULL default '',
  `number_exported` int(11) NOT NULL default '0',
  `date_exported` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`brickfox_export_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `brickfox_orders`;
CREATE TABLE `brickfox_orders` (
  `brickfox_orders_id` INT(11) NOT NULL,
  `extern_orders_id` VARCHAR(255) NOT NULL,
  `intern_orders_id` INT(11) NOT NULL,
  PRIMARY KEY  (`brickfox_orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `brickfox_orders_lines`;
CREATE TABLE `brickfox_orders_lines` (
  `brickfox_orders_lines_id` INT(11) NOT NULL,
  `orders_products_id` INT(11) NOT NULL,
  PRIMARY KEY  (`brickfox_orders_lines_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `ekomi_order_information`;
CREATE TABLE `ekomi_order_information` (
  `orders_id` int(11) NOT NULL,
  `link` varchar(255) NOT NULL,
  `hash` varchar(255) NOT NULL,
  `date_sent` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `mf_config`;
CREATE TABLE `mf_config` (
  `config_key` varchar(255) NOT NULL,
  `config_value` varchar(255) NOT NULL,
  KEY `config_name` (`config_key`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `mf_claims`;
CREATE TABLE `mf_claims` (
  `orderId` int(10) unsigned NOT NULL,
  `fileNumber` int(10) unsigned NOT NULL,
  `firstname` VARCHAR(100) NOT NULL,
  `lastname` VARCHAR(100) NOT NULL,
  `transmissionDate` int(10) unsigned NOT NULL,
  `statusCode` smallint(5) unsigned NOT NULL,
  `statusText` text NOT NULL,
  `statusDetails` text NOT NULL,
  `lastChange` datetime NOT NULL,
  UNIQUE KEY `orderId` (`orderId`,`fileNumber`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `mf_errors`;
CREATE TABLE `mf_errors` (
  `errorId` smallint(5) unsigned NOT NULL auto_increment,
  `errorText` text NOT NULL,
  `customerId` int(10) unsigned NOT NULL,
  `date` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`errorId`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `mf_score_results`;
CREATE TABLE `mf_score_results` (
	`scoreId` smallint(5) unsigned NOT NULL auto_increment,
	`customerId` int(10) unsigned NOT NULL,
	`score` decimal(2,1) NOT NULL,
	`explanation` text NOT NULL,
	`lastCheck` int(10) unsigned NOT NULL,
	`negativeEntryList` text NOT NULL,
PRIMARY KEY  (`scoreId`),
UNIQUE KEY `customerId` (`customerId`)) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_iloxxdata`;
CREATE TABLE IF NOT EXISTS `orders_iloxxdata` (
	`orders_id` INT UNSIGNED NOT NULL ,
	`parcelnumber` VARCHAR(255) NULL DEFAULT NULL ,
	`service` VARCHAR(255) NOT NULL ,
	`weight` DECIMAL(15,4) NOT NULL DEFAULT '0',
	`shipdate` DATE NULL DEFAULT NULL ,
	PRIMARY KEY (`orders_id`),
	INDEX (`parcelnumber`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `sepa`;
CREATE TABLE `sepa` (
  `orders_id` int(11) NOT NULL,
  `sepa_owner` varchar(64) DEFAULT NULL,
  `sepa_iban` varchar(35) DEFAULT NULL,
  `sepa_bic` varchar(15) DEFAULT NULL,
  `sepa_bankname` varchar(255) DEFAULT NULL,
  `sepa_status` int(11) DEFAULT NULL,
  `sepa_prz` char(2) DEFAULT NULL,
  `sepa_fax` char(2) DEFAULT NULL,
  PRIMARY KEY (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `ts_certs`;
CREATE TABLE `ts_certs` (
  `tsid` varchar(33) NOT NULL,
  `language` varchar(2) NOT NULL,
  `state` enum('PRODUCTION','CANCELLED','DISABLED','INTEGRATION','TEST','INVALID_TS_ID') NOT NULL,
  `type` enum('CLASSIC','EXCELLENCE','MIGRATION') NOT NULL,
  `url` text NOT NULL,
  `user` varchar(255) NOT NULL DEFAULT '',
  `password` varchar(255) NOT NULL DEFAULT '',
  `login_ok` tinyint(1) NOT NULL DEFAULT '0',
  `rating_ok` tinyint(1) NOT NULL DEFAULT '0',
  `date_checked` datetime NOT NULL,
  PRIMARY KEY (`tsid`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `ts_items`;
CREATE TABLE `ts_items` (
  `ts_items_id` int(11) NOT NULL AUTO_INCREMENT,
  `ts_id` varchar(33) NOT NULL,
  `retrievaldate` datetime NOT NULL,
  `creationdate` datetime NOT NULL,
  `id` int(11) NOT NULL,
  `currency` varchar(3) NOT NULL,
  `grossfee` decimal(15,5) NOT NULL,
  `netfee` decimal(15,5) NOT NULL,
  `protectedamount` decimal(15,5) NOT NULL,
  `protectionduration` int(11) NOT NULL,
  `tsproductid` varchar(255) NOT NULL,
  PRIMARY KEY (`ts_items_id`),
  KEY `ts_id` (`ts_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `ts_protection`;
CREATE TABLE `ts_protection` (
  `orders_id` int(11) NOT NULL,
  `application_number` int(11) NOT NULL,
  `tsid` varchar(33) NOT NULL,
  `result` int(11) DEFAULT NULL,
  PRIMARY KEY (`orders_id`),
  KEY `application_number` (`application_number`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `version_history`;
CREATE TABLE `version_history` (
  `history_id` int(11) NOT NULL AUTO_INCREMENT,
  `version` varchar(255) CHARACTER SET utf8 NOT NULL,
  `name` varchar(255) CHARACTER SET utf8 NOT NULL,
  `type` enum('master_update', 'service_pack', 'update') NOT NULL DEFAULT 'update',
  `revision` int(11) NOT NULL,
  `is_full_version` tinyint(1) NOT NULL DEFAULT '0',
  `installation_date` datetime NOT NULL,
  `php_version` varchar(255) CHARACTER SET utf8 NOT NULL,
  `mysql_version` varchar(255) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`history_id`)
) ENGINE=MyISAM AUTO_INCREMENT=1;

DROP TABLE IF EXISTS `sepa`;
CREATE TABLE `sepa` (
  `orders_id` int(11) NOT NULL default '0',
  `sepa_owner` varchar(64),
  `sepa_iban` varchar(35),
  `sepa_bic` varchar(15),
  `sepa_bankname` varchar(255),
  `sepa_status` int(11),
  `sepa_prz` char(2),
  `sepa_fax` char(2),
  PRIMARY KEY (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `personal_offers_by_customers_status_0`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_1`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_2`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_3`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_4`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_5`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_6`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_7`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_8`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_9`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_10`;

DROP TABLE IF EXISTS `module_newsletter_temp_1`;
DROP TABLE IF EXISTS `module_newsletter_temp_2`;
DROP TABLE IF EXISTS `module_newsletter_temp_3`;
DROP TABLE IF EXISTS `module_newsletter_temp_4`;
DROP TABLE IF EXISTS `module_newsletter_temp_5`;
DROP TABLE IF EXISTS `module_newsletter_temp_6`;
DROP TABLE IF EXISTS `module_newsletter_temp_7`;
DROP TABLE IF EXISTS `module_newsletter_temp_8`;
DROP TABLE IF EXISTS `module_newsletter_temp_9`;
DROP TABLE IF EXISTS `module_newsletter_temp_10`;


ALTER TABLE `content_manager` CHANGE `gm_url_keywords` `gm_url_keywords` VARCHAR( 255 ) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL;
ALTER TABLE `categories_description` CHANGE `gm_url_keywords` `gm_url_keywords` VARCHAR( 255 ) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL;
ALTER TABLE `products_description` CHANGE `gm_url_keywords` `gm_url_keywords` VARCHAR( 255 ) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL;


INSERT INTO `address_format` (`address_format_id`, `address_format`, `address_summary`) VALUES(1, '$firstname $lastname$cr$streets$cr$city, $postcode$cr$statecomma$country', '$city / $country');
INSERT INTO `address_format` (`address_format_id`, `address_format`, `address_summary`) VALUES(2, '$firstname $lastname$cr$streets$cr$city, $state    $postcode$cr$country', '$city, $state / $country');
INSERT INTO `address_format` (`address_format_id`, `address_format`, `address_summary`) VALUES(3, '$firstname $lastname$cr$streets$cr$city$cr$postcode - $statecomma$country', '$state / $country');
INSERT INTO `address_format` (`address_format_id`, `address_format`, `address_summary`) VALUES(4, '$firstname $lastname$cr$streets$cr$city ($postcode)$cr$country', '$postcode / $country');
INSERT INTO `address_format` (`address_format_id`, `address_format`, `address_summary`) VALUES(5, '$firstname $lastname$cr$streets$cr$postcode $city$cr$country', '$city / $country');


INSERT INTO `admin_access` SET
	`customers_id` = 'groups',
	`configuration` = 1,
	`modules` = 1,
	`countries` = 1,
	`currencies` = 1,
	`zones` = 1,
	`geo_zones` = 1,
	`tax_classes` = 1,
	`tax_rates` = 1,
	`accounting` = 1,
	`backup` = 1,
	`cache` = 1,
	`server_info` = 1,
	`whos_online` = 1,
	`languages` = 1,
	`define_language` = 1,
	`orders_status` = 1,
	`shipping_status` = 1,
	`module_export` = 1,
	`customers` = 1,
	`create_account` = 1,
	`customers_status` = 1,
	`orders` = 1,
	`campaigns` = 2,
	`print_packingslip` = 2,
	`print_order` = 2,
	`popup_memo` = 3,
	`coupon_admin` = 3,
	`listcategories` = 3,
	`gv_queue` = 3,
	`gv_mail` = 3,
	`gv_sent` = 3,
	`validproducts` = 3,
	`validcategories` = 4,
	`mail` = 4,
	`categories` = 4,
	`new_attributes` = 4,
	`products_attributes` = 2,
	`manufacturers` = 4,
	`reviews` = 2,
	`specials` = 2,
	`stats_products_expected` = 2,
	`stats_products_viewed` = 2,
	`stats_products_purchased` = 5,
	`stats_customers` = 5,
	`stats_sales_report` = 5,
	`stats_campaigns` = 5,
	`banner_manager` = 5,
	`banner_statistics` = 5,
	`module_newsletter` = 5,
	`start` = 5,
	`content_manager` = 2,
	`content_preview` = 2,
	`credits` = 2,
	`blacklist` = 2,
	`orders_edit` = 2,
	`popup_image` = 2,
	`csv_backend` = 2,
	`products_vpe` = 2,
	`cross_sell_groups` = 2,
	`econda` = 2,
	`listproducts` = 1,
	`gm_scroller` = 1,
	`gm_pdf` = 1,
	`gm_id_starts` = 1,
	`gm_pdf_order` = 1,
	`gm_pdf_action` = 1,
	`gm_emails` = 1,
	`gm_emails_preview` = 1,
	`gm_guestbook` = 1,
	`gm_counter` = 1,
	`gm_counter_action` = 1,
	`gm_meta` = 1,
	`gm_meta_action` = 1,
	`gm_analytics` = 1,
	`gm_bookmarks` = 1,
	`gm_bookmarks_action` = 1,
	`gm_logo` = 1,
	`gm_security` = 1,
	`gm_style_edit` = 1,
	`gm_send_order` = 1,
	`gm_order_menu` = 1,
	`gm_miscellaneous` = 1,
	`gm_lang_edit` = 1,
	`gm_sitemap` = 1,
	`gm_sitemap_creator` = 1,
	`gm_sql` = 1,
	`gm_offline` = 1,
	`gm_lightbox` = 1,
	`gm_seo_boost` = 1,
	`gm_trusted_shop_id` = 1,
	`gm_opensearch` = 1,
	`gm_opensearch_action` = 1,
	`gm_module_export` = 1,
	`gm_backup_files_zip` = 1,
	`gm_janolaw` = 1,
	`gm_module_part_export` = 1,
	`gm_product_export` = 1,
	`gm_gprint` = 1,
	`gm_gprint_download` = 1,
	`gm_gmotion` = 1,
	`xml_export` = 1,
	`gm_feature_control` = 1,
	`properties` = 1,
	`properties_combis` = 1,
	`request_port` = 1,
	`gm_slider` = 1,
	`template_configuration` = 1,
	`quantity_units` = 1,
	`show_logs` = 1,
	`robots_download` = 1,
	`clear_cache` = 1,
	`directory_scan` = 1,
	`yoochoose` = 1,
	`yatego` = 1,
	`gm_invoicing` = 1,
	`brickfox` = 1,
	`phpminiadmin` = 1,
	`minisql` = 1,
	`ekomi` = 1,
	`magnalister` = 1,
	`mobile` = 1,
	`shopgate` = 1,
	`mediafinanz` = 1,
	`lettr_de` = 1,
	`admin_javascript` = 1,
	`hermes_collection` = 1,
	`hermes_list` = 1,
	`hermes_info` = 1,
	`hermes_order` = 1,
	`hermes_config` = 1,
	`iloxx` = 1,
	`orders_iloxx` = 1,
	`affiliprint_module` = 1,
	`csv` = 1,
	`paypal_config` = 1,
	`paypal_logs` = 1,
	`print_intraship_label` = 1,
	`intraship` = 1,
	`klarna_config` = 1,
	`protectedshops` = 1,
	`itrecht_config` = 1,
	`withdrawals` = 1,
	`findologic_config` = 1,
	`amazonadvpay` = 1,
	`payone_config` = 1,
	`payone_logs` = 1;
INSERT INTO `admin_access` SET
	`customers_id` = 1,
	`configuration` = 1,
	`modules` = 1,
	`countries` = 1,
	`currencies` = 1,
	`zones` = 1,
	`geo_zones` = 1,
	`tax_classes` = 1,
	`tax_rates` = 1,
	`accounting` = 1,
	`backup` = 1,
	`cache` = 1,
	`server_info` = 1,
	`whos_online` = 1,
	`languages` = 1,
	`define_language` = 1,
	`orders_status` = 1,
	`shipping_status` = 1,
	`module_export` = 1,
	`customers` = 1,
	`create_account` = 1,
	`customers_status` = 1,
	`orders` = 1,
	`campaigns` = 1,
	`print_packingslip` = 1,
	`print_order` = 1,
	`popup_memo` = 1,
	`coupon_admin` = 1,
	`listcategories` = 1,
	`gv_queue` = 1,
	`gv_mail` = 1,
	`gv_sent` = 1,
	`validproducts` = 1,
	`validcategories` = 1,
	`mail` = 1,
	`categories` = 1,
	`new_attributes` = 1,
	`products_attributes` = 1,
	`manufacturers` = 1,
	`reviews` = 1,
	`specials` = 1,
	`stats_products_expected` = 1,
	`stats_products_viewed` = 1,
	`stats_products_purchased` = 1,
	`stats_customers` = 1,
	`stats_sales_report` = 1,
	`stats_campaigns` = 1,
	`banner_manager` = 1,
	`banner_statistics` = 1,
	`module_newsletter` = 1,
	`start` = 1,
	`content_manager` = 1,
	`content_preview` = 1,
	`credits` = 1,
	`blacklist` = 1,
	`orders_edit` = 1,
	`popup_image` = 1,
	`csv_backend` = 1,
	`products_vpe` = 1,
	`cross_sell_groups` = 1,
	`econda` = 1,
	`listproducts` = 1,
	`gm_scroller` = 1,
	`gm_pdf` = 1,
	`gm_id_starts` = 1,
	`gm_pdf_order` = 1,
	`gm_pdf_action` = 1,
	`gm_emails` = 1,
	`gm_emails_preview` = 1,
	`gm_guestbook` = 1,
	`gm_counter` = 1,
	`gm_counter_action` = 1,
	`gm_meta` = 1,
	`gm_meta_action` = 1,
	`gm_analytics` = 1,
	`gm_bookmarks` = 1,
	`gm_bookmarks_action` = 1,
	`gm_logo` = 1,
	`gm_security` = 1,
	`gm_style_edit` = 1,
	`gm_send_order` = 1,
	`gm_order_menu` = 1,
	`gm_miscellaneous` = 1,
	`gm_lang_edit` = 1,
	`gm_sitemap` = 1,
	`gm_sitemap_creator` = 1,
	`gm_sql` = 1,
	`gm_offline` = 1,
	`gm_lightbox` = 1,
	`gm_seo_boost` = 1,
	`gm_trusted_shop_id` = 1,
	`gm_opensearch` = 1,
	`gm_opensearch_action` = 1,
	`gm_module_export` = 1,
	`gm_backup_files_zip` = 1,
	`gm_janolaw` = 1,
	`gm_module_part_export` = 1,
	`gm_product_export` = 0,
	`gm_gprint` = 1,
	`gm_gprint_download` = 1,
	`gm_gmotion` = 1,
	`xml_export` = 1,
	`gm_feature_control` = 1,
	`properties` = 1,
	`properties_combis` = 1,
	`request_port` = 1,
	`gm_slider` = 1,
	`template_configuration` = 1,
	`quantity_units` = 1,
	`show_logs` = 1,
	`robots_download` = 1,
	`clear_cache` = 1,
	`directory_scan` = 1,
	`yoochoose` = 1,
	`yatego` = 1,
	`gm_invoicing` = 0,
	`brickfox` = 1,
	`phpminiadmin` = 1,
	`minisql` = 1,
	`ekomi` = 1,
	`magnalister` = 1,
	`mobile` = 1,
	`shopgate` = 1,
	`mediafinanz` = 1,
	`lettr_de` = 1,
	`admin_javascript` = 1,
	`hermes_collection` = 1,
	`hermes_list` = 1,
	`hermes_info` = 1,
	`hermes_order` = 1,
	`hermes_config` = 1,
	`iloxx` = 1,
	`orders_iloxx` = 1,
	`affiliprint_module` = 1,
	`csv` = 1,
	`paypal_config` = 1,
	`paypal_logs` = 1,
	`print_intraship_label` = 1,
	`intraship` = 1,
	`klarna_config` = 1,
	`protectedshops` = 1,
	`itrecht_config` = 1,
	`withdrawals` = 1,
	`findologic_config` = 1,
	`amazonadvpay` = 1,
	`payone_config` = 1,
	`payone_logs` = 1;

INSERT INTO `categories` (`categories_id`, `categories_image`, `parent_id`, `categories_status`, `categories_template`, `group_permission_0`, `group_permission_1`, `group_permission_2`, `group_permission_3`, `listing_template`, `sort_order`, `products_sorting`, `products_sorting2`, `date_added`, `last_modified`, `categories_icon`, `categories_icon_w`, `categories_icon_h`, `group_ids`, `gm_show_attributes`, `gm_show_graduated_prices`, `gm_show_qty`, `gm_priority`, `gm_changefreq`, `gm_sitemap_entry`, `gm_show_qty_info`, `feature_mode`, `feature_display_mode`) VALUES(1, '', 0, 1, 'categorie_listing.html', 0, 0, 0, 0, 'product_listing_v1.html', 0, 'p.products_price', 'ASC', '2008-08-08 17:16:41', '2008-08-25 17:33:52', 'item_ltr.gif', 5, 13, '', 0, 0, 1, '0.5', 'daily', 1, 0, 0, 0);


INSERT INTO `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `categories_meta_title`, `categories_meta_description`, `categories_meta_keywords`, `gm_alt_text`, `gm_url_keywords`) VALUES(1, 1, 'test category', 'test category', '<p>test category description</p>', '', '', '', '', 'test-category');
INSERT INTO `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `categories_meta_title`, `categories_meta_description`, `categories_meta_keywords`, `gm_alt_text`, `gm_url_keywords`) VALUES(1, 2, 'Testkategorie', 'Testkategorie', '<p>Testkategorie Beschreibung</p>', '', '', '', '', 'Testkategorie');


INSERT INTO `cm_file_flags` (`file_flag`, `file_flag_name`) VALUES(0, 'information');
INSERT INTO `cm_file_flags` (`file_flag`, `file_flag_name`) VALUES(1, 'content');
INSERT INTO `cm_file_flags` (`file_flag`, `file_flag_name`) VALUES(2, 'topmenu_corner');
INSERT INTO `cm_file_flags` (`file_flag`, `file_flag_name`) VALUES(3, 'topmenu');
INSERT INTO `cm_file_flags` (`file_flag`, `file_flag_name`) VALUES(4, 'extraboxes');
INSERT INTO `cm_file_flags` (`file_flag`, `file_flag_name`) VALUES(5, 'withdrawal');


INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(1, 'STORE_NAME', 'Shopname', 1, 1, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2, 'STORE_OWNER', 'Shopbetreiber', 1, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(3, 'STORE_OWNER_EMAIL_ADDRESS', '', 1, 14, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(4, 'EMAIL_FROM', '', 1, 15, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(5, 'STORE_COUNTRY', '81', 1, 10, NULL, '0000-00-00 00:00:00', 'xtc_get_country_name', 'xtc_cfg_pull_down_country_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(6, 'STORE_ZONE', '88', 1, 11, NULL, '0000-00-00 00:00:00', 'xtc_cfg_get_zone_name', 'xtc_cfg_pull_down_zone_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(7, 'EXPECTED_PRODUCTS_SORT', 'asc', 1, 23, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''asc'', ''desc''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(8, 'EXPECTED_PRODUCTS_FIELD', 'date_expected', 1, 24, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''products_name'', ''date_expected''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(9, 'USE_DEFAULT_LANGUAGE_CURRENCY', 'false', 1, 25, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(11, 'DISPLAY_CART', 'true', 1, 28, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(12, 'ADVANCED_SEARCH_DEFAULT_OPERATOR', 'and', 1, 30, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''and'', ''or''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(13, 'STORE_NAME_ADDRESS', '', 1, 17, NULL, '0000-00-00 00:00:00', NULL, 'xtc_cfg_textarea(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(14, 'SHOW_COUNTS', 'false', 1, 32, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(15, 'DEFAULT_CUSTOMERS_STATUS_ID_ADMIN', '0', 1, 35, NULL, '0000-00-00 00:00:00', 'xtc_get_customers_status_name', 'xtc_cfg_pull_down_customers_status_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(16, 'DEFAULT_CUSTOMERS_STATUS_ID_GUEST', '1', 1, 36, NULL, '0000-00-00 00:00:00', 'xtc_get_customers_status_name', 'xtc_cfg_pull_down_customers_status_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(17, 'DEFAULT_CUSTOMERS_STATUS_ID', '2', 1, 38, NULL, '0000-00-00 00:00:00', 'xtc_get_customers_status_name', 'xtc_cfg_pull_down_default_customers_status_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(18, 'ALLOW_ADD_TO_CART', 'false', 1, 39, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(19, 'CURRENT_TEMPLATE', 'EyeCandy', 1, 41, NULL, '0000-00-00 00:00:00', NULL, 'xtc_cfg_pull_down_template_sets(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(20, 'PRICE_IS_BRUTTO', 'true', 1, 42, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(21, 'PRICE_PRECISION', '4', 1, 43, NULL, '0000-00-00 00:00:00', NULL, '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(22, 'CC_KEYCHAIN', 'tobechanged', 1, 44, NULL, '0000-00-00 00:00:00', NULL, '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(23, 'ENTRY_FIRST_NAME_MIN_LENGTH', '2', 2, 1, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(24, 'ENTRY_LAST_NAME_MIN_LENGTH', '2', 2, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(25, 'ENTRY_DOB_MIN_LENGTH', '10', 2, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(26, 'ENTRY_EMAIL_ADDRESS_MIN_LENGTH', '6', 2, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(27, 'ENTRY_STREET_ADDRESS_MIN_LENGTH', '5', 2, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(28, 'ENTRY_COMPANY_MIN_LENGTH', '2', 2, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(29, 'ENTRY_POSTCODE_MIN_LENGTH', '4', 2, 7, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(30, 'ENTRY_CITY_MIN_LENGTH', '2', 2, 8, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(31, 'ENTRY_STATE_MIN_LENGTH', '2', 2, 9, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(32, 'ENTRY_TELEPHONE_MIN_LENGTH', '0', 2, 10, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(33, 'ENTRY_PASSWORD_MIN_LENGTH', '5', 2, 11, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(34, 'CC_OWNER_MIN_LENGTH', '3', 2, 12, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(35, 'CC_NUMBER_MIN_LENGTH', '10', 2, 13, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(36, 'REVIEW_TEXT_MIN_LENGTH', '50', 2, 14, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(37, 'MIN_DISPLAY_BESTSELLERS', '1', 2, 15, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(38, 'MIN_DISPLAY_ALSO_PURCHASED', '1', 2, 16, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(39, 'MAX_ADDRESS_BOOK_ENTRIES', '5', 3, 1, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(40, 'MAX_DISPLAY_SEARCH_RESULTS', '8', 3, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(41, 'MAX_DISPLAY_PAGE_LINKS', '4', 3, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(42, 'MAX_DISPLAY_SPECIAL_PRODUCTS', '8', 3, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(44, 'MAX_DISPLAY_UPCOMING_PRODUCTS', '0', 3, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(45, 'MAX_DISPLAY_MANUFACTURERS_IN_A_LIST', '1', 3, 7, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(46, 'MAX_MANUFACTURERS_LIST', '1', 3, 7, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(47, 'MAX_DISPLAY_MANUFACTURER_NAME_LEN', '15', 3, 8, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(48, 'MAX_DISPLAY_NEW_REVIEWS', '6', 3, 9, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(49, 'MAX_RANDOM_SELECT_REVIEWS', '10', 3, 10, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(50, 'MAX_RANDOM_SELECT_NEW', '30', 3, 11, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(51, 'MAX_RANDOM_SELECT_SPECIALS', '10', 3, 12, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(52, 'MAX_DISPLAY_CATEGORIES_PER_ROW', '2', 3, 13, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(53, 'MAX_DISPLAY_PRODUCTS_NEW', '10', 3, 14, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(54, 'MAX_DISPLAY_BESTSELLERS', '5', 3, 15, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(55, 'MAX_DISPLAY_ALSO_PURCHASED', '4', 3, 16, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(56, 'MAX_DISPLAY_PRODUCTS_IN_ORDER_HISTORY_BOX', '6', 3, 17, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(57, 'MAX_DISPLAY_ORDER_HISTORY', '5', 3, 18, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(58, 'PRODUCT_REVIEWS_VIEW', '5', 3, 19, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(59, 'MAX_PRODUCTS_QTY', '1000000', 3, 21, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(60, 'MAX_DISPLAY_NEW_PRODUCTS_DAYS', '30', 3, 22, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(61, 'CONFIG_CALCULATE_IMAGE_SIZE', 'true', 4, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(62, 'IMAGE_QUALITY', '100', 4, 2, '2003-12-15 12:10:45', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(63, 'PRODUCT_IMAGE_THUMBNAIL_WIDTH', '150', 4, 7, '2003-12-15 12:10:45', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(64, 'PRODUCT_IMAGE_THUMBNAIL_HEIGHT', '130', 4, 8, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(65, 'PRODUCT_IMAGE_INFO_WIDTH', '369', 4, 9, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(66, 'PRODUCT_IMAGE_INFO_HEIGHT', '350', 4, 10, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(67, 'PRODUCT_IMAGE_POPUP_WIDTH', '600', 4, 11, '2003-12-15 12:11:00', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(68, 'PRODUCT_IMAGE_POPUP_HEIGHT', '600', 4, 12, '2003-12-15 12:11:09', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(69, 'PRODUCT_IMAGE_THUMBNAIL_BEVEL', '', 4, 13, '2003-12-15 13:14:39', '0000-00-00 00:00:00', '', '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(70, 'PRODUCT_IMAGE_THUMBNAIL_GREYSCALE', '', 4, 14, '2003-12-15 13:13:37', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(71, 'PRODUCT_IMAGE_THUMBNAIL_ELLIPSE', '', 4, 15, '2003-12-15 13:14:57', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(72, 'PRODUCT_IMAGE_THUMBNAIL_ROUND_EDGES', '', 4, 16, '2003-12-15 13:19:45', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(73, 'PRODUCT_IMAGE_THUMBNAIL_MERGE', '', 4, 17, '2003-12-15 12:01:43', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(74, 'PRODUCT_IMAGE_THUMBNAIL_FRAME', '', 4, 18, '2003-12-15 13:19:37', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(75, 'PRODUCT_IMAGE_THUMBNAIL_DROP_SHADDOW', '', 4, 19, '2003-12-15 13:15:14', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(76, 'PRODUCT_IMAGE_THUMBNAIL_MOTION_BLUR', '', 4, 20, '2003-12-15 12:02:19', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(77, 'PRODUCT_IMAGE_INFO_BEVEL', '', 4, 21, '2003-12-15 13:42:09', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(78, 'PRODUCT_IMAGE_INFO_GREYSCALE', '', 4, 22, '2003-12-15 13:18:00', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(79, 'PRODUCT_IMAGE_INFO_ELLIPSE', '', 4, 23, '2003-12-15 13:41:53', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(80, 'PRODUCT_IMAGE_INFO_ROUND_EDGES', '', 4, 24, '2003-12-15 13:21:55', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(81, 'PRODUCT_IMAGE_INFO_MERGE', '', 4, 25, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(82, 'PRODUCT_IMAGE_INFO_FRAME', '', 4, 26, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(83, 'PRODUCT_IMAGE_INFO_DROP_SHADDOW', '', 4, 27, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(84, 'PRODUCT_IMAGE_INFO_MOTION_BLUR', '', 4, 28, '2003-12-15 13:21:18', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(85, 'PRODUCT_IMAGE_POPUP_BEVEL', '', 4, 29, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(86, 'PRODUCT_IMAGE_POPUP_GREYSCALE', '', 4, 30, '2003-12-15 13:22:58', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(87, 'PRODUCT_IMAGE_POPUP_ELLIPSE', '', 4, 31, '2003-12-15 13:22:51', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(88, 'PRODUCT_IMAGE_POPUP_ROUND_EDGES', '', 4, 32, '2003-12-15 13:23:17', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(89, 'PRODUCT_IMAGE_POPUP_MERGE', '', 4, 33, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(90, 'PRODUCT_IMAGE_POPUP_FRAME', '', 4, 34, '2003-12-15 13:22:43', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(91, 'PRODUCT_IMAGE_POPUP_DROP_SHADDOW', '', 4, 35, '2003-12-15 13:22:26', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(92, 'PRODUCT_IMAGE_POPUP_MOTION_BLUR', '', 4, 36, '2003-12-15 13:22:32', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(93, 'MO_PICS', '3', 4, 3, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(94, 'IMAGE_MANIPULATOR', 'image_manipulator_GD2.php', 4, 3, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'xtc_cfg_select_option(array(''image_manipulator_GD2.php'', ''image_manipulator_GD1.php''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(95, 'ACCOUNT_GENDER', 'true', 5, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(96, 'ACCOUNT_DOB', 'false', 5, 2, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(97, 'ACCOUNT_COMPANY', 'true', 5, 3, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(98, 'ACCOUNT_SUBURB', 'false', 5, 4, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(99, 'ACCOUNT_STATE', 'false', 5, 5, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(100, 'ACCOUNT_OPTIONS', 'both', 5, 6, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''account'', ''guest'', ''both''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(101, 'DELETE_GUEST_ACCOUNT', 'true', 5, 7, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(102, 'MODULE_PAYMENT_INSTALLED', '', 6, 0, '2008-08-25 17:50:17', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(103, 'MODULE_ORDER_TOTAL_INSTALLED', 'ot_subtotal.php;ot_discount.php;ot_coupon.php;ot_shipping.php;ot_cod_fee.php;ot_gv.php;ot_subtotal_no_tax.php;ot_tax.php;ot_total_netto.php;ot_total.php', 6, 0, '2008-08-25 16:49:22', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2064, 'MODULE_ORDER_TOTAL_SUBTOTAL_STATUS', 'true', 6, 1, NULL, '2008-08-11 16:22:38', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(104, 'MODULE_SHIPPING_INSTALLED', '', 6, 0, '2008-08-25 17:50:34', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(105, 'DEFAULT_CURRENCY', 'EUR', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(106, 'DEFAULT_LANGUAGE', 'de', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(107, 'DEFAULT_ORDERS_STATUS_ID', '1', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(108, 'DEFAULT_PRODUCTS_VPE_ID', '', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(109, 'DEFAULT_SHIPPING_STATUS_ID', '1', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(125, 'SHIPPING_ORIGIN_COUNTRY', '81', 7, 1, NULL, '0000-00-00 00:00:00', 'xtc_get_country_name', 'xtc_cfg_pull_down_country_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(126, 'SHIPPING_ORIGIN_ZIP', '12345', 7, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(127, 'SHIPPING_MAX_WEIGHT', '50', 7, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(128, 'SHIPPING_BOX_WEIGHT', '0', 7, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(129, 'SHIPPING_BOX_PADDING', '0', 7, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(130, 'SHOW_SHIPPING', 'true', 7, 6, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(131, 'SHIPPING_INFOS', '3889891', 7, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2655, 'SHOW_CART_SHIPPING_COSTS', 'true', 7, 8, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(132, 'PRODUCT_LIST_FILTER', '1', 8, 1, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(133, 'STOCK_CHECK', 'true', 9, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(134, 'ATTRIBUTE_STOCK_CHECK', 'true', 9, 2, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(135, 'STOCK_LIMITED', 'true', 9, 3, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(136, 'STOCK_ALLOW_CHECKOUT', 'true', 9, 4, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(137, 'STOCK_MARK_PRODUCT_OUT_OF_STOCK', '***', 9, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(138, 'STOCK_REORDER_LEVEL', '5', 9, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(139, 'STORE_PAGE_PARSE_TIME', 'false', 10, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(140, 'STORE_PAGE_PARSE_TIME_LOG', '/tmp/', 10, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(141, 'STORE_PARSE_DATE_TIME_FORMAT', '%d/%m/%Y %H:%M:%S', 10, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(142, 'DISPLAY_PAGE_PARSE_TIME', 'false', 10, 4, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(143, 'STORE_DB_TRANSACTIONS', 'false', 10, 8, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(144, 'USE_CACHE', 'false', 11, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(145, 'DIR_FS_CACHE', 'cache', 11, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(146, 'CACHE_LIFETIME', '3600', 11, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(147, 'CACHE_CHECK', 'false', 11, 4, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(148, 'DB_CACHE', 'false', 11, 5, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(149, 'DB_CACHE_EXPIRE', '3600', 11, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(150, 'EMAIL_TRANSPORT', 'mail', 12, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''sendmail'', ''smtp'', ''mail''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(151, 'SENDMAIL_PATH', '/usr/sbin/sendmail', 12, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(152, 'SMTP_MAIN_SERVER', 'localhost', 12, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(153, 'SMTP_Backup_Server', 'localhost', 12, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(154, 'SMTP_PORT', '25', 12, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(155, 'SMTP_USERNAME', 'Please Enter', 12, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(156, 'SMTP_PASSWORD', 'Please Enter', 12, 7, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(157, 'SMTP_AUTH', 'false', 12, 8, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(158, 'EMAIL_LINEFEED', 'LF', 12, 9, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''LF'', ''CRLF''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(159, 'EMAIL_USE_HTML', 'true', 12, 10, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(160, 'ENTRY_EMAIL_ADDRESS_CHECK', 'false', 12, 11, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(161, 'SEND_EMAILS', 'true', 12, 12, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(162, 'CONTACT_US_EMAIL_ADDRESS', '', 12, 20, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(163, 'CONTACT_US_NAME', 'Ihr Name', 12, 21, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(164, 'CONTACT_US_REPLY_ADDRESS', '', 12, 22, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(165, 'CONTACT_US_REPLY_ADDRESS_NAME', 'Ihr Name', 12, 23, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(166, 'CONTACT_US_EMAIL_SUBJECT', 'Kontakt', 12, 24, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(167, 'CONTACT_US_FORWARDING_STRING', '', 12, 25, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(168, 'EMAIL_SUPPORT_ADDRESS', '', 12, 26, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(169, 'EMAIL_SUPPORT_NAME', 'Ihr Name', 12, 27, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(170, 'EMAIL_SUPPORT_REPLY_ADDRESS', '', 12, 28, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(171, 'EMAIL_SUPPORT_REPLY_ADDRESS_NAME', 'Ihr Name', 12, 29, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(172, 'EMAIL_SUPPORT_SUBJECT', 'Technischer Support', 12, 30, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(173, 'EMAIL_SUPPORT_FORWARDING_STRING', '', 12, 31, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(174, 'EMAIL_BILLING_ADDRESS', '', 12, 32, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(175, 'EMAIL_BILLING_NAME', 'Ihr Name', 12, 33, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(176, 'EMAIL_BILLING_REPLY_ADDRESS', '', 12, 34, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(177, 'EMAIL_BILLING_REPLY_ADDRESS_NAME', 'Ihr Name', 12, 35, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(178, 'EMAIL_BILLING_SUBJECT', 'Verrechnung', 12, 36, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(179, 'EMAIL_BILLING_FORWARDING_STRING', '', 12, 37, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(180, 'EMAIL_BILLING_SUBJECT_ORDER', 'Ihre Bestellung {$nr}, am {$date}', 12, 38, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(181, 'DOWNLOAD_ENABLED', 'true', 13, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(182, 'DOWNLOAD_BY_REDIRECT', 'false', 13, 2, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(183, 'DOWNLOAD_UNALLOWED_PAYMENT', 'banktransfer,cod,invoice,moneyorder', 13, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(184, 'DOWNLOAD_MIN_ORDERS_STATUS', '3', 13, 5, NULL, '0000-00-00 00:00:00', NULL, 'cfg_download_order_status_checkboxes(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(185, 'GZIP_COMPRESSION', 'true', 14, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(186, 'GZIP_LEVEL', '9', 14, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(188, 'SESSION_FORCE_COOKIE_USE', 'False', 15, 2, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''True'', ''False''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(189, 'SESSION_CHECK_SSL_SESSION_ID', 'False', 15, 3, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''True'', ''False''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(190, 'SESSION_CHECK_USER_AGENT', 'False', 15, 4, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''True'', ''False''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(191, 'SESSION_CHECK_IP_ADDRESS', 'False', 15, 5, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''True'', ''False''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(192, 'SESSION_RECREATE', 'False', 15, 7, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''True'', ''False''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(204, 'CHECK_CLIENT_AGENT', 'true', 16, 13, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(205, 'USE_WYSIWYG', 'true', 17, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(206, 'ACTIVATE_GIFT_SYSTEM', 'false', 17, 2, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(207, 'SECURITY_CODE_LENGTH', '10', 17, 3, NULL, '2003-12-05 05:01:41', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(208, 'NEW_SIGNUP_GIFT_VOUCHER_AMOUNT', '', 17, 4, NULL, '2003-12-05 05:01:41', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(209, 'NEW_SIGNUP_DISCOUNT_COUPON', '', 17, 5, NULL, '2003-12-05 05:01:41', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(210, 'ACTIVATE_SHIPPING_STATUS', 'true', 17, 6, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(213, 'GROUP_CHECK', 'false', 17, 9, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(214, 'ACTIVATE_NAVIGATOR', 'false', 17, 10, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(215, 'QUICKLINK_ACTIVATED', 'true', 17, 11, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(216, 'ACTIVATE_REVERSE_CROSS_SELLING', 'true', 17, 12, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(217, 'ACTIVATE_PAGE_TOKEN', 'true', 17, 13, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(217, 'SHOW_UNTRANSLATED_MENUITEMS', 'false', 17, 13, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(219, 'ACCOUNT_COMPANY_VAT_CHECK', 'true', 18, 4, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(221, 'DEFAULT_CUSTOMERS_VAT_STATUS_ID', '3', 18, 23, '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'xtc_get_customers_status_name', 'xtc_cfg_pull_down_default_customers_status_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(222, 'ACCOUNT_COMPANY_VAT_LIVE_CHECK', 'true', 18, 4, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(223, 'ACCOUNT_COMPANY_VAT_GROUP', 'false', 18, 4, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(224, 'ACCOUNT_VAT_BLOCK_ERROR', 'true', 18, 4, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(225, 'DEFAULT_CUSTOMERS_VAT_STATUS_ID_LOCAL', '3', 18, 24, NULL, '0000-00-00 00:00:00', 'xtc_get_customers_status_name', 'xtc_cfg_pull_down_default_customers_status_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(226, 'GOOGLE_CONVERSION_ID', '', 19, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(227, 'GOOGLE_LANG', 'de', 19, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(228, 'GOOGLE_CONVERSION', 'false', 19, 0, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(229, 'CSV_TEXTSIGN', '', 20, 1, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(230, 'CSV_SEPERATOR', '|', 20, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(231, 'COMPRESS_EXPORT', 'false', 20, 3, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(232, 'AFTERBUY_PARTNERID', '', 21, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(233, 'AFTERBUY_PARTNERPASS', '', 21, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(234, 'AFTERBUY_USERID', '', 21, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(235, 'AFTERBUY_ORDERSTATUS', '1', 21, 5, NULL, '0000-00-00 00:00:00', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(236, 'AFTERBUY_ACTIVATED', 'false', 21, 6, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(237, 'SEARCH_IN_DESC', 'true', 22, 2, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(238, 'SEARCH_IN_ATTR', 'true', 22, 3, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(239, 'TRACKING_ECONDA_ACTIVE', 'false', 23, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(240, 'TRACKING_ECONDA_ID', '', 23, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(241, 'MODULE_EXPORT_INSTALLED', 'magnalister.php', 6, 0, '2008-08-25 22:19:34', '2007-11-25 14:11:52', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2158, 'MODULE_DELISPRINT_FILE', 'delisprint.txt', 6, 1, NULL, '2008-08-13 17:07:06', NULL, '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2156, 'MODULE_HERMES_FILE', 'hermes.txt', 6, 1, NULL, '2008-08-12 12:59:02', NULL, '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2157, 'MODULE_HERMES_STATUS', 'True', 6, 1, NULL, '2008-08-12 12:59:02', NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2159, 'MODULE_DELISPRINT_STATUS', 'True', 6, 1, NULL, '2008-08-13 17:07:06', NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2201, 'MODULE_GLS_STATUS', 'True', 6, 1, NULL, '2008-08-13 17:36:14', NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2200, 'MODULE_GLS_FILE', 'gls.txt', 6, 1, NULL, '2008-08-13 17:36:14', NULL, '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(801, 'PAYPAL_API_SANDBOX_SIGNATURE', '', 25, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(802, 'PAYPAL_API_SANDBOX_PWD', '', 25, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(803, 'PAYPAL_API_SANDBOX_USER', '', 25, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(804, 'PAYPAL_SHOP_LOGO', '', 25, 13, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(805, 'PAYPAL_EXPRESS_ADDRESS_OVERRIDE', 'true', 25, 18, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'xtc_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(806, 'PAYPAL_EXPRESS_PAYMENTACTION', 'Sale', 25, 16, NULL, '2007-07-14 11:38:40', NULL, 'xtc_cfg_select_option(array(''Sale'', ''Authorization'', ''Order''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(807, 'PAYPAL_MODE', 'live', 25, 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'xtc_cfg_select_option(array(''sandbox'', ''live''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(808, 'PAYPAL_API_USER', '', 25, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(809, 'PAYPAL_API_PWD', '', 25, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(810, 'PAYPAL_API_SIGNATURE', '', 25, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(811, 'PAYPAL_EXPRESS_ADDRESS_CHANGE', 'true', 25, 17, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'xtc_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(812, 'PAYPAL_COUNTRY_MODE', 'de', 25, 16, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'xtc_cfg_select_option(array(''de'', ''uk''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(813, 'PAYPAL_ORDER_STATUS_TMP_ID', '1', 25, 9, NULL, '2007-07-04 16:13:02', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(814, 'PAYPAL_ORDER_STATUS_SUCCESS_ID', '2', 25, 10, NULL, '2007-07-04 16:13:02', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(815, 'PAYPAL_ORDER_STATUS_PENDING_ID', '1', 25, 11, NULL, '2007-07-04 16:13:02', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(816, 'PAYPAL_ORDER_STATUS_REJECTED_ID', '1', 25, 12, NULL, '2007-07-04 16:13:02', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(817, 'PAYPAL_API_KEY', '120,116,99,111,109,109,101,114,99,101,95,83,104,111,112,112,105,110,103,67,97,114,116,95', 6, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(1734, 'GM_SET_OUT_OF_STOCK_PRODUCTS', 'false', 9, NULL, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(1735, 'GM_SET_OUT_OF_STOCK_ATTRIBUTES', 'false', 9, NULL, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(1736, 'GM_SET_OUT_OF_STOCK_ATTRIBUTES_SHOW', 'false', 9, NULL, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2071, 'MODULE_ORDER_TOTAL_SHIPPING_TAX_CLASS', '0', 6, 7, NULL, '2008-08-11 16:22:45', 'xtc_get_tax_class_title', 'xtc_cfg_pull_down_tax_classes(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2070, 'MODULE_ORDER_TOTAL_SHIPPING_DESTINATION', 'national', 6, 5, NULL, '2008-08-11 16:22:45', NULL, 'xtc_cfg_select_option(array(''national'', ''international'', ''both''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2069, 'MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER', '50', 6, 4, NULL, '2008-08-11 16:22:45', 'currencies->format', NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2068, 'MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING', 'false', 6, 3, NULL, '2008-08-11 16:22:45', NULL, 'xtc_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2067, 'MODULE_ORDER_TOTAL_SHIPPING_SORT_ORDER', '30', 6, 2, NULL, '2008-08-11 16:22:45', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2066, 'MODULE_ORDER_TOTAL_SHIPPING_STATUS', 'true', 6, 1, NULL, '2008-08-11 16:22:45', NULL, 'xtc_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2065, 'MODULE_ORDER_TOTAL_SUBTOTAL_SORT_ORDER', '10', 6, 2, NULL, '2008-08-11 16:22:38', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2063, 'MODULE_ORDER_TOTAL_SUBTOTAL_NO_TAX_SORT_ORDER', '96', 6, 2, NULL, '2008-08-11 16:22:32', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2062, 'MODULE_ORDER_TOTAL_SUBTOTAL_NO_TAX_STATUS', 'true', 6, 1, NULL, '2008-08-11 16:22:32', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2058, 'MODULE_ORDER_TOTAL_TOTAL_STATUS', 'true', 6, 1, NULL, '2008-08-11 16:21:01', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2059, 'MODULE_ORDER_TOTAL_TOTAL_SORT_ORDER', '99', 6, 2, NULL, '2008-08-11 16:21:01', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2055, 'MODULE_ORDER_TOTAL_TOTAL_NETTO_SORT_ORDER', '98', 6, 2, NULL, '2008-08-11 16:20:34', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2054, 'MODULE_ORDER_TOTAL_TOTAL_NETTO_STATUS', 'true', 6, 1, NULL, '2008-08-11 16:20:34', NULL, 'xtc_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2275, 'MODULE_ORDER_TOTAL_GV_SORT_ORDER', '80', 6, 2, NULL, '2008-08-15 17:32:15', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2274, 'MODULE_ORDER_TOTAL_GV_STATUS', 'true', 6, 1, NULL, '2008-08-15 17:32:15', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2278, 'MODULE_ORDER_TOTAL_GV_INC_TAX', 'true', 6, 6, NULL, '2008-08-15 17:32:15', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2276, 'MODULE_ORDER_TOTAL_GV_QUEUE', 'true', 6, 3, NULL, '2008-08-15 17:32:15', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2277, 'MODULE_ORDER_TOTAL_GV_INC_SHIPPING', 'False', 6, 5, NULL, '2008-08-15 17:32:15', NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2435, 'MODULE_ORDER_TOTAL_FREEAMOUNT_FREE', 'AT:3.00,DE:3.58,00:9.99', 6, 0, NULL, '2008-08-19 10:55:02', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2436, 'MODULE_ORDER_TOTAL_COD_FEE_TAX_CLASS', '0', 6, 0, NULL, '2008-08-19 10:55:02', 'xtc_get_tax_class_title', 'xtc_cfg_pull_down_tax_classes(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2281, 'MODULE_ORDER_TOTAL_GV_CREDIT_TAX', 'false', 6, 8, NULL, '2008-08-15 17:32:15', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2280, 'MODULE_ORDER_TOTAL_GV_TAX_CLASS', '0', 6, 0, NULL, '2008-08-15 17:32:15', 'xtc_get_tax_class_title', 'xtc_cfg_pull_down_tax_classes(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2279, 'MODULE_ORDER_TOTAL_GV_CALC_TAX', 'None', 6, 7, NULL, '2008-08-15 17:32:15', NULL, 'xtc_cfg_select_option(array(''None'', ''Standard'', ''Credit Note''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2416, 'MODULE_ORDER_TOTAL_COD_FEE_STATUS', 'true', 6, 0, NULL, '2008-08-19 10:55:02', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2417, 'MODULE_ORDER_TOTAL_COD_FEE_SORT_ORDER', '35', 6, 0, NULL, '2008-08-19 10:55:02', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2418, 'MODULE_ORDER_TOTAL_COD_FEE_RULES', 'free|AT:3.00,DE:3.58,00:9.99|flat|AT:3.00,DE:3.58,00:9.99|item|AT:3.00,DE:3.58,00:9.99|table|AT:3.00,DE:3.58,00:9.99|zones|CA:4.50,US:3.00,00:9.99|upse|AT:3.00,DE:3.58,00:9.99|chronopost|FR:4.00,00:9.99|dhl|AT:3.00,DE:3.58,00:9.99|ups|AT:3.00,DE:3.58,00:9.99|chp|CH:4.00,00:9.99|dpd|DE:4.00,00:9.99|ap|AT:3.63,00:9.99|zonese|DE:4.00,00:9.99|selfpickup|DE:4.00,00:9.99|gambioultra|DE:4.00,00:9.99|fedexeu|DE:4.00,00:9.99|dp|DE:4.00,00:9.99', 6, 0, NULL, '2013-11-12 10:46:04', '', 'cfg_cod_fee_form(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2585, 'MODULE_ORDER_TOTAL_TAX_SORT_ORDER', '97', 6, 2, NULL, '2008-08-25 16:49:21', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2586, 'MODULE_ORDER_TOTAL_TAX_STATUS', 'true', 6, 1, NULL, '2008-08-25 16:49:21', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');

INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2618, 'MODULE_BRICKFOX_URL', '', 26, 1, NULL, '2010-04-01 22:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2624, 'MODULE_BRICKFOX_PORT', '443', 26, 2, NULL, '2010-04-01 22:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2619, 'MODULE_BRICKFOX_USERNAME', '', 26, 3, NULL, '2010-04-01 22:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2620, 'MODULE_BRICKFOX_PASSWORD', '', 26, 4, NULL, '2010-04-01 22:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2621, 'MODULE_BRICKFOX_EXCLUDE_CATEGORIES', '', 26, 5, NULL, '2010-04-01 22:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2622, 'MODULE_BRICKFOX_EXCLUDE_PRODUCTS', '', 26, 6, NULL, '2010-04-01 22:00:00', null, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2623, 'MODULE_BRICKFOX_STATUS', 'False', 26, 7, NULL, '2010-04-01 22:00:00', NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ACCOUNT_TELEPHONE', 'true', 5, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ACCOUNT_FAX', 'true', 5, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('EMAIL_SIGNATURE', '', 12, 16, NULL, '0000-00-00 00:00:00', NULL, 'xtc_cfg_textarea(');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('HTTP_CACHING', 'true', 11, 7, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('LOG_SQL_FRONTEND', 'false', 10, 5, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('LOG_SQL_BACKEND', 'false', 10, 6, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('SQL_LOG_MAX_FILESIZE', '1', 10, 7, NULL, '0000-00-00 00:00:00', NULL, NULL);

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COUPON_STATUS', 'true', 6, 1, NULL, '2011-11-10 18:13:22', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COUPON_SORT_ORDER', '29', 6, 2, NULL, '2011-11-10 18:13:22', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COUPON_INC_SHIPPING', 'false', 6, 5, NULL, '2011-11-10 18:13:22', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COUPON_INC_TAX', 'true', 6, 6, NULL, '2011-11-10 18:13:22', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COUPON_CALC_TAX', 'Standard', 6, 7, NULL, '2011-11-10 18:13:22', NULL, 'xtc_cfg_select_option(array(''None'', ''Standard'', ''Credit Note''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COUPON_TAX_CLASS', '0', 6, 0, NULL, '2011-11-10 18:13:22', 'xtc_get_tax_class_title', 'xtc_cfg_pull_down_tax_classes(');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_DISCOUNT_STATUS', 'true', 6, 1, NULL, '2011-11-10 18:15:39', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_DISCOUNT_SORT_ORDER', '20', 6, 2, NULL, '2011-11-10 18:15:39', NULL, NULL);

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('APPEND_PROPERTIES_MODEL', 'true', 1, 45, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('SHOW_PRODUCTS_MODEL', 'false', 1, 46, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('PREFER_GZHANDLER', 'false', 14, 3, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('SEND_EMAIL_BY_BILLING_ADRESS', 'CUSTOMER_MAIL', 12, 40 , NULL , '0000-00-00 00:00:00', NULL , 'gm_cfg_select_option(array(''CUSTOMER_MAIL'', ''SHOP_OWNER''),');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('GOOGLE_CONVERSION_LABEL', 'Purchase', 19, 4, NULL , '0000-00-00 00:00:00', NULL , NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('GAMBIO_SHOP_KEY', '', 753, 1 , NULL , '0000-00-00 00:00:00', NULL, NULL);

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_EMAILID', '', 32, 1, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_PWD', '', 32, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_MERCHANTID', '', 32, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_MODULES', '', 32, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_TMP_STATUS_ID', '0', 32, 5, NULL, '0000-00-00 00:00:00', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_PROCESSED_STATUS_ID', '0', 32, 6, NULL, '0000-00-00 00:00:00', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_PENDING_STATUS_ID', '0', 32, 7, NULL, '0000-00-00 00:00:00', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_CANCELED_STATUS_ID', '0', 32, 8, NULL, '0000-00-00 00:00:00', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_EXPERTMODE', '0', 32, 9, NULL, '0000-00-00 00:00:00', NULL, NULL);

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('SHOW_CART_SHIPPING_WEIGHT', 'true', 7, 9, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_PAYMENT_SEPA_SEND_MANDATE', 'true', 6, 0, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_PAYMENT_SEPA_CREDITOR_ID', '', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_PAYMENT_SEPA_POSTCODE_CITY', '', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_PAYMENT_SEPA_STREET_ADDRESS', '', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_PAYMENT_SEPA_COMPANY', '', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_EMAIL', '', 10, 8, NULL, NOW(), NULL, '');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_ERROR', 'False', 10, 9, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_WARNING', 'False', 10, 10, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_PARSE', 'False', 10, 11, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_NOTICE', 'True', 10, 12, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_CORE_ERROR', 'False', 10, 13, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_CORE_WARNING', 'False', 10, 14, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_COMPILE_ERROR', 'False', 10, 15, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_COMPILE_WARNING', 'False', 10, 16, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_USER_ERROR', 'False', 10, 17, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_USER_WARNING', 'False', 10, 18, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_USER_NOTICE', 'False', 10, 19, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_ALL', 'False', 10, 20, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_STRICT', 'True', 10, 21, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_RECOVERABLE_ERROR', 'False', 10, 22, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ERROR_REPORT_HIDE_E_DEPRECATED', 'True', 10, 23, NULL, NOW(), NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('LOGGING_ENABLED', 'true', 10, 0, NULL , NOW(), NULL , 'gm_cfg_select_option(array(''true'', ''false''), ');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('COMPANY_NAME', '', 1, 3, NULL, '0000-00-00 00:00:00', '', '');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('TRADER_FIRSTNAME', '', 1, 4, NULL, '0000-00-00 00:00:00', '', '');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('TRADER_NAME', '', 1, 5, NULL, '0000-00-00 00:00:00', '', '');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('TRADER_STREET', '', 1, 6, NULL, '0000-00-00 00:00:00', '', '');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('TRADER_STREET_NUMBER', '', 1, 7, NULL, '0000-00-00 00:00:00', '', '');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('TRADER_ZIPCODE', '', 1, 8, NULL, '0000-00-00 00:00:00', '', '');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('TRADER_LOCATION', '', 1, 9, NULL, '0000-00-00 00:00:00', '', '');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('TRADER_TEL', '', 1, 12, NULL, '0000-00-00 00:00:00', '', '');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('TRADER_FAX', '', 1, 13, NULL, '0000-00-00 00:00:00', '', '');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('DATE_TIMEZONE', 'Europe/Berlin', 1, 47, NULL, '0000-00-00 00:00:00', '', 'cfg_pull_down_timezones(');


INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(1, 'My Store', 'General information about my store', 1, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(2, 'Minimum Values', 'The minimum values for functions / data', 2, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(3, 'Maximum Values', 'The maximum values for functions / data', 3, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(4, 'Images', 'Image parameters', 4, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(5, 'Customer Details', 'Customer account configuration', 5, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(6, 'Module Options', 'Hidden from configuration', 6, 0);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(7, 'Shipping/Packaging', 'Shipping options available at my store', 7, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(8, 'Product Listing', 'Product Listing    configuration options', 8, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(9, 'Stock', 'Stock configuration options', 9, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(10, 'Logging', 'Logging configuration options', 10, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(11, 'Cache', 'Caching configuration options', 11, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(12, 'E-Mail Options', 'General setting for E-Mail transport and HTML E-Mails', 12, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(13, 'Download', 'Downloadable products options', 13, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(14, 'GZip Compression', 'GZip compression options', 14, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(15, 'Sessions', 'Session options', 15, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(16, 'Meta-Tags/Search engines', 'Meta-tags/Search engines', 16, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(18, 'Vat ID', 'Vat ID', 18, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(19, 'Google Conversion', 'Google Conversion-Tracking', 19, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(20, 'Import/Export', 'Import/Export', 20, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(21, 'Afterbuy', 'Afterbuy.de', 21, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(22, 'Search Options', 'Additional Options for search function', 22, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(25, 'PayPal', 'PayPal', 25, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(26, 'brickfox', 'brickfox.de', 26, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(753, 'Gambio-Shop-Key', 'Gambio-Shop-Key', 753, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(32, 'Skrill', 'Skrill', 32, 1);


INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Privacy Notice', 'Privacy Notice', '<p>Enter your Privacy Notice information here.</p>', 0, 1, '', '', 1, 2, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:21:28', 1, 'privacy-notice', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Conditions of Use', 'Conditions of Use', '<p>Enter your Conditions of Use information here.</p>', 0, 1, '', '', 1, 3, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:21:47', 1, 'conditions-of-use', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Imprint', 'Imprint', '<p>Enter your Company information here.</p>', 0, 1, '', '', 1, 4, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:22:50', 1, 'imprint', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Index', 'Welcome', '<p>This Onlineshop was created with <a href="http://www.gambio.de"><strong>Gambio Shopsoftware</strong></a>.</p>\r\n<p>This text can be edited at Content Manager -&gt; Index in the backend.</p>', 0, 1, '', '', 0, 5, 0, '', '_blank', '0.0', 'always', '2011-03-16 16:28:26', 1, '', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Privatsphäre und Datenschutz', 'Privatsphäre und Datenschutz', '<p>F&uuml;gen Sie hier Ihre Informationen &uuml;ber Privatsph&auml;re und Datenschutz ein. Alternativ k&ouml;nnen Sie das Plugin <i>janolaw AGB-Hosting</i> nutzen und Ihre Datenschutzerkl&auml;rung mithilfe eines Online-Assistenten direkt zusammen mit AGB, Widerrufsbelehrung und Impressum erstellen. In nur wenigen Minuten haben Sie&nbsp;unter fachkundiger Anleitung die <strong>wichtigsten</strong> Dokumente f&uuml;r Ihren Shop <strong>individuell</strong> zusammengestellt.</p><p>Das Plugin sorgt&nbsp;daf&uuml;r, dass die Dokumente in Ihren Shop eingebunden und bei ver&auml;nderter Rechtslage <strong>automatisch aktualisiert</strong> werden. Dabei wird die aktuelle Widerrufsbelehrung zus&auml;tzlich auch in der <strong>E-Mail-Best&auml;tigung</strong> angezeigt, die Sie an Ihre Kunden verschicken. Zusammen mit&nbsp;der <strong>Abmahnkostenhaftung</strong> durch die janolaw AG sind Sie damit optimal vor Abmahnungen gesch&uuml;tzt. <a href="http://www.janolaw.de/internetrecht/agb/agb-hosting-service/gambio/?partnerid=8604#menu">Hier</a> k&ouml;nnen Sie den Service unseres Partners janolaw buchen.</p>', 3, 1, '', '', 1, 2, 0, '', '_blank', '0.0', 'always', '2008-08-26 19:59:30', 1, 'privatsphaere-und-datenschutz', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'AGB', 'Allgemeine Geschäftsbedingungen', '<strong>Hinweis:</strong><br />\r\nSie haben soeben eine <strong>&Auml;nderung in Ihren Zahlungseinstellungen</strong> vorgenommen. Beachten Sie, dass Sie ggf. Ihre rechtlichen Dokumente, in diesem Fall die <strong>Datenschutzerkl&auml;rung, anpassen</strong> m&uuml;ssen, um nicht das Risiko einer Abmahnung einzugehen.  <br />\r\n<br />\r\n<strong>Unsere Empfehlung:</strong> <br />\r\nNutzen Sie den preiswerten <strong>AGB Hosting-Service</strong> unseres Partners janolaw.  janolaw hilft Ihnen bei der Online-Erstellung Ihrer Datenschutzerkl&auml;rung sowie der AGB, Widerrufsbelehrung und des Impressums und h&auml;lt diese Dokumente f&uuml;r Sie aktuell. Einfach und bequem &uuml;ber die Gambio Schnittstelle. Mit <strong>dauerhaft 10% Rabatt</strong> f&uuml;r Sie als Gambio Kunde. <br />\r\n<br />\r\n<a type="Hier k&ouml;nnen Sie den Service buchen" href="http://www.janolaw.de/internetrecht/agb/agb-hosting-service/gambio/?partnerid=8604#menu" target="_blank" title="Hier k&ouml;nnen Sie den Service buchen">Hier k&ouml;nnen Sie den Service buchen</a><br />', 1, 1, '', '', 1, 3, 0, '', '_blank', '0.0', 'always', '2012-01-30 14:45:57', 1, 'allgemeine-geschaeftsbedingungen', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Suchen', '', '', 0, 3, '', '', 0, 30, 1, 'advanced_search.php', '_top', '0.0', 'always', '2008-07-30 04:24:06', 0, '', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Impressum', 'Impressum', '<p>F&uuml;gen Sie hier Ihr Impressum ein. Alternativ k&ouml;nnen Sie das Plugin <i>janolaw AGB-Hosting</i> nutzen und Ihr Impressum mithilfe eines Online-Assistenten direkt zusammen mit AGB, Widerrufsbelehrung und Datenschutzerkl&auml;rung erstellen. In nur wenigen Minuten haben Sie&nbsp;unter fachkundiger Anleitung die <strong>wichtigsten</strong> Dokumente f&uuml;r Ihren Shop <strong>individuell</strong> zusammengestellt.</p><p>Das Plugin sorgt&nbsp;daf&uuml;r, dass die Dokumente in Ihren Shop eingebunden und bei ver&auml;nderter Rechtslage <strong>automatisch aktualisiert</strong> werden. Dabei wird die aktuelle Widerrufsbelehrung zus&auml;tzlich auch in der <strong>E-Mail-Best&auml;tigung</strong> angezeigt, die Sie an Ihre Kunden verschicken. Zusammen mit&nbsp;der <strong>Abmahnkostenhaftung</strong> durch die janolaw AG sind Sie damit optimal vor Abmahnungen gesch&uuml;tzt. <a href="http://www.janolaw.de/internetrecht/agb/agb-hosting-service/gambio/?partnerid=8604#menu">Hier</a> k&ouml;nnen Sie den Service unseres Partners janolaw buchen.</p>', 0, 1, '', '', 1, 4, 0, '', '_top',   '1.0', 'always', '2008-07-29 18:01:46', 1, 'impressum', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Index', '', '<p>Dieser Onlineshop wurde mit der <a href="http://www.gambio.de"><strong>Gambio Shopsoftware</strong></a> erstellt.</p>\r\n<p>Diesen Text k&ouml;nnen Sie im Administrationsbereich unter Content Manager -&gt; Index bearbeiten.</p>', 0, 1, '', '', 0, 5, 0, '', '_blank', '0.0', 'always', '2011-03-16 16:24:27', 1, '', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Gutscheine', 'Gutscheine - Fragen und Antworte', '<table cellSpacing=0 cellPadding=0>\r\n<tbody>\r\n<tr>\r\n<td class=main><STRONG>Gutscheine kaufen </STRONG></td></tr>\r\n<tr>\r\n<td class=main>Gutscheine können, falls sie im Shop angeboten werden, wie normale Artikel gekauft werden. Sobald Sie einen Gutschein gekauft haben und dieser nach erfolgreicher Zahlung freigeschaltet wurde, erscheint der Betrag unter Ihrem Warenkorb. Nun können Sie über den Link " Gutschein versenden " den gewünschten Betrag per E-Mail versenden. </td></tr></tbody></table>\r\n<table cellSpacing=0 cellPadding=0>\r\n<tbody>\r\n<tr>\r\n<td class=main><STRONG>Wie man Gutscheine versendet </STRONG></td></tr>\r\n<tr>\r\n<td class=main>Um einen Gutschein zu versenden, klicken Sie bitte auf den Link "Gutschein versenden" in Ihrem Einkaufskorb. Um einen Gutschein zu versenden, benötigen wir folgende Angaben von Ihnen: Vor- und Nachname des Empfängers. Eine gültige E-Mail Adresse des Empfängers. Den gewünschten Betrag (Sie können auch Teilbeträge Ihres Guthabens versenden). Eine kurze Nachricht an den Empfänger. Bitte überprüfen Sie Ihre Angaben noch einmal vor dem Versenden. Sie haben vor dem Versenden jederzeit die Möglichkeit Ihre Angaben zu korrigieren. </td></tr></tbody></table>\r\n<table cellSpacing=0 cellPadding=0>\r\n<tbody>\r\n<tr>\r\n<td class=main><STRONG>Mit Gutscheinen Einkaufen. </STRONG></td></tr>\r\n<tr>\r\n<td class=main>Sobald Sie über ein Guthaben verfügen, können Sie dieses zum Bezahlen Ihrer Bestellung verwenden. Während des Bestellvorganges haben Sie die Möglichkeit Ihr Guthaben einzulösen. Falls das Guthaben unter dem Warenwert liegt müssen Sie Ihre bevorzugte Zahlungsweise für den Differenzbetrag wählen. Übersteigt Ihr Guthaben den Warenwert, steht Ihnen das Restguthaben selbstverständlich für Ihre nächste Bestellung zur Verfügung. </td></tr></tbody></table>\r\n<table cellSpacing=0 cellPadding=0>\r\n<tbody>\r\n<tr>\r\n<td class=main><STRONG>Gutscheine verbuchen. </STRONG></td></tr>\r\n<tr>\r\n<td class=main>Wenn Sie einen Gutschein per E-Mail erhalten haben, können Sie den Betrag wie folgt verbuchen:. <br />1. Klicken Sie auf den in der E-Mail angegebenen Link. Falls Sie noch nicht über ein persönliches Kundenkonto verfügen, haben Sie die Möglichkeit ein Konto zu eröffnen. <br />2. Nachdem Sie ein Produkt in den Warenkorb gelegt haben, können Sie dort Ihren Gutscheincode eingeben.</td></tr></tbody></table>\r\n<table cellSpacing=0 cellPadding=0>\r\n<tbody>\r\n<tr>\r\n<td class=main><STRONG>Falls es zu Problemen kommen sollte: </STRONG></td></tr>\r\n<tr>\r\n<td class=main>Falls es wider Erwarten zu Problemen mit einem Gutschein kommen sollte, kontaktieren Sie uns bitte per E-Mail : you@yourdomain.com. Bitte beschreiben Sie möglichst genau das Problem, wichtige Angaben sind unter anderem: Ihre Kundennummer, der Gutscheincode, Fehlermeldungen des Systems sowie der von Ihnen benutzte Browser. </td></tr></tbody></table>', 0, 1, '', '', 0, 6, 1, '', '', '', '', NULL, 1, '', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Vouchers', 'Vouchers', '<p>Enter your Vouchers information here.</p>', 0, 1, '', '', 0, 6, 1, '', '_blank', '0.0', 'always', '2008-08-25 17:23:24', 1, '', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Über uns', 'Über uns', '<p>F&uuml;gen Sie hier Ihre Informationen &uuml;ber sich bzw. Ihr Unternehmen ein.</p>', 1, 3, '', '', 0, 82, 1, '', '_blank', '0.0', 'always', '2008-08-25 17:57:47', 0, '', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Kontakt', 'Kontakt', '<p>F&uuml;gen Sie hier Ihre Kontaktinformationen ein.</p>', 0, 1, '', '', 1, 7, 0, '', '_blank', '0.0', 'always', '2008-08-26 20:00:45', 1, 'mein-kontakt', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Contact', 'Contact', '<p>Enter your Contact information here.</p>', 0, 1, '', '', 1, 7, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:23:42', 1, 'contact', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Sitemap', '', '', 0, 0, 'sitemap.php', '', 1, 8, 0, '', '', '', '', NULL, 1, 'sitemap', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Sitemap', 'Sitemap', '', 0, 0, 'sitemap.php', '', 1, 8, 0, '', '_blank', '', '', NULL, 1, 'sitemap', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Callback Service', 'Callback Service', '<p>Den Inhalt dieses Bereiches k&ouml;nnen Sie im Administrationsbereich unter Content Manager -&gt; Callback Service bearbeiten.</p>', 5, 1, 'gm_callback_service.php', '', 1, 14, 1, '', '_blank', '0.0', 'always', '2008-08-26 20:02:29', 1, 'callback-service', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Zusatzbox 1', 'Zusatzbox 1', '<p style="text-align: center;"><a href="http://validator.w3.org/check?uri=referer"><img height="31" width="88" alt="Valid XHTML 1.0 Transitional" src="http://www.w3.org/Icons/valid-xhtml10" /></a></p>', 0, 4, '', '', 1, 61, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:45:27', 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Zusatzbox 2', 'Zusatzbox 2 Titel', '<p>Zusatzbox Inhalt</p>\r\n<br />', 0, 4, '', '', 1, 62, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:10', 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Zusatzbox 3', 'Zusatzbox 3 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', '', 1, 63, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:17', 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Zusatzbox 4', 'Zusatzbox 4 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', '', 0, 64, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:22', 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Zusatzbox 5', 'Zusatzbox 5 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', '', 0, 65, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:29', 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Zusatzbox 6', 'Zusatzbox 6 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', '', 0, 66, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:35', 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Zusatzbox 7', 'Zusatzbox 7 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', '', 0, 67, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:41', 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Zusatzbox 8', 'Zusatzbox 8 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', '', 0, 68, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:50', 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Zusatzbox 9', 'Zusatzbox 9 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', '', 1, 69, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:17:00', 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Extrabox 1', 'Extrabox 1 Title', '<a href="http://validator.w3.org/check?uri=referer"><img src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid XHTML 1.0 Transitional" height="31" width="88" /></a>', 0, 4, '', '', 1, 61, 0, '', '_blank', '0.0', 'always', '2008-08-15 09:24:18', 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Extrabox 2', 'Extrabox 2 Title', 'Content Extrabox', 0, 4, '', '', 1, 62, 0, '', '', '', '', NULL, 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Extrabox 3', 'Extrabox 3 Title', 'Content Extrabox', 0, 4, '', '', 1, 63, 0, '', '', '', '', NULL, 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Extrabox 4', 'Extrabox 4 Title', 'Content Extrabox', 0, 4, '', '', 1, 64, 0, '', '', '', '', NULL, 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Extrabox 5', 'Extrabox 5 Title', 'Content Extrabox', 0, 4, '', '', 1, 65, 0, '', '', '', '', NULL, 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Extrabox 6', 'Extrabox 6 Title', 'Content Extrabox', 0, 4, '', '', 1, 66, 0, '', '', '', '', NULL, 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Extrabox 7', 'Extrabox 7 Title', 'Content Extrabox', 0, 4, '', '', 1, 67, 0, '', '', '', '', NULL, 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Extrabox 8', 'Extrabox 8 Title', 'Content Extrabox', 0, 4, '', '', 1, 68, 0, '', '', '', '', NULL, 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Extrabox 9', 'Extrabox 9 Title', 'Content Extrabox', 0, 4, '', '', 1, 69, 0, '', '', '', '', NULL, 1, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Trusted Shops', 'Trusted Shops', '', '', 0, 1, 'trustedshops.php', 0, 15, 1, '', '_blank', '1.0', 'never', '2008-08-26 20:02:53', 1, 'trusted-shops', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Index (center)', '', '', 0, 1, '', '', 0, 10, 0, '', '_blank', '0.0', 'always', '2008-07-29 18:04:53', 1, '', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Index (Mitte)', '', '', 0, 1, '', '', 0, 10, 0, '', '_blank', '0.0', 'always', '2008-07-29 18:03:44', 1, '', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Index (bottom)', '', '', 0, 1, '', '', 0, 11, 0, '', '_blank', '0.0', 'always', '2008-07-29 18:04:53', 1, '', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Index (unten)', '', '', 0, 1, '', '', 0, 11, 0, '', '_blank', '0.0', 'always', '2008-07-29 18:03:44', 1, '', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Footer', '', '<p>This text can be edited at Content Manager -&gt; Footer in the backend.</p>', 0, 4, '', '', 1, 199, 0, '', '_blank', '0.0', 'always', '2011-03-17 11:39:53', 0, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Footer', '', '<p>Diesen Text k&ouml;nnen Sie im Administrationsbereich unter Content Manager -&gt; Footer bearbeiten.</p>', 0, 4, '', '', 1, 199, 0, '', '_blank', '0.0', 'always', '2011-03-17 11:39:26', 0, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Checkout confirmation information', '', '', 0, 4, '', '', 1, 198, 0, '', '_blank', '0.0', 'always', '2011-03-17 11:39:53', 0, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Bestellzusammenfassung Information', '', '', 0, 4, '', '', 1, 198, 0, '', '_blank', '0.0', 'always', '2011-03-17 11:39:26', 0, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Shipping & payment conditions', 'Shipping & payment conditions', 'Enter your information about shipping and payment conditions here. <br /><br />{$shipping_and_payment_matrix}<br />', 0, 1, '', '', 1, 3889891, 0, '', '_blank', '1.0', 'never', '2014-06-10 13:46:44', 1, 'Shipping-and-payment-conditions', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Versand- & Zahlungsbedingungen', 'Versand- & Zahlungsbedingungen', 'F&uuml;gen Sie hier Ihre Informationen zu Versand- &amp; Zahlungsbedingungen ein. <br /><br />{$shipping_and_payment_matrix}<br />', 0, 1, '', '', 1, 3889891, 0, '', '_blank', '1.0', 'never', '2014-06-10 13:46:44', 1, 'Versand-und-Zahlungsbedingungen', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Right of Withdrawal / Model Withdrawal Form', 'Right of Withdrawal / Model Withdrawal Form', '<img alt="" src="templates/EyeCandy/img/icon_arrow.gif" style="margin-bottom:2px" /> <a href="{$PAGE_URL}#withdrawal_rights"><u>Right of Withdrawal</u></a> <br />\r\n<br />\r\n<img alt="" src="templates/EyeCandy/img/icon_arrow.gif" style="margin-bottom:2px" /> <a href="{$PAGE_URL}#withdrawal_form"><u>Model Withdrawal Form</u></a> <br />\r\n<br />\r\n<br />\r\n<h2 style="border-bottom: 1px solid #DADADA; padding-bottom: 5px; color: #666666; font-size: 14px;"><a name="withdrawal_rights"></a>Right of Withdrawal <span style="font-size: 13px; font-weight: normal;">(<a href="{$PDF_URL}"><u>Download as PDF</u></a>)</span></h2>\r\n<span style="color: #666666">{$WITHDRAWAL_TEXT}</span><br />\r\n<br />\r\n<br />\r\n{* withdrawal_form_start *}\r\n<h2 style="border-bottom: 1px solid #DADADA; padding-bottom: 5px; color: #666666; font-size: 14px;"><a name="withdrawal_form"></a>Model Withdrawal Form</h2>\r\n{* withdrawal_pdf_link_start *}<span style=" color: #666666;">Our model withdrawal form as PDF document: <a href="{$PDF_FORM_URL}"><u>DOWNLOAD</u></a></span><br />\r\n{* withdrawal_pdf_link_end *} {* withdrawal_form_link_start *}<span style=" color: #666666;">Our online model withdrawal form: <a href="{$WEBFORM_URL}"><u>ONLINE-FORM</u></a></span><br />\r\n{* withdrawal_form_link_end *} <br />\r\n<br />\r\n{* withdrawal_form_end *}<span style="color: #999999"><em>To open the downloadable PDF-files, you need an additional program such as the Adobe Reader, which you can download online for free. The current version of the Adobe Reader you can find <a href="http://get.adobe.com/uk/reader/" target="_blank" style="color: #999999"><u>here</u></a>.</em></span><br />\r\n<br />', 0, 1, '', '', 1, 3889895, 0, '', '_blank', '1.0', 'never', '2008-08-26 20:02:53', 1, 'Right-of-Withdrawal--Model-Withdrawal-Form', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Widerrufsrecht & Muster-Widerrufsformular', 'Widerrufsrecht & Muster-Widerrufsformular', '<img style="margin-bottom:2px" src="templates/EyeCandy/img/icon_arrow.gif" alt="" /> <a href="{$PAGE_URL}#withdrawal_rights"><u>Widerrufsrecht</u></a> <br />\r\n<br />\r\n<img style="margin-bottom:2px" src="templates/EyeCandy/img/icon_arrow.gif" alt="" /> <a href="{$PAGE_URL}#withdrawal_form"><u>Muster-Widerrufsformular</u></a> <br />\r\n<br />\r\n<br />\r\n<h2 style="border-bottom: 1px solid #DADADA; padding-bottom: 5px; color: #666666; font-size: 14px;"><a name="withdrawal_rights"></a>Widerrufsrecht <span style="font-size: 13px; font-weight: normal;">(<a href="{$PDF_URL}"><u>Als PDF downloaden</u></a>)</span></h2>\r\n<span style="color: #666666">{$WITHDRAWAL_TEXT}</span><br />\r\n<br />\r\n<br />\r\n{* withdrawal_form_start *}\r\n<h2 style="border-bottom: 1px solid #DADADA; padding-bottom: 5px; color: #666666; font-size: 14px;"><a name="withdrawal_form"></a>Muster-Widerrufsformular</h2>\r\n{* withdrawal_pdf_link_start *}<span style=" color: #666666;">Unser Muster-Widerrufsformular im PDF-Format: <a href="{$PDF_FORM_URL}"><u>DOWNLOAD</u></a></span><br />\r\n{* withdrawal_pdf_link_end *} {* withdrawal_form_link_start *}<span style=" color: #666666;">Unser Muster-Widerrufsformular zum online Ausf&uuml;llen: <a href="{$WEBFORM_URL}"><u>ONLINE-FORMULAR</u></a></span><br />\r\n{* withdrawal_form_link_end *} <br />\r\n<br />\r\n{* withdrawal_form_end *}<span style="color: #999999"><em>Um die zum Download angebotenen PDF-Dateien zu &ouml;ffnen, ben&ouml;tigen Sie ein Zusatzprogramm, wie zum Beispiel den Adobe Reader, welchen Sie im Internet kostenfrei herunterladen k&ouml;nnen. Die aktuelle Version des Adobe Readers finden Sie <a href="http://get.adobe.com/de/reader/" target="_blank" style="color: #999999"><u>hier</u></a>.</em></span><br />\r\n<br />', 0, 1, '', '', 1, 3889895, 0, '', '_blank', '1.0', 'never', '2008-08-26 20:02:53', 1, 'Widerrufsrecht-und-Muster-Widerrufsformular', 0);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Withdrawal 1', 'Withdrawal 1', '<p>Enter your Withdrawal information here.</p>', 1, 5, '', '', 1, 3889896, 0, '', '_blank', '1.0', 'never', '2014-07-03 12:12:50', 0, 'Withdrawal-1', '1');
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Withdrawal 2', 'Withdrawal 2', 'Withdrawal 2 content', 2, 5, '', '', 0, 3889897, 0, '', '_blank', '1.0', 'never', '2014-06-10 13:46:44', 0, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Withdrawal 3', 'Withdrawal 3', 'Withdrawal 3 content', 3, 5, '', '', 0, 3889898, 0, '', '_blank', '1.0', 'never', '2014-06-10 13:46:44', 0, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 1, 'Withdrawal 4', 'Withdrawal 4', 'Withdrawal 4 content', 4, 5, '', '', 0, 3889899, 0, '', '_blank', '1.0', 'never', '2014-06-10 13:46:44', 0, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Widerrufsrecht 1', 'Widerrufsrecht 1', '<p>F&uuml;gen Sie hier Ihre Hinweise zum Widerrufsrecht ein. Alternativ k&ouml;nnen Sie das Plugin <em>janolaw AGB-Hosting</em> nutzen und Ihre Widerrufsbelehrung mithilfe eines Online-Assistenten direkt zusammen mit AGB, Datenschutzerkl&auml;rung und Impressum erstellen. In nur wenigen Minuten haben Sie&nbsp;unter fachkundiger Anleitung die <strong>wichtigsten</strong> Dokumente f&uuml;r Ihren Shop <strong>individuell </strong>zusammengestellt.</p>\r\n\r\n<p>Das Plugin sorgt&nbsp;daf&uuml;r, dass die Dokumente in Ihren Shop eingebunden und bei ver&auml;nderter Rechtslage <strong>automatisch aktualisiert</strong> werden. Dabei wird die aktuelle Widerrufsbelehrung zus&auml;tzlich auch in der <strong>E-Mail-Best&auml;tigung</strong> angezeigt, die Sie an Ihre Kunden verschicken. Zusammen mit der <strong>Abmahnkostenhaftung</strong> durch die janolaw AG sind Sie damit optimal vor Abmahnungen gesch&uuml;tzt. <a href="http://www.janolaw.de/internetrecht/agb/agb-hosting-service/gambio/?partnerid=8604#menu">Hier</a> k&ouml;nnen Sie den Service unseres Partners janolaw buchen.</p>', 1, 5, '', '', 1, 3889896, 0, '', '_blank', '1.0', 'never', '2014-07-03 12:11:43', 0, 'Widerrufsrecht-1', '1');
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Widerrufsrecht 2', 'Widerrufsrecht 2', 'Widerrufsrecht 2 Inhalt', 2, 5, '', '', 0, 3889897, 0, '', '_blank', '1.0', 'never', '2014-06-10 13:46:44', 0, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Widerrufsrecht 3', 'Widerrufsrecht 3', 'Widerrufsrecht 3 Inhalt', 3, 5, '', '', 0, 3889898, 0, '', '_blank', '1.0', 'never', '2014-06-10 13:46:44', 0, '', 1);
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `download_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `protected`) VALUES(0, 0, '', 2, 'Widerrufsrecht 4', 'Widerrufsrecht 4', 'Widerrufsrecht 4 Inhalt', 4, 5, '', '', 0, 3889899, 0, '', '_blank', '1.0', 'never', '2014-06-10 13:46:44', 0, '', 1);

INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(1, 'Afghanistan', 'AF', 'AFG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(2, 'Albania', 'AL', 'ALB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(3, 'Algeria', 'DZ', 'DZA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(4, 'American Samoa', 'AS', 'ASM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(5, 'Andorra', 'AD', 'AND', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(6, 'Angola', 'AO', 'AGO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(7, 'Anguilla', 'AI', 'AIA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(8, 'Antarctica', 'AQ', 'ATA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(9, 'Antigua and Barbuda', 'AG', 'ATG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(10, 'Argentina', 'AR', 'ARG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(11, 'Armenia', 'AM', 'ARM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(12, 'Aruba', 'AW', 'ABW', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(13, 'Australia', 'AU', 'AUS', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(14, 'Austria', 'AT', 'AUT', 5, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(15, 'Azerbaijan', 'AZ', 'AZE', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(16, 'Bahamas', 'BS', 'BHS', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(17, 'Bahrain', 'BH', 'BHR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(18, 'Bangladesh', 'BD', 'BGD', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(19, 'Barbados', 'BB', 'BRB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(20, 'Belarus', 'BY', 'BLR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(21, 'Belgium', 'BE', 'BEL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(22, 'Belize', 'BZ', 'BLZ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(23, 'Benin', 'BJ', 'BEN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(24, 'Bermuda', 'BM', 'BMU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(25, 'Bhutan', 'BT', 'BTN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(26, 'Bolivia', 'BO', 'BOL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(27, 'Bosnia and Herzegowina', 'BA', 'BIH', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(28, 'Botswana', 'BW', 'BWA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(29, 'Bouvet Island', 'BV', 'BVT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(30, 'Brazil', 'BR', 'BRA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(31, 'British Indian Ocean Territory', 'IO', 'IOT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(32, 'Brunei Darussalam', 'BN', 'BRN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(33, 'Bulgaria', 'BG', 'BGR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(34, 'Burkina Faso', 'BF', 'BFA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(35, 'Burundi', 'BI', 'BDI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(36, 'Cambodia', 'KH', 'KHM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(37, 'Cameroon', 'CM', 'CMR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(38, 'Canada', 'CA', 'CAN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(39, 'Cape Verde', 'CV', 'CPV', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(40, 'Cayman Islands', 'KY', 'CYM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(41, 'Central African Republic', 'CF', 'CAF', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(42, 'Chad', 'TD', 'TCD', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(43, 'Chile', 'CL', 'CHL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(44, 'China', 'CN', 'CHN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(45, 'Christmas Island', 'CX', 'CXR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(46, 'Cocos (Keeling) Islands', 'CC', 'CCK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(47, 'Colombia', 'CO', 'COL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(48, 'Comoros', 'KM', 'COM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(49, 'Congo', 'CG', 'COG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(50, 'Cook Islands', 'CK', 'COK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(51, 'Costa Rica', 'CR', 'CRI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(52, 'Cote D''Ivoire', 'CI', 'CIV', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(53, 'Croatia', 'HR', 'HRV', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(54, 'Cuba', 'CU', 'CUB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(55, 'Cyprus', 'CY', 'CYP', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(56, 'Czech Republic', 'CZ', 'CZE', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(57, 'Denmark', 'DK', 'DNK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(58, 'Djibouti', 'DJ', 'DJI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(59, 'Dominica', 'DM', 'DMA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(60, 'Dominican Republic', 'DO', 'DOM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(61, 'East Timor', 'TP', 'TMP', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(62, 'Ecuador', 'EC', 'ECU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(63, 'Egypt', 'EG', 'EGY', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(64, 'El Salvador', 'SV', 'SLV', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(65, 'Equatorial Guinea', 'GQ', 'GNQ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(66, 'Eritrea', 'ER', 'ERI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(67, 'Estonia', 'EE', 'EST', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(68, 'Ethiopia', 'ET', 'ETH', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(69, 'Falkland Islands (Malvinas)', 'FK', 'FLK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(70, 'Faroe Islands', 'FO', 'FRO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(71, 'Fiji', 'FJ', 'FJI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(72, 'Finland', 'FI', 'FIN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(73, 'France', 'FR', 'FRA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(74, 'France, Metropolitan', 'FX', 'FXX', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(75, 'French Guiana', 'GF', 'GUF', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(76, 'French Polynesia', 'PF', 'PYF', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(77, 'French Southern Territories', 'TF', 'ATF', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(78, 'Gabon', 'GA', 'GAB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(79, 'Gambia', 'GM', 'GMB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(80, 'Georgia', 'GE', 'GEO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(81, 'Germany', 'DE', 'DEU', 5, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(82, 'Ghana', 'GH', 'GHA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(83, 'Gibraltar', 'GI', 'GIB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(84, 'Greece', 'GR', 'GRC', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(85, 'Greenland', 'GL', 'GRL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(86, 'Grenada', 'GD', 'GRD', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(87, 'Guadeloupe', 'GP', 'GLP', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(88, 'Guam', 'GU', 'GUM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(89, 'Guatemala', 'GT', 'GTM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(90, 'Guinea', 'GN', 'GIN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(91, 'Guinea-bissau', 'GW', 'GNB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(92, 'Guyana', 'GY', 'GUY', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(93, 'Haiti', 'HT', 'HTI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(94, 'Heard and Mc Donald Islands', 'HM', 'HMD', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(95, 'Honduras', 'HN', 'HND', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(96, 'Hong Kong', 'HK', 'HKG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(97, 'Hungary', 'HU', 'HUN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(98, 'Iceland', 'IS', 'ISL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(99, 'India', 'IN', 'IND', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(100, 'Indonesia', 'ID', 'IDN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(101, 'Iran (Islamic Republic of)', 'IR', 'IRN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(102, 'Iraq', 'IQ', 'IRQ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(103, 'Ireland', 'IE', 'IRL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(104, 'Israel', 'IL', 'ISR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(105, 'Italy', 'IT', 'ITA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(106, 'Jamaica', 'JM', 'JAM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(107, 'Japan', 'JP', 'JPN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(108, 'Jordan', 'JO', 'JOR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(109, 'Kazakhstan', 'KZ', 'KAZ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(110, 'Kenya', 'KE', 'KEN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(111, 'Kiribati', 'KI', 'KIR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(112, 'Korea, Democratic People''s Republic of', 'KP', 'PRK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(113, 'Korea, Republic of', 'KR', 'KOR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(114, 'Kuwait', 'KW', 'KWT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(115, 'Kyrgyzstan', 'KG', 'KGZ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(116, 'Lao People''s Democratic Republic', 'LA', 'LAO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(117, 'Latvia', 'LV', 'LVA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(118, 'Lebanon', 'LB', 'LBN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(119, 'Lesotho', 'LS', 'LSO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(120, 'Liberia', 'LR', 'LBR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(121, 'Libyan Arab Jamahiriya', 'LY', 'LBY', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(122, 'Liechtenstein', 'LI', 'LIE', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(123, 'Lithuania', 'LT', 'LTU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(124, 'Luxembourg', 'LU', 'LUX', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(125, 'Macau', 'MO', 'MAC', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(126, 'Macedonia, The Former Yugoslav Republic of', 'MK', 'MKD', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(127, 'Madagascar', 'MG', 'MDG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(128, 'Malawi', 'MW', 'MWI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(129, 'Malaysia', 'MY', 'MYS', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(130, 'Maldives', 'MV', 'MDV', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(131, 'Mali', 'ML', 'MLI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(132, 'Malta', 'MT', 'MLT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(133, 'Marshall Islands', 'MH', 'MHL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(134, 'Martinique', 'MQ', 'MTQ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(135, 'Mauritania', 'MR', 'MRT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(136, 'Mauritius', 'MU', 'MUS', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(137, 'Mayotte', 'YT', 'MYT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(138, 'Mexico', 'MX', 'MEX', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(139, 'Micronesia, Federated States of', 'FM', 'FSM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(140, 'Moldova, Republic of', 'MD', 'MDA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(141, 'Monaco', 'MC', 'MCO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(142, 'Mongolia', 'MN', 'MNG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(143, 'Montserrat', 'MS', 'MSR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(144, 'Morocco', 'MA', 'MAR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(145, 'Mozambique', 'MZ', 'MOZ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(146, 'Myanmar', 'MM', 'MMR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(147, 'Namibia', 'NA', 'NAM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(148, 'Nauru', 'NR', 'NRU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(149, 'Nepal', 'NP', 'NPL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(150, 'Netherlands', 'NL', 'NLD', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(151, 'Netherlands Antilles', 'AN', 'ANT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(152, 'New Caledonia', 'NC', 'NCL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(153, 'New Zealand', 'NZ', 'NZL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(154, 'Nicaragua', 'NI', 'NIC', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(155, 'Niger', 'NE', 'NER', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(156, 'Nigeria', 'NG', 'NGA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(157, 'Niue', 'NU', 'NIU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(158, 'Norfolk Island', 'NF', 'NFK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(159, 'Northern Mariana Islands', 'MP', 'MNP', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(160, 'Norway', 'NO', 'NOR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(161, 'Oman', 'OM', 'OMN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(162, 'Pakistan', 'PK', 'PAK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(163, 'Palau', 'PW', 'PLW', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(164, 'Panama', 'PA', 'PAN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(165, 'Papua New Guinea', 'PG', 'PNG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(166, 'Paraguay', 'PY', 'PRY', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(167, 'Peru', 'PE', 'PER', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(168, 'Philippines', 'PH', 'PHL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(169, 'Pitcairn', 'PN', 'PCN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(170, 'Poland', 'PL', 'POL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(171, 'Portugal', 'PT', 'PRT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(172, 'Puerto Rico', 'PR', 'PRI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(173, 'Qatar', 'QA', 'QAT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(174, 'Reunion', 'RE', 'REU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(175, 'Romania', 'RO', 'ROM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(176, 'Russian Federation', 'RU', 'RUS', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(177, 'Rwanda', 'RW', 'RWA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(178, 'Saint Kitts and Nevis', 'KN', 'KNA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(179, 'Saint Lucia', 'LC', 'LCA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(180, 'Saint Vincent and the Grenadines', 'VC', 'VCT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(181, 'Samoa', 'WS', 'WSM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(182, 'San Marino', 'SM', 'SMR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(183, 'Sao Tome and Principe', 'ST', 'STP', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(184, 'Saudi Arabia', 'SA', 'SAU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(185, 'Senegal', 'SN', 'SEN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(186, 'Seychelles', 'SC', 'SYC', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(187, 'Sierra Leone', 'SL', 'SLE', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(188, 'Singapore', 'SG', 'SGP', 4, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(189, 'Slovakia (Slovak Republic)', 'SK', 'SVK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(190, 'Slovenia', 'SI', 'SVN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(191, 'Solomon Islands', 'SB', 'SLB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(192, 'Somalia', 'SO', 'SOM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(193, 'South Africa', 'ZA', 'ZAF', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(194, 'South Georgia and the South Sandwich Islands', 'GS', 'SGS', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(195, 'Spain', 'ES', 'ESP', 3, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(196, 'Sri Lanka', 'LK', 'LKA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(197, 'St. Helena', 'SH', 'SHN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(198, 'St. Pierre and Miquelon', 'PM', 'SPM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(199, 'Sudan', 'SD', 'SDN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(200, 'Suriname', 'SR', 'SUR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(201, 'Svalbard and Jan Mayen Islands', 'SJ', 'SJM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(202, 'Swaziland', 'SZ', 'SWZ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(203, 'Sweden', 'SE', 'SWE', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(204, 'Switzerland', 'CH', 'CHE', 5, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(205, 'Syrian Arab Republic', 'SY', 'SYR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(206, 'Taiwan', 'TW', 'TWN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(207, 'Tajikistan', 'TJ', 'TJK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(208, 'Tanzania, United Republic of', 'TZ', 'TZA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(209, 'Thailand', 'TH', 'THA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(210, 'Togo', 'TG', 'TGO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(211, 'Tokelau', 'TK', 'TKL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(212, 'Tonga', 'TO', 'TON', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(213, 'Trinidad and Tobago', 'TT', 'TTO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(214, 'Tunisia', 'TN', 'TUN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(215, 'Turkey', 'TR', 'TUR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(216, 'Turkmenistan', 'TM', 'TKM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(217, 'Turks and Caicos Islands', 'TC', 'TCA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(218, 'Tuvalu', 'TV', 'TUV', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(219, 'Uganda', 'UG', 'UGA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(220, 'Ukraine', 'UA', 'UKR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(221, 'United Arab Emirates', 'AE', 'ARE', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(222, 'United Kingdom', 'GB', 'GBR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(223, 'United States', 'US', 'USA', 2, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(224, 'United States Minor Outlying Islands', 'UM', 'UMI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(225, 'Uruguay', 'UY', 'URY', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(226, 'Uzbekistan', 'UZ', 'UZB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(227, 'Vanuatu', 'VU', 'VUT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(228, 'Vatican City State (Holy See)', 'VA', 'VAT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(229, 'Venezuela', 'VE', 'VEN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(230, 'Viet Nam', 'VN', 'VNM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(231, 'Virgin Islands (British)', 'VG', 'VGB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(232, 'Virgin Islands (U.S.)', 'VI', 'VIR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(233, 'Wallis and Futuna Islands', 'WF', 'WLF', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(234, 'Western Sahara', 'EH', 'ESH', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(235, 'Yemen', 'YE', 'YEM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(236, 'Yugoslavia', 'YU', 'YUG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(237, 'Zaire', 'ZR', 'ZAR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(238, 'Zambia', 'ZM', 'ZMB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(239, 'Zimbabwe', 'ZW', 'ZWE', 1, 1);

INSERT INTO `currencies` (`currencies_id`, `title`, `code`, `symbol_left`, `symbol_right`, `decimal_point`, `thousands_point`, `decimal_places`, `value`, `last_updated`) VALUES(1, 'Euro', 'EUR', '', 'EUR', ',', '.', '2', 1.00000000, '2008-05-08 14:15:39');
INSERT INTO `currencies` (`currencies_id`, `title`, `code`, `symbol_left`, `symbol_right`, `decimal_point`, `thousands_point`, `decimal_places`, `value`, `last_updated`) VALUES(2, 'Dollar', 'USD', '', 'USD', '.', ',', '2', 1.55792999, '2008-05-08 14:15:39');
INSERT INTO `currencies` (`currencies_id`, `title`, `code`, `symbol_left`, `symbol_right`, `decimal_point`, `thousands_point`, `decimal_places`, `value`, `last_updated`) VALUES(3, 'Schweizer Franken', 'CHF', '', 'CHF', ',', '.', '2', 1.62945998, NULL);

INSERT INTO `database_version` (`version`) VALUES('3.0.4.0');

INSERT INTO `categories_index` (`products_id`, `categories_index`) VALUES(1, '-0--1-');

INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(1, 2, '[Gambio] Google Shopping', 'google_shopping.txt', '\\t', '', '2013-05-11 12:52:03', '2013-05-11 14:48:29', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(2, 2, '[Gambio] Billiger.de', 'billiger.csv', '|', '', '2013-05-11 12:52:03', '2013-05-11 14:48:29', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(3, 2, '[Gambio] Idealo.de', 'idealo.csv', '\\t', '', '2013-05-11 12:52:03', '2013-05-11 14:48:29', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(4, 2, '[Gambio] Preisroboter.de', 'preisroboter.txt', '|', '', '2013-05-11 12:52:03', '2013-05-11 14:48:29', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(5, 1, '[Gambio] Artikelexport', 'artikelexport.csv', '|', '"', '2013-05-29 12:52:03', '2013-05-29 14:48:29', '0000-00-00 00:00:00', 'gambio', 0, 0, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(6, 2, '[Gambio] Ciao.de', 'ciao.csv', '|', '"', '2013-05-29 12:52:03', '2013-05-29 14:48:29', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(7, 2, '[Gambio] Geizhals.at', 'geizhals.csv', ';', '"', '2013-05-30 11:16:15', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(8, 2, '[Gambio] Guenstiger.de', 'guenstiger.csv', '|', '', '2013-05-30 13:51:21', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(9, 2, '[Gambio] Become.eu', 'become.txt', '|', '"', '2013-05-30 14:29:44', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(10, 2, '[Gambio] Preissuchmaschine.de', 'preissuchmaschine.csv', '|', '', '2013-05-30 14:50:20', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(11, 2, '[Gambio] Carmio.de', 'carmio.csv', ';', '"', '2013-05-30 16:05:42', '2013-05-30 16:47:52', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(12, 2, '[Gambio] Nextag.de', 'nextag.csv', ';', '"', '2013-05-30 20:51:29', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(13, 2, '[Gambio] Smatch.com', 'smatch.csv', ';', '"', '2013-05-31 11:12:22', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(14, 2, '[Gambio] Preis.de', 'preis.csv', ';', '"', '2013-06-03 12:50:05', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(15, 2, '[Gambio] LeGuide.com', 'leguide.csv', '|', '', '2013-07-23 15:18:09', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(16, 2, '[Gambio] Preisvergleich.de', 'preisvergleich.txt', ';', '', '2013-07-23 14:34:32', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(17, 2, '[Gambio] Shopzilla.de', 'shopzilla.csv', ';', '"', '2013-07-23 16:46:08', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(18, 2, '[Gambio] Zentralverkauf.de', 'zentralverkauf.csv', '|', '', '2013-07-23 14:34:32', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(19, 2, '[Gambio] Geizkragen.de', 'geizkragen.csv', ';', '', '2013-07-23 20:01:32', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(20, 2, '[Gambio] Daparto.de', 'daparto.csv', ';', '''', '2013-07-24 12:43:38', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');
INSERT INTO `export_schemes` (`scheme_id`, `type_id`, `scheme_name`, `filename`, `field_separator`, `field_quotes`, `date_created`, `date_modified`, `date_last_export`, `created_by`, `customers_status_id`, `currencies_id`, `languages_id`, `campaign_id`, `shipping_free_minimum`, `quantity_minimum`, `export_attributes`, `export_properties`, `export_features`, `cronjob_allowed`, `cronjob_days`, `cronjob_hour`, `cronjob_interval`) VALUES(21, 2, '[Gambio] Shopping.com', 'shopping.csv', '|', '"', '2013-07-24 13:50:25', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'gambio', 1, 1, 2, '0', 0.0000, 0.0000, 0, 0, 0, 0, 'Mon|Tue|Wed|Thu|Fri|Sat|Sun', '3', '0');

INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'ID', '{p_id}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Titel', '{p_google_name_vpe_suffix}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Beschreibung', '{p_description}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Google Produktkategorie', '{p_google_category}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Produkttyp', '{c_path}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Link', '{p_link}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Bildlink', '{p_popup_image}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Zusätzlicher Bildlink', '{p_popup_images}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Zustand', '{p_google_export_condition}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Verfügbarkeit', '{p_google_export_availability}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Preis', '{p_old_price_comma} {p_currency}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Sonderangebotspreis', '{p_price_comma} {p_currency}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Sonderangebotszeitraum', '{p_special_period}', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Marke', '{brand_name}', '', 'gambio', 14);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'GTIN', '{p_google_export_gtin}', '', 'gambio', 15);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'MPN', '{code_mpn}', '', 'gambio', 16);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Kennzeichnung existiert', '{p_google_identifier_exists}', '', 'gambio', 17);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Geschlecht', '{gender}', '', 'gambio', 18);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Altersgruppe', '{age_group}', '', 'gambio', 19);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Versandgewicht', '{p_weight_point} kg', '', 'gambio', 20);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Nicht jugendfrei', '{p_google_fsk18}', '', 'gambio', 21);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Grundpreis Maß', '{p_google_unit_price_measure}', '', 'gambio', 22);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Grundpreis Einheitsmaß', '{p_google_unit_pricing_base_measure}', '', 'gambio', 23);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Verfallsdatum', '{p_expiration_date}', '', 'gambio', 24);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Farbe', '{collective_field||Farbe||attributes;additional_fields}', '', 'gambio', 25);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Größe', '{collective_field||Größe||attributes;additional_fields}', '', 'gambio', 26);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Material', '{collective_field||Material||attributes;additional_fields}', '', 'gambio', 27);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Muster', '{collective_field||Muster||attributes;additional_fields}', '', 'gambio', 28);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(1, 'Produktgruppe', '{p_google_product_group}', '', 'gambio', 29);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'aid', '{p_id}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'brand', '{p_manufacturer_name}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'mpnr', '{p_model}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'ean', '{p_ean}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'name', '{p_name}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'desc', '{p_description}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'shop_cat', '{c_path}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'price', '{p_price_point}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'ppu', '{p_baseprice_point}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'link', '{p_link}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'image', '{p_popup_image}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'dlv_time', '{p_shipping_status_name}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'dlv_cost', '{p_shipping_costs_point}', '0.00', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(2, 'pzn', '', '', 'gambio', 14);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(3, 'Artikelnummer', '{p_id}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(3, 'EAN', '{p_ean}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(3, 'Herstellerartikelnummer', '{p_model}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(3, 'Herstellername', '{p_manufacturer_name}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(3, 'Produktname', '{p_name}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(3, 'Kategorie', '{c_path}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(3, 'Preis', '{p_price_point}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(3, 'Lieferzeit', '{p_shipping_status_name}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(3, 'ProduktURL', '{p_link}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(3, 'BildURL', '{p_popup_image}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(3, 'Versandkosten Vorkasse', '{p_shipping_costs_point}', '0.00', 'custom', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(3, 'Beschreibung', '{p_description}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(3, 'Grundpreis', '{p_baseprice_point}', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(4, 'Artikel-Nr.', '{p_id}', '', 'gambio', 0);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(4, 'Artikelname', '{p_name}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(4, 'Preis', '{p_price_point}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(4, 'Deeplink', '{p_link}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(4, 'Bild-URL', '{p_popup_image}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(4, 'Kurzbeschr.', '{p_short_description}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(4, 'Versandk.', '{p_shipping_costs_point}', '0.00', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(4, 'Verfügbarkeit', '{p_shipping_status_name}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(4, 'EAN', '{p_ean}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(4, 'PZN', '', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(4, 'Hersteller', '{p_manufacturer_name}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(4, 'Hersteller-ArtNr', '{code_mpn}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(4, 'Kategorie', '{c_path}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'XTSOL', 'XTSOL', '', 'gambio', 0);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_id', '{products_id}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_model', '{products_model}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_stock', '{products_quantity}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_sorting', '{products_sort}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_startpage', '{products_startpage}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_startpage_sort', '{products_startpage_sort}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_shipping', '{products_shippingtime}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_tpl', '{product_template}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_opttpl', '{options_template}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_manufacturer', '{manufacturers_id}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_fsk18', '{products_fsk18}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_priceNoTax', '{products_price}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_priceNoTax.1', '{p_personal_offer#1}', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_priceNoTax.2', '{p_personal_offer#2}', '', 'gambio', 14);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_priceNoTax.3', '{p_personal_offer#3}', '', 'gambio', 15);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_tax', '{products_tax_class_id}', '', 'gambio', 16);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_status', '{products_status}', '', 'gambio', 17);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_weight', '{products_weight}', '', 'gambio', 18);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_ean', '{products_ean}', '', 'gambio', 19);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'code_isbn', '{code_isbn}', '', 'gambio', 20);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'code_upc', '{code_upc}', '', 'gambio', 21);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'code_mpn', '{code_mpn}', '', 'gambio', 22);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'code_jan', '{code_jan}', '', 'gambio', 23);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'brand_name', '{brand_name}', '', 'gambio', 24);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_disc', '{products_discount_allowed}', '', 'gambio', 25);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_date_added', '{products_date_added}', '', 'gambio', 26);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_last_modified', '{products_last_modified}', '', 'gambio', 27);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_date_available', '{products_date_available}', '', 'gambio', 28);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_ordered', '{products_ordered}', '', 'gambio', 29);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'nc_ultra_shipping_costs', '{nc_ultra_shipping_costs}', '', 'gambio', 30);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'gm_show_date_added', '{gm_show_date_added}', '', 'gambio', 31);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'gm_show_price_offer', '{gm_show_price_offer}', '', 'gambio', 32);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'gm_show_weight', '{gm_show_weight}', '', 'gambio', 33);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'gm_show_qty_info', '{gm_show_qty_info}', '', 'gambio', 34);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'gm_price_status', '{gm_price_status}', '', 'gambio', 35);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'gm_min_order', '{gm_min_order}', '', 'gambio', 36);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'gm_graduated_qty', '{gm_graduated_qty}', '', 'gambio', 37);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'gm_options_template', '{gm_options_template}', '', 'gambio', 38);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_vpe', '{products_vpe}', '', 'gambio', 39);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_vpe_status', '{products_vpe_status}', '', 'gambio', 40);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_vpe_value', '{products_vpe_value}', '', 'gambio', 41);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_image.1', '{products_image#1}', '', 'gambio', 42);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_image.2', '{products_image#2}', '', 'gambio', 43);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_image.3', '{products_image#3}', '', 'gambio', 44);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_image', '{products_image}', '', 'gambio', 45);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_name.en', '{products_name.en}', '', 'gambio', 46);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_desc.en', '{products_description.en}', '', 'gambio', 47);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_shortdesc.en', '{products_short_description.en}', '', 'gambio', 48);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_checkout_information.en', '{checkout_information.en}', '', 'gambio', 49);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_meta_title.en', '{products_meta_title.en}', '', 'gambio', 50);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_meta_desc.en', '{products_meta_description.en}', '', 'gambio', 51);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_meta_key.en', '{products_meta_keywords.en}', '', 'gambio', 52);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_keywords.en', '{products_keywords.en}', '', 'gambio', 53);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_url.en', '{products_url.en}', '', 'gambio', 54);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'gm_url_keywords.en', '{gm_url_keywords.en}', '', 'gambio', 55);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_name.de', '{products_name.de}', '', 'gambio', 56);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_desc.de', '{products_description.de}', '', 'gambio', 57);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_shortdesc.de', '{products_short_description.de}', '', 'gambio', 58);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_checkout_information.de', '{checkout_information.de}', '', 'gambio', 59);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_meta_title.de', '{products_meta_title.de}', '', 'gambio', 60);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_meta_desc.de', '{products_meta_description.de}', '', 'gambio', 61);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_meta_key.de', '{products_meta_keywords.de}', '', 'gambio', 62);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_keywords.de', '{products_keywords.de}', '', 'gambio', 63);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_url.de', '{products_url.de}', '', 'gambio', 64);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'gm_url_keywords.de', '{gm_url_keywords.de}', '', 'gambio', 65);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_cat.en', '{c_path.en}', '', 'gambio', 66);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_cat.de', '{c_path.de}', '', 'gambio', 67);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'google_export_availability', '{p_google_export_availability}', '', 'gambio', 68);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'google_export_condition', '{p_google_export_condition}', '', 'gambio', 69);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'google_category', '{p_google_category}', '', 'gambio', 70);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_img_alt_text.en', '{p_gm_alt_text.en}', '', 'gambio', 71);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_img_alt_text.1.en', '{p_gm_alt_text#1.en}', '', 'gambio', 72);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_img_alt_text.2.en', '{p_gm_alt_text#2.en}', '', 'gambio', 73);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_img_alt_text.3.en', '{p_gm_alt_text#3.en}', '', 'gambio', 74);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_img_alt_text.de', '{p_gm_alt_text.de}', '', 'gambio', 75);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_img_alt_text.1.de', '{p_gm_alt_text#1.de}', '', 'gambio', 76);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_img_alt_text.2.de', '{p_gm_alt_text#2.de}', '', 'gambio', 77);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_img_alt_text.3.de', '{p_gm_alt_text#3.de}', '', 'gambio', 78);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_group_permission.0', '{p_group_permission#0}', '', 'gambio', 79);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_group_permission.1', '{p_group_permission#1}', '', 'gambio', 80);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_group_permission.2', '{p_group_permission#2}', '', 'gambio', 81);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_group_permission.3', '{p_group_permission#3}', '', 'gambio', 82);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'specials_qty', '{specials_quantity}', '', 'gambio', 83);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'specials_new_products_price', '{specials_new_products_price}', '', 'gambio', 84);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'expires_date', '{expires_date}', '', 'gambio', 85);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'specials_status', '{status}', '', 'gambio', 86);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'gm_priority', '{gm_priority}', '', 'gambio', 87);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'gm_changefreq', '{gm_changefreq}', '', 'gambio', 88);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'gm_sitemap_entry', '{gm_sitemap_entry}', '', 'gambio', 89);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_qty_unit_id', '{quantity_unit_id}', '', 'gambio', 90);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(5, 'p_type', '{product_type}', '', 'gambio', 91);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(6, 'Description', '{p_description}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(6, 'Brand', '{p_manufacturer_name}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(6, 'MPN', '{code_mpn}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(6, 'EAN', '{p_ean}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(6, 'Image URL', '{p_popup_image}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(6, 'Category', '{c_path}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(6, 'Shipping Cost', '{p_shipping_costs_comma}', '0,00', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(6, 'Offer ID', '{p_id}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(6, 'Price', '{p_price_comma}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(6, 'Product URL', '{p_link}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(6, 'Product Name', '{p_name}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(6, 'OfferValidity', '', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(6, 'Availability', '{p_shipping_status_name}', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(7, 'product_url', '{p_link}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(7, 'weight', '{products_weight}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(7, 'shippingtime', '{p_shipping_status_name}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(7, 'quantity', '{p_quantity}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(7, 'price', '{p_price_comma}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(7, 'name', '{p_name}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(7, 'brand', '{p_manufacturer_name}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(7, 'ean', '{p_ean}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(7, 'id', '{p_id}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(7, 'shippingstatus', '{number_of_days}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(7, 'image_url', '{p_popup_image}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(7, 'description', '{p_description}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'ProduktID', '{p_id}', '', 'custom', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'Gewicht', '{products_weight}', '', 'custom', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'EAN', '{p_ean}', '', 'custom', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'Hersteller', '{p_manufacturer_name}', '', 'custom', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'ProduktBezeichnung', '{p_name}', '', 'custom', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'ArtikelNroderHerstellerArtikelNr', '{p_model}', '', 'custom', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'Preis', '{p_price_comma}', '', 'custom', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'ProduktLangBeschreibung', '{p_description}', '', 'custom', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'ProduktKurzBeschreibung', '{p_short_description}', '', 'custom', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'Lieferzeit', '{p_shipping_status_name}', '', 'custom', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'Versandkosten', '{p_shipping_costs_comma}', '0,00', 'custom', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'Produktlink', '{p_link}', '', 'custom', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'FotoLink', '{p_popup_image}', '', 'custom', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(8, 'Kategoriename', '{c_path}', '', 'custom', 14);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'offer-id', '{p_id}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'label', '{p_name}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'merchant-category', '{c_path}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'prices', '{p_price_point}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'offer-url', '{p_link}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'brand', '{p_manufacturer_name}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'description', '{p_short_description}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'image-url', '{p_popup_image}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'old-prices', '{p_old_price_point_currency}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'mfname', '', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'mfpn', '', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'product-id', '{p_model}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'delivery-period', '{p_shipping_status_name}', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'delivery_period_text', '', '', 'gambio', 14);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'delivery-charge', '{p_shipping_costs_point}', '0.00', 'gambio', 15);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'delivery_charge_text', '', '', 'gambio', 16);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'baseprice-unit', '{become_baseprice_unit}', '', 'gambio', 17);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'baseprice-value', '{become_baseprice_value}', '', 'gambio', 18);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(9, 'baseprice-amount', '{become_baseprice_amount}', '', 'gambio', 19);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'ProduktID', '{p_id}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'Gewicht', '{products_weight}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'EAN', '{p_ean}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'Lagerbestand', '{p_quantity_floor}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'Hersteller', '{p_manufacturer_name}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'ProduktBezeichnung', '{p_name}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'ArtikelNroderHerstellerArtikelNr', '{p_model}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'Preis', '{p_price_comma}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'ProduktLangBeschreibung', '{p_description}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'ProduktKurzBeschreibung', '{p_short_description}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'Lieferzeit', '{p_shipping_status_name}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'Produktlink', '{p_link}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'FotoLink', '{p_popup_image}', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'Kategoriename', '{c_name}', '', 'gambio', 14);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(10, 'Grundpreis', '{p_baseprice_point}', '', 'gambio', 15);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Lieferzeit', '{p_shipping_status_name}', '', 'gambio', 22);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'TecDoc Daten', '0', '', 'gambio', 21);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Gewicht', '{p_weight_comma}', '', 'gambio', 20);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Versandkosten PP', '', '', 'gambio', 19);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Versandkosten KK', '', '', 'gambio', 18);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Versandkosten VK', '{p_shipping_costs_comma}', '0,00', 'gambio', 16);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Versandkosten NN', '', '', 'gambio', 17);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Angebotsformat', '1', '', 'gambio', 15);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Im Austausch', '1', '', 'gambio', 14);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Zustand', '1', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Produktbeschreibung', '{p_description}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'ProduktURL', '{p_link}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'BildURL(groß)', '{p_popup_image}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Kategorie', '{c_name}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Preis', '{p_price_comma}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Kompatibilität', '{products_ean}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Produktname', '{p_name}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'OE-Vergleichsnummern', '', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'EAN-Nummer', '{products_ean}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Teilenummer', '{p_model}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Hersteller', '{p_manufacturer_name}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(11, 'Artikelnummer', '{p_id}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(12, 'Manufacturer with Manufacturer Part # (SKU)', '{p_manufacturer_name} {code_mpn}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(12, 'UPC', '{p_ean}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(12, 'ISBN', '{code_isbn}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(12, 'Product Name', '{p_name}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(12, 'Description', '{p_description}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(12, 'Price', '{p_price_comma}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(12, 'Click-out-URL', '{p_link}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(12, 'Category', '{c_path}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(12, 'Product Condition', '{p_google_export_condition}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(12, 'Stock Status', '{p_quantity_floor}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(12, 'Image URL', '{p_popup_image}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(12, 'Ground Shipping', '{p_shipping_costs_comma}', '0.00', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(12, 'Cost-per-Click', '', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'ART_NUMBER', '{p_id}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'ART_NAME', '{p_name}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'DEEP_LINK', '{p_link}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'LONG_DESCRIPTION', '{p_description}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'IMAGE_URL', '{p_popup_image}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'CATEGORY', '{c_path}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'PRICE', '{p_price_comma}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'EAN', '{p_ean}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'DELIVERY_TIME', '{p_shipping_status_name}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'DELIVERY_COSTS', '{p_shipping_costs_comma}', '0,00', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'OLD_PRICE', '{p_old_price_comma}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'KEYWORDS', '{products_meta_keywords}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'AVAILABLE_PRODUCTS', '{p_quantity}', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(13, 'BRAND', '{p_manufacturer_name}', '', 'gambio', 14);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(14, 'Artikelnummer', '{p_id}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(14, 'Produktbezeichnung (inkl. Hersteller)', '{p_name}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(14, 'Produktbeschreibung', '{p_description}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(14, 'Preis', '{p_price_comma}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(14, 'Status Lieferbarkeit', '{p_shipping_status_name}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(14, 'Deeplink zum Artikel', '{p_link}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(14, 'Deeplink zum Artikelfoto', '{p_popup_image}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(14, 'EAN', '{p_ean}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(14, 'produktbezogene Versandkosten', '{p_shipping_costs_point}', '0.00', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(15, 'category', '{c_path}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(15, 'offer_id', '{p_id}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(15, 'name', '{p_name}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(15, 'price', '{p_price_point}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(15, 'product_url', '{p_link}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(15, 'image_url', '{p_popup_image}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(15, 'description', '{p_description}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(15, 'shipping', '{p_shipping_costs_point}', '0.00', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(15, 'availability', '0', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(15, 'brand', '{p_manufacturer_name}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(15, 'ean', '{p_ean}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(15, 'list_price', '{p_old_price_point}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(15, 'model_number', '{p_model}', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'productid', '{p_id}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'name', '{p_name}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'price', '{p_price_point}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'description_short', '{p_short_description}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'description', '{p_description}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'deeplink', '{p_link}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'image', '{p_popup_image}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'deliverypossibilities', '{p_availability}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'deliverytime', '{p_shipping_status_name}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'deliverycost', '{p_shipping_costs_point}', '0.00', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'categoryname', '{c_name}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'manufacturer', '{p_manufacturer_name}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'manufacturerid', '{p_model}', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(16, 'ean', '{products_ean}', '', 'gambio', 14);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Titel', '{p_name}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Beschreibung', '{p_description}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Kategorie in Pfadnavigation', '{c_path}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Preis', '{p_price_comma}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Produkt URL', '{p_link}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Bild URL', '{p_popup_image}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Page_ID', '{p_id}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Lagerbestand', 'Auf Lager', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'SKU / MPID', '{p_id}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Hersteller / Marke', '{p_manufacturer_name}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'EAN/UPC', '{p_ean}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'ISBN', '{code_isbn}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Zustand', 'Neu', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Versandkosten', '{p_shipping_costs_comma}', '0,00', 'gambio', 14);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Bid', '', '', 'gambio', 15);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Werbeaktion', '', '', 'gambio', 16);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'page_id_variant', '', '', 'gambio', 17);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(17, 'Empfohlener Verkaufspreis', '{p_old_price_comma}', '', 'gambio', 18);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'ID_VK', '{p_id}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'KLASSE', '', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'STATUS', '1', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'BEZEICHNUNG', '{products_name}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'DEF_1', '{p_manufacturer_name}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'DEF_2', '{p_model}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'KENZ_ID', '{p_ean}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'BESCHR_LANG', '{p_description}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'BESCHR_KURZ', '{p_short_description}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'ANG_MENGE', '{p_quantity}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'MENGEN_EINHEIT', '{vpe_name}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'ENTH_EINHEIT', '', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'MIND_BEST_MENGE', '{gm_min_order}', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'GRUNDP_INHALT', '', '', 'gambio', 14);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'GRUNDP_EINHEIT', '{vpe_name}', '', 'gambio', 15);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'GRUNDP_REFMENGE', '', '', 'gambio', 16);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'BILD_1', '{p_image}', '', 'gambio', 17);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'BILD_2', '{p_image#1}', '', 'gambio', 18);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'BILD_3', '{p_image#2}', '', 'gambio', 19);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'BILD_4', '{p_image#3}', '', 'gambio', 20);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'BILD_5', '{p_image#4}', '', 'gambio', 21);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'KEYWORDS', '{products_keywords}', '', 'gambio', 22);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'CROSS_SELLING', '', '', 'gambio', 23);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'PREIS', '{p_price_comma}', '', 'gambio', 24);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'MWST', '{p_tax}', '', 'gambio', 25);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'VERS_ZEIT', '{number_of_days}', '', 'gambio', 26);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'VERS_EINHEITEN', '{p_weight_point}', '', 'gambio', 27);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'VERS_GRUPPE', '', '', 'gambio', 28);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'VERS_AUFSCHL', '', '', 'gambio', 29);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'VERS_AUFSCHL_BER', '', '', 'gambio', 30);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'KAT_BAUM_VK', '{c_path.de}', '', 'gambio', 31);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'VAR_GRUPPE', '{products_id}', '', 'gambio', 32);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(18, 'VAR_ATTRIBUTE', '{p_attribute}', '', 'gambio', 33);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(19, 'Artikelnummer', '{p_id}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(19, 'Kategorie', '{c_name}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(19, 'Hersteller', '{p_manufacturer_name}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(19, 'Produktname', '{p_name}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(19, 'Deeplink', '{p_link}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(19, 'Bildlink', '{p_popup_image}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(19, 'EAN', '{p_ean}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(19, 'Herst-Art.Nr.', '{p_model}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(19, 'Preis', '{p_price_point}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(19, 'Versandkosten VK', '{p_shipping_costs_point}', '0.00', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(19, 'Versandkosten NN', '0.00', '', 'custom', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(19, 'Lieferzeit', '{p_shipping_status_name}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Artikelbezeichnung', '{p_name}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Teilehersteller,Teilenummer', '{p_manufacturer_name},{p_model}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Vergleichs-Teilehersteller,Vergleichs-Teilenummern', '', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Verwendung', '{p_ean}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Preis', '{p_price_comma}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Baugruppen- bzw. Kategorienummer', '', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Artikel-Nummer im Shop des Anbieters', '{p_id}', '', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Artikelfoto', '{p_popup_image}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Artikelbeschreibung', '{p_description}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Link zum Shop', '{p_link}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Zustand', '1', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Pfand', '', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'nicht genutzt M', '', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Versandkosten des Artikels', '{p_shipping_costs_comma}', '0,00', 'gambio', 14);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Gewicht', '{p_weight_comma}', '', 'gambio', 15);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'nicht genutzt P', '', '', 'gambio', 16);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(20, 'Lieferzeit', '{p_daparto_shippingtime}', '', 'gambio', 17);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Produktname', '{p_name}', '', 'gambio', 1);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Produktbeschreibung', '{p_description}', '', 'gambio', 2);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Preis', '{p_price_comma}', '', 'gambio', 3);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Streichpreis', '{p_old_price_comma}', '', 'gambio', 4);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Produkt-URL', '{p_link}', '', 'gambio', 5);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Bild-URL', '{p_popup_image}', '', 'gambio', 6);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Versandkosten', '{p_shipping_costs_comma}', '0,00', 'gambio', 7);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Artikelnummer(SKU)', '{p_id}', '', 'gambio', 8);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Kategoriename und Unterkategoriename', '{c_path}', '', 'gambio', 9);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Unterstes Kategorielevel', '{c_name}', '', 'gambio', 10);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Marke/Hersteller', '{p_manufacturer_name}', '', 'gambio', 11);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'EAN', '{p_ean}', '', 'gambio', 12);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'MPN', '{p_model}', '', 'gambio', 13);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Verfügbarkeit', '{p_availability}', '', 'gambio', 14);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Verfügbarkeitsdetails', '{p_shipping_status_name}', '', 'gambio', 15);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Produkttyp', '', '', 'gambio', 16);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Geschlecht', '', '', 'gambio', 17);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Farbe', '', '', 'gambio', 18);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Material', '', '', 'gambio', 19);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Alternative Bild-URL 2', '{p_image#1}', '', 'gambio', 20);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Alternative Bild-URL 3', '{p_image#2}', '', 'gambio', 21);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Alternative Bild-URL 4', '{p_image#3}', '', 'gambio', 22);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Alternative Bild-URL 5', '{p_image#4}', '', 'gambio', 23);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Coupon-Code', '', '', 'gambio', 24);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Coupon-Code Beschreibung', '', '', 'gambio', 25);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Produkteigenschaften 1. Aufzählungspunkt', '', '', 'gambio', 26);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Produkteigenschaften 2. Aufzählungspunkt', '', '', 'gambio', 27);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Produkteigenschaften 3. Aufzählungspunkt', '', '', 'gambio', 28);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Produkteigenschaften 4. Aufzählungspunkt', '', '', 'gambio', 29);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Produkteigenschaften 5. Aufzählungspunkt', '', '', 'gambio', 30);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Mobiltelefon', '', '', 'gambio', 31);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Mobiltelefon Bauart', '', '', 'gambio', 32);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Vertragstyp', '', '', 'gambio', 33);
INSERT INTO `export_scheme_fields` (`scheme_id`, `field_name`, `field_content`, `field_content_default`, `created_by`, `sort_order`) VALUES(21, 'Mobilfunk-Nutzungsprofil', '', '', 'gambio', 34);

INSERT INTO `export_types` (`type_id`, `language_id`, `name`) VALUES(1, 1, 'Product export');
INSERT INTO `export_types` (`type_id`, `language_id`, `name`) VALUES(1, 2, 'Artikelexport');
INSERT INTO `export_types` (`type_id`, `language_id`, `name`) VALUES(2, 1, 'Price comparison');
INSERT INTO `export_types` (`type_id`, `language_id`, `name`) VALUES(2, 2, 'Preis-Portal');

INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(530, 4, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(587, 4, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(581, 4, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(529, 4, 'BOX_HEADING_PRODUCTS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(230, 4, 'BOX_HEADING_ECONDA', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(532, 4, 'BOX_HEADING_STATISTICS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(589, 4, 'BOX_HEADING_MODULES', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(533, 4, 'BOX_HEADING_TOOLS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(583, 4, 'BOX_HEADING_GV_ADMIN', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(535, 4, 'BOX_HEADING_ZONE', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(536, 4, 'BOX_HEADING_CONFIGURATION', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(394, 7, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(269, 7, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(501, 8, 'BOX_HEADING_MODULES', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(502, 8, 'BOX_HEADING_STATISTICS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(223, 6, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(225, 6, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(320, 6, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(514, 8, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(372, 7, 'BOX_HEADING_PRODUCTS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(547, 8, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(378, 7, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(306, 7, 'BOX_HEADING_ZONE', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(505, 8, 'BOX_HEADING_ZONE', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(500, 8, 'BOX_HEADING_PRODUCTS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(366, 4, 'last', 0);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(557, 0, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(508, 8, 'BOX_HEADING_CONFIGURATION', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(504, 8, 'BOX_HEADING_GV_ADMIN', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(503, 8, 'BOX_HEADING_TOOLS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(432, 24, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(434, 24, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(436, 24, 'BOX_HEADING_GV_ADMIN', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(438, 24, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(456, 24, 'BOX_HEADING_ZONE', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(458, 24, 'BOX_HEADING_CONFIGURATION', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(450, 24, 'BOX_HEADING_STATISTICS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(454, 24, 'BOX_HEADING_TOOLS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(462, 24, 'BOX_HEADING_PRODUCTS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(464, 25, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(510, 25, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(516, 8, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(541, 44, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(543, 44, 'BOX_HEADING_GV_ADMIN', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(545, 44, 'BOX_HEADING_STATISTICS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(549, 44, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(597, 1, 'BOX_HEADING_PRODUCTS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(601, 2, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(561, 2, 'BOX_HEADING_PRODUCTS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(559, 2, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(565, 2, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(567, 2, 'BOX_HEADING_MODULES', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(569, 3, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(575, 2, 'BOX_HEADING_TOOLS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(577, 3, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(593, 1, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(603, 1, 'BOX_HEADING_GAMBIO', 1);


INSERT INTO `gm_admin_favorites` (`favorites_id`, `customers_id`, `link_key`, `sort_order`) VALUES(1, 1, 'id_e6d18015c0e4f88f119c48f00142e6d5', 0);
INSERT INTO `gm_admin_favorites` (`favorites_id`, `customers_id`, `link_key`, `sort_order`) VALUES(2, 1, 'id_46a7254c38e4bfacf97ae97135da12d9', 0);
INSERT INTO `gm_admin_favorites` (`favorites_id`, `customers_id`, `link_key`, `sort_order`) VALUES(3, 1, 'id_87bad688f21b28cca9981cbf2b843249', 0);
INSERT INTO `gm_admin_favorites` (`favorites_id`, `customers_id`, `link_key`, `sort_order`) VALUES(4, 1, 'id_ae14fd556f1e86067621605e2dac56b4', 0);
INSERT INTO `gm_admin_favorites` (`favorites_id`, `customers_id`, `link_key`, `sort_order`) VALUES(5, 1, 'id_393bb7cb2161a3c52f4feb39f71f1f2a', 0);


INSERT INTO `gm_bookmarks` (`gm_bookmarks_id`, `gm_bookmarks_name`, `gm_bookmarks_link`, `gm_bookmarks_image`) VALUES(14, 'digg.com', 'http://digg.com/submit?url=', 'diggs.gif');
INSERT INTO `gm_bookmarks` (`gm_bookmarks_id`, `gm_bookmarks_name`, `gm_bookmarks_link`, `gm_bookmarks_image`) VALUES(16, 'folkd', 'http://www.folkd.com/page/submit.html?addtofolkd=1&step1_sent=1&url=', 'folkd.gif');
INSERT INTO `gm_bookmarks` (`gm_bookmarks_id`, `gm_bookmarks_name`, `gm_bookmarks_link`, `gm_bookmarks_image`) VALUES(17, 'favoriten.de', 'http://www.favoriten.de/url-hinzufuegen.html?bm_url=', 'favoriten.gif');
INSERT INTO `gm_bookmarks` (`gm_bookmarks_id`, `gm_bookmarks_name`, `gm_bookmarks_link`, `gm_bookmarks_image`) VALUES(19, 'google', 'http://www.google.com/bookmarks/mark?op=add&hl=de&bkmk=', 'google.gif');
INSERT INTO `gm_bookmarks` (`gm_bookmarks_id`, `gm_bookmarks_name`, `gm_bookmarks_link`, `gm_bookmarks_image`) VALUES(20, 'del.icio.us', 'http://del.icio.us/post?url=', 'delicio.gif');
INSERT INTO `gm_bookmarks` (`gm_bookmarks_id`, `gm_bookmarks_name`, `gm_bookmarks_link`, `gm_bookmarks_image`) VALUES(24, 'edelight', 'http://www.edelight.de/geschenk/neu?purl=', 'edelight.gif');


INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'admin', 'gm_box_pos_2', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'categories', 'gm_box_pos_4', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'filter', 'gm_box_pos_6', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'login', 'gm_box_pos_8', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'bestsellers', 'gm_box_pos_10', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'reviews', 'gm_box_pos_12', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'gm_trusted_shops_widget', 'gm_box_pos_14', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'specials', 'gm_box_pos_16', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'add_quickie', 'gm_box_pos_18', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'search', 'gm_box_pos_20', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'manufacturers_info', 'gm_box_pos_22', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'languages', 'gm_box_pos_24', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'currencies', 'gm_box_pos_26', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'infobox', 'gm_box_pos_28', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'newsletter', 'gm_box_pos_30', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'gm_counter', 'gm_box_pos_32', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'last_viewed', 'gm_box_pos_34', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'whatsnew', 'gm_box_pos_36', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'order_history', 'gm_box_pos_38', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'manufacturers', 'gm_box_pos_40', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'trusted', 'gm_box_pos_42', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'gm_scroller', 'gm_box_pos_44', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'information', 'gm_box_pos_46', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'content', 'gm_box_pos_48', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'gm_bookmarks', 'gm_box_pos_50', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'paypal', 'gm_box_pos_52', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox1', 'gm_box_pos_54', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox2', 'gm_box_pos_56', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox3', 'gm_box_pos_58', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox4', 'gm_box_pos_60', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox5', 'gm_box_pos_62', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox6', 'gm_box_pos_64', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox7', 'gm_box_pos_66', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox8', 'gm_box_pos_70', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox9', 'gm_box_pos_74', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'ekomi', 'gm_box_pos_76', 0);

INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(7, 'GM_SCROLLER_HEIGHT', '200', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(8, 'GM_SCROLLER_SPEED', '50', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(921, 'GM_PDF_CONDITIONS_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(922, 'GM_PDF_CONDITIONS_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(923, 'GM_PDF_CONDITIONS_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(924, 'GM_PDF_HEADING_CONDITIONS_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(925, 'GM_PDF_HEADING_CONDITIONS_FONT_STYLE', 'b', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(926, 'GM_PDF_HEADING_CONDITIONS_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(927, 'GM_PDF_FOOTER_FONT_SIZE', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(928, 'GM_PDF_FOOTER_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(929, 'GM_PDF_FOOTER_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(930, 'GM_PDF_ORDER_INFO_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(931, 'GM_PDF_ORDER_INFO_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(932, 'GM_PDF_ORDER_INFO_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(933, 'GM_PDF_HEADING_ORDER_INFO_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(934, 'GM_PDF_HEADING_ORDER_INFO_FONT_STYLE', 'b', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(935, 'GM_PDF_HEADING_ORDER_INFO_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(936, 'GM_PDF_ORDER_TOTAL_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(937, 'GM_PDF_ORDER_TOTAL_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(938, 'GM_PDF_ORDER_TOTAL_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(939, 'GM_PDF_ORDER_FONT_SIZE', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(940, 'GM_PDF_ORDER_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(941, 'GM_PDF_ORDER_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(942, 'GM_PDF_HEADING_ORDER_FONT_SIZE', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(943, 'GM_PDF_HEADING_ORDER_FONT_STYLE', 'b', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(944, 'GM_PDF_HEADING_ORDER_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(945, 'GM_PDF_HEADING_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(946, 'GM_PDF_HEADING_FONT_STYLE', 'b', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(947, 'GM_PDF_HEADING_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(948, 'GM_PDF_COMPANY_RIGHT_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(949, 'GM_PDF_COMPANY_RIGHT_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(950, 'GM_PDF_COMPANY_RIGHT_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(951, 'GM_PDF_COMPANY_LEFT_FONT_SIZE', '9', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(952, 'GM_PDF_COMPANY_LEFT_FONT_STYLE', 'u', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(953, 'GM_PDF_COMPANY_LEFT_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(954, 'GM_PDF_CUSTOMER_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(955, 'GM_PDF_CUSTOMER_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(956, 'GM_PDF_CUSTOMER_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(957, 'GM_PDF_DEFAULT_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(958, 'GM_PDF_DEFAULT_FONT_STYLE', 'b', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(959, 'GM_PDF_DEFAULT_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(960, 'GM_PDF_HEADING_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(961, 'GM_PDF_HEADING_INVOICE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(962, 'GM_PDF_COMPANY_ADRESS_RIGHT', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(963, 'GM_PDF_COMPANY_ADRESS_LEFT', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(964, 'GM_PDF_INFO_TEXT_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(965, 'GM_PDF_INFO_TEXT_INVOICE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(966, 'GM_PDF_INFO_TITLE_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(967, 'GM_PDF_INFO_TITLE_INVOICE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(968, 'GM_PDF_HEADING_INFO_TEXT_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(969, 'GM_PDF_HEADING_INFO_TEXT_INVOICE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(970, 'GM_PDF_FOOTER_CELL_4', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(971, 'GM_PDF_FOOTER_CELL_3', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(972, 'GM_PDF_FOOTER_CELL_2', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(973, 'GM_PDF_FOOTER_CELL_1', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(974, 'GM_PDF_HEADING_CONDITIONS', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1003, 'GM_PDF_USE_CUSTOMER_COMMENT', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1005, 'GM_PDF_LOGO_SRC', 'pdf_logo.gif', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(975, 'GM_PDF_HEADING_WITHDRAWAL', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(976, 'GM_PDF_CONDITIONS', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(977, 'GM_PDF_WITHDRAWAL', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(978, 'GM_PDF_USE_CUSTOMER_CODE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(979, 'GM_PDF_USE_ORDER_CODE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(980, 'GM_PDF_USE_PACKING_CODE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(981, 'GM_PDF_USE_INVOICE_CODE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(982, 'GM_PDF_USE_ORDER_DATE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(983, 'GM_PDF_USE_DATE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(984, 'GM_PDF_USE_WITHDRAWAL', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(985, 'GM_PDF_USE_CONDITIONS', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(986, 'GM_PDF_USE_INFO_TEXT', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(987, 'GM_PDF_USE_INFO', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(988, 'GM_PDF_USE_FOOTER', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(989, 'GM_PDF_FIX_HEADER', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(990, 'GM_PDF_USE_HEADER', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(992, 'GM_PDF_DISPLAY_LAYOUT', 'continuous', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(993, 'GM_PDF_DISPLAY_ZOOM', 'real', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(994, 'GM_PDF_CUSTOMER_ADR_POS', '50', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(995, 'GM_PDF_CELL_HEIGHT', '5', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(996, 'GM_PDF_ORDER_INFO_MARGIN_TOP', '30', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(997, 'GM_PDF_HEADING_MARGIN_BOTTOM', '15', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(998, 'GM_PDF_HEADING_MARGIN_TOP', '15', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(999, 'GM_PDF_LEFT_MARGIN', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1000, 'GM_PDF_BOTTOM_MARGIN', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1001, 'GM_PDF_RIGHT_MARGIN', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1002, 'GM_PDF_TOP_MARGIN', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1009, 'GM_PDF_CONDITIONS_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1011, 'GM_PDF_HEADING_CONDITIONS_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1013, 'GM_PDF_FOOTER_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1015, 'GM_PDF_ORDER_INFO_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1017, 'GM_PDF_HEADING_ORDER_INFO_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1019, 'GM_PDF_ORDER_TOTAL_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1021, 'GM_PDF_ORDER_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1023, 'GM_PDF_HEADING_ORDER_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1025, 'GM_PDF_HEADING_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1027, 'GM_PDF_COMPANY_RIGHT_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1029, 'GM_PDF_COMPANY_LEFT_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1031, 'GM_PDF_CUSTOMER_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1033, 'GM_PDF_DEFAULT_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1034, 'GM_GUESTBOOK_WAITING_TIME', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1035, 'GM_GUESTBOOK_BLACKLIST', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1036, 'GM_GUESTBOOK_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1084, 'GM_STAT_PLOT_WIDTH', '640', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1039, 'GM_PDF_DRAW_COLOR', '#0065AC', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1040, 'GM_PDF_ALLOW_COPYING', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1038, 'GM_TEMPLATE_NAME', 'xtc4', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1041, 'GM_PDF_ALLOW_NOTIFYING', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1042, 'GM_PDF_ALLOW_MODIFYING', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1043, 'GM_PDF_ALLOW_PRINTING', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1048, 'GM_GUESTBOOK_ENTRIES_LIMIT', '5', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1046, 'GM_COUNTER_IP_BARRIER', '86400', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1049, 'UPLOAD_CONTENT_EXTENSIONS', 'html,htm,xhtml,xml,txt,php,php3,php4,php5,js, pdf', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1050, 'GM_BOOKMARKS_CATEGORIES', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1051, 'GM_BOOKMARKS_ARTICLES', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1052, 'GM_BOOKMARKS_START', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1053, 'GM_BOOKMARKS_REST', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1054, 'GM_LOGO_SHOP', 'shop_logo.gif', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1055, 'GM_LOGO_MAIL', 'email_logo.gif', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1056, 'GM_LOGO_OVERLAY', 'overlay.gif', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1057, 'GM_LOGO_FAVICON', 'favicon.ico', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1058, 'GM_LOGIN_TIMEOUT', '20', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1059, 'GM_LOGIN_TRYOUT', '2', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1060, 'GM_LOGIN_TIMELINE', '20', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1061, 'GM_LOGO_SHOP_USE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1095, 'GM_TOPMENU_MODE', 'mode1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1063, 'GM_LOGO_FAVICON_USE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1064, 'GM_LOGO_FLASH_USE', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1065, 'GM_LOGO_OVERLAY_USE', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1072, 'GM_LOGO_FLASH', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1073, 'GM_LOGO_PDF_USE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1074, 'GM_LOGO_PDF', 'pdf_logo.gif', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1075, 'GM_PRICE_OFFER_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1077, 'GM_REVIEWS_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1078, 'GM_TELL_A_FRIEND_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1079, 'TAX_INFO_TAX_FREE', 'false', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1080, 'GM_GUESTBOOK_ACTIVATE_ENTRIES', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1081, 'GM_CALLBACK_SERVICE_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1085, 'GM_STAT_PLOT_HEIGHT', '480', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1086, 'GM_TELL_A_FRIEND', 'false', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1089, 'GM_ANALYTICS_CODE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1090, 'GM_ANALYTICS_CODE_USE', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1096, 'GM_SHOW_ATTRIBUTES_STOCK', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1097, 'GM_HIDE_ATTR_OUT_OF_STOCK', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1098, 'GM_SET_OUT_OF_STOCK_PRODUCTS_INACTIVE', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1099, 'GM_CONTACT_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1105, 'GM_CART_ON_TOP', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1106, 'GM_LOGO_CAT', 'item_ltr.gif', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1107, 'GM_LOGO_CAT_USE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1108, 'GM_SITEMAP_GOOGLE_CHANGEFREQ', 'weekly', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1109, 'GM_SITEMAP_GOOGLE_PRIORITY', '0.5', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1110, 'GM_SITEMAP_GOOGLE_LANGUAGE_ID', '2', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1111, 'GM_SPECIALS_STARTPAGE', '6', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1112, 'GM_NEW_PRODUCTS_STARTPAGE', '3', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1113, 'GM_PDF_USE_PRODUCTS_MODEL', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1114, 'GM_SHOW_WISH_LIST', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1115, 'GM_SHOP_OFFLINE_MSG', '<p><font face="Arial" size="2">Unser Shop ist aufgrund von Wartungsarbeiten im Moment nicht erreichbar.<br />\r\n</font><font face="Arial" size="2">Bitte besuchen Sie uns zu einem sp&auml;teren Zeitpunkt noch einmal.</font><br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<a href="login_admin.php"><font color="#808080">Login</font></a></p>', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1116, 'GM_SHOP_OFFLINE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1117, 'TRUNCATE_PRODUCTS_NAME', '40', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1123, 'GM_SEO_BOOST_PRODUCTS', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1118, 'GM_LIGHTBOX_CREATE_ACCOUNT', 'false', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1119, 'GM_LIGHTBOX_CART', 'false', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1120, 'GM_LIGHTBOX_CHECKOUT', 'false', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1124, 'GM_SEO_BOOST_CATEGORIES', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1125, 'GM_SEO_BOOST_CONTENT', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1126, 'GM_CHECK_CONDITIONS', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1127, 'GM_SHOW_CONDITIONS', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1136, 'GM_WITHDRAWAL_CONTENT_ID', '3889895', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1129, 'GM_SHOW_WITHDRAWAL', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1137, 'GM_SHOW_PRIVACY_ORDER', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1133, 'GM_SHOW_PRIVACY_REGISTRATION', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1138, 'GM_CHECK_PRIVACY_ORDER', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1139, 'GM_SHOW_PRIVACY_CONFIRMATION', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1140, 'GM_SHOW_CONDITIONS_CONFIRMATION', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1141, 'GM_SHOW_WITHDRAWAL_CONFIRMATION', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1150, 'GM_LOGO_MAIL_USE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1147, 'GM_LOG_IP', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1145, 'GM_CHECK_WITHDRAWAL', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1146, 'TRUSTED_SHOP_ID', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1148, 'GM_SHOW_IP', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1149, 'GM_CONFIRM_IP', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1152, 'GM_SEARCH_TRYOUT', '2', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1153, 'GM_SEARCH_TIMELINE', '20', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1154, 'GM_SEARCH_TIMEOUT', '20', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1155, 'GM_UNDERLINE_LINKS', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1156, 'GM_GUESTBOOK_SEND_MAIL', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1157, 'GM_ORDER_STATUS_CANCEL_ID', '99', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1158, 'GM_PDF_CANCEL_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1159, 'GM_PDF_CANCEL_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1160, 'GM_PDF_CANCEL_FONT_STYLE', 'b', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1161, 'GM_PDF_CANCEL_FONT_FACE', 'freesans', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1162, 'GM_PDF_DISPLAY_OUTPUT', 'I', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1163, 'GM_GAMBIO_CORNER', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1164, 'GM_BOOKMARKS_CONTENT', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1165, 'GM_CAT_HOVER', '#b3ccdd', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1166, 'GM_STARTPAGE_HOVER', '#b3ccdd', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1168, 'GM_FOOTER', '<a href="http://www.gambio.de" target="_blank">Shopsoftware</a> by Gambio.de &copy; 2011', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1170, 'GM_OPENSEARCH_BOX', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1171, 'GM_OPENSEARCH_SEARCH', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1173, 'TRUNCATE_PRODUCTS_HISTORY', '16', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1174, 'GM_NEXT_INVOICE_ID', '12', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1175, 'GM_NEXT_PACKINGS_ID', '87', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1176, 'GM_INVOICE_ID', 'R_{INVOICE_ID}_2008', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1177, 'GM_PACKINGS_ID', '{DELIVERY_ID}_2008', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1178, 'GM_OPENSEARCH_CHANGED', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1179, 'GM_SHOW_FLYOVER', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1180, 'GM_LOGO_CAT_SIZE_W', '5', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1181, 'GM_LOGO_CAT_SIZE_H', '13', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1182, 'GM_LOGO_SHOP_SIZE_W', '142', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1183, 'GM_LOGO_SHOP_SIZE_H', '96', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1184, 'GM_LOGO_FLASH_SIZE_W', '160', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1185, 'GM_LOGO_FLASH_SIZE_H', '600', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1186, 'GM_SHOW_WISHLIST', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1187, 'GM_TITLE_USE_STANDARD_META_TITLE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1188, 'GM_TITLE_SHOW_STANDARD_META_TITLE', 'before', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_ALLOWED_FILE_EXTENSIONS', 'jpg,png,gif,jpeg', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_CHARACTER_LENGTH', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_AUTO_WIDTH', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_POSITION', '3', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_SHOW_PRODUCTS_DESCRIPTION', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_EXCLUDE_SPACES', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_SHOW_TABS', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_UPLOADS_PER_IP', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_UPLOADS_PER_IP_INTERVAL', '60', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_POSITION', '3', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_WIDTH', '351', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_HEIGHT', '200', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_LIGHTBOX_WIDTH', '700', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_LIGHTBOX_HEIGHT', '400', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_AUTO_WIDTH', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_LIGHTBOX', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_POSITION_FROM', '0% 50%', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_POSITION_TO', '100% 50%', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_ZOOM_FROM', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_ZOOM_TO', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_LIGHTBOX_ZOOM_FROM', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_LIGHTBOX_ZOOM_TO', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_DURATION', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_PDF_ORDER_STATUS_INVOICE_DATE', '149', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_PDF_ORDER_STATUS_INVOICE_MAIL', '149', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_PDF_ORDER_STATUS_INVOICE', '149', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('TRUNCATE_FLYOVER', '35', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('TRUNCATE_FLYOVER_TEXT', '150', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('FEATURE_EMPTY_BOX_MODE', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('FEATURE_DISPLAY_MODE', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('FEATURE_MODE', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('STARTPAGE_FILTER_ACTIVE', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GLOBAL_FILTER', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('PERSISTENT_GLOBAL_FILTER', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_FORGOT_PASSWORD_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('SHOW_OLD_SPECIAL_PRICE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_CAPTCHA_TYPE', 'standard', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_RECAPTCHA_PUBLIC_KEY', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_RECAPTCHA_PRIVATE_KEY', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_FORGOT_PASSWORD_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GOOGLE_TAXONOMY_FILE_PATH', 'http://www.google.com/basepages/producttype/taxonomy.de-DE.txt', 0, 0);

INSERT INTO `gm_configuration` SET `gm_key` = 'GM_AUTO_SHIPPING_STATUS', `gm_value` = 'true';

INSERT INTO `gm_configuration` SET `gm_key` = 'CUSTOMIZER_POSITION', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_GALLERY', `gm_value` = 'true';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_ZOOM', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'CAT_MENU_TOP', `gm_value` = 'true';
INSERT INTO `gm_configuration` SET `gm_key` = 'CAT_MENU_LEFT', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'CAT_MENU_CLASSIC', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_TOP_LANGUAGE_SELECTION', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_TOP_CURRENCY_SELECTION', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_FOOTER', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_QUICK_SEARCH', `gm_value` = 'true';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_FACEBOOK', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_PRINT', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_BOOKMARKING', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SECURE_TOKEN', `gm_value` = md5(rand());
INSERT INTO `gm_configuration` SET `gm_key` = 'PRICE_FILTER_FROM_ACTIVE', `gm_value` = 'true';
INSERT INTO `gm_configuration` SET `gm_key` = 'PRICE_FILTER_TO_ACTIVE', `gm_value` = 'true';

INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_CALLBACK', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_CONTACT', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_TELL_A_FRIEND', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_FOUND_CHEAPER', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_REVIEWS', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_ACCOUNT_CONTACT', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_ACCOUNT_ADDRESS_BOOK', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_ACCOUNT_NEWSLETTER', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_CHECKOUT_SHIPPING', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_CHECKOUT_PAYMENT', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'MAIN_SHOW_ATTRIBUTES', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'MAIN_SHOW_GRADUATED_PRICES', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'MAIN_SHOW_QTY', `gm_value` = 'true';
INSERT INTO `gm_configuration` SET `gm_key` = 'MAIN_SHOW_QTY_INFO', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'MAIN_VIEW_MODE_TILED', `gm_value` = 'false';

INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_OLD_SPECIAL_PRICE', `gm_value` = '0';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_OLD_DISCOUNT_PRICE', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_OLD_GROUP_PRICE', `gm_value` = '0';

INSERT INTO `gm_configuration` SET `gm_key` = 'EKOMI_STATUS', `gm_value` = '0';
INSERT INTO `gm_configuration` SET `gm_key` = 'EKOMI_API_PASSWORD', `gm_value` = '';
INSERT INTO `gm_configuration` SET `gm_key` = 'EKOMI_API_ID', `gm_value` = '';
INSERT INTO `gm_configuration` SET `gm_key` = 'EKOMI_WIDGET_CODE', `gm_value` = '';

INSERT INTO `gm_configuration` SET `gm_key` = 'DISPLAY_TAX', `gm_value` = '1';

INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_TWITTER', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_GOOGLEPLUS', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_PINTEREST', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_ORDER_STATUS_INVOICE_CREATED_ID', `gm_value` = '149';
INSERT INTO `gm_configuration` SET `gm_key` = 'NUMBER_OF_ORDERS_PER_PAGE', `gm_value` = '20';

INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('WITHDRAWAL_WEBFORM_ACTIVE', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('WITHDRAWAL_PDF_ACTIVE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('SHOW_ACCOUNT_WITHDRAWAL_LINK', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_WITHDRAWAL_CONTENT_ID_BACKUP', '9', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('SHIPPING_INFOS_BACKUP', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('ATTACH_CONDITIONS_OF_USE_IN_ORDER_CONFIRMATION', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('ATTACH_WITHDRAWAL_INFO_IN_ORDER_CONFIRMATION', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('ATTACH_WITHDRAWAL_FORM_IN_ORDER_CONFIRMATION', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('USE_SEO_BOOST_LANGUAGE_CODE', 'true', 0, 0);

INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(103, 1, 'robots', 'index,follow', 1, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(104, 2, 'robots', 'index,follow', 1, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(105, 1, 'keywords', '', 1, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(107, 2, 'keywords', 'keywords,kommagetrennt', 1, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(117, 2, 'XTCsid', 'b391baf59be7494b871846d2d5bf7a45', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(5, 2, 'GM_PDF_HEADING_PACKINGSLIP', 'Ihr Lieferschein', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(6, 2, 'GM_PDF_HEADING_INVOICE', 'Ihre Rechnung', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(7, 2, 'GM_PDF_COMPANY_ADRESS_RIGHT', 'Ihr Name \nIhre Strasse 1 \n\n12345 Ihr Ort', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(8, 2, 'GM_PDF_COMPANY_ADRESS_LEFT', 'Ihr Name, Ihre Strasse 1, 12345 Ihr Ort', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(9, 1, 'GM_PDF_HEADING_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(10, 1, 'GM_PDF_HEADING_INVOICE', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(11, 1, 'GM_PDF_COMPANY_ADRESS_RIGHT', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(12, 1, 'GM_PDF_COMPANY_ADRESS_LEFT', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(13, 2, 'GM_PDF_HEADING_CONDITIONS', 'Unsere AGB', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(14, 2, 'GM_PDF_HEADING_WITHDRAWAL', 'Unser Widerrufsrecht', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(15, 2, 'GM_PDF_CONDITIONS', 'Hier könnten Ihre AGB stehen.', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(16, 2, 'GM_PDF_WITHDRAWAL', 'Hier könnte Ihr Widerrufsrecht stehen.', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(17, 1, 'GM_PDF_HEADING_CONDITIONS', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(18, 1, 'GM_PDF_HEADING_WITHDRAWAL', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(19, 1, 'GM_PDF_CONDITIONS', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(20, 1, 'GM_PDF_WITHDRAWAL', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(43, 1, 'GM_PDF_EMAIL_TEXT', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(44, 2, 'GM_PDF_EMAIL_TEXT', 'Sehr geehrte/r {CUSTOMER},\n\nSie erhalten mit dieser E-Mail Ihre Rechnung Nr. {INVOICE_ID} von der Bestellung Nr. {ORDER_ID} vom {DATE}.\n\nMit freundlichem Gruß\n\nIhr Ansprechpartner', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(21, 2, 'GM_PDF_INFO_TEXT_PACKINGSLIP', 'Ihr Hinweistext für den Lieferschein', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(22, 2, 'GM_PDF_INFO_TEXT_INVOICE', 'Ihr Hinweistext für die Rechnung', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(23, 2, 'GM_PDF_INFO_TITLE_PACKINGSLIP', 'Beachten Sie bitte', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(24, 2, 'GM_PDF_INFO_TITLE_INVOICE', 'Beachten Sie bitte', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(25, 2, 'GM_PDF_HEADING_INFO_TEXT_PACKINGSLIP', 'Lieferhinweis', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(26, 2, 'GM_PDF_HEADING_INFO_TEXT_INVOICE', 'Rechnungshinweis', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(27, 2, 'GM_PDF_FOOTER_CELL_4', 'Zusätzliche\nInformationen\nin der vierten\nSpalte\n', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(28, 2, 'GM_PDF_FOOTER_CELL_3', 'Ihre Steuernummer\nIhre Ust. ID. Nr.\nIhre Gerichtsbarkeit\nIhre Informationen', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(29, 2, 'GM_PDF_FOOTER_CELL_2', 'Ihre Telefonnummer\nIhre Faxnummer\nIhre Homepage\nIhre E-Mail', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(30, 2, 'GM_PDF_FOOTER_CELL_1', 'Ihr Name \nIhre Strasse 1 \n\n12345 Ihr Ort', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(31, 1, 'GM_PDF_INFO_TEXT_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(32, 1, 'GM_PDF_INFO_TEXT_INVOICE', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(33, 1, 'GM_PDF_INFO_TITLE_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(34, 1, 'GM_PDF_INFO_TITLE_INVOICE', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(35, 1, 'GM_PDF_HEADING_INFO_TEXT_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(36, 1, 'GM_PDF_HEADING_INFO_TEXT_INVOICE', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(37, 1, 'GM_PDF_FOOTER_CELL_4', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(38, 1, 'GM_PDF_FOOTER_CELL_3', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(39, 1, 'GM_PDF_FOOTER_CELL_2', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(40, 1, 'GM_PDF_FOOTER_CELL_1', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(73, 0, 'GM_BOOKMARKS_CATEGORIES', '1', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(74, 0, 'GM_BOOKMARKS_ARTICLES', '1', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(75, 0, 'GM_BOOKMARKS_START', '1', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(76, 0, 'GM_BOOKMARKS_REST', '1', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(120, 2, 'GM_SCROLLER_CONTENT', '<p style="text-align: center;"><strong>Hier ist genug Platz f&uuml;r Ihre Texte, Links&nbsp;und Bilder!</strong></p>\r\n<p style="text-align: center;">&nbsp;</p>\r\n<p style="text-align: center;"><a href="http://www.gambio.de"><strong><img height="64" width="145" src="images/gambio-logo.jpg" alt="" /></strong></a></p>', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(121, 1, 'GM_SCROLLER_CONTENT', '<p>News</p>', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(125, 2, 'GM_PDF_EMAIL_SUBJECT', 'Ihre Rechnung der Nr. {INVOICE_ID} vom {DATE} mit der Bestellnummer {ORDER_ID}', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(127, 2, 'GM_OPENSEARCH_SHORTNAME', 'Shop Suche', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(128, 2, 'GM_OPENSEARCH_LONGNAME', 'Unsere Shopsuche findet alles', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(129, 2, 'GM_OPENSEARCH_DESCRIPTION', 'Super Such Beschreibung', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(130, 2, 'GM_OPENSEARCH_TAGS', 'Shopsuche Suchen Shop', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(131, 2, 'GM_OPENSEARCH_CONTACT', 'admin@shop.de', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(143, 1, 'GM_OPENSEARCH_TEXT', 'Instant Search', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(133, 2, 'GM_OPENSEARCH_LINK', 'Suche zu Ihrer Browser-Schnellsuche hinzufügen.', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(141, 2, 'GM_OPENSEARCH_TEXT', 'Browser-Schnellsuche', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(135, 1, 'GM_OPENSEARCH_LINK', 'Add this Search to your Browser Instant Search', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(136, 1, 'GM_OPENSEARCH_SHORTNAME', 'Shop Search', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(137, 1, 'GM_OPENSEARCH_LONGNAME', 'Shop Instant Search', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(138, 1, 'GM_OPENSEARCH_DESCRIPTION', 'Add this Search to your Browser Instant Search', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(139, 1, 'GM_OPENSEARCH_TAGS', 'Instant Search', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(140, 1, 'GM_OPENSEARCH_CONTACT', 'you@example.com', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(142, 1, 'GM_PDF_EMAIL_SUBJECT', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(145, 2, 'date', '', 1, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(146, 1, 'GM_TITLE_STANDARD_META_TITLE_SEPARATOR', ' - ', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(147, 2, 'GM_TITLE_STANDARD_META_TITLE_SEPARATOR', ' - ', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(148, 1, 'GM_TITLE_STANDARD_META_TITLE', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(149, 2, 'GM_TITLE_STANDARD_META_TITLE', '', 0, 0);
INSERT INTO gm_contents (languages_id, gm_key, gm_value) VALUES (1, 'EMAIL_BILLING_SUBJECT_ORDER', 'Your order {$nr}, {$date}');
INSERT INTO gm_contents (languages_id, gm_key, gm_value) VALUES (2, 'EMAIL_BILLING_SUBJECT_ORDER', 'Ihre Bestellung {$nr}, am {$date}');

INSERT INTO `gm_counter_info` (`gm_counter_info_id`, `gm_counter_info_type_id`, `gm_counter_info_hits`, `gm_counter_info_name`) VALUES(126, 1, 1, 'Mozilla Firefox 3.0.1');
INSERT INTO `gm_counter_info` (`gm_counter_info_id`, `gm_counter_info_type_id`, `gm_counter_info_hits`, `gm_counter_info_name`) VALUES(127, 2, 1, 'Windows XP');
INSERT INTO `gm_counter_info` (`gm_counter_info_id`, `gm_counter_info_type_id`, `gm_counter_info_hits`, `gm_counter_info_name`) VALUES(128, 5, 1, 'de');
INSERT INTO `gm_counter_info` (`gm_counter_info_id`, `gm_counter_info_type_id`, `gm_counter_info_hits`, `gm_counter_info_name`) VALUES(129, 3, 1, '1680x1050');
INSERT INTO `gm_counter_info` (`gm_counter_info_id`, `gm_counter_info_type_id`, `gm_counter_info_hits`, `gm_counter_info_name`) VALUES(130, 4, 1, '32');


INSERT INTO `gm_counter_info_type` (`gm_counter_info_type_id`, `gm_counter_info_type_name`) VALUES(1, 'browser');
INSERT INTO `gm_counter_info_type` (`gm_counter_info_type_id`, `gm_counter_info_type_name`) VALUES(2, 'platform');
INSERT INTO `gm_counter_info_type` (`gm_counter_info_type_id`, `gm_counter_info_type_name`) VALUES(3, 'resolution');
INSERT INTO `gm_counter_info_type` (`gm_counter_info_type_id`, `gm_counter_info_type_name`) VALUES(4, 'color_depth');
INSERT INTO `gm_counter_info_type` (`gm_counter_info_type_id`, `gm_counter_info_type_name`) VALUES(5, 'origin');



INSERT INTO `gm_counter_visits` (`gm_counter_id`, `gm_counter_visits_total`, `gm_counter_date`) VALUES(1, 1, '2008-08-25 00:00:00');

INSERT INTO `gm_css_look` (`gm_css_ref_look_id`, `gm_css_look_name`) VALUES ('1', 'default');

INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(1, 1, '', 'change_password_mail', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p><span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>Dear customer,</strong></span></span></p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Your password was successfully changed.<br />\r\n								<br />\r\n								Your new login data:\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Your mail:</strong> {$EMAIL}<br />\r\n											<strong>Your new passwort:</strong> {$PASSWORD}\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p><span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>Dear customer,</strong></span></span></p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Your password was successfully changed.<br />\r\n								<br />\r\n								Your new login data:\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Your mail:</strong> {$EMAIL}<br />\r\n											<strong>Your new passwort:</strong> {$PASSWORD}\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear customer,\r\n\r\nYour password was successfully changed.\r\n\r\nYour new login data:\r\n      \r\nemail: {$EMAIL}\r\nPassword: {$PASSWORD}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', 'Dear customer,\r\n\r\nYour password was successfully changed.\r\n\r\nYour new login data:\r\n      \r\nemail: {$EMAIL}\r\nPassword: {$PASSWORD}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p><span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>Dear customer,</strong></span></span></p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Your password was successfully changed.<br />\r\n								<br />\r\n								Your new login data:\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Your mail:</strong> {$EMAIL}<br />\r\n											<strong>Your new passwort:</strong> {$PASSWORD}\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear customer,\r\n\r\nYour password was successfully changed.\r\n\r\nYour new login data:\r\n      \r\nemail: {$EMAIL}\r\nPassword: {$PASSWORD}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(1, 2, '', 'change_password_mail', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p><span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>Sehr geehrter Kunde,</strong></span></span></p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								ihr Passwort wurde erfolgreich ge&auml;ndert.<br />\r\n								<br />\r\n								Ihre neuen Logindaten lauten:\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>E-Mail:</strong> {$EMAIL}<br />\r\n											<strong>Neues Passwort:</strong> {$PASSWORD}\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p><span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>Sehr geehrter Kunde,</strong></span></span></p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								ihr Passwort wurde erfolgreich ge&auml;ndert.<br />\r\n								<br />\r\n								Ihre neuen Logindaten lauten:\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>E-Mail:</strong> {$EMAIL}<br />\r\n											<strong>Neues Passwort:</strong> {$PASSWORD}\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr geehrter Kunde,\r\n\r\nihr Passwort wurde erfolgreich geändert.\r\n\r\nIhre neuen Logindaten lauten: \r\nE-Mail: {$EMAIL}\r\nNeues Passwort: {$PASSWORD}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', 'Sehr geehrter Kunde,\r\n\r\nihr Passwort wurde erfolgreich geändert.\r\n\r\nIhre neuen Logindaten lauten: \r\nE-Mail: {$EMAIL}\r\nNeues Passwort: {$PASSWORD}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p><span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>Sehr geehrter Kunde,</strong></span></span></p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								ihr Passwort wurde erfolgreich ge&auml;ndert.<br />\r\n								<br />\r\n								Ihre neuen Logindaten lauten:\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>E-Mail:</strong> {$EMAIL}<br />\r\n											<strong>Neues Passwort:</strong> {$PASSWORD}\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr geehrter Kunde,\r\n\r\nihr Passwort wurde erfolgreich geändert.\r\n\r\nIhre neuen Logindaten lauten: \r\nE-Mail: {$EMAIL}\r\nNeues Passwort: {$PASSWORD}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(2, 1, '', 'create_account_mail', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; font-size: 13px; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-family:arial,helvetica,sans-serif;"><span style="font-size: 13px;">\r\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\r\n							<br />\r\n\r\n							You successfully created your Customer Account, now you got following features in our shop.<br />\r\n							<br />\r\n							<strong>- Customer shopping cart:</strong> Every item remains registered until you go to the cash box, or the products are deleted from the shopping cart.<br />\r\n							<strong>- Address book:</strong> Now we can send the products to the postal address selected by you. The perfect way to get a birthday present.<br />\r\n							<strong>- Previous orders:</strong> You can check your previous orders at any time.<br />\r\n							<strong>- Opinions about products:</strong> Tell your opinion about our products to other customers.<br />\r\n							<br />\r\n							If you have questions to our customer-service, contact us directly: {$content.MAIL_REPLY_ADDRESS}.<br />\r\n							Caution: This eMail-address was announced to us by a customer. If you did not announce yourself, please send an eMail to {$content.MAIL_REPLY_ADDRESS}.<br />\r\n							<br />\r\n							{if $SEND_GIFT==true}<br />\r\n							As part of our welcome to new customers, we have sent you an e-Gift Voucher worth: <strong>{$GIFT_AMMOUNT}</strong><br />\r\n							<br />\r\n							The redeem code for the e-Gift Voucher is <strong>{$GIFT_CODE}</strong>, you can enter the redeem code when checking out while making a purchase.<br />\r\n							<br />\r\n							To use your e-Gift voucher, click on Following link <a href="{$GIFT_LINK}">[redeem Voucher]</a>.<br /><br />{/if}\r\n							{if $SEND_COUPON==true}Congratulations, to make your first visit to our online shop a more rewarding experience we are sending you an e-Discount Coupon.<br />\r\n							Below are details of the Discount Coupon created just for you.<br />\r\n							Description: <strong>{$COUPON_DESC}</strong><br />\r\n							To use the coupon enter the redeem code which is {$COUPON_CODE} during checkout while making a purchase. {/if}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; font-size: 13px; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-family:arial,helvetica,sans-serif;"><span style="font-size: 13px;">\r\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\r\n							<br />\r\n\r\n							You successfully created your Customer Account, now you got following features in our shop.<br />\r\n							<br />\r\n							<strong>- Customer shopping cart:</strong> Every item remains registered until you go to the cash box, or the products are deleted from the shopping cart.<br />\r\n							<strong>- Address book:</strong> Now we can send the products to the postal address selected by you. The perfect way to get a birthday present.<br />\r\n							<strong>- Previous orders:</strong> You can check your previous orders at any time.<br />\r\n							<strong>- Opinions about products:</strong> Tell your opinion about our products to other customers.<br />\r\n							<br />\r\n							If you have questions to our customer-service, contact us directly: {$content.MAIL_REPLY_ADDRESS}.<br />\r\n							Caution: This eMail-address was announced to us by a customer. If you did not announce yourself, please send an eMail to {$content.MAIL_REPLY_ADDRESS}.<br />\r\n							<br />\r\n							{if $SEND_GIFT==true}<br />\r\n							As part of our welcome to new customers, we have sent you an e-Gift Voucher worth: <strong>{$GIFT_AMMOUNT}</strong><br />\r\n							<br />\r\n							The redeem code for the e-Gift Voucher is <strong>{$GIFT_CODE}</strong>, you can enter the redeem code when checking out while making a purchase.<br />\r\n							<br />\r\n							To use your e-Gift voucher, click on Following link <a href="{$GIFT_LINK}">[redeem Voucher]</a>.<br /><br />{/if}\r\n							{if $SEND_COUPON==true}Congratulations, to make your first visit to our online shop a more rewarding experience we are sending you an e-Discount Coupon.<br />\r\n							Below are details of the Discount Coupon created just for you.<br />\r\n							Description: <strong>{$COUPON_DESC}</strong><br />\r\n							To use the coupon enter the redeem code which is {$COUPON_CODE} during checkout while making a purchase. {/if}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nYou successfully created your Customer Account, now you got following features in our shop.\r\n\r\n- Customer shopping cart: Every item remains registered until you go to the cash box, or the products are deleted from the shopping cart.\r\n- Address book: Now we can send the products to the postal address selected by you. The perfect way to get a birthday present.\r\n- Previous orders: You can check  your previous orders at any time.\r\n- Opinions about products: Tell your opinion about our products to other customers\r\n\r\nIf you have questions to our customer-service, contact us directly: {$content.MAIL_REPLY_ADDRESS}\r\nCaution: This eMail-address was announced to us by a customer. If you did not announce yourself, please send an eMail to {$content.MAIL_REPLY_ADDRESS}.\r\n\r\n{if $SEND_GIFT==true}\r\nAs part of our welcome to new customers, we have sent you an e-Gift Voucher worth: {$GIFT_AMMOUNT}\r\n\r\nThe redeem code for the e-Gift Voucher is {$GIFT_CODE}, you can enter the redeem code when checking out while making a purchase.\r\n\r\nTo use your e-Gift voucher, click on Following link {$GIFT_LINK}. \r\n{/if} \r\n\r\n{if $SEND_COUPON==true} \r\nCongratulations, to make your first visit to our online shop a more rewarding experience we are sending you an e-Discount Coupon.\r\nBelow are details of the Discount Coupon created just for you.\r\n\r\nDescription: {$COUPON_DESC}\r\n\r\nTo use the coupon enter the redeem code which is {$COUPON_CODE} during checkout while making a purchase.\r\n{/if}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nYou successfully created your Customer Account, now you got following features in our shop.\r\n\r\n- Customer shopping cart: Every item remains registered until you go to the cash box, or the products are deleted from the shopping cart.\r\n- Address book: Now we can send the products to the postal address selected by you. The perfect way to get a birthday present.\r\n- Previous orders: You can check  your previous orders at any time.\r\n- Opinions about products: Tell your opinion about our products to other customers\r\n\r\nIf you have questions to our customer-service, contact us directly: {$content.MAIL_REPLY_ADDRESS}\r\nCaution: This eMail-address was announced to us by a customer. If you did not announce yourself, please send an eMail to {$content.MAIL_REPLY_ADDRESS}.\r\n\r\n{if $SEND_GIFT==true}\r\nAs part of our welcome to new customers, we have sent you an e-Gift Voucher worth: {$GIFT_AMMOUNT}\r\n\r\nThe redeem code for the e-Gift Voucher is {$GIFT_CODE}, you can enter the redeem code when checking out while making a purchase.\r\n\r\nTo use your e-Gift voucher, click on Following link {$GIFT_LINK}. \r\n{/if} \r\n\r\n{if $SEND_COUPON==true} \r\nCongratulations, to make your first visit to our online shop a more rewarding experience we are sending you an e-Discount Coupon.\r\nBelow are details of the Discount Coupon created just for you.\r\n\r\nDescription: {$COUPON_DESC}\r\n\r\nTo use the coupon enter the redeem code which is {$COUPON_CODE} during checkout while making a purchase.\r\n{/if}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; font-size: 13px; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-family:arial,helvetica,sans-serif;"><span style="font-size: 13px;">\r\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\r\n							<br />\r\n\r\n							You successfully created your Customer Account, now you got following features in our shop.<br />\r\n							<br />\r\n							<strong>- Customer shopping cart:</strong> Every item remains registered until you go to the cash box, or the products are deleted from the shopping cart.<br />\r\n							<strong>- Address book:</strong> Now we can send the products to the postal address selected by you. The perfect way to get a birthday present.<br />\r\n							<strong>- Previous orders:</strong> You can check your previous orders at any time.<br />\r\n							<strong>- Opinions about products:</strong> Tell your opinion about our products to other customers.<br />\r\n							<br />\r\n							If you have questions to our customer-service, contact us directly: {$content.MAIL_REPLY_ADDRESS}.<br />\r\n							Caution: This eMail-address was announced to us by a customer. If you did not announce yourself, please send an eMail to {$content.MAIL_REPLY_ADDRESS}.<br />\r\n							<br />\r\n							{if $SEND_GIFT==true}<br />\r\n							As part of our welcome to new customers, we have sent you an e-Gift Voucher worth: <strong>{$GIFT_AMMOUNT}</strong><br />\r\n							<br />\r\n							The redeem code for the e-Gift Voucher is <strong>{$GIFT_CODE}</strong>, you can enter the redeem code when checking out while making a purchase.<br />\r\n							<br />\r\n							To use your e-Gift voucher, click on Following link <a href="{$GIFT_LINK}">[redeem Voucher]</a>.<br /><br />{/if}\r\n							{if $SEND_COUPON==true}Congratulations, to make your first visit to our online shop a more rewarding experience we are sending you an e-Discount Coupon.<br />\r\n							Below are details of the Discount Coupon created just for you.<br />\r\n							Description: <strong>{$COUPON_DESC}</strong><br />\r\n							To use the coupon enter the redeem code which is {$COUPON_CODE} during checkout while making a purchase. {/if}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nYou successfully created your Customer Account, now you got following features in our shop.\r\n\r\n- Customer shopping cart: Every item remains registered until you go to the cash box, or the products are deleted from the shopping cart.\r\n- Address book: Now we can send the products to the postal address selected by you. The perfect way to get a birthday present.\r\n- Previous orders: You can check  your previous orders at any time.\r\n- Opinions about products: Tell your opinion about our products to other customers\r\n\r\nIf you have questions to our customer-service, contact us directly: {$content.MAIL_REPLY_ADDRESS}\r\nCaution: This eMail-address was announced to us by a customer. If you did not announce yourself, please send an eMail to {$content.MAIL_REPLY_ADDRESS}.\r\n\r\n{if $SEND_GIFT==true}\r\nAs part of our welcome to new customers, we have sent you an e-Gift Voucher worth: {$GIFT_AMMOUNT}\r\n\r\nThe redeem code for the e-Gift Voucher is {$GIFT_CODE}, you can enter the redeem code when checking out while making a purchase.\r\n\r\nTo use your e-Gift voucher, click on Following link {$GIFT_LINK}. \r\n{/if} \r\n\r\n{if $SEND_COUPON==true} \r\nCongratulations, to make your first visit to our online shop a more rewarding experience we are sending you an e-Discount Coupon.\r\nBelow are details of the Discount Coupon created just for you.\r\n\r\nDescription: {$COUPON_DESC}\r\n\r\nTo use the coupon enter the redeem code which is {$COUPON_CODE} during checkout while making a purchase.\r\n{/if}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(2, 2, '', 'create_account_mail', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; font-size: 13px; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-family:arial,helvetica,sans-serif;"><span style="font-size: 13px;">\r\n							<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau{else}geehrte(r) {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							Sie haben soeben Ihr Kundenkonto erfolgreich erstellt. Als registrierter Kunde haben Sie folgende Vorteile in unserem Shop:<br />\r\n							<br />\r\n							<strong>- Kundenwarenkorb:</strong> Jeder Artikel bleibt registriert bis Sie zur Kasse gehen oder die Produkte aus dem Warenkorb entfernen.<br />\r\n							<strong>- Adressbuch:</strong> Wir k&ouml;nnen jetzt die Produkte zu der von Ihnen ausgesuchten Adresse senden. Der perfekte Weg ein Geburtstagsgeschenk zu versenden.<br />\r\n							<strong>- Vorherige Bestellungen:</strong> Sie k&ouml;nnen jederzeit Ihre vorherigen Bestellungen &uuml;berpr&uuml;fen.<br />\r\n							<strong>- Meinungen &uuml;ber Produkte:</strong> Teilen Sie Ihre Meinung zu unseren Produkten mit anderen Kunden.<br />\r\n							<br />\r\n							Falls Sie Fragen zu unserem Kunden-Service haben, wenden Sie sich bitte an {$content.MAIL_REPLY_ADDRESS}.<br />\r\n							Achtung: Diese E-Mail-Adresse wurde uns von einem Kunden bekannt gegeben. Falls Sie sich nicht angemeldet haben, senden Sie bitte eine E-Mail an {$content.MAIL_REPLY_ADDRESS}.<br />\r\n							<br />\r\n							{if $SEND_GIFT==true}<br />\r\n							Als kleines Willkommensgeschenk senden wir Ihnen einen Gutschein &uuml;ber: <strong>{$GIFT_AMMOUNT}</strong><br />\r\n							<br />\r\n							Ihr pers&ouml;nlicher Gutschein-Code lautet <strong>{$GIFT_CODE}</strong>. Sie k&ouml;nnen diese Gutschrift an der Kasse w&auml;hrend des Bestellvorganges verbuchen.<br />\r\n							<br />\r\n							Um den Gutschein einzul&ouml;sen klicken Sie bitte auf <a href="{$GIFT_LINK}">[Gutschein Einl&ouml;sen]</a>.<br /><br />{/if}\r\n							{if $SEND_COUPON==true}Als kleines Willkommensgeschenk senden wir Ihnen einen Kupon.<br />\r\n							Kuponbeschreibung: <strong>{$COUPON_DESC}</strong><br />\r\n							Geben Sie einfach Ihren pers&ouml;nlichen Code {$COUPON_CODE} w&auml;hrend des Bezahlvorganges ein. {/if}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; font-size: 13px; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-family:arial,helvetica,sans-serif;"><span style="font-size: 13px;">\r\n							<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau{else}geehrte(r) {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							Sie haben soeben Ihr Kundenkonto erfolgreich erstellt. Als registrierter Kunde haben Sie folgende Vorteile in unserem Shop:<br />\r\n							<br />\r\n							<strong>- Kundenwarenkorb:</strong> Jeder Artikel bleibt registriert bis Sie zur Kasse gehen oder die Produkte aus dem Warenkorb entfernen.<br />\r\n							<strong>- Adressbuch:</strong> Wir k&ouml;nnen jetzt die Produkte zu der von Ihnen ausgesuchten Adresse senden. Der perfekte Weg ein Geburtstagsgeschenk zu versenden.<br />\r\n							<strong>- Vorherige Bestellungen:</strong> Sie k&ouml;nnen jederzeit Ihre vorherigen Bestellungen &uuml;berpr&uuml;fen.<br />\r\n							<strong>- Meinungen &uuml;ber Produkte:</strong> Teilen Sie Ihre Meinung zu unseren Produkten mit anderen Kunden.<br />\r\n							<br />\r\n							Falls Sie Fragen zu unserem Kunden-Service haben, wenden Sie sich bitte an {$content.MAIL_REPLY_ADDRESS}.<br />\r\n							Achtung: Diese E-Mail-Adresse wurde uns von einem Kunden bekannt gegeben. Falls Sie sich nicht angemeldet haben, senden Sie bitte eine E-Mail an {$content.MAIL_REPLY_ADDRESS}.<br />\r\n							<br />\r\n							{if $SEND_GIFT==true}<br />\r\n							Als kleines Willkommensgeschenk senden wir Ihnen einen Gutschein &uuml;ber: <strong>{$GIFT_AMMOUNT}</strong><br />\r\n							<br />\r\n							Ihr pers&ouml;nlicher Gutschein-Code lautet <strong>{$GIFT_CODE}</strong>. Sie k&ouml;nnen diese Gutschrift an der Kasse w&auml;hrend des Bestellvorganges verbuchen.<br />\r\n							<br />\r\n							Um den Gutschein einzul&ouml;sen klicken Sie bitte auf <a href="{$GIFT_LINK}">[Gutschein Einl&ouml;sen]</a>.<br /><br />{/if}\r\n							{if $SEND_COUPON==true}Als kleines Willkommensgeschenk senden wir Ihnen einen Kupon.<br />\r\n							Kuponbeschreibung: <strong>{$COUPON_DESC}</strong><br />\r\n							Geben Sie einfach Ihren pers&ouml;nlichen Code {$COUPON_CODE} w&auml;hrend des Bezahlvorganges ein. {/if}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nSie haben soeben Ihr Kundenkonto erfolgreich erstellt. Als registrierter Kunde haben Sie folgende Vorteile in unserem Shop:\r\n\r\n- Kundenwarenkorb: Jeder Artikel bleibt registriert bis Sie zur Kasse gehen oder die Produkte aus dem Warenkorb entfernen.\r\n- Adressbuch: Wir können jetzt die Produkte zu der von Ihnen ausgesuchten Adresse senden. Der perfekte Weg ein Geburtstagsgeschenk zu versenden.\r\n- Vorherige Bestellungen: Sie können jederzeit Ihre vorherigen Bestellungen überprüfen.\r\n- Meinungen über Produkte: Teilen Sie Ihre Meinung zu unseren Produkten mit anderen Kunden.\r\n\r\nFalls Sie Fragen zu unserem Kunden-Service haben, wenden Sie sich bitte an {$content.MAIL_REPLY_ADDRESS}.\r\nAchtung: Diese E-Mail-Adresse wurde uns von einem Kunden bekannt gegeben. Falls Sie sich nicht angemeldet haben, senden Sie bitte eine E-Mail an {$content.MAIL_REPLY_ADDRESS}.\r\n\r\n{if $SEND_GIFT==true}\r\nAls kleines Willkommensgeschenk senden wir Ihnen einen Gutschein über: {$GIFT_AMMOUNT}\r\n\r\nIhr persönlicher Gutschein-Code lautet {$GIFT_CODE}. Sie können diese Gutschrift an der Kasse während des Bestellvorganges verbuchen.\r\n\r\nUm den Gutschein einzulösen klicken Sie bitte auf [Gutschein Einlösen].\r\n{/if}\r\n\r\n{if $SEND_COUPON==true}\r\nAls kleines Willkommensgeschenk senden wir Ihnen einen Kupon.\r\n\r\nKuponbeschreibung: {$COUPON_DESC}\r\n\r\nGeben Sie einfach Ihren persönlichen Code {$COUPON_CODE} während des Bezahlvorganges ein.\r\n{/if}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nSie haben soeben Ihr Kundenkonto erfolgreich erstellt. Als registrierter Kunde haben Sie folgende Vorteile in unserem Shop:\r\n\r\n- Kundenwarenkorb: Jeder Artikel bleibt registriert bis Sie zur Kasse gehen oder die Produkte aus dem Warenkorb entfernen.\r\n- Adressbuch: Wir können jetzt die Produkte zu der von Ihnen ausgesuchten Adresse senden. Der perfekte Weg ein Geburtstagsgeschenk zu versenden.\r\n- Vorherige Bestellungen: Sie können jederzeit Ihre vorherigen Bestellungen überprüfen.\r\n- Meinungen über Produkte: Teilen Sie Ihre Meinung zu unseren Produkten mit anderen Kunden.\r\n\r\nFalls Sie Fragen zu unserem Kunden-Service haben, wenden Sie sich bitte an {$content.MAIL_REPLY_ADDRESS}.\r\nAchtung: Diese E-Mail-Adresse wurde uns von einem Kunden bekannt gegeben. Falls Sie sich nicht angemeldet haben, senden Sie bitte eine E-Mail an {$content.MAIL_REPLY_ADDRESS}.\r\n\r\n{if $SEND_GIFT==true}\r\nAls kleines Willkommensgeschenk senden wir Ihnen einen Gutschein über: {$GIFT_AMMOUNT}\r\n\r\nIhr persönlicher Gutschein-Code lautet {$GIFT_CODE}. Sie können diese Gutschrift an der Kasse während des Bestellvorganges verbuchen.\r\n\r\nUm den Gutschein einzulösen klicken Sie bitte auf [Gutschein Einlösen].\r\n{/if}\r\n\r\n{if $SEND_COUPON==true}\r\nAls kleines Willkommensgeschenk senden wir Ihnen einen Kupon.\r\n\r\nKuponbeschreibung: {$COUPON_DESC}\r\n\r\nGeben Sie einfach Ihren persönlichen Code {$COUPON_CODE} während des Bezahlvorganges ein.\r\n{/if}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; font-size: 13px; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-family:arial,helvetica,sans-serif;"><span style="font-size: 13px;">\r\n							<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau{else}geehrte(r) {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							Sie haben soeben Ihr Kundenkonto erfolgreich erstellt. Als registrierter Kunde haben Sie folgende Vorteile in unserem Shop:<br />\r\n							<br />\r\n							<strong>- Kundenwarenkorb:</strong> Jeder Artikel bleibt registriert bis Sie zur Kasse gehen oder die Produkte aus dem Warenkorb entfernen.<br />\r\n							<strong>- Adressbuch:</strong> Wir k&ouml;nnen jetzt die Produkte zu der von Ihnen ausgesuchten Adresse senden. Der perfekte Weg ein Geburtstagsgeschenk zu versenden.<br />\r\n							<strong>- Vorherige Bestellungen:</strong> Sie k&ouml;nnen jederzeit Ihre vorherigen Bestellungen &uuml;berpr&uuml;fen.<br />\r\n							<strong>- Meinungen &uuml;ber Produkte:</strong> Teilen Sie Ihre Meinung zu unseren Produkten mit anderen Kunden.<br />\r\n							<br />\r\n							Falls Sie Fragen zu unserem Kunden-Service haben, wenden Sie sich bitte an {$content.MAIL_REPLY_ADDRESS}.<br />\r\n							Achtung: Diese E-Mail-Adresse wurde uns von einem Kunden bekannt gegeben. Falls Sie sich nicht angemeldet haben, senden Sie bitte eine E-Mail an {$content.MAIL_REPLY_ADDRESS}.<br />\r\n							<br />\r\n							{if $SEND_GIFT==true}<br />\r\n							Als kleines Willkommensgeschenk senden wir Ihnen einen Gutschein &uuml;ber: <strong>{$GIFT_AMMOUNT}</strong><br />\r\n							<br />\r\n							Ihr pers&ouml;nlicher Gutschein-Code lautet <strong>{$GIFT_CODE}</strong>. Sie k&ouml;nnen diese Gutschrift an der Kasse w&auml;hrend des Bestellvorganges verbuchen.<br />\r\n							<br />\r\n							Um den Gutschein einzul&ouml;sen klicken Sie bitte auf <a href="{$GIFT_LINK}">[Gutschein Einl&ouml;sen]</a>.<br /><br />{/if}\r\n							{if $SEND_COUPON==true}Als kleines Willkommensgeschenk senden wir Ihnen einen Kupon.<br />\r\n							Kuponbeschreibung: <strong>{$COUPON_DESC}</strong><br />\r\n							Geben Sie einfach Ihren pers&ouml;nlichen Code {$COUPON_CODE} w&auml;hrend des Bezahlvorganges ein. {/if}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nSie haben soeben Ihr Kundenkonto erfolgreich erstellt. Als registrierter Kunde haben Sie folgende Vorteile in unserem Shop:\r\n\r\n- Kundenwarenkorb: Jeder Artikel bleibt registriert bis Sie zur Kasse gehen oder die Produkte aus dem Warenkorb entfernen.\r\n- Adressbuch: Wir können jetzt die Produkte zu der von Ihnen ausgesuchten Adresse senden. Der perfekte Weg ein Geburtstagsgeschenk zu versenden.\r\n- Vorherige Bestellungen: Sie können jederzeit Ihre vorherigen Bestellungen überprüfen.\r\n- Meinungen über Produkte: Teilen Sie Ihre Meinung zu unseren Produkten mit anderen Kunden.\r\n\r\nFalls Sie Fragen zu unserem Kunden-Service haben, wenden Sie sich bitte an {$content.MAIL_REPLY_ADDRESS}.\r\nAchtung: Diese E-Mail-Adresse wurde uns von einem Kunden bekannt gegeben. Falls Sie sich nicht angemeldet haben, senden Sie bitte eine E-Mail an {$content.MAIL_REPLY_ADDRESS}.\r\n\r\n{if $SEND_GIFT==true}\r\nAls kleines Willkommensgeschenk senden wir Ihnen einen Gutschein über: {$GIFT_AMMOUNT}\r\n\r\nIhr persönlicher Gutschein-Code lautet {$GIFT_CODE}. Sie können diese Gutschrift an der Kasse während des Bestellvorganges verbuchen.\r\n\r\nUm den Gutschein einzulösen klicken Sie bitte auf [Gutschein Einlösen].\r\n{/if}\r\n\r\n{if $SEND_COUPON==true}\r\nAls kleines Willkommensgeschenk senden wir Ihnen einen Kupon.\r\n\r\nKuponbeschreibung: {$COUPON_DESC}\r\n\r\nGeben Sie einfach Ihren persönlichen Code {$COUPON_CODE} während des Bezahlvorganges ein.\r\n{/if}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(3, 1, '', 'new_password_mail', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								<strong>Dear {if	$GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs{/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p style="display: block;"><span style="font-size:13px;">\r\n							<span style="font-family: verdana,geneva,sans-serif;">\r\n								You receive this mail, because you required a new password.<br />\r\n								Please log in with the following password and your email address<br />\r\n								and change your password like you wish.\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Your new Password:</strong><br />\r\n											{$NEW_PASSWORD}\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">We wish you further much fun with our offer!</span></span>\r\n						</p>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								<strong>Dear {if	$GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs{/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p style="display: block;"><span style="font-size:13px;">\r\n							<span style="font-family: verdana,geneva,sans-serif;">\r\n								You receive this mail, because you required a new password.<br />\r\n								Please log in with the following password and your email address<br />\r\n								and change your password like you wish.\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Your new Password:</strong><br />\r\n											{$NEW_PASSWORD}\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">We wish you further much fun with our offer!</span></span>\r\n						</p>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nYou receive this mail, because you required a new password. \r\nPlease log in with the following password and your email address \r\nand change your password like you wish.\r\n\r\nYour new password:      \r\n{$NEW_PASSWORD}\r\n\r\nWe wish you further much fun with our offer!\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nYou receive this mail, because you required a new password. \r\nPlease log in with the following password and your email address \r\nand change your password like you wish.\r\n\r\nYour new password:      \r\n{$NEW_PASSWORD}\r\n\r\nWe wish you further much fun with our offer!\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								<strong>Dear {if	$GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs{/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p style="display: block;"><span style="font-size:13px;">\r\n							<span style="font-family: verdana,geneva,sans-serif;">\r\n								You receive this mail, because you required a new password.<br />\r\n								Please log in with the following password and your email address<br />\r\n								and change your password like you wish.\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Your new Password:</strong><br />\r\n											{$NEW_PASSWORD}\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">We wish you further much fun with our offer!</span></span>\r\n						</p>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nYou receive this mail, because you required a new password. \r\nPlease log in with the following password and your email address \r\nand change your password like you wish.\r\n\r\nYour new password:      \r\n{$NEW_PASSWORD}\r\n\r\nWe wish you further much fun with our offer!\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(3, 2, '', 'new_password_mail', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Sie erhalten diese E-Mail, da Sie ein neues Passwort angefordert haben.<br />\r\n								Bitte loggen Sie sich mit folgendem Passwort und Ihrer E-Mail-Adresse bei uns ein<br />\r\n								und &auml;ndern Ihr Passwort in Ihrem Account, wie Sie es w&uuml;nschen.\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Ihr neues Passwort:</strong><br />\r\n											{$NEW_PASSWORD}\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Wir w&uuml;nschen Ihnen weiterhin viel Spa&szlig; mit unserem Angebot!\r\n							</span></span>\r\n						</p>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Sie erhalten diese E-Mail, da Sie ein neues Passwort angefordert haben.<br />\r\n								Bitte loggen Sie sich mit folgendem Passwort und Ihrer E-Mail-Adresse bei uns ein<br />\r\n								und &auml;ndern Ihr Passwort in Ihrem Account, wie Sie es w&uuml;nschen.\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Ihr neues Passwort:</strong><br />\r\n											{$NEW_PASSWORD}\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Wir w&uuml;nschen Ihnen weiterhin viel Spa&szlig; mit unserem Angebot!\r\n							</span></span>\r\n						</p>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nSie erhalten diese E-Mail, da Sie ein neues Passwort angefordert haben.\r\nBitte loggen Sie sich mit folgendem Passwort und Ihrer E-Mail-Adresse bei uns ein\r\nund ändern Ihr Passwort in Ihrem Account, wie Sie es wünschen.\r\n      \r\nIhr neues Passwort: {$NEW_PASSWORD}\r\n\r\nWir wünschen Ihnen weiterhin viel Spaß mit unserem Angebot!\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nSie erhalten diese E-Mail, da Sie ein neues Passwort angefordert haben.\r\nBitte loggen Sie sich mit folgendem Passwort und Ihrer E-Mail-Adresse bei uns ein\r\nund ändern Ihr Passwort in Ihrem Account, wie Sie es wünschen.\r\n      \r\nIhr neues Passwort: {$NEW_PASSWORD}\r\n\r\nWir wünschen Ihnen weiterhin viel Spaß mit unserem Angebot!\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Sie erhalten diese E-Mail, da Sie ein neues Passwort angefordert haben.<br />\r\n								Bitte loggen Sie sich mit folgendem Passwort und Ihrer E-Mail-Adresse bei uns ein<br />\r\n								und &auml;ndern Ihr Passwort in Ihrem Account, wie Sie es w&uuml;nschen.\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Ihr neues Passwort:</strong><br />\r\n											{$NEW_PASSWORD}\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n\r\n						<p style="display: block;">\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Wir w&uuml;nschen Ihnen weiterhin viel Spa&szlig; mit unserem Angebot!\r\n							</span></span>\r\n						</p>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nSie erhalten diese E-Mail, da Sie ein neues Passwort angefordert haben.\r\nBitte loggen Sie sich mit folgendem Passwort und Ihrer E-Mail-Adresse bei uns ein\r\nund ändern Ihr Passwort in Ihrem Account, wie Sie es wünschen.\r\n      \r\nIhr neues Passwort: {$NEW_PASSWORD}\r\n\r\nWir wünschen Ihnen weiterhin viel Spaß mit unserem Angebot!\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(4, 1, '', 'newsletter_mail', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								<b>Dear {if	$GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</b>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								<b>thank you for your subscription.</b>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								You receive this mail, because you want to receive our newsletter.\r\n								Please you click on the activation link to activate this service. If you should\r\n								not have registered yourselves in newsletter and/or the receipt of the newsletters\r\n								is not wanted, we wish you to do nothing. Your address is then deleted automatically\r\n								with the next actualization of the data base.\r\n							</span></span>\r\n						</p>\r\n\r\n						<br />\r\n						\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n											<b>Your activation-link:</b><br />\r\n											<a href="{$LINK}">{$LINK}</a>\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n						<br />\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								<b>Dear {if	$GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</b>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								<b>thank you for your subscription.</b>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								You receive this mail, because you want to receive our newsletter.\r\n								Please you click on the activation link to activate this service. If you should\r\n								not have registered yourselves in newsletter and/or the receipt of the newsletters\r\n								is not wanted, we wish you to do nothing. Your address is then deleted automatically\r\n								with the next actualization of the data base.\r\n							</span></span>\r\n						</p>\r\n\r\n						<br />\r\n						\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n											<b>Your activation-link:</b><br />\r\n											<a href="{$LINK}">{$LINK}</a>\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n						<br />\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nthank you for your subscription.\r\n\r\nYou receive this mail, because you want to receive our newsletter. \r\nPlease you click on the activation link to activate this service. If you should \r\nnot have registered yourselves in newsletter and/or the receipt of the newsletters \r\nis not wanted, we wish you to do nothing. Your address is then deleted automatically \r\nwith the next actualization of the data base.\r\n      \r\nYour activation-link:\r\n{$LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nthank you for your subscription.\r\n\r\nYou receive this mail, because you want to receive our newsletter. \r\nPlease you click on the activation link to activate this service. If you should \r\nnot have registered yourselves in newsletter and/or the receipt of the newsletters \r\nis not wanted, we wish you to do nothing. Your address is then deleted automatically \r\nwith the next actualization of the data base.\r\n      \r\nYour activation-link:\r\n{$LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								<b>Dear {if	$GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</b>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								<b>thank you for your subscription.</b>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								You receive this mail, because you want to receive our newsletter.\r\n								Please you click on the activation link to activate this service. If you should\r\n								not have registered yourselves in newsletter and/or the receipt of the newsletters\r\n								is not wanted, we wish you to do nothing. Your address is then deleted automatically\r\n								with the next actualization of the data base.\r\n							</span></span>\r\n						</p>\r\n\r\n						<br />\r\n						\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n											<b>Your activation-link:</b><br />\r\n											<a href="{$LINK}">{$LINK}</a>\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n						<br />\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nthank you for your subscription.\r\n\r\nYou receive this mail, because you want to receive our newsletter. \r\nPlease you click on the activation link to activate this service. If you should \r\nnot have registered yourselves in newsletter and/or the receipt of the newsletters \r\nis not wanted, we wish you to do nothing. Your address is then deleted automatically \r\nwith the next actualization of the data base.\r\n      \r\nYour activation-link:\r\n{$LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(4, 2, '', 'newsletter_mail', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								<strong>vielen Dank f&uuml;r die Anmeldung.</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								Sie erhalten diese E-Mail, weil Sie unseren Newsletter empfangen m&ouml;chten. Bitte klicken Sie auf den Aktivierungslink, \r\n								damit Ihre E-Mail-Adresse f&uuml;r den Newsletterempfang freigeschaltet wird. \r\n								Sollten Sie sich nicht in unseren Newsletter eingetragen haben bzw. den Empfang des Newsletters nicht w&uuml;nschen, \r\n								bitten wir Sie gar nichts zu tun. Ihre E-Mail-Adresse wird dann bei der n&auml;chsten Aktualisierung der Datenbank automatisch gel&ouml;scht.\r\n							</span></span>\r\n						</p>\r\n\r\n						<br />\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n											<strong>Ihr Aktivierungslink:</strong><br />\r\n											<a href="{$LINK}">{$LINK}</a>\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n						<br />\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								<strong>vielen Dank f&uuml;r die Anmeldung.</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								Sie erhalten diese E-Mail, weil Sie unseren Newsletter empfangen m&ouml;chten. Bitte klicken Sie auf den Aktivierungslink, \r\n								damit Ihre E-Mail-Adresse f&uuml;r den Newsletterempfang freigeschaltet wird. \r\n								Sollten Sie sich nicht in unseren Newsletter eingetragen haben bzw. den Empfang des Newsletters nicht w&uuml;nschen, \r\n								bitten wir Sie gar nichts zu tun. Ihre E-Mail-Adresse wird dann bei der n&auml;chsten Aktualisierung der Datenbank automatisch gel&ouml;scht.\r\n							</span></span>\r\n						</p>\r\n\r\n						<br />\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n											<strong>Ihr Aktivierungslink:</strong><br />\r\n											<a href="{$LINK}">{$LINK}</a>\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n						<br />\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nvielen Dank für die Anmeldung.\r\n\r\nSie erhalten diese E-Mail, weil Sie unseren Newsletter empfangen möchten. Bitte klicken Sie auf den Aktivierungslink, damit Ihre E-Mail-Adresse für den Newsletterempfang freigeschaltet wird. Sollten Sie sich nicht in unseren Newsletter eingetragen haben bzw. den Empfang des Newsletters nicht wünschen, bitten wir Sie gar nichts zu tun. Ihre E-Mail-Adresse wird dann bei der nächsten Aktualisierung der Datenbank automatisch gelöscht.\r\n\r\nIhr Aktivierungslink:\r\n{$LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nvielen Dank für die Anmeldung.\r\n\r\nSie erhalten diese E-Mail, weil Sie unseren Newsletter empfangen möchten. Bitte klicken Sie auf den Aktivierungslink, damit Ihre E-Mail-Adresse für den Newsletterempfang freigeschaltet wird. Sollten Sie sich nicht in unseren Newsletter eingetragen haben bzw. den Empfang des Newsletters nicht wünschen, bitten wir Sie gar nichts zu tun. Ihre E-Mail-Adresse wird dann bei der nächsten Aktualisierung der Datenbank automatisch gelöscht.\r\n\r\nIhr Aktivierungslink:\r\n{$LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								<strong>vielen Dank f&uuml;r die Anmeldung.</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n								Sie erhalten diese E-Mail, weil Sie unseren Newsletter empfangen m&ouml;chten. Bitte klicken Sie auf den Aktivierungslink, \r\n								damit Ihre E-Mail-Adresse f&uuml;r den Newsletterempfang freigeschaltet wird. \r\n								Sollten Sie sich nicht in unseren Newsletter eingetragen haben bzw. den Empfang des Newsletters nicht w&uuml;nschen, \r\n								bitten wir Sie gar nichts zu tun. Ihre E-Mail-Adresse wird dann bei der n&auml;chsten Aktualisierung der Datenbank automatisch gel&ouml;scht.\r\n							</span></span>\r\n						</p>\r\n\r\n						<br />\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-family:verdana,geneva,sans-serif;"><span style="font-size: 13px;">\r\n											<strong>Ihr Aktivierungslink:</strong><br />\r\n											<a href="{$LINK}">{$LINK}</a>\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n						<br />\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nvielen Dank für die Anmeldung.\r\n\r\nSie erhalten diese E-Mail, weil Sie unseren Newsletter empfangen möchten. Bitte klicken Sie auf den Aktivierungslink, damit Ihre E-Mail-Adresse für den Newsletterempfang freigeschaltet wird. Sollten Sie sich nicht in unseren Newsletter eingetragen haben bzw. den Empfang des Newsletters nicht wünschen, bitten wir Sie gar nichts zu tun. Ihre E-Mail-Adresse wird dann bei der nächsten Aktualisierung der Datenbank automatisch gelöscht.\r\n\r\nIhr Aktivierungslink:\r\n{$LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(5, 1, '', 'order_mail', '<meta charset="UTF-8" />\r\n<div style="height: auto; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table style="width: 100%; display: block;overflow: hidden;">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{php}echo nl2br(STORE_NAME_ADDRESS){/php}</span></span>\r\n					</td>\r\n					<td>\r\n						{if $gm_logo_mail}{$gm_logo_mail}{/if}\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n\r\n		<h1>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</span></span>\r\n		</h1>\r\n\r\n		<p>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">thank you for your order in our onlineshop!</span></span>\r\n		</p>\r\n\r\n		<p>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				{if $PAYMENT_MODUL==''moneyorder''} Our bank details:<br />\r\n					{php} echo nl2br(MODULE_PAYMENT_MONEYORDER_PAYTO); {/php} \r\n				{else} \r\n					{$PAYMENT_INFO_HTML} \r\n				{/if}\r\n			</span></span>\r\n		</p>\r\n\r\n		<br />\r\n		\r\n		<h3 style="border-bottom: 1px solid #ddd; padding: 5px 0px">\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Your order: </span></span>\r\n		</h3>\r\n		\r\n		<div style="height: auto; overflow: hidden;">\r\n			<p style="float: left; width: 33%;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					<strong>Payment	address</strong><br />\r\n					{$address_label_payment}\r\n				</span></span>\r\n			</p>\r\n\r\n			<p style="float: left; width: 33%;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					<strong>Shipping address</strong><br />\r\n					{$address_label_shipping}\r\n				</span></span>\r\n			</p>\r\n\r\n			<p style="float: left; width: 33%; text-align: right;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					{if $PAYMENT_METHOD}<strong>Paymentmethod:</strong> {$PAYMENT_METHOD}<br />{/if} \r\n					<strong>Order No.:</strong> {$oID}<br />\r\n					<strong>Order date:</strong> {$DATE}<br />\r\n					<br />\r\n					{if $csID}<strong>Customer ID:</strong> {$csID}<br />{/if} \r\n					{if $PHONE}<strong>Telephone number:</strong> {$PHONE}<br />{/if} \r\n					{if $customer_vat}<strong>Vat No.:</strong> {$customer_vat}<br />{/if}\r\n				</span></span>\r\n			</p>\r\n		</div>\r\n\r\n		<table cellspacing="0" style="width: 100%; font-size: 12px; margin-top: 25px; padding: 0;">\r\n			<tbody>\r\n				<tr>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">pcs.</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Article</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Article-No.</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 4px 3px 3px; font-size: 13px; text-align: right;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Single price</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 4px 3px 3px; font-size: 13px; text-align: right;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Total price</span></span>\r\n					</th>\r\n				</tr>\r\n\r\n				<!--{foreach name=aussen item=order_values from=$order_data}-->\r\n				<tr>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_QTY}{if $order_values.UNIT}{$order_values.UNIT}{else}x{/if}</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>{$order_values.PRODUCTS_NAME}</strong><br />\r\n						{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES} \r\n							{$prop_item_array.properties_name}: {$prop_item_array.values_name}<br />\r\n						{/foreach}\r\n\r\n						{if $order_values.PRODUCTS_ATTRIBUTES}\r\n							{$order_values.PRODUCTS_ATTRIBUTES}<br />\r\n						{/if}\r\n\r\n						{if $order_values.CHECKOUT_INFORMATION}\r\n							{$order_values.CHECKOUT_INFORMATION}<br />\r\n						{else}\r\n							<br />\r\n						{/if}\r\n						{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}\r\n							Shipping time: {$order_values.PRODUCTS_SHIPPING_TIME}\r\n						{/if}\r\n						</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							{$order_values.PRODUCTS_MODEL}<br />\r\n							<em>{$order_values.PRODUCTS_ATTRIBUTES_MODEL}</em>\r\n						</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; text-align: right; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_SINGLE_PRICE}</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; text-align: right; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_PRICE}</span></span>\r\n					</td>\r\n				</tr>\r\n				<!--{/foreach}-->\r\n			\r\n			</tbody>\r\n		</table>\r\n\r\n		<div style="float: right; text-align: right">\r\n			{foreach name=aussen item=order_total_values from=$order_total}\r\n				<span style="font-size:13px"><span style="font-family: verdana,geneva,sans-serif;">{$order_total_values.TITLE}{$order_total_values.TEXT}</span></span><br />\r\n			{/foreach}\r\n		</div>\r\n		\r\n		<br style="clear: right;" />\r\n		\r\n		{if $COMMENTS}\r\n		<p style="display: block;">\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>Your comments:</strong><br />\r\n				{$COMMENTS}\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n\r\n		{$TS_RATING}\r\n\r\n		{if $SHOW_ABANDONMENT_WITHDRAWAL_DOWNLOADS_INFO}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>You	chose:</strong><br />\r\n				I expressly agree that you commence with the execution of the contract prior to the expiration of the \r\n				cancellation period. It is known to me that, with this approval, I lose any cancellation right with the \r\n				start of the execution of the contract. \r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		{if $SHOW_ABANDONMENT_WITHDRAWAL_SERVICES_INFO}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>You chose:</strong><br />\r\n				I agree and demand expressly that you commence with the execution of the assigned service prior to the expiration of \r\n				the cancellation period. It is known to me that I lose any cancellation right with the complete fulfillment \r\n				of the contract by your company.\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		{if $WITHDRAWAL_LINK || $PDF_LINK}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>&sect; Model Withdrawal Form</strong><br />\r\n				{if $PDF_LINK} Our model withdrawal form as PDF document: <a href="{$PDF_LINK}">DOWNLOAD</a><br />{/if}\r\n				{if $WITHDRAWAL_LINK} Our online model withdrawal form: <a href="{$WITHDRAWAL_LINK}">ONLINE-FORM</a>{/if}\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				To open the downloadable PDF-files, you need an additional program such as the Adobe Reader, \r\n				which you can download online for free. The current version of the Adobe Reader you can find \r\n				<a href="http://get.adobe.com/uk/reader/" target="_blank">here</a>.<br />\r\n			</span></span>\r\n		</p>\r\n		<br />\r\n		{if $JANOLAW_INFO_HTML}\r\n		<div style="font-size:10px;font-family: verdana,geneva,sans-serif;">\r\n			{$JANOLAW_INFO_HTML}<br />\r\n		</div>\r\n		{/if}\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: auto; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table style="width: 100%; display: block;overflow: hidden;">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{php}echo nl2br(STORE_NAME_ADDRESS){/php}</span></span>\r\n					</td>\r\n					<td>\r\n						{if $gm_logo_mail}{$gm_logo_mail}{/if}\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n\r\n		<h1>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</span></span>\r\n		</h1>\r\n\r\n		<p>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">thank you for your order in our onlineshop!</span></span>\r\n		</p>\r\n\r\n		<p>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				{if $PAYMENT_MODUL==''moneyorder''} Our bank details:<br />\r\n					{php} echo nl2br(MODULE_PAYMENT_MONEYORDER_PAYTO); {/php} \r\n				{else} \r\n					{$PAYMENT_INFO_HTML} \r\n				{/if}\r\n			</span></span>\r\n		</p>\r\n\r\n		<br />\r\n		\r\n		<h3 style="border-bottom: 1px solid #ddd; padding: 5px 0px">\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Your order: </span></span>\r\n		</h3>\r\n		\r\n		<div style="height: auto; overflow: hidden;">\r\n			<p style="float: left; width: 33%;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					<strong>Payment	address</strong><br />\r\n					{$address_label_payment}\r\n				</span></span>\r\n			</p>\r\n\r\n			<p style="float: left; width: 33%;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					<strong>Shipping address</strong><br />\r\n					{$address_label_shipping}\r\n				</span></span>\r\n			</p>\r\n\r\n			<p style="float: left; width: 33%; text-align: right;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					{if $PAYMENT_METHOD}<strong>Paymentmethod:</strong> {$PAYMENT_METHOD}<br />{/if} \r\n					<strong>Order No.:</strong> {$oID}<br />\r\n					<strong>Order date:</strong> {$DATE}<br />\r\n					<br />\r\n					{if $csID}<strong>Customer ID:</strong> {$csID}<br />{/if} \r\n					{if $PHONE}<strong>Telephone number:</strong> {$PHONE}<br />{/if} \r\n					{if $customer_vat}<strong>Vat No.:</strong> {$customer_vat}<br />{/if}\r\n				</span></span>\r\n			</p>\r\n		</div>\r\n\r\n		<table cellspacing="0" style="width: 100%; font-size: 12px; margin-top: 25px; padding: 0;">\r\n			<tbody>\r\n				<tr>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">pcs.</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Article</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Article-No.</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 4px 3px 3px; font-size: 13px; text-align: right;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Single price</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 4px 3px 3px; font-size: 13px; text-align: right;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Total price</span></span>\r\n					</th>\r\n				</tr>\r\n\r\n				<!--{foreach name=aussen item=order_values from=$order_data}-->\r\n				<tr>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_QTY}{if $order_values.UNIT}{$order_values.UNIT}{else}x{/if}</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>{$order_values.PRODUCTS_NAME}</strong><br />\r\n						{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES} \r\n							{$prop_item_array.properties_name}: {$prop_item_array.values_name}<br />\r\n						{/foreach}\r\n\r\n						{if $order_values.PRODUCTS_ATTRIBUTES}\r\n							{$order_values.PRODUCTS_ATTRIBUTES}<br />\r\n						{/if}\r\n\r\n						{if $order_values.CHECKOUT_INFORMATION}\r\n							{$order_values.CHECKOUT_INFORMATION}<br />\r\n						{else}\r\n							<br />\r\n						{/if}\r\n						{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}\r\n							Shipping time: {$order_values.PRODUCTS_SHIPPING_TIME}\r\n						{/if}\r\n						</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							{$order_values.PRODUCTS_MODEL}<br />\r\n							<em>{$order_values.PRODUCTS_ATTRIBUTES_MODEL}</em>\r\n						</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; text-align: right; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_SINGLE_PRICE}</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; text-align: right; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_PRICE}</span></span>\r\n					</td>\r\n				</tr>\r\n				<!--{/foreach}-->\r\n			\r\n			</tbody>\r\n		</table>\r\n\r\n		<div style="float: right; text-align: right">\r\n			{foreach name=aussen item=order_total_values from=$order_total}\r\n				<span style="font-size:13px"><span style="font-family: verdana,geneva,sans-serif;">{$order_total_values.TITLE}{$order_total_values.TEXT}</span></span><br />\r\n			{/foreach}\r\n		</div>\r\n		\r\n		<br style="clear: right;" />\r\n		\r\n		{if $COMMENTS}\r\n		<p style="display: block;">\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>Your comments:</strong><br />\r\n				{$COMMENTS}\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n\r\n		{$TS_RATING}\r\n\r\n		{if $SHOW_ABANDONMENT_WITHDRAWAL_DOWNLOADS_INFO}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>You	chose:</strong><br />\r\n				I expressly agree that you commence with the execution of the contract prior to the expiration of the \r\n				cancellation period. It is known to me that, with this approval, I lose any cancellation right with the \r\n				start of the execution of the contract. \r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		{if $SHOW_ABANDONMENT_WITHDRAWAL_SERVICES_INFO}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>You chose:</strong><br />\r\n				I agree and demand expressly that you commence with the execution of the assigned service prior to the expiration of \r\n				the cancellation period. It is known to me that I lose any cancellation right with the complete fulfillment \r\n				of the contract by your company.\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		{if $WITHDRAWAL_LINK || $PDF_LINK}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>&sect; Model Withdrawal Form</strong><br />\r\n				{if $PDF_LINK} Our model withdrawal form as PDF document: <a href="{$PDF_LINK}">DOWNLOAD</a><br />{/if}\r\n				{if $WITHDRAWAL_LINK} Our online model withdrawal form: <a href="{$WITHDRAWAL_LINK}">ONLINE-FORM</a>{/if}\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				To open the downloadable PDF-files, you need an additional program such as the Adobe Reader, \r\n				which you can download online for free. The current version of the Adobe Reader you can find \r\n				<a href="http://get.adobe.com/uk/reader/" target="_blank">here</a>.<br />\r\n			</span></span>\r\n		</p>\r\n		<br />\r\n		{if $JANOLAW_INFO_HTML}\r\n		<div style="font-size:10px;font-family: verdana,geneva,sans-serif;">\r\n			{$JANOLAW_INFO_HTML}<br />\r\n		</div>\r\n		{/if}\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{$address_label_customer}\r\n\r\n{if $PHONE}Telephone number: {$PHONE}\r\n{/if}\r\n{if $customer_vat}Vat No.: {$customer_vat}{/if}\r\n\r\n\r\n{if $PAYMENT_METHOD}Payment method: {$PAYMENT_METHOD}\r\n{/if}\r\nOrder No.: {$oID}\r\nDate: {$DATE}\r\n{if $csID}Customer ID:{$csID}{/if}\r\n\r\n----------------------------------------------------------------------\r\n\r\n\r\nDear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nthank you for your order in our onlineshop.\r\n\r\n{if $PAYMENT_MODUL==''moneyorder''}\r\nOur bank details:\r\n{php} echo MODULE_PAYMENT_MONEYORDER_PAYTO; {/php}\r\n{else}\r\n{$PAYMENT_INFO_TXT}\r\n{/if}\r\n\r\n{if $COMMENTS}\r\nYour Comments:\r\n{$COMMENTS}\r\n{/if}\r\n\r\nYou ordered the following products:\r\n----------------------------------------------------------------------\r\n{foreach name=aussen item=order_values from=$order_data} \r\n{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if} {$order_values.PRODUCTS_NAME} {$order_values.PRODUCTS_PRICE}\r\n{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES}\r\n {$prop_item_array.properties_name}: {$prop_item_array.values_name}\r\n{/foreach}\r\n{if $order_values.PRODUCTS_ATTRIBUTES !=''''}{$order_values.PRODUCTS_ATTRIBUTES}{/if}\r\n\r\n{$order_values.CHECKOUT_INFORMATION_TEXT}\r\n{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}\r\nShipping time: {$order_values.PRODUCTS_SHIPPING_TIME}\r\n{/if}\r\n\r\n{/foreach}\r\n\r\n{foreach name=aussen item=order_total_values from=$order_total}\r\n{$order_total_values.TITLE}{$order_total_values.TEXT}\r\n{/foreach}\r\n\r\n\r\n{if $address_label_payment}\r\nPayment address\r\n----------------------------------------------------------------------\r\n{$address_label_payment}\r\n{/if}\r\n\r\n\r\nShipping address \r\n----------------------------------------------------------------------\r\n{$address_label_shipping}\r\n\r\n\r\n{$TS_RATING}\r\n\r\n{if $SHOW_ABANDONMENT_WITHDRAWAL_DOWNLOADS_INFO}\r\nYou chose:\r\nI expressly agree that you commence with the execution of the contract prior to the expiration of the cancellation period. It is known to me that, with this approval, I lose any cancellation right with the start of the execution of the contract.\r\n\r\n{/if}\r\n{if $SHOW_ABANDONMENT_WITHDRAWAL_SERVICES_INFO}\r\nYou chose:\r\nI agree and demand expressly that you commence with the execution of the assigned service prior to the expiration of the cancellation period. It is known to me that I lose any cancellation right with the complete fulfillment of the contract by your company.\r\n\r\n{/if}\r\n{if $WITHDRAWAL_LINK || $PDF_LINK}\r\n§ Model Withdrawal Form\r\n{if $PDF_LINK}Our model withdrawal form as PDF document: {$PDF_LINK} {/if}\r\n{if $WITHDRAWAL_LINK}\r\nOur online model withdrawal form: {$WITHDRAWAL_LINK}{/if}\r\n{/if}\r\n\r\n\r\nTo open the downloadable PDF-files, you need an additional program such as the Adobe Reader, which you can download online for free. The current version of the Adobe Reader you can find here: http://get.adobe.com/uk/reader/\r\n\r\n{if $JANOLAW_INFO_TEXT}{$JANOLAW_INFO_TEXT}{/if}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '{$address_label_customer}\r\n\r\n{if $PHONE}Telephone number: {$PHONE}\r\n{/if}\r\n{if $customer_vat}Vat No.: {$customer_vat}{/if}\r\n\r\n\r\n{if $PAYMENT_METHOD}Payment method: {$PAYMENT_METHOD}\r\n{/if}\r\nOrder No.: {$oID}\r\nDate: {$DATE}\r\n{if $csID}Customer ID:{$csID}{/if}\r\n\r\n----------------------------------------------------------------------\r\n\r\n\r\nDear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nthank you for your order in our onlineshop.\r\n\r\n{if $PAYMENT_MODUL==''moneyorder''}\r\nOur bank details:\r\n{php} echo MODULE_PAYMENT_MONEYORDER_PAYTO; {/php}\r\n{else}\r\n{$PAYMENT_INFO_TXT}\r\n{/if}\r\n\r\n{if $COMMENTS}\r\nYour Comments:\r\n{$COMMENTS}\r\n{/if}\r\n\r\nYou ordered the following products:\r\n----------------------------------------------------------------------\r\n{foreach name=aussen item=order_values from=$order_data} \r\n{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if} {$order_values.PRODUCTS_NAME} {$order_values.PRODUCTS_PRICE}\r\n{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES}\r\n {$prop_item_array.properties_name}: {$prop_item_array.values_name}\r\n{/foreach}\r\n{if $order_values.PRODUCTS_ATTRIBUTES !=''''}{$order_values.PRODUCTS_ATTRIBUTES}{/if}\r\n\r\n{$order_values.CHECKOUT_INFORMATION_TEXT}\r\n{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}\r\nShipping time: {$order_values.PRODUCTS_SHIPPING_TIME}\r\n{/if}\r\n\r\n{/foreach}\r\n\r\n{foreach name=aussen item=order_total_values from=$order_total}\r\n{$order_total_values.TITLE}{$order_total_values.TEXT}\r\n{/foreach}\r\n\r\n\r\n{if $address_label_payment}\r\nPayment address\r\n----------------------------------------------------------------------\r\n{$address_label_payment}\r\n{/if}\r\n\r\n\r\nShipping address \r\n----------------------------------------------------------------------\r\n{$address_label_shipping}\r\n\r\n\r\n{$TS_RATING}\r\n\r\n{if $SHOW_ABANDONMENT_WITHDRAWAL_DOWNLOADS_INFO}\r\nYou chose:\r\nI expressly agree that you commence with the execution of the contract prior to the expiration of the cancellation period. It is known to me that, with this approval, I lose any cancellation right with the start of the execution of the contract.\r\n\r\n{/if}\r\n{if $SHOW_ABANDONMENT_WITHDRAWAL_SERVICES_INFO}\r\nYou chose:\r\nI agree and demand expressly that you commence with the execution of the assigned service prior to the expiration of the cancellation period. It is known to me that I lose any cancellation right with the complete fulfillment of the contract by your company.\r\n\r\n{/if}\r\n{if $WITHDRAWAL_LINK || $PDF_LINK}\r\n§ Model Withdrawal Form\r\n{if $PDF_LINK}Our model withdrawal form as PDF document: {$PDF_LINK} {/if}\r\n{if $WITHDRAWAL_LINK}\r\nOur online model withdrawal form: {$WITHDRAWAL_LINK}{/if}\r\n{/if}\r\n\r\n\r\nTo open the downloadable PDF-files, you need an additional program such as the Adobe Reader, which you can download online for free. The current version of the Adobe Reader you can find here: http://get.adobe.com/uk/reader/\r\n\r\n{if $JANOLAW_INFO_TEXT}{$JANOLAW_INFO_TEXT}{/if}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="height: auto; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table style="width: 100%; display: block;overflow: hidden;">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{php}echo nl2br(STORE_NAME_ADDRESS){/php}</span></span>\r\n					</td>\r\n					<td>\r\n						{if $gm_logo_mail}{$gm_logo_mail}{/if}\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n\r\n		<h1>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</span></span>\r\n		</h1>\r\n\r\n		<p>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">thank you for your order in our onlineshop!</span></span>\r\n		</p>\r\n\r\n		<p>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				{if $PAYMENT_MODUL==''moneyorder''} Our bank details:<br />\r\n					{php} echo nl2br(MODULE_PAYMENT_MONEYORDER_PAYTO); {/php} \r\n				{else} \r\n					{$PAYMENT_INFO_HTML} \r\n				{/if}\r\n			</span></span>\r\n		</p>\r\n\r\n		<br />\r\n		\r\n		<h3 style="border-bottom: 1px solid #ddd; padding: 5px 0px">\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Your order: </span></span>\r\n		</h3>\r\n		\r\n		<div style="height: auto; overflow: hidden;">\r\n			<p style="float: left; width: 33%;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					<strong>Payment	address</strong><br />\r\n					{$address_label_payment}\r\n				</span></span>\r\n			</p>\r\n\r\n			<p style="float: left; width: 33%;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					<strong>Shipping address</strong><br />\r\n					{$address_label_shipping}\r\n				</span></span>\r\n			</p>\r\n\r\n			<p style="float: left; width: 33%; text-align: right;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					{if $PAYMENT_METHOD}<strong>Paymentmethod:</strong> {$PAYMENT_METHOD}<br />{/if} \r\n					<strong>Order No.:</strong> {$oID}<br />\r\n					<strong>Order date:</strong> {$DATE}<br />\r\n					<br />\r\n					{if $csID}<strong>Customer ID:</strong> {$csID}<br />{/if} \r\n					{if $PHONE}<strong>Telephone number:</strong> {$PHONE}<br />{/if} \r\n					{if $customer_vat}<strong>Vat No.:</strong> {$customer_vat}<br />{/if}\r\n				</span></span>\r\n			</p>\r\n		</div>\r\n\r\n		<table cellspacing="0" style="width: 100%; font-size: 12px; margin-top: 25px; padding: 0;">\r\n			<tbody>\r\n				<tr>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">pcs.</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Article</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Article-No.</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 4px 3px 3px; font-size: 13px; text-align: right;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Single price</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 4px 3px 3px; font-size: 13px; text-align: right;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Total price</span></span>\r\n					</th>\r\n				</tr>\r\n\r\n				<!--{foreach name=aussen item=order_values from=$order_data}-->\r\n				<tr>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_QTY}{if $order_values.UNIT}{$order_values.UNIT}{else}x{/if}</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>{$order_values.PRODUCTS_NAME}</strong><br />\r\n						{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES} \r\n							{$prop_item_array.properties_name}: {$prop_item_array.values_name}<br />\r\n						{/foreach}\r\n\r\n						{if $order_values.PRODUCTS_ATTRIBUTES}\r\n							{$order_values.PRODUCTS_ATTRIBUTES}<br />\r\n						{/if}\r\n\r\n						{if $order_values.CHECKOUT_INFORMATION}\r\n							{$order_values.CHECKOUT_INFORMATION}<br />\r\n						{else}\r\n							<br />\r\n						{/if}\r\n						{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}\r\n							Shipping time: {$order_values.PRODUCTS_SHIPPING_TIME}\r\n						{/if}\r\n						</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							{$order_values.PRODUCTS_MODEL}<br />\r\n							<em>{$order_values.PRODUCTS_ATTRIBUTES_MODEL}</em>\r\n						</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; text-align: right; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_SINGLE_PRICE}</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; text-align: right; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_PRICE}</span></span>\r\n					</td>\r\n				</tr>\r\n				<!--{/foreach}-->\r\n			\r\n			</tbody>\r\n		</table>\r\n\r\n		<div style="float: right; text-align: right">\r\n			{foreach name=aussen item=order_total_values from=$order_total}\r\n				<span style="font-size:13px"><span style="font-family: verdana,geneva,sans-serif;">{$order_total_values.TITLE}{$order_total_values.TEXT}</span></span><br />\r\n			{/foreach}\r\n		</div>\r\n		\r\n		<br style="clear: right;" />\r\n		\r\n		{if $COMMENTS}\r\n		<p style="display: block;">\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>Your comments:</strong><br />\r\n				{$COMMENTS}\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n\r\n		{$TS_RATING}\r\n\r\n		{if $SHOW_ABANDONMENT_WITHDRAWAL_DOWNLOADS_INFO}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>You	chose:</strong><br />\r\n				I expressly agree that you commence with the execution of the contract prior to the expiration of the \r\n				cancellation period. It is known to me that, with this approval, I lose any cancellation right with the \r\n				start of the execution of the contract. \r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		{if $SHOW_ABANDONMENT_WITHDRAWAL_SERVICES_INFO}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>You chose:</strong><br />\r\n				I agree and demand expressly that you commence with the execution of the assigned service prior to the expiration of \r\n				the cancellation period. It is known to me that I lose any cancellation right with the complete fulfillment \r\n				of the contract by your company.\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		{if $WITHDRAWAL_LINK || $PDF_LINK}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>&sect; Model Withdrawal Form</strong><br />\r\n				{if $PDF_LINK} Our model withdrawal form as PDF document: <a href="{$PDF_LINK}">DOWNLOAD</a><br />{/if}\r\n				{if $WITHDRAWAL_LINK} Our online model withdrawal form: <a href="{$WITHDRAWAL_LINK}">ONLINE-FORM</a>{/if}\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				To open the downloadable PDF-files, you need an additional program such as the Adobe Reader, \r\n				which you can download online for free. The current version of the Adobe Reader you can find \r\n				<a href="http://get.adobe.com/uk/reader/" target="_blank">here</a>.<br />\r\n			</span></span>\r\n		</p>\r\n		<br />\r\n		{if $JANOLAW_INFO_HTML}\r\n		<div style="font-size:10px;font-family: verdana,geneva,sans-serif;">\r\n			{$JANOLAW_INFO_HTML}<br />\r\n		</div>\r\n		{/if}\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{$address_label_customer}\r\n\r\n{if $PHONE}Telephone number: {$PHONE}\r\n{/if}\r\n{if $customer_vat}Vat No.: {$customer_vat}{/if}\r\n\r\n\r\n{if $PAYMENT_METHOD}Payment method: {$PAYMENT_METHOD}\r\n{/if}\r\nOrder No.: {$oID}\r\nDate: {$DATE}\r\n{if $csID}Customer ID:{$csID}{/if}\r\n\r\n----------------------------------------------------------------------\r\n\r\n\r\nDear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nthank you for your order in our onlineshop.\r\n\r\n{if $PAYMENT_MODUL==''moneyorder''}\r\nOur bank details:\r\n{php} echo MODULE_PAYMENT_MONEYORDER_PAYTO; {/php}\r\n{else}\r\n{$PAYMENT_INFO_TXT}\r\n{/if}\r\n\r\n{if $COMMENTS}\r\nYour Comments:\r\n{$COMMENTS}\r\n{/if}\r\n\r\nYou ordered the following products:\r\n----------------------------------------------------------------------\r\n{foreach name=aussen item=order_values from=$order_data} \r\n{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if} {$order_values.PRODUCTS_NAME} {$order_values.PRODUCTS_PRICE}\r\n{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES}\r\n {$prop_item_array.properties_name}: {$prop_item_array.values_name}\r\n{/foreach}\r\n{if $order_values.PRODUCTS_ATTRIBUTES !=''''}{$order_values.PRODUCTS_ATTRIBUTES}{/if}\r\n\r\n{$order_values.CHECKOUT_INFORMATION_TEXT}\r\n{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}\r\nShipping time: {$order_values.PRODUCTS_SHIPPING_TIME}\r\n{/if}\r\n\r\n{/foreach}\r\n\r\n{foreach name=aussen item=order_total_values from=$order_total}\r\n{$order_total_values.TITLE}{$order_total_values.TEXT}\r\n{/foreach}\r\n\r\n\r\n{if $address_label_payment}\r\nPayment address\r\n----------------------------------------------------------------------\r\n{$address_label_payment}\r\n{/if}\r\n\r\n\r\nShipping address \r\n----------------------------------------------------------------------\r\n{$address_label_shipping}\r\n\r\n\r\n{$TS_RATING}\r\n\r\n{if $SHOW_ABANDONMENT_WITHDRAWAL_DOWNLOADS_INFO}\r\nYou chose:\r\nI expressly agree that you commence with the execution of the contract prior to the expiration of the cancellation period. It is known to me that, with this approval, I lose any cancellation right with the start of the execution of the contract.\r\n\r\n{/if}\r\n{if $SHOW_ABANDONMENT_WITHDRAWAL_SERVICES_INFO}\r\nYou chose:\r\nI agree and demand expressly that you commence with the execution of the assigned service prior to the expiration of the cancellation period. It is known to me that I lose any cancellation right with the complete fulfillment of the contract by your company.\r\n\r\n{/if}\r\n{if $WITHDRAWAL_LINK || $PDF_LINK}\r\n§ Model Withdrawal Form\r\n{if $PDF_LINK}Our model withdrawal form as PDF document: {$PDF_LINK} {/if}\r\n{if $WITHDRAWAL_LINK}\r\nOur online model withdrawal form: {$WITHDRAWAL_LINK}{/if}\r\n{/if}\r\n\r\n\r\nTo open the downloadable PDF-files, you need an additional program such as the Adobe Reader, which you can download online for free. The current version of the Adobe Reader you can find here: http://get.adobe.com/uk/reader/\r\n\r\n{if $JANOLAW_INFO_TEXT}{$JANOLAW_INFO_TEXT}{/if}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(5, 2, '', 'order_mail', '<meta charset="UTF-8" />\r\n<div style="height: auto; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table style="width: 100%; overflow: hidden;">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{php}echo nl2br(STORE_NAME_ADDRESS){/php}</span></span>\r\n					</td>\r\n					<td style="text-align: right;">\r\n						{$gm_logo_mail}\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n\r\n		<h1>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</span></span>\r\n		</h1>\r\n\r\n		<p>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">vielen Dank f&uuml;r Ihre Bestellung in unserem Online-Shop!</span></span>\r\n		</p>\r\n\r\n		<p>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				{if $PAYMENT_MODUL==''moneyorder''} Unsere Bankverbindung:<br />\r\n					{php} echo nl2br(MODULE_PAYMENT_MONEYORDER_PAYTO); {/php} \r\n				{else} \r\n					{$PAYMENT_INFO_HTML} \r\n				{/if}\r\n			</span></span>\r\n		</p>\r\n\r\n		<br />\r\n		\r\n		<h3 style="border-bottom: 1px solid #ddd; padding: 5px 0px">\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Ihre Bestellung: </span></span>\r\n		</h3>\r\n		\r\n		<div style="height: auto; overflow: hidden;">\r\n			<p style="float: left; width: 33%;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					<strong>Rechnungsadresse</strong><br />\r\n					{$address_label_payment}\r\n				</span></span>\r\n			</p>\r\n\r\n			<p style="float: left; width: 33%;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					<strong>Lieferadresse</strong><br />\r\n					{$address_label_shipping}\r\n				</span></span>\r\n			</p>\r\n\r\n			<p style="float: left; width: 33%; text-align: right;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					{if $PAYMENT_METHOD}<strong>Zahlungsmethode:</strong> {$PAYMENT_METHOD}<br />{/if} \r\n					<strong>Bestellnummer:</strong> {$oID}<br />\r\n					<strong>Bestelldatum:</strong> {$DATE}<br />\r\n					<br />\r\n					{if $csID}<strong>Kundennummer:</strong> {$csID}<br />{/if} \r\n					{if $PHONE}<strong>Telefonnummer:</strong> {$PHONE}<br />{/if} \r\n					{if $customer_vat}<strong>USt-IdNr.:</strong> {$customer_vat}<br />{/if}\r\n				</span></span>\r\n			</p>\r\n		</div>\r\n\r\n		<table cellspacing="0" style="width: 100%; font-size: 12px; margin-top: 25px; padding: 0;">\r\n			<tbody>\r\n				<tr>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Anzahl</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Artikel</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Artikel-Nr.</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 4px 3px 3px; font-size: 13px; text-align: right;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Einzelpreis</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 4px 3px 3px; font-size: 13px; text-align: right;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Gesamtpreis</span></span>\r\n					</th>\r\n				</tr>\r\n\r\n				<!--{foreach name=aussen item=order_values from=$order_data}-->\r\n				<tr>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_QTY}{if $order_values.UNIT}{$order_values.UNIT}{else}x{/if}</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>{$order_values.PRODUCTS_NAME}</strong><br />\r\n						{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES} \r\n							{$prop_item_array.properties_name}: {$prop_item_array.values_name}<br />\r\n						{/foreach}\r\n\r\n						{if $order_values.PRODUCTS_ATTRIBUTES}\r\n							{$order_values.PRODUCTS_ATTRIBUTES}<br />\r\n						{/if}\r\n\r\n						{if $order_values.CHECKOUT_INFORMATION}\r\n							{$order_values.CHECKOUT_INFORMATION}<br />\r\n						{else}\r\n							<br />\r\n						{/if}\r\n						{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}\r\n							Lieferzeit: {$order_values.PRODUCTS_SHIPPING_TIME}\r\n						{/if}\r\n						</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							{$order_values.PRODUCTS_MODEL}<br />\r\n							<em>{$order_values.PRODUCTS_ATTRIBUTES_MODEL}</em>\r\n						</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; text-align: right; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_SINGLE_PRICE}</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; text-align: right; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_PRICE}</span></span>\r\n					</td>\r\n				</tr>\r\n				<!--{/foreach}-->\r\n			\r\n			</tbody>\r\n		</table>\r\n\r\n		<div style="float: right; text-align: right">\r\n			{foreach name=aussen item=order_total_values from=$order_total}\r\n				<span style="font-size:13px"><span style="font-family: verdana,geneva,sans-serif;">{$order_total_values.TITLE}{$order_total_values.TEXT}</span></span><br />\r\n			{/foreach}\r\n		</div>\r\n		\r\n		<br style="clear: right;" />\r\n		\r\n		{if $COMMENTS}\r\n		<p style="display: block;">\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>Anmerkungen:</strong><br />\r\n				{$COMMENTS}\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n\r\n		{$TS_RATING}\r\n\r\n		{if $SHOW_ABANDONMENT_WITHDRAWAL_DOWNLOADS_INFO}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>Sie haben gew&auml;hlt:</strong><br />\r\n				Ich stimme ausdr&uuml;cklich zu, dass Sie vor Ablauf der Widerrufsfrist mit der Ausf&uuml;hrung des Vertrages beginnen. \r\n				Mir ist bekannt, dass ich durch diese Zustimmung mit Beginn der Ausf&uuml;hrung des Vertrages mein Widerrufsrecht verliere.\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		{if $SHOW_ABANDONMENT_WITHDRAWAL_SERVICES_INFO}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>Sie haben gew&auml;hlt:</strong><br />\r\n				Ich bin einverstanden und verlange ausdr&uuml;cklich, dass Sie vor Ende der Widerrufsfrist mit der Ausf&uuml;hrung der beauftragten Dienstleistung beginnen. \r\n				Mir ist bekannt, dass ich bei vollst&auml;ndiger Vertragserf&uuml;llung durch Sie mein Widerrufsrecht verliere.\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		{if $WITHDRAWAL_LINK || $PDF_LINK}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>&sect; Muster-Widerrufsformular</strong><br />\r\n				{if $PDF_LINK} Unser Muster-Widerrufsformular im PDF-Format: <a href="{$PDF_LINK}">DOWNLOAD</a><br />{/if}\r\n				{if $WITHDRAWAL_LINK} Unser Muster-Widerrufsformular zum online Ausf&uuml;llen: <a href="{$WITHDRAWAL_LINK}">ONLINE-FORMULAR</a>{/if}\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				Um die zum Download angebotenen PDF-Dateien zu &ouml;ffnen, ben&ouml;tigen Sie ein Zusatzprogramm, \r\n				wie zum Beispiel den Adobe Reader, welchen Sie im Internet kostenfrei herunterladen k&ouml;nnen. \r\n				Die aktuelle Version des Adobe Readers finden Sie <a href="http://get.adobe.com/de/reader/" target="_blank">hier</a>.<br />\r\n			</span></span>\r\n		</p>\r\n		<br />\r\n		{if $JANOLAW_INFO_HTML}\r\n		<div style="font-size:10px;font-family: verdana,geneva,sans-serif;">\r\n			{$JANOLAW_INFO_HTML}<br />\r\n		</div>\r\n		{/if}\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: auto; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table style="width: 100%; overflow: hidden;">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{php}echo nl2br(STORE_NAME_ADDRESS){/php}</span></span>\r\n					</td>\r\n					<td style="text-align: right;">\r\n						{$gm_logo_mail}\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n\r\n		<h1>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</span></span>\r\n		</h1>\r\n\r\n		<p>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">vielen Dank f&uuml;r Ihre Bestellung in unserem Online-Shop!</span></span>\r\n		</p>\r\n\r\n		<p>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				{if $PAYMENT_MODUL==''moneyorder''} Unsere Bankverbindung:<br />\r\n					{php} echo nl2br(MODULE_PAYMENT_MONEYORDER_PAYTO); {/php} \r\n				{else} \r\n					{$PAYMENT_INFO_HTML} \r\n				{/if}\r\n			</span></span>\r\n		</p>\r\n\r\n		<br />\r\n		\r\n		<h3 style="border-bottom: 1px solid #ddd; padding: 5px 0px">\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Ihre Bestellung: </span></span>\r\n		</h3>\r\n		\r\n		<div style="height: auto; overflow: hidden;">\r\n			<p style="float: left; width: 33%;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					<strong>Rechnungsadresse</strong><br />\r\n					{$address_label_payment}\r\n				</span></span>\r\n			</p>\r\n\r\n			<p style="float: left; width: 33%;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					<strong>Lieferadresse</strong><br />\r\n					{$address_label_shipping}\r\n				</span></span>\r\n			</p>\r\n\r\n			<p style="float: left; width: 33%; text-align: right;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					{if $PAYMENT_METHOD}<strong>Zahlungsmethode:</strong> {$PAYMENT_METHOD}<br />{/if} \r\n					<strong>Bestellnummer:</strong> {$oID}<br />\r\n					<strong>Bestelldatum:</strong> {$DATE}<br />\r\n					<br />\r\n					{if $csID}<strong>Kundennummer:</strong> {$csID}<br />{/if} \r\n					{if $PHONE}<strong>Telefonnummer:</strong> {$PHONE}<br />{/if} \r\n					{if $customer_vat}<strong>USt-IdNr.:</strong> {$customer_vat}<br />{/if}\r\n				</span></span>\r\n			</p>\r\n		</div>\r\n\r\n		<table cellspacing="0" style="width: 100%; font-size: 12px; margin-top: 25px; padding: 0;">\r\n			<tbody>\r\n				<tr>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Anzahl</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Artikel</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Artikel-Nr.</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 4px 3px 3px; font-size: 13px; text-align: right;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Einzelpreis</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 4px 3px 3px; font-size: 13px; text-align: right;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Gesamtpreis</span></span>\r\n					</th>\r\n				</tr>\r\n\r\n				<!--{foreach name=aussen item=order_values from=$order_data}-->\r\n				<tr>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_QTY}{if $order_values.UNIT}{$order_values.UNIT}{else}x{/if}</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>{$order_values.PRODUCTS_NAME}</strong><br />\r\n						{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES} \r\n							{$prop_item_array.properties_name}: {$prop_item_array.values_name}<br />\r\n						{/foreach}\r\n\r\n						{if $order_values.PRODUCTS_ATTRIBUTES}\r\n							{$order_values.PRODUCTS_ATTRIBUTES}<br />\r\n						{/if}\r\n\r\n						{if $order_values.CHECKOUT_INFORMATION}\r\n							{$order_values.CHECKOUT_INFORMATION}<br />\r\n						{else}\r\n							<br />\r\n						{/if}\r\n						{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}\r\n							Lieferzeit: {$order_values.PRODUCTS_SHIPPING_TIME}\r\n						{/if}\r\n						</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							{$order_values.PRODUCTS_MODEL}<br />\r\n							<em>{$order_values.PRODUCTS_ATTRIBUTES_MODEL}</em>\r\n						</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; text-align: right; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_SINGLE_PRICE}</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; text-align: right; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_PRICE}</span></span>\r\n					</td>\r\n				</tr>\r\n				<!--{/foreach}-->\r\n			\r\n			</tbody>\r\n		</table>\r\n\r\n		<div style="float: right; text-align: right">\r\n			{foreach name=aussen item=order_total_values from=$order_total}\r\n				<span style="font-size:13px"><span style="font-family: verdana,geneva,sans-serif;">{$order_total_values.TITLE}{$order_total_values.TEXT}</span></span><br />\r\n			{/foreach}\r\n		</div>\r\n		\r\n		<br style="clear: right;" />\r\n		\r\n		{if $COMMENTS}\r\n		<p style="display: block;">\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>Anmerkungen:</strong><br />\r\n				{$COMMENTS}\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n\r\n		{$TS_RATING}\r\n\r\n		{if $SHOW_ABANDONMENT_WITHDRAWAL_DOWNLOADS_INFO}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>Sie haben gew&auml;hlt:</strong><br />\r\n				Ich stimme ausdr&uuml;cklich zu, dass Sie vor Ablauf der Widerrufsfrist mit der Ausf&uuml;hrung des Vertrages beginnen. \r\n				Mir ist bekannt, dass ich durch diese Zustimmung mit Beginn der Ausf&uuml;hrung des Vertrages mein Widerrufsrecht verliere.\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		{if $SHOW_ABANDONMENT_WITHDRAWAL_SERVICES_INFO}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>Sie haben gew&auml;hlt:</strong><br />\r\n				Ich bin einverstanden und verlange ausdr&uuml;cklich, dass Sie vor Ende der Widerrufsfrist mit der Ausf&uuml;hrung der beauftragten Dienstleistung beginnen. \r\n				Mir ist bekannt, dass ich bei vollst&auml;ndiger Vertragserf&uuml;llung durch Sie mein Widerrufsrecht verliere.\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		{if $WITHDRAWAL_LINK || $PDF_LINK}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>&sect; Muster-Widerrufsformular</strong><br />\r\n				{if $PDF_LINK} Unser Muster-Widerrufsformular im PDF-Format: <a href="{$PDF_LINK}">DOWNLOAD</a><br />{/if}\r\n				{if $WITHDRAWAL_LINK} Unser Muster-Widerrufsformular zum online Ausf&uuml;llen: <a href="{$WITHDRAWAL_LINK}">ONLINE-FORMULAR</a>{/if}\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				Um die zum Download angebotenen PDF-Dateien zu &ouml;ffnen, ben&ouml;tigen Sie ein Zusatzprogramm, \r\n				wie zum Beispiel den Adobe Reader, welchen Sie im Internet kostenfrei herunterladen k&ouml;nnen. \r\n				Die aktuelle Version des Adobe Readers finden Sie <a href="http://get.adobe.com/de/reader/" target="_blank">hier</a>.<br />\r\n			</span></span>\r\n		</p>\r\n		<br />\r\n		{if $JANOLAW_INFO_HTML}\r\n		<div style="font-size:10px;font-family: verdana,geneva,sans-serif;">\r\n			{$JANOLAW_INFO_HTML}<br />\r\n		</div>\r\n		{/if}\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{$address_label_customer}\r\n\r\n{if $PHONE}Telefonnummer: {$PHONE}\r\n{/if}\r\n{if $customer_vat}USt-IdNr.: {$customer_vat}{/if}\r\n\r\n\r\n{if $PAYMENT_METHOD}Zahlungsmethode: {$PAYMENT_METHOD}\r\n{/if}\r\nBestellnummer: {$oID}\r\nDatum: {$DATE}\r\n{if $csID}Kundennummer:{$csID}{/if}\r\n\r\n----------------------------------------------------------------------\r\n\r\n\r\nSehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nvielen Dank für Ihre Bestellung in unserem Onlineshop.\r\n\r\n{if $PAYMENT_MODUL==''moneyorder''}\r\nUnsere Bankverbindung:\r\n{php} echo MODULE_PAYMENT_MONEYORDER_PAYTO; {/php}\r\n{else}\r\n{$PAYMENT_INFO_TXT}\r\n{/if}\r\n\r\n{if $COMMENTS}\r\nIhre Anmerkungen:\r\n{$COMMENTS}\r\n{/if}\r\n\r\nIhre bestellten Produkte zur Kontrolle:\r\n----------------------------------------------------------------------\r\n{foreach name=aussen item=order_values from=$order_data} \r\n{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if} {$order_values.PRODUCTS_NAME} {$order_values.PRODUCTS_PRICE}\r\n{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES}\r\n {$prop_item_array.properties_name}: {$prop_item_array.values_name}\r\n{/foreach}\r\n{if $order_values.PRODUCTS_ATTRIBUTES !=''''}{$order_values.PRODUCTS_ATTRIBUTES}{/if}\r\n\r\n{$order_values.CHECKOUT_INFORMATION_TEXT}\r\n{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}\r\nLieferzeit: {$order_values.PRODUCTS_SHIPPING_TIME}\r\n{/if}\r\n\r\n{/foreach}\r\n\r\n{foreach name=aussen item=order_total_values from=$order_total}\r\n{$order_total_values.TITLE}{$order_total_values.TEXT}\r\n{/foreach}\r\n\r\n\r\n{if $address_label_payment}\r\nRechnungsadresse\r\n----------------------------------------------------------------------\r\n{$address_label_payment}\r\n{/if}\r\n\r\n\r\nVersandadresse \r\n----------------------------------------------------------------------\r\n{$address_label_shipping}\r\n\r\n\r\n{$TS_RATING}\r\n\r\n{if $SHOW_ABANDONMENT_WITHDRAWAL_DOWNLOADS_INFO}\r\nSie haben gewählt:\r\nIch stimme ausdrücklich zu, dass Sie vor Ablauf der Widerrufsfrist mit der Ausführung des Vertrages beginnen. Mir ist bekannt, dass ich durch diese Zustimmung mit Beginn der Ausführung des Vertrages mein Widerrufsrecht verliere.\r\n\r\n{/if}\r\n{if $SHOW_ABANDONMENT_WITHDRAWAL_SERVICES_INFO}\r\nSie haben gewählt:\r\nIch bin einverstanden und verlange ausdrücklich, dass Sie vor Ende der Widerrufsfrist mit der Ausführung der beauftragten Dienstleistung beginnen. Mir ist bekannt, dass ich bei vollständiger Vertragserfüllung durch Sie mein Widerrufsrecht verliere.\r\n\r\n{/if}\r\n{if $WITHDRAWAL_LINK || $PDF_LINK}\r\n§ Muster-Widerrufsformular\r\n{if $PDF_LINK}Unser Muster-Widerrufsformular im PDF-Format: {$PDF_LINK} {/if}\r\n{if $WITHDRAWAL_LINK}\r\nUnser Muster-Widerrufsformular zum online Ausfüllen: {$WITHDRAWAL_LINK}{/if}\r\n{/if}\r\n\r\n\r\nUm die zum Download angebotenen PDF-Dateien zu öffnen, benötigen Sie ein Zusatzprogramm, wie zum Beispiel den Adobe Reader, welchen Sie im Internet kostenfrei herunterladen können. Die aktuelle Version des Adobe Readers finden Sie hier: http://get.adobe.com/de/reader/\r\n\r\n{if $JANOLAW_INFO_TEXT}{$JANOLAW_INFO_TEXT}{/if}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '{$address_label_customer}\r\n\r\n{if $PHONE}Telefonnummer: {$PHONE}\r\n{/if}\r\n{if $customer_vat}USt-IdNr.: {$customer_vat}{/if}\r\n\r\n\r\n{if $PAYMENT_METHOD}Zahlungsmethode: {$PAYMENT_METHOD}\r\n{/if}\r\nBestellnummer: {$oID}\r\nDatum: {$DATE}\r\n{if $csID}Kundennummer:{$csID}{/if}\r\n\r\n----------------------------------------------------------------------\r\n\r\n\r\nSehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nvielen Dank für Ihre Bestellung in unserem Onlineshop.\r\n\r\n{if $PAYMENT_MODUL==''moneyorder''}\r\nUnsere Bankverbindung:\r\n{php} echo MODULE_PAYMENT_MONEYORDER_PAYTO; {/php}\r\n{else}\r\n{$PAYMENT_INFO_TXT}\r\n{/if}\r\n\r\n{if $COMMENTS}\r\nIhre Anmerkungen:\r\n{$COMMENTS}\r\n{/if}\r\n\r\nIhre bestellten Produkte zur Kontrolle:\r\n----------------------------------------------------------------------\r\n{foreach name=aussen item=order_values from=$order_data} \r\n{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if} {$order_values.PRODUCTS_NAME} {$order_values.PRODUCTS_PRICE}\r\n{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES}\r\n {$prop_item_array.properties_name}: {$prop_item_array.values_name}\r\n{/foreach}\r\n{if $order_values.PRODUCTS_ATTRIBUTES !=''''}{$order_values.PRODUCTS_ATTRIBUTES}{/if}\r\n\r\n{$order_values.CHECKOUT_INFORMATION_TEXT}\r\n{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}\r\nLieferzeit: {$order_values.PRODUCTS_SHIPPING_TIME}\r\n{/if}\r\n\r\n{/foreach}\r\n\r\n{foreach name=aussen item=order_total_values from=$order_total}\r\n{$order_total_values.TITLE}{$order_total_values.TEXT}\r\n{/foreach}\r\n\r\n\r\n{if $address_label_payment}\r\nRechnungsadresse\r\n----------------------------------------------------------------------\r\n{$address_label_payment}\r\n{/if}\r\n\r\n\r\nVersandadresse \r\n----------------------------------------------------------------------\r\n{$address_label_shipping}\r\n\r\n\r\n{$TS_RATING}\r\n\r\n{if $SHOW_ABANDONMENT_WITHDRAWAL_DOWNLOADS_INFO}\r\nSie haben gewählt:\r\nIch stimme ausdrücklich zu, dass Sie vor Ablauf der Widerrufsfrist mit der Ausführung des Vertrages beginnen. Mir ist bekannt, dass ich durch diese Zustimmung mit Beginn der Ausführung des Vertrages mein Widerrufsrecht verliere.\r\n\r\n{/if}\r\n{if $SHOW_ABANDONMENT_WITHDRAWAL_SERVICES_INFO}\r\nSie haben gewählt:\r\nIch bin einverstanden und verlange ausdrücklich, dass Sie vor Ende der Widerrufsfrist mit der Ausführung der beauftragten Dienstleistung beginnen. Mir ist bekannt, dass ich bei vollständiger Vertragserfüllung durch Sie mein Widerrufsrecht verliere.\r\n\r\n{/if}\r\n{if $WITHDRAWAL_LINK || $PDF_LINK}\r\n§ Muster-Widerrufsformular\r\n{if $PDF_LINK}Unser Muster-Widerrufsformular im PDF-Format: {$PDF_LINK} {/if}\r\n{if $WITHDRAWAL_LINK}\r\nUnser Muster-Widerrufsformular zum online Ausfüllen: {$WITHDRAWAL_LINK}{/if}\r\n{/if}\r\n\r\n\r\nUm die zum Download angebotenen PDF-Dateien zu öffnen, benötigen Sie ein Zusatzprogramm, wie zum Beispiel den Adobe Reader, welchen Sie im Internet kostenfrei herunterladen können. Die aktuelle Version des Adobe Readers finden Sie hier: http://get.adobe.com/de/reader/\r\n\r\n{if $JANOLAW_INFO_TEXT}{$JANOLAW_INFO_TEXT}{/if}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="height: auto; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table style="width: 100%; overflow: hidden;">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{php}echo nl2br(STORE_NAME_ADDRESS){/php}</span></span>\r\n					</td>\r\n					<td style="text-align: right;">\r\n						{$gm_logo_mail}\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n\r\n		<h1>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</span></span>\r\n		</h1>\r\n\r\n		<p>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">vielen Dank f&uuml;r Ihre Bestellung in unserem Online-Shop!</span></span>\r\n		</p>\r\n\r\n		<p>\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				{if $PAYMENT_MODUL==''moneyorder''} Unsere Bankverbindung:<br />\r\n					{php} echo nl2br(MODULE_PAYMENT_MONEYORDER_PAYTO); {/php} \r\n				{else} \r\n					{$PAYMENT_INFO_HTML} \r\n				{/if}\r\n			</span></span>\r\n		</p>\r\n\r\n		<br />\r\n		\r\n		<h3 style="border-bottom: 1px solid #ddd; padding: 5px 0px">\r\n			<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Ihre Bestellung: </span></span>\r\n		</h3>\r\n		\r\n		<div style="height: auto; overflow: hidden;">\r\n			<p style="float: left; width: 33%;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					<strong>Rechnungsadresse</strong><br />\r\n					{$address_label_payment}\r\n				</span></span>\r\n			</p>\r\n\r\n			<p style="float: left; width: 33%;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					<strong>Lieferadresse</strong><br />\r\n					{$address_label_shipping}\r\n				</span></span>\r\n			</p>\r\n\r\n			<p style="float: left; width: 33%; text-align: right;">\r\n				<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n					{if $PAYMENT_METHOD}<strong>Zahlungsmethode:</strong> {$PAYMENT_METHOD}<br />{/if} \r\n					<strong>Bestellnummer:</strong> {$oID}<br />\r\n					<strong>Bestelldatum:</strong> {$DATE}<br />\r\n					<br />\r\n					{if $csID}<strong>Kundennummer:</strong> {$csID}<br />{/if} \r\n					{if $PHONE}<strong>Telefonnummer:</strong> {$PHONE}<br />{/if} \r\n					{if $customer_vat}<strong>USt-IdNr.:</strong> {$customer_vat}<br />{/if}\r\n				</span></span>\r\n			</p>\r\n		</div>\r\n\r\n		<table cellspacing="0" style="width: 100%; font-size: 12px; margin-top: 25px; padding: 0;">\r\n			<tbody>\r\n				<tr>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Anzahl</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Artikel</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 0 3px 3px; font-size: 13px; text-align: left;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Artikel-Nr.</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 4px 3px 3px; font-size: 13px; text-align: right;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Einzelpreis</span></span>\r\n					</th>\r\n					<th style="font-weight: bold; border-bottom: 2px solid #000; padding: 3px 4px 3px 3px; font-size: 13px; text-align: right;">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Gesamtpreis</span></span>\r\n					</th>\r\n				</tr>\r\n\r\n				<!--{foreach name=aussen item=order_values from=$order_data}-->\r\n				<tr>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_QTY}{if $order_values.UNIT}{$order_values.UNIT}{else}x{/if}</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>{$order_values.PRODUCTS_NAME}</strong><br />\r\n						{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES} \r\n							{$prop_item_array.properties_name}: {$prop_item_array.values_name}<br />\r\n						{/foreach}\r\n\r\n						{if $order_values.PRODUCTS_ATTRIBUTES}\r\n							{$order_values.PRODUCTS_ATTRIBUTES}<br />\r\n						{/if}\r\n\r\n						{if $order_values.CHECKOUT_INFORMATION}\r\n							{$order_values.CHECKOUT_INFORMATION}<br />\r\n						{else}\r\n							<br />\r\n						{/if}\r\n						{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}\r\n							Lieferzeit: {$order_values.PRODUCTS_SHIPPING_TIME}\r\n						{/if}\r\n						</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							{$order_values.PRODUCTS_MODEL}<br />\r\n							<em>{$order_values.PRODUCTS_ATTRIBUTES_MODEL}</em>\r\n						</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; text-align: right; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_SINGLE_PRICE}</span></span>\r\n					</td>\r\n					<td style="border-bottom: 1px solid #ddd; padding: 5px 4px; text-align: right; vertical-align: top">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$order_values.PRODUCTS_PRICE}</span></span>\r\n					</td>\r\n				</tr>\r\n				<!--{/foreach}-->\r\n			\r\n			</tbody>\r\n		</table>\r\n\r\n		<div style="float: right; text-align: right">\r\n			{foreach name=aussen item=order_total_values from=$order_total}\r\n				<span style="font-size:13px"><span style="font-family: verdana,geneva,sans-serif;">{$order_total_values.TITLE}{$order_total_values.TEXT}</span></span><br />\r\n			{/foreach}\r\n		</div>\r\n		\r\n		<br style="clear: right;" />\r\n		\r\n		{if $COMMENTS}\r\n		<p style="display: block;">\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>Anmerkungen:</strong><br />\r\n				{$COMMENTS}\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n\r\n		{$TS_RATING}\r\n\r\n		{if $SHOW_ABANDONMENT_WITHDRAWAL_DOWNLOADS_INFO}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>Sie haben gew&auml;hlt:</strong><br />\r\n				Ich stimme ausdr&uuml;cklich zu, dass Sie vor Ablauf der Widerrufsfrist mit der Ausf&uuml;hrung des Vertrages beginnen. \r\n				Mir ist bekannt, dass ich durch diese Zustimmung mit Beginn der Ausf&uuml;hrung des Vertrages mein Widerrufsrecht verliere.\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		{if $SHOW_ABANDONMENT_WITHDRAWAL_SERVICES_INFO}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>Sie haben gew&auml;hlt:</strong><br />\r\n				Ich bin einverstanden und verlange ausdr&uuml;cklich, dass Sie vor Ende der Widerrufsfrist mit der Ausf&uuml;hrung der beauftragten Dienstleistung beginnen. \r\n				Mir ist bekannt, dass ich bei vollst&auml;ndiger Vertragserf&uuml;llung durch Sie mein Widerrufsrecht verliere.\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		{if $WITHDRAWAL_LINK || $PDF_LINK}\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				<strong>&sect; Muster-Widerrufsformular</strong><br />\r\n				{if $PDF_LINK} Unser Muster-Widerrufsformular im PDF-Format: <a href="{$PDF_LINK}">DOWNLOAD</a><br />{/if}\r\n				{if $WITHDRAWAL_LINK} Unser Muster-Widerrufsformular zum online Ausf&uuml;llen: <a href="{$WITHDRAWAL_LINK}">ONLINE-FORMULAR</a>{/if}\r\n			</span></span>\r\n		</p>\r\n		{/if}\r\n		\r\n		<p>\r\n			<span style="font-size:12px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n				Um die zum Download angebotenen PDF-Dateien zu &ouml;ffnen, ben&ouml;tigen Sie ein Zusatzprogramm, \r\n				wie zum Beispiel den Adobe Reader, welchen Sie im Internet kostenfrei herunterladen k&ouml;nnen. \r\n				Die aktuelle Version des Adobe Readers finden Sie <a href="http://get.adobe.com/de/reader/" target="_blank">hier</a>.<br />\r\n			</span></span>\r\n		</p>\r\n		<br />\r\n		{if $JANOLAW_INFO_HTML}\r\n		<div style="font-size:10px;font-family: verdana,geneva,sans-serif;">\r\n			{$JANOLAW_INFO_HTML}<br />\r\n		</div>\r\n		{/if}\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{$address_label_customer}\r\n\r\n{if $PHONE}Telefonnummer: {$PHONE}\r\n{/if}\r\n{if $customer_vat}USt-IdNr.: {$customer_vat}{/if}\r\n\r\n\r\n{if $PAYMENT_METHOD}Zahlungsmethode: {$PAYMENT_METHOD}\r\n{/if}\r\nBestellnummer: {$oID}\r\nDatum: {$DATE}\r\n{if $csID}Kundennummer:{$csID}{/if}\r\n\r\n----------------------------------------------------------------------\r\n\r\n\r\nSehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nvielen Dank für Ihre Bestellung in unserem Onlineshop.\r\n\r\n{if $PAYMENT_MODUL==''moneyorder''}\r\nUnsere Bankverbindung:\r\n{php} echo MODULE_PAYMENT_MONEYORDER_PAYTO; {/php}\r\n{else}\r\n{$PAYMENT_INFO_TXT}\r\n{/if}\r\n\r\n{if $COMMENTS}\r\nIhre Anmerkungen:\r\n{$COMMENTS}\r\n{/if}\r\n\r\nIhre bestellten Produkte zur Kontrolle:\r\n----------------------------------------------------------------------\r\n{foreach name=aussen item=order_values from=$order_data} \r\n{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if} {$order_values.PRODUCTS_NAME} {$order_values.PRODUCTS_PRICE}\r\n{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES}\r\n {$prop_item_array.properties_name}: {$prop_item_array.values_name}\r\n{/foreach}\r\n{if $order_values.PRODUCTS_ATTRIBUTES !=''''}{$order_values.PRODUCTS_ATTRIBUTES}{/if}\r\n\r\n{$order_values.CHECKOUT_INFORMATION_TEXT}\r\n{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}\r\nLieferzeit: {$order_values.PRODUCTS_SHIPPING_TIME}\r\n{/if}\r\n\r\n{/foreach}\r\n\r\n{foreach name=aussen item=order_total_values from=$order_total}\r\n{$order_total_values.TITLE}{$order_total_values.TEXT}\r\n{/foreach}\r\n\r\n\r\n{if $address_label_payment}\r\nRechnungsadresse\r\n----------------------------------------------------------------------\r\n{$address_label_payment}\r\n{/if}\r\n\r\n\r\nVersandadresse \r\n----------------------------------------------------------------------\r\n{$address_label_shipping}\r\n\r\n\r\n{$TS_RATING}\r\n\r\n{if $SHOW_ABANDONMENT_WITHDRAWAL_DOWNLOADS_INFO}\r\nSie haben gewählt:\r\nIch stimme ausdrücklich zu, dass Sie vor Ablauf der Widerrufsfrist mit der Ausführung des Vertrages beginnen. Mir ist bekannt, dass ich durch diese Zustimmung mit Beginn der Ausführung des Vertrages mein Widerrufsrecht verliere.\r\n\r\n{/if}\r\n{if $SHOW_ABANDONMENT_WITHDRAWAL_SERVICES_INFO}\r\nSie haben gewählt:\r\nIch bin einverstanden und verlange ausdrücklich, dass Sie vor Ende der Widerrufsfrist mit der Ausführung der beauftragten Dienstleistung beginnen. Mir ist bekannt, dass ich bei vollständiger Vertragserfüllung durch Sie mein Widerrufsrecht verliere.\r\n\r\n{/if}\r\n{if $WITHDRAWAL_LINK || $PDF_LINK}\r\n§ Muster-Widerrufsformular\r\n{if $PDF_LINK}Unser Muster-Widerrufsformular im PDF-Format: {$PDF_LINK} {/if}\r\n{if $WITHDRAWAL_LINK}\r\nUnser Muster-Widerrufsformular zum online Ausfüllen: {$WITHDRAWAL_LINK}{/if}\r\n{/if}\r\n\r\n\r\nUm die zum Download angebotenen PDF-Dateien zu öffnen, benötigen Sie ein Zusatzprogramm, wie zum Beispiel den Adobe Reader, welchen Sie im Internet kostenfrei herunterladen können. Die aktuelle Version des Adobe Readers finden Sie hier: http://get.adobe.com/de/reader/\r\n\r\n{if $JANOLAW_INFO_TEXT}{$JANOLAW_INFO_TEXT}{/if}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(6, 1, '', 'password_verification_mail', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n						\r\n						<div style="page-break-after: always"><span style="display: none;">&nbsp;</span></div>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Please confirm, that you personally required a new password. For this reason we sent this email \r\n								with a personal confirmation-link. If you confirm the link, by clicking it, immediately a new \r\n								password is sent to you in a further email at the disposal.\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Your confirmation-link:</strong><br />\r\n											<a href="{$LINK}">{$LINK}</a>\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n						\r\n						<div style="page-break-after: always"><span style="display: none;">&nbsp;</span></div>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Please confirm, that you personally required a new password. For this reason we sent this email \r\n								with a personal confirmation-link. If you confirm the link, by clicking it, immediately a new \r\n								password is sent to you in a further email at the disposal.\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Your confirmation-link:</strong><br />\r\n											<a href="{$LINK}">{$LINK}</a>\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nPlease confirm, that you personally required a new password. \r\nFor this reason we sent this email with a personal confirmation-link. If you confirm the link, by clicking it, immediately a new password \r\nis sent to you in a further email at the disposal.\r\n      \r\nYour confirmation-link:\r\n{$LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nPlease confirm, that you personally required a new password. \r\nFor this reason we sent this email with a personal confirmation-link. If you confirm the link, by clicking it, immediately a new password \r\nis sent to you in a further email at the disposal.\r\n      \r\nYour confirmation-link:\r\n{$LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n						\r\n						<div style="page-break-after: always"><span style="display: none;">&nbsp;</span></div>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Please confirm, that you personally required a new password. For this reason we sent this email \r\n								with a personal confirmation-link. If you confirm the link, by clicking it, immediately a new \r\n								password is sent to you in a further email at the disposal.\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Your confirmation-link:</strong><br />\r\n											<a href="{$LINK}">{$LINK}</a>\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nPlease confirm, that you personally required a new password. \r\nFor this reason we sent this email with a personal confirmation-link. If you confirm the link, by clicking it, immediately a new password \r\nis sent to you in a further email at the disposal.\r\n      \r\nYour confirmation-link:\r\n{$LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(6, 2, '', 'password_verification_mail', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau{else}geehrte(r) {/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<div style="page-break-after: always"><span style="display: none;">&nbsp;</span></div>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Bitte best&auml;tigen Sie, dass Sie selber ein neues Passwort angefordert haben. \r\n								Aus diesem Grund haben wir Ihnen diese E-Mail mit einem pers&ouml;nlichen Best&auml;tigungslink geschickt. \r\n								Wenn Sie den Link best&auml;tigen, indem Sie ihn anklicken, wird Ihnen umgehend ein neues Passwort in einer weiteren E-Mail zur Verf&uuml;gung gestellt.\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Ihr	Best&auml;tigungslink:</strong><br />\r\n											<a href="{$LINK}">{$LINK}</a>\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau{else}geehrte(r) {/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<div style="page-break-after: always"><span style="display: none;">&nbsp;</span></div>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Bitte best&auml;tigen Sie, dass Sie selber ein neues Passwort angefordert haben. \r\n								Aus diesem Grund haben wir Ihnen diese E-Mail mit einem pers&ouml;nlichen Best&auml;tigungslink geschickt. \r\n								Wenn Sie den Link best&auml;tigen, indem Sie ihn anklicken, wird Ihnen umgehend ein neues Passwort in einer weiteren E-Mail zur Verf&uuml;gung gestellt.\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Ihr	Best&auml;tigungslink:</strong><br />\r\n											<a href="{$LINK}">{$LINK}</a>\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nBitte bestätigen Sie, dass Sie selber ein neues Passwort angefordert haben. \r\nAus diesem Grund haben wir Ihnen diese E-Mail mit einem persönlichen \r\nBestätigungslink geschickt. Wenn Sie den Link bestätigen, indem Sie ihn \r\nanklicken, wird Ihnen umgehend ein neues Passwort in einer weiteren E-Mail \r\nzur Verfügung gestellt.\r\n      \r\nIhr Bestätigungslink:\r\n{$LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nBitte bestätigen Sie, dass Sie selber ein neues Passwort angefordert haben. \r\nAus diesem Grund haben wir Ihnen diese E-Mail mit einem persönlichen \r\nBestätigungslink geschickt. Wenn Sie den Link bestätigen, indem Sie ihn \r\nanklicken, wird Ihnen umgehend ein neues Passwort in einer weiteren E-Mail \r\nzur Verfügung gestellt.\r\n      \r\nIhr Bestätigungslink:\r\n{$LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau{else}geehrte(r) {/if}{$NAME},</strong>\r\n							</span></span>\r\n						</p>\r\n\r\n						<div style="page-break-after: always"><span style="display: none;">&nbsp;</span></div>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Bitte best&auml;tigen Sie, dass Sie selber ein neues Passwort angefordert haben. \r\n								Aus diesem Grund haben wir Ihnen diese E-Mail mit einem pers&ouml;nlichen Best&auml;tigungslink geschickt. \r\n								Wenn Sie den Link best&auml;tigen, indem Sie ihn anklicken, wird Ihnen umgehend ein neues Passwort in einer weiteren E-Mail zur Verf&uuml;gung gestellt.\r\n							</span></span>\r\n						</p>\r\n\r\n						<table bgcolor="#f1f1f1" border="0" cellpadding="8" width="100%">\r\n							<tbody>\r\n								<tr>\r\n									<td>\r\n										<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n											<strong>Ihr	Best&auml;tigungslink:</strong><br />\r\n											<a href="{$LINK}">{$LINK}</a>\r\n										</span></span>\r\n									</td>\r\n								</tr>\r\n							</tbody>\r\n						</table>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br /> \r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nBitte bestätigen Sie, dass Sie selber ein neues Passwort angefordert haben. \r\nAus diesem Grund haben wir Ihnen diese E-Mail mit einem persönlichen \r\nBestätigungslink geschickt. Wenn Sie den Link bestätigen, indem Sie ihn \r\nanklicken, wird Ihnen umgehend ein neues Passwort in einer weiteren E-Mail \r\nzur Verfügung gestellt.\r\n      \r\nIhr Bestätigungslink:\r\n{$LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(7, 1, '', 'send_gift_to_friend', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p style="padding: 10px; border-top: 1px solid #333; border-bottom: 1px solid #333; text-align: center; display: block">\r\n							<span style="font-size:16px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Gratulation, you received a gift voucher over: <strong>{$AMMOUNT} </strong>\r\n							</span></span>\r\n						</p>\r\n						<br /> \r\n						<br />\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							This gift voucher is from: {$FROM_NAME}<br /><br /> Message:<br />\r\n							<br />\r\n							{$MESSAGE}<br />\r\n							<br />\r\n							Your personal gift voucher code is <strong>{$GIFT_CODE}</strong>. You can redeem this gift voucher during your order in our store,<br />\r\n							<br />\r\n							or with a click on the following link <a href="{$GIFT_LINK}">{$GIFT_LINK}</a>.<br />\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p style="padding: 10px; border-top: 1px solid #333; border-bottom: 1px solid #333; text-align: center; display: block">\r\n							<span style="font-size:16px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Gratulation, you received a gift voucher over: <strong>{$AMMOUNT} </strong>\r\n							</span></span>\r\n						</p>\r\n						<br /> \r\n						<br />\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							This gift voucher is from: {$FROM_NAME}<br /><br /> Message:<br />\r\n							<br />\r\n							{$MESSAGE}<br />\r\n							<br />\r\n							Your personal gift voucher code is <strong>{$GIFT_CODE}</strong>. You can redeem this gift voucher during your order in our store,<br />\r\n							<br />\r\n							or with a click on the following link <a href="{$GIFT_LINK}">{$GIFT_LINK}</a>.<br />\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '---------------------------------------------------------------------------------------- \r\nGratulation, you received a gift voucher over: {$AMMOUNT}\r\n----------------------------------------------------------------------------------------\r\n\r\nThis gift voucher is from: {$FROM_NAME}\r\n\r\nMessage: \r\n\r\n{$MESSAGE}\r\n\r\nYour personal gift voucher code is: {$GIFT_CODE}. \r\nYou can redeem this gift voucher during your order in our store or with a click on the following link:\r\n{$GIFT_LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '---------------------------------------------------------------------------------------- \r\nGratulation, you received a gift voucher over: {$AMMOUNT}\r\n----------------------------------------------------------------------------------------\r\n\r\nThis gift voucher is from: {$FROM_NAME}\r\n\r\nMessage: \r\n\r\n{$MESSAGE}\r\n\r\nYour personal gift voucher code is: {$GIFT_CODE}. \r\nYou can redeem this gift voucher during your order in our store or with a click on the following link:\r\n{$GIFT_LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p style="padding: 10px; border-top: 1px solid #333; border-bottom: 1px solid #333; text-align: center; display: block">\r\n							<span style="font-size:16px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Gratulation, you received a gift voucher over: <strong>{$AMMOUNT} </strong>\r\n							</span></span>\r\n						</p>\r\n						<br /> \r\n						<br />\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							This gift voucher is from: {$FROM_NAME}<br /><br /> Message:<br />\r\n							<br />\r\n							{$MESSAGE}<br />\r\n							<br />\r\n							Your personal gift voucher code is <strong>{$GIFT_CODE}</strong>. You can redeem this gift voucher during your order in our store,<br />\r\n							<br />\r\n							or with a click on the following link <a href="{$GIFT_LINK}">{$GIFT_LINK}</a>.<br />\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '---------------------------------------------------------------------------------------- \r\nGratulation, you received a gift voucher over: {$AMMOUNT}\r\n----------------------------------------------------------------------------------------\r\n\r\nThis gift voucher is from: {$FROM_NAME}\r\n\r\nMessage: \r\n\r\n{$MESSAGE}\r\n\r\nYour personal gift voucher code is: {$GIFT_CODE}. \r\nYou can redeem this gift voucher during your order in our store or with a click on the following link:\r\n{$GIFT_LINK}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(7, 2, '', 'send_gift_to_friend', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p style="padding: 10px; border-top: 1px solid #333; border-bottom: 1px solid #333; text-align: center; display: block">\r\n							<span style="font-size:16px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Herzlichen Gl&uuml;ckwunsch, Sie haben einen Gutschein &uuml;ber <strong>{$AMMOUNT} </strong>erhalten!\r\n							</span></span>\r\n						</p>\r\n						<br />\r\n						<br />\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							Dieser Gutschein wurde Ihnen von {$FROM_NAME} mit folgender Nachricht &uuml;bermittelt:<br />\r\n							<br />\r\n							{$MESSAGE}<br />\r\n							<br />\r\n							Ihr pers&ouml;nlicher Gutschein-Code lautet <strong>{$GIFT_CODE}</strong>. Sie k&ouml;nnen diese Gutschrift w&auml;hrend des Bestellvorgangs verbuchen.<br />\r\n							<br />\r\n							Um den Gutschein einzul&ouml;sen, klicken Sie bitte auf <a href="{$GIFT_LINK}">{$GIFT_LINK}</a>.<br />\r\n							<br />\r\n							Falls es mit dem obigen Link zu Probleme beim Einl&ouml;sen kommen sollte, k&ouml;nnen Sie den Betrag w&auml;hrend des Bestellvorganges verbuchen.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p style="padding: 10px; border-top: 1px solid #333; border-bottom: 1px solid #333; text-align: center; display: block">\r\n							<span style="font-size:16px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Herzlichen Gl&uuml;ckwunsch, Sie haben einen Gutschein &uuml;ber <strong>{$AMMOUNT} </strong>erhalten!\r\n							</span></span>\r\n						</p>\r\n						<br />\r\n						<br />\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							Dieser Gutschein wurde Ihnen von {$FROM_NAME} mit folgender Nachricht &uuml;bermittelt:<br />\r\n							<br />\r\n							{$MESSAGE}<br />\r\n							<br />\r\n							Ihr pers&ouml;nlicher Gutschein-Code lautet <strong>{$GIFT_CODE}</strong>. Sie k&ouml;nnen diese Gutschrift w&auml;hrend des Bestellvorgangs verbuchen.<br />\r\n							<br />\r\n							Um den Gutschein einzul&ouml;sen, klicken Sie bitte auf <a href="{$GIFT_LINK}">{$GIFT_LINK}</a>.<br />\r\n							<br />\r\n							Falls es mit dem obigen Link zu Probleme beim Einl&ouml;sen kommen sollte, k&ouml;nnen Sie den Betrag w&auml;hrend des Bestellvorganges verbuchen.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '----------------------------------------------------------------------------------------------\r\nHerzlichen Glückwunsch, Sie haben einen Gutschein über {$AMMOUNT} erhalten!\r\n----------------------------------------------------------------------------------------------\r\n\r\nDieser Gutschein wurde Ihnen von {$FROM_NAME} mit folgender Nachricht übermittelt:\r\n\r\n{$MESSAGE}\r\n\r\nIhr persönlicher Gutschein-Code lautet {$GIFT_CODE}. Sie können diese Gutschrift während des Bestellvorgangs verbuchen.\r\n\r\nUm den Gutschein einzulösen, klicken Sie bitte auf {$GIFT_LINK}.\r\n\r\nFalls es mit dem obigen Link zu Probleme beim Einlösen kommen sollte, können Sie den Betrag während des Bestellvorganges verbuchen.\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '----------------------------------------------------------------------------------------------\r\nHerzlichen Glückwunsch, Sie haben einen Gutschein über {$AMMOUNT} erhalten!\r\n----------------------------------------------------------------------------------------------\r\n\r\nDieser Gutschein wurde Ihnen von {$FROM_NAME} mit folgender Nachricht übermittelt:\r\n\r\n{$MESSAGE}\r\n\r\nIhr persönlicher Gutschein-Code lautet {$GIFT_CODE}. Sie können diese Gutschrift während des Bestellvorgangs verbuchen.\r\n\r\nUm den Gutschein einzulösen, klicken Sie bitte auf {$GIFT_LINK}.\r\n\r\nFalls es mit dem obigen Link zu Probleme beim Einlösen kommen sollte, können Sie den Betrag während des Bestellvorganges verbuchen.\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p style="padding: 10px; border-top: 1px solid #333; border-bottom: 1px solid #333; text-align: center; display: block">\r\n							<span style="font-size:16px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n								Herzlichen Gl&uuml;ckwunsch, Sie haben einen Gutschein &uuml;ber <strong>{$AMMOUNT} </strong>erhalten!\r\n							</span></span>\r\n						</p>\r\n						<br />\r\n						<br />\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							Dieser Gutschein wurde Ihnen von {$FROM_NAME} mit folgender Nachricht &uuml;bermittelt:<br />\r\n							<br />\r\n							{$MESSAGE}<br />\r\n							<br />\r\n							Ihr pers&ouml;nlicher Gutschein-Code lautet <strong>{$GIFT_CODE}</strong>. Sie k&ouml;nnen diese Gutschrift w&auml;hrend des Bestellvorgangs verbuchen.<br />\r\n							<br />\r\n							Um den Gutschein einzul&ouml;sen, klicken Sie bitte auf <a href="{$GIFT_LINK}">{$GIFT_LINK}</a>.<br />\r\n							<br />\r\n							Falls es mit dem obigen Link zu Probleme beim Einl&ouml;sen kommen sollte, k&ouml;nnen Sie den Betrag w&auml;hrend des Bestellvorganges verbuchen.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '----------------------------------------------------------------------------------------------\r\nHerzlichen Glückwunsch, Sie haben einen Gutschein über {$AMMOUNT} erhalten!\r\n----------------------------------------------------------------------------------------------\r\n\r\nDieser Gutschein wurde Ihnen von {$FROM_NAME} mit folgender Nachricht übermittelt:\r\n\r\n{$MESSAGE}\r\n\r\nIhr persönlicher Gutschein-Code lautet {$GIFT_CODE}. Sie können diese Gutschrift während des Bestellvorgangs verbuchen.\r\n\r\nUm den Gutschein einzulösen, klicken Sie bitte auf {$GIFT_LINK}.\r\n\r\nFalls es mit dem obigen Link zu Probleme beim Einlösen kommen sollte, können Sie den Betrag während des Bestellvorganges verbuchen.\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(8, 1, 'admin/', 'change_order_mail', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							The status of your order {$ORDER_NR} from {$ORDER_DATE} changed.<br />\r\n							{if $NOTIFY_COMMENTS}<br />\r\n							Comments: {$NOTIFY_COMMENTS}<br />\r\n							{/if}<br />\r\n							New status: <strong>{$ORDER_STATUS}</strong><br />\r\n							For questions, feel free to anwser to this mail.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							The status of your order {$ORDER_NR} from {$ORDER_DATE} changed.<br />\r\n							{if $NOTIFY_COMMENTS}<br />\r\n							Comments: {$NOTIFY_COMMENTS}<br />\r\n							{/if}<br />\r\n							New status: <strong>{$ORDER_STATUS}</strong><br />\r\n							For questions, feel free to anwser to this mail.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nThe status of your order {$ORDER_NR} from {$ORDER_DATE} changed.\r\n\r\n{if $NOTIFY_COMMENTS}\r\nComments: {$NOTIFY_COMMENTS}\r\n\r\n{/if}\r\nNew status: {$ORDER_STATUS}\r\nFor questions, feel free to anwser to this mail.', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nThe status of your order {$ORDER_NR} from {$ORDER_DATE} changed.\r\n\r\n{if $NOTIFY_COMMENTS}\r\nComments: {$NOTIFY_COMMENTS}\r\n\r\n{/if}\r\nNew status: {$ORDER_STATUS}\r\nFor questions, feel free to anwser to this mail.', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							The status of your order {$ORDER_NR} from {$ORDER_DATE} changed.<br />\r\n							{if $NOTIFY_COMMENTS}<br />\r\n							Comments: {$NOTIFY_COMMENTS}<br />\r\n							{/if}<br />\r\n							New status: <strong>{$ORDER_STATUS}</strong><br />\r\n							For questions, feel free to anwser to this mail.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nThe status of your order {$ORDER_NR} from {$ORDER_DATE} changed.\r\n\r\n{if $NOTIFY_COMMENTS}\r\nComments: {$NOTIFY_COMMENTS}\r\n\r\n{/if}\r\nNew status: {$ORDER_STATUS}\r\nFor questions, feel free to anwser to this mail.');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(8, 2, 'admin/', 'change_order_mail', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if} {$NAME}, </strong><br />\r\n							<br />\r\n							Der Status Ihrer Bestellung vom {$ORDER_DATE} mit der Bestellnummer {$ORDER_NR} wurde ge&auml;ndert.<br />\r\n							{if $NOTIFY_COMMENTS}<br />\r\n							Anmerkungen und Kommentare zu Ihrer Bestellung: {$NOTIFY_COMMENTS}<br />\r\n							{/if}<br />\r\n							Neuer Status: <strong>{$ORDER_STATUS}</strong><br />\r\n							Bei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if} {$NAME}, </strong><br />\r\n							<br />\r\n							Der Status Ihrer Bestellung vom {$ORDER_DATE} mit der Bestellnummer {$ORDER_NR} wurde ge&auml;ndert.<br />\r\n							{if $NOTIFY_COMMENTS}<br />\r\n							Anmerkungen und Kommentare zu Ihrer Bestellung: {$NOTIFY_COMMENTS}<br />\r\n							{/if}<br />\r\n							Neuer Status: <strong>{$ORDER_STATUS}</strong><br />\r\n							Bei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nDer Status Ihrer Bestellung vom {$ORDER_DATE} mit der Bestellnummer {$ORDER_NR} wurde geändert.\r\n{if $NOTIFY_COMMENTS}\r\n\r\nAnmerkungen und Kommentare zu Ihrer Bestellung: {$NOTIFY_COMMENTS}\r\n{/if}\r\n\r\nNeuer Status: {$ORDER_STATUS}\r\nBei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail.', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nDer Status Ihrer Bestellung vom {$ORDER_DATE} mit der Bestellnummer {$ORDER_NR} wurde geändert.\r\n{if $NOTIFY_COMMENTS}\r\n\r\nAnmerkungen und Kommentare zu Ihrer Bestellung: {$NOTIFY_COMMENTS}\r\n{/if}\r\n\r\nNeuer Status: {$ORDER_STATUS}\r\nBei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail.', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if} {$NAME}, </strong><br />\r\n							<br />\r\n							Der Status Ihrer Bestellung vom {$ORDER_DATE} mit der Bestellnummer {$ORDER_NR} wurde ge&auml;ndert.<br />\r\n							{if $NOTIFY_COMMENTS}<br />\r\n							Anmerkungen und Kommentare zu Ihrer Bestellung: {$NOTIFY_COMMENTS}<br />\r\n							{/if}<br />\r\n							Neuer Status: <strong>{$ORDER_STATUS}</strong><br />\r\n							Bei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nDer Status Ihrer Bestellung vom {$ORDER_DATE} mit der Bestellnummer {$ORDER_NR} wurde geändert.\r\n{if $NOTIFY_COMMENTS}\r\n\r\nAnmerkungen und Kommentare zu Ihrer Bestellung: {$NOTIFY_COMMENTS}\r\n{/if}\r\n\r\nNeuer Status: {$ORDER_STATUS}\r\nBei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail.');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(9, 1, 'admin/', 'create_account_mail', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							We created an account for you.<br />\r\n							<br />\r\n							{if $COMMENTS} Comments: {$COMMENTS}<br />\r\n							{/if}<br />\r\n							<br />\r\n							Login with following account/password:<br />\r\n							<br />\r\n							mail: {$EMAIL}<br />\r\n							password: {$PASSWORD}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							We created an account for you.<br />\r\n							<br />\r\n							{if $COMMENTS} Comments: {$COMMENTS}<br />\r\n							{/if}<br />\r\n							<br />\r\n							Login with following account/password:<br />\r\n							<br />\r\n							mail: {$EMAIL}<br />\r\n							password: {$PASSWORD}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nWe created an account for you.\r\n\r\n{if $COMMENTS}Comments:{$COMMENTS}{/if}\r\n\r\nLogin with following account/password:\r\n\r\nmail: {$EMAIL}\r\npassword: {$PASSWORD}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nWe created an account for you.\r\n\r\n{if $COMMENTS}Comments:{$COMMENTS}{/if}\r\n\r\nLogin with following account/password:\r\n\r\nmail: {$EMAIL}\r\npassword: {$PASSWORD}', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							We created an account for you.<br />\r\n							<br />\r\n							{if $COMMENTS} Comments: {$COMMENTS}<br />\r\n							{/if}<br />\r\n							<br />\r\n							Login with following account/password:<br />\r\n							<br />\r\n							mail: {$EMAIL}<br />\r\n							password: {$PASSWORD}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nWe created an account for you.\r\n\r\n{if $COMMENTS}Comments:{$COMMENTS}{/if}\r\n\r\nLogin with following account/password:\r\n\r\nmail: {$EMAIL}\r\npassword: {$PASSWORD}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(9, 2, 'admin/', 'create_account_mail', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r){/if}{$NAME},</strong><br />\r\n							<br />\r\n							es wurde ein Account f&uuml;r Sie eingerichtet. Sie k&ouml;nnen sich mit folgenden Daten in unseren Shop einloggen.<br />\r\n							<br />\r\n							{if $COMMENTS} Anmerkungen: {$COMMENTS}<br />\r\n							{/if}<br />\r\n							<br />\r\n							Ihre Logindaten f&uuml;r unseren Shop:<br />\r\n							<br />\r\n							E-Mail: {$EMAIL}<br />\r\n							Ihr Passwort: {$PASSWORD}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r){/if}{$NAME},</strong><br />\r\n							<br />\r\n							es wurde ein Account f&uuml;r Sie eingerichtet. Sie k&ouml;nnen sich mit folgenden Daten in unseren Shop einloggen.<br />\r\n							<br />\r\n							{if $COMMENTS} Anmerkungen: {$COMMENTS}<br />\r\n							{/if}<br />\r\n							<br />\r\n							Ihre Logindaten f&uuml;r unseren Shop:<br />\r\n							<br />\r\n							E-Mail: {$EMAIL}<br />\r\n							Ihr Passwort: {$PASSWORD}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nes wurde ein Account für Sie eingerichtet. Sie können sich mit folgenden Daten in unseren Shop einloggen.\r\n\r\n{if $COMMENTS}Anmerkungen: {$COMMENTS}{/if}\r\n\r\nIhre Logindaten für unseren Shop:\r\n\r\nE-Mail: {$EMAIL}\r\n\r\nIhr Passwort: {$PASSWORD}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nes wurde ein Account für Sie eingerichtet. Sie können sich mit folgenden Daten in unseren Shop einloggen.\r\n\r\n{if $COMMENTS}Anmerkungen: {$COMMENTS}{/if}\r\n\r\nIhre Logindaten für unseren Shop:\r\n\r\nE-Mail: {$EMAIL}\r\n\r\nIhr Passwort: {$PASSWORD}', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r){/if}{$NAME},</strong><br />\r\n							<br />\r\n							es wurde ein Account f&uuml;r Sie eingerichtet. Sie k&ouml;nnen sich mit folgenden Daten in unseren Shop einloggen.<br />\r\n							<br />\r\n							{if $COMMENTS} Anmerkungen: {$COMMENTS}<br />\r\n							{/if}<br />\r\n							<br />\r\n							Ihre Logindaten f&uuml;r unseren Shop:<br />\r\n							<br />\r\n							E-Mail: {$EMAIL}<br />\r\n							Ihr Passwort: {$PASSWORD}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nes wurde ein Account für Sie eingerichtet. Sie können sich mit folgenden Daten in unseren Shop einloggen.\r\n\r\n{if $COMMENTS}Anmerkungen: {$COMMENTS}{/if}\r\n\r\nIhre Logindaten für unseren Shop:\r\n\r\nE-Mail: {$EMAIL}\r\n\r\nIhr Passwort: {$PASSWORD}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(10, 1, 'admin/', 'gift_accepted', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							You have recently ordered a coupon in our online shop, which was not activated immediately for safety \r\n							reasons. This credit is now available for you. You can book your coupon and send it by e-mail. The \r\n							ordered coupon have a value of {$AMMOUNT}. \r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							You have recently ordered a coupon in our online shop, which was not activated immediately for safety \r\n							reasons. This credit is now available for you. You can book your coupon and send it by e-mail. The \r\n							ordered coupon have a value of {$AMMOUNT}. \r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nYou have recently ordered a coupon in our online shop, which was not activated immediately for safety reasons.\r\nThis credit is now available for you. You can book your coupon and send it by e-mail. The ordered coupon have a value of {$AMMOUNT}.', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nYou have recently ordered a coupon in our online shop, which was not activated immediately for safety reasons.\r\nThis credit is now available for you. You can book your coupon and send it by e-mail. The ordered coupon have a value of {$AMMOUNT}.', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							You have recently ordered a coupon in our online shop, which was not activated immediately for safety \r\n							reasons. This credit is now available for you. You can book your coupon and send it by e-mail. The \r\n							ordered coupon have a value of {$AMMOUNT}. \r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\r\n\r\nYou have recently ordered a coupon in our online shop, which was not activated immediately for safety reasons.\r\nThis credit is now available for you. You can book your coupon and send it by e-mail. The ordered coupon have a value of {$AMMOUNT}.');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(10, 2, 'admin/', 'gift_accepted', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							Sie haben k&uuml;rzlich in unserem Online-Shop einen Gutschein bestellt, welcher aus Sicherheitsgr&uuml;nden nicht sofort freigeschaltet wurde. \r\n							Dieses Guthaben steht Ihnen nun zur Verf&uuml;gung. Sie k&ouml;nnen Ihren Gutschein verbuchen und per E-Mail versenden. \r\n							Der von Ihnen bestellte Gutschein hat einen Wert von {$AMMOUNT}.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							Sie haben k&uuml;rzlich in unserem Online-Shop einen Gutschein bestellt, welcher aus Sicherheitsgr&uuml;nden nicht sofort freigeschaltet wurde. \r\n							Dieses Guthaben steht Ihnen nun zur Verf&uuml;gung. Sie k&ouml;nnen Ihren Gutschein verbuchen und per E-Mail versenden. \r\n							Der von Ihnen bestellte Gutschein hat einen Wert von {$AMMOUNT}.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nSie haben kürzlich in unserem Online-Shop einen Gutschein bestellt, welcher aus Sicherheitsgründen nicht sofort freigeschaltet wurde.\r\nDieses Guthaben steht Ihnen nun zur Verfügung. Sie können Ihren Gutschein verbuchen und per E-Mail versenden. Der von Ihnen bestellte Gutschein hat einen Wert von {$AMMOUNT}.', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nSie haben kürzlich in unserem Online-Shop einen Gutschein bestellt, welcher aus Sicherheitsgründen nicht sofort freigeschaltet wurde.\r\nDieses Guthaben steht Ihnen nun zur Verfügung. Sie können Ihren Gutschein verbuchen und per E-Mail versenden. Der von Ihnen bestellte Gutschein hat einen Wert von {$AMMOUNT}.', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME}, </strong><br />\r\n							<br />\r\n							Sie haben k&uuml;rzlich in unserem Online-Shop einen Gutschein bestellt, welcher aus Sicherheitsgr&uuml;nden nicht sofort freigeschaltet wurde. \r\n							Dieses Guthaben steht Ihnen nun zur Verf&uuml;gung. Sie k&ouml;nnen Ihren Gutschein verbuchen und per E-Mail versenden. \r\n							Der von Ihnen bestellte Gutschein hat einen Wert von {$AMMOUNT}.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\nSie haben kürzlich in unserem Online-Shop einen Gutschein bestellt, welcher aus Sicherheitsgründen nicht sofort freigeschaltet wurde.\r\nDieses Guthaben steht Ihnen nun zur Verfügung. Sie können Ihren Gutschein verbuchen und per E-Mail versenden. Der von Ihnen bestellte Gutschein hat einen Wert von {$AMMOUNT}.');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(11, 1, 'admin/', 'send_coupon', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							{$MESSAGE}<br />\r\n							<br />\r\n							You can redeem your voucher with your order. Enter your voucher number in the Voucher box.<br />\r\n							<br />\r\n							Your voucher number is: <strong>{$COUPON_ID}</strong><br />\r\n							<br />\r\n							Please make sure to keep your voucher number safe, as it is the only way you can benefit from this offer the next time you visit us under <a href="{$WEBSITE}">{$WEBSITE}</a>.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							{$MESSAGE}<br />\r\n							<br />\r\n							You can redeem your voucher with your order. Enter your voucher number in the Voucher box.<br />\r\n							<br />\r\n							Your voucher number is: <strong>{$COUPON_ID}</strong><br />\r\n							<br />\r\n							Please make sure to keep your voucher number safe, as it is the only way you can benefit from this offer the next time you visit us under <a href="{$WEBSITE}">{$WEBSITE}</a>.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{$MESSAGE}\r\n\r\nYou can redeem your voucher with your order. Enter your voucher number in the Voucher box.\r\n\r\nYour voucher number is: {$COUPON_ID}\r\n\r\nPlease make sure to keep your voucher number safe, as it is the only way you can benefit from this offer the next time you visit us under {$WEBSITE}.', '{$MESSAGE}\r\n\r\nYou can redeem your voucher with your order. Enter your voucher number in the Voucher box.\r\n\r\nYour voucher number is: {$COUPON_ID}\r\n\r\nPlease make sure to keep your voucher number safe, as it is the only way you can benefit from this offer the next time you visit us under {$WEBSITE}.', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							{$MESSAGE}<br />\r\n							<br />\r\n							You can redeem your voucher with your order. Enter your voucher number in the Voucher box.<br />\r\n							<br />\r\n							Your voucher number is: <strong>{$COUPON_ID}</strong><br />\r\n							<br />\r\n							Please make sure to keep your voucher number safe, as it is the only way you can benefit from this offer the next time you visit us under <a href="{$WEBSITE}">{$WEBSITE}</a>.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{$MESSAGE}\r\n\r\nYou can redeem your voucher with your order. Enter your voucher number in the Voucher box.\r\n\r\nYour voucher number is: {$COUPON_ID}\r\n\r\nPlease make sure to keep your voucher number safe, as it is the only way you can benefit from this offer the next time you visit us under {$WEBSITE}.');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(11, 2, 'admin/', 'send_coupon', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$MESSAGE}<br />\r\n							<br />\r\n							Sie k&ouml;nnen den Gutschein bei Ihrer Bestellung einl&ouml;sen. Geben Sie daf&uuml;r Ihre Gutschein-Nummer in das Feld Gutscheine ein.<br />\r\n							<br />\r\n							Ihre Gutschein-Nummer lautet: <strong>{$COUPON_ID}</strong><br />\r\n							<br />\r\n							Heben Sie Ihre Gutschein-Nummer gut auf, nur so k&ouml;nnen Sie von diesem Angebot profitieren, wenn Sie uns das n&auml;chste Mal unter <a href="{$WEBSITE}">{$WEBSITE}</a> besuchen.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$MESSAGE}<br />\r\n							<br />\r\n							Sie k&ouml;nnen den Gutschein bei Ihrer Bestellung einl&ouml;sen. Geben Sie daf&uuml;r Ihre Gutschein-Nummer in das Feld Gutscheine ein.<br />\r\n							<br />\r\n							Ihre Gutschein-Nummer lautet: <strong>{$COUPON_ID}</strong><br />\r\n							<br />\r\n							Heben Sie Ihre Gutschein-Nummer gut auf, nur so k&ouml;nnen Sie von diesem Angebot profitieren, wenn Sie uns das n&auml;chste Mal unter <a href="{$WEBSITE}">{$WEBSITE}</a> besuchen.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{$MESSAGE}\r\n\r\nSie können den Gutschein bei Ihrer Bestellung einlösen. Geben Sie dafür Ihre Gutschein-Nummer in das Feld Gutscheine ein.\r\n\r\nIhre Gutschein-Nummer lautet: {$COUPON_ID}\r\n\r\nHeben Sie Ihre Gutschein-Nummer gut auf, nur so können Sie von diesem Angebot profitieren, wenn Sie uns das nächste Mal unter {$WEBSITE} besuchen.\r\n', '{$MESSAGE}\r\n\r\nSie können den Gutschein bei Ihrer Bestellung einlösen. Geben Sie dafür Ihre Gutschein-Nummer in das Feld Gutscheine ein.\r\n\r\nIhre Gutschein-Nummer lautet: {$COUPON_ID}\r\n\r\nHeben Sie Ihre Gutschein-Nummer gut auf, nur so können Sie von diesem Angebot profitieren, wenn Sie uns das nächste Mal unter {$WEBSITE} besuchen.\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$MESSAGE}<br />\r\n							<br />\r\n							Sie k&ouml;nnen den Gutschein bei Ihrer Bestellung einl&ouml;sen. Geben Sie daf&uuml;r Ihre Gutschein-Nummer in das Feld Gutscheine ein.<br />\r\n							<br />\r\n							Ihre Gutschein-Nummer lautet: <strong>{$COUPON_ID}</strong><br />\r\n							<br />\r\n							Heben Sie Ihre Gutschein-Nummer gut auf, nur so k&ouml;nnen Sie von diesem Angebot profitieren, wenn Sie uns das n&auml;chste Mal unter <a href="{$WEBSITE}">{$WEBSITE}</a> besuchen.\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{$MESSAGE}\r\n\r\nSie können den Gutschein bei Ihrer Bestellung einlösen. Geben Sie dafür Ihre Gutschein-Nummer in das Feld Gutscheine ein.\r\n\r\nIhre Gutschein-Nummer lautet: {$COUPON_ID}\r\n\r\nHeben Sie Ihre Gutschein-Nummer gut auf, nur so können Sie von diesem Angebot profitieren, wenn Sie uns das nächste Mal unter {$WEBSITE} besuchen.\r\n');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(12, 1, 'admin/', 'send_gift', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$MESSAGE}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Voucher value: {$AMMOUNT}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">In order to post your voucher, click on the link below. To be safe, please write down your personal voucher code. Your voucher code is: {$GIFT_ID}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><a href="{$GIFT_LINK}">{$GIFT_LINK}</a></span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Should there be any unexpected problems posting the voucher, please visit our website <a href="{$WEBSITE}">{$WEBSITE}</a> and enter the voucher code manually.</span></span>\r\n						</p>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$MESSAGE}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Voucher value: {$AMMOUNT}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">In order to post your voucher, click on the link below. To be safe, please write down your personal voucher code. Your voucher code is: {$GIFT_ID}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><a href="{$GIFT_LINK}">{$GIFT_LINK}</a></span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Should there be any unexpected problems posting the voucher, please visit our website <a href="{$WEBSITE}">{$WEBSITE}</a> and enter the voucher code manually.</span></span>\r\n						</p>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{$MESSAGE}\r\n\r\nVoucher value: {$AMMOUNT}\r\n\r\nIn order to post your voucher, click on the link below. To be safe, please write down your personal voucher code. \r\n\r\nYour voucher code is: {$GIFT_ID} \r\n{$GIFT_LINK}\r\n\r\nShould there be any unexpected problems posting the voucher, please visit our website {$WEBSITE} and enter the voucher code manually.', '{$MESSAGE}\r\n\r\nVoucher value: {$AMMOUNT}\r\n\r\nIn order to post your voucher, click on the link below. To be safe, please write down your personal voucher code. \r\n\r\nYour voucher code is: {$GIFT_ID} \r\n{$GIFT_LINK}\r\n\r\nShould there be any unexpected problems posting the voucher, please visit our website {$WEBSITE} and enter the voucher code manually.', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$MESSAGE}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Voucher value: {$AMMOUNT}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">In order to post your voucher, click on the link below. To be safe, please write down your personal voucher code. Your voucher code is: {$GIFT_ID}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><a href="{$GIFT_LINK}">{$GIFT_LINK}</a></span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Should there be any unexpected problems posting the voucher, please visit our website <a href="{$WEBSITE}">{$WEBSITE}</a> and enter the voucher code manually.</span></span>\r\n						</p>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{$MESSAGE}\r\n\r\nVoucher value: {$AMMOUNT}\r\n\r\nIn order to post your voucher, click on the link below. To be safe, please write down your personal voucher code. \r\n\r\nYour voucher code is: {$GIFT_ID} \r\n{$GIFT_LINK}\r\n\r\nShould there be any unexpected problems posting the voucher, please visit our website {$WEBSITE} and enter the voucher code manually.');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(12, 2, 'admin/', 'send_gift', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$MESSAGE}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Gutscheinwert: {$AMMOUNT}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Um Ihren Gutschein zu verbuchen, klicken Sie auf den unten stehenden Link. Bitte notieren Sie sich zur Sicherheit Ihren pers&ouml;nlichen Gutschein-Code. Ihr Gutschein-Code lautet: {$GIFT_ID}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><a href="{$GIFT_LINK}">{$GIFT_LINK}</a></span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Falls es wider Erwarten zu Problemen beim Verbuchen kommen sollte, besuchen Sie unsere Webseite <a href="{$WEBSITE}">{$WEBSITE}</a> und geben den Gutschein-Code bitte manuell ein.</span></span>\r\n						</p>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$MESSAGE}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Gutscheinwert: {$AMMOUNT}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Um Ihren Gutschein zu verbuchen, klicken Sie auf den unten stehenden Link. Bitte notieren Sie sich zur Sicherheit Ihren pers&ouml;nlichen Gutschein-Code. Ihr Gutschein-Code lautet: {$GIFT_ID}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><a href="{$GIFT_LINK}">{$GIFT_LINK}</a></span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Falls es wider Erwarten zu Problemen beim Verbuchen kommen sollte, besuchen Sie unsere Webseite <a href="{$WEBSITE}">{$WEBSITE}</a> und geben den Gutschein-Code bitte manuell ein.</span></span>\r\n						</p>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{$MESSAGE}\r\n\r\nGutscheinwert: {$AMMOUNT}\r\n\r\nUm Ihren Gutschein zu verbuchen, klicken Sie auf den unten stehenden Link. Bitte notieren Sie sich zur Sicherheit Ihren persönlichen Gutschein-Code. \r\n\r\nIhr Gutschein-Code lautet: {$GIFT_ID} \r\n{$GIFT_LINK}\r\n\r\nFalls es wider Erwarten zu Problemen beim Verbuchen kommen sollte, besuchen Sie unsere Webseite {$WEBSITE} und geben den Gutschein-Code bitte manuell ein.', '{$MESSAGE}\r\n\r\nGutscheinwert: {$AMMOUNT}\r\n\r\nUm Ihren Gutschein zu verbuchen, klicken Sie auf den unten stehenden Link. Bitte notieren Sie sich zur Sicherheit Ihren persönlichen Gutschein-Code. \r\n\r\nIhr Gutschein-Code lautet: {$GIFT_ID} \r\n{$GIFT_LINK}\r\n\r\nFalls es wider Erwarten zu Problemen beim Verbuchen kommen sollte, besuchen Sie unsere Webseite {$WEBSITE} und geben den Gutschein-Code bitte manuell ein.', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$MESSAGE}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Gutscheinwert: {$AMMOUNT}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Um Ihren Gutschein zu verbuchen, klicken Sie auf den unten stehenden Link. Bitte notieren Sie sich zur Sicherheit Ihren pers&ouml;nlichen Gutschein-Code. Ihr Gutschein-Code lautet: {$GIFT_ID}</span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><a href="{$GIFT_LINK}">{$GIFT_LINK}</a></span></span>\r\n						</p>\r\n\r\n						<p>\r\n							<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">Falls es wider Erwarten zu Problemen beim Verbuchen kommen sollte, besuchen Sie unsere Webseite <a href="{$WEBSITE}">{$WEBSITE}</a> und geben den Gutschein-Code bitte manuell ein.</span></span>\r\n						</p>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{$MESSAGE}\r\n\r\nGutscheinwert: {$AMMOUNT}\r\n\r\nUm Ihren Gutschein zu verbuchen, klicken Sie auf den unten stehenden Link. Bitte notieren Sie sich zur Sicherheit Ihren persönlichen Gutschein-Code. \r\n\r\nIhr Gutschein-Code lautet: {$GIFT_ID} \r\n{$GIFT_LINK}\r\n\r\nFalls es wider Erwarten zu Problemen beim Verbuchen kommen sollte, besuchen Sie unsere Webseite {$WEBSITE} und geben den Gutschein-Code bitte manuell ein.');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(13, 1, 'admin/', 'delete_account_mail', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Dear admin, </strong><br />\r\n							<br />\r\n							the customer {$CUSTOMER} would like to delete his account.<br />\r\n							{if $NOTIFY_COMMENTS}<br />\r\n							<br />\r\n							Comments:<br />\r\n							{$NOTIFY_COMMENTS}<br />\r\n							{/if}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Dear admin, </strong><br />\r\n							<br />\r\n							the customer {$CUSTOMER} would like to delete his account.<br />\r\n							{if $NOTIFY_COMMENTS}<br />\r\n							<br />\r\n							Comments:<br />\r\n							{$NOTIFY_COMMENTS}<br />\r\n							{/if}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear admin,\r\n\r\nthe customer {$CUSTOMER} would like to delete his account.\r\n{if $NOTIFY_COMMENTS}\r\n\r\nComments:\r\n{$NOTIFY_COMMENTS}\r\n{/if}', 'Dear admin,\r\n\r\nthe customer {$CUSTOMER} would like to delete his account.\r\n{if $NOTIFY_COMMENTS}\r\n\r\nComments:\r\n{$NOTIFY_COMMENTS}\r\n{/if}', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Dear admin, </strong><br />\r\n							<br />\r\n							the customer {$CUSTOMER} would like to delete his account.<br />\r\n							{if $NOTIFY_COMMENTS}<br />\r\n							<br />\r\n							Comments:<br />\r\n							{$NOTIFY_COMMENTS}<br />\r\n							{/if}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Dear admin,\r\n\r\nthe customer {$CUSTOMER} would like to delete his account.\r\n{if $NOTIFY_COMMENTS}\r\n\r\nComments:\r\n{$NOTIFY_COMMENTS}\r\n{/if}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(13, 2, 'admin/', 'delete_account_mail', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Sehr geehrter Admin, </strong><br />\r\n							<br />\r\n							der Kunde {$CUSTOMER} m&ouml;chte sein Konto l&ouml;schen.<br />\r\n							{if $NOTIFY_COMMENTS}<br />\r\n							<br />\r\n							Anmerkungen:<br />\r\n							{$NOTIFY_COMMENTS}<br />\r\n							{/if}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Sehr geehrter Admin, </strong><br />\r\n							<br />\r\n							der Kunde {$CUSTOMER} m&ouml;chte sein Konto l&ouml;schen.<br />\r\n							{if $NOTIFY_COMMENTS}<br />\r\n							<br />\r\n							Anmerkungen:<br />\r\n							{$NOTIFY_COMMENTS}<br />\r\n							{/if}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr geehrter Admin,\r\n\r\nder Kunde {$CUSTOMER} möchte sein Konto löschen.\r\n{if $NOTIFY_COMMENTS}\r\n\r\nAnmerkungen:\r\n{$NOTIFY_COMMENTS}\r\n{/if}\r\n', 'Sehr geehrter Admin,\r\n\r\nder Kunde {$CUSTOMER} möchte sein Konto löschen.\r\n{if $NOTIFY_COMMENTS}\r\n\r\nAnmerkungen:\r\n{$NOTIFY_COMMENTS}\r\n{/if}\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td>\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>Sehr geehrter Admin, </strong><br />\r\n							<br />\r\n							der Kunde {$CUSTOMER} m&ouml;chte sein Konto l&ouml;schen.<br />\r\n							{if $NOTIFY_COMMENTS}<br />\r\n							<br />\r\n							Anmerkungen:<br />\r\n							{$NOTIFY_COMMENTS}<br />\r\n							{/if}\r\n						</span></span>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr geehrter Admin,\r\n\r\nder Kunde {$CUSTOMER} möchte sein Konto löschen.\r\n{if $NOTIFY_COMMENTS}\r\n\r\nAnmerkungen:\r\n{$NOTIFY_COMMENTS}\r\n{/if}\r\n');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(14, 1, 'admin/', 'send_paylink', '<meta charset="UTF-8" />\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\n\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\n			<tbody>\n				<tr>\n					<td>\n						{if $gm_logo_mail}\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\n						{/if}\n					</td>\n				</tr>\n				<tr>\n					<td>\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\n							<br />\n							to pay your order with order number {$ORDER_NR} by PayPal, please follow this link:<br />\n							<br />\n							<a href="{$PAY_LINK}">{$PAY_LINK}</a><br />\n							<br />\n							If there are questions about your order, please answer this mail.\n						</span></span>\n					</td>\n				</tr>\n			</tbody>\n		</table>\n		<br />\n		&nbsp;\n	</div>\n\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\n		<br /><br />\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\n		<br /><br />\n	</div>\n</div>\n', '<meta charset="UTF-8" />\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\n\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\n			<tbody>\n				<tr>\n					<td>\n						{if $gm_logo_mail}\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\n						{/if}\n					</td>\n				</tr>\n				<tr>\n					<td>\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\n							<br />\n							to pay your order with order number {$ORDER_NR} by PayPal, please follow this link:<br />\n							<br />\n							<a href="{$PAY_LINK}">{$PAY_LINK}</a><br />\n							<br />\n							If there are questions about your order, please answer this mail.\n						</span></span>\n					</td>\n				</tr>\n			</tbody>\n		</table>\n		<br />\n		&nbsp;\n	</div>\n\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\n		<br /><br />\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\n		<br /><br />\n	</div>\n</div>\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nto pay your order with order number {$ORDER_NR} by PayPal, please follow this link:\n\n{$PAY_LINK}\n\nIf there are questions about your order, please answer this mail.', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nto pay your order with order number {$ORDER_NR} by PayPal, please follow this link:\n\n{$PAY_LINK}\n\nIf there are questions about your order, please answer this mail.', '<meta charset="UTF-8" />\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\n\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\n			<tbody>\n				<tr>\n					<td>\n						{if $gm_logo_mail}\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\n						{/if}\n					</td>\n				</tr>\n				<tr>\n					<td>\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\n							<strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\n							<br />\n							to pay your order with order number {$ORDER_NR} by PayPal, please follow this link:<br />\n							<br />\n							<a href="{$PAY_LINK}">{$PAY_LINK}</a><br />\n							<br />\n							If there are questions about your order, please answer this mail.\n						</span></span>\n					</td>\n				</tr>\n			</tbody>\n		</table>\n		<br />\n		&nbsp;\n	</div>\n\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\n		<br /><br />\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\n		<br /><br />\n	</div>\n</div>\n', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nto pay your order with order number {$ORDER_NR} by PayPal, please follow this link:\n\n{$PAY_LINK}\n\nIf there are questions about your order, please answer this mail.');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(14, 2, 'admin/', 'send_paylink', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td><span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</strong><br />\r\n				<br />\r\n				um Ihre Bestellung mit der Bestellnummer {$ORDER_NR} per PayPal zu bezahlen, folgen Sie bitte diesem Link:<br />\r\n				<br />\r\n				<a href="{$PAY_LINK}">{$PAY_LINK}</a><br />\r\n				<br />\r\n				Bei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail. </span></span></td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td><span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</strong><br />\r\n				<br />\r\n				um Ihre Bestellung mit der Bestellnummer {$ORDER_NR} per PayPal zu bezahlen, folgen Sie bitte diesem Link:<br />\r\n				<br />\r\n				<a href="{$PAY_LINK}">{$PAY_LINK}</a><br />\r\n				<br />\r\n				Bei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail. </span></span></td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\num Ihre Bestellung mit der Bestellnummer {$ORDER_NR} per PayPal zu\r\nbezahlen, folgen Sie bitte diesem Link:\r\n\r\n{$PAY_LINK}\r\n\r\nBei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail.', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\num Ihre Bestellung mit der Bestellnummer {$ORDER_NR} per PayPal zu\r\nbezahlen, folgen Sie bitte diesem Link:\r\n\r\n{$PAY_LINK}\r\n\r\nBei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail.', '<meta charset="UTF-8" />\r\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $gm_logo_mail}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td><span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;"><strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</strong><br />\r\n				<br />\r\n				um Ihre Bestellung mit der Bestellnummer {$ORDER_NR} per PayPal zu bezahlen, folgen Sie bitte diesem Link:<br />\r\n				<br />\r\n				<a href="{$PAY_LINK}">{$PAY_LINK}</a><br />\r\n				<br />\r\n				Bei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail. </span></span></td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\r\n\r\num Ihre Bestellung mit der Bestellnummer {$ORDER_NR} per PayPal zu\r\nbezahlen, folgen Sie bitte diesem Link:\r\n\r\n{$PAY_LINK}\r\n\r\nBei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail.');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(15, 1, '', 'withdrawal_confirmation', '{load_language_text section="withdrawal"}\r\n<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $LOGO}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$LOGO}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td style="font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>{$txt.customer_greeting}</strong><br />\r\n							<br />\r\n							{$txt.process_cancellation}\r\n						</span></span>\r\n\r\n						<div style="font-style: italic">\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$txt.withdrawal_to}:\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$smarty.const.COMPANY_NAME}<br />\r\n									{$smarty.const.TRADER_FIRSTNAME} {$smarty.const.TRADER_NAME}<br />\r\n									{$smarty.const.TRADER_STREET} {$smarty.const.TRADER_STREET_NUMBER}<br />\r\n									{$smarty.const.TRADER_ZIPCODE} {$smarty.const.TRADER_LOCATION}<br />\r\n									{$smarty.const.STORE_COUNTRY_NAME}<br />\r\n									<br />\r\n									{if $smarty.const.TRADER_TEL != ''''}{$txt.phone}: {$smarty.const.TRADER_TEL}<br />{/if} \r\n									{if $smarty.const.TRADER_FAX != ''''}{$txt.fax}: {$smarty.const.TRADER_FAX}<br />{/if} \r\n									{if $smarty.const.STORE_OWNER_EMAIL_ADDRESS != ''''}{$txt.mail}: <a href="mailto:{$smarty.const.STORE_OWNER_EMAIL_ADDRESS}">{$smarty.const.STORE_OWNER_EMAIL_ADDRESS}</a><br />{/if}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$txt.withdrawal_yourData}:\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$CUSTOMER_GENDER}<br />\r\n									{$CUSTOMER_NAME}<br />\r\n									{$CUSTOMER_STREET_ADDRESS}<br />\r\n									{$CUSTOMER_POSTCODE} {$CUSTOMER_CITY}<br />\r\n									{$CUSTOMER_COUNTRY}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{if $ORDER_DATE}{$txt.order_date}: {$ORDER_DATE}<br />\r\n									{/if} {if $DELIVERY_DATE}{$txt.deliverydate_t}: {$DELIVERY_DATE}<br />\r\n									{/if} {$txt.withdrawal_date}: {$WITHDRAWAL_DATE}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$txt.withdrawal}:</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$WITHDRAWAL_CONTENT}</span></span>\r\n							</p>\r\n						</div>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{load_language_text section="withdrawal"}\r\n<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $LOGO}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$LOGO}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td style="font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>{$txt.customer_greeting}</strong><br />\r\n							<br />\r\n							{$txt.process_cancellation}\r\n						</span></span>\r\n\r\n						<div style="font-style: italic">\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$txt.withdrawal_to}:\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$smarty.const.COMPANY_NAME}<br />\r\n									{$smarty.const.TRADER_FIRSTNAME} {$smarty.const.TRADER_NAME}<br />\r\n									{$smarty.const.TRADER_STREET} {$smarty.const.TRADER_STREET_NUMBER}<br />\r\n									{$smarty.const.TRADER_ZIPCODE} {$smarty.const.TRADER_LOCATION}<br />\r\n									{$smarty.const.STORE_COUNTRY_NAME}<br />\r\n									<br />\r\n									{if $smarty.const.TRADER_TEL != ''''}{$txt.phone}: {$smarty.const.TRADER_TEL}<br />{/if} \r\n									{if $smarty.const.TRADER_FAX != ''''}{$txt.fax}: {$smarty.const.TRADER_FAX}<br />{/if} \r\n									{if $smarty.const.STORE_OWNER_EMAIL_ADDRESS != ''''}{$txt.mail}: <a href="mailto:{$smarty.const.STORE_OWNER_EMAIL_ADDRESS}">{$smarty.const.STORE_OWNER_EMAIL_ADDRESS}</a><br />{/if}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$txt.withdrawal_yourData}:\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$CUSTOMER_GENDER}<br />\r\n									{$CUSTOMER_NAME}<br />\r\n									{$CUSTOMER_STREET_ADDRESS}<br />\r\n									{$CUSTOMER_POSTCODE} {$CUSTOMER_CITY}<br />\r\n									{$CUSTOMER_COUNTRY}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{if $ORDER_DATE}{$txt.order_date}: {$ORDER_DATE}<br />\r\n									{/if} {if $DELIVERY_DATE}{$txt.deliverydate_t}: {$DELIVERY_DATE}<br />\r\n									{/if} {$txt.withdrawal_date}: {$WITHDRAWAL_DATE}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$txt.withdrawal}:</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$WITHDRAWAL_CONTENT}</span></span>\r\n							</p>\r\n						</div>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{load_language_text section="withdrawal"}\r\n{$txt.customer_greeting}\r\n\r\n{$txt.process_cancellation}\r\n\r\n{$txt.withdrawal_to}:\r\n\r\n{$smarty.const.COMPANY_NAME}\r\n{$smarty.const.TRADER_FIRSTNAME} {$smarty.const.TRADER_NAME}\r\n{$smarty.const.TRADER_STREET} {$smarty.const.TRADER_STREET_NUMBER}\r\n{$smarty.const.TRADER_ZIPCODE} {$smarty.const.TRADER_LOCATION}\r\n{$smarty.const.STORE_COUNTRY_NAME}\r\n\r\n{if $smarty.const.TRADER_TEL != ''''}{$txt.phone}: {$smarty.const.TRADER_TEL}{/if}\r\n\r\n{if $smarty.const.TRADER_FAX != ''''}{$txt.fax}: {$smarty.const.TRADER_FAX}{/if}\r\n\r\n{if $smarty.const.STORE_OWNER_EMAIL_ADDRESS != ''''}{$txt.mail}: {$smarty.const.STORE_OWNER_EMAIL_ADDRESS}{/if}\r\n\r\n\r\n\r\n{$txt.withdrawal_yourData}:\r\n\r\n{$CUSTOMER_GENDER}\r\n{$CUSTOMER_NAME}\r\n{$CUSTOMER_STREET_ADDRESS}\r\n{$CUSTOMER_POSTCODE} {$CUSTOMER_CITY}\r\n{$CUSTOMER_COUNTRY}\r\n\r\n{if $ORDER_DATE}{$txt.order_date}: {$ORDER_DATE}{/if}\r\n{if $DELIVERY_DATE}{$txt.deliverydate_t}: {$DELIVERY_DATE}{/if}\r\n\r\n{$txt.withdrawal_date}: {$WITHDRAWAL_DATE}\r\n\r\n{$txt.withdrawal}:\r\n{$WITHDRAWAL_CONTENT}\r\n\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '{load_language_text section="withdrawal"}\r\n{$txt.customer_greeting}\r\n\r\n{$txt.process_cancellation}\r\n\r\n{$txt.withdrawal_to}:\r\n\r\n{$smarty.const.COMPANY_NAME}\r\n{$smarty.const.TRADER_FIRSTNAME} {$smarty.const.TRADER_NAME}\r\n{$smarty.const.TRADER_STREET} {$smarty.const.TRADER_STREET_NUMBER}\r\n{$smarty.const.TRADER_ZIPCODE} {$smarty.const.TRADER_LOCATION}\r\n{$smarty.const.STORE_COUNTRY_NAME}\r\n\r\n{if $smarty.const.TRADER_TEL != ''''}{$txt.phone}: {$smarty.const.TRADER_TEL}{/if}\r\n\r\n{if $smarty.const.TRADER_FAX != ''''}{$txt.fax}: {$smarty.const.TRADER_FAX}{/if}\r\n\r\n{if $smarty.const.STORE_OWNER_EMAIL_ADDRESS != ''''}{$txt.mail}: {$smarty.const.STORE_OWNER_EMAIL_ADDRESS}{/if}\r\n\r\n\r\n\r\n{$txt.withdrawal_yourData}:\r\n\r\n{$CUSTOMER_GENDER}\r\n{$CUSTOMER_NAME}\r\n{$CUSTOMER_STREET_ADDRESS}\r\n{$CUSTOMER_POSTCODE} {$CUSTOMER_CITY}\r\n{$CUSTOMER_COUNTRY}\r\n\r\n{if $ORDER_DATE}{$txt.order_date}: {$ORDER_DATE}{/if}\r\n{if $DELIVERY_DATE}{$txt.deliverydate_t}: {$DELIVERY_DATE}{/if}\r\n\r\n{$txt.withdrawal_date}: {$WITHDRAWAL_DATE}\r\n\r\n{$txt.withdrawal}:\r\n{$WITHDRAWAL_CONTENT}\r\n\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '{load_language_text section="withdrawal"}\r\n<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $LOGO}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$LOGO}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td style="font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>{$txt.customer_greeting}</strong><br />\r\n							<br />\r\n							{$txt.process_cancellation}\r\n						</span></span>\r\n\r\n						<div style="font-style: italic">\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$txt.withdrawal_to}:\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$smarty.const.COMPANY_NAME}<br />\r\n									{$smarty.const.TRADER_FIRSTNAME} {$smarty.const.TRADER_NAME}<br />\r\n									{$smarty.const.TRADER_STREET} {$smarty.const.TRADER_STREET_NUMBER}<br />\r\n									{$smarty.const.TRADER_ZIPCODE} {$smarty.const.TRADER_LOCATION}<br />\r\n									{$smarty.const.STORE_COUNTRY_NAME}<br />\r\n									<br />\r\n									{if $smarty.const.TRADER_TEL != ''''}{$txt.phone}: {$smarty.const.TRADER_TEL}<br />{/if} \r\n									{if $smarty.const.TRADER_FAX != ''''}{$txt.fax}: {$smarty.const.TRADER_FAX}<br />{/if} \r\n									{if $smarty.const.STORE_OWNER_EMAIL_ADDRESS != ''''}{$txt.mail}: <a href="mailto:{$smarty.const.STORE_OWNER_EMAIL_ADDRESS}">{$smarty.const.STORE_OWNER_EMAIL_ADDRESS}</a><br />{/if}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$txt.withdrawal_yourData}:\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$CUSTOMER_GENDER}<br />\r\n									{$CUSTOMER_NAME}<br />\r\n									{$CUSTOMER_STREET_ADDRESS}<br />\r\n									{$CUSTOMER_POSTCODE} {$CUSTOMER_CITY}<br />\r\n									{$CUSTOMER_COUNTRY}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{if $ORDER_DATE}{$txt.order_date}: {$ORDER_DATE}<br />\r\n									{/if} {if $DELIVERY_DATE}{$txt.deliverydate_t}: {$DELIVERY_DATE}<br />\r\n									{/if} {$txt.withdrawal_date}: {$WITHDRAWAL_DATE}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$txt.withdrawal}:</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$WITHDRAWAL_CONTENT}</span></span>\r\n							</p>\r\n						</div>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{load_language_text section="withdrawal"}\r\n{$txt.customer_greeting}\r\n\r\n{$txt.process_cancellation}\r\n\r\n{$txt.withdrawal_to}:\r\n\r\n{$smarty.const.COMPANY_NAME}\r\n{$smarty.const.TRADER_FIRSTNAME} {$smarty.const.TRADER_NAME}\r\n{$smarty.const.TRADER_STREET} {$smarty.const.TRADER_STREET_NUMBER}\r\n{$smarty.const.TRADER_ZIPCODE} {$smarty.const.TRADER_LOCATION}\r\n{$smarty.const.STORE_COUNTRY_NAME}\r\n\r\n{if $smarty.const.TRADER_TEL != ''''}{$txt.phone}: {$smarty.const.TRADER_TEL}{/if}\r\n\r\n{if $smarty.const.TRADER_FAX != ''''}{$txt.fax}: {$smarty.const.TRADER_FAX}{/if}\r\n\r\n{if $smarty.const.STORE_OWNER_EMAIL_ADDRESS != ''''}{$txt.mail}: {$smarty.const.STORE_OWNER_EMAIL_ADDRESS}{/if}\r\n\r\n\r\n\r\n{$txt.withdrawal_yourData}:\r\n\r\n{$CUSTOMER_GENDER}\r\n{$CUSTOMER_NAME}\r\n{$CUSTOMER_STREET_ADDRESS}\r\n{$CUSTOMER_POSTCODE} {$CUSTOMER_CITY}\r\n{$CUSTOMER_COUNTRY}\r\n\r\n{if $ORDER_DATE}{$txt.order_date}: {$ORDER_DATE}{/if}\r\n{if $DELIVERY_DATE}{$txt.deliverydate_t}: {$DELIVERY_DATE}{/if}\r\n\r\n{$txt.withdrawal_date}: {$WITHDRAWAL_DATE}\r\n\r\n{$txt.withdrawal}:\r\n{$WITHDRAWAL_CONTENT}\r\n\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(15, 2, '', 'withdrawal_confirmation', '{load_language_text section="withdrawal"}\r\n<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $LOGO}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$LOGO}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td style="font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>{$txt.customer_greeting}</strong><br />\r\n							<br />\r\n							{$txt.process_cancellation}\r\n						</span></span>\r\n\r\n						<div style="font-style: italic">\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$txt.withdrawal_to}:\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$smarty.const.COMPANY_NAME}<br />\r\n									{$smarty.const.TRADER_FIRSTNAME} {$smarty.const.TRADER_NAME}<br />\r\n									{$smarty.const.TRADER_STREET} {$smarty.const.TRADER_STREET_NUMBER}<br />\r\n									{$smarty.const.TRADER_ZIPCODE} {$smarty.const.TRADER_LOCATION}<br />\r\n									{$smarty.const.STORE_COUNTRY_NAME}<br />\r\n									<br />\r\n									{if $smarty.const.TRADER_TEL != ''''}{$txt.phone}: {$smarty.const.TRADER_TEL}<br />{/if} \r\n									{if $smarty.const.TRADER_FAX != ''''}{$txt.fax}: {$smarty.const.TRADER_FAX}<br />{/if} \r\n									{if $smarty.const.STORE_OWNER_EMAIL_ADDRESS != ''''}{$txt.mail}: <a href="mailto:{$smarty.const.STORE_OWNER_EMAIL_ADDRESS}">{$smarty.const.STORE_OWNER_EMAIL_ADDRESS}</a><br />{/if}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$txt.withdrawal_yourData}:\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$CUSTOMER_GENDER}<br />\r\n									{$CUSTOMER_NAME}<br />\r\n									{$CUSTOMER_STREET_ADDRESS}<br />\r\n									{$CUSTOMER_POSTCODE} {$CUSTOMER_CITY}<br />\r\n									{$CUSTOMER_COUNTRY}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{if $ORDER_DATE}{$txt.order_date}: {$ORDER_DATE}<br />\r\n									{/if} {if $DELIVERY_DATE}{$txt.deliverydate_t}: {$DELIVERY_DATE}<br />\r\n									{/if} {$txt.withdrawal_date}: {$WITHDRAWAL_DATE}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$txt.withdrawal}:</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$WITHDRAWAL_CONTENT}</span></span>\r\n							</p>\r\n						</div>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{load_language_text section="withdrawal"}\r\n<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $LOGO}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$LOGO}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td style="font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>{$txt.customer_greeting}</strong><br />\r\n							<br />\r\n							{$txt.process_cancellation}\r\n						</span></span>\r\n\r\n						<div style="font-style: italic">\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$txt.withdrawal_to}:\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$smarty.const.COMPANY_NAME}<br />\r\n									{$smarty.const.TRADER_FIRSTNAME} {$smarty.const.TRADER_NAME}<br />\r\n									{$smarty.const.TRADER_STREET} {$smarty.const.TRADER_STREET_NUMBER}<br />\r\n									{$smarty.const.TRADER_ZIPCODE} {$smarty.const.TRADER_LOCATION}<br />\r\n									{$smarty.const.STORE_COUNTRY_NAME}<br />\r\n									<br />\r\n									{if $smarty.const.TRADER_TEL != ''''}{$txt.phone}: {$smarty.const.TRADER_TEL}<br />{/if} \r\n									{if $smarty.const.TRADER_FAX != ''''}{$txt.fax}: {$smarty.const.TRADER_FAX}<br />{/if} \r\n									{if $smarty.const.STORE_OWNER_EMAIL_ADDRESS != ''''}{$txt.mail}: <a href="mailto:{$smarty.const.STORE_OWNER_EMAIL_ADDRESS}">{$smarty.const.STORE_OWNER_EMAIL_ADDRESS}</a><br />{/if}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$txt.withdrawal_yourData}:\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$CUSTOMER_GENDER}<br />\r\n									{$CUSTOMER_NAME}<br />\r\n									{$CUSTOMER_STREET_ADDRESS}<br />\r\n									{$CUSTOMER_POSTCODE} {$CUSTOMER_CITY}<br />\r\n									{$CUSTOMER_COUNTRY}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{if $ORDER_DATE}{$txt.order_date}: {$ORDER_DATE}<br />\r\n									{/if} {if $DELIVERY_DATE}{$txt.deliverydate_t}: {$DELIVERY_DATE}<br />\r\n									{/if} {$txt.withdrawal_date}: {$WITHDRAWAL_DATE}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$txt.withdrawal}:</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$WITHDRAWAL_CONTENT}</span></span>\r\n							</p>\r\n						</div>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{load_language_text section="withdrawal"}\r\n{$txt.customer_greeting}\r\n\r\n{$txt.process_cancellation}\r\n\r\n{$txt.withdrawal_to}:\r\n\r\n{$smarty.const.COMPANY_NAME}\r\n{$smarty.const.TRADER_FIRSTNAME} {$smarty.const.TRADER_NAME}\r\n{$smarty.const.TRADER_STREET} {$smarty.const.TRADER_STREET_NUMBER}\r\n{$smarty.const.TRADER_ZIPCODE} {$smarty.const.TRADER_LOCATION}\r\n{$smarty.const.STORE_COUNTRY_NAME}\r\n\r\n{if $smarty.const.TRADER_TEL != ''''}{$txt.phone}: {$smarty.const.TRADER_TEL}{/if}\r\n\r\n{if $smarty.const.TRADER_FAX != ''''}{$txt.fax}: {$smarty.const.TRADER_FAX}{/if}\r\n\r\n{if $smarty.const.STORE_OWNER_EMAIL_ADDRESS != ''''}{$txt.mail}: {$smarty.const.STORE_OWNER_EMAIL_ADDRESS}{/if}\r\n\r\n\r\n\r\n{$txt.withdrawal_yourData}:\r\n\r\n{$CUSTOMER_GENDER}\r\n{$CUSTOMER_NAME}\r\n{$CUSTOMER_STREET_ADDRESS}\r\n{$CUSTOMER_POSTCODE} {$CUSTOMER_CITY}\r\n{$CUSTOMER_COUNTRY}\r\n\r\n{if $ORDER_DATE}{$txt.order_date}: {$ORDER_DATE}{/if}\r\n{if $DELIVERY_DATE}{$txt.deliverydate_t}: {$DELIVERY_DATE}{/if}\r\n\r\n{$txt.withdrawal_date}: {$WITHDRAWAL_DATE}\r\n\r\n{$txt.withdrawal}:\r\n{$WITHDRAWAL_CONTENT}\r\n\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '{load_language_text section="withdrawal"}\r\n{$txt.customer_greeting}\r\n\r\n{$txt.process_cancellation}\r\n\r\n{$txt.withdrawal_to}:\r\n\r\n{$smarty.const.COMPANY_NAME}\r\n{$smarty.const.TRADER_FIRSTNAME} {$smarty.const.TRADER_NAME}\r\n{$smarty.const.TRADER_STREET} {$smarty.const.TRADER_STREET_NUMBER}\r\n{$smarty.const.TRADER_ZIPCODE} {$smarty.const.TRADER_LOCATION}\r\n{$smarty.const.STORE_COUNTRY_NAME}\r\n\r\n{if $smarty.const.TRADER_TEL != ''''}{$txt.phone}: {$smarty.const.TRADER_TEL}{/if}\r\n\r\n{if $smarty.const.TRADER_FAX != ''''}{$txt.fax}: {$smarty.const.TRADER_FAX}{/if}\r\n\r\n{if $smarty.const.STORE_OWNER_EMAIL_ADDRESS != ''''}{$txt.mail}: {$smarty.const.STORE_OWNER_EMAIL_ADDRESS}{/if}\r\n\r\n\r\n\r\n{$txt.withdrawal_yourData}:\r\n\r\n{$CUSTOMER_GENDER}\r\n{$CUSTOMER_NAME}\r\n{$CUSTOMER_STREET_ADDRESS}\r\n{$CUSTOMER_POSTCODE} {$CUSTOMER_CITY}\r\n{$CUSTOMER_COUNTRY}\r\n\r\n{if $ORDER_DATE}{$txt.order_date}: {$ORDER_DATE}{/if}\r\n{if $DELIVERY_DATE}{$txt.deliverydate_t}: {$DELIVERY_DATE}{/if}\r\n\r\n{$txt.withdrawal_date}: {$WITHDRAWAL_DATE}\r\n\r\n{$txt.withdrawal}:\r\n{$WITHDRAWAL_CONTENT}\r\n\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '{load_language_text section="withdrawal"}\r\n<meta charset="UTF-8" />\r\n<div style="margin: 0 !important; padding: 0 !important; max-width: 9000px !important; font-family: arial, verdana, sans-serif; background-color: #e5e5e5; height: 100%">\r\n	<div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #999999; text-align: right;">&nbsp;</div>\r\n\r\n	<div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\r\n		<table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\r\n			<tbody>\r\n				<tr>\r\n					<td>\r\n						{if $LOGO}\r\n						<div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$LOGO}</div>\r\n						{/if}\r\n					</td>\r\n				</tr>\r\n				<tr>\r\n					<td style="font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px">\r\n						<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n							<strong>{$txt.customer_greeting}</strong><br />\r\n							<br />\r\n							{$txt.process_cancellation}\r\n						</span></span>\r\n\r\n						<div style="font-style: italic">\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$txt.withdrawal_to}:\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$smarty.const.COMPANY_NAME}<br />\r\n									{$smarty.const.TRADER_FIRSTNAME} {$smarty.const.TRADER_NAME}<br />\r\n									{$smarty.const.TRADER_STREET} {$smarty.const.TRADER_STREET_NUMBER}<br />\r\n									{$smarty.const.TRADER_ZIPCODE} {$smarty.const.TRADER_LOCATION}<br />\r\n									{$smarty.const.STORE_COUNTRY_NAME}<br />\r\n									<br />\r\n									{if $smarty.const.TRADER_TEL != ''''}{$txt.phone}: {$smarty.const.TRADER_TEL}<br />{/if} \r\n									{if $smarty.const.TRADER_FAX != ''''}{$txt.fax}: {$smarty.const.TRADER_FAX}<br />{/if} \r\n									{if $smarty.const.STORE_OWNER_EMAIL_ADDRESS != ''''}{$txt.mail}: <a href="mailto:{$smarty.const.STORE_OWNER_EMAIL_ADDRESS}">{$smarty.const.STORE_OWNER_EMAIL_ADDRESS}</a><br />{/if}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$txt.withdrawal_yourData}:\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{$CUSTOMER_GENDER}<br />\r\n									{$CUSTOMER_NAME}<br />\r\n									{$CUSTOMER_STREET_ADDRESS}<br />\r\n									{$CUSTOMER_POSTCODE} {$CUSTOMER_CITY}<br />\r\n									{$CUSTOMER_COUNTRY}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\r\n									{if $ORDER_DATE}{$txt.order_date}: {$ORDER_DATE}<br />\r\n									{/if} {if $DELIVERY_DATE}{$txt.deliverydate_t}: {$DELIVERY_DATE}<br />\r\n									{/if} {$txt.withdrawal_date}: {$WITHDRAWAL_DATE}\r\n								</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$txt.withdrawal}:</span></span>\r\n							</p>\r\n\r\n							<p>\r\n								<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$WITHDRAWAL_CONTENT}</span></span>\r\n							</p>\r\n						</div>\r\n					</td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		<br />\r\n		&nbsp;\r\n	</div>\r\n\r\n	<div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\r\n		<br /><br />\r\n		<span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\r\n		<br /><br />\r\n	</div>\r\n</div>\r\n', '{load_language_text section="withdrawal"}\r\n{$txt.customer_greeting}\r\n\r\n{$txt.process_cancellation}\r\n\r\n{$txt.withdrawal_to}:\r\n\r\n{$smarty.const.COMPANY_NAME}\r\n{$smarty.const.TRADER_FIRSTNAME} {$smarty.const.TRADER_NAME}\r\n{$smarty.const.TRADER_STREET} {$smarty.const.TRADER_STREET_NUMBER}\r\n{$smarty.const.TRADER_ZIPCODE} {$smarty.const.TRADER_LOCATION}\r\n{$smarty.const.STORE_COUNTRY_NAME}\r\n\r\n{if $smarty.const.TRADER_TEL != ''''}{$txt.phone}: {$smarty.const.TRADER_TEL}{/if}\r\n\r\n{if $smarty.const.TRADER_FAX != ''''}{$txt.fax}: {$smarty.const.TRADER_FAX}{/if}\r\n\r\n{if $smarty.const.STORE_OWNER_EMAIL_ADDRESS != ''''}{$txt.mail}: {$smarty.const.STORE_OWNER_EMAIL_ADDRESS}{/if}\r\n\r\n\r\n\r\n{$txt.withdrawal_yourData}:\r\n\r\n{$CUSTOMER_GENDER}\r\n{$CUSTOMER_NAME}\r\n{$CUSTOMER_STREET_ADDRESS}\r\n{$CUSTOMER_POSTCODE} {$CUSTOMER_CITY}\r\n{$CUSTOMER_COUNTRY}\r\n\r\n{if $ORDER_DATE}{$txt.order_date}: {$ORDER_DATE}{/if}\r\n{if $DELIVERY_DATE}{$txt.deliverydate_t}: {$DELIVERY_DATE}{/if}\r\n\r\n{$txt.withdrawal_date}: {$WITHDRAWAL_DATE}\r\n\r\n{$txt.withdrawal}:\r\n{$WITHDRAWAL_CONTENT}\r\n\r\n\r\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(16, 1, '', 'amazonadvpay_mail', '<meta charset="UTF-8" />\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\n  <div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; color: #999999; text-align: right;">&nbsp;</div>\n\n  <div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\n   <table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\n      <tbody>\n       <tr>\n          <td>\n            {if $gm_logo_mail}\n            <div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\n           {/if}\n         </td>\n       </tr>\n       <tr>\n          <td>\n            <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\n              Valued customer,<br>\n              Thank you very much for your order.<br>\n             Unfortunately Amazon Payments declined your payment.<br>\n              Please go to https://payments.amazon.co.uk/overview and update the payment\n              information for your order. Afterwards we will automatically request payment again\n              from Amazon Payments and you will receive a confirmation email.<br>\n             <br>\n              <br>\n              For reference:<br>\n              Order placed on {$ORDERDATE}<br>\n              Order ID {$ORDERS_ID}\n           </span></span>\n          </td>\n       </tr>\n     </tbody>\n    </table>\n    <br />\n    &nbsp;\n  </div>\n\n  <div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\n    <br /><br />\n    <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\n   <br /><br />\n  </div>\n</div>\n', '<meta charset="UTF-8" />\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\n <div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; color: #999999; text-align: right;">&nbsp;</div>\n\n  <div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\n   <table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\n      <tbody>\n       <tr>\n          <td>\n            {if $gm_logo_mail}\n            <div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\n           {/if}\n         </td>\n       </tr>\n       <tr>\n          <td>\n            <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\n              Sehr geehrte/r {$NAME},<br />\n             <br />\n              leider k&ouml;nnen wir Ihre Bestellung vom {$ORDERDATE}, Bestellnummer {$ORDERS_ID}, nicht ausf&uuml;hren, \n             da die Zahlung mit dem von Ihnen gew&auml;hlten Zahlungsmittel abgelehnt wurde. Bitte besuchen Sie \n             http://payments.amazon.de/ und w&auml;hlen Sie dort eine andere Zahlungsweise f&uuml;r diese Bestellung.\n              <br />\n              <br />\n            </span></span>\n          </td>\n       </tr>\n     </tbody>\n    </table>\n    <br />\n    &nbsp;\n  </div>\n\n  <div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\n    <br /><br />\n    <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\n   <br /><br />\n  </div>\n</div>\n', 'Valued customer,\n\nThank you very much for your order.\nUnfortunately Amazon Payments declined your payment.\nPlease go to https://payments.amazon.co.uk/overview and update the payment\ninformation for your order. Afterwards we will automatically request payment again\nfrom Amazon Payments and you will receive a confirmation email.\n\nKind regards,\n{$EMAIL_SIGNATURE_TEXT}\n\n\nFor reference:\nOrder placed on {$ORDERDATE}\nOrder ID {$ORDERS_ID}\n', 'Sehr geehrte/r {$NAME},\n\nleider können wir Ihre Bestellung vom {$ORDERDATE}, Bestellnummer {$ORDERS_ID}, nicht ausführen, da die Zahlung mit\ndem von Ihnen gewählten Zahlungsmittel abgelehnt wurde. Bitte besuchen Sie http://payments.amazon.de/ und wählen Sie\ndort eine andere Zahlungsweise für die Bestellung.\n\n{$EMAIL_SIGNATURE_TEXT}\n', '<meta charset="UTF-8" />\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\n <div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; color: #999999; text-align: right;">&nbsp;</div>\n\n  <div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\n   <table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\n      <tbody>\n       <tr>\n          <td>\n            {if $gm_logo_mail}\n            <div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\n           {/if}\n         </td>\n       </tr>\n       <tr>\n          <td>\n            <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\n              Valued customer,<br>\n              Thank you very much for your order.<br>\n             Unfortunately Amazon Payments declined your payment.<br>\n              Please go to https://payments.amazon.co.uk/overview and update the payment\n              information for your order. Afterwards we will automatically request payment again\n              from Amazon Payments and you will receive a confirmation email.<br>\n             <br>\n              <br>\n              For reference:<br>\n              Order placed on {$ORDERDATE}<br>\n              Order ID {$ORDERS_ID}\n           </span></span>\n          </td>\n       </tr>\n     </tbody>\n    </table>\n    <br />\n    &nbsp;\n  </div>\n\n  <div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\n    <br /><br />\n    <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\n   <br /><br />\n  </div>\n</div>\n', 'Valued customer,\n\nThank you very much for your order.\nUnfortunately Amazon Payments declined your payment.\nPlease go to https://payments.amazon.co.uk/overview and update the payment\ninformation for your order. Afterwards we will automatically request payment again\nfrom Amazon Payments and you will receive a confirmation email.\n\nKind regards,\n{$EMAIL_SIGNATURE_TEXT}\n\n\nFor reference:\nOrder placed on {$ORDERDATE}\nOrder ID {$ORDERS_ID}\n');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(16, 2, '', 'amazonadvpay_mail', '<meta charset="UTF-8" />\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\n  <div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; color: #999999; text-align: right;">&nbsp;</div>\n\n  <div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\n   <table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\n      <tbody>\n       <tr>\n          <td>\n            {if $gm_logo_mail}\n            <div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\n           {/if}\n         </td>\n       </tr>\n       <tr>\n          <td>\n            <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\n              Sehr geehrter Kunde,<br>\n              <br>\n              Vielen Dank für Ihre Bestellung.<br>\n              Leider wurde Ihre Bezahlung von Amazon Payments abgelehnt.<br>\n              Sie können unter https://payments.amazon.de/overview die Zahlungsinformationen für\n              Ihre Bestellung aktualisieren indem Sie eine andere Zahlungsweise auszuwählen oder\n              eine neue Zahlungsweise eingeben. Mit der neuen Zahlungsweise wird dann ein\n             erneuter Zahlungsversuch vorgenommen und Sie erhalten eine Bestätigungsemail.\n             <br>\n              <br>\n              Referenzdaten:<br>\n              Bestellung vom {$ORDERDATE}<br>\n             Bestellnummer {$ORDERS_ID}\n            </span></span>\n          </td>\n       </tr>\n     </tbody>\n    </table>\n    <br />\n    &nbsp;\n  </div>\n\n  <div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\n    <br /><br />\n    <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\n   <br /><br />\n  </div>\n</div>\n', '<meta charset="UTF-8" />\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\n <div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; color: #999999; text-align: right;">&nbsp;</div>\n\n  <div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\n   <table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\n      <tbody>\n       <tr>\n          <td>\n            {if $gm_logo_mail}\n            <div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\n           {/if}\n         </td>\n       </tr>\n       <tr>\n          <td>\n            <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\n              Sehr geehrte/r {$NAME},<br />\n             <br />\n              leider k&ouml;nnen wir Ihre Bestellung vom {$ORDERDATE}, Bestellnummer {$ORDERS_ID}, nicht ausf&uuml;hren, \n             da die Zahlung mit dem von Ihnen gew&auml;hlten Zahlungsmittel abgelehnt wurde. Bitte besuchen Sie \n             http://payments.amazon.de/ und w&auml;hlen Sie dort eine andere Zahlungsweise f&uuml;r diese Bestellung.\n              <br />\n              <br />\n            </span></span>\n          </td>\n       </tr>\n     </tbody>\n    </table>\n    <br />\n    &nbsp;\n  </div>\n\n  <div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\n    <br /><br />\n    <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\n   <br /><br />\n  </div>\n</div>\n', 'Sehr geehrter Kunde,\n\nVielen Dank für Ihre Bestellung.\nLeider wurde Ihre Bezahlung von Amazon Payments abgelehnt.\nSie können unter https://payments.amazon.de/overview die Zahlungsinformationen für\nIhre Bestellung aktualisieren indem Sie eine andere Zahlungsweise auszuwählen oder\neine neue Zahlungsweise eingeben. Mit der neuen Zahlungsweise wird dann ein\nerneuter Zahlungsversuch vorgenommen und Sie erhalten eine Bestätigungsemail.\n\n\nMit freundlichen Grüßen<br>\n{$EMAIL_SIGNATURE_TEXT}\n\n\nReferenzdaten:\nBestellung vom {$ORDERDATE}\nBestellnummer {$ORDERS_ID}\n', 'Sehr geehrte/r {$NAME},\n\nleider können wir Ihre Bestellung vom {$ORDERDATE}, Bestellnummer {$ORDERS_ID}, nicht ausführen, da die Zahlung mit\ndem von Ihnen gewählten Zahlungsmittel abgelehnt wurde. Bitte besuchen Sie http://payments.amazon.de/ und wählen Sie\ndort eine andere Zahlungsweise für die Bestellung.\n\n{$EMAIL_SIGNATURE_TEXT}\n', '<meta charset="UTF-8" />\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\n <div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; color: #999999; text-align: right;">&nbsp;</div>\n\n  <div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\n   <table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\n      <tbody>\n       <tr>\n          <td>\n            {if $gm_logo_mail}\n            <div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\n           {/if}\n         </td>\n       </tr>\n       <tr>\n          <td>\n            <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\n              Sehr geehrter Kunde,<br>\n              <br>\n              Vielen Dank für Ihre Bestellung.<br>\n              Leider wurde Ihre Bezahlung von Amazon Payments abgelehnt.<br>\n              Sie können unter https://payments.amazon.de/overview die Zahlungsinformationen für\n              Ihre Bestellung aktualisieren indem Sie eine andere Zahlungsweise auszuwählen oder\n              eine neue Zahlungsweise eingeben. Mit der neuen Zahlungsweise wird dann ein\n             erneuter Zahlungsversuch vorgenommen und Sie erhalten eine Bestätigungsemail.\n             <br>\n              <br>\n              Referenzdaten:<br>\n              Bestellung vom {$ORDERDATE}<br>\n             Bestellnummer {$ORDERS_ID}\n            </span></span>\n          </td>\n       </tr>\n     </tbody>\n    </table>\n    <br />\n    &nbsp;\n  </div>\n\n  <div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\n    <br /><br />\n    <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\n   <br /><br />\n  </div>\n</div>\n', 'Sehr geehrter Kunde,\n\nVielen Dank für Ihre Bestellung.\nLeider wurde Ihre Bezahlung von Amazon Payments abgelehnt.\nSie können unter https://payments.amazon.de/overview die Zahlungsinformationen für\nIhre Bestellung aktualisieren indem Sie eine andere Zahlungsweise auszuwählen oder\neine neue Zahlungsweise eingeben. Mit der neuen Zahlungsweise wird dann ein\nerneuter Zahlungsversuch vorgenommen und Sie erhalten eine Bestätigungsemail.\n\n\nMit freundlichen Grüßen<br>\n{$EMAIL_SIGNATURE_TEXT}\n\n\nReferenzdaten:\nBestellung vom {$ORDERDATE}\nBestellnummer {$ORDERS_ID}\n');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(17, 1, '', 'amazonadvpay_mail_hard', '<meta charset="UTF-8" />\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\n <div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; color: #999999; text-align: right;">&nbsp;</div>\n\n  <div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\n   <table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\n      <tbody>\n       <tr>\n          <td>\n            {if $gm_logo_mail}\n            <div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\n           {/if}\n         </td>\n       </tr>\n       <tr>\n          <td>\n            <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\n              Valued customer,<br>\n              Unfortunately Amazon Payments declined the payment for your order in our online\n             shop. Please contact us.<br>\n              <br>\n              <br>\n              For reference:<br>\n              Order placed on {$ORDERDATE}<br>\n              Order ID {$ORDERS_ID}\n           </span></span>\n          </td>\n       </tr>\n     </tbody>\n    </table>\n    <br />\n    &nbsp;\n  </div>\n\n  <div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\n    <br /><br />\n    <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\n   <br /><br />\n  </div>\n</div>\n', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n  <tbody>\n   <tr>\n      <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n       <div align="right">{if $gm_logo_mail}{$gm_logo_mail}{/if}</div>\n     </td>\n   </tr>\n   <tr>\n      <td>\n        Valued customer,<br>\n        Unfortunately Amazon Payments declined the payment for your order in our online\n       shop. Please contact us.<br>\n        <br>\n        Kind regards,<br>\n       <br>\n        {$EMAIL_SIGNATURE_HTML}\n       <br>\n        <br>\n        For reference:<br>\n        Order placed on {$ORDERDATE}<br>\n        Order ID {$ORDERS_ID}\n     </td>\n   </tr>\n </tbody>\n</table>\n<br />\n<br />\n', 'Valued customer,\n\nUnfortunately Amazon Payments declined the payment for your order in our online\nshop. Please contact us.\n\nKind regards,\n\n{$EMAIL_SIGNATURE_TEXT}\n\n\nFor reference:\nOrder placed on {$ORDERDATE}\nOrder ID {$ORDERS_ID}\n', 'Valued customer,\n\nUnfortunately Amazon Payments declined the payment for your order in our online\nshop. Please contact us.\n\nKind regards,\n\n{$EMAIL_SIGNATURE_HTML}\n\n\nFor reference:\nOrder placed on {$ORDERDATE}\nOrder ID {$ORDERS_ID}\n', '<meta charset="UTF-8" />\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\n <div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; color: #999999; text-align: right;">&nbsp;</div>\n\n  <div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\n   <table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\n      <tbody>\n       <tr>\n          <td>\n            {if $gm_logo_mail}\n            <div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\n           {/if}\n         </td>\n       </tr>\n       <tr>\n          <td>\n            <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\n              Valued customer,<br>\n              Unfortunately Amazon Payments declined the payment for your order in our online\n             shop. Please contact us.<br>\n              <br>\n              <br>\n              For reference:<br>\n              Order placed on {$ORDERDATE}<br>\n              Order ID {$ORDERS_ID}\n           </span></span>\n          </td>\n       </tr>\n     </tbody>\n    </table>\n    <br />\n    &nbsp;\n  </div>\n\n  <div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\n    <br /><br />\n    <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\n   <br /><br />\n  </div>\n</div>\n', 'Valued customer,\n\nUnfortunately Amazon Payments declined the payment for your order in our online\nshop. Please contact us.\n\nKind regards,\n\n{$EMAIL_SIGNATURE_TEXT}\n\n\nFor reference:\nOrder placed on {$ORDERDATE}\nOrder ID {$ORDERS_ID}\n');
INSERT INTO `gm_emails` (`gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`, `html`, `txt`) VALUES(17, 2, '', 'amazonadvpay_mail_hard', '<meta charset="UTF-8" />\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\n <div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; color: #999999; text-align: right;">&nbsp;</div>\n\n  <div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\n   <table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\n      <tbody>\n       <tr>\n          <td>\n            {if $gm_logo_mail}\n            <div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\n           {/if}\n         </td>\n       </tr>\n       <tr>\n          <td>\n            <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\n              Sehr geehrter Kunde,<br>\n              <br>\n              Leider wurde die Zahlung zu Ihrer Bestellung in unserem Onlineshop von\n              Amazon Payments zurückgewiesen. Bitte kontaktieren Sie uns.<br>\n             <br>\n              <br>\n              Referenzdaten:<br>\n              Bestellung vom {$ORDERDATE}<br>\n             Bestellnummer {$ORDERS_ID}\n            </span></span>\n          </td>\n       </tr>\n     </tbody>\n    </table>\n    <br />\n    &nbsp;\n  </div>\n\n  <div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\n    <br /><br />\n    <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\n   <br /><br />\n  </div>\n</div>\n', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n  <tbody>\n   <tr>\n      <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n       <div align="right">{if $gm_logo_mail}{$gm_logo_mail}{/if}</div>\n     </td>\n   </tr>\n   <tr>\n      <td>\n        Sehr geehrter Kunde,<br>\n        <br>\n        Leider wurde die Zahlung zu Ihrer Bestellung in unserem Onlineshop von\n        Amazon Payments zurückgewiesen. Bitte kontaktieren Sie uns.<br>\n       <br>\n        <br>\n        Mit freundlichen Grüßen<br>\n       {$EMAIL_SIGNATURE_HTML}\n       <br>\n        <br>\n        Referenzdaten:<br>\n        Bestellung vom {$ORDERDATE}<br>\n       Bestellnummer {$ORDERS_ID}\n      </td>\n   </tr>\n </tbody>\n</table>\n<br />\n<br />\n', 'Sehr geehrter Kunde,\n\nLeider wurde die Zahlung zu Ihrer Bestellung in unserem Onlineshop von\nAmazon Payments zurückgewiesen. Bitte kontaktieren Sie uns.\n\n\nMit freundlichen Grüßen\n{$EMAIL_SIGNATURE_TEXT}\n\n\nReferenzdaten:\nBestellung vom {$ORDERDATE}\nBestellnummer {$ORDERS_ID}\n', 'Sehr geehrter Kunde,\n\nLeider wurde die Zahlung zu Ihrer Bestellung in unserem Onlineshop von\nAmazon Payments zurückgewiesen. Bitte kontaktieren Sie uns.\n\n\nMit freundlichen Grüßen\n{$EMAIL_SIGNATURE_HTML}\n\n\nReferenzdaten:\nBestellung vom {$ORDERDATE}\nBestellnummer {$ORDERS_ID}\n', '<meta charset="UTF-8" />\n<div style="height: 100%; margin: 0 !important; padding: 0 !important; max-width: 9000px !important; background-color: #e5e5e5;">\n <div style="margin-left: auto; margin-right: auto; width: 720px; padding-bottom: 5px; padding-top: 5px; color: #999999; text-align: right;">&nbsp;</div>\n\n  <div style="margin-left: auto; margin-right: auto; width: 630px; padding: 25px 45px 25px; background-color: white; margin-top: 15px; margin-bottom: 15px; display: block;">\n   <table align="center" border="0" cellpadding="4" cellspacing="0" width="100%">\n      <tbody>\n       <tr>\n          <td>\n            {if $gm_logo_mail}\n            <div style="overflow: hidden; margin-bottom: 25px; display: block; float: right;">{$gm_logo_mail}</div>\n           {/if}\n         </td>\n       </tr>\n       <tr>\n          <td>\n            <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">\n              Sehr geehrter Kunde,<br>\n              <br>\n              Leider wurde die Zahlung zu Ihrer Bestellung in unserem Onlineshop von\n              Amazon Payments zurückgewiesen. Bitte kontaktieren Sie uns.<br>\n             <br>\n              <br>\n              Referenzdaten:<br>\n              Bestellung vom {$ORDERDATE}<br>\n             Bestellnummer {$ORDERS_ID}\n            </span></span>\n          </td>\n       </tr>\n     </tbody>\n    </table>\n    <br />\n    &nbsp;\n  </div>\n\n  <div style="padding-bottom: 5px; padding-top: 5px; font-size: 9pt; color: #444444; font-family: arial; text-align: center;">\n    <br /><br />\n    <span style="font-size:13px;"><span style="font-family: verdana,geneva,sans-serif;">{$EMAIL_SIGNATURE_HTML}</span></span>\n   <br /><br />\n  </div>\n</div>\n', 'Sehr geehrter Kunde,\n\nLeider wurde die Zahlung zu Ihrer Bestellung in unserem Onlineshop von\nAmazon Payments zurückgewiesen. Bitte kontaktieren Sie uns.\n\n\nMit freundlichen Grüßen\n{$EMAIL_SIGNATURE_TEXT}\n\n\nReferenzdaten:\nBestellung vom {$ORDERDATE}\nBestellnummer {$ORDERS_ID}\n');

INSERT INTO `gm_gmotion` (`gm_gmotion_id`, `products_id`, `image_nr`, `position_from`, `position_to`, `zoom_from`, `zoom_to`, `duration`, `sort_order`) VALUES(1, 1, 0, '4% 98%', '93% 11%', 1.0, 1.0, 10, 1);
INSERT INTO `gm_gmotion` (`gm_gmotion_id`, `products_id`, `image_nr`, `position_from`, `position_to`, `zoom_from`, `zoom_to`, `duration`, `sort_order`) VALUES(2, 1, 1, '21% 30%', '63% 67%', 1.0, 1.0, 10, 2);
INSERT INTO `gm_gmotion` (`gm_gmotion_id`, `products_id`, `image_nr`, `position_from`, `position_to`, `zoom_from`, `zoom_to`, `duration`, `sort_order`) VALUES(3, 1, 2, '73% 12%', '34% 92%', 1.0, 1.0, 10, 3);
INSERT INTO `gm_gmotion` (`gm_gmotion_id`, `products_id`, `image_nr`, `position_from`, `position_to`, `zoom_from`, `zoom_to`, `duration`, `sort_order`) VALUES(4, 1, 3, '6% 73%', '92% 34%', 1.0, 1.0, 10, 4);


INSERT INTO `gm_gmotion_products` (`gm_gmotion_products_id`, `products_id`) VALUES(1, 1);


INSERT INTO `gm_guestbook_customers_status` (`gm_guestbook_customers_status_id`, `customers_status_id`) VALUES(1, 0);
INSERT INTO `gm_guestbook_customers_status` (`gm_guestbook_customers_status_id`, `customers_status_id`) VALUES(2, 1);
INSERT INTO `gm_guestbook_customers_status` (`gm_guestbook_customers_status_id`, `customers_status_id`) VALUES(3, 2);
INSERT INTO `gm_guestbook_customers_status` (`gm_guestbook_customers_status_id`, `customers_status_id`) VALUES(4, 3);


INSERT INTO `gm_prd_img_alt` (`img_alt_id`, `image_id`, `products_id`, `language_id`, `gm_alt_text`) VALUES(8, 5, 1, 2, 'Artikelbild');
INSERT INTO `gm_prd_img_alt` (`img_alt_id`, `image_id`, `products_id`, `language_id`, `gm_alt_text`) VALUES(7, 5, 1, 1, 'product image');
INSERT INTO `gm_prd_img_alt` (`img_alt_id`, `image_id`, `products_id`, `language_id`, `gm_alt_text`) VALUES(11, 7, 1, 1, 'product image');
INSERT INTO `gm_prd_img_alt` (`img_alt_id`, `image_id`, `products_id`, `language_id`, `gm_alt_text`) VALUES(10, 6, 1, 2, 'Artikelbild');
INSERT INTO `gm_prd_img_alt` (`img_alt_id`, `image_id`, `products_id`, `language_id`, `gm_alt_text`) VALUES(9, 6, 1, 1, 'product image');
INSERT INTO `gm_prd_img_alt` (`img_alt_id`, `image_id`, `products_id`, `language_id`, `gm_alt_text`) VALUES(12, 7, 1, 2, 'Artikelbild');


INSERT INTO `google_export_availability` (`google_export_availability_id`, `availability`) VALUES(1, 'auf lager');
INSERT INTO `google_export_availability` (`google_export_availability_id`, `availability`) VALUES(2, 'bestellbar');
INSERT INTO `google_export_availability` (`google_export_availability_id`, `availability`) VALUES(3, 'nicht auf lager');
INSERT INTO `google_export_availability` (`google_export_availability_id`, `availability`) VALUES(4, 'vorbestellt');


INSERT INTO `languages` (`languages_id`, `name`, `code`, `image`, `directory`, `sort_order`, `language_charset`, `status`) VALUES(1, 'English', 'en', 'icon.gif', 'english', 2, 'utf-8', 1);
INSERT INTO `languages` (`languages_id`, `name`, `code`, `image`, `directory`, `sort_order`, `language_charset`, `status`) VALUES(2, 'Deutsch', 'de', 'icon.gif', 'german', 1, 'utf-8', 1);


INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(1, 1, 'Pending');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(2, 1, 'Processing');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(2, 2, 'In Bearbeitung');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(3, 1, 'Delivered');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(3, 2, 'Versendet');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(99, 1, 'Canceled');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(99, 2, 'Storniert');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(1, 2, 'Offen');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(149, 2, 'Rechnung erstellt');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(149, 1, 'Invoice created');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(160, 1, 'ipayment temporary');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(160, 2, 'ipayment temporaer');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(161, 1, 'ipayment paid');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(161, 2, 'ipayment bezahlt');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(162, 1, 'ipayment error');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(162, 2, 'ipayment Fehler');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(170, 2, 'PayPal temp');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(170, 1, 'PayPal temp');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(171, 2, 'PayPal bezahlt');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(171, 1, 'PayPal paid');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(172, 2, 'PayPal autorisiert');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(172, 1, 'PayPal authorized');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(173, 2, 'PayPal vorautorisiert');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(173, 1, 'PayPal pre-authorized');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(174, 2, 'PayPal in Schwebe');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(174, 1, 'PayPal payment pending');

INSERT INTO `products` (`products_id`, `products_ean`, `products_quantity`, `products_shippingtime`, `products_model`, `product_type`, `group_permission_0`, `group_permission_1`, `group_permission_2`, `group_permission_3`, `products_sort`, `products_image`, `products_price`, `products_discount_allowed`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `product_template`, `options_template`, `manufacturers_id`, `products_ordered`, `products_fsk18`, `products_vpe`, `products_vpe_status`, `products_vpe_value`, `products_startpage`, `products_startpage_sort`, `group_ids`, `nc_ultra_shipping_costs`, `gm_show_date_added`, `gm_show_price_offer`, `gm_show_weight`, `gm_price_status`, `gm_min_order`, `gm_graduated_qty`, `gm_options_template`, `gm_priority`, `gm_changefreq`, `gm_show_qty_info`, `gm_sitemap_entry`, `products_image_w`, `products_image_h`, `gm_show_image`, `properties_dropdown_mode`, `properties_show_price`, `use_properties_combis_weight`, `use_properties_combis_quantity`, `use_properties_combis_shipping_time`) VALUES(1, '', 998.0000, 1, 'ABC123', 1, 0, 0, 0, 0, 0, 'artikelbild.jpg', 16.7983, 0.00, '2008-08-08 17:19:46', '2011-03-16 16:01:51', NULL, 0.0000, 1, 1, 'standard.html', 'product_options_dropdown.html', 0, 1.0000, 0, 0, 0, 0.0000, 0, 0, '', 0.00, 0, 1, 0, 0, 1.0000, 1.0000, 'product_options_dropdown.html', '0.5', 'daily', 1, 1, 130, 130, 1, 'dropdown_mode_1', 'true', 0, 0, 1);


INSERT INTO `products_description` (`products_id`, `language_id`, `products_name`, `products_description`, `products_short_description`, `products_keywords`, `products_meta_title`, `products_meta_description`, `products_meta_keywords`, `products_url`, `products_viewed`, `gm_alt_text`, `gm_url_keywords`) VALUES(1, 1, 'test article', '<p>test article description</p>', '<p>test article short description</p>', '', '', '', '', '', 0, 'product image', 'test-article');
INSERT INTO `products_description` (`products_id`, `language_id`, `products_name`, `products_description`, `products_short_description`, `products_keywords`, `products_meta_title`, `products_meta_description`, `products_meta_keywords`, `products_url`, `products_viewed`, `gm_alt_text`, `gm_url_keywords`) VALUES(1, 2, 'Testartikel', '<p>[TAB:Seite 1] Testartikel Beschreibung Seite 1 [TAB:Seite 2] Testartikel Beschreibung Seite 2 [TAB:Seite 3] Testartikel Beschreibung Seite 3</p>', '<p>Testartikel Kurzbeschreibung</p>', '', '', '', '', '', 32, 'Artikelbild', 'Testartikel');


INSERT INTO `products_images` (`image_id`, `products_id`, `image_nr`, `image_name`, `gm_show_image`) VALUES(7, 1, 3, 'artikelbild_1_3.jpg', 1);
INSERT INTO `products_images` (`image_id`, `products_id`, `image_nr`, `image_name`, `gm_show_image`) VALUES(6, 1, 2, 'artikelbild_1_2.jpg', 1);
INSERT INTO `products_images` (`image_id`, `products_id`, `image_nr`, `image_name`, `gm_show_image`) VALUES(5, 1, 1, 'artikelbild_1_1.jpg', 1);


INSERT INTO `products_properties_admin_select` VALUES(1, 1, 1, 1);
INSERT INTO `products_properties_admin_select` VALUES(2, 1, 1, 2);
INSERT INTO `products_properties_admin_select` VALUES(3, 1, 1, 3);
INSERT INTO `products_properties_admin_select` VALUES(4, 1, 2, 4);
INSERT INTO `products_properties_admin_select` VALUES(5, 1, 2, 5);
INSERT INTO `products_properties_admin_select` VALUES(6, 1, 2, 6);


INSERT INTO `products_properties_combis` VALUES(1, 1, 1, 's-gold', '123456789', 100.0000, 2, 2.0000, 'calc', 0.0000, '', 0, 0.0000);
INSERT INTO `products_properties_combis` VALUES(2, 1, 2, 's-red', '123456789', 100.0000, 2, 2.0000, 'calc', 0.0000, '', 0, 0.0000);
INSERT INTO `products_properties_combis` VALUES(3, 1, 3, 's-black', '123456789', 100.0000, 2, 2.0000, 'calc', 1.6807, '', 0, 0.0000);
INSERT INTO `products_properties_combis` VALUES(4, 1, 4, 'm-gold', '123456789', 100.0000, 2, 2.0000, 'calc', 0.0000, '', 0, 0.0000);
INSERT INTO `products_properties_combis` VALUES(5, 1, 5, 'm-red', '123456789', 100.0000, 2, 2.0000, 'calc', 0.0000, '', 0, 0.0000);
INSERT INTO `products_properties_combis` VALUES(6, 1, 6, 'm-black', '123456789', 100.0000, 2, 2.0000, 'calc', 1.6807, '', 0, 0.0000);
INSERT INTO `products_properties_combis` VALUES(7, 1, 7, 'l-gold', '123456789', 100.0000, 2, 2.0000, 'calc', 4.2017, '', 0, 0.0000);
INSERT INTO `products_properties_combis` VALUES(8, 1, 8, 'l-red', '123456789', 100.0000, 2, 2.0000, 'calc', 4.2017, '', 0, 0.0000);
INSERT INTO `products_properties_combis` VALUES(9, 1, 9, 'l-black', '123456789', 100.0000, 2, 2.0000, 'calc', 5.8824, '', 0, 0.0000);


INSERT INTO `products_properties_combis_defaults` VALUES(1, 1, '123456789', 100.0000, 2, 2.0000, 'calc', 0.0000, 0, 0.0000);


INSERT INTO `products_properties_combis_values` VALUES(1, 1, 1);
INSERT INTO `products_properties_combis_values` VALUES(2, 1, 4);
INSERT INTO `products_properties_combis_values` VALUES(3, 2, 1);
INSERT INTO `products_properties_combis_values` VALUES(4, 2, 5);
INSERT INTO `products_properties_combis_values` VALUES(5, 3, 1);
INSERT INTO `products_properties_combis_values` VALUES(6, 3, 6);
INSERT INTO `products_properties_combis_values` VALUES(7, 4, 2);
INSERT INTO `products_properties_combis_values` VALUES(8, 4, 4);
INSERT INTO `products_properties_combis_values` VALUES(9, 5, 2);
INSERT INTO `products_properties_combis_values` VALUES(10, 5, 5);
INSERT INTO `products_properties_combis_values` VALUES(11, 6, 2);
INSERT INTO `products_properties_combis_values` VALUES(12, 6, 6);
INSERT INTO `products_properties_combis_values` VALUES(13, 7, 3);
INSERT INTO `products_properties_combis_values` VALUES(14, 7, 4);
INSERT INTO `products_properties_combis_values` VALUES(15, 8, 3);
INSERT INTO `products_properties_combis_values` VALUES(16, 8, 5);
INSERT INTO `products_properties_combis_values` VALUES(17, 9, 3);
INSERT INTO `products_properties_combis_values` VALUES(18, 9, 6);


INSERT INTO `products_properties_index` VALUES(1, 1, 1, 1, 1, 'Size', '', 1, 'S', 0.0000, 1);
INSERT INTO `products_properties_index` VALUES(1, 1, 1, 2, 1, 'Size', '', 1, 'S', 0.0000, 1);
INSERT INTO `products_properties_index` VALUES(1, 1, 1, 3, 1, 'Size', '', 1, 'S', 0.0000, 1);
INSERT INTO `products_properties_index` VALUES(1, 1, 1, 4, 2, 'Size', '', 1, 'M', 0.0000, 2);
INSERT INTO `products_properties_index` VALUES(1, 1, 1, 5, 2, 'Size', '', 1, 'M', 0.0000, 2);
INSERT INTO `products_properties_index` VALUES(1, 1, 1, 6, 2, 'Size', '', 1, 'M', 0.0000, 2);
INSERT INTO `products_properties_index` VALUES(1, 1, 1, 7, 3, 'Size', '', 1, 'L', 5.0000, 3);
INSERT INTO `products_properties_index` VALUES(1, 1, 1, 8, 3, 'Size', '', 1, 'L', 5.0000, 3);
INSERT INTO `products_properties_index` VALUES(1, 1, 1, 9, 3, 'Size', '', 1, 'L', 5.0000, 3);
INSERT INTO `products_properties_index` VALUES(1, 1, 2, 1, 4, 'Color', '', 2, 'Gold', 0.0000, 1);
INSERT INTO `products_properties_index` VALUES(1, 1, 2, 4, 4, 'Color', '', 2, 'Gold', 0.0000, 1);
INSERT INTO `products_properties_index` VALUES(1, 1, 2, 7, 4, 'Color', '', 2, 'Gold', 0.0000, 1);
INSERT INTO `products_properties_index` VALUES(1, 1, 2, 2, 5, 'Color', '', 2, 'Red', 0.0000, 2);
INSERT INTO `products_properties_index` VALUES(1, 1, 2, 5, 5, 'Color', '', 2, 'Red', 0.0000, 2);
INSERT INTO `products_properties_index` VALUES(1, 1, 2, 8, 5, 'Color', '', 2, 'Red', 0.0000, 2);
INSERT INTO `products_properties_index` VALUES(1, 1, 2, 3, 6, 'Color', '', 2, 'Black', 2.0000, 3);
INSERT INTO `products_properties_index` VALUES(1, 1, 2, 6, 6, 'Color', '', 2, 'Black', 2.0000, 3);
INSERT INTO `products_properties_index` VALUES(1, 1, 2, 9, 6, 'Color', '', 2, 'Black', 2.0000, 3);
INSERT INTO `products_properties_index` VALUES(1, 2, 1, 1, 1, 'Größe', '', 1, 'S', 0.0000, 1);
INSERT INTO `products_properties_index` VALUES(1, 2, 1, 2, 1, 'Größe', '', 1, 'S', 0.0000, 1);
INSERT INTO `products_properties_index` VALUES(1, 2, 1, 3, 1, 'Größe', '', 1, 'S', 0.0000, 1);
INSERT INTO `products_properties_index` VALUES(1, 2, 1, 4, 2, 'Größe', '', 1, 'M', 0.0000, 2);
INSERT INTO `products_properties_index` VALUES(1, 2, 1, 5, 2, 'Größe', '', 1, 'M', 0.0000, 2);
INSERT INTO `products_properties_index` VALUES(1, 2, 1, 6, 2, 'Größe', '', 1, 'M', 0.0000, 2);
INSERT INTO `products_properties_index` VALUES(1, 2, 1, 7, 3, 'Größe', '', 1, 'L', 5.0000, 3);
INSERT INTO `products_properties_index` VALUES(1, 2, 1, 8, 3, 'Größe', '', 1, 'L', 5.0000, 3);
INSERT INTO `products_properties_index` VALUES(1, 2, 1, 9, 3, 'Größe', '', 1, 'L', 5.0000, 3);
INSERT INTO `products_properties_index` VALUES(1, 2, 2, 1, 4, 'Farbe', '', 2, 'Gold', 0.0000, 1);
INSERT INTO `products_properties_index` VALUES(1, 2, 2, 4, 4, 'Farbe', '', 2, 'Gold', 0.0000, 1);
INSERT INTO `products_properties_index` VALUES(1, 2, 2, 7, 4, 'Farbe', '', 2, 'Gold', 0.0000, 1);
INSERT INTO `products_properties_index` VALUES(1, 2, 2, 2, 5, 'Farbe', '', 2, 'Rot', 0.0000, 2);
INSERT INTO `products_properties_index` VALUES(1, 2, 2, 5, 5, 'Farbe', '', 2, 'Rot', 0.0000, 2);
INSERT INTO `products_properties_index` VALUES(1, 2, 2, 8, 5, 'Farbe', '', 2, 'Rot', 0.0000, 2);
INSERT INTO `products_properties_index` VALUES(1, 2, 2, 3, 6, 'Farbe', '', 2, 'Schwarz', 2.0000, 3);
INSERT INTO `products_properties_index` VALUES(1, 2, 2, 6, 6, 'Farbe', '', 2, 'Schwarz', 2.0000, 3);
INSERT INTO `products_properties_index` VALUES(1, 2, 2, 9, 6, 'Farbe', '', 2, 'Schwarz', 2.0000, 3);


INSERT INTO `products_to_categories` (`products_id`, `categories_id`) VALUES(1, 1);


INSERT INTO `product_types` (`product_type_id`) VALUES(1);
INSERT INTO `product_types` (`product_type_id`) VALUES(2);
INSERT INTO `product_types` (`product_type_id`) VALUES(3);


INSERT INTO `product_type_descriptions` (`product_type_id`, `language_id`, `name`) VALUES(1, 1, 'Default');
INSERT INTO `product_type_descriptions` (`product_type_id`, `language_id`, `name`) VALUES(1, 2, 'Standard');
INSERT INTO `product_type_descriptions` (`product_type_id`, `language_id`, `name`) VALUES(2, 1, 'Download');
INSERT INTO `product_type_descriptions` (`product_type_id`, `language_id`, `name`) VALUES(2, 2, 'Download');
INSERT INTO `product_type_descriptions` (`product_type_id`, `language_id`, `name`) VALUES(3, 1, 'Service');
INSERT INTO `product_type_descriptions` (`product_type_id`, `language_id`, `name`) VALUES(3, 2, 'Dienstleistung');


INSERT INTO `properties` VALUES(1, 1);
INSERT INTO `properties` VALUES(2, 2);


INSERT INTO `properties_description` VALUES(1, 1, 2, 'Größe', '');
INSERT INTO `properties_description` VALUES(2, 1, 1, 'Size', '');
INSERT INTO `properties_description` VALUES(3, 2, 2, 'Farbe', '');
INSERT INTO `properties_description` VALUES(4, 2, 1, 'Color', '');


INSERT INTO `properties_values` VALUES(1, 1, 1, 's', 0.0000);
INSERT INTO `properties_values` VALUES(2, 1, 2, 'm', 0.0000);
INSERT INTO `properties_values` VALUES(3, 1, 3, 'l', 5.0000);
INSERT INTO `properties_values` VALUES(4, 2, 1, 'gold', 0.0000);
INSERT INTO `properties_values` VALUES(5, 2, 2, 'red', 0.0000);
INSERT INTO `properties_values` VALUES(6, 2, 3, 'black', 2.0000);


INSERT INTO `properties_values_description` VALUES(1, 1, 2, 'S');
INSERT INTO `properties_values_description` VALUES(2, 1, 1, 'S');
INSERT INTO `properties_values_description` VALUES(3, 2, 2, 'M');
INSERT INTO `properties_values_description` VALUES(4, 2, 1, 'M');
INSERT INTO `properties_values_description` VALUES(5, 3, 2, 'L');
INSERT INTO `properties_values_description` VALUES(6, 3, 1, 'L');
INSERT INTO `properties_values_description` VALUES(7, 4, 2, 'Gold');
INSERT INTO `properties_values_description` VALUES(8, 4, 1, 'Gold');
INSERT INTO `properties_values_description` VALUES(9, 5, 2, 'Rot');
INSERT INTO `properties_values_description` VALUES(10, 5, 1, 'Red');
INSERT INTO `properties_values_description` VALUES(11, 6, 2, 'Schwarz');
INSERT INTO `properties_values_description` VALUES(12, 6, 1, 'Black');


INSERT INTO `shipping_status` (`shipping_status_id`, `language_id`, `shipping_status_name`, `shipping_status_image`, `number_of_days`, `shipping_quantity`) VALUES(1, 1, 'ca. 3-4 days', 'green.png', 4, 999999);
INSERT INTO `shipping_status` (`shipping_status_id`, `language_id`, `shipping_status_name`, `shipping_status_image`, `number_of_days`, `shipping_quantity`) VALUES(1, 2, 'ca. 3-4 Tage', 'green.png', 4, 999999);
INSERT INTO `shipping_status` (`shipping_status_id`, `language_id`, `shipping_status_name`, `shipping_status_image`, `number_of_days`, `shipping_quantity`) VALUES(2, 1, '1 Week', 'orange.png', 7, 0);
INSERT INTO `shipping_status` (`shipping_status_id`, `language_id`, `shipping_status_name`, `shipping_status_image`, `number_of_days`, `shipping_quantity`) VALUES(2, 2, 'ca. 1 Woche', 'orange.png', 7, 0);
INSERT INTO `shipping_status` (`shipping_status_id`, `language_id`, `shipping_status_name`, `shipping_status_image`, `number_of_days`, `shipping_quantity`) VALUES(3, 1, '2 Weeks', 'red.png', 14, 0);
INSERT INTO `shipping_status` (`shipping_status_id`, `language_id`, `shipping_status_name`, `shipping_status_image`, `number_of_days`, `shipping_quantity`) VALUES(3, 2, 'ca. 2 Wochen', 'red.png', 14, 0);


INSERT INTO `shipping_status_to_google_availability` (`shipping_status_id`, `google_export_availability_id`) VALUES(1, 1);
INSERT INTO `shipping_status_to_google_availability` (`shipping_status_id`, `google_export_availability_id`) VALUES(2, 2);
INSERT INTO `shipping_status_to_google_availability` (`shipping_status_id`, `google_export_availability_id`) VALUES(3, 3);


INSERT INTO `specials` (`specials_id`, `products_id`, `specials_quantity`, `specials_new_products_price`, `specials_date_added`, `specials_last_modified`, `expires_date`, `date_status_change`, `status`) VALUES(1, 1, 1857.0000, 12.6050, '2008-08-12 15:40:47', '2008-08-14 19:06:03', '0000-00-00 00:00:00', NULL, 1);


INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1, 223, 'AL', 'Alabama');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(2, 223, 'AK', 'Alaska');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(3, 223, 'AS', 'American Samoa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(4, 223, 'AZ', 'Arizona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(5, 223, 'AR', 'Arkansas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(6, 223, 'AF', 'Armed Forces Africa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(7, 223, 'AA', 'Armed Forces Americas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(8, 223, 'AC', 'Armed Forces Canada');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(9, 223, 'AE', 'Armed Forces Europe');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(10, 223, 'AM', 'Armed Forces Middle East');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(11, 223, 'AP', 'Armed Forces Pacific');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(12, 223, 'CA', 'California');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(13, 223, 'CO', 'Colorado');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(14, 223, 'CT', 'Connecticut');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(15, 223, 'DE', 'Delaware');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(16, 223, 'DC', 'District of Columbia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(17, 223, 'FM', 'Federated States Of Micronesia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(18, 223, 'FL', 'Florida');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(19, 223, 'GA', 'Georgia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(20, 223, 'GU', 'Guam');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(21, 223, 'HI', 'Hawaii');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(22, 223, 'ID', 'Idaho');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(23, 223, 'IL', 'Illinois');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(24, 223, 'IN', 'Indiana');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(25, 223, 'IA', 'Iowa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(26, 223, 'KS', 'Kansas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(27, 223, 'KY', 'Kentucky');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(28, 223, 'LA', 'Louisiana');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(29, 223, 'ME', 'Maine');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(30, 223, 'MH', 'Marshall Islands');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(31, 223, 'MD', 'Maryland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(32, 223, 'MA', 'Massachusetts');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(33, 223, 'MI', 'Michigan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(34, 223, 'MN', 'Minnesota');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(35, 223, 'MS', 'Mississippi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(36, 223, 'MO', 'Missouri');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(37, 223, 'MT', 'Montana');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(38, 223, 'NE', 'Nebraska');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(39, 223, 'NV', 'Nevada');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(40, 223, 'NH', 'New Hampshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(41, 223, 'NJ', 'New Jersey');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(42, 223, 'NM', 'New Mexico');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(43, 223, 'NY', 'New York');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(44, 223, 'NC', 'North Carolina');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(45, 223, 'ND', 'North Dakota');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(46, 223, 'MP', 'Northern Mariana Islands');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(47, 223, 'OH', 'Ohio');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(48, 223, 'OK', 'Oklahoma');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(49, 223, 'OR', 'Oregon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(50, 223, 'PW', 'Palau');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(51, 223, 'PA', 'Pennsylvania');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(52, 223, 'PR', 'Puerto Rico');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(53, 223, 'RI', 'Rhode Island');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(54, 223, 'SC', 'South Carolina');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(55, 223, 'SD', 'South Dakota');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(56, 223, 'TN', 'Tennessee');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(57, 223, 'TX', 'Texas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(58, 223, 'UT', 'Utah');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(59, 223, 'VT', 'Vermont');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(60, 223, 'VI', 'Virgin Islands');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(61, 223, 'VA', 'Virginia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(62, 223, 'WA', 'Washington');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(63, 223, 'WV', 'West Virginia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(64, 223, 'WI', 'Wisconsin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(65, 223, 'WY', 'Wyoming');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(66, 38, 'AB', 'Alberta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(67, 38, 'BC', 'British Columbia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(68, 38, 'MB', 'Manitoba');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(69, 38, 'NF', 'Newfoundland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(70, 38, 'NB', 'New Brunswick');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(71, 38, 'NS', 'Nova Scotia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(72, 38, 'NT', 'Northwest Territories');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(73, 38, 'NU', 'Nunavut');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(74, 38, 'ON', 'Ontario');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(75, 38, 'PE', 'Prince Edward Island');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(76, 38, 'QC', 'Quebec');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(77, 38, 'SK', 'Saskatchewan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(78, 38, 'YT', 'Yukon Territory');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(79, 81, 'NDS', 'Niedersachsen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(80, 81, 'BAW', 'Baden-Württemberg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(81, 81, 'BAY', 'Bayern');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(82, 81, 'BER', 'Berlin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(83, 81, 'BRG', 'Brandenburg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(84, 81, 'BRE', 'Bremen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(85, 81, 'HAM', 'Hamburg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(86, 81, 'HES', 'Hessen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(87, 81, 'MEC', 'Mecklenburg-Vorpommern');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(88, 81, 'NRW', 'Nordrhein-Westfalen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(89, 81, 'RHE', 'Rheinland-Pfalz');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(90, 81, 'SAR', 'Saarland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(91, 81, 'SAS', 'Sachsen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(92, 81, 'SAC', 'Sachsen-Anhalt');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(93, 81, 'SCN', 'Schleswig-Holstein');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(94, 81, 'THE', 'Thüringen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(95, 14, 'WI', 'Wien');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(96, 14, 'NO', 'Niederösterreich');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(97, 14, 'OO', 'Oberösterreich');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(98, 14, 'SB', 'Salzburg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(99, 14, 'KN', 'Kärnten');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(100, 14, 'ST', 'Steiermark');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(101, 14, 'TI', 'Tirol');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(102, 14, 'BL', 'Burgenland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(103, 14, 'VB', 'Vorarlberg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(104, 204, 'AG', 'Aargau');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(105, 204, 'AI', 'Appenzell Innerrhoden');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(106, 204, 'AR', 'Appenzell Ausserrhoden');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(107, 204, 'BE', 'Bern');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(108, 204, 'BL', 'Basel-Landschaft');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(109, 204, 'BS', 'Basel-Stadt');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(110, 204, 'FR', 'Freiburg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(111, 204, 'GE', 'Genf');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(112, 204, 'GL', 'Glarus');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(113, 204, 'JU', 'Graubünden');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(114, 204, 'JU', 'Jura');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(115, 204, 'LU', 'Luzern');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(116, 204, 'NE', 'Neuenburg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(117, 204, 'NW', 'Nidwalden');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(118, 204, 'OW', 'Obwalden');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(119, 204, 'SG', 'St. Gallen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(120, 204, 'SH', 'Schaffhausen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(121, 204, 'SO', 'Solothurn');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(122, 204, 'SZ', 'Schwyz');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(123, 204, 'TG', 'Thurgau');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(124, 204, 'TI', 'Tessin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(125, 204, 'UR', 'Uri');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(126, 204, 'VD', 'Waadt');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(127, 204, 'VS', 'Wallis');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(128, 204, 'ZG', 'Zug');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(129, 204, 'ZH', 'Zürich');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(130, 195, 'A Coruña', 'A Coruña');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(131, 195, 'Alava', 'Alava');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(132, 195, 'Albacete', 'Albacete');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(133, 195, 'Alicante', 'Alicante');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(134, 195, 'Almeria', 'Almeria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(135, 195, 'Asturias', 'Asturias');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(136, 195, 'Avila', 'Avila');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(137, 195, 'Badajoz', 'Badajoz');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(138, 195, 'Baleares', 'Baleares');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(139, 195, 'Barcelona', 'Barcelona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(140, 195, 'Burgos', 'Burgos');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(141, 195, 'Caceres', 'Caceres');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(142, 195, 'Cadiz', 'Cadiz');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(143, 195, 'Cantabria', 'Cantabria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(144, 195, 'Castellon', 'Castellon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(145, 195, 'Ceuta', 'Ceuta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(146, 195, 'Ciudad Real', 'Ciudad Real');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(147, 195, 'Cordoba', 'Cordoba');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(148, 195, 'Cuenca', 'Cuenca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(149, 195, 'Girona', 'Girona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(150, 195, 'Granada', 'Granada');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(151, 195, 'Guadalajara', 'Guadalajara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(152, 195, 'Guipuzcoa', 'Guipuzcoa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(153, 195, 'Huelva', 'Huelva');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(154, 195, 'Huesca', 'Huesca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(155, 195, 'Jaen', 'Jaen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(156, 195, 'La Rioja', 'La Rioja');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(157, 195, 'Las Palmas', 'Las Palmas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(158, 195, 'Leon', 'Leon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(159, 195, 'Lleida', 'Lleida');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(160, 195, 'Lugo', 'Lugo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(161, 195, 'Madrid', 'Madrid');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(162, 195, 'Malaga', 'Malaga');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(163, 195, 'Melilla', 'Melilla');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(164, 195, 'Murcia', 'Murcia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(165, 195, 'Navarra', 'Navarra');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(166, 195, 'Ourense', 'Ourense');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(167, 195, 'Palencia', 'Palencia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(168, 195, 'Pontevedra', 'Pontevedra');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(169, 195, 'Salamanca', 'Salamanca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(170, 195, 'Santa Cruz de Tenerife', 'Santa Cruz de Tenerife');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(171, 195, 'Segovia', 'Segovia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(172, 195, 'Sevilla', 'Sevilla');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(173, 195, 'Soria', 'Soria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(174, 195, 'Tarragona', 'Tarragona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(175, 195, 'Teruel', 'Teruel');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(176, 195, 'Toledo', 'Toledo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(177, 195, 'Valencia', 'Valencia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(178, 195, 'Valladolid', 'Valladolid');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(179, 195, 'Vizcaya', 'Vizcaya');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(180, 195, 'Zamora', 'Zamora');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(181, 195, 'Zaragoza', 'Zaragoza');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(182, 13, 'NSW', 'New South Wales');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(183, 13, 'VIC', 'Victoria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(184, 13, 'QLD', 'Queensland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(185, 13, 'NT', 'Northern Territory');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(186, 13, 'WA', 'Western Australia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(187, 13, 'SA', 'South Australia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(188, 13, 'TAS', 'Tasmania');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(189, 13, 'ACT', 'Australian Capital Territory');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(190, 153, 'Northland', 'Northland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(191, 153, 'Auckland', 'Auckland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(192, 153, 'Waikato', 'Waikato');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(193, 153, 'Bay of Plenty', 'Bay of Plenty');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(194, 153, 'Gisborne', 'Gisborne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(195, 153, 'Hawkes Bay', 'Hawkes Bay');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(196, 153, 'Taranaki', 'Taranaki');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(197, 153, 'Manawatu-Wanganui', 'Manawatu-Wanganui');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(198, 153, 'Wellington', 'Wellington');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(199, 153, 'West Coast', 'West Coast');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(200, 153, 'Canterbury', 'Canterbury');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(201, 153, 'Otago', 'Otago');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(202, 153, 'Southland', 'Southland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(203, 153, 'Tasman', 'Tasman');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(204, 153, 'Nelson', 'Nelson');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(205, 153, 'Marlborough', 'Marlborough');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(206, 30, 'SP', 'São Paulo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(207, 30, 'RJ', 'Rio de Janeiro');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(208, 30, 'PE', 'Pernanbuco');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(209, 30, 'BA', 'Bahia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(210, 30, 'AM', 'Amazonas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(211, 30, 'MG', 'Minas Gerais');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(212, 30, 'ES', 'Espirito Santo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(213, 30, 'RS', 'Rio Grande do Sul');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(214, 30, 'PR', 'Paraná');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(215, 30, 'SC', 'Santa Catarina');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(216, 30, 'RG', 'Rio Grande do Norte');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(217, 30, 'MS', 'Mato Grosso do Sul');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(218, 30, 'MT', 'Mato Grosso');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(219, 30, 'GO', 'Goias');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(220, 30, 'TO', 'Tocantins');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(221, 30, 'DF', 'Distrito Federal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(222, 30, 'RO', 'Rondonia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(223, 30, 'AC', 'Acre');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(224, 30, 'AP', 'Amapa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(225, 30, 'RO', 'Roraima');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(226, 30, 'AL', 'Alagoas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(227, 30, 'CE', 'Ceará');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(228, 30, 'MA', 'Maranhão');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(229, 30, 'PA', 'Pará');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(230, 30, 'PB', 'Paraíba');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(231, 30, 'PI', 'Piauí');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(232, 30, 'SE', 'Sergipe');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(233, 43, 'I', 'I Región de Tarapacá');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(234, 43, 'II', 'II Región de Antofagasta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(235, 43, 'III', 'III Región de Atacama');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(236, 43, 'IV', 'IV Región de Coquimbo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(237, 43, 'V', 'V Región de Valaparaíso');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(238, 43, 'RM', 'Región Metropolitana');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(239, 43, 'VI', 'VI Región de L. B. OŽhiggins');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(240, 43, 'VII', 'VII Región del Maule');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(241, 43, 'VIII', 'VIII Región del Bío Bío');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(242, 43, 'IX', 'IX Región de la Araucanía');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(243, 43, 'X', 'X Región de los Lagos');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(244, 43, 'XI', 'XI Región de Aysén');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(245, 43, 'XII', 'XII Región de Magallanes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(246, 47, 'AMA', 'Amazonas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(247, 47, 'ANT', 'Antioquia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(248, 47, 'ARA', 'Arauca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(249, 47, 'ATL', 'Atlantico');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(250, 47, 'BOL', 'Bolivar');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(251, 47, 'BOY', 'Boyaca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(252, 47, 'CAL', 'Caldas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(253, 47, 'CAQ', 'Caqueta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(254, 47, 'CAS', 'Casanare');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(255, 47, 'CAU', 'Cauca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(256, 47, 'CES', 'Cesar');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(257, 47, 'CHO', 'Choco');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(258, 47, 'COR', 'Cordoba');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(259, 47, 'CUN', 'Cundinamarca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(260, 47, 'HUI', 'Huila');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(261, 47, 'GUA', 'Guainia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(262, 47, 'GUA', 'Guajira');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(263, 47, 'GUV', 'Guaviare');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(264, 47, 'MAG', 'Magdalena');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(265, 47, 'MET', 'Meta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(266, 47, 'NAR', 'Narino');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(267, 47, 'NDS', 'Norte de Santander');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(268, 47, 'PUT', 'Putumayo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(269, 47, 'QUI', 'Quindio');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(270, 47, 'RIS', 'Risaralda');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(271, 47, 'SAI', 'San Andres Islas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(272, 47, 'SAN', 'Santander');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(273, 47, 'SUC', 'Sucre');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(274, 47, 'TOL', 'Tolima');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(275, 47, 'VAL', 'Valle');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(276, 47, 'VAU', 'Vaupes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(277, 47, 'VIC', 'Vichada');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(278, 73, 'Et', 'Etranger');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(279, 73, '01', 'Ain');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(280, 73, '02', 'Aisne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(281, 73, '03', 'Allier');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(282, 73, '04', 'Alpes de Haute Provence');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(283, 73, '05', 'Hautes-Alpes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(284, 73, '06', 'Alpes Maritimes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(285, 73, '07', 'Ardèche');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(286, 73, '08', 'Ardennes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(287, 73, '09', 'Ariège');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(288, 73, '10', 'Aube');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(289, 73, '11', 'Aude');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(290, 73, '12', 'Aveyron');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(291, 73, '13', 'Bouches-du-Rhône');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(292, 73, '14', 'Calvados');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(293, 73, '15', 'Cantal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(294, 73, '16', 'Charente');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(295, 73, '17', 'Charente Maritime');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(296, 73, '18', 'Cher');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(297, 73, '19', 'Corrèze');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(298, 73, '2A', 'Corse du Sud');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(299, 73, '2B', 'Haute Corse');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(300, 73, '21', 'Côte d''Azur');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(301, 73, '22', 'Côtes d''Armor');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(302, 73, '23', 'Creuse');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(303, 73, '24', 'Dordogne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(304, 73, '25', 'Doubs');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(305, 73, '26', 'Drôme');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(306, 73, '27', 'Eure');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(307, 73, '28', 'Eure et Loir');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(308, 73, '29', 'Finistère');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(309, 73, '30', 'Gard');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(310, 73, '31', 'Haute Garonne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(311, 73, '32', 'Gers');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(312, 73, '33', 'Gironde');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(313, 73, '34', 'Hérault');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(314, 73, '35', 'Ille et Vilaine');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(315, 73, '36', 'Indre');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(316, 73, '37', 'Indre et Loire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(317, 73, '38', 'Isère');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(318, 73, '39', 'Jura');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(319, 73, '40', 'Landes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(320, 73, '41', 'Loir et Cher');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(321, 73, '42', 'Loire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(322, 73, '43', 'Haute Loire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(323, 73, '44', 'Loire Atlantique');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(324, 73, '45', 'Loiret');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(325, 73, '46', 'Lot');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(326, 73, '47', 'Lot et Garonne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(327, 73, '48', 'Lozère');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(328, 73, '49', 'Maine et Loire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(329, 73, '50', 'Manche');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(330, 73, '51', 'Marne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(331, 73, '52', 'Haute Marne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(332, 73, '53', 'Mayenne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(333, 73, '54', 'Meurthe et Moselle');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(334, 73, '55', 'Meuse');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(335, 73, '56', 'Morbihan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(336, 73, '57', 'Moselle');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(337, 73, '58', 'Nièvre');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(338, 73, '59', 'Nord');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(339, 73, '60', 'Oise');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(340, 73, '61', 'Orne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(341, 73, '62', 'Pas de Calais');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(342, 73, '63', 'Puy-de-Dôme');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(343, 73, '64', 'Pyrénées-Atlantiques');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(344, 73, '65', 'Hautes-Pyrénées');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(345, 73, '66', 'Pyrénées-Orientales');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(346, 73, '67', 'Bas Rhin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(347, 73, '68', 'Haut Rhin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(348, 73, '69', 'Rhône');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(349, 73, '70', 'Haute-Saône');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(350, 73, '71', 'Saône-et-Loire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(351, 73, '72', 'Sarthe');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(352, 73, '73', 'Savoie');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(353, 73, '74', 'Haute Savoie');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(354, 73, '75', 'Paris');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(355, 73, '76', 'Seine Maritime');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(356, 73, '77', 'Seine et Marne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(357, 73, '78', 'Yvelines');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(358, 73, '79', 'Deux-Sèvres');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(359, 73, '80', 'Somme');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(360, 73, '81', 'Tarn');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(361, 73, '82', 'Tarn et Garonne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(362, 73, '83', 'Var');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(363, 73, '84', 'Vaucluse');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(364, 73, '85', 'Vendée');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(365, 73, '86', 'Vienne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(366, 73, '87', 'Haute Vienne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(367, 73, '88', 'Vosges');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(368, 73, '89', 'Yonne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(369, 73, '90', 'Territoire de Belfort');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(370, 73, '91', 'Essonne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(371, 73, '92', 'Hauts de Seine');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(372, 73, '93', 'Seine St-Denis');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(373, 73, '94', 'Val de Marne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(374, 73, '95', 'Val d''Oise');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(375, 73, '971 (DOM)', 'Guadeloupe');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(376, 73, '972 (DOM)', 'Martinique');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(377, 73, '973 (DOM)', 'Guyane');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(378, 73, '974 (DOM)', 'Saint Denis');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(379, 73, '975 (DOM)', 'St-Pierre de Miquelon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(380, 73, '976 (TOM)', 'Mayotte');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(381, 73, '984 (TOM)', 'Terres australes et Antartiques');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(382, 73, '985 (TOM)', 'Nouvelle-Calédonie');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(383, 73, '986 (TOM)', 'Wallis et Futuna');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(384, 73, '987 (TOM)', 'Polynésie française');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(385, 99, 'DL', 'Delhi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(386, 99, 'MH', 'Maharashtra');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(387, 99, 'TN', 'Tamil Nadu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(388, 99, 'KL', 'Kerala');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(389, 99, 'AP', 'Andhra Pradesh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(390, 99, 'KA', 'Karnataka');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(391, 99, 'GA', 'Goa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(392, 99, 'MP', 'Madhya Pradesh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(393, 99, 'PY', 'Pondicherry');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(394, 99, 'GJ', 'Gujarat');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(395, 99, 'OR', 'Orrisa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(396, 99, 'CA', 'Chhatisgarh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(397, 99, 'JH', 'Jharkhand');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(398, 99, 'BR', 'Bihar');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(399, 99, 'WB', 'West Bengal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(400, 99, 'UP', 'Uttar Pradesh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(401, 99, 'RJ', 'Rajasthan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(402, 99, 'PB', 'Punjab');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(403, 99, 'HR', 'Haryana');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(404, 99, 'CH', 'Chandigarh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(405, 99, 'JK', 'Jammu & Kashmir');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(406, 99, 'HP', 'Himachal Pradesh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(407, 99, 'UA', 'Uttaranchal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(408, 99, 'LK', 'Lakshadweep');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(409, 99, 'AN', 'Andaman & Nicobar');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(410, 99, 'MG', 'Meghalaya');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(411, 99, 'AS', 'Assam');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(412, 99, 'DR', 'Dadra & Nagar Haveli');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(413, 99, 'DN', 'Daman & Diu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(414, 99, 'SK', 'Sikkim');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(415, 99, 'TR', 'Tripura');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(416, 99, 'MZ', 'Mizoram');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(417, 99, 'MN', 'Manipur');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(418, 99, 'NL', 'Nagaland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(419, 99, 'AR', 'Arunachal Pradesh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(420, 105, 'AG', 'Agrigento');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(421, 105, 'AL', 'Alessandria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(422, 105, 'AN', 'Ancona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(423, 105, 'AO', 'Aosta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(424, 105, 'AR', 'Arezzo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(425, 105, 'AP', 'Ascoli Piceno');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(426, 105, 'AT', 'Asti');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(427, 105, 'AV', 'Avellino');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(428, 105, 'BA', 'Bari');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(429, 105, 'BL', 'Belluno');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(430, 105, 'BN', 'Benevento');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(431, 105, 'BG', 'Bergamo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(432, 105, 'BI', 'Biella');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(433, 105, 'BO', 'Bologna');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(434, 105, 'BZ', 'Bolzano');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(435, 105, 'BS', 'Brescia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(436, 105, 'BR', 'Brindisi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(437, 105, 'CA', 'Cagliari');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(438, 105, 'CL', 'Caltanissetta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(439, 105, 'CB', 'Campobasso');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(440, 105, 'CE', 'Caserta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(441, 105, 'CT', 'Catania');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(442, 105, 'CZ', 'Catanzaro');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(443, 105, 'CH', 'Chieti');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(444, 105, 'CO', 'Como');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(445, 105, 'CS', 'Cosenza');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(446, 105, 'CR', 'Cremona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(447, 105, 'KR', 'Crotone');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(448, 105, 'CN', 'Cuneo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(449, 105, 'EN', 'Enna');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(450, 105, 'FE', 'Ferrara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(451, 105, 'FI', 'Firenze');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(452, 105, 'FG', 'Foggia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(453, 105, 'FO', 'Forlì');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(454, 105, 'FR', 'Frosinone');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(455, 105, 'GE', 'Genova');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(456, 105, 'GO', 'Gorizia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(457, 105, 'GR', 'Grosseto');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(458, 105, 'IM', 'Imperia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(459, 105, 'IS', 'Isernia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(460, 105, 'AQ', 'Aquila');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(461, 105, 'SP', 'La Spezia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(462, 105, 'LT', 'Latina');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(463, 105, 'LE', 'Lecce');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(464, 105, 'LC', 'Lecco');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(465, 105, 'LI', 'Livorno');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(466, 105, 'LO', 'Lodi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(467, 105, 'LU', 'Lucca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(468, 105, 'MC', 'Macerata');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(469, 105, 'MN', 'Mantova');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(470, 105, 'MS', 'Massa-Carrara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(471, 105, 'MT', 'Matera');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(472, 105, 'ME', 'Messina');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(473, 105, 'MI', 'Milano');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(474, 105, 'MO', 'Modena');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(475, 105, 'NA', 'Napoli');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(476, 105, 'NO', 'Novara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(477, 105, 'NU', 'Nuoro');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(478, 105, 'OR', 'Oristano');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(479, 105, 'PD', 'Padova');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(480, 105, 'PA', 'Palermo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(481, 105, 'PR', 'Parma');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(482, 105, 'PG', 'Perugia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(483, 105, 'PV', 'Pavia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(484, 105, 'PS', 'Pesaro e Urbino');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(485, 105, 'PE', 'Pescara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(486, 105, 'PC', 'Piacenza');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(487, 105, 'PI', 'Pisa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(488, 105, 'PT', 'Pistoia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(489, 105, 'PN', 'Pordenone');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(490, 105, 'PZ', 'Potenza');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(491, 105, 'PO', 'Prato');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(492, 105, 'RG', 'Ragusa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(493, 105, 'RA', 'Ravenna');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(494, 105, 'RC', 'Reggio di Calabria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(495, 105, 'RE', 'Reggio Emilia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(496, 105, 'RI', 'Rieti');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(497, 105, 'RN', 'Rimini');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(498, 105, 'RM', 'Roma');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(499, 105, 'RO', 'Rovigo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(500, 105, 'SA', 'Salerno');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(501, 105, 'SS', 'Sassari');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(502, 105, 'SV', 'Savona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(503, 105, 'SI', 'Siena');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(504, 105, 'SR', 'Siracusa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(505, 105, 'SO', 'Sondrio');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(506, 105, 'TA', 'Taranto');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(507, 105, 'TE', 'Teramo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(508, 105, 'TR', 'Terni');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(509, 105, 'TO', 'Torino');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(510, 105, 'TP', 'Trapani');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(511, 105, 'TN', 'Trento');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(512, 105, 'TV', 'Treviso');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(513, 105, 'TS', 'Trieste');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(514, 105, 'UD', 'Udine');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(515, 105, 'VA', 'Varese');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(516, 105, 'VE', 'Venezia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(517, 105, 'VB', 'Verbania');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(518, 105, 'VC', 'Vercelli');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(519, 105, 'VR', 'Verona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(520, 105, 'VV', 'Vibo Valentia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(521, 105, 'VI', 'Vicenza');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(522, 105, 'VT', 'Viterbo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(523, 107, 'Niigata', 'Niigata');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(524, 107, 'Toyama', 'Toyama');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(525, 107, 'Ishikawa', 'Ishikawa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(526, 107, 'Fukui', 'Fukui');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(527, 107, 'Yamanashi', 'Yamanashi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(528, 107, 'Nagano', 'Nagano');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(529, 107, 'Gifu', 'Gifu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(530, 107, 'Shizuoka', 'Shizuoka');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(531, 107, 'Aichi', 'Aichi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(532, 107, 'Mie', 'Mie');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(533, 107, 'Shiga', 'Shiga');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(534, 107, 'Kyoto', 'Kyoto');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(535, 107, 'Osaka', 'Osaka');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(536, 107, 'Hyogo', 'Hyogo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(537, 107, 'Nara', 'Nara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(538, 107, 'Wakayama', 'Wakayama');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(539, 107, 'Tottori', 'Tottori');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(540, 107, 'Shimane', 'Shimane');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(541, 107, 'Okayama', 'Okayama');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(542, 107, 'Hiroshima', 'Hiroshima');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(543, 107, 'Yamaguchi', 'Yamaguchi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(544, 107, 'Tokushima', 'Tokushima');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(545, 107, 'Kagawa', 'Kagawa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(546, 107, 'Ehime', 'Ehime');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(547, 107, 'Kochi', 'Kochi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(548, 107, 'Fukuoka', 'Fukuoka');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(549, 107, 'Saga', 'Saga');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(550, 107, 'Nagasaki', 'Nagasaki');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(551, 107, 'Kumamoto', 'Kumamoto');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(552, 107, 'Oita', 'Oita');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(553, 107, 'Miyazaki', 'Miyazaki');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(554, 107, 'Kagoshima', 'Kagoshima');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(555, 129, 'JOH', 'Johor');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(556, 129, 'KDH', 'Kedah');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(557, 129, 'KEL', 'Kelantan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(558, 129, 'KL', 'Kuala Lumpur');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(559, 129, 'MEL', 'Melaka');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(560, 129, 'NS', 'Negeri Sembilan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(561, 129, 'PAH', 'Pahang');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(562, 129, 'PRK', 'Perak');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(563, 129, 'PER', 'Perlis');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(564, 129, 'PP', 'Pulau Pinang');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(565, 129, 'SAB', 'Sabah');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(566, 129, 'SWK', 'Sarawak');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(567, 129, 'SEL', 'Selangor');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(568, 129, 'TER', 'Terengganu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(569, 129, 'LAB', 'W.P.Labuan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(570, 138, 'AGS', 'Aguascalientes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(571, 138, 'BC', 'Baja California');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(572, 138, 'BCS', 'Baja California Sur');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(573, 138, 'CAM', 'Campeche');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(574, 138, 'COA', 'Coahuila');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(575, 138, 'COL', 'Colima');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(576, 138, 'CHI', 'Chiapas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(577, 138, 'CHIH', 'Chihuahua');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(578, 138, 'DF', 'Distrito Federal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(579, 138, 'DGO', 'Durango');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(580, 138, 'MEX', 'Estado de Mexico');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(581, 138, 'GTO', 'Guanajuato');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(582, 138, 'GRO', 'Guerrero');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(583, 138, 'HGO', 'Hidalgo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(584, 138, 'JAL', 'Jalisco');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(585, 138, 'MCH', 'Michoacan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(586, 138, 'MOR', 'Morelos');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(587, 138, 'NAY', 'Nayarit');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(588, 138, 'NL', 'Nuevo Leon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(589, 138, 'OAX', 'Oaxaca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(590, 138, 'PUE', 'Puebla');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(591, 138, 'QRO', 'Queretaro');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(592, 138, 'QR', 'Quintana Roo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(593, 138, 'SLP', 'San Luis Potosi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(594, 138, 'SIN', 'Sinaloa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(595, 138, 'SON', 'Sonora');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(596, 138, 'TAB', 'Tabasco');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(597, 138, 'TMPS', 'Tamaulipas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(598, 138, 'TLAX', 'Tlaxcala');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(599, 138, 'VER', 'Veracruz');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(600, 138, 'YUC', 'Yucatan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(601, 138, 'ZAC', 'Zacatecas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(602, 160, 'OSL', 'Oslo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(603, 160, 'AKE', 'Akershus');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(604, 160, 'AUA', 'Aust-Agder');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(605, 160, 'BUS', 'Buskerud');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(606, 160, 'FIN', 'Finnmark');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(607, 160, 'HED', 'Hedmark');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(608, 160, 'HOR', 'Hordaland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(609, 160, 'MOR', 'Møre og Romsdal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(610, 160, 'NOR', 'Nordland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(611, 160, 'NTR', 'Nord-Trøndelag');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(612, 160, 'OPP', 'Oppland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(613, 160, 'ROG', 'Rogaland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(614, 160, 'SOF', 'Sogn og Fjordane');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(615, 160, 'STR', 'Sør-Trøndelag');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(616, 160, 'TEL', 'Telemark');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(617, 160, 'TRO', 'Troms');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(618, 160, 'VEA', 'Vest-Agder');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(619, 160, 'OST', 'Østfold');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(620, 160, 'SVA', 'Svalbard');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(621, 99, 'KHI', 'Karachi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(622, 99, 'LH', 'Lahore');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(623, 99, 'ISB', 'Islamabad');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(624, 99, 'QUE', 'Quetta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(625, 99, 'PSH', 'Peshawar');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(626, 99, 'GUJ', 'Gujrat');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(627, 99, 'SAH', 'Sahiwal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(628, 99, 'FSB', 'Faisalabad');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(629, 99, 'RIP', 'Rawal Pindi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(630, 175, 'AB', 'Alba');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(631, 175, 'AR', 'Arad');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(632, 175, 'AG', 'Arges');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(633, 175, 'BC', 'Bacau');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(634, 175, 'BH', 'Bihor');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(635, 175, 'BN', 'Bistrita-Nasaud');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(636, 175, 'BT', 'Botosani');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(637, 175, 'BV', 'Brasov');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(638, 175, 'BR', 'Braila');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(639, 175, 'B', 'Bucuresti');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(640, 175, 'BZ', 'Buzau');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(641, 175, 'CS', 'Caras-Severin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(642, 175, 'CL', 'Calarasi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(643, 175, 'CJ', 'Cluj');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(644, 175, 'CT', 'Constanta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(645, 175, 'CV', 'Covasna');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(646, 175, 'DB', 'Dimbovita');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(647, 175, 'DJ', 'Dolj');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(648, 175, 'GL', 'Galati');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(649, 175, 'GR', 'Giurgiu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(650, 175, 'GJ', 'Gorj');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(651, 175, 'HR', 'Harghita');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(652, 175, 'HD', 'Hunedoara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(653, 175, 'IL', 'Ialomita');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(654, 175, 'IS', 'Iasi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(655, 175, 'IF', 'Ilfov');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(656, 175, 'MM', 'Maramures');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(657, 175, 'MH', 'Mehedint');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(658, 175, 'MS', 'Mures');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(659, 175, 'NT', 'Neamt');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(660, 175, 'OT', 'Olt');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(661, 175, 'PH', 'Prahova');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(662, 175, 'SM', 'Satu-Mare');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(663, 175, 'SJ', 'Salaj');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(664, 175, 'SB', 'Sibiu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(665, 175, 'SV', 'Suceava');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(666, 175, 'TR', 'Teleorman');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(667, 175, 'TM', 'Timis');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(668, 175, 'TL', 'Tulcea');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(669, 175, 'VS', 'Vaslui');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(670, 175, 'VL', 'Valcea');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(671, 175, 'VN', 'Vrancea');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(672, 193, 'WP', 'Western Cape');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(673, 193, 'GP', 'Gauteng');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(674, 193, 'KZN', 'Kwazulu-Natal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(675, 193, 'NC', 'Northern-Cape');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(676, 193, 'EC', 'Eastern-Cape');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(677, 193, 'MP', 'Mpumalanga');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(678, 193, 'NW', 'North-West');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(679, 193, 'FS', 'Free State');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(680, 193, 'NP', 'Northern Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(681, 215, 'ADANA', 'ADANA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(682, 215, 'ADIYAMAN', 'ADIYAMAN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(683, 215, 'AFYON', 'AFYON');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(684, 215, 'AGRI', 'AGRI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(685, 215, 'AMASYA', 'AMASYA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(686, 215, 'ANKARA', 'ANKARA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(687, 215, 'ANTALYA', 'ANTALYA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(688, 215, 'ARTVIN', 'ARTVIN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(689, 215, 'AYDIN', 'AYDIN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(690, 215, 'BALIKESIR', 'BALIKESIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(691, 215, 'BILECIK', 'BILECIK');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(692, 215, 'BINGÖL', 'BINGÖL');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(693, 215, 'BITLIS', 'BITLIS');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(694, 215, 'BOLU', 'BOLU');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(695, 215, 'BURDUR', 'BURDUR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(696, 215, 'BURSA', 'BURSA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(697, 215, 'ÇANAKKALE', 'ÇANAKKALE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(698, 215, 'ÇANKIRI', 'ÇANKIRI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(699, 215, 'ÇORUM', 'ÇORUM');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(700, 215, 'DENIZLI', 'DENIZLI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(701, 215, 'DIYARBAKIR', 'DIYARBAKIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(702, 215, 'EDIRNE', 'EDIRNE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(703, 215, 'ELAZIG', 'ELAZIG');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(704, 215, 'ERZINCAN', 'ERZINCAN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(705, 215, 'ERZURUM', 'ERZURUM');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(706, 215, 'ESKISEHIR', 'ESKISEHIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(707, 215, 'GAZIANTEP', 'GAZIANTEP');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(708, 215, 'GIRESUN', 'GIRESUN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(709, 215, 'GÜMÜSHANE', 'GÜMÜSHANE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(710, 215, 'HAKKARI', 'HAKKARI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(711, 215, 'HATAY', 'HATAY');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(712, 215, 'ISPARTA', 'ISPARTA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(713, 215, 'IÇEL', 'IÇEL');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(714, 215, 'ISTANBUL', 'ISTANBUL');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(715, 215, 'IZMIR', 'IZMIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(716, 215, 'KARS', 'KARS');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(717, 215, 'KASTAMONU', 'KASTAMONU');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(718, 215, 'KAYSERI', 'KAYSERI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(719, 215, 'KIRKLARELI', 'KIRKLARELI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(720, 215, 'KIRSEHIR', 'KIRSEHIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(721, 215, 'KOCAELI', 'KOCAELI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(722, 215, 'KONYA', 'KONYA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(723, 215, 'KÜTAHYA', 'KÜTAHYA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(724, 215, 'MALATYA', 'MALATYA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(725, 215, 'MANISA', 'MANISA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(726, 215, 'KAHRAMANMARAS', 'KAHRAMANMARAS');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(727, 215, 'MARDIN', 'MARDIN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(728, 215, 'MUGLA', 'MUGLA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(729, 215, 'MUS', 'MUS');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(730, 215, 'NEVSEHIR', 'NEVSEHIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(731, 215, 'NIGDE', 'NIGDE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(732, 215, 'ORDU', 'ORDU');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(733, 215, 'RIZE', 'RIZE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(734, 215, 'SAKARYA', 'SAKARYA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(735, 215, 'SAMSUN', 'SAMSUN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(736, 215, 'SIIRT', 'SIIRT');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(737, 215, 'SINOP', 'SINOP');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(738, 215, 'SIVAS', 'SIVAS');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(739, 215, 'TEKIRDAG', 'TEKIRDAG');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(740, 215, 'TOKAT', 'TOKAT');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(741, 215, 'TRABZON', 'TRABZON');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(742, 215, 'TUNCELI', 'TUNCELI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(743, 215, 'SANLIURFA', 'SANLIURFA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(744, 215, 'USAK', 'USAK');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(745, 215, 'VAN', 'VAN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(746, 215, 'YOZGAT', 'YOZGAT');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(747, 215, 'ZONGULDAK', 'ZONGULDAK');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(748, 215, 'AKSARAY', 'AKSARAY');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(749, 215, 'BAYBURT', 'BAYBURT');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(750, 215, 'KARAMAN', 'KARAMAN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(751, 215, 'KIRIKKALE', 'KIRIKKALE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(752, 215, 'BATMAN', 'BATMAN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(753, 215, 'SIRNAK', 'SIRNAK');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(754, 215, 'BARTIN', 'BARTIN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(755, 215, 'ARDAHAN', 'ARDAHAN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(756, 215, 'IGDIR', 'IGDIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(757, 215, 'YALOVA', 'YALOVA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(758, 215, 'KARABÜK', 'KARABÜK');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(759, 215, 'KILIS', 'KILIS');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(760, 215, 'OSMANIYE', 'OSMANIYE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(761, 215, 'DÜZCE', 'DÜZCE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(762, 229, 'AM', 'Amazonas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(763, 229, 'AN', 'Anzoátegui');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(764, 229, 'AR', 'Aragua');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(765, 229, 'AP', 'Apure');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(766, 229, 'BA', 'Barinas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(767, 229, 'BO', 'Bolívar');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(768, 229, 'CA', 'Carabobo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(769, 229, 'CO', 'Cojedes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(770, 229, 'DA', 'Delta Amacuro');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(771, 229, 'DC', 'Distrito Capital');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(772, 229, 'FA', 'Falcón');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(773, 229, 'GA', 'Guárico');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(774, 229, 'GU', 'Guayana');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(775, 229, 'LA', 'Lara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(776, 229, 'ME', 'Mérida');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(777, 229, 'MI', 'Miranda');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(778, 229, 'MO', 'Monagas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(779, 229, 'NE', 'Nueva Esparta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(780, 229, 'PO', 'Portuguesa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(781, 229, 'SU', 'Sucre');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(782, 229, 'TA', 'Táchira');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(783, 229, 'TU', 'Trujillo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(784, 229, 'VA', 'Vargas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(785, 229, 'YA', 'Yaracuy');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(786, 229, 'ZU', 'Zulia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(787, 222, 'AVON', 'Avon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(788, 222, 'BEDS', 'Bedfordshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(789, 222, 'BERK', 'Berkshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(790, 222, 'BIRM', 'Birmingham');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(791, 222, 'BORD', 'Borders');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(792, 222, 'BUCK', 'Buckinghamshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(793, 222, 'CAMB', 'Cambridgeshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(794, 222, 'CENT', 'Central');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(795, 222, 'CHES', 'Cheshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(796, 222, 'CLEV', 'Cleveland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(797, 222, 'CLWY', 'Clwyd');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(798, 222, 'CORN', 'Cornwall');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(799, 222, 'CUMB', 'Cumbria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(800, 222, 'DERB', 'Derbyshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(801, 222, 'DEVO', 'Devon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(802, 222, 'DORS', 'Dorset');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(803, 222, 'DUMF', 'Dumfries & Galloway');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(804, 222, 'DURH', 'Durham');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(805, 222, 'DYFE', 'Dyfed');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(806, 222, 'ESUS', 'East Sussex');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(807, 222, 'ESSE', 'Essex');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(808, 222, 'FIFE', 'Fife');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(809, 222, 'GLAM', 'Glamorgan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(810, 222, 'GLOU', 'Gloucestershire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(811, 222, 'GRAM', 'Grampian');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(812, 222, 'GWEN', 'Gwent');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(813, 222, 'GWYN', 'Gwynedd');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(814, 222, 'HAMP', 'Hampshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(815, 222, 'HERE', 'Hereford & Worcester');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(816, 222, 'HERT', 'Hertfordshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(817, 222, 'HUMB', 'Humberside');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(818, 222, 'KENT', 'Kent');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(819, 222, 'LANC', 'Lancashire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(820, 222, 'LEIC', 'Leicestershire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(821, 222, 'LINC', 'Lincolnshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(822, 222, 'LOND', 'London');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(823, 222, 'LOTH', 'Lothian');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(824, 222, 'MANC', 'Manchester');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(825, 222, 'MERS', 'Merseyside');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(826, 222, 'NORF', 'Norfolk');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(827, 222, 'NYOR', 'North Yorkshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(828, 222, 'NWHI', 'North west Highlands');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(829, 222, 'NHAM', 'Northamptonshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(830, 222, 'NUMB', 'Northumberland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(831, 222, 'NOTT', 'Nottinghamshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(832, 222, 'OXFO', 'Oxfordshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(833, 222, 'POWY', 'Powys');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(834, 222, 'SHRO', 'Shropshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(835, 222, 'SOME', 'Somerset');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(836, 222, 'SYOR', 'South Yorkshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(837, 222, 'STAF', 'Staffordshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(838, 222, 'STRA', 'Strathclyde');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(839, 222, 'SUFF', 'Suffolk');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(840, 222, 'SURR', 'Surrey');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(841, 222, 'WSUS', 'West Sussex');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(842, 222, 'TAYS', 'Tayside');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(843, 222, 'TYWE', 'Tyne & Wear');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(844, 222, 'WARW', 'Warwickshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(845, 222, 'WISL', 'West Isles');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(846, 222, 'WYOR', 'West Yorkshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(847, 222, 'WILT', 'Wiltshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(848, 44, 'BJ', 'Beijing Municipality');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(849, 44, 'TJ', 'Tianjin Municipality');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(850, 44, 'HE', 'Hebei Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(851, 44, 'SX', 'Shanxi Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(852, 44, 'NM', 'Inner Mongolia Autonomous Region (Nei Mongol Autonomous Region)');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(853, 44, 'LN', 'Liaoning Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(854, 44, 'JL', 'Jilin Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(855, 44, 'HL', 'Heilongjiang Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(856, 44, 'SH', 'Shanghai Municipality');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(857, 44, 'JS', 'Jiangsu Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(858, 44, 'ZJ', 'Zhejiang Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(859, 44, 'AH', 'Anhui Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(860, 44, 'FJ', 'Fujian Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(861, 44, 'JX', 'Jiangxi Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(862, 44, 'SD', 'Shandong Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(863, 44, 'HA', 'Henan Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(864, 44, 'HB', 'Hubei Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(865, 44, 'HN', 'Hunan Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(866, 44, 'GD', 'Guangdong Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(867, 44, 'GX', 'Guangxi Zhuang Autonomous Region');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(868, 44, 'HI', 'Hainan Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(869, 44, 'CQ', 'Chongqing Municipality');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(870, 44, 'SC', 'Sichuan Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(871, 44, 'GZ', 'Guizhou Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(872, 44, 'YN', 'Yunnan Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(873, 44, 'XZ', 'Tibet Autonomous Region (Xizang Autonomous Region)');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(874, 44, 'SN', 'Shaanxi Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(875, 44, 'GS', 'Gansu Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(876, 44, 'QH', 'Qinghai Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(877, 44, 'NX', 'Ningxia Hui Autonomous Region');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(878, 44, 'XJ', 'Xinjiang Uyghur Autonomous Region');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(879, 44, 'HK', 'Hong Kong Special Administrative Region (Xianggang Special Administrative Region)');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(880, 44, 'MC', 'Macau Special Administrative Region (Aomen Special Administrative Region)');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(881, 10, 'CF', 'Buenos Aires City');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(882, 10, 'BA', 'Buenos Aires');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(883, 10, 'CT', 'Catamarca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(884, 10, 'CC', 'Chaco');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(885, 10, 'CH', 'Chubut');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(886, 10, 'CD', 'Córdoba');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(887, 10, 'CR', 'Corrientes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(888, 10, 'ER', 'Entre Ríos');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(889, 10, 'FO', 'Formosa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(890, 10, 'JY', 'Jujuy');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(891, 10, 'LP', 'La Pampa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(892, 10, 'LR', 'La Rioja');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(893, 10, 'MZ', 'Mendoza');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(894, 10, 'MN', 'Misiones');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(895, 10, 'NQ', 'Neuquén');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(896, 10, 'RN', 'Río Negro');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(897, 10, 'SA', 'Salta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(898, 10, 'SJ', 'San Juan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(899, 10, 'SL', 'San Luis');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(900, 10, 'SC', 'Santa Cruz');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(901, 10, 'SF', 'Santa Fe');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(902, 10, 'SE', 'Santiago del Estero');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(903, 10, 'TF', 'Tierra del Fuego');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(904, 10, 'TM', 'Tucumán');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(905, 209, 'BKK', 'Bangkok (Krung Thep Maha Nakhon)');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(906, 209, 'ACR', 'Amnat Charoen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(907, 209, 'ATG', 'Ang Thong');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(908, 209, 'BRM', 'Buriram');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(909, 209, 'CCO', 'Chachoengsao');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(910, 209, 'CNT', 'Chainat');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(911, 209, 'CPM', 'Chaiyaphum');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(912, 209, 'CTI', 'Chanthaburi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(913, 209, 'CMI', 'Chiang Mai');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(914, 209, 'CRI', 'Chiang Rai');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(915, 209, 'CBI', 'Chonburi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(916, 209, 'CPN', 'Chumphon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(917, 209, 'KSN', 'Kalasin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(918, 209, 'KPT', 'Kamphaeng Phet');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(919, 209, 'KRI', 'Kanchanaburi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(920, 209, 'KKN', 'Khon Kaen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(921, 209, 'KBI', 'Krabi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(922, 209, 'LPG', 'Lampang');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(923, 209, 'LPN', 'Lamphun');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(924, 209, 'LEI', 'Loei Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(925, 209, 'LRI', 'Lopburi Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(926, 209, 'MSN', 'Mae Hong Son');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(927, 209, 'MKM', 'Maha Sarakham');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(928, 209, 'MDH', 'Mukdahan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(929, 209, 'NYK', 'Nakhon Nayok');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(930, 209, 'NPT', 'Nakhon Pathom');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(931, 209, 'NPM', 'Nakhon Phanom');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(932, 209, 'NMA', 'Nakhon Ratchasima');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(933, 209, 'NSN', 'Nakhon Sawan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(934, 209, 'NRT', 'Nakhon Si Thammarat Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(935, 209, 'NAN', 'Nan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(936, 209, 'NWT', 'Narathiwat');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(937, 209, 'NBP', 'Nong Bua Lamphu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(938, 209, 'NKI', 'Nong Khai');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(939, 209, 'NBI', 'Nonthaburi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(940, 209, 'PTE', 'Pathum Thani');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(941, 209, 'PTN', 'Pattani');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(942, 209, 'PNA', 'Phang Nga');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(943, 209, 'PLG', 'Phatthalung');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(944, 209, 'PYO', 'Phayao');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(945, 209, 'PNB', 'Phetchabun');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(946, 209, 'PBI', 'Phetchaburi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(947, 209, 'PCT', 'Phichit');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(948, 209, 'PLK', 'Phitsanulok');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(949, 209, 'AYA', 'Phra Nakhon Si Ayutthaya');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(950, 209, 'PRE', 'Phrae');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(951, 209, 'PKT', 'Phuket');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(952, 209, 'PRI', 'Prachinburi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(953, 209, 'PKN', 'Prachuap Khiri Khan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(954, 209, 'RNG', 'Ranong');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(955, 209, 'RBR', 'Ratchaburi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(956, 209, 'RYG', 'Rayong');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(957, 209, 'RET', 'Roi Et');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(958, 209, 'SKW', 'Sa Kaeo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(959, 209, 'SNK', 'Sakon Nakhon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(960, 209, 'SPK', 'Samut Prakan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(961, 209, 'SKN', 'Samut Sakhon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(962, 209, 'SKM', 'Samut Songkhram');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(963, 209, 'SRI', 'Saraburi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(964, 209, 'STN', 'Satun');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(965, 209, 'SBR', 'Sing Buri');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(966, 209, 'SSK', 'Sisaket');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(967, 209, 'SKA', 'Songkhla');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(968, 209, 'STI', 'Sukhothai');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(969, 209, 'SPB', 'Suphan Buri');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(970, 209, 'SNI', 'Surat Thani');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(971, 209, 'SRN', 'Surin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(972, 209, 'TAK', 'Tak');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(973, 209, 'TRG', 'Trang');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(974, 209, 'TRT', 'Trat');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(975, 209, 'UBN', 'Ubon Ratchathani');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(976, 209, 'UDN', 'Udon Thani');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(977, 209, 'UTI', 'Uthai Thani');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(978, 209, 'UTD', 'Uttaradit');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(979, 209, 'YLA', 'Yala');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(980, 209, 'YST', 'Yasothon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(981, 100, 'AC', 'Special Region of Aceh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(982, 100, 'BA', 'Bali');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(983, 100, 'BB', 'Bangka-Belitung');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(984, 100, 'BT', 'Banten');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(985, 100, 'BE', 'Bengkulu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(986, 100, 'JT', 'Central Java');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(987, 100, 'KT', 'Central Kalimantan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(988, 100, 'ST', 'Central Sulawesi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(989, 100, 'JI', 'East Java');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(990, 100, 'KI', 'East Kalimantan[4]');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(991, 100, 'NT', 'East Nusa Tenggara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(992, 100, 'GO', 'Gorontalo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(993, 100, 'JK', 'Jakarta (Special City District)');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(994, 100, 'JA', 'Jambi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(995, 100, 'LA', 'Lampung');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(996, 100, 'MA', 'Maluku');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(997, 100, 'KU', 'North Kalimantan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(998, 100, 'MU', 'North Maluku');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(999, 100, 'SA', 'North Sulawesi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1000, 100, 'SU', 'North Sumatra');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1001, 100, 'PA', 'Special Region of Papua');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1002, 100, 'RI', 'Riau');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1003, 100, 'KR', 'Riau Islands');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1004, 100, 'SG', 'Southeast Sulawesi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1005, 100, 'KS', 'South Kalimantan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1006, 100, 'SN', 'South Sulawesi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1007, 100, 'SS', 'South Sumatra');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1008, 100, 'JB', 'West Java');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1009, 100, 'KB', 'West Kalimantan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1010, 100, 'NB', 'West Nusa Tenggara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1011, 100, 'PB', 'Special Region of West Papua');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1012, 100, 'SR', 'West Sulawesi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1013, 100, 'SB', 'West Sumatra');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1014, 100, 'YO', 'Special Region of Yogyakarta');

INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('person.active', '1');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('company.active', '1');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('sandbox', '1');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('applicationLicence', 'ff24b9634bb8e0b24a15a7cbbddc5fe6');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('clientLicence', '');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('clientId', '');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('recheckSuspect', '30');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('buergel.score', '2.3');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('paymentModules', 'invoice,banktransfer');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('orderTotal', '100');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('allowPaymentWithNoResult', '0');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('daysUntilClaimStart', '20');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('orderStatusIdMarked', '1');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('displayClaimsCount', '5');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('overdueFees', '5.00');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('lastStatusUpdate', '1207030153');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('statusUpdateInterval', '3');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('daysFromLastReminder', '10');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('defaultType', '1');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('requestType', 'always');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('requestOnModules', 'invoice,banktransfer');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('paymentErrorText', 'Leider ist die ausgewählte Zahlart zur Zeit nicht verfügbar. Bitte wählen Sie eine andere Zahlart aus.');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('minAmountForRequest', '0');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('maxAmountForRequest', '0');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('allowPaymentUnderMinAmount', '0');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('allowPaymentOverMaxAmount', '0');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('defaultPersonScore', 'MF_Score_BuergelClient');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('defaultCompanyScore', 'MF_Score_AccumioClient');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('accumio.score', '2');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('accumio.minSimilarity', '80');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('version', '0.3.2');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('applicationId', '317');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('registrationKey', '');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('serviceLicenceKey', '9c889dd2408ca44b1cd9e12ba40333fa');

INSERT INTO `log_levels` (`log_level_id`, `name`) VALUES(1, 'error');
INSERT INTO `log_levels` (`log_level_id`, `name`) VALUES(2, 'warning');
INSERT INTO `log_levels` (`log_level_id`, `name`) VALUES(3, 'notice');

INSERT INTO `log_output_types` (`log_output_type_id`, `name`) VALUES(1, 'file');
INSERT INTO `log_output_types` (`log_output_type_id`, `name`) VALUES(2, 'screen');
INSERT INTO `log_output_types` (`log_output_type_id`, `name`) VALUES(3, 'mail');
INSERT INTO `log_output_types` (`log_output_type_id`, `name`) VALUES(4, 'html_file');

INSERT INTO `log_outputs` (`log_output_id`, `name`) VALUES(1, 'output');
INSERT INTO `log_outputs` (`log_output_id`, `name`) VALUES(2, 'filepath');
INSERT INTO `log_outputs` (`log_output_id`, `name`) VALUES(3, 'backtrace');
INSERT INTO `log_outputs` (`log_output_id`, `name`) VALUES(4, 'request_data');
INSERT INTO `log_outputs` (`log_output_id`, `name`) VALUES(5, 'code_snippet');
INSERT INTO `log_outputs` (`log_output_id`, `name`) VALUES(6, 'class_data');
INSERT INTO `log_outputs` (`log_output_id`, `name`) VALUES(7, 'function_data');
INSERT INTO `log_outputs` (`log_output_id`, `name`) VALUES(8, 'session_data');

INSERT INTO `log_groups` (`log_group_id`, `name`) VALUES(1, 'error_handler');
INSERT INTO `log_groups` (`log_group_id`, `name`) VALUES(2, 'security');
INSERT INTO `log_groups` (`log_group_id`, `name`) VALUES(3, 'payment');
INSERT INTO `log_groups` (`log_group_id`, `name`) VALUES(4, 'shipping');
INSERT INTO `log_groups` (`log_group_id`, `name`) VALUES(5, 'widgets');

INSERT INTO `log_configuration` (`log_group_id`, `log_level_id`, `log_output_type_id`, `log_output_id`) VALUES
(1, 1, 1, 1),
(1, 1, 1, 2),
(1, 1, 1, 3),
(1, 1, 1, 4),
(1, 1, 1, 5),
(1, 1, 1, 6),
(1, 1, 1, 7),
(1, 1, 1, 8),
(1, 1, 2, 1),
(1, 1, 3, 1),
(1, 1, 3, 2),
(1, 1, 3, 3),
(1, 1, 3, 4),
(1, 1, 3, 5),
(1, 1, 3, 6),
(1, 1, 3, 7),
(1, 1, 3, 8),
(1, 1, 4, 1),
(1, 1, 4, 2),
(1, 1, 4, 3),
(1, 1, 4, 4),
(1, 1, 4, 5),
(1, 1, 4, 6),
(1, 1, 4, 7),
(1, 1, 4, 8),
(1, 2, 1, 1),
(1, 2, 1, 2),
(1, 2, 1, 3),
(1, 2, 1, 4),
(1, 2, 1, 5),
(1, 2, 1, 6),
(1, 2, 1, 7),
(1, 2, 1, 8),
(1, 2, 2, 1),
(1, 2, 3, 1),
(1, 2, 3, 2),
(1, 2, 3, 3),
(1, 2, 3, 4),
(1, 2, 3, 5),
(1, 2, 3, 6),
(1, 2, 3, 7),
(1, 2, 3, 8),
(1, 2, 4, 1),
(1, 2, 4, 2),
(1, 2, 4, 3),
(1, 2, 4, 4),
(1, 2, 4, 5),
(1, 2, 4, 6),
(1, 2, 4, 7),
(1, 2, 4, 8),
(1, 3, 1, 1),
(1, 3, 1, 2),
(1, 3, 1, 3),
(1, 3, 1, 4),
(1, 3, 3, 1),
(1, 3, 3, 2),
(1, 3, 3, 3),
(1, 3, 3, 4),
(1, 3, 4, 1),
(1, 3, 4, 2),
(1, 3, 4, 3),
(1, 3, 4, 4);

INSERT INTO `log_configuration` (`log_group_id`, `log_level_id`, `log_output_type_id`, `log_output_id`) VALUES
(2, 1, 1, 1),
(2, 1, 1, 2),
(2, 1, 1, 3),
(2, 1, 1, 4),
(2, 1, 1, 5),
(2, 1, 1, 6),
(2, 1, 1, 7),
(2, 1, 1, 8),
(2, 1, 3, 1),
(2, 1, 3, 2),
(2, 1, 3, 3),
(2, 1, 3, 4),
(2, 1, 3, 5),
(2, 1, 3, 6),
(2, 1, 3, 7),
(2, 1, 3, 8),
(2, 1, 4, 1),
(2, 1, 4, 2),
(2, 1, 4, 3),
(2, 1, 4, 4),
(2, 1, 4, 5),
(2, 1, 4, 6),
(2, 1, 4, 7),
(2, 1, 4, 8),
(2, 2, 1, 1),
(2, 2, 1, 2),
(2, 2, 1, 3),
(2, 2, 1, 4),
(2, 2, 1, 5),
(2, 2, 1, 6),
(2, 2, 1, 7),
(2, 2, 1, 8),
(2, 2, 3, 1),
(2, 2, 3, 2),
(2, 2, 3, 3),
(2, 2, 3, 4),
(2, 2, 3, 5),
(2, 2, 3, 6),
(2, 2, 3, 7),
(2, 2, 3, 8),
(2, 2, 4, 1),
(2, 2, 4, 2),
(2, 2, 4, 3),
(2, 2, 4, 4),
(2, 2, 4, 5),
(2, 2, 4, 6),
(2, 2, 4, 7),
(2, 2, 4, 8),
(2, 3, 1, 1),
(2, 3, 1, 2),
(2, 3, 1, 3),
(2, 3, 1, 4),
(2, 3, 3, 1),
(2, 3, 3, 2),
(2, 3, 3, 3),
(2, 3, 3, 4),
(2, 3, 4, 1),
(2, 3, 4, 2),
(2, 3, 4, 3),
(2, 3, 4, 4);

INSERT INTO `log_configuration` (`log_group_id`, `log_level_id`, `log_output_type_id`, `log_output_id`) VALUES
(3, 1, 1, 1),
(3, 1, 1, 2),
(3, 1, 1, 3),
(3, 1, 1, 4),
(3, 1, 1, 5),
(3, 1, 1, 6),
(3, 1, 1, 7),
(3, 1, 1, 8),
(3, 1, 2, 1),
(3, 1, 3, 1),
(3, 1, 3, 2),
(3, 1, 3, 3),
(3, 1, 3, 4),
(3, 1, 3, 5),
(3, 1, 3, 6),
(3, 1, 3, 7),
(3, 1, 3, 8),
(3, 1, 4, 1),
(3, 1, 4, 2),
(3, 1, 4, 3),
(3, 1, 4, 4),
(3, 1, 4, 5),
(3, 1, 4, 6),
(3, 1, 4, 7),
(3, 1, 4, 8),
(3, 2, 1, 1),
(3, 2, 1, 2),
(3, 2, 1, 3),
(3, 2, 1, 4),
(3, 2, 1, 5),
(3, 2, 1, 8),
(3, 2, 4, 1),
(3, 2, 4, 2),
(3, 2, 4, 3),
(3, 2, 4, 4),
(3, 2, 4, 5),
(3, 2, 4, 8),
(3, 3, 1, 1),
(3, 3, 1, 2);

INSERT INTO `log_configuration` (`log_group_id`, `log_level_id`, `log_output_type_id`, `log_output_id`) VALUES
(4, 1, 1, 1),
(4, 1, 1, 2),
(4, 1, 1, 3),
(4, 1, 1, 4),
(4, 1, 1, 5),
(4, 1, 1, 6),
(4, 1, 1, 7),
(4, 1, 1, 8),
(4, 1, 2, 1),
(4, 1, 3, 1),
(4, 1, 3, 2),
(4, 1, 3, 3),
(4, 1, 3, 4),
(4, 1, 3, 5),
(4, 1, 3, 6),
(4, 1, 3, 7),
(4, 1, 3, 8),
(4, 1, 4, 1),
(4, 1, 4, 2),
(4, 1, 4, 3),
(4, 1, 4, 4),
(4, 1, 4, 5),
(4, 1, 4, 6),
(4, 1, 4, 7),
(4, 1, 4, 8),
(4, 2, 1, 1),
(4, 2, 1, 2),
(4, 2, 1, 3),
(4, 2, 1, 4),
(4, 2, 1, 5),
(4, 2, 1, 8),
(4, 2, 4, 1),
(4, 2, 4, 2),
(4, 2, 4, 3),
(4, 2, 4, 4),
(4, 2, 4, 5),
(4, 2, 4, 8),
(4, 3, 1, 1),
(4, 3, 1, 2);

INSERT INTO `log_configuration` (`log_group_id`, `log_level_id`, `log_output_type_id`, `log_output_id`) VALUES
(5, 1, 1, 1),
(5, 1, 1, 2),
(5, 1, 1, 3),
(5, 1, 1, 4),
(5, 1, 1, 5),
(5, 1, 1, 6),
(5, 1, 1, 7),
(5, 1, 1, 8),
(5, 1, 3, 1),
(5, 1, 3, 2),
(5, 1, 3, 3),
(5, 1, 3, 4),
(5, 1, 3, 5),
(5, 1, 3, 6),
(5, 1, 3, 7),
(5, 1, 3, 8),
(5, 1, 4, 1),
(5, 1, 4, 2),
(5, 1, 4, 3),
(5, 1, 4, 4),
(5, 1, 4, 5),
(5, 1, 4, 6),
(5, 1, 4, 7),
(5, 1, 4, 8),
(5, 2, 1, 1),
(5, 2, 1, 2),
(5, 2, 1, 3),
(5, 2, 1, 4),
(5, 2, 1, 5),
(5, 2, 1, 8),
(5, 2, 3, 1),
(5, 2, 3, 2),
(5, 2, 3, 3),
(5, 2, 3, 4),
(5, 2, 3, 5),
(5, 2, 3, 8),
(5, 2, 4, 1),
(5, 2, 4, 2),
(5, 2, 4, 3),
(5, 2, 4, 4),
(5, 2, 4, 5),
(5, 2, 4, 8),
(5, 3, 1, 1),
(5, 3, 4, 1);
